unit blacktiger_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     z80,mcs51,main_engine,controls_engine,ym_2203,gfx_engine,timer_engine,
     rom_engine,cpu_engine,file_engine,pal_engine,sound_engine;

procedure Cargar_blktiger;
procedure blktiger_principal; 
function iniciar_blktiger:boolean; 
procedure reset_blktiger; 
procedure cerrar_blktiger; 
//Main CPU
function blktiger_getbyte(direccion:word): Byte;
procedure blktiger_putbyte(direccion:word;valor:byte);
function blktiger_inbyte(puerto:word):byte;
procedure blktiger_outbyte(valor:byte;puerto:word);
procedure blk_hi_score;
//Sound CPU
function blksnd_getbyte(direccion:word): Byte;
procedure blksnd_putbyte(direccion:word;valor:byte);
procedure snd_irq(numchip:integer;irqstate:integer);
procedure blk_despues_instruccion;
//MCU
procedure out_port0(valor:byte);
function in_port0:Byte;

const
        blktiger_rom:array[0..5] of tipo_roms=(
        (n:'bdu-01a.5e';l:$8000;p:0;crc:$a8f98f22),(n:'bdu-02a.6e';l:$10000;p:$8000;crc:$7bef96e8),
        (n:'bdu-03a.8e';l:$10000;p:$18000;crc:$4089e157),(n:'bd-04.9e';l:$10000;p:$28000;crc:$ed6af6ec),
        (n:'bd-05.10e';l:$10000;p:$38000;crc:$ae59b72e),());
        blktiger_char: tipo_roms=(n:'bd-15.2n';l:$8000;p:0;crc:$70175d78);
        blktiger_sprites:array[0..4] of tipo_roms=(
        (n:'bd-08.5a';l:$10000;p:0;crc:$e2f17438),(n:'bd-07.4a';l:$10000;p:$10000;crc:$5fccbd27),
        (n:'bd-10.9a';l:$10000;p:$20000;crc:$fc33ccc6),(n:'bd-09.8a';l:$10000;p:$30000;crc:$f449de01),());
        blktiger_tiles:array[0..4] of tipo_roms=(
        (n:'bd-12.5b';l:$10000;p:0;crc:$c4524993),(n:'bd-11.4b';l:$10000;p:$10000;crc:$7932c86f),
        (n:'bd-14.9b';l:$10000;p:$20000;crc:$dc49593a),(n:'bd-13.8b';l:$10000;p:$30000;crc:$7ed7a122),());
        blktiger_snd:tipo_roms=(n:'bd-06.1l';l:$8000;p:0;crc:$2cf54274);
        blktiger_mcu:tipo_roms=(n:'bd.6k';l:$1000;p:0;crc:$ac7d14f1);
        //Dip
        blktiger_dip_a:array [0..4] of def_dip=(
        (mask:$7;name:'Coin A';number:8;dip:((dip_val:$0;dip_name:'4 Coin - 1 Credit'),(dip_val:$1;dip_name:'3 Coin - 1 Credit'),(dip_val:$2;dip_name:'2 Coin - 1 Credit'),(dip_val:$7;dip_name:'1 Coin - 1 Credit'),(dip_val:$6;dip_name:'1 Coin - 2 Credit'),(dip_val:$5;dip_name:'1 Coin - 3 Credit'),(dip_val:$4;dip_name:'1 Coin - 4 Credit'),(dip_val:$3;dip_name:'1 Coin - 5 Credit'),(),(),(),(),(),(),(),())),
        (mask:$38;name:'Coin B';number:8;dip:((dip_val:$0;dip_name:'4 Coin - 1 Credit'),(dip_val:$8;dip_name:'3 Coin - 1 Credit'),(dip_val:$10;dip_name:'2 Coin - 1 Credit'),(dip_val:$38;dip_name:'1 Coin - 1 Credit'),(dip_val:$30;dip_name:'1 Coin - 2 Credit'),(dip_val:$28;dip_name:'1 Coin - 3 Credit'),(dip_val:$20;dip_name:'1 Coin - 4 Credit'),(dip_val:$18;dip_name:'1 Coin - 5 Credit'),(),(),(),(),(),(),(),())),
        (mask:$40;name:'Flip Screen';number:2;dip:((dip_val:$40;dip_name:'Off'),(dip_val:$0;dip_name:'On'),(),(),(),(),(),(),(),(),(),(),(),(),(),())),
        (mask:$80;name:'Test';number:2;dip:((dip_val:$80;dip_name:'Off'),(dip_val:$0;dip_name:'On'),(),(),(),(),(),(),(),(),(),(),(),(),(),())),());
        blktiger_dip_b:array [0..5] of def_dip=(
        (mask:$3;name:'Lives';number:4;dip:((dip_val:$2;dip_name:'2 Lives'),(dip_val:$3;dip_name:'3 Lives'),(dip_val:$1;dip_name:'5 Lives'),(dip_val:$0;dip_name:'7 Lives'),(),(),(),(),(),(),(),(),(),(),(),())),
        (mask:$1c;name:'Difficulty';number:8;dip:((dip_val:$1c;dip_name:'Very Easy'),(dip_val:$18;dip_name:'Easy 3'),(dip_val:$14;dip_name:'Easy 2'),(dip_val:$10;dip_name:'Easy 1'),(dip_val:$c;dip_name:'Normal'),(dip_val:$8;dip_name:'Difficult 1'),(dip_val:$4;dip_name:'Difficult 2'),(dip_val:$0;dip_name:'Very Difficult'),(),(),(),(),(),(),(),())),
        (mask:$20;name:'Demo Sounds';number:2;dip:((dip_val:$0;dip_name:'Off'),(dip_val:$20;dip_name:'On'),(),(),(),(),(),(),(),(),(),(),(),(),(),())),
        (mask:$40;name:'Allow Continue';number:2;dip:((dip_val:$0;dip_name:'No'),(dip_val:$40;dip_name:'Yes'),(),(),(),(),(),(),(),(),(),(),(),(),(),())),
        (mask:$80;name:'Cabinet';number:2;dip:((dip_val:$0;dip_name:'Upright'),(dip_val:$80;dip_name:'Cocktail'),(),(),(),(),(),(),(),(),(),(),(),(),(),())),());

var
 scroll_ram:array[0..$3FFF] of byte;
 memoria_rom:array [0..$F,$0..$3FFF] of byte;
 banco_rom,soundlatch:byte;
 scroll_x,scroll_y:parejas;
 scroll_bank:word;
 mask_x,mask_y,shl_row:byte;
 mask_sx,mask_sy:word;
 i8751_latch,z80_latch:byte;
 timer_hs:byte;
 bg_on,ch_on,spr_on:boolean;

implementation
uses principal;

procedure Cargar_blktiger;
begin
llamadas_maquina.iniciar:=iniciar_blktiger;
llamadas_maquina.bucle_general:=blktiger_principal;
llamadas_maquina.cerrar:=cerrar_blktiger;
llamadas_maquina.reset:=reset_blktiger;
end;

procedure cerrar_blktiger; 
begin
save_hi('blktiger.hi',@memoria[$e200],80);
cerrar_cpus;
ym2203_close(0);
ym2203_close(1);
close_audio;
close_video;
end;

procedure reset_blktiger;
begin
 reset_z80(main_z80);
 reset_z80(snd_z80);
 reset_mcs51(main_mcs51,main_mcs51_ll);
 ym2203_reset(0);
 ym2203_reset(1);
 reset_audio;
 banco_rom:=0;
 soundlatch:=0;
 scroll_bank:=0;
 scroll_x.w:=0;
 scroll_y.w:=0;
 marcade.in0:=$FF;
 marcade.in1:=$FF;
 mask_x:=$70;
 mask_y:=$30;
 shl_row:=7;
 i8751_latch:=0;
 z80_latch:=0;
 bg_on:=true;
 ch_on:=true;
 spr_on:=true;
end;

function iniciar_blktiger:boolean;
var
      f:word;
      memoria_temp:array[0..$47fff] of byte;
const
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3);
  pc_y:array[0..7] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16);
  ps_x:array[0..15] of dword=(0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3,
			16*16+0, 16*16+1, 16*16+2, 16*16+3, 16*16+8+0, 16*16+8+1, 16*16+8+2, 16*16+8+3);
  ps_y:array[0..15] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16,
			8*16, 9*16, 10*16, 11*16, 12*16, 13*16, 14*16, 15*16);
begin
iniciar_blktiger:=false;
iniciar_audio(false);
//Principal
p_final[0].x:=256;
p_final[0].y:=224;
//Background
p_final[1].x:=272;
p_final[1].y:=256;
p_final[1].scroll.long_x:=272;
p_final[1].scroll.long_y:=256;
p_final[1].scroll.mask_x:=255;
p_final[1].scroll.mask_y:=255;
p_final[1].scroll.max_x:=256;
p_final[1].scroll.max_y:=256;
p_final[1].trans:=true;
//Foreground
p_final[2].x:=272;
p_final[2].y:=256;
p_final[2].trans:=true;
p_final[2].scroll:=p_final[1].scroll;
//Chars
p_final[3].x:=256;
p_final[3].y:=256;
p_final[3].trans:=true;
//Final
p_final[4].x:=512;
p_final[4].y:=256;
p_final[4].final_mix:=true;
iniciar_video;
//Main CPU
init_cpu(z80_main,0,6000000/256);
main_z80_ll.getbyte:=blktiger_getbyte;
main_z80_ll.putbyte:=blktiger_putbyte;
main_z80_ll.outbyte:=blktiger_outbyte;
main_z80_ll.inbyte:=blktiger_inbyte;
//Sound CPU
init_cpu(z80_snd,1,3579545/256);
snd_z80_ll.getbyte:=blksnd_getbyte;
snd_z80_ll.putbyte:=blksnd_putbyte;
//MCU
init_cpu(mcs51_main,2,6000000/256);
main_mcs51_ll.out_port0:=out_port0;
main_mcs51_ll.in_port0:=in_port0;
//Sound Chip
ym2203_Init(0,1,3579545,3579545,1,nil,nil,nil,nil,snd_irq);
ym2203_Init(1,1,3579545,3579545,1,nil,nil,nil,nil,nil);
init_sound_engine(1,3579545,blk_despues_instruccion);
//Timers
timer_hs:=init_timer(0,10000,blk_hi_score,true);
//cargar roms
if not(cargar_roms(@memoria_temp[0],@blktiger_rom[0],'blktiger.zip',0)) then exit;
//poner las roms y los bancos de rom
copymemory(addr(memoria[0]),addr(memoria_temp[0]),$8000);
for f:=0 to 15 do copymemory(addr(memoria_rom[f,0]),addr(memoria_temp[$8000+(f*$4000)]),$4000);
//sonido
if not(cargar_roms(@mem_snd[0],@blktiger_snd,'blktiger.zip',1)) then exit;
//MCU ROM
if not(cargar_roms(@main_mcs51.rom[0],@blktiger_mcu,'blktiger.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@blktiger_char,'blktiger.zip',1)) then exit;
init_gfx(0,8,8,2048);
gfx[0].trans[3]:=true;
des_gfx.pos_planos[0]:=4;
des_gfx.pos_planos[1]:=0;
des_gfx.bit_pixel:=2;
des_gfx.long_sprites:=16*8;
des_gfx.banks:=0;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@blktiger_sprites[0],'blktiger.zip',0)) then exit;
init_gfx(1,16,16,$800);
gfx[1].trans[15]:=true;
des_gfx.bit_pixel:=4;
des_gfx.pos_planos[0]:=$800*32*16+4;
des_gfx.pos_planos[1]:=$800*32*16+0;
des_gfx.pos_planos[2]:=4;
des_gfx.pos_planos[3]:=0;
des_gfx.long_sprites:=32*16;
convert_gfx(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//tiles
if not(cargar_roms(@memoria_temp[0],@blktiger_tiles[0],'blktiger.zip',0)) then exit;
init_gfx(2,16,16,$800);
gfx[2].trans[15]:=true;
gfx[2].trans_alt[0,15]:=true;
for f:=4 to 15 do gfx[2].trans_alt[1,f]:=true;
for f:=8 to 15 do gfx[2].trans_alt[2,f]:=true;
for f:=12 to 15 do gfx[2].trans_alt[3,f]:=true;
des_gfx.bit_pixel:=4;
des_gfx.pos_planos[0]:=$800*32*16+4;
des_gfx.pos_planos[1]:=$800*32*16+0;
des_gfx.pos_planos[2]:=4;
des_gfx.pos_planos[3]:=0;
des_gfx.long_sprites:=32*16;
convert_gfx(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//DIP
marcade.dswa:=$ff;
marcade.dswb:=$6f;
marcade.dswa_val:=@blktiger_dip_a;
marcade.dswb_val:=@blktiger_dip_b;
//final
reset_blktiger;
iniciar_blktiger:=true;
end;

procedure update_video_blktiger;inline;
const
  split_table:array[0..15] of byte=(3,3,0,0,0,1,0,0,0,0,0,0,0,0,0,0);
var
    f,x,y,nchar,pos_x,pos_y,color:word;
    sx,sy,pos,atrib:word;
    flip_x:boolean;
begin
//atributo de las tiles
//80 --> flip x
//40+20+10+8 --> Color
//4+2+1 --> Numero tile
if bg_on then begin
  fill_full_screen(4,$3ff);
  pos_x:=(scroll_x.w and mask_sx) shr 4;
  pos_y:=(scroll_y.w and mask_sy) shr 4;
  for f:=0 to $10f do begin
    x:=f mod 17;
    y:=f div 17;
    sx:=x+pos_x;
    sy:=y+pos_y;
    pos:=((sx and $0f)+((sy and $0f) shl 4)+((sx and mask_x) shl 4)+((sy and mask_y) shl shl_row)) shl 1;
    atrib:=scroll_ram[pos+1];
    color:=(atrib and $78) shr 3;
    if ((gfx[2].buffer[pos shr 1]) or (gfx[2].color_buffer[color])) then begin
      nchar:=scroll_ram[pos]+((atrib and $7) shl 8);
      flip_x:=(atrib and $80)<>0;
      put_gfx_trans_flip_alt(x*16,y*16,nchar,color shl 4,1,2,flip_x,false,0);
      if split_table[color]<>0 then put_gfx_trans_flip_alt(x*16,y*16,nchar,color shl 4,2,2,flip_x,false,split_table[color])
        else put_gfx_block_trans(x*16,y*16,2,16,16);
      gfx[2].buffer[pos shr 1]:=false;
    end;
  end;
  fillchar(gfx[2].color_buffer[0],$10,0);
end;
scroll_x_y(1,4,scroll_x.w and $f,scroll_y.w and $f);
//cuatro bytes
// 0 --> codigo sprite
// 1 --> Atributo
//          $80+$40+$20 resto codigo sprite
//          $10 posicion x
//          $8 flip x
//          $4+$2+$1 color sprite
// 2 --> Y
// 3 --> X
if spr_on then begin
  for f:=$7f downto 0 do begin
    atrib:=buffer_sprites[$1+(f*4)];
    nchar:=buffer_sprites[f*4]+(atrib and $e0) shl 3;
    color:=(atrib and $7) shl 4;
    x:=buffer_sprites[$3+(f*4)]+(atrib and $10) shl 4;
    y:=buffer_sprites[$2+(f*4)];
    put_gfx_sprite(nchar,color+$200,(atrib and 8)<>0,false,1);
    actualiza_gfx_sprite_over(x,y,4,1,2,scroll_x.w and $f,scroll_y.w and $f);
  end;
end;
//Caracteres
if ch_on then begin
  for f:=$0 to $3ff do begin
   atrib:=memoria[$d400+f];
   color:=atrib and $1f;
   if ((gfx[0].buffer[f]) or (gfx[0].color_buffer[color])) then begin
      y:=f shr 5;
      x:=f and $1f;
      nchar:=memoria[$d000+f]+(atrib and $e0) shl 3;
      put_gfx_trans(x*8,y*8,nchar,(color shl 2)+$300,3,0);
      gfx[0].buffer[f]:=false;
   end;
  end;
  fillchar(gfx[0].color_buffer[0],$20,0);
  actualiza_trozo(0,0,256,256,3,0,0,256,256,4);
end;
actualiza_trozo_final(0,16,256,224,4);
copymemory(addr(buffer_sprites[0]),addr(memoria[$fe00]),$200);
end;

procedure eventos_blktiger;
begin
if event.arcade then begin
  if arcade_input.up[0] then marcade.in1:=(marcade.in1 and $f7) else marcade.in1:=(marcade.in1 or $8);
  if arcade_input.down[0] then marcade.in1:=(marcade.in1 and $fb) else marcade.in1:=(marcade.in1 or $4);
  if arcade_input.left[0] then marcade.in1:=(marcade.in1 and $fd) else marcade.in1:=(marcade.in1 or $2);
  if arcade_input.right[0] then marcade.in1:=(marcade.in1 and $fe) else marcade.in1:=(marcade.in1 or $1);
  if arcade_input.but0[0] then marcade.in1:=(marcade.in1 and $df) else marcade.in1:=(marcade.in1 or $20);
  if arcade_input.but1[0] then marcade.in1:=(marcade.in1 and $ef) else marcade.in1:=(marcade.in1 or $10);
  if arcade_input.coin[0] then marcade.in0:=(marcade.in0 and $bf) else marcade.in0:=(marcade.in0 or $40);
  if arcade_input.coin[1] then marcade.in0:=(marcade.in0 and $7f) else marcade.in0:=(marcade.in0 or $80);
  if arcade_input.start[0] then marcade.in0:=(marcade.in0 and $fe) else marcade.in0:=(marcade.in0 or 1);
  if arcade_input.start[1] then marcade.in0:=(marcade.in0 and $fd) else marcade.in0:=(marcade.in0 or 2);
end;
end;

procedure blktiger_principal;
var
  frame_m,frame_s,frame_mcu:single;
  f:byte;
begin
init_controls(false,false,false,true);
frame_m:=main_z80.tframes;
frame_s:=snd_z80.tframes;
frame_mcu:=main_mcs51.tframes;
while EmuStatus=EsRuning do begin
  for f:=0 to $ff do begin
    //Main CPU
    run_z80(main_z80,main_z80_ll,trunc(frame_m));
    frame_m:=frame_m+main_z80.tframes-main_z80.contador;
    //Sound CPU
    run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
    frame_s:=frame_s+snd_z80.tframes-snd_z80.contador;
    //MCU
    run_mcs51(main_mcs51,main_mcs51_ll,trunc(frame_mcu));
    frame_mcu:=frame_mcu+main_mcs51.tframes-main_mcs51.contador;
    if f=239 then begin
      update_video_blktiger;
      main_z80.pedir_irq:=HOLD_LINE;
    end;
  end;
  eventos_blktiger;
  video_sync;
end;
end;

function blksnd_getbyte(direccion:word):byte;
begin
  case direccion of
    $c800:blksnd_getbyte:=soundlatch;
    $e000:blksnd_getbyte:=ym2203_Read_Status(0);
    $e001:blksnd_getbyte:=ym2203_Read_Reg(0);
    $e002:blksnd_getbyte:=ym2203_Read_Status(1);
    $e003:blksnd_getbyte:=ym2203_Read_Reg(1);
    else blksnd_getbyte:=mem_snd[direccion];
  end;
end;

procedure blksnd_putbyte(direccion:word;valor:byte);
begin
if direccion<$8000 then exit;
mem_snd[direccion]:=valor;
case direccion of
  $e000:ym2203_Control(0,valor);
  $e001:ym2203_Write_Reg(0,valor);
  $e002:ym2203_Control(1,valor);
  $e003:ym2203_Write_Reg(1,valor);
end;
end;

function blktiger_getbyte(direccion:word):byte;
begin
case direccion of
  $8000..$bfff:blktiger_getbyte:=memoria_rom[banco_rom,(direccion and $3fff)];
  $c000..$cfff:blktiger_getbyte:=scroll_ram[scroll_bank+(direccion and $fff)];
  // $f3a1:blktiger_getbyte:=4;
  else blktiger_getbyte:=memoria[direccion];
end;
end;

procedure cambiar_color(dir:word);inline;
var
  tmp_color:byte;
  color:tcolor;
begin
  tmp_color:=buffer_paleta[dir];
  color.r:=pal4bit(tmp_color shr 4);
  color.g:=pal4bit(tmp_color);
  tmp_color:=buffer_paleta[dir+$400];
  color.b:=pal4bit(tmp_color);
  set_pal_color(color,addr(paleta[dir]));
  case dir of
    $0..$ff:gfx[2].color_buffer[dir shr 4]:=true;
    $300..$37f:gfx[0].color_buffer[(dir shr 2) and $1f]:=true;
  end;
end;

procedure blktiger_putbyte(direccion:word;valor:byte);
begin
if direccion<$c000 then exit;
memoria[direccion]:=valor;
case direccion of
        $c000..$cfff:if scroll_ram[scroll_bank+(direccion and $fff)]<>valor then begin
                        scroll_ram[scroll_bank+(direccion and $fff)]:=valor;
                        gfx[2].buffer[(scroll_bank+(direccion and $fff)) shr 1]:=true;
                     end;
        $d000..$d7ff:gfx[0].buffer[direccion and $3ff]:=true;
        $d800..$dfff:if buffer_paleta[direccion and $7ff]<>valor then begin
                        buffer_paleta[direccion and $7ff]:=valor;
                        cambiar_color((direccion and $3ff));
                     end;
end;
end;

function blktiger_inbyte(puerto:word):byte;
begin
case (puerto and $FF) of
  0:blktiger_inbyte:=marcade.in0;
  1:blktiger_inbyte:=marcade.in1;
  2:blktiger_inbyte:=$FF;  //in2
  3:blktiger_inbyte:=marcade.dswa;
  4:blktiger_inbyte:=marcade.dswb;
  5:blktiger_inbyte:=$1; //Freeze?
  7:blktiger_inbyte:=i8751_latch;  //Proteccion
  else blktiger_inbyte:=$FF;
end;
end;

procedure blktiger_outbyte(valor:byte;puerto:word);
begin
case (puerto and $FF) of
  0:soundlatch:=valor;
  1:banco_rom:=valor and $F;
  4:begin
      ch_on:=(valor and $80)=0;
      main_screen.flip_main_screen:=(valor and $40)<>0;
      if snd_z80.enabled and ((valor and $20)<>0) then reset_z80(snd_z80);
      snd_z80.enabled:=(valor and $20)=0;
    end;
  7:begin
      z80_latch:=valor;
      main_mcs51.pedir_irq1:=ASSERT_LINE;
    end;
  8:if (scroll_x.l<>valor) then begin
      if abs((scroll_x.w and mask_sx)-(valor and mask_sx))>15 then fillchar(gfx[2].buffer[0],$2000,1);
      scroll_x.l:=valor;
    end;
  9:if (scroll_x.h<>valor) then begin
      if abs((scroll_x.w and mask_sx)-(valor and mask_sx))>15 then fillchar(gfx[2].buffer[0],$2000,1);
      scroll_x.h:=valor;
    end;
  $a:if (scroll_y.l<>valor) then begin
      if abs((scroll_y.w and mask_sy)-(valor and mask_sy))>15 then fillchar(gfx[2].buffer[0],$2000,1);
      scroll_y.l:=valor;
    end;
  $b:if (scroll_y.h<>valor) then begin
      if abs((scroll_y.w and mask_sy)-(valor and mask_sy))>15 then fillchar(gfx[2].buffer[0],$2000,1);
      scroll_y.h:=valor;
    end;
  $c:begin
      bg_on:=(valor and $2)=0;
      if not(bg_on) then fill_full_screen(1,$3ff);
      spr_on:=(valor and $4)=0;
     end;
  $d:scroll_bank:=(valor and 3) shl 12;
  $e:if ((valor and 1)=1) then begin
        mask_x:=$70;
        mask_y:=$30;
        shl_row:=7;
        mask_sx:=$1ff0;
        mask_sy:=$ff0;
     end else begin
        mask_x:=$30;
        mask_y:=$70;
        shl_row:=6;
        mask_sx:=$ff0;
        mask_sy:=$1ff0;
     end
end;
end;

procedure out_port0(valor:byte);
begin
  i8751_latch:=valor;
end;

function in_port0:Byte;
begin
  clear_irq_mcs51(main_mcs51,1);
  in_port0:=z80_latch;
end;

procedure blk_despues_instruccion;
begin
  ym2203_Update(0);
  ym2203_Update(1);
end;

procedure snd_irq(numchip:integer;irqstate:integer);
begin
  if (irqstate=1) then snd_z80.pedir_irq:=ASSERT_LINE
    else snd_z80.pedir_irq:=CLEAR_LINE;
end;

procedure blk_hi_score;
begin
if ((memoria[$e204]=2) and (memoria[$e205]=0) and (memoria[$e206]=0)) then begin
    load_hi('blktiger.hi',@memoria[$e200],80);
    copymemory(addr(memoria[$e1e0]),addr(memoria[$e200]),8);
    timer[timer_hs].enabled:=false;
end;
end;

end.
