unit cavemanninja_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     m68000,main_engine,controls_engine,gfx_engine,rom_engine,cpu_engine,
     pal_engine,oki6295,sound_engine,hu6280,deco16ic,deco_common;

procedure Cargar_cninja;
function iniciar_cninja:boolean;
procedure reset_cninja;
procedure cerrar_cninja;
procedure cninja_principal;
//Caveman Ninja
function cninja_getword(direccion:dword):word;
procedure cninja_putword(direccion:dword;valor:word);
function cninja_video_bank(bank:word):word;
//Robocop 2
function robocop2_getword(direccion:dword):word;
procedure robocop2_putword(direccion:dword;valor:word);
function robocop2_video_bank(bank:word):word;
//sound
procedure sound_bank_rom(numchip:integer;valor:byte);

const
        //Caveman Ninja
        cninja_rom:array[0..6] of tipo_roms=(
        (n:'gn-02-3.1k';l:$20000;p:0;crc:$39aea12a),(n:'gn-05-2.3k';l:$20000;p:$1;crc:$0f4360ef),
        (n:'gn-01-2.1j';l:$20000;p:$40000;crc:$f740ef7e),(n:'gn-04-2.3j';l:$20000;p:$40001;crc:$c98fcb62),
        (n:'gn-00.rom';l:$20000;p:$80000;crc:$0b110b16),(n:'gn-03.rom';l:$20000;p:$80001;crc:$1e28e697),());
        cninja_sound:tipo_roms=(n:'gl-07.rom';l:$10000;p:$0;crc:$ca8bef96);
        cninja_chars:array[0..2] of tipo_roms=(
        (n:'gl-09.rom';l:$10000;p:$0;crc:$5a2d4752),(n:'gl-08.rom';l:$10000;p:1;crc:$33a2b400),());
        cninja_tiles1:tipo_roms=(n:'mag-02.rom';l:$80000;p:$0;crc:$de89c69a);
        cninja_tiles2:array[0..2] of tipo_roms=(
        (n:'mag-00.rom';l:$80000;p:$0;crc:$a8f05d33),(n:'mag-01.rom';l:$80000;p:$80000;crc:$5b399eed),());
        cninja_oki2:tipo_roms=(n:'mag-07.rom';l:$80000;p:0;crc:$08eb5264);
        cninja_oki1:tipo_roms=(n:'gl-06.rom';l:$20000;p:0;crc:$d92e519d);
        cninja_sprites:array[0..4] of tipo_roms=(
        (n:'mag-03.rom';l:$80000;p:0;crc:$2220eb9f),(n:'mag-05.rom';l:$80000;p:$1;crc:$56a53254),
        (n:'mag-04.rom';l:$80000;p:$100000;crc:$144b94cc),(n:'mag-06.rom';l:$80000;p:$100001;crc:$82d44749),());
        //Robocop 2
        robocop2_rom:array[0..8] of tipo_roms=(
        (n:'gq-03.k1';l:$20000;p:0;crc:$a7e90c28),(n:'gq-07.k3';l:$20000;p:$1;crc:$d2287ec1),
        (n:'gq-02.j1';l:$20000;p:$40000;crc:$6777b8a0),(n:'gq-06.j3';l:$20000;p:$40001;crc:$e11e27b5),
        (n:'go-01-1.h1';l:$20000;p:$80000;crc:$ab5356c0),(n:'go-05-1.h3';l:$20000;p:$80001;crc:$ce21bda5),
        (n:'go-00.f1';l:$20000;p:$c0000;crc:$a93369ea),(n:'go-04.f3';l:$20000;p:$c0001;crc:$ee2f6ad9),());
        robocop2_char:array[0..2] of tipo_roms=(
        (n:'gp10-1.y6';l:$10000;p:1;crc:$d25d719c),(n:'gp11-1.z6';l:$10000;p:0;crc:$030ded47),());
        robocop2_sound:tipo_roms=(n:'gp-09.k13';l:$10000;p:$0;crc:$4a4e0f8d);
        robocop2_oki1:tipo_roms=(n:'gp-08.j13';l:$20000;p:0;crc:$365183b1);
        robocop2_oki2:tipo_roms=(n:'mah-11.f13';l:$80000;p:0;crc:$642bc692);
        robocop2_tiles1:array[0..2] of tipo_roms=(
        (n:'mah-04.z4';l:$80000;p:$0;crc:$9b6ca18c),(n:'mah-03.y4';l:$80000;p:$80000;crc:$37894ddc),());
        robocop2_tiles2:array[0..3] of tipo_roms=(
        (n:'mah-01.z1';l:$80000;p:0;crc:$26e0dfff),(n:'mah-00.y1';l:$80000;p:$80000;crc:$7bd69e41),
        (n:'mah-02.a1';l:$80000;p:$100000;crc:$328a247d),());
        robocop2_sprites:array[0..6] of tipo_roms=(
        (n:'mah-05.y9';l:$80000;p:$000000;crc:$6773e613),(n:'mah-08.y12';l:$80000;p:$000001;crc:$88d310a5),
        (n:'mah-06.z9';l:$80000;p:$100000;crc:$27a8808a),(n:'mah-09.z12';l:$80000;p:$100001;crc:$a58c43a7),
        (n:'mah-07.a9';l:$80000;p:$200000;crc:$526f4190),(n:'mah-10.a12';l:$80000;p:$200001;crc:$14b770da),());
type
    tipo_update_video=procedure;
var
 rom:array[0..$fffff] of byte;
 ram:array[0..$3fff] of byte;
 prot104_ram:array[0..$fff] of byte;
 screen_line,irq_mask,irq_line:byte;
 oki2_mem:pbyte;
 prioridad:word;
 proc_update_video:tipo_update_video;

implementation
uses principal;

procedure Cargar_cninja;
begin
llamadas_maquina.bucle_general:=cninja_principal;
llamadas_maquina.iniciar:=iniciar_cninja;
llamadas_maquina.cerrar:=cerrar_cninja;
llamadas_maquina.reset:=reset_cninja;
llamadas_maquina.fps_max:=58;
end;

procedure update_video_cninja;inline;
begin
//fill_full_screen(5,$300);
//poner_sprites($c0);
update_pf_2(1,5,false);
deco16_sprites_pri($80);
update_pf_1(1,5,true);
deco16_sprites_pri($40);
update_pf_2(0,5,true);
deco16_sprites_pri($00);
update_pf_1(0,5,true);
actualiza_trozo_final(0,8,256,240,5);
end;

procedure update_video_robocop2;inline;
begin
if (prioridad and 4)=0 then update_pf_2(1,5,false)
  else begin
    deco16_sprites_pri($c0);
    fill_full_screen(5,$200);
  end;
deco16_sprites_pri($80);
if (prioridad and $8)<>0 then begin
      update_pf_2(0,5,true);
      deco16_sprites_pri($40);
      update_pf_1(1,5,true);
end else begin
      update_pf_1(1,5,true);
      deco16_sprites_pri($40);
      update_pf_2(0,5,true);
end;
deco16_sprites_pri($00);
update_pf_1(0,5,true);
actualiza_trozo_final(0,8,320,240,5);
end;

//Inicio Normal
function iniciar_cninja:boolean;
const
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7);
  pc_y:array[0..7] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16);
  pt_x:array[0..15] of dword=(32*8+0, 32*8+1, 32*8+2, 32*8+3, 32*8+4, 32*8+5, 32*8+6, 32*8+7,
		0, 1, 2, 3, 4, 5, 6, 7);
  pt_y:array[0..15] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16,
			8*16, 9*16, 10*16, 11*16, 12*16, 13*16, 14*16, 15*16);
  ps_x:array[0..15] of dword=(64*8+0, 64*8+1, 64*8+2, 64*8+3, 64*8+4, 64*8+5, 64*8+6, 64*8+7,
		0, 1, 2, 3, 4, 5, 6, 7);
  ps_y:array[0..15] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32,
			8*32, 9*32, 10*32, 11*32, 12*32, 13*32, 14*32, 15*32);
var
  memoria_temp,memoria_temp2,ptemp,ptemp2:pbyte;
  f:dword;
  tempw,tempw2:word;

procedure cninja_convert_chars(num:word);
begin
init_gfx(0,8,8,num);
gfx[0].trans[0]:=true;
des_gfx.pos_planos[0]:=num*16*8+8;
des_gfx.pos_planos[1]:=num*16*8+0;
des_gfx.pos_planos[2]:=8;
des_gfx.pos_planos[3]:=0;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=16*8;
convert_gfx(@gfx[0],0,memoria_temp,@pc_x[0],@pc_y[0],false,false);
end;

procedure cninja_convert_tiles(ngfx:byte;num:word);
begin
init_gfx(ngfx,16,16,num);
gfx[ngfx].trans[0]:=true;
des_gfx.pos_planos[0]:=num*64*8+8;
des_gfx.pos_planos[1]:=num*64*8+0;
des_gfx.pos_planos[2]:=8;
des_gfx.pos_planos[3]:=0;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=64*8;
convert_gfx(@gfx[ngfx],0,memoria_temp2,@pt_x[0],@pt_y[0],false,false);
end;

procedure cninja_convert_sprites(num:dword);
begin
init_gfx(3,16,16,num);
gfx[3].trans[0]:=true;
des_gfx.pos_planos[0]:=16;
des_gfx.pos_planos[1]:=0;
des_gfx.pos_planos[2]:=24;
des_gfx.pos_planos[3]:=8;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=128*8;
convert_gfx(@gfx[3],0,memoria_temp,@ps_x[0],@ps_y[0],false,false);
end;

begin
iniciar_cninja:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].y:=240;
case main_vars.tipo_maquina of
  162:begin
        p_final[0].x:=256;
        init_dec16ic(0,1,2,$000,$000,$f,$f,0,1,0,16,nil,nil);
        init_dec16ic(1,3,4,$000,$200,$f,$f,0,2,0,48,cninja_video_bank,cninja_video_bank);
        deco16_global_x_size:=240;
      end;
  163:begin
        p_final[0].x:=320;
        init_dec16ic(0,1,2,$000,$000,$f,$f,0,1,0,16,nil,robocop2_video_bank);
        init_dec16ic(1,3,4,$000,$200,$f,$f,0,2,0,48,robocop2_video_bank,robocop2_video_bank);
        deco16_global_x_size:=304;
      end;
end;
p_final[5].x:=512;
p_final[5].y:=512;
p_final[5].final_mix:=true;
iniciar_video;
//Sound CPU
deco16_sprite_color_add:=$300;
deco16_snd_double_init(32220000 div 8,32220000,sound_bank_rom);
getmem(memoria_temp,$300000);
getmem(oki2_mem,$80000);
case main_vars.tipo_maquina of
  162:begin //Caveman Ninja
        deco16_sprite_mask:=$3fff;
        //Main CPU
        init_cpu(m68000_main,0,12000000/$100);
        main_68000_ll.getword:=cninja_getword;
        main_68000_ll.putword:=cninja_putword;
        proc_update_video:=update_video_cninja;
        //cargar roms y parchear
        if not(cargar_roms16b(@rom[0],@cninja_rom[0],'cninja.zip',0)) then exit;
        for f:=0 to $3ffff do begin
        		tempw:=rom[(f*2)+1] or (rom[f*2] shl 8);
        		if ((tempw=$66ff) or (tempw=$67ff)) then begin
              tempw2:=rom[((f-4)*2)+1] or (rom[(f-4)*2] shl 8);
        			// Cmpi + btst controlling opcodes */
        			if ((tempw2=$c39) or (tempw2=$839)) then begin
                rom[(f*2)+1]:=$71;
                rom[f*2]:=$4e;
                rom[((f-1)*2)+1]:=$71;
                rom[(f-1)*2]:=$4e;
                rom[((f-2)*2)+1]:=$71;
                rom[(f-2)*2]:=$4e;
                rom[((f-3)*2)+1]:=$71;
                rom[(f-3)*2]:=$4e;
                rom[((f-4)*2)+1]:=$71;
                rom[(f-4)*2]:=$4e;
        			end;
        	  end;
        end;
        //cargar sonido
        if not(cargar_roms(@mem_snd[0],@cninja_sound,'cninja.zip',1)) then exit;
        //OKIs rom
        if not(cargar_roms(oki_6295[0].rom,@cninja_oki1,'cninja.zip',1)) then exit;
        if not(cargar_roms(oki2_mem,@cninja_oki2,'cninja.zip',1)) then exit;
        //convertir chars
        if not(cargar_roms16b(memoria_temp,@cninja_chars[0],'cninja.zip',0)) then exit;
        cninja_convert_chars($1000);
        //Tiles
        getmem(memoria_temp2,$100000);
        if not(cargar_roms(memoria_temp2,@cninja_tiles1,'cninja.zip',1)) then exit;
        cninja_convert_tiles(1,$1000);
        if not(cargar_roms(memoria_temp,@cninja_tiles2[0],'cninja.zip',0)) then exit;
        //ordenar
        ptemp:=memoria_temp2;
        ptemp2:=memoria_temp;
        copymemory(ptemp,ptemp2,$40000);
        inc(ptemp2,$40000);
        inc(ptemp,$80000);
        copymemory(ptemp,ptemp2,$40000);
        inc(ptemp2,$40000);
        ptemp:=memoria_temp2;
        inc(ptemp,$40000);
        copymemory(ptemp,ptemp2,$40000);
        inc(ptemp2,$40000);
        inc(ptemp,$80000);
        copymemory(ptemp,ptemp2,$40000);
        cninja_convert_tiles(2,$2000);
        freemem(memoria_temp2);
        //Sprites
        if not(cargar_roms16b(memoria_temp,@cninja_sprites[0],'cninja.zip',0)) then exit;
        cninja_convert_sprites($4000);
  end;
  163:begin //Robocop 2
        deco16_sprite_mask:=$7fff;
        //Main CPU
        init_cpu(m68000_main,0,14000000/$100);
        main_68000_ll.getword:=robocop2_getword;
        main_68000_ll.putword:=robocop2_putword;
        proc_update_video:=update_video_robocop2;
        //cargar roms
        if not(cargar_roms16b(@rom[0],@robocop2_rom[0],'robocop2.zip',0)) then exit;
        //cargar sonido
        if not(cargar_roms(@mem_snd[0],@robocop2_sound,'robocop2.zip',1)) then exit;
        //OKIs rom
        if not(cargar_roms(oki_6295[0].rom,@robocop2_oki1,'robocop2.zip',1)) then exit;
        if not(cargar_roms(oki2_mem,@robocop2_oki2,'robocop2.zip',1)) then exit;
        //convertir chars
        if not(cargar_roms16b(memoria_temp,@robocop2_char[0],'robocop2.zip',0)) then exit;
        cninja_convert_chars($1000);
        //Tiles
        if not(cargar_roms(memoria_temp,@robocop2_tiles1[0],'robocop2.zip',0)) then exit;
        getmem(memoria_temp2,$180000);
        ptemp:=memoria_temp2;
        ptemp2:=memoria_temp;
        copymemory(ptemp,ptemp2,$40000);
        inc(ptemp2,$40000);
        inc(ptemp,$80000);
        copymemory(ptemp,ptemp2,$40000);
        inc(ptemp2,$40000);
        ptemp:=memoria_temp2;
        inc(ptemp,$40000);
        copymemory(ptemp,ptemp2,$40000);
        inc(ptemp2,$40000);
        inc(ptemp,$80000);
        copymemory(ptemp,ptemp2,$40000);
        cninja_convert_tiles(1,$2000);
        //Tiles 2
        if not(cargar_roms(memoria_temp,@robocop2_tiles2[0],'robocop2.zip',0)) then exit;
        ptemp:=memoria_temp2;
        ptemp2:=memoria_temp;
        copymemory(ptemp,ptemp2,$40000);
        inc(ptemp,$c0000);
        inc(ptemp2,$40000);
        copymemory(ptemp,ptemp2,$40000);
        inc(ptemp2,$40000);
        ptemp:=memoria_temp2;
        inc(ptemp,$40000);
        copymemory(ptemp,ptemp2,$40000);
        inc(ptemp2,$40000);
        inc(ptemp,$c0000);
        copymemory(ptemp,ptemp2,$40000);
        inc(ptemp2,$40000);
        ptemp:=memoria_temp2;
        inc(ptemp,$80000);
        copymemory(ptemp,ptemp2,$40000);
        inc(ptemp2,$40000);
        inc(ptemp,$c0000); 
        copymemory(ptemp,ptemp2,$40000);
        cninja_convert_tiles(2,$3000);
        //Tiles 8bbp
        init_gfx(4,16,16,$1000);
        gfx[4].trans[0]:=true;
        des_gfx.pos_planos[0]:=$100000*8+8;
        des_gfx.pos_planos[1]:=$100000*8;
        des_gfx.pos_planos[2]:=$40000*8+8;
        des_gfx.pos_planos[3]:=$40000*8;
        des_gfx.pos_planos[4]:=$c0000*8+8;
        des_gfx.pos_planos[5]:=$c0000*8;
        des_gfx.pos_planos[6]:=8;
        des_gfx.pos_planos[7]:=0;
        des_gfx.bit_pixel:=8;
        des_gfx.banks:=0;
        des_gfx.long_sprites:=64*8;
        convert_gfx(@gfx[4],0,memoria_temp2,@pt_x[0],@pt_y[0],false,false);
        freemem(memoria_temp2);
        //Sprites
        if not(cargar_roms16b(memoria_temp,@robocop2_sprites[0],'robocop2.zip',0)) then exit;
        cninja_convert_sprites($6000);
  end;
end;
//final
freemem(memoria_temp);
reset_cninja;
iniciar_cninja:=true;
end;

procedure cerrar_cninja;
begin
cerrar_cpus;
close_dec16ic(0);
close_dec16ic(1);
deco16_snd_double_close;
close_audio;
close_video;
freemem(oki2_mem);
end;

procedure reset_cninja;
begin
 reset_68000(main_68000,main_68000_ll);
 reset_dec16ic(0);
 reset_dec16ic(1);
 deco16_snd_double_reset;
 copymemory(oki_6295[1].rom,oki2_mem,$40000);
 reset_audio;
 in0:=$FF;
 in1:=$F7;
 in2:=$FF;
 irq_mask:=0;
 irq_line:=0;
end;

procedure eventos_cninja;
begin
if event.arcade then begin
  //P1
  if arcade_input.up[0] then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if arcade_input.down[0] then in0:=(in0 and $Fd) else in0:=(in0 or $2);
  if arcade_input.left[0] then in0:=(in0 and $fb) else in0:=(in0 or $4);
  if arcade_input.right[0] then in0:=(in0 and $F7) else in0:=(in0 or $8);
  if arcade_input.but0[0] then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if arcade_input.but1[0] then in0:=(in0 and $df) else in0:=(in0 or $20);
  if arcade_input.start[0] then in0:=(in0 and $7f) else in0:=(in0 or $80);
  //P2
  if arcade_input.up[1] then in2:=(in2 and $fe) else in2:=(in2 or $1);
  if arcade_input.down[1] then in2:=(in2 and $Fd) else in2:=(in2 or $2);
  if arcade_input.left[1] then in2:=(in2 and $fb) else in2:=(in2 or $4);
  if arcade_input.right[1] then in2:=(in2 and $F7) else in2:=(in2 or $8);
  if arcade_input.but0[1] then in2:=(in2 and $ef) else in2:=(in2 or $10);
  if arcade_input.but1[1] then in2:=(in2 and $df) else in2:=(in2 or $20);
  if arcade_input.start[1] then in2:=(in2 and $7f) else in2:=(in2 or $80);
  //SYSTEM
  if arcade_input.coin[0] then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if arcade_input.coin[1] then in1:=(in1 and $fd) else in1:=(in1 or $2);
end;
end;

procedure cninja_principal;
var
  frame_m,frame_s:single;
begin
init_controls(false,false,false,true);
frame_m:=main_68000.tframes;
frame_s:=main_h6280.tframes;
while EmuStatus=EsRuning do begin
 for screen_line:=0 to $ff do begin
   run_68000(main_68000,main_68000_ll,trunc(frame_m));
   frame_m:=frame_m+main_68000.tframes-main_68000.contador;
   run_h6280(main_h6280,main_h6280_ll,trunc(frame_s));
   frame_s:=frame_s+main_h6280.tframes-main_h6280.contador;
   case screen_line of
      0..239:if (((irq_mask and $2)<>0) and (irq_line>0) and (irq_line<240)) then begin
              if (irq_mask and $10)<>0 then main_68000.irq[3]:=ASSERT_LINE
                else main_68000.irq[4]:=ASSERT_LINE;
          end;
      247:begin
            main_68000.irq[5]:=HOLD_LINE;
            proc_update_video;
            in1:=in1 and $f7;
          end;
      255:in1:=in1 or $8;
   end;
 end;
 eventos_cninja;
 video_sync;
end;
end;

procedure cambiar_color(numero:word);
var
  color:tcolor;
begin
  color.b:=buffer_paleta[(numero*4)+1];
  color.g:=buffer_paleta[(numero*4)+2];
  color.r:=buffer_paleta[(numero*4)+3];
  set_pal_color(color,addr(paleta[numero]));
  case numero of
    $000..$0ff:deco16ic_chip[0].dec16ic_buffer_color[1,(numero shr 4) and $f]:=true;
    $100..$1ff:deco16ic_chip[0].dec16ic_buffer_color[2,(numero shr 4) and $f]:=true;
    $200..$2ff:deco16ic_chip[1].dec16ic_buffer_color[1,(numero shr 4) and deco16ic_chip[1].dec16ic_color_mask[1]]:=true;
    $500..$5ff:deco16ic_chip[1].dec16ic_buffer_color[2,(numero shr 4) and $f]:=true;
  end;
end;

function deco16_104_cninja_prot_r(offset:word):word;inline;
begin
	case offset of
		$80:deco16_104_cninja_prot_r:=(prot104_ram[0] shl 8)+prot104_ram[1]; // Master level control */
    $de:deco16_104_cninja_prot_r:=(prot104_ram[2] shl 8)+prot104_ram[3]; // Restart position control */
    $e6:deco16_104_cninja_prot_r:=(prot104_ram[4] shl 8)+prot104_ram[5]; // The number of credits in the system. */
    $86:deco16_104_cninja_prot_r:=(prot104_ram[6] shl 8)+prot104_ram[7]; // End of game check.  See 0x1814 */
		// Video registers */
    $5a:deco16_104_cninja_prot_r:=(prot104_ram[16] shl 8)+prot104_ram[17]; // Moved to 0x140000 on int */
    $84:deco16_104_cninja_prot_r:=(prot104_ram[18] shl 8)+prot104_ram[19]; // Moved to 0x14000a on int */
    $20:deco16_104_cninja_prot_r:=(prot104_ram[20] shl 8)+prot104_ram[21]; // Moved to 0x14000c on int */
    $72:deco16_104_cninja_prot_r:=(prot104_ram[22] shl 8)+prot104_ram[23]; // Moved to 0x14000e on int */
    $dc:deco16_104_cninja_prot_r:=(prot104_ram[24] shl 8)+prot104_ram[25]; // Moved to 0x150000 on int */
    $6e:deco16_104_cninja_prot_r:=(prot104_ram[26] shl 8)+prot104_ram[27]; // Moved to 0x15000a on int */
    $6c:deco16_104_cninja_prot_r:=(prot104_ram[28] shl 8)+prot104_ram[29]; // Moved to 0x15000c on int */
    $08:deco16_104_cninja_prot_r:=(prot104_ram[30] shl 8)+prot104_ram[31]; // Moved to 0x15000e on int */
    $36:deco16_104_cninja_prot_r:=$7fff; // Dip switches */
    $1c8:deco16_104_cninja_prot_r:=$0000+in1; // Coins */
    $22c:deco16_104_cninja_prot_r:=(in2 shl 8)+in0; // Player 1 & 2 input ports */
      else deco16_104_cninja_prot_r:=0;
  end;
end;

function cninja_getword(direccion:dword):word;
begin
direccion:=direccion and $fffffe;
case direccion of
  $0..$bffff:cninja_getword:=rom[direccion+1] or (rom[direccion] shl 8);
  $144000..$144fff:cninja_getword:=deco16ic_chip[0].dec16ic_pf_data[1,(direccion and $fff)+1] or (deco16ic_chip[0].dec16ic_pf_data[1,direccion and $fff] shl 8);
  $146000..$146fff:cninja_getword:=deco16ic_chip[0].dec16ic_pf_data[2,(direccion and $fff)+1] or (deco16ic_chip[0].dec16ic_pf_data[2,direccion and $fff] shl 8);
  $14c000..$14c7ff:cninja_getword:=deco16ic_chip[0].dec16ic_pf_rowscroll[1,(direccion and $7ff) shr 1];
  $14e000..$14e7ff:cninja_getword:=deco16ic_chip[0].dec16ic_pf_rowscroll[2,(direccion and $7ff) shr 1];
  $154000..$154fff:cninja_getword:=deco16ic_chip[1].dec16ic_pf_data[1,(direccion and $fff)+1] or (deco16ic_chip[1].dec16ic_pf_data[1,direccion and $fff] shl 8);
  $156000..$156fff:cninja_getword:=deco16ic_chip[1].dec16ic_pf_data[2,(direccion and $fff)+1] or (deco16ic_chip[1].dec16ic_pf_data[2,direccion and $fff] shl 8);
  $15c000..$15c7ff:cninja_getword:=deco16ic_chip[1].dec16ic_pf_rowscroll[1,(direccion and $7ff) shr 1];
  $15e000..$15e7ff:cninja_getword:=deco16ic_chip[1].dec16ic_pf_rowscroll[2,(direccion and $7ff) shr 1];
  $184000..$187fff:cninja_getword:=ram[(direccion and $3fff)+1] or (ram[direccion and $3fff] shl 8);
  $190000..$190007:case (direccion and $7) of
                      1:cninja_getword:=screen_line; // Raster IRQ scanline position
	                    2:begin // Raster IRQ ACK
                          main_68000.irq[3]:=CLEAR_LINE;
                          main_68000.irq[4]:=CLEAR_LINE;
                          cninja_getword:=0;
                      end;
                        else cninja_getword:=0;
                   end;
  $19c000..$19dfff:cninja_getword:=buffer_paleta[(direccion and $1fff)+1] or (buffer_paleta[direccion and $1fff] shl 8);
  $1a4000..$1a47ff:cninja_getword:=sprite_ram[(direccion and $7ff)+1] or (sprite_ram[direccion and $7ff] shl 8);
	$1bc000..$1bcfff:cninja_getword:=deco16_104_cninja_prot_r(direccion and $fff);
end;
end;

procedure cninja_putword(direccion:dword;valor:word);
begin
direccion:=direccion and $fffffe;
if direccion<$c0000 then exit;
case direccion of
  $140000..$14000f:dec16ic_pf_control_w(0,(direccion and $f) shr 1,valor);
  $144000..$144fff:begin
                      deco16ic_chip[0].dec16ic_pf_data[1,(direccion and $fff)+1]:=valor and $ff;
                      deco16ic_chip[0].dec16ic_pf_data[1,direccion and $fff]:=valor shr 8;
                      deco16ic_chip[0].dec16ic_buffer[1,(direccion and $fff) shr 1]:=true
                   end;
  $146000..$146fff:begin
                      deco16ic_chip[0].dec16ic_pf_data[2,(direccion and $fff)+1]:=valor and $ff;
                      deco16ic_chip[0].dec16ic_pf_data[2,direccion and $fff]:=valor shr 8;
                      deco16ic_chip[0].dec16ic_buffer[2,(direccion and $fff) shr 1]:=true
                   end;
  $14c000..$14c7ff:deco16ic_chip[0].dec16ic_pf_rowscroll[1,(direccion and $7ff) shr 1]:=valor;
  $14e000..$14e7ff:deco16ic_chip[0].dec16ic_pf_rowscroll[2,(direccion and $7ff) shr 1]:=valor;
  $150000..$15000f:dec16ic_pf_control_w(1,(direccion and $f) shr 1,valor);
	$154000..$154fff:begin
                      deco16ic_chip[1].dec16ic_pf_data[1,(direccion and $fff)+1]:=valor and $ff;
                      deco16ic_chip[1].dec16ic_pf_data[1,direccion and $fff]:=valor shr 8;
                      deco16ic_chip[1].dec16ic_buffer[1,(direccion and $fff) shr 1]:=true
                   end;
  $156000..$156fff:begin
                      deco16ic_chip[1].dec16ic_pf_data[2,(direccion and $fff)+1]:=valor and $ff;
                      deco16ic_chip[1].dec16ic_pf_data[2,direccion and $fff]:=valor shr 8;
                      deco16ic_chip[1].dec16ic_buffer[2,(direccion and $fff) shr 1]:=true
                   end;
  $15c000..$15c7ff:deco16ic_chip[1].dec16ic_pf_rowscroll[1,(direccion and $7ff) shr 1]:=valor;
  $15e000..$15e7ff:deco16ic_chip[1].dec16ic_pf_rowscroll[2,(direccion and $7ff) shr 1]:=valor;
  $184000..$187fff:begin
                      ram[(direccion and $3fff)+1]:=valor and $ff;
                      ram[direccion and $3fff]:=valor shr 8;
                   end;
	$190000..$190007:case (direccion and $7) of
	                    0:irq_mask:=valor and $ff; // IRQ enable:
	                    1:irq_line:=valor and $ff; // Raster IRQ scanline position, only valid for values between 1 & 239 (0 and 240-256 do NOT generate IRQ's) */
                   end;
  $19c000..$19dfff:if valor<>(buffer_paleta[(direccion and $1fff)+1] or (buffer_paleta[direccion and $1fff] shl 8)) then begin
                      buffer_paleta[(direccion and $1fff)+1]:=valor and $ff;
                      buffer_paleta[direccion and $1fff]:=valor shr 8;
                      cambiar_color((direccion and $1fff) shr 2);
                   end;
  $1a4000..$1a47ff:begin
                      sprite_ram[(direccion and $7ff)+1]:=valor and $ff;
                      sprite_ram[direccion and $7ff]:=valor shr 8;
                   end;
  $1b4000..$1b4001:copymemory(@buffer_sprites[0],@sprite_ram[0],$800);
  $1b0002..$1b000f:;
	$1bc000..$1bcfff:begin
                      prot104_ram[(direccion and $fff)+1]:=valor and $ff;
                      prot104_ram[direccion and $fff]:=valor shr 8;
                      if (direccion and $fff)=$a8 then begin
                        deco16_sound_latch:=valor and $ff;
                        set_irq_line(main_h6280,0,HOLD_LINE);
                      end;
                   end;
end;
end;

//Roboop 2
function robocop2_getword(direccion:dword):word;
begin
direccion:=direccion and $fffffe;
case direccion of
  $0..$fffff:robocop2_getword:=rom[direccion+1] or (rom[direccion] shl 8);
  $144000..$144fff:robocop2_getword:=deco16ic_chip[0].dec16ic_pf_data[1,(direccion and $fff)+1] or (deco16ic_chip[0].dec16ic_pf_data[1,direccion and $fff] shl 8);
  $146000..$146fff:robocop2_getword:=deco16ic_chip[0].dec16ic_pf_data[2,(direccion and $fff)+1] or (deco16ic_chip[0].dec16ic_pf_data[2,direccion and $fff] shl 8);
  $14c000..$14c7ff:robocop2_getword:=deco16ic_chip[0].dec16ic_pf_rowscroll[1,(direccion and $7ff) shr 1];
  $14e000..$14e7ff:robocop2_getword:=deco16ic_chip[0].dec16ic_pf_rowscroll[2,(direccion and $7ff) shr 1];
  $154000..$154fff:robocop2_getword:=deco16ic_chip[1].dec16ic_pf_data[1,(direccion and $fff)+1] or (deco16ic_chip[1].dec16ic_pf_data[1,direccion and $fff] shl 8);
  $156000..$156fff:robocop2_getword:=deco16ic_chip[1].dec16ic_pf_data[2,(direccion and $fff)+1] or (deco16ic_chip[1].dec16ic_pf_data[2,direccion and $fff] shl 8);
  $15c000..$15c7ff:robocop2_getword:=deco16ic_chip[1].dec16ic_pf_rowscroll[1,(direccion and $7ff) shr 1];
  $15e000..$15e7ff:robocop2_getword:=deco16ic_chip[1].dec16ic_pf_rowscroll[2,(direccion and $7ff) shr 1];
  $180000..$1807ff:robocop2_getword:=sprite_ram[(direccion and $7ff)+1] or (sprite_ram[direccion and $7ff] shl 8);
  $18c000..$18c7ff:case (direccion and $7ff) of
                      $320:robocop2_getword:=in1;
                      $41a:robocop2_getword:=(in2 shl 8)+in0;
                      $4e6:robocop2_getword:=$7fbf;
                      $504:robocop2_getword:=$84;
                   end;
  $1a8000..$1a9fff:robocop2_getword:=buffer_paleta[(direccion and $1fff)+1] or (buffer_paleta[direccion and $1fff] shl 8);
  $1b0000..$1b0007:case (direccion and $7) of
                      1:robocop2_getword:=screen_line; // Raster IRQ scanline position
	                    2:begin // Raster IRQ ACK
                          main_68000.irq[3]:=CLEAR_LINE;
                          main_68000.irq[4]:=CLEAR_LINE;
                          robocop2_getword:=0;
                      end;
                        else robocop2_getword:=0;
                   end;
  $1b8000..$1bbfff:robocop2_getword:=ram[(direccion and $3fff)+1] or (ram[direccion and $3fff] shl 8);
	$1f8000..$1f8001:robocop2_getword:=$00ff;
end;
end;

procedure robocop2_putword(direccion:dword;valor:word);
begin
direccion:=direccion and $fffffe;
if direccion<$100000 then exit;
case direccion of
  $140000..$14000f:dec16ic_pf_control_w(0,(direccion and $f) shr 1,valor);
  $144000..$144fff:begin
                      deco16ic_chip[0].dec16ic_pf_data[1,(direccion and $fff)+1]:=valor and $ff;
                      deco16ic_chip[0].dec16ic_pf_data[1,direccion and $fff]:=valor shr 8;
                      deco16ic_chip[0].dec16ic_buffer[1,(direccion and $fff) shr 1]:=true
                   end;
  $146000..$146fff:begin
                      deco16ic_chip[0].dec16ic_pf_data[2,(direccion and $fff)+1]:=valor and $ff;
                      deco16ic_chip[0].dec16ic_pf_data[2,direccion and $fff]:=valor shr 8;
                      deco16ic_chip[0].dec16ic_buffer[2,(direccion and $fff) shr 1]:=true
                   end;
  $14c000..$14c7ff:deco16ic_chip[0].dec16ic_pf_rowscroll[1,(direccion and $7ff) shr 1]:=valor;
  $14e000..$14e7ff:deco16ic_chip[0].dec16ic_pf_rowscroll[2,(direccion and $7ff) shr 1]:=valor;
  $150000..$15000f:dec16ic_pf_control_w(1,(direccion and $f) shr 1,valor);
	$154000..$154fff:begin
                      deco16ic_chip[1].dec16ic_pf_data[1,(direccion and $fff)+1]:=valor and $ff;
                      deco16ic_chip[1].dec16ic_pf_data[1,direccion and $fff]:=valor shr 8;
                      deco16ic_chip[1].dec16ic_buffer[1,(direccion and $fff) shr 1]:=true
                   end;
  $156000..$156fff:begin
                      deco16ic_chip[1].dec16ic_pf_data[2,(direccion and $fff)+1]:=valor and $ff;
                      deco16ic_chip[1].dec16ic_pf_data[2,direccion and $fff]:=valor shr 8;
                      deco16ic_chip[1].dec16ic_buffer[2,(direccion and $fff) shr 1]:=true
                   end;
  $15c000..$15c7ff:deco16ic_chip[1].dec16ic_pf_rowscroll[1,(direccion and $7ff) shr 1]:=valor;
  $15e000..$15e7ff:deco16ic_chip[1].dec16ic_pf_rowscroll[2,(direccion and $7ff) shr 1]:=valor;
  $180000..$1807ff:begin
                      sprite_ram[(direccion and $7ff)+1]:=valor and $ff;
                      sprite_ram[direccion and $7ff]:=valor shr 8;
                   end;
  $18c000..$18c7ff:case direccion and $7ff of
                      $64:begin
                            deco16_sound_latch:=valor and $ff;
                            set_irq_line(main_h6280,0,HOLD_LINE);
                      end;
                   end;
  $198000..$198001:copymemory(@buffer_sprites[0],@sprite_ram[0],$800);
  $1a0002..$1a00ff:;
  $1a8000..$1a9fff:if valor<>(buffer_paleta[(direccion and $1fff)+1] or (buffer_paleta[direccion and $1fff] shl 8)) then begin
                      buffer_paleta[(direccion and $1fff)+1]:=valor and $ff;
                      buffer_paleta[direccion and $1fff]:=valor shr 8;
                      cambiar_color((direccion and $1fff) shr 2);
                   end;
  $1b0000..$1b0007:case (direccion and $7) of
	                    0:irq_mask:=valor and $ff; // IRQ enable:
	                    1:irq_line:=valor and $ff; // Raster IRQ scanline position, only valid for values between 1 & 239 (0 and 240-256 do NOT generate IRQ's) */
                   end;
  $1b8000..$1bbfff:begin
                      ram[(direccion and $3fff)+1]:=valor and $ff;
                      ram[direccion and $3fff]:=valor shr 8;
                   end;
  $1f0000..$1f0001:if prioridad<>valor then begin
                     prioridad:=valor;
                     if (prioridad and 4)<>0 then begin
                        deco16ic_chip[1].dec16ic_gfx_plane[2]:=4;
                        deco16ic_chip[1].dec16ic_color_mask[2]:=0;
                     end else begin
                        deco16ic_chip[1].dec16ic_gfx_plane[2]:=2;
                        deco16ic_chip[1].dec16ic_color_mask[2]:=$f;
                     end;
                     fillchar(deco16ic_chip[1].dec16ic_buffer[1,0],$800,1);
                     fillchar(deco16ic_chip[1].dec16ic_buffer[2,0],$800,1);
                   end;
end;
end;

procedure sound_bank_rom(numchip:integer;valor:byte);
var
  temp:pbyte;
begin
  temp:=oki2_mem;
  inc(temp,(valor and 1)*$40000);
  copymemory(oki_6295[1].rom,temp,$40000);
end;

function cninja_video_bank(bank:word):word;
begin
  	if ((bank shr 4) and $f)<>0 then cninja_video_bank:=$0 // Only 2 banks */
	    else cninja_video_bank:=$1000;
end;

function robocop2_video_bank(bank:word):word;
begin
  	robocop2_video_bank:=(bank and $30) shl 8;
end;

end.
