unit commando_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     z80,main_engine,controls_engine,ym_2203,gfx_engine,misc_functions,
     rom_engine,cpu_engine,pal_engine,sound_engine,timer_engine;

procedure Cargar_commando;
procedure commando_principal;
function iniciar_commando:boolean;
procedure reset_commando;
procedure cerrar_commando;
//Main CPU
function commando_getbyte(direccion:word):byte;
procedure commando_putbyte(direccion:word;valor:byte);
//Sound CPU
function commando_snd_getbyte(direccion:word):byte;
procedure commando_snd_putbyte(direccion:word;valor:byte);
procedure commando_sound;
procedure commando_snd_irq;

const
        commando_rom:array[0..2] of tipo_roms=(
        (n:'cm04.9m';l:$8000;p:0;crc:$8438b694),(n:'cm03.8m';l:$4000;p:$8000;crc:$35486542),());
        commando_snd_rom:tipo_roms=(n:'cm02.9f';l:$4000;p:0;crc:$f9cc4a74);
        commando_pal:array[0..3] of tipo_roms=(
        (n:'vtb1.1d';l:$100;p:0;crc:$3aba15a1),(n:'vtb2.2d';l:$100;p:$100;crc:$88865754),
        (n:'vtb3.3d';l:$100;p:$200;crc:$4c14c3f6),());
        commando_char:tipo_roms=(n:'vt01.5d';l:$4000;p:0;crc:$505726e0);
        commando_sprites:array[0..6] of tipo_roms=(
        (n:'vt05.7e';l:$4000;p:0;crc:$79f16e3d),(n:'vt06.8e';l:$4000;p:$4000;crc:$26fee521),
        (n:'vt07.9e';l:$4000;p:$8000;crc:$ca88bdfd),(n:'vt08.7h';l:$4000;p:$c000;crc:$2019c883),
        (n:'vt09.8h';l:$4000;p:$10000;crc:$98703982),(n:'vt10.9h';l:$4000;p:$14000;crc:$f069d2f8),());
        commando_tiles:array[0..6] of tipo_roms=(
        (n:'vt11.5a';l:$4000;p:0;crc:$7b2e1b48),(n:'vt12.6a';l:$4000;p:$4000;crc:$81b417d3),
        (n:'vt13.7a';l:$4000;p:$8000;crc:$5612dbd2),(n:'vt14.8a';l:$4000;p:$c000;crc:$2b2dee36),
        (n:'vt15.9a';l:$4000;p:$10000;crc:$de70babf),(n:'vt16.10a';l:$4000;p:$14000;crc:$14178237),());

var
 memoria_dec:array[0..$bfff] of byte;
 scroll_x,scroll_y:parejas;
 sound_command:byte;

implementation
uses principal;

procedure Cargar_commando;
begin
llamadas_maquina.iniciar:=iniciar_commando;
llamadas_maquina.bucle_general:=commando_principal;
llamadas_maquina.cerrar:=cerrar_commando;
llamadas_maquina.reset:=reset_commando;
end;

function iniciar_commando:boolean;
var
      colores:tpaleta;
      f:word;
      memoria_temp:array[0..$17fff] of byte;
const
    pc_x:array[0..7] of dword=(0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3);
    pc_y:array[0..7] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16);
    ps_x:array[0..15] of dword=(0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3,
			32*8+0, 32*8+1, 32*8+2, 32*8+3, 33*8+0, 33*8+1, 33*8+2, 33*8+3);
    ps_y:array[0..15] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16,
			8*16, 9*16, 10*16, 11*16, 12*16, 13*16, 14*16, 15*16);
    pt_x:array[0..15] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			16*8+0, 16*8+1, 16*8+2, 16*8+3, 16*8+4, 16*8+5, 16*8+6, 16*8+7);
    pt_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8);
begin
iniciar_commando:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=224;
p_final[0].y:=256;
p_final[1].x:=512;
p_final[1].y:=512;
p_final[1].final_mix:=true;
p_final[2].x:=512;
p_final[2].y:=512;
p_final[2].scroll.long_x:=512;
p_final[2].scroll.long_y:=512;
p_final[2].scroll.max_x:=256;
p_final[2].scroll.max_y:=256;
p_final[2].scroll.mask_x:=511;
p_final[2].scroll.mask_y:=511;
p_final[3].x:=256;
p_final[3].y:=256;
p_final[3].trans:=true;
iniciar_video;
//Main CPU
init_cpu(z80_main,0,4000000/256);
main_z80_ll.getbyte:=commando_getbyte;
main_z80_ll.putbyte:=commando_putbyte;
//Sound CPU
init_cpu(z80_snd,1,3000000/256);
snd_z80_ll.getbyte:=commando_snd_getbyte;
snd_z80_ll.putbyte:=commando_snd_putbyte;
//IRQ Sound CPU
init_timer(1,3000000/(4*60),commando_snd_irq,true);
//Sound Chips
YM2203_Init(0,1,1500000,3000000,2,nil,nil,nil,nil,nil);
YM2203_Init(1,1,1500000,3000000,2,nil,nil,nil,nil,nil);
init_sound_engine(1,3000000,commando_sound);
//cargar y desencriptar las ROMS
if not(cargar_roms(@memoria[0],@commando_rom[0],'commando.zip',0)) then exit;
memoria_dec[0]:=memoria[0];
for f:=1 to $bfff do memoria_dec[f]:=bitswap8(memoria[f],3,2,1,4,7,6,5,0);
//cargar ROMS sonido
if not(cargar_roms(@mem_snd[0],@commando_snd_rom,'commando.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@commando_char,'commando.zip',1)) then exit;
init_gfx(0,8,8,1024);
gfx[0].trans[3]:=true;
des_gfx.pos_planos[0]:=4;
des_gfx.pos_planos[1]:=0;
des_gfx.bit_pixel:=2;
des_gfx.banks:=0;
des_gfx.long_sprites:=16*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,true);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@commando_sprites[0],'commando.zip',0)) then exit;
init_gfx(1,16,16,768);
gfx[1].trans[15]:=true;
des_gfx.pos_planos[0]:=$c000*8+4;
des_gfx.pos_planos[1]:=$c000*8+0;
des_gfx.pos_planos[2]:=4;
des_gfx.pos_planos[3]:=0;
des_gfx.bit_pixel:=4;
des_gfx.long_sprites:=64*8;
convert_gfx(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,true);
//tiles
if not(cargar_roms(@memoria_temp[0],@commando_tiles[0],'commando.zip',0)) then exit;
init_gfx(2,16,16,1024);
des_gfx.pos_planos[0]:=0;
des_gfx.pos_planos[1]:=$8000*8;
des_gfx.pos_planos[2]:=$8000*8*2;
des_gfx.bit_pixel:=3;
des_gfx.long_sprites:=32*8;
convert_gfx(@gfx[2],0,@memoria_temp[0],@pt_x[0],@pt_y[0],false,true);
//poner la paleta
if not(cargar_roms(@memoria_temp[0],@commando_pal[0],'commando.zip',0)) then exit;
for f:=0 to 255 do begin
  colores[f].r:=((memoria_temp[f] and $f) shl 4) or (memoria_temp[f] and $f);
  colores[f].g:=((memoria_temp[f+$100] and $f) shl 4) or (memoria_temp[f+$100] and $f);
  colores[f].b:=((memoria_temp[f+$200] and $f) shl 4) or (memoria_temp[f+$200] and $f);
end;
set_pal(colores,256);
//crear la tabla de colores
for f:=0 to 63 do begin
  gfx[1].colores[f]:=f+128;
  gfx[0].colores[f]:=f+192;
end;
//final
reset_commando;
iniciar_commando:=true;
end;

procedure cerrar_commando;
begin
cerrar_cpus;
YM2203_close(0);
YM2203_close(1);
close_audio;
close_video;
end;

procedure reset_commando;
begin
 reset_z80(main_z80);
 main_z80.im0:=$d7;  //rst 10
 reset_z80(snd_z80);
 YM2203_reset(0);
 YM2203_reset(1);
 reset_audio;
 in0:=$FF;
 in1:=$FF;
 scroll_x.w:=0;
 scroll_y.w:=0;
 sound_command:=0;
end;

procedure update_video_commando;inline;
var
  f,color,nchar,x,y:word;
  attr,bank:byte;
begin
for f:=$3ff downto 0 do begin
  //tiles
  if gfx[2].buffer[f] then begin
      x:=f mod 32;
      y:=31-(f div 32);
      attr:=memoria[$dc00+f];
      nchar:=memoria[$d800+f]+((attr and $c0) shl 2);
      color:=(attr and $f) shl 3;
      put_gfx_flip(x*16,y*16,nchar,color,2,2,(attr and $20)<>0,(attr and $10)<>0);
      gfx[2].buffer[f]:=false;
  end;
  //Chars
  if gfx[0].buffer[f] then begin
    x:=f div 32;
    y:=31-(f mod 32);
    attr:=memoria[f+$d400];
    color:=(attr and $f) shl 2;
    nchar:=memoria[f+$d000]+((attr and $c0) shl 2);
    put_gfx_trans_flip(x*8,y*8,nchar,color,3,0,(attr and $20)<>0,(attr and $10)<>0);
    gfx[0].buffer[f]:=false;
  end;
end;
scroll_x_y(2,1,scroll_x.w,256-scroll_y.w);
//sprites
for f:=$7f downto 0 do begin
    attr:=buffer_sprites[1+(f*4)];
    bank:=(attr and $c0) shr 6;
    if bank<3 then begin
      nchar:=buffer_sprites[f*4]+(bank shl 8);
      color:=attr and $30;
      x:=buffer_sprites[2+(f*4)];
      y:=240-(buffer_sprites[3+(f*4)]+((attr and $1) shl 8));
      put_gfx_sprite(nchar,color,(attr and $8)<>0,(attr and $4)<>0,1);
      actualiza_gfx_sprite(x,y,1,1);
    end;
end;
actualiza_trozo(0,0,256,256,3,0,0,256,256,1);
actualiza_trozo_final(16,0,224,256,1);
copymemory(@buffer_sprites[0],@memoria[$fe00],$200);
end;

procedure eventos_commando;
begin
if event.arcade then begin
  if arcade_input.left[0] then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if arcade_input.right[0] then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if arcade_input.up[0] then in1:=(in1 and $F7) else in1:=(in1 or $8);
  if arcade_input.but0[0] then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if arcade_input.but1[0] then in1:=(in1 and $df) else in1:=(in1 or $20);
  if arcade_input.down[0] then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if arcade_input.start[0] then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if arcade_input.start[1] then in0:=(in0 and $fd) else in0:=(in0 or $2);
  if arcade_input.coin[1] then in0:=(in0 and $bf) else in0:=(in0 or $40);
  if arcade_input.coin[0] then in0:=(in0 and $7f) else in0:=(in0 or $80);
end;
end;

procedure commando_principal;
var
  f:byte;
  frame_m,frame_s:single;
begin
init_controls(false,false,false,true);
frame_m:=main_z80.tframes;
frame_s:=snd_z80.tframes;
while EmuStatus=EsRuning do begin
  for f:=0 to $ff do begin
    //main
    run_z80(main_z80,main_z80_ll,trunc(frame_m));
    frame_m:=frame_m+main_z80.tframes-main_z80.contador;
    //snd
    run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
    frame_s:=frame_s+snd_z80.tframes-snd_z80.contador;
    if (f=239) then begin
            main_z80.pedir_irq:=HOLD_LINE;
            update_video_commando;
    end;
  end;
  eventos_commando;
  video_sync;
end;
end;

function commando_getbyte(direccion:word):byte;
begin
case direccion of
  $0..$bfff:if main_z80.opcode then commando_getbyte:=memoria_dec[direccion]
                 else commando_getbyte:=memoria[direccion];
  $c000:commando_getbyte:=in0;
  $c001:commando_getbyte:=in1;
  $c002:commando_getbyte:=$ff;
  $c003:commando_getbyte:=$ff;
  $c004:commando_getbyte:=$1f;
  else commando_getbyte:=memoria[direccion];
end;
end;

procedure commando_putbyte(direccion:word;valor:byte);
begin
if direccion<$c000 then exit;
case direccion of
   $c800:sound_command:=valor;
   $c808:scroll_y.l:=valor;
   $c809:scroll_y.h:=valor and $1;
   $c80a:scroll_x.l:=valor;
   $c80b:scroll_x.h:=valor and $1;
   $d000..$d7ff:gfx[0].buffer[direccion and $3ff]:=true;
   $d800..$dfff:gfx[2].buffer[direccion and $3ff]:=true;
end;
memoria[direccion]:=valor;
end;

function commando_snd_getbyte(direccion:word):byte;
begin
if direccion=$6000 then commando_snd_getbyte:=sound_command
 else commando_snd_getbyte:=mem_snd[direccion];
end;

procedure commando_snd_putbyte(direccion:word;valor:byte);
begin
if direccion<$4000 then exit;
mem_snd[direccion]:=valor;
case direccion of
  $8000:ym2203_Control(0,valor);
  $8001:ym2203_Write_Reg(0,valor);
  $8002:ym2203_Control(1,valor);
  $8003:ym2203_Write_Reg(1,valor);
end;
end;

procedure commando_sound;
begin
  ym2203_Update(0);
  ym2203_Update(1);
end;

procedure commando_snd_irq;
begin
  snd_z80.pedir_irq:=HOLD_LINE;
end;


end.
