unit contra_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     hd6309,m6809,main_engine,controls_engine,gfx_engine,ym_2151,
     rom_engine,cpu_engine,pal_engine,konami_video,sound_engine;

procedure Cargar_contra;
procedure contra_principal;
function iniciar_contra:boolean;
procedure reset_contra;
procedure cerrar_contra;
//Main CPU
function contra_getbyte(direccion:word): Byte;
procedure contra_putbyte(direccion:word;valor:byte);
//Sound CPU
function sound_getbyte(direccion:word):Byte;
procedure sound_putbyte(direccion:word;valor:byte);
procedure sound_instruccion;

const
        contra_rom:array[0..2] of tipo_roms=(
        (n:'633m03.18a';l:$10000;p:$0;crc:$d045e1da),(n:'633i02.17a';l:$10000;p:$10000;crc:$b2f7bd9a),());
        contra_proms:array[0..4] of tipo_roms=(
        (n:'633e08.10g';l:$100;p:0;crc:$9f0949fa),(n:'633e09.12g';l:$100;p:$100;crc:$14ca5e19),
        (n:'633f10.18g';l:$100;p:$200;crc:$2b244d84),(n:'633f11.20g';l:$100;p:$300;crc:$14ca5e19),());
        contra_chars:array[0..2] of tipo_roms=(
        (n:'633e04.7d';l:$40000;p:0;crc:$14ddc542),(n:'633e05.7f';l:$40000;p:$1;crc:$42185044),());
        contra_chars2:array[0..2] of tipo_roms=(
        (n:'633e06.16d';l:$40000;p:0;crc:$9cf6faae),(n:'633e07.16f';l:$40000;p:$1;crc:$f2d06638),());
        contra_sound:tipo_roms=(n:'633e01.12a';l:$8000;p:$8000;crc:$d1549255);

var
 memoria_rom:array[0..$b,0..$1FFF] of byte;
 banco,sound_latch:byte;

implementation
uses principal;

procedure Cargar_contra;
begin
llamadas_maquina.iniciar:=iniciar_contra;
llamadas_maquina.bucle_general:=contra_principal;
llamadas_maquina.cerrar:=cerrar_contra;
llamadas_maquina.reset:=reset_contra;
end;

function iniciar_contra:boolean;
var
  f:byte;
  memoria_temp:array[0..$7ffff] of byte;
const
    pc_x:array[0..7] of dword=(0, 4, 8, 12, 16, 20, 24, 28 );
    pc_y:array[0..7] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32);
procedure clut_contra;
var
  chip,pal,i,ctabentry,clut:byte;
begin
for chip:=0 to 1 do begin
		for pal:=0 to 7 do begin
			clut:=(chip shl 1) or (pal and 1);
			for i:=0 to $ff do begin
				if (((pal and $01)=0) and (memoria_temp[(clut shl 8) or i]=0)) then ctabentry:=0
				  else ctabentry:=(pal shl 4) or (memoria_temp[(clut shl 8) or i] and $0f);
        gfx[chip].colores[(pal shl 8) or i]:=ctabentry;
			end;
		end;
end;
end;
begin
iniciar_contra:=false;
iniciar_audio(true);
//Pantallas
p_final[0].x:=224;
p_final[0].y:=280;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[1].trans:=true;
p_final[2].x:=256;
p_final[2].y:=256;
p_final[2].scroll.long_x:=256;
p_final[2].scroll.max_x:=256;
p_final[2].scroll.mask_x:=255;
p_final[2].scroll.long_y:=256;
p_final[2].scroll.max_y:=256;
p_final[2].scroll.mask_y:=255;
p_final[3].x:=256;
p_final[3].y:=256;
p_final[3].trans:=true;
p_final[3].scroll:=p_final[2].scroll;
p_final[4].x:=512;
p_final[4].y:=256;
p_final[4].final_mix:=true;
iniciar_video;
//Main CPU
init_cpu(hd6309_main,0,24000000/2/10);
main_6309_ll.getbyte:=contra_getbyte;
main_6309_ll.putbyte:=contra_putbyte;
//Sound CPU
init_cpu(m6809_snd,1,24000000/8/10);
snd_6809_ll.getbyte:=sound_getbyte;
snd_6809_ll.putbyte:=sound_putbyte;
//Audio chips
ym2151_init(0,1,3579545,3000000,nil,nil);
init_sound_engine(1,24000000/8,sound_instruccion);
//cargar roms
if not(cargar_roms(@memoria_temp[0],@contra_rom[0],'contra.zip',0)) then exit;
//Pongo las ROMs en su banco
copymemory(@memoria[$8000],@memoria_temp[$8000],$8000);
for f:=0 to 7 do copymemory(@memoria_rom[f,0],@memoria_temp[$10000+(f*$2000)],$2000);
for f:=0 to 3 do copymemory(@memoria_rom[8+f,0],@memoria_temp[0+(f*$2000)],$2000);
//Cargar Sound
if not(cargar_roms(@mem_snd[0],@contra_sound,'contra.zip',1)) then exit;
//convertir chars
if not(cargar_roms16b(@memoria_temp[0],@contra_chars[0],'contra.zip',0)) then exit;
init_gfx(0,8,8,$4000);
gfx[0].trans[0]:=true;
des_gfx.pos_planos[0]:=0;
des_gfx.pos_planos[1]:=1;
des_gfx.pos_planos[2]:=2;
des_gfx.pos_planos[3]:=3;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=32*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
//chars 2
if not(cargar_roms16b(@memoria_temp[0],@contra_chars2[0],'contra.zip',0)) then exit;
init_gfx(1,8,8,$4000);
gfx[1].trans[0]:=true;
convert_gfx(@gfx[1],0,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
//Color lookup
if not(cargar_roms(@memoria_temp[0],@contra_proms,'contra.zip',0)) then exit;
clut_contra;
reset_contra;
iniciar_contra:=true;
end;

procedure cerrar_contra;
begin
cerrar_cpus;
ym2151_close(0);
close_audio;
close_video;
end;

procedure reset_contra;
begin
 reset_6309(main_6309,main_6309_ll);
 reset_6809(snd_6809,snd_6809_ll);
 reset_audio;
 K007121_reset(0);
 K007121_reset(1);
 ym2151_reset(0);
 in0:=$FF;
 in1:=$FF;
 in2:=$ff;
 banco:=0;
 sound_latch:=0;
end;

procedure draw_sprites(bank:byte);inline;
var
  color_base:word;
begin
  color_base:=(K007121_chip[bank].control[$06] and $30)*2;
  K007121_draw_sprites(bank,4,16,color_base,true);
end;

procedure update_video_contra;inline;
var
  x,y,f,nchar,color,mask:word;
  atrib,bank,bit0,bit1,bit2,bit3:byte;
begin
for f:=$0 to $3ff do begin
    x:=31-(f div 32);
    y:=f mod 32;
    //background
    atrib:=memoria[$4000+f];
    color:=((K007121_chip[1].control[$06] and $30)*2+16)+(atrib and 7);
    if ((gfx[1].buffer[f]) or (gfx[0].color_buffer[color])) then begin
      bit0:=(K007121_chip[1].control[$05] shr 0) and $03;
      bit1:=(K007121_chip[1].control[$05] shr 2) and $03;
      bit2:=(K007121_chip[1].control[$05] shr 4) and $03;
      bit3:=(K007121_chip[1].control[$05] shr 6) and $03;
      bank:= ((atrib and $80) shr 7) or
			((atrib shr (bit0+2)) and $02) or
			((atrib shr (bit1+1)) and $04) or
			((atrib shr (bit2  )) and $08) or
			((atrib shr (bit3-1)) and $10) or
      ((K007121_chip[1].control[$03] and $01) shl 5);
      mask:=(K007121_chip[1].control[$04] and $f0) shr 4;
      bank:=(bank and not(mask shl 1)) or ((K007121_chip[1].control[$04] and mask) shl 1);
      nchar:=memoria[$4400+f]+bank*256;
      put_gfx(x*8,y*8,nchar,color shl 4,2,1);
      gfx[1].buffer[f]:=false;
    end;
    //foreground
    atrib:=memoria[$2000+f];
    color:=((K007121_chip[0].control[$6] and $30)*2+16)+(atrib and 7);
    if ((gfx[0].buffer[$400+f]) or (gfx[0].color_buffer[color])) then begin
      bit0:=(K007121_chip[0].control[$05] shr 0) and $03;
      bit1:=(K007121_chip[0].control[$05] shr 2) and $03;
      bit2:=(K007121_chip[0].control[$05] shr 4) and $03;
      bit3:=(K007121_chip[0].control[$05] shr 6) and $03;
      bank:=((atrib and $80) shr 7) or ((atrib shr (bit0+2)) and $02) or	((atrib shr (bit1+1)) and $04) or	((atrib shr bit2) and $08) or ((atrib shr (bit3-1)) and $10) or ((K007121_chip[0].control[$03] and $01) shl 5);
      mask:=(K007121_chip[0].control[$04] and $f0) shr 4;
      bank:=(bank and not(mask shl 1)) or ((K007121_chip[0].control[$04] and mask) shl 1);
      nchar:=memoria[$2400+f]+bank*256;
      put_gfx_trans(x*8,y*8,nchar,color shl 4,3,0);
      gfx[0].buffer[$400+f]:=false;
    end;
    //text
    atrib:=memoria[$2800+f];
    color:=((K007121_chip[0].control[$6] and $30)*2+16)+(atrib and 7);
    if ((gfx[0].buffer[f]) or (gfx[0].color_buffer[color])) then begin
      bit0:=(K007121_chip[0].control[$05] shr 0) and $03;
      bit1:=(K007121_chip[0].control[$05] shr 2) and $03;
      bit2:=(K007121_chip[0].control[$05] shr 4) and $03;
      bit3:=(K007121_chip[0].control[$05] shr 6) and $03;
      bank:= ((atrib and $80) shr 7) or
			((atrib shr (bit0+2)) and $02) or
			((atrib shr (bit1+1)) and $04) or
			((atrib shr (bit2  )) and $08) or
			((atrib shr (bit3-1)) and $10);
      nchar:=memoria[$2c00+f]+bank*256;
      if y<5 then put_gfx(x*8,y*8,nchar,color shl 4,1,0)
        else put_gfx_trans(x*8,y*8,nchar,color shl 4,1,0);
      gfx[0].buffer[f]:=false;
    end;
end;
fillchar(gfx[0].color_buffer[0],$80,0);
scroll_x_y(2,4,256-K007121_chip[1].control[$2],K007121_chip[1].control[$0]);
scroll_x_y(3,4,256-K007121_chip[0].control[$2],K007121_chip[0].control[$0]);
draw_sprites(0);
draw_sprites(1);
actualiza_trozo(16+32,0+32,224,256,4,0,40,224,256,0);
//El texto empieza en la linea 0 de la pantalla VISIBLE
actualiza_trozo(16,0,224,256,1,0,0,224,256,0);
end;

procedure eventos_contra;
begin
if event.arcade then begin
  if arcade_input.coin[0] then in0:=(in0 and $fe) else in0:=(in0 or 1);
  if arcade_input.coin[1] then in0:=(in0 and $fd) else in0:=(in0 or 2);
  if arcade_input.start[0] then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if arcade_input.start[1] then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if arcade_input.up[0] then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if arcade_input.down[0] then in1:=(in1 and $f7) else in1:=(in1 or $8);
  if arcade_input.left[0] then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if arcade_input.right[0] then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if arcade_input.but0[0] then in1:=(in1 and $df) else in1:=(in1 or $20);
  if arcade_input.but1[0] then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if arcade_input.up[1] then in2:=(in2 and $fb) else in2:=(in2 or $4);
  if arcade_input.down[1] then in2:=(in2 and $f7) else in2:=(in2 or $8);
  if arcade_input.left[1] then in2:=(in2 and $fe) else in2:=(in2 or $1);
  if arcade_input.right[1] then in2:=(in2 and $fd) else in2:=(in2 or $2);
  if arcade_input.but0[1] then in2:=(in2 and $df) else in2:=(in2 or $20);
  if arcade_input.but1[1] then in2:=(in2 and $ef) else in2:=(in2 or $10);
end;
end;

procedure contra_principal;
var
  f:byte;
  frame_m,frame_s:single;
begin
init_controls(false,false,false,true);
frame_m:=main_6309.tframes;
frame_s:=snd_6809.tframes;
while EmuStatus=EsRuning do begin
  for f:=0 to 9 do begin
    //Main
    run_6309(main_6309,main_6309_ll,trunc(frame_m));
    frame_m:=frame_m+main_6309.tframes-main_6309.contador;
    //SND
    run_6809(snd_6809,snd_6809_ll,trunc(frame_s));
    frame_s:=frame_s+snd_6809.tframes-snd_6809.contador;
  end;
  if (K007121_chip[0].control[$07] and $2)<>0 then main_6309.pedir_irq:=HOLD_LINE;
  update_video_contra;
  eventos_contra;
  video_sync;
end;
end;

function contra_getbyte(direccion:word):byte;
begin
    case direccion of
        0..$7:contra_getbyte:=K007121_chip[0].control[direccion];
        $10:contra_getbyte:=in0;
        $11:contra_getbyte:=in1;
        $12:contra_getbyte:=in2;
        $14:contra_getbyte:=$ff;
        $13:contra_getbyte:=0;
        $15:contra_getbyte:=$7a;
        $16:contra_getbyte:=$0f;
        $60..$67:contra_getbyte:=K007121_chip[1].control[direccion and $7];
        $3000..$37ff:contra_getbyte:=K007121_chip[0].sprite_ram[direccion and $7ff];
        $6000..$7fff:contra_getbyte:=memoria_rom[banco,direccion and $1fff];
    else contra_getbyte:=memoria[direccion];
    end;
end;

procedure cambiar_color(dir:byte);inline;
var
  data:word;
  color:tcolor;
begin
  data:=buffer_paleta[dir]+(buffer_paleta[1+dir] shl 8);
  color.r:=pal5bit(data);
  color.g:=pal5bit(data shr 5);
  color.b:=pal5bit(data shr 10);
  dir:=dir shr 1;
  set_pal_color(color,addr(paleta[dir]));
  gfx[0].color_buffer[dir]:=true;
end;

procedure contra_putbyte(direccion:word;valor:byte);
begin
if ((direccion>$5fff) and (direccion<>$7000)) then exit;
memoria[direccion]:=valor;
case direccion of
  $0..$7:if K007121_chip[0].control[direccion]<>valor then begin
            K007121_chip[0].control[direccion]:=valor;
            fillchar(gfx[0].buffer[$400],$400,1);
         end;
  $1a:snd_6809.pedir_irq:=HOLD_LINE;
  $1c:sound_latch:=valor;
  $60..$67:begin
              if K007121_chip[1].control[direccion and $7]<>valor then begin
                  K007121_chip[1].control[direccion and $7]:=valor;
                  fillchar(gfx[1].buffer[0],$400,1);
              end;
              if (direccion and $7)=3 then begin              
                if ((valor and $8)=0) then copymemory(@K007121_chip[1].sprite_ram[0],@memoria[$5800],$800)
		                else copymemory(@K007121_chip[1].sprite_ram[0],@memoria[$5000],$800);
              end;
           end;
  $c00..$cff:if buffer_paleta[direccion and $ff]<>valor then begin
                buffer_paleta[direccion and $ff]:=valor;
                cambiar_color(direccion and $fe);
             end;
  $2000..$27ff:gfx[0].buffer[$400+(direccion and $3ff)]:=true;
  $2800..$2fff:gfx[0].buffer[direccion and $3ff]:=true;
  $3000..$37ff:K007121_chip[0].sprite_ram[direccion and $7ff]:=valor;
  $4000..$47ff:gfx[1].buffer[direccion and $3ff]:=true;
  $7000:begin
          banco:=(valor and $f);
          if banco>$b then banco:=0;
        end;
end;
end;

function sound_getbyte(direccion:word):Byte;
begin
case direccion of
  0:sound_getbyte:=sound_latch;
  $2001:sound_getbyte:=ym2151_status_port_read(0);
    else sound_getbyte:=mem_snd[direccion];
end;
end;

procedure sound_putbyte(direccion:word;valor:byte);
begin
if direccion>$7fff then exit;
mem_snd[direccion]:=valor;
case direccion of
  $2000:ym2151_register_port_write(0,valor);
  $2001:YM2151_data_port_write(0,valor);
end;
end;

procedure sound_instruccion;
begin
  ym2151_Update(0);
end;

end.
