unit doubledragon_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     hd6309,m680x,m6809,z80,ym_2151,msm5205,main_engine,controls_engine,
     gfx_engine,oki6295,rom_engine,cpu_engine,pal_engine,sound_engine;

procedure Cargar_ddragon;
function iniciar_ddragon:boolean; 
procedure reset_ddragon; 
procedure cerrar_ddragon; 
//Double Dragon
procedure ddragon_principal; 
function ddragon_getbyte(direccion:word): Byte;  
procedure ddragon_putbyte(direccion:word;valor:byte); 
function ddragon_sub_getbyte(direccion:word): Byte;  
procedure ddragon_sub_putbyte(direccion:word;valor:byte); 
function ddragon_snd_getbyte(direccion:word): Byte;  
procedure ddragon_snd_putbyte(direccion:word;valor:byte); 
procedure sound_instruccion; 
procedure ym2151_snd_irq(numchip:integer;irqstate:integer);
procedure snd_adpcm0; 
procedure snd_adpcm1; 
//Double Dragon II
procedure ddragon2_principal;
function ddragon2_getbyte(direccion:word): Byte;
procedure ddragon2_putbyte(direccion:word;valor:byte);
function ddragon2_sub_getbyte(direccion:word): Byte;
procedure ddragon2_sub_putbyte(direccion:word;valor:byte);
function ddragon2_snd_getbyte(direccion:word): Byte;
procedure ddragon2_snd_putbyte(direccion:word;valor:byte);
procedure ym2151_snd_irq_dd2(numchip:integer;irqstate:integer);

const
        //Double Dragon
        ddragon_rom:array[0..4] of tipo_roms=(
        (n:'21j-1-5.26';l:$8000;p:$0;crc:$ae714964),(n:'21j-2-3.25';l:$8000;p:$8000;crc:$5779705e),
        (n:'21j-3.24';l:$8000;p:$10000;crc:$dbf24897),(n:'21j-4-1.23';l:$8000;p:$18000;crc:$6c9f46fa),());
        ddragon_sub:tipo_roms=(n:'63701.bin';l:$4000;p:$c000;crc:$f5232d03);
        ddragon_snd:tipo_roms=(n:'21j-0-1';l:$8000;p:$8000;crc:$9efa95bb);
        ddragon_char:tipo_roms=(n:'21j-5';l:$8000;p:0;crc:$7a8b8db4);
        ddragon_tiles:array[0..4] of tipo_roms=(
        (n:'21j-8';l:$10000;p:0;crc:$7c435887),(n:'21j-9';l:$10000;p:$10000;crc:$c6640aed),
        (n:'21j-i';l:$10000;p:$20000;crc:$5effb0a0),(n:'21j-j';l:$10000;p:$30000;crc:$5fb42e7c),());
        ddragon_sprites:array[0..8] of tipo_roms=(
        (n:'21j-a';l:$10000;p:0;crc:$574face3),(n:'21j-b';l:$10000;p:$10000;crc:$40507a76),
        (n:'21j-c';l:$10000;p:$20000;crc:$bb0bc76f),(n:'21j-d';l:$10000;p:$30000;crc:$cb4f231b),
        (n:'21j-e';l:$10000;p:$40000;crc:$a0a0c261),(n:'21j-f';l:$10000;p:$50000;crc:$6ba152f6),
        (n:'21j-g';l:$10000;p:$60000;crc:$3220a0b6),(n:'21j-h';l:$10000;p:$70000;crc:$65c7517d),());
        ddragon_adpcm:array[0..2] of tipo_roms=(
        (n:'21j-6';l:$10000;p:0;crc:$34755de3),(n:'21j-7';l:$10000;p:$10000;crc:$904de6f8),());
        //Double Dragon II
        ddragon2_rom:array[0..4] of tipo_roms=(
        (n:'26a9-04.bin';l:$8000;p:$0;crc:$f2cfc649),(n:'26aa-03.bin';l:$8000;p:$8000;crc:$44dd5d4b),
        (n:'26ab-0.bin';l:$8000;p:$10000;crc:$49ddddcd),(n:'26ac-0e.63';l:$8000;p:$18000;crc:$57acad2c),());
        ddragon2_sub:tipo_roms=(n:'26ae-0.bin';l:$10000;p:$0;crc:$ea437867);
        ddragon2_snd:tipo_roms=(n:'26ad-0.bin';l:$8000;p:$0;crc:$75e36cd6);
        ddragon2_char:tipo_roms=(n:'26a8-0e.19';l:$10000;p:0;crc:$4e80cd36);
        ddragon2_tiles:array[0..2] of tipo_roms=(
        (n:'26j4-0.bin';l:$20000;p:0;crc:$a8c93e76),(n:'26j5-0.bin';l:$20000;p:$20000;crc:$ee555237),());
        ddragon2_sprites:array[0..6] of tipo_roms=(
        (n:'26j0-0.bin';l:$20000;p:0;crc:$db309c84),(n:'26j1-0.bin';l:$20000;p:$20000;crc:$c3081e0c),
        (n:'26af-0.bin';l:$20000;p:$40000;crc:$3a615aad),(n:'26j2-0.bin';l:$20000;p:$60000;crc:$589564ae),
        (n:'26j3-0.bin';l:$20000;p:$80000;crc:$daf040d6),(n:'26a10-0.bin';l:$20000;p:$a0000;crc:$6d16d889),());
        ddragon2_adpcm:array[0..2] of tipo_roms=(
        (n:'26j6-0.bin';l:$20000;p:0;crc:$a84b2a29),(n:'26j7-0.bin';l:$20000;p:$20000;crc:$bc6a48d5),());

var
 rom:array[0..5,0..$3FFF] of byte;
 banco_rom,soundlatch,dd_sub_cpu_busy,vblank:byte;
 scroll_x,scroll_y:parejas;
 //sprite_ram:array[0..$fff] of byte;
 adpcm_mem:array[0..$1ffff] of byte;
 adpcm_idle,adpcm_ch,adpcm_data:array[0..1] of byte;
 adpcm_pos,adpcm_end:array[0..1] of dword;
 tipo_video,mask:byte;

implementation
uses principal;

procedure Cargar_ddragon;
begin
case main_vars.tipo_maquina of
  92:llamadas_maquina.bucle_general:=ddragon_principal;
  96:llamadas_maquina.bucle_general:=ddragon2_principal;
end;
llamadas_maquina.iniciar:=iniciar_ddragon;
llamadas_maquina.cerrar:=cerrar_ddragon;
llamadas_maquina.reset:=reset_ddragon;
llamadas_maquina.fps_max:=6000000/384/272;
end;

function iniciar_ddragon:boolean;
var
  f:word;
  memoria_temp:array[0..$bffff] of byte;
const
    pc_x:array[0..7] of dword=(1, 0, 8*8+1, 8*8+0, 16*8+1, 16*8+0, 24*8+1, 24*8+0);
    pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
    pt_x:array[0..15] of dword=(3, 2, 1, 0, 16*8+3, 16*8+2, 16*8+1, 16*8+0,
		  32*8+3, 32*8+2, 32*8+1, 32*8+0, 48*8+3, 48*8+2, 48*8+1, 48*8+0);
    pt_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
		  8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8);
procedure extract_chars(num:word);
begin
  init_gfx(0,8,8,num);
  gfx[0].trans[0]:=true;
  des_gfx.pos_planos[0]:=0;
  des_gfx.pos_planos[1]:=2;
  des_gfx.pos_planos[2]:=4;
  des_gfx.pos_planos[3]:=6;
  des_gfx.bit_pixel:=4;
  des_gfx.banks:=0;
  des_gfx.long_sprites:=32*8;
  convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
end;
procedure extract_tiles(num:word);
begin
  init_gfx(1,16,16,num);
  des_gfx.pos_planos[0]:=$20000*8+0;
  des_gfx.pos_planos[1]:=$20000*8+4;
  des_gfx.pos_planos[2]:=0;
  des_gfx.pos_planos[3]:=4;
  des_gfx.bit_pixel:=4;
  des_gfx.banks:=0;
  des_gfx.long_sprites:=64*8;
  convert_gfx(@gfx[1],0,@memoria_temp[0],@pt_x[0],@pt_y[0],false,false);
end;
procedure extract_sprites(num:word;pos:byte);
begin
  init_gfx(2,16,16,num);
  gfx[2].trans[0]:=true;
  des_gfx.pos_planos[0]:=pos*$10000*8+0;
  des_gfx.pos_planos[1]:=pos*$10000*8+4;
  des_gfx.pos_planos[2]:=0;
  des_gfx.pos_planos[3]:=4;
  des_gfx.bit_pixel:=4;
  des_gfx.banks:=0;
  des_gfx.long_sprites:=64*8;
  convert_gfx(@gfx[2],0,@memoria_temp[0],@pt_x[0],@pt_y[0],false,false);
end;
begin
iniciar_ddragon:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=256;
p_final[0].y:=240;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[1].trans:=true;
p_final[2].x:=512;
p_final[2].y:=512;
p_final[2].scroll.long_x:=512;
p_final[2].scroll.long_y:=512;
p_final[2].scroll.max_x:=256;
p_final[2].scroll.max_y:=256;
p_final[2].scroll.mask_x:=511;
p_final[2].scroll.mask_y:=511;
p_final[4].x:=512;
p_final[4].y:=512;
p_final[4].final_mix:=true;
iniciar_video;
case main_vars.tipo_maquina of
  92:begin
        //Main CPU
        init_cpu(hd6309_main,0,12000000/272);
        main_6309_ll.getbyte:=ddragon_getbyte;
        main_6309_ll.putbyte:=ddragon_putbyte;
        //Sub CPU
        init_cpu(m6800_snd,1,6000000/272);
        snd_6800_ll.getbyte:=ddragon_sub_getbyte;
        snd_6800_ll.putbyte:=ddragon_sub_putbyte;
        init_6800(cpu_hd63701,snd_6800);
        //Sound CPU
        init_cpu(m6809_snd,2,1500000/272);
        snd_6809_ll.getbyte:=ddragon_snd_getbyte;
        snd_6809_ll.putbyte:=ddragon_snd_putbyte;
        //Sound Chips
        YM2151_Init(0,2,3579545,1500000,nil,ym2151_snd_irq);
        init_sound_engine(2,1500000,sound_instruccion);
        msm5205_init(0,375000,2,MSM5205_S48_4B,1,1500000,snd_adpcm0);
        msm5205_init(1,375000,2,MSM5205_S48_4B,1,1500000,snd_adpcm1);
        //Main roms
        if not(cargar_roms(@memoria_temp[0],@ddragon_rom[0],'ddragon.zip',0)) then exit;
        //Pongo las ROMs en su banco
        copymemory(@memoria[$8000],@memoria_temp[$0],$8000);
        for f:=0 to 5 do copymemory(@rom[f,0],@memoria_temp[$8000+(f*$4000)],$4000);
        //Sub roms
        if not(cargar_roms(@mem_misc[0],@ddragon_sub,'ddragon.zip',1)) then exit;
        //Sound roms
        if not(cargar_roms(@mem_snd[0],@ddragon_snd,'ddragon.zip',1)) then exit;
        if not(cargar_roms(@adpcm_mem[0],@ddragon_adpcm[0],'ddragon.zip',0)) then exit;
        //convertir chars
        if not(cargar_roms(@memoria_temp[0],@ddragon_char,'ddragon.zip',1)) then exit;
        extract_chars($400);
        //convertir tiles
        if not(cargar_roms(@memoria_temp[0],@ddragon_tiles[0],'ddragon.zip',0)) then exit;
        extract_tiles($800);
        //convertir sprites
        if not(cargar_roms(@memoria_temp[0],@ddragon_sprites[0],'ddragon.zip',0)) then exit;
        extract_sprites($1000,4);
        tipo_video:=0;
        mask:=$3
     end;
  96:begin
        //Main CPU
        init_cpu(hd6309_main,0,12000000/272);
        main_6309_ll.getbyte:=ddragon2_getbyte;
        main_6309_ll.putbyte:=ddragon2_putbyte;
        //Sub CPU
        init_cpu(z80_misc,1,4000000/272);
        misc_z80_ll.getbyte:=ddragon2_sub_getbyte;
        misc_z80_ll.putbyte:=ddragon2_sub_putbyte;
        //Sound CPU
        init_cpu(z80_snd,2,3579545/272);
        snd_z80_ll.getbyte:=ddragon2_snd_getbyte;
        snd_z80_ll.putbyte:=ddragon2_snd_putbyte;
        //Sound Chips
        YM2151_Init(0,2,3579545,3579545,nil,ym2151_snd_irq_dd2);
        init_oki6295(0,1056000,OKIM6295_PIN7_HIGH,2,3579545,1);
        init_sound_engine(2,3579545,sound_instruccion);
        //Cargar ADPCM ROMS
        if not(cargar_roms(oki_6295[0].rom,@ddragon2_adpcm[0],'ddragon2.zip',0)) then exit;
        //Main roms
        if not(cargar_roms(@memoria_temp[0],@ddragon2_rom[0],'ddragon2.zip',0)) then exit;
        //Pongo las ROMs en su banco
        copymemory(@memoria[$8000],@memoria_temp[$0],$8000);
        for f:=0 to 5 do copymemory(@rom[f,0],@memoria_temp[$8000+(f*$4000)],$4000);
        //Sub roms
        if not(cargar_roms(@mem_misc[0],@ddragon2_sub,'ddragon2.zip',1)) then exit;
        //Sound roms
        if not(cargar_roms(@mem_snd[0],@ddragon2_snd,'ddragon2.zip',1)) then exit;
        //convertir chars
        if not(cargar_roms(@memoria_temp[0],@ddragon2_char,'ddragon2.zip',1)) then exit;
        extract_chars($800);
        //convertir tiles
        if not(cargar_roms(@memoria_temp[0],@ddragon2_tiles[0],'ddragon2.zip',0)) then exit;
        extract_tiles($800);
        //convertir sprites
        if not(cargar_roms(@memoria_temp[0],@ddragon2_sprites[0],'ddragon2.zip',0)) then exit;
        extract_sprites($1800,6);
        tipo_video:=1;
        mask:=$7;
     end;
end;
//final
reset_ddragon;
iniciar_ddragon:=true;
end;

procedure cerrar_ddragon; 
begin
cerrar_cpus;
ym2151_close(0);
case main_vars.tipo_maquina of
  92:begin
      msm5205_close(0);
      msm5205_close(1);
    end;
  96:close_oki6295(0);
end;
close_audio;
close_video;
end;

procedure reset_ddragon;
begin
 reset_6309(main_6309,main_6309_ll);
 ym2151_reset(0);
 case main_vars.tipo_maquina of
    92:begin
         reset_6800(snd_6800,snd_6800_ll);
         reset_6809(snd_6809,snd_6809_ll);
         msm5205_Reset(0);
         msm5205_Reset(1);
    end;
    96:begin
        reset_z80(misc_z80);
        reset_z80(snd_z80);
        reset_oki6295(0);
       end;
 end;
 reset_audio;
 in0:=$FF;
 in1:=$FF;
 in2:=$e7;
 soundlatch:=0;
 vblank:=0;
 banco_rom:=0;
 dd_sub_cpu_busy:=1;
 scroll_x.w:=0;
 scroll_y.w:=0;
 adpcm_idle[0]:=0;
 adpcm_idle[1]:=0;
 adpcm_ch[0]:=1;
 adpcm_ch[1]:=1;
end;

procedure draw_sprites;inline;
var
  f,x,y,color,nchar,size:word;
  atrib:byte;
  flipx,flipy:boolean;
begin
	for f:=0 to $3f do begin
		atrib:=buffer_sprites[$801+(f*5)];
		if (atrib and $80)<>0 then begin  // visible */
			x:=240-buffer_sprites[$804+(f*5)]+((atrib and 2) shl 7);
			y:=240-buffer_sprites[$800+(f*5)]+ ((atrib and 1) shl 8);
			size:=(atrib and $30) shr 4;
			flipx:=(atrib and 8)<>0;
			flipy:=(atrib and 4)<>0;
      if tipo_video=1 then begin
          color:=(buffer_sprites[$802+(f*5)] shr 5) shl 4;
			    nchar:=buffer_sprites[$803+(f*5)]+((buffer_sprites[$802+(f*5)] and $1f) shl 8);
      end else begin
          color:=((buffer_sprites[$802+(f*5)] shr 4) and $07) shl 4;
			    nchar:=buffer_sprites[$803+(f*5)]+((buffer_sprites[$802+(f*5)] and $0f) shl 8);
      end;
			nchar:=nchar and not(size);
			case size of
				0:begin // normal */
             put_gfx_sprite(nchar,128+color,flipx,flipy,2);
             actualiza_gfx_sprite(x,y,4,2);
				  end;
				1:begin // double y */
             put_gfx_sprite_diff(nchar,128+color,flipx,flipy,2,0,0);
             put_gfx_sprite_diff(nchar+1,128+color,flipx,flipy,2,0,16);
             actualiza_gfx_sprite_size(x,y-16,4,16,32);
				  end;
				2:begin // double x */
             put_gfx_sprite_diff(nchar,128+color,flipx,flipy,2,0,0);
             put_gfx_sprite_diff(nchar+1,128+color,flipx,flipy,2,16,0);
             actualiza_gfx_sprite_size(x-16,y,4,32,16);
				  end;
				3:begin
             put_gfx_sprite_diff(nchar,128+color,flipx,flipy,2,0,0);
             put_gfx_sprite_diff(nchar+1,128+color,flipx,flipy,2,16,0);
             put_gfx_sprite_diff(nchar+2,128+color,flipx,flipy,2,0,16);
             put_gfx_sprite_diff(nchar+3,128+color,flipx,flipy,2,16,16);
             actualiza_gfx_sprite_size(x-16,y-16,4,32,32);
				  end;
			end;
		end;  //visible
	end;  //for
end;

procedure update_video_ddragon;inline;
var
  x,y,color,f,nchar,pos:word;
  atrib:byte;
begin
for f:=$0 to $3ff do begin
  x:=f mod 32;
  y:=f div 32;
  //background
  pos:=(x and $0f)+((y and $0f) shl 4)+((x and $10) shl 4)+((y and $10) shl 5);
  atrib:=memoria[(pos*2)+$3000];
  color:=(atrib and $38) shr 3;
  if ((gfx[1].buffer[pos]) or (gfx[1].color_buffer[color])) then begin
      nchar:=memoria[(pos*2)+$3001]+((atrib and $7) shl 8);
      put_gfx_flip(x*16,y*16,nchar,$100+(color shl 4),2,1,(atrib and $40)<>0,(atrib and $80)<>0);
      gfx[1].buffer[pos]:=false;
  end;
  //foreground
  atrib:=memoria[$1800+(f*2)];
  color:=(atrib and $e0) shr 5;
  if ((gfx[0].buffer[f]) or (gfx[0].color_buffer[color])) then begin
      nchar:=memoria[$1801+(f*2)]+((atrib and mask) shl 8);
      put_gfx_trans(x*8,y*8,nchar,color shl 4,1,0);
      gfx[0].buffer[f]:=false;
   end;
end;
fillchar(gfx[0].color_buffer[0],$8,0);
fillchar(gfx[1].color_buffer[0],$8,0);
scroll_x_y(2,4,scroll_x.w,scroll_y.w);
draw_sprites;
actualiza_trozo(0,0,256,256,1,0,0,256,256,4);
actualiza_trozo_final(0,8,256,240,4);
end;

procedure eventos_ddragon;
begin
if event.arcade then begin
  //p1
  if arcade_input.right[0] then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if arcade_input.left[0] then in0:=(in0 and $fd) else in0:=(in0 or $2);
  if arcade_input.up[0] then in0:=(in0 and $fb) else in0:=(in0 or $4);
  if arcade_input.down[0] then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if arcade_input.but0[0] then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if arcade_input.but1[0] then in0:=(in0 and $df) else in0:=(in0 or $20);
  if arcade_input.start[0] then in0:=(in0 and $bf) else in0:=(in0 or $40);
  if arcade_input.start[1] then in0:=(in0 and $7f) else in0:=(in0 or $80);
  if arcade_input.but2[0] then in2:=(in2 and $fd) else in2:=(in2 or $2);
  //p2
  if arcade_input.right[1] then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if arcade_input.left[1] then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if arcade_input.up[1] then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if arcade_input.down[1] then in1:=(in1 and $f7) else in1:=(in1 or $8);
  if arcade_input.but0[1] then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if arcade_input.but1[1] then in1:=(in1 and $df) else in1:=(in1 or $20);
  if arcade_input.coin[0] then in1:=(in1 and $bf) else in1:=(in1 or $40);
  if arcade_input.coin[1] then in1:=(in1 and $7f) else in1:=(in1 or $80);
  if arcade_input.but2[1] then in2:=(in2 and $fb) else in2:=(in2 or $4);
end;
end;

procedure ddragon_principal;
var
  f:word;
  frame_m,frame_s,frame_snd:single;
begin
init_controls(false,false,false,true);
frame_m:=main_6309.tframes;
frame_s:=snd_6800.tframes;
frame_snd:=snd_6809.tframes;
while EmuStatus=EsRuning do begin
  for f:=0 to 271 do begin
    //main
    run_6309(main_6309,main_6309_ll,trunc(frame_m));
    frame_m:=frame_m+main_6309.tframes-main_6309.contador;
    //sub
    run_6800(snd_6800,snd_6800_ll,trunc(frame_s));
    frame_s:=frame_s+snd_6800.tframes-snd_6800.contador;
    //snd
    run_6809(snd_6809,snd_6809_ll,trunc(frame_snd));
    frame_snd:=frame_snd+snd_6809.tframes-snd_6809.contador;
    case f of
      239:begin
            update_video_ddragon;
            vblank:=8;
          end;
      248:main_6309.pedir_nmi:=ASSERT_LINE;
      271:vblank:=0;
    end;
    if (((f and 8)<>0) and (f<>0)) then main_6309.pedir_firq:=ASSERT_LINE;
  end;
  eventos_ddragon;
  video_sync;
end;
end;

procedure cambiar_color(pos:word);inline;
var
  tmp_color:byte;
  color:tcolor;
begin
  tmp_color:=buffer_paleta[pos];
  color.r:=pal4bit(tmp_color);
  color.g:=pal4bit(tmp_color shr 4);
  tmp_color:=buffer_paleta[pos+$200];
  color.b:=pal4bit(tmp_color);
  set_pal_color(color,addr(paleta[pos]));
  case pos of
    0..127:gfx[0].color_buffer[pos shr 4]:=true;
    256..383:gfx[1].color_buffer[(pos shr 4) and $7]:=true;
  end;
end;

function ddragon_getbyte(direccion:word):byte;
begin
    case direccion of
        $0..$fff,$1400..$1fff,$3000..$37ff:ddragon_getbyte:=memoria[direccion];
        $1000..$13ff:ddragon_getbyte:=buffer_paleta[direccion and $3ff];
        $2000..$2048,$204a..$2fff:ddragon_getbyte:=buffer_sprites[direccion and $fff];
        //Proteccion ?
        $2049:if ((main_6309.pc=$6261) and (buffer_sprites[$49]=$1f)) then ddragon_getbyte:=$1
                else ddragon_getbyte:=buffer_sprites[$49];
        $3800:ddragon_getbyte:=in0;
        $3801:ddragon_getbyte:=in1;
        $3802:ddragon_getbyte:=in2+(dd_sub_cpu_busy*$10)+vblank;
        $3803:ddragon_getbyte:=$ff;
        $3804:ddragon_getbyte:=$ff;
        $380b:;
        $4000..$7fff:ddragon_getbyte:=rom[banco_rom,direccion and $3FFF];
        $8000..$ffff:ddragon_getbyte:=memoria[direccion];
    end;
end;

procedure ddragon_putbyte(direccion:word;valor:byte);
begin
if direccion>$3fff then exit;
memoria[direccion]:=valor;
case direccion of
        $1000..$13ff:if buffer_paleta[direccion and $3ff]<>valor then begin
                          buffer_paleta[direccion and $3ff]:=valor;
                          cambiar_color(direccion and $1ff);
                     end;
        $1800..$1fff:gfx[0].buffer[(direccion and $7ff) shr 1]:=true;
        $2000..$2fff:buffer_sprites[direccion and $fff]:=valor;
        $3000..$37ff:gfx[1].buffer[(direccion and $7ff) shr 1]:=true;
        $3808:begin
                scroll_x.h:=valor and $1;
                scroll_y.h:=(valor shr 1) and $1;
                if (valor and $10)<>0 then dd_sub_cpu_busy:=0
	                else if (dd_sub_cpu_busy=0) then snd_6800.pedir_nmi:=ASSERT_LINE;
                banco_rom:=(valor and $e0) shr 5;
              end;
        $3809:scroll_x.l:=valor;
        $380a:scroll_y.l:=valor;
        $380b:clear_nmi_6309(main_6309);
        $380c:main_6309.pedir_firq:=CLEAR_LINE;
        $380d:main_6309.pedir_irq:=CLEAR_LINE;
        $380e:begin
                soundlatch:=valor;
                snd_6809.pedir_irq:=HOLD_LINE;
              end;
end;
end;

function ddragon_sub_getbyte(direccion:word): Byte;
begin
  case direccion of
      $0..$1e:ddragon_sub_getbyte:=0;
      $8000..$8fff:ddragon_sub_getbyte:=buffer_sprites[direccion and $fff];
      else ddragon_sub_getbyte:=mem_misc[direccion];
  end;
end;

procedure ddragon_sub_putbyte(direccion:word;valor:byte);
begin
if direccion>$bfff then exit;
mem_misc[direccion]:=valor;
case direccion of
  $0..$1f:if (direccion=$17) then begin
        		  // This is a guess, but makes sense.. The mcu definitely interrupts the main cpu.
              // I don't know what bit is the assert and what is the clear though (in comparison
              // it's quite obvious from the Double Dragon 2 code, below). */
		          if (valor and 3)<>0 then begin
                main_6309.pedir_irq:=ASSERT_LINE;
                clear_nmi_6800(snd_6800);
		          end;
        	end;
  $8000..$8fff:begin
                  if direccion=$8000 then dd_sub_cpu_busy:=1;
                  buffer_sprites[direccion and $fff]:=valor;
               end;
end;
end;

function ddragon_snd_getbyte(direccion:word): Byte;
begin
case direccion of
  $1000:ddragon_snd_getbyte:=soundlatch;
  $1800:ddragon_snd_getbyte:=adpcm_idle[0]+(adpcm_idle[1] shl 1);
  $2801:ddragon_snd_getbyte:=YM2151_status_port_read(0);
    else ddragon_snd_getbyte:=mem_snd[direccion];
end;
end;

procedure ddragon_snd_putbyte(direccion:word;valor:byte);
var
  adpcm_chip:byte;
begin
if direccion>$3fff then exit;
mem_snd[direccion]:=valor;
case direccion of
  $2800:YM2151_register_port_write(0,valor);
  $2801:YM2151_data_port_write(0,valor);
  $3800..$3807:begin
                  adpcm_chip:=direccion and $1;
                  case ((direccion and $7) shr 1) of
                    3:begin
			                  adpcm_idle[adpcm_chip]:=1;
			                  msm5205_reset_w(adpcm_chip, 1);
                    end;
		                2:adpcm_pos[adpcm_chip]:=(valor and $7f)*$200;
		                1:adpcm_end[adpcm_chip]:=(valor and $7f)*$200;
		                0:begin
			                  adpcm_idle[adpcm_chip]:= 0;
			                  msm5205_reset_w(adpcm_chip, 0);
                    end;
                  end;
               end;
end;
end;

procedure ym2151_snd_irq(numchip:integer;irqstate:integer);
begin
  if (irqstate=1) then snd_6809.pedir_firq:=ASSERT_LINE
    else snd_6809.pedir_firq:=CLEAR_LINE;
end;

procedure snd_adpcm0;
begin
if ((adpcm_pos[0]>=adpcm_end[0]) or (adpcm_pos[0]>=$10000)) then begin
		adpcm_idle[0]:=1;
		msm5205_reset_w(0,1);
	end else if adpcm_ch[0]<>1 then begin
		          msm5205_data_w(0,adpcm_data[0] and $0f);
		          adpcm_ch[0]:=1;
	          end else begin
              adpcm_ch[0]:=0;
              adpcm_data[0]:=adpcm_mem[adpcm_pos[0]];
              adpcm_pos[0]:=(adpcm_pos[0]+1) and $ffff;
          		msm5205_data_w(0,adpcm_data[0] shr 4);
            end;
end;

procedure snd_adpcm1;
begin
if ((adpcm_pos[1]>=adpcm_end[1]) or (adpcm_pos[1]>=$10000)) then begin
		adpcm_idle[1]:=1;
		msm5205_reset_w(1,1);
	end else if adpcm_ch[1]<>1 then begin
		          msm5205_data_w(1,adpcm_data[1] and $0f);
		          adpcm_ch[1]:=1;
	          end else begin
              adpcm_ch[1]:=0;
              adpcm_data[1]:=adpcm_mem[adpcm_pos[1]+$10000];
              adpcm_pos[1]:=(adpcm_pos[1]+1) and $ffff;
          		msm5205_data_w(1,adpcm_data[1] shr 4);
            end;
end;

procedure sound_instruccion;
begin
  ym2151_Update(0);
end;

//Double Dragon II
procedure ddragon2_principal;
var
  f:word;
  frame_m,frame_s,frame_snd:single;
begin
init_controls(false,false,false,true);
frame_m:=main_6309.tframes;
frame_s:=misc_z80.tframes;
frame_snd:=snd_z80.tframes;
while EmuStatus=EsRuning do begin
  for f:=0 to 271 do begin
    //main
    run_6309(main_6309,main_6309_ll,trunc(frame_m));
    frame_m:=frame_m+main_6309.tframes-main_6309.contador;
    //sub
    run_z80(misc_z80,misc_z80_ll,trunc(frame_s));
    frame_s:=frame_s+misc_z80.tframes-misc_z80.contador;
    //snd
    run_z80(snd_z80,snd_z80_ll,trunc(frame_snd));
    frame_snd:=frame_snd+snd_z80.tframes-snd_z80.contador;
    case f of
      239:begin
            update_video_ddragon;
            vblank:=8;
          end;
      248:main_6309.pedir_nmi:=ASSERT_LINE;
      271:vblank:=0;
    end;
    if (f and 8)<>0 then main_6309.pedir_firq:=ASSERT_LINE;
  end;
  eventos_ddragon;
  video_sync;
end;
end;

function ddragon2_getbyte(direccion:word): Byte;
begin
    case direccion of
        $0..$1fff,$3000..$37ff:ddragon2_getbyte:=memoria[direccion];
        $2000..$2fff:ddragon2_getbyte:=buffer_sprites[direccion and $fff];
        $3800:ddragon2_getbyte:=in0;
        $3801:ddragon2_getbyte:=in1;
        $3802:ddragon2_getbyte:=in2+(dd_sub_cpu_busy*$10)+vblank;
        $3803:ddragon2_getbyte:=$ff;
        $3804:ddragon2_getbyte:=$ff;
        $3c00..$3fff:ddragon2_getbyte:=buffer_paleta[direccion and $3ff];
        $4000..$7fff:ddragon2_getbyte:=rom[banco_rom,direccion and $3FFF];
        $8000..$ffff:ddragon2_getbyte:=memoria[direccion];
    end;
end;

procedure ddragon2_putbyte(direccion:word;valor:byte);
begin
if direccion>$3fff then exit;
memoria[direccion]:=valor;
case direccion of
        $1800..$1fff:gfx[0].buffer[(direccion and $7ff) shr 1]:=true;
        $2000..$2fff:buffer_sprites[direccion and $fff]:=valor;
        $3000..$37ff:gfx[1].buffer[(direccion and $7ff) shr 1]:=true;
        $3808:begin
                scroll_x.h:=valor and $1;
                scroll_y.h:=(valor shr 1) and $1;
                if (valor and $10)<>0 then dd_sub_cpu_busy:=0
	                else if (dd_sub_cpu_busy=0) then misc_z80.pedir_nmi:=PULSE_LINE;
                banco_rom:=(valor and $e0) shr 5;
              end;
        $3809:scroll_x.l:=valor;
        $380a:scroll_y.l:=valor;
        $380b:clear_nmi_6309(main_6309);
        $380c:main_6309.pedir_firq:=CLEAR_LINE;
        $380d:main_6309.pedir_irq:=CLEAR_LINE;
        $380e:begin
                soundlatch:=valor;
                snd_z80.pedir_nmi:=PULSE_LINE;
              end;
        $3c00..$3fff:if buffer_paleta[direccion and $3ff]<>valor then begin
                          buffer_paleta[direccion and $3ff]:=valor;
                          cambiar_color(direccion and $1ff);
                     end;
end;
end;

function ddragon2_sub_getbyte(direccion:word):byte;
begin
case direccion of
    $c000..$c3ff:ddragon2_sub_getbyte:=buffer_sprites[direccion and $3ff];
    else ddragon2_sub_getbyte:=mem_misc[direccion];
  end;
end;

procedure ddragon2_sub_putbyte(direccion:word;valor:byte);
begin
if direccion<$c000 then exit;
mem_misc[direccion]:=valor;
case direccion of
  $c000..$c3ff:begin
                  if direccion=$c000 then dd_sub_cpu_busy:=1;
                  buffer_sprites[direccion and $3ff]:=valor;
               end;
  $d000:clear_nmi_z80(misc_z80);
	$e000:main_6309.pedir_irq:=ASSERT_LINE;
end;
end;

function ddragon2_snd_getbyte(direccion:word): Byte;
begin
case direccion of
    $8801:ddragon2_snd_getbyte:=YM2151_status_port_read(0);
    $9800:ddragon2_snd_getbyte:=okim6295_r(0);
    $a000:ddragon2_snd_getbyte:=soundlatch;
    else ddragon2_snd_getbyte:=mem_snd[direccion];
  end;
end;

procedure ddragon2_snd_putbyte(direccion:word;valor:byte);
begin
if direccion<$8000 then exit;
mem_snd[direccion]:=valor;
case direccion of
  $8800:YM2151_register_port_write(0,valor);
  $8801:YM2151_data_port_write(0,valor);
  $9800:okim6295_w(0,valor);
end;
end;

procedure ym2151_snd_irq_dd2(numchip:integer;irqstate:integer);
begin
  if (irqstate=1) then snd_z80.pedir_irq:=ASSERT_LINE
    else snd_z80.pedir_irq:=CLEAR_LINE;
end;

end.
