unit galaxian_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     z80,main_engine,ay_8910,controls_engine,gfx_engine,timer_engine,samples,
     rom_engine,cpu_engine,file_engine,pal_engine,sound_engine,ppi8255,
     konami_snd,misc_functions;

//funciones generales
procedure Cargar_hgalaxian;
procedure hgalaxian_principal;
function iniciar_hgalaxian:boolean;
procedure reset_hgalaxian;
procedure cerrar_hgalaxian;
function port_0_a_read:byte;
function port_0_b_read:byte;
function port_0_c_read:byte;
//Galaxian
function galaxian_getbyte(direccion:word):byte;
procedure galaxian_putbyte(direccion:word;valor:byte);
procedure galaxian_despues_instruccion;
//Jump Bug
function jumpbug_getbyte(direccion:word):byte;
procedure jumpbug_putbyte(direccion:word;valor:byte);
procedure jumpbug_despues_instruccion;
procedure jumpbug_blinking;
//Moon Cresta
function mooncrst_getbyte(direccion:word):byte;
procedure mooncrst_putbyte(direccion:word;valor:byte);
//Scramble
procedure scramble_principal;
function scramble_getbyte(direccion:word):byte;
procedure scramble_putbyte(direccion:word;valor:byte);
function scramblesound_getbyte(direccion:word): Byte;
procedure scramblesound_putbyte(direccion:word;valor:byte);
function scramblesound_inbyte(puerto:word):byte;
procedure scramblesound_outbyte(valor:byte;puerto:word);
procedure scramble_despues_instruccion;
function scramble_port_1_c_read:byte;
procedure scramble_port_1_a_write(valor:byte);
procedure scramble_port_1_b_write(valor:byte);
procedure scramble_port_1_c_write(valor:byte);
function scramble_ay_porta:byte;
function scramble_ay_portb:byte;
//Super Cobra
function scobra_getbyte(direccion:word):byte;
procedure scobra_putbyte(direccion:word;valor:byte);
//Frogger
function frogger_getbyte(direccion:word):byte;
procedure frogger_putbyte(direccion:word;valor:byte);
function frogger_sound_getbyte(direccion:word): Byte;
procedure frogger_sound_putbyte(direccion:word;valor:byte);
function frogger_sound_inbyte(puerto:word):byte;
procedure frogger_sound_outbyte(valor:byte;puerto:word);
procedure frogger_port_1_a_write(valor:byte);
procedure frogger_port_1_b_write(valor:byte);
//Amidar
function amidar_getbyte(direccion:word):byte;
procedure amidar_putbyte(direccion:word;valor:byte);
function port_1_c_read:byte;

type
  tstars=record
          x,y,color:word;
  end;
const
        //Galaxian
        galaxian_rom:array[0..5] of tipo_roms=(
        (n:'galmidw.u';l:$800;p:0;crc:$745e2d61),(n:'galmidw.v';l:$800;p:$800;crc:$9c999a40),
        (n:'galmidw.w';l:$800;p:$1000;crc:$b5894925),(n:'galmidw.y';l:$800;p:$1800;crc:$6b3ca10b),
        (n:'7l';l:$800;p:$2000;crc:$1b933207),());
        galaxian_char:array[0..2] of tipo_roms=(
        (n:'1h.bin';l:$800;p:0;crc:$39fb43a4),(n:'1k.bin';l:$800;p:$800;crc:$7e3f56a2),());
        galaxian_pal:tipo_roms=(n:'6l.bpr';l:$20;p:0;crc:$c3ac9467);
        galaxian_samples:array[0..4] of tipo_nombre_samples=(
        (nombre:'fire.wav'),(nombre:'death.wav'),(nombre:'back1.wav'),(nombre:'back2.wav'),(nombre:'back3.wav'));
        //Jump Bug
        jumpbug_rom:array[0..7] of tipo_roms=(
        (n:'jb1';l:$1000;p:0;crc:$415aa1b7),(n:'jb2';l:$1000;p:$1000;crc:$b1c27510),
        (n:'jb3';l:$1000;p:$2000;crc:$97c24be2),(n:'jb4';l:$1000;p:$3000;crc:$66751d12),
        (n:'jb5';l:$1000;p:$8000;crc:$e2d66faf),(n:'jb6';l:$1000;p:$9000;crc:$49e0bdfd),
        (n:'jb7';l:$800;p:$a000;crc:$83d71302),());
        jumpbug_char:array[0..6] of tipo_roms=(
        (n:'jbl';l:$800;p:0;crc:$9a091b0a),(n:'jbm';l:$800;p:$800;crc:$8a0fc082),
        (n:'jbn';l:$800;p:$1000;crc:$155186e0),(n:'jbi';l:$800;p:$1800;crc:$7749b111),
        (n:'jbj';l:$800;p:$2000;crc:$06e8d7df),(n:'jbk';l:$800;p:$2800;crc:$b8dbddf3),());
        jumpbug_pal:tipo_roms=(n:'l06_prom.bin';l:$20;p:0;crc:$6a0c7d87);
        //Moon Cresta
        mooncrst_rom:array[0..8] of tipo_roms=(
        (n:'mc1';l:$800;p:0;crc:$7d954a7a),(n:'mc2';l:$800;p:$800;crc:$44bb7cfa),
        (n:'mc3';l:$800;p:$1000;crc:$9c412104),(n:'mc4';l:$800;p:$1800;crc:$7e9b1ab5),
        (n:'mc5.7r';l:$800;p:$2000;crc:$16c759af),(n:'mc6.8d';l:$800;p:$2800;crc:$69bcafdb),
        (n:'mc7.8e';l:$800;p:$3000;crc:$b50dbc46),(n:'mc8';l:$800;p:$3800;crc:$18ca312b),());
        mooncrst_char:array[0..4] of tipo_roms=(
        (n:'mcs_b';l:$800;p:0;crc:$fb0f1f81),(n:'mcs_d';l:$800;p:$800;crc:$13932a15),
        (n:'mcs_a';l:$800;p:$1000;crc:$631ebb5a),(n:'mcs_c';l:$800;p:$1800;crc:$24cfd145),());
        mooncrst_pal:tipo_roms=(n:'l06_prom.bin';l:$20;p:0;crc:$6a0c7d87);
        mooncrst_samples:array[0..4] of tipo_nombre_samples=(
        (nombre:'fire.wav'),(nombre:'death.wav'),(nombre:'back1.wav'),(nombre:'back2.wav'),(nombre:'back3.wav'));
        //Scramble
        scramble_rom:array[0..8] of tipo_roms=(
        (n:'s1.2d';l:$800;p:0;crc:$ea35ccaa),(n:'s2.2e';l:$800;p:$800;crc:$e7bba1b3),
        (n:'s3.2f';l:$800;p:$1000;crc:$12d7fc3e),(n:'s4.2h';l:$800;p:$1800;crc:$b59360eb),
        (n:'s5.2j';l:$800;p:$2000;crc:$4919a91c),(n:'s6.2l';l:$800;p:$2800;crc:$26a4547b),
        (n:'s7.2m';l:$800;p:$3000;crc:$0bb49470),(n:'s8.2p';l:$800;p:$3800;crc:$6a5740e5),());
        scramble_char:array[0..2] of tipo_roms=(
        (n:'c2.5f';l:$800;p:0;crc:$4708845b),(n:'c1.5h';l:$800;p:$800;crc:$11fd2887),());
        scramble_sound:array[0..3] of tipo_roms=(
        (n:'ot1.5c';l:$800;p:0;crc:$bcd297f0),(n:'ot2.5d';l:$800;p:$800;crc:$de7912da),
        (n:'ot3.5e';l:$800;p:$1000;crc:$ba2fa933),());
        scramble_pal:tipo_roms=(n:'c01s.6e';l:$20;p:0;crc:$4e3caeab);
        //Super Cobra
        scobra_rom:array[0..6] of tipo_roms=(
        (n:'epr1265.2c';l:$1000;p:0;crc:$a0744b3f),(n:'2e';l:$1000;p:$1000;crc:$8e7245cd),
        (n:'epr1267.2f';l:$1000;p:$2000;crc:$47a4e6fb),(n:'2h';l:$1000;p:$3000;crc:$7244f21c),
        (n:'epr1269.2j';l:$1000;p:$4000;crc:$e1f8a801),(n:'2l';l:$1000;p:$5000;crc:$d52affde),());
        scobra_sound:array[0..3] of tipo_roms=(
        (n:'5c';l:$800;p:0;crc:$d4346959),(n:'5d';l:$800;p:$800;crc:$cc025d95),
        (n:'5e';l:$800;p:$1000;crc:$1628c53f),());
        scobra_char:array[0..2] of tipo_roms=(
        (n:'epr1274.5h';l:$800;p:0;crc:$64d113b4),(n:'epr1273.5f';l:$800;p:$800;crc:$a96316d3),());
        scobra_pal:tipo_roms=(n:'82s123.6e';l:$20;p:0;crc:$9b87f90d);
        //Frogger
        frogger_rom:array[0..3] of tipo_roms=(
        (n:'frogger.26';l:$1000;p:0;crc:$597696d6),(n:'frogger.27';l:$1000;p:$1000;crc:$b6e6fcc3),
        (n:'frsm3.7';l:$1000;p:$2000;crc:$aca22ae0),());
        frogger_char:array[0..2] of tipo_roms=(
        (n:'frogger.607';l:$800;p:0;crc:$05f7d883),(n:'frogger.606';l:$800;p:$800;crc:$f524ee30),());
        frogger_pal:tipo_roms=(n:'pr-91.6l';l:32;p:0;crc:$413703bf);
        frogger_sound:array[0..3] of tipo_roms=(
        (n:'frogger.608';l:$800;p:0;crc:$e8ab0256),(n:'frogger.609';l:$800;p:$800;crc:$7380a48f),
        (n:'frogger.610';l:$800;p:$1000;crc:$31d7eb27),());
        //Amidar
        amidar_rom:array[0..4] of tipo_roms=(
        (n:'amidar.2c';l:$1000;p:0;crc:$c294bf27),(n:'amidar.2e';l:$1000;p:$1000;crc:$e6e96826),
        (n:'amidar.2f';l:$1000;p:$2000;crc:$3656be6f),(n:'amidar.2h';l:$1000;p:$3000;crc:$1be170bd),());
        amidar_char:array[0..2] of tipo_roms=(
        (n:'amidar.5f';l:$800;p:0;crc:$5e51e84d),(n:'amidar.5h';l:$800;p:$800;crc:$2f7f1c30),());
        amidar_pal:tipo_roms=(n:'amidar.clr';l:32;p:0;crc:$f940dcc3);
        amidar_sound:array[0..2] of tipo_roms=(
        (n:'amidar.5c';l:$1000;p:0;crc:$c4b66ae4),(n:'amidar.5d';l:$1000;p:$1000;crc:$806785af),());
        //Stars
        star_count=252;
var
  //variables de funciones especificas
  eventos_hardware_galaxian:procedure;
  calc_nchar:function(direccion:word):word;
  calc_sprite:function(direccion:byte):word;
  draw_stars:procedure;
  galaxian_update_video:procedure;
  //Variables globales
  haz_nmi,stars_enable,hay_samples:boolean;
  stars_scrollpos:dword;
  stars_blinking,latch,port_b_latch:byte;
  stars:array[0..star_count-1] of tstars;
  videoram_mem:array[0..$3ff] of byte;
  sprite_mem,disparo_mem:array[0..$1f] of byte;
  atributos_mem:array[0..$3f] of byte;
  gfx_bank:array[0..4] of byte;
  //scramble
  scramble_background:boolean;
  scramble_prot_state:integer;
  scramble_prot:byte;
  //frogger
  timer_hs_frogger:byte;

implementation
uses principal;

//Galaxian
procedure eventos_galaxian;
begin
if event.arcade then begin
  if arcade_input.left[0] then in0:=(in0 or $4) else in0:=(in0 and $fb);
  if arcade_input.right[0] then in0:=(in0 or $8) else in0:=(in0 and $f7);
  if arcade_input.but0[0] then in0:=(in0 or $10) else in0:=(in0 and $ef);
  if arcade_input.start[0] then in1:=(in1 or $1) else in1:=(in1 and $fe);
  if arcade_input.coin[0] then in0:=(in0 or $1) else in0:=(in0 and $fe);
end;
end;

function galaxian_getbyte(direccion:word):byte;
begin
case direccion of
  $0..$3fff:galaxian_getbyte:=memoria[direccion];
  $4000..$47ff:galaxian_getbyte:=memoria[$4000+(direccion and $3ff)];
  $5000..$57ff:galaxian_getbyte:=videoram_mem[direccion and $3ff];
  $5800..$5fff:case (direccion and $ff) of
                  0..$3f:galaxian_getbyte:=atributos_mem[direccion and $3f];
                  $40..$5f:galaxian_getbyte:=sprite_mem[direccion and $1f];
                  $60..$7f:galaxian_getbyte:=disparo_mem[direccion and $1f];
                  else galaxian_getbyte:=memoria[$5800+(direccion and $ff)];
               end;
  $6000..$67ff:galaxian_getbyte:=in0;
  $6800..$6fff:galaxian_getbyte:=in1;
  $7000..$77ff:galaxian_getbyte:=in2;
  else galaxian_getbyte:=$ff;
end;
end;

procedure galaxian_putbyte(direccion:word;valor:byte);
var
  f,dir:byte;
begin
if direccion<$4000 then exit;
case direccion of
  $4000..$47ff:memoria[$4000+(direccion and $3ff)]:=valor;
  $5000..$57ff:if videoram_mem[direccion and $3ff]<>valor then begin
                  gfx[0].buffer[direccion and $3ff]:=true;
                  videoram_mem[direccion and $3ff]:=valor;
               end;
  $5800..$5fff:case (direccion and $ff) of
                  0..$3f:if atributos_mem[direccion and $3f]<>valor then begin
                            atributos_mem[direccion and $3f]:=valor;
                            dir:=((direccion and $3F) shr 1);
                            for f:=0 to $1F do gfx[0].buffer[dir+(f shl 5)]:=true;
                         end;
                  $40..$5f:sprite_mem[direccion and $1f]:=valor;
                  $60..$7f:disparo_mem[direccion and $1f]:=valor;
                    else memoria[$5800+(direccion and $ff)]:=valor;
               end;
  $6800..$6fff:case (direccion and $7) of
                  $0:if ((valor<>0) and hay_samples) then start_sample(2);
                  $1:if ((valor<>0) and hay_samples) then start_sample(3);
                  $2:if ((valor<>0) and hay_samples) then start_sample(4);
                  $3:if ((valor<>0) and hay_samples) then start_sample(1);
                  $5:if ((valor<>0) and hay_samples) then start_sample(0);
                end;
  $7000..$77ff:case (direccion and $7) of
                  $1:haz_nmi:=((valor and 1)<>0);
                  $4:begin
                       stars_enable:=(valor and $1)<>0;
                       if not(stars_enable) then stars_scrollpos:=0;
                    end;
               end;
end;
end;

function galaxian_calc_nchar(direccion:word):word;
begin
  galaxian_calc_nchar:=videoram_mem[direccion];
end;

function galaxian_calc_sprite(direccion:byte):word;
begin
  galaxian_calc_sprite:=sprite_mem[$1+(direccion*4)] and $3f;
end;

procedure stars_galaxian;inline;
var
  f:byte;
  x,y,color:word;
begin
for f:=0 to star_count-1 do begin
		x:=(stars[f].x+stars_scrollpos) and $1ff;
		y:=(stars[f].y+((stars_scrollpos+stars[f].x) shr 9)) and $ff;
		if ((y and $01) xor ((x shr 3) and $01))<>0 then begin
      color:=paleta[stars[f].color];
      putpixel(y,x,1,@color,1);
		end;
 end;
end;

procedure galaxian_despues_instruccion;
begin
if hay_samples then samples_update;
end;

//Jump Bug
procedure eventos_jumpbug;
begin
if event.arcade then begin
  if arcade_input.left[0] then in0:=(in0 or $4) else in0:=(in0 and $fb);
  if arcade_input.right[0] then in0:=(in0 or $8) else in0:=(in0 and $f7);
  if arcade_input.down[0] then in0:=(in0 or $40) else in0:=(in0 and $bf);
  if arcade_input.up[0] then in0:=(in0 or $80) else in0:=(in0 and $7f);
  if arcade_input.but0[0] then in0:=(in0 or $10) else in0:=(in0 and $ef);
  if arcade_input.start[0] then in1:=(in1 or $1) else in1:=(in1 and $fe);
  if arcade_input.coin[0] then in0:=(in0 or $1) else in0:=(in0 and $fe);
end;
end;

function jumpbug_getbyte(direccion:word):byte;
begin
case direccion of
  $0..$47ff,$8000..$afff:jumpbug_getbyte:=memoria[direccion];
  $4800..$4fff:jumpbug_getbyte:=videoram_mem[direccion and $3ff];
  $5000..$57ff:case (direccion and $ff) of
                  $0..$3f:jumpbug_getbyte:=atributos_mem[direccion and $3f];
                  $40..$5f:jumpbug_getbyte:=sprite_mem[direccion and $1f];
                  $60..$7f:jumpbug_getbyte:=disparo_mem[direccion and $1f];
                    else jumpbug_getbyte:=memoria[$5000+(direccion and $ff)];
               end;
  $6000..$67ff:jumpbug_getbyte:=in0;
  $6800..$6fff:jumpbug_getbyte:=in1;
  $7000..$77ff:jumpbug_getbyte:=in2;
  $b000..$bfff:case (direccion and $fff) of  //proteccion
                  $114:jumpbug_getbyte:=$4f;
	                $118:jumpbug_getbyte:=$d3;
	                $214:jumpbug_getbyte:=$cf;
	                $235:jumpbug_getbyte:=$02;
                  $311:jumpbug_getbyte:=$ff;
	                else jumpbug_getbyte:=$00;
               end;
    else jumpbug_getbyte:=$ff;
end;
end;

procedure jumpbug_putbyte(direccion:word;valor:byte);
var
  f,dir:byte;
begin
case direccion of
  0..$3fff,$8000..$afff:exit;  //rom
  $4000..$47ff:memoria[direccion]:=valor;
  $4800..$4fff:if videoram_mem[direccion and $3ff]<>valor then begin
                  gfx[0].buffer[direccion and $3ff]:=true;
                  videoram_mem[direccion and $3ff]:=valor;
               end;
  $5000..$57ff:case (direccion and $ff) of
                 $0..$3f:if atributos_mem[direccion and $3f]<>valor then begin
                          atributos_mem[direccion and $3f]:=valor;
                          dir:=((direccion and $3F) shr 1);
                          for f:=0 to $1F do gfx[0].buffer[dir+(f shl 5)]:=true;
                        end;
                 $40..$5f:sprite_mem[direccion and $1f]:=valor;
                 $60..$7f:disparo_mem[direccion and $1f]:=valor;
                  else memoria[$5000+(direccion and $ff)]:=valor;
               end;
  $5800..$58ff:AY8910_Write(valor,0);
  $5900..$59ff:AY8910_Control(valor,0);
  $6000..$67ff:case direccion and $7 of
                $2..$6:if gfx_bank[(direccion and $7)-2]<>valor then begin
                        gfx_bank[(direccion and $7)-2]:=valor;
                        fillchar(gfx[0].buffer[0],$400,1);
                       end;
               end;
  $7000..$77ff:case direccion and $7 of
                $1:haz_nmi:=(valor and 1)<>0;
                $4:begin
                     stars_enable:=(valor and $1)<>0;
                     if not(stars_enable) then stars_scrollpos:=0;
                  end;
                end;
end;
end;

function jumpbug_calc_nchar(direccion:word):word;inline;
var
  charcode:word;
begin
  charcode:=videoram_mem[direccion];
  if (((charcode and $c0)=$80) and ((gfx_bank[2] and 1)<>0)) then begin
		charcode:=charcode+(128 + ((gfx_bank[0] and 1) shl 6) +
				           ((gfx_bank[1] and 1) shl 7) +
						   ((not(gfx_bank[4]) and 1) shl 8));
	end;
  jumpbug_calc_nchar:=charcode;
end;

function jumpbug_calc_sprite(direccion:byte):word;inline;
var
  spritecode:word;
begin
  spritecode:=sprite_mem[$1+(direccion*4)] and $3f;
  if (((spritecode and $30)=$20) and ((gfx_bank[2] and 1)<>0)) then begin
		spritecode:=spritecode+(32 + ((gfx_bank[0] and 1) shl 4) +
		                    ((gfx_bank[1] and 1) shl 5) +
		                    ((not(gfx_bank[4]) and 1) shl 6));
	end;
  jumpbug_calc_sprite:=spritecode;
end;

procedure jumpbug_blinking;inline;
begin
  stars_blinking:=stars_blinking+1;
end;

procedure jumpbug_despues_instruccion;
begin
  ay8910_update(0);
end;

procedure stars_jumpbug;inline;
var
  f:byte;
  x,y,color:word;
begin
for f:=0 to STAR_COUNT-1 do begin
		x:=stars[f].x;
		y:=stars[f].y;
		// determine when to skip plotting */
		if ((y and $01) xor ((x shr 3) and $01))<>0 then begin
			case (stars_blinking and $03) of
  			0:if (stars[f].color and $01)=0 then continue;
  			1:if (stars[f].color and $04)=0 then continue;
  			2:if (stars[f].y and $02)=0 then continue;
			end;
			// no stars in the status area */
			if ((x>=240) and (main_vars.tipo_maquina=48)) then continue;
      color:=paleta[stars[f].color];
      putpixel(y,x,1,@color,1);
		end;
end;
end;

//Moon Cresta
function mooncrst_getbyte(direccion:word): Byte;
begin
case direccion of
  $0..$3fff:mooncrst_getbyte:=memoria[direccion];
  $8000..$87ff:mooncrst_getbyte:=memoria[$8000+(direccion and $3ff)];
  $9000..$97ff:mooncrst_getbyte:=videoram_mem[(direccion and $3ff)];
  $9800..$9fff:case (direccion and $ff) of
                  $0..$3f:mooncrst_getbyte:=atributos_mem[direccion and $3f];
                  $40..$5f:mooncrst_getbyte:=sprite_mem[direccion and $1f];
                  $60..$7f:mooncrst_getbyte:=disparo_mem[direccion and $1f];
                   else mooncrst_getbyte:=memoria[$9800+(direccion and $ff)];
               end;
  $a000..$a7ff:mooncrst_getbyte:=in0;
  $a800..$afff:mooncrst_getbyte:=in1;
  $b000..$b7ff:mooncrst_getbyte:=in2;
    else mooncrst_getbyte:=$ff;
end;
end;

procedure mooncrst_putbyte(direccion:word;valor:byte);
var
  f,dir:byte;
begin
if direccion<$4000 then exit;
case direccion of
  $8000..$87ff:memoria[$8000+(direccion and $3ff)]:=valor;
  $9000..$97ff:if videoram_mem[direccion and $3ff]<>valor then begin
                  gfx[0].buffer[direccion and $3ff]:=true;
                  videoram_mem[direccion and $3ff]:=valor;
               end;
  $9800..$9fff:case (direccion and $ff) of
                  $0..$3f:if atributos_mem[direccion and $3f]<>valor then begin
                              atributos_mem[direccion and $3f]:=valor;
                              dir:=((direccion and $3F) shr 1);
                              for f:=0 to $1F do gfx[0].buffer[dir+(f shl 5)]:=true;
                           end;
                  $40..$5f:sprite_mem[direccion and $1f]:=valor;
                  $60..$7f:disparo_mem[direccion and $1f]:=valor;
                   else memoria[$9800+(direccion and $ff)]:=valor;
               end;
  $a000..$a7ff:case (direccion and $7) of
                  $0..$2:if gfx_bank[direccion-$a000]<>valor then begin
                            gfx_bank[direccion-$a000]:=valor;
                            fillchar(gfx[0].buffer[0],$400,1);
                         end;
               end;
  $a800..$afff:case (direccion and $7) of
                  $0:if ((valor<>0) and hay_samples) then start_sample(2);
                  $1:if ((valor<>0) and hay_samples) then start_sample(3);
                  $2:if ((valor<>0) and hay_samples) then start_sample(4);
                  $3:if ((valor<>0) and hay_samples) then start_sample(1);
                  $5:if ((valor<>0) and hay_samples) then start_sample(0);
                end;
  $b000..$b7ff:case (direccion and $7) of
                  $0:haz_nmi:=(valor and 1)<>0;
                  $4:begin
                       stars_enable:=(valor and $1)<>0;
                       if not(stars_enable) then stars_scrollpos:=0;
                     end;
               end;
end;
end;

function mooncrst_calc_nchar(direccion:word):word;inline;
var
  charcode:word;
begin
  charcode:=videoram_mem[direccion];
  if ((gfx_bank[2]<>0) and ((charcode and $c0)=$80)) then
		charcode:=(charcode and $3f) or (gfx_bank[0] shl 6) or (gfx_bank[1] shl 7) or $0100;
  mooncrst_calc_nchar:=charcode;
end;

function mooncrst_calc_sprite(direccion:byte):word;inline;
var
  spritecode:word;
begin
  spritecode:=sprite_mem[$1+(direccion*4)] and $3f;
  if ((gfx_bank[2]<>0) and ((spritecode and $30)=$20)) then
		spritecode:=(spritecode and $f) or (gfx_bank[0] shl 4) or (gfx_bank[1] shl 5) or $40;
  mooncrst_calc_sprite:=spritecode;
end;

//Scramble
procedure eventos_scramble;
begin
if event.arcade then begin
  //in0
  if arcade_input.but1[0] then in0:=(in0 and $fd) else in0:=(in0 or $2);
  if arcade_input.but0[0] then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if arcade_input.right[0] then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if arcade_input.left[0] then in0:=(in0 and $df) else in0:=(in0 or $20);
  if arcade_input.coin[0] then in0:=(in0 and $7F) else in0:=(in0 or $80);
  if arcade_input.coin[1] then in0:=(in0 and $bF) else in0:=(in0 or $40);
  //in1
  if arcade_input.start[1] then in1:=(in1 and $bf) else in1:=(in1 or $40);
  if arcade_input.start[0] then in1:=(in1 and $7f) else in1:=(in1 or $80);
  //in2
  if arcade_input.up[0] then in2:=(in2 and $EF) else in2:=(in2 or $10);
  if arcade_input.down[0] then in2:=(in2 and $BF) else in2:=(in2 or $40);
end;
end;

function scramble_ppi8255_r(direccion:word):byte;
var
  res:byte;
begin
	res:=$ff;
	if (direccion and $0100)<>0 then res:=res and (ppi8255_r(0,direccion and 3));
	if (direccion and $0200)<>0 then res:=res and (ppi8255_r(1,direccion and 3));
	scramble_ppi8255_r:=res;
end;

function scramble_getbyte(direccion:word):byte;
begin
case direccion of
  $0..$47ff:scramble_getbyte:=memoria[direccion];
  $4800..$4fff:scramble_getbyte:=videoram_mem[direccion and $3ff];
  $5000..$5fff:case (direccion and $7f) of
                0..$3f:scramble_getbyte:=atributos_mem[direccion and $3f];
                $40..$5f:scramble_getbyte:=sprite_mem[direccion and $1f];
                $60..$7f:scramble_getbyte:=disparo_mem[direccion and $1f];
                  else scramble_getbyte:=memoria[$5000+(direccion and $ff)];
               end;
  $8000..$ffff:scramble_getbyte:=scramble_ppi8255_r(direccion);
    else scramble_getbyte:=$ff;
end;
end;

procedure scramble_ppi8255_w(direccion:word;valor:byte);
begin
  if (direccion and $0100)<>0 then ppi8255_w(0,direccion and 3,valor);
	if (direccion and $0200)<>0 then ppi8255_w(1,direccion and 3,valor);
end;

procedure scramble_putbyte(direccion:word;valor:byte);
var
  f,dir:byte;
begin
if direccion<$4000 then exit;
memoria[direccion]:=valor;
case direccion of
  $4800..$4fff:if videoram_mem[direccion and $3ff]<>valor then begin
                  gfx[0].buffer[direccion and $3ff]:=true;
                  videoram_mem[direccion and $3ff]:=valor;
               end;
  $5000..$5fff:case (direccion and $ff) of
                    $0..$3f:if atributos_mem[direccion and $3f]<>valor then begin
                              atributos_mem[direccion and $3f]:=valor;
                              dir:=((direccion and $3f) shr 1);
                              for f:=0 to $1f do gfx[0].buffer[dir+(f shl 5)]:=true;
                            end;
                    $40..$5f:sprite_mem[direccion and $1f]:=valor;
                    $60..$7f:disparo_mem[direccion and $1f]:=valor;
                      else memoria[$5000+(direccion and $ff)]:=valor;
               end;
  $6800..$6fff:case (direccion and $7) of
                  1:haz_nmi:=(valor and 1)<>0;
                  3:scramble_background:=((valor and 1)<>0);
                  4:begin
                     stars_enable:=(valor and $1)<>0;
                     if not(stars_enable) then stars_scrollpos:=0;
                  end;
               end;
  $8000..$ffff:scramble_ppi8255_w(direccion,valor);
end;
end;

//8255 scramble
function scramble_port_1_c_read:byte;
begin
  scramble_port_1_c_read:=scramble_prot;
end;

procedure scramble_port_1_a_write(valor:byte);
begin
  latch:=valor;
end;

procedure scramble_port_1_b_write(valor:byte);
var
  old:byte;
begin
  old:=port_b_latch;
	port_b_latch:=valor;
	if (((old and $08)<>0) and ((not(valor and $08))<>0)) then snd_z80.pedir_irq:=HOLD_LINE;
	//device->machine().sound().system_mute(data & 0x10);
end;

procedure scramble_port_1_c_write(valor:byte);
begin
  scramble_prot_state:=(scramble_prot_state shl 4) or (valor and $0f);
	case (scramble_prot_state and $fff) of
		// scramble */
		$f09:scramble_prot:=$ff;
		$a49:scramble_prot:=$bf;
		$319:scramble_prot:=$4f;
		$5c9:scramble_prot:=$6f;
	end;
end;

function scramblesound_getbyte(direccion:word):byte;
begin
case direccion of
  0..$2fff:scramblesound_getbyte:=mem_snd[direccion];
  $8000..$8fff,$a000..$afff,$c000..$cfff,$e000..$efff:scramblesound_getbyte:=mem_snd[$8000+(direccion and $3ff)];
end;
end;

procedure scramblesound_putbyte(direccion:word;valor:byte);
begin
if direccion<$3000 then exit;
case direccion of
  $8000..$8fff,$a000..$afff,$c000..$cfff,$e000..$efff:mem_snd[$8000+(direccion and $3ff)]:=valor;
end;
end;

function scramblesound_inbyte(puerto:word):byte;
var
  res:byte;
begin
res:=$ff;
if (puerto and $20)<>0 then res:=res and AY8910_Read(1);
if (puerto and $80)<>0 then res:=res and AY8910_Read(0);
scramblesound_inbyte:=res;
end;

procedure scramblesound_outbyte(valor:byte;puerto:word);
begin
if (puerto and $10)<>0 then begin
    AY8910_Control(valor,1);
end else begin
    if (puerto and $20)<>0 then AY8910_Write(valor,1);
end;
if (puerto and $40)<>0 then begin
		AY8910_Control(valor,0);
end else begin
  if (puerto and $80)<>0 then AY8910_Write(valor,0);
end;
end;

function scramble_ay_porta:byte;
begin
  scramble_ay_porta:=latch;
end;

function scramble_ay_portb:byte;
var
  cycles:dword;
  hibit:byte;
begin
  cycles:=((snd_z80.contador+(konami_sound.frame*256))*4) mod (16*16*2*8*5*2);
	hibit:=0;
	// separate the high bit from the others */
	if (cycles>=(16*16*2*8*5)) then begin
		hibit:=1;
		cycles:=cycles-(16*16*2*8*5);
	end;
	scramble_ay_portb:=(hibit shl 7) or	// B7 is the output of the final divide-by-2 counter */
		   (BIT_n(cycles,14) shl 6) or // B6 is the high bit of the divide-by-5 counter */
		   (BIT_n(cycles,13) shl 5) or // B5 is the 2nd highest bit of the divide-by-5 counter */
		   (BIT_n(cycles,11) shl 4) or // B4 is the high bit of the divide-by-8 counter */
		   $0e;
end;

procedure scramble_despues_instruccion;
begin
  ay8910_update(0);
  ay8910_update(1);
end;

function scobra_getbyte(direccion:word):byte;
begin
case direccion of
  $0..$7fff:scobra_getbyte:=memoria[direccion];
  $8000..$87ff,$c000..$c7ff:scobra_getbyte:=memoria[$8000+(direccion and $7ff)];
  $8800..$8bff,$c800..$cbff:scobra_getbyte:=videoram_mem[direccion and $3ff];
  $9000..$97ff,$d000..$d7ff:case (direccion and $ff) of
                0..$3f:scobra_getbyte:=atributos_mem[direccion and $3f];
                $40..$5f:scobra_getbyte:=sprite_mem[direccion and $1f];
                $60..$7f:scobra_getbyte:=disparo_mem[direccion and $1f];
                  else scobra_getbyte:=memoria[$9000+(direccion and $ff)];
               end;
  $9800..$9fff,$d800..$dfff:scobra_getbyte:=ppi8255_r(0,direccion and 3);
  $a000..$a7ff,$e000..$e7ff:scobra_getbyte:=ppi8255_r(1,direccion and 3);
    else scobra_getbyte:=$ff;
end;
end;

procedure scobra_putbyte(direccion:word;valor:byte);
var
  f,dir:byte;
begin
if direccion<$8000 then exit;
memoria[direccion]:=valor;
case direccion of
  $8000..$87ff,$c000..$c7ff:memoria[$8000+(direccion and $7ff)]:=valor;
  $8800..$8bff,$c800..$cbff:if videoram_mem[direccion and $3ff]<>valor then begin
                  gfx[0].buffer[direccion and $3ff]:=true;
                  videoram_mem[direccion and $3ff]:=valor;
               end;
  $9000..$97ff,$d000..$d7ff:case (direccion and $ff) of
                    $0..$3f:if atributos_mem[direccion and $3f]<>valor then begin
                              atributos_mem[direccion and $3f]:=valor;
                              dir:=((direccion and $3f) shr 1);
                              for f:=0 to $1f do gfx[0].buffer[dir+(f shl 5)]:=true;
                            end;
                    $40..$5f:sprite_mem[direccion and $1f]:=valor;
                    $60..$7f:disparo_mem[direccion and $1f]:=valor;
                      else memoria[$9000+(direccion and $ff)]:=valor;
               end;
  $9800..$9fff,$d800..$dfff:ppi8255_w(0,direccion and 3,valor);
  $a000..$a7ff,$e000..$e7ff:ppi8255_w(1,direccion and 3,valor);
  $a800..$afff,$e800..$efff:case (direccion and $7) of
                  1:haz_nmi:=(valor and 1)<>0;
                  3:;//scramble_background:=((valor and 1)<>0);
                  4:begin
                     stars_enable:=(valor and $1)<>0;
                     if not(stars_enable) then stars_scrollpos:=0;
                  end;
               end;
end;
end;

//Frogger
procedure eventos_frogger;
begin
if event.arcade then begin
  if arcade_input.coin[0] then in0:=(in0 and $7F) else in0:=(in0 or $80);
  if arcade_input.coin[1] then in0:=(in0 and $bF) else in0:=(in0 or $40);
  if arcade_input.start[0] then in1:=in1 and $7F else in1:=in1 or $80;
  if arcade_input.up[0] then in2:=in2 and $EF else in2:=in2 or $10;
  if arcade_input.down[0] then in2:=in2 and $BF else in2:=in2 or $40;
  if arcade_input.left[0] then in0:=in0 and $DF else in0:=in0 or $20;
  if arcade_input.right[0] then in0:=in0 and $EF else in0:=in0 or $10;
end;
end;

function frogger_ppi8255_r(direccion:word):byte;inline;
var
  res:byte;
begin
	// the decoding here is very simplistic, and you can address both simultaneously
	res:=$ff;
	if (direccion and $1000)<>0 then res:=res and (ppi8255_r(1,(direccion shr 1) and 3));
	if (direccion and $2000)<>0 then res:=res and (ppi8255_r(0,(direccion shr 1) and 3));
	frogger_ppi8255_r:=res;
end;

function frogger_getbyte(direccion:word):byte;
begin
case direccion of
  $0..$3fff,$8000..$87ff:frogger_getbyte:=memoria[direccion];
  $a800..$afff:frogger_getbyte:=videoram_mem[direccion and $3ff];
  $b000..$b7ff:case (direccion and $ff) of
                0..$3f:frogger_getbyte:=atributos_mem[direccion and $3f];
                $40..$5f:frogger_getbyte:=sprite_mem[direccion and $1f];
                $60..$7f:frogger_getbyte:=disparo_mem[direccion and $1f];
                  else frogger_getbyte:=memoria[$b000+(direccion and $ff)];
               end;
  $c000..$ffff:frogger_getbyte:=frogger_ppi8255_r(direccion);
    else frogger_getbyte:=$ff;
end;
end;

procedure frogger_ppi8255_w(direccion:word;valor:byte);inline;
begin
  if (direccion and $1000)<>0 then ppi8255_w(1,(direccion shr 1) and 3,valor);
	if (direccion and $2000)<>0 then ppi8255_w(0,(direccion shr 1) and 3,valor);
end;

procedure frogger_putbyte(direccion:word;valor:byte);
var
  dir,f:byte;
begin
if direccion<$4000 then exit;
memoria[direccion]:=valor;
case direccion of
        $a800..$afff:if videoram_mem[direccion and $3ff]<>valor then begin
                  gfx[0].buffer[direccion and $3ff]:=true;
                  videoram_mem[direccion and $3ff]:=valor;
               end;
        $b000..$b7ff:case (direccion and $ff) of
                    $0..$3f:if atributos_mem[direccion and $3f]<>valor then begin
                              atributos_mem[direccion and $3f]:=valor;
                              dir:=((direccion and $3f) shr 1);
                              for f:=0 to $1f do gfx[0].buffer[dir+(f shl 5)]:=true;
                            end;
                    $40..$5f:sprite_mem[direccion and $1f]:=valor;
                    $60..$7f:disparo_mem[direccion and $1f]:=valor;
                      else memoria[$b000+(direccion and $ff)]:=valor;
               end;
        $b800..$bfff:case (direccion and $1f) of
                        8:haz_nmi:=(valor and 1)<>0;
                     end;
        $c000..$ffff:frogger_ppi8255_w(direccion,valor);
end;
end;

function frogger_sound_getbyte(direccion:word):byte;
begin
case (direccion and $7fff) of
  0..$1fff:frogger_sound_getbyte:=mem_snd[direccion];
  $4000..$5fff:frogger_sound_getbyte:=mem_snd[$4000+(direccion and $3ff)];
end;
end;

procedure frogger_sound_putbyte(direccion:word;valor:byte);
begin
if direccion<$2000 then exit;
case (direccion and $7fff) of
  $4000..$5fff:mem_snd[$4000+(direccion and $3ff)]:=valor;
end;
end;

function frogger_sound_inbyte(puerto:word):byte;
begin
  if (puerto and $ff)=$40 then frogger_sound_inbyte:=($ff and AY8910_Read(0));
end;

procedure frogger_sound_outbyte(valor:byte;puerto:word);
begin
  case (puerto and $ff) of
    $40:AY8910_Write(valor,0);
    $80:AY8910_Control(valor,0);
end;
end;

procedure frogger_hi_score;
begin
if ((memoria[$83f1]=$63) and (memoria[$83f2]=$04)) then begin
    load_hi('frogger.hi',@memoria[$83f1],10);
    copymemory(@memoria[$83ef],@memoria[$83f1],2);
    timer[timer_hs_frogger].enabled:=false;
end;
end;

function frogger_clock(valor:byte):byte;
begin
  frogger_clock:=BITSWAP8(valor,7,6,3,4,5,2,1,0);
end;

procedure frogger_port_1_a_write(valor:byte);
begin
  konami_sound.sound_latch:=valor;
end;

procedure frogger_port_1_b_write(valor:byte);
begin
  if ((port_b_latch=0) and (valor<>0)) then snd_z80.pedir_irq:=HOLD_LINE;
  port_b_latch:=valor;
end;

//amidar
procedure eventos_amidar;
begin
if event.arcade then begin
  if arcade_input.but0[0] then in0:=in0 and $F7 else in0:=in0 or $8;
  if arcade_input.left[0] then in0:=in0 and $DF else in0:=in0 or $20;
  if arcade_input.right[0] then in0:=in0 and $EF else in0:=in0 or $10;
  if arcade_input.coin[0] then in0:=(in0 and $7F) else in0:=(in0 or $80);
  if arcade_input.coin[1] then in0:=(in0 and $bF) else in0:=(in0 or $40);
  //in1
  if arcade_input.start[1] then in1:=in1 and $bF else in1:=in1 or $40;
  if arcade_input.start[0] then in1:=in1 and $7F else in1:=in1 or $80;
  //in2
  if arcade_input.up[0] then in2:=in2 and $ef else in2:=in2 or $10;
  if arcade_input.down[0] then in2:=in2 and $BF else in2:=in2 or $40;
end;
end;

function amidar_getbyte(direccion:word):byte;
begin
case direccion of
  $0..$7fff:amidar_getbyte:=memoria[direccion];
  $8000..$87ff,$c000..$c7ff:amidar_getbyte:=memoria[$8000-(direccion and $7ff)];
  $9000..$97ff,$d000..$d7ff:amidar_getbyte:=videoram_mem[direccion and $3ff];
  $9800..$9fff,$d800..$dfff:case (direccion and $ff) of
                              0..$3f:amidar_getbyte:=atributos_mem[direccion and $3f];
                              $40..$5f:amidar_getbyte:=sprite_mem[direccion and $1f];
                              $60..$7f:amidar_getbyte:=disparo_mem[direccion and $1f];
                                 else amidar_getbyte:=memoria[$9800+(direccion and $ff)];
                            end;
  $b000..$b7ff,$f000..$f7ff:amidar_getbyte:=ppi8255_r(0,(direccion shr 4) and 3);
  $b800..$bfff,$f800..$ffff:amidar_getbyte:=ppi8255_r(1,(direccion shr 4) and 3);
    else amidar_getbyte:=$ff;
end;
end;

procedure amidar_putbyte(direccion:word;valor:byte);
var
  dir,f:byte;
begin
if direccion<$8000 then exit;
memoria[direccion]:=valor;
case direccion of
        $8000..$87ff,$c000..$c7ff:memoria[$8000-(direccion and $7ff)]:=valor;
        $9000..$97ff,$d000..$d7ff:if videoram_mem[direccion and $3ff]<>valor then begin
                  gfx[0].buffer[direccion and $3ff]:=true;
                  videoram_mem[direccion and $3ff]:=valor;
               end;
        $9800..$9fff,$d800..$dfff:case (direccion and $ff) of
                                    $0..$3f:if atributos_mem[direccion and $3f]<>valor then begin
                                              atributos_mem[direccion and $3f]:=valor;
                                              dir:=((direccion and $3f) shr 1);
                                              for f:=0 to $1f do gfx[0].buffer[dir+(f shl 5)]:=true;
                                            end;
                                    $40..$5f:sprite_mem[direccion and $1f]:=valor;
                                    $60..$7f:disparo_mem[direccion and $1f]:=valor;
                                        else memoria[$9800+(direccion and $ff)]:=valor;
                                 end;
        $a000..$a7ff,$e000..$e7ff:case (direccion and $3f) of
                                    8:haz_nmi:=(valor and 1)<>0;
                                  end;
        $b000..$b7ff,$f000..$f7ff:ppi8255_w(0,(direccion shr 4) and 3,valor);
        $b800..$bfff,$f800..$ffff:ppi8255_w(1,(direccion shr 4) and 3,valor);
end;
end;

//Definiciones Hardware General
//PPI 8255 0 y 1
function port_0_a_read:byte;
begin
  port_0_a_read:=in0;
end;

function port_0_b_read:byte;
begin
  port_0_b_read:=in1;
end;

function port_0_c_read:byte;
begin
  port_0_c_read:=in2;
end;

function port_1_c_read:byte;
begin
  port_1_c_read:=$ff;  //Amidar IN3
end;

procedure update_video_frogger;
var
        f,color,nchar:word;
        scroll,x,y,atrib:byte;
begin
//Chars
for f:=$0 to $3ff do begin
  if gfx[0].buffer[f] then begin
    x:=31-(f div 32);
    y:=f mod 32;
    atrib:=atributos_mem[y*2];
    color:=atributos_mem[$1+(y*2)];
    color:=(((color shr 1) and $3)+((color shl 2) and $4)) shl 2;
    scroll:=(x*8)+((atrib and $f) shl 4)+(atrib shr 4);
    nchar:=videoram_mem[f];
    if y<16 then color:=color+100;
    put_gfx(scroll,y*8,nchar,color,2,0);
    gfx[0].buffer[f]:=false;
  end;
end;
actualiza_trozo(0,0,256,256,2,0,0,256,256,1);
//Sprites
for f:=7 downto 0 do begin
  y:=sprite_mem[$3+(f*4)]+1;
  if y<16 then continue;
  atrib:=sprite_mem[$1+(f*4)];
  nchar:=atrib and $3f;
  color:=sprite_mem[$2+(f*4)];
  color:=(((color shr 1) and $3)+((color shl 2) and $4)) shl 2;
  x:=((sprite_mem[f*4] and $F) shl 4)+(sprite_mem[f*4] shr 4);
  put_gfx_sprite(nchar,color,(atrib and $80)<>0,(atrib and $40)<>0,1);
  actualiza_gfx_sprite(x,y,1,1);
end;
actualiza_trozo_final(16,0,224,256,1);
end;

procedure update_video_hgalaxian;
var
        f,color,nchar:word;
        scroll,x,y,atrib:byte;
begin
if scramble_background then fill_full_screen(1,99)
  else fill_full_screen(1,150);
//estellas
if stars_enable then draw_stars;
//Chars
for f:=$0 to $3ff do begin
  if gfx[0].buffer[f] then begin
    x:=31-(f div 32);
    y:=f mod 32;
    color:=(atributos_mem[$1+(y shl 1)] and $07) shl 2;
    scroll:=(x*8)+atributos_mem[y shl 1];
    nchar:=calc_nchar(f);
    put_gfx_trans(scroll,y*8,nchar,color,2,0);
    gfx[0].buffer[f]:=false;
  end;
end;
actualiza_trozo(0,0,256,256,2,0,0,256,256,1);
//Disparos
for f:=0 to 7 do begin
  if f=7 then color:=32 else color:=33;
  y:=251-disparo_mem[$3+(f*4)];
  x:=disparo_mem[$1+(f*4)];
  put_gfx_sprite(0,color,false,false,2);
  actualiza_gfx_sprite(x,y,1,2);
end;
//Sprites
for f:=7 downto 0 do begin
  y:=sprite_mem[$3+(f*4)]+1;
  if y<16 then continue; //en las dos primeras lineas no hay sprites
  nchar:=calc_sprite(f);
  atrib:=sprite_mem[$1+(f*4)];
  color:=(sprite_mem[$2+(f*4)] and $7) shl 2;
  x:=sprite_mem[f*4];
  put_gfx_sprite(nchar,color,(atrib and $80)<>0,(atrib and $40)<>0,1);
  actualiza_gfx_sprite(x,y,1,1);
end;
actualiza_trozo_final(16,0,224,256,1);
end;

procedure Cargar_hgalaxian;
begin
case main_vars.tipo_maquina of
  14:begin
      llamadas_maquina.bucle_general:=scramble_principal;
      eventos_hardware_galaxian:=eventos_frogger;
      calc_nchar:=galaxian_calc_nchar; //no usado
      calc_sprite:=galaxian_calc_sprite;  //no usado
      draw_stars:=stars_galaxian;  //no usado
      galaxian_update_video:=update_video_frogger;
     end;
  47:begin
      llamadas_maquina.bucle_general:=hgalaxian_principal;
      eventos_hardware_galaxian:=eventos_galaxian;
      calc_nchar:=galaxian_calc_nchar;
      calc_sprite:=galaxian_calc_sprite;
      draw_stars:=stars_galaxian;
      galaxian_update_video:=update_video_hgalaxian;
     end;
  48:begin
      llamadas_maquina.bucle_general:=hgalaxian_principal;
      eventos_hardware_galaxian:=eventos_jumpbug;
      calc_nchar:=jumpbug_calc_nchar;
      calc_sprite:=jumpbug_calc_sprite;
      draw_stars:=stars_jumpbug;
      galaxian_update_video:=update_video_hgalaxian;
  end;
  49:begin
      llamadas_maquina.bucle_general:=hgalaxian_principal;
      eventos_hardware_galaxian:=eventos_galaxian;
      calc_nchar:=mooncrst_calc_nchar;
      calc_sprite:=mooncrst_calc_sprite;
      draw_stars:=stars_galaxian;
      galaxian_update_video:=update_video_hgalaxian;
  end;
  143:begin
      llamadas_maquina.bucle_general:=scramble_principal;
      eventos_hardware_galaxian:=eventos_scramble;
      calc_nchar:=galaxian_calc_nchar;
      calc_sprite:=galaxian_calc_sprite;
      draw_stars:=stars_jumpbug;
      galaxian_update_video:=update_video_hgalaxian;
  end;
  144:begin
      llamadas_maquina.bucle_general:=scramble_principal;
      eventos_hardware_galaxian:=eventos_scramble;
      calc_nchar:=galaxian_calc_nchar;
      calc_sprite:=galaxian_calc_sprite;
      draw_stars:=stars_jumpbug;
      galaxian_update_video:=update_video_hgalaxian;
  end;
  145:begin
      llamadas_maquina.bucle_general:=scramble_principal;
      eventos_hardware_galaxian:=eventos_amidar;
      calc_nchar:=galaxian_calc_nchar;
      calc_sprite:=galaxian_calc_sprite;
      draw_stars:=stars_jumpbug;
      galaxian_update_video:=update_video_hgalaxian;
  end;
end;
llamadas_maquina.iniciar:=iniciar_hgalaxian;
llamadas_maquina.cerrar:=cerrar_hgalaxian;
llamadas_maquina.reset:=reset_hgalaxian;
llamadas_maquina.fps_max:=60.6060606060;
end;

procedure scramble_principal;
var
  frame_m,frame_s:single;
  f:byte;
begin
init_controls(false,false,false,true);
frame_m:=main_z80.tframes;
frame_s:=snd_z80.tframes;
while EmuStatus=EsRuning do begin
  for f:=0 to $ff do begin
    konami_sound.frame:=f;
    run_z80(main_z80,main_z80_ll,trunc(frame_m));
    frame_m:=frame_m+main_z80.tframes-main_z80.contador;
    //SND CPU
    run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
    frame_s:=frame_s+snd_z80.tframes-snd_z80.contador;
    if f=248 then begin
      if haz_nmi then main_z80.pedir_nmi:=PULSE_LINE;
      if stars_enable then stars_scrollpos:=stars_scrollpos+1;
      galaxian_update_video;
    end;
  end;
  eventos_hardware_galaxian;
  video_sync;
end;
end;

procedure hgalaxian_principal;
var
  frame:single;
  f:byte;
begin
init_controls(false,false,false,true);
frame:=main_z80.tframes;
while EmuStatus=EsRuning do begin
  for f:=0 to $ff do begin
    run_z80(main_z80,main_z80_ll,trunc(frame));
    frame:=frame+main_z80.tframes-main_z80.contador;
    if f=248 then begin
      if haz_nmi then main_z80.pedir_nmi:=PULSE_LINE;
      if stars_enable then stars_scrollpos:=stars_scrollpos+1;
      update_video_hgalaxian;  //el general, no hace falta la funcion
    end;
  end;
  eventos_hardware_galaxian;
  video_sync;
end;
end;

procedure cerrar_hgalaxian;
begin
cerrar_cpus;
case main_vars.tipo_maquina of
  14:begin
        save_hi('frogger.hi',@memoria[$83f1],10);
        konamisnd_close;
        close_ppi8255(0);
        close_ppi8255(1);
     end;
  47,49:close_samples;
  48:AY8910_close(0);
  143,144,145:begin
        AY8910_close(0);
        AY8910_close(1);
        close_ppi8255(0);
        close_ppi8255(1);
      end;
end;
close_audio;
close_video;
end;

procedure reset_hgalaxian;
begin
 reset_z80(main_z80);
 reset_audio;
 stars_scrollpos:=0;
 haz_nmi:=false;
 stars_enable:=false;
 scramble_background:=false;
 case main_vars.tipo_maquina of
  14:begin
       reset_z80(snd_z80);
       konamisnd_reset;
       reset_ppi8255(0);
       reset_ppi8255(1);
       in0:=$FF;
       in1:=$FC;
       in2:=$F1;
     end;
  47:begin
       in0:=0;
       in1:=0;
       in2:=4;
       if hay_samples then reset_samples;
  end;
  48:begin
       in0:=0;
       in1:=0;
       in2:=1;
       AY8910_reset(0);
  end;
  49:begin
       in0:=0;
       in1:=$80;
       in2:=0;
       if hay_samples then reset_samples;
  end;
  143:begin
        reset_z80(snd_z80);
        AY8910_reset(0);
        AY8910_reset(1);
        in0:=$ff;
        in1:=$fc;
        in2:=$f1;
        scramble_prot:=0;
        scramble_prot_state:=0;
        reset_ppi8255(0);
        reset_ppi8255(1);
        latch:=0;
        port_b_latch:=0;
      end;
  144:begin
        reset_z80(snd_z80);
        AY8910_reset(0);
        AY8910_reset(1);
        in0:=$ff;
        in1:=$fd;
        in2:=$f2;
        reset_ppi8255(0);
        reset_ppi8255(1);
        latch:=0;
        port_b_latch:=0;
      end;
  145:begin
        reset_z80(snd_z80);
        AY8910_reset(0);
        AY8910_reset(1);
        in0:=$ff;
        in1:=$ff;
        in2:=$f1;
        reset_ppi8255(0);
        reset_ppi8255(1);
        latch:=0;
        port_b_latch:=0;
      end;
 end;
end;

function iniciar_hgalaxian:boolean;
var
      colores:tpaleta;
      f,x,y:word;
      pos:pbyte;
      ctemp1,ctemp2,total_stars:byte;
      bit0,generator:dword;
      memoria_temp:array[0..$afff] of byte;
const
  ps_x:array[0..15] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			8*8+0, 8*8+1, 8*8+2, 8*8+3, 8*8+4, 8*8+5, 8*8+6, 8*8+7);
  ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			16*8, 17*8, 18*8, 19*8, 20*8, 21*8, 22*8, 23*8);
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7 );
  pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
  map:array[0..3] of byte =($00,$88,$cc,$ff);
//pequeas funciones para aclarar el codigo
procedure convert_chars(n:word);
begin
  init_gfx(0,8,8,n);
  gfx[0].trans[0]:=true;
  des_gfx.pos_planos[0]:=0;
  des_gfx.pos_planos[1]:=n*8*8;
  des_gfx.bit_pixel:=2;
  des_gfx.banks:=0;
  des_gfx.long_sprites:=8*8;
  convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
end;
procedure convert_sprt(n:word);
begin
  init_gfx(1,16,16,n);
  gfx[1].trans[0]:=true;
  des_gfx.pos_planos[0]:=0;
  des_gfx.pos_planos[1]:=n*16*16;
  des_gfx.bit_pixel:=2;
  des_gfx.banks:=0;
  des_gfx.long_sprites:=32*8;
  convert_gfx(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
end;
begin
iniciar_hgalaxian:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=224;
p_final[0].y:=256;
p_final[1].x:=256;
p_final[1].y:=512;
p_final[1].trans:=true;
p_final[1].final_mix:=true;
p_final[2].x:=512;
p_final[2].y:=256;
p_final[2].trans:=true;
iniciar_video;
//Main CPU
init_cpu(z80_main,0,3072000/256);
case main_vars.tipo_maquina of
  14:begin  //frogger
      //Main CPU
      main_z80_ll.getbyte:=frogger_getbyte;
      main_z80_ll.putbyte:=frogger_putbyte;
      //Sound CPU
      init_cpu(z80_snd,1,1789750/256);
      snd_z80_ll.getbyte:=frogger_sound_getbyte;
      snd_z80_ll.putbyte:=frogger_sound_putbyte;
      snd_z80_ll.inbyte:=frogger_sound_inbyte;
      snd_z80_ll.outbyte:=frogger_sound_outbyte;
      //Sound Chip
      konamisnd_init(2,1,ONE_AY8910,1789750,frogger_clock);
      //Hi-Score
      timer_hs_frogger:=init_timer(0,10000,frogger_hi_score,true);
      //PPI 8255
      init_ppi8255(0,port_0_a_read,port_0_b_read,port_0_c_read,nil,nil,nil);
      init_ppi8255(1,nil,nil,nil,frogger_port_1_a_write,frogger_port_1_b_write,nil);
      //cargar roms
      if not(cargar_roms(@memoria[0],@frogger_rom[0],'frogger.zip',0)) then exit;
      if not(cargar_roms(@mem_snd[0],@frogger_sound[0],'frogger.zip',0)) then exit;
      //Las ROMS tienen lineas movidas...
      for f:=0 to $7FF do mem_snd[f]:=BITSWAP8(mem_snd[f],7,6,5,4,3,2,0,1);
      //convertir chars & sprites
      if not(cargar_roms(@memoria_temp[0],@frogger_char[0],'frogger.zip',0)) then exit;
      //la rom tiene cambiadas D1 y D0
      for f:=$800 to $FFF do memoria_temp[f]:=BITSWAP8(memoria_temp[f],7,6,5,4,3,2,0,1);
      convert_chars(256);
      convert_sprt(64);
      if not(cargar_roms(@memoria_temp[$0],@frogger_pal,'frogger.zip',1)) then exit;
  end;
  47:begin
      //funciones Z80
      main_z80_ll.getbyte:=galaxian_getbyte;
      main_z80_ll.putbyte:=galaxian_putbyte;
      //cargar roms
      if not(cargar_roms(@memoria[0],@galaxian_rom[0],'galaxian.zip',0)) then exit;
      //cargar samples
      hay_samples:=load_samples('galaxian.zip',@galaxian_samples[0],5);
      init_sound_engine(0,3072000,galaxian_despues_instruccion);
      //convertir chars &sprites
      if not(cargar_roms(@memoria_temp[0],@galaxian_char[0],'galaxian.zip',0)) then exit;
      convert_chars(256);
      convert_sprt(64);
      if not(cargar_roms(@memoria_temp[0],@galaxian_pal,'galaxian.zip',1)) then exit;
  end;
  48:begin //Jump Bug
      //funciones Z80
      main_z80_ll.getbyte:=jumpbug_getbyte;
      main_z80_ll.putbyte:=jumpbug_putbyte;
      //chip de sonido
      AY8910_init(1500000,0,1,nil,nil,nil,nil);
      init_sound_engine(0,3072000,jumpbug_despues_instruccion);
      //Timers
      init_timer(0,3072000*(0.693*(100000+2*10000)*0.00001),jumpbug_blinking,true);
      //cargar roms
      if not(cargar_roms(@memoria[0],@jumpbug_rom[0],'jumpbug.zip',0)) then exit;
      //convertir chars &sprites
      if not(cargar_roms(@memoria_temp[0],@jumpbug_char[0],'jumpbug.zip',0)) then exit;
      convert_chars(768);
      convert_sprt(192);
      if not(cargar_roms(@memoria_temp[0],@jumpbug_pal,'jumpbug.zip',1)) then exit;
  end;
  49:begin  //mooncrst
      //funciones Z80
      main_z80_ll.getbyte:=mooncrst_getbyte;
      main_z80_ll.putbyte:=mooncrst_putbyte;
      //cargar roms
      if not(cargar_roms(@memoria[0],@mooncrst_rom[0],'mooncrst.zip',0)) then exit;
      //Desencriptarlas
      for f:=0 to $3fff do begin
		    ctemp1:=memoria[f];
		    ctemp2:=ctemp1;
		    if ((ctemp1 and 2)<>0) then ctemp2:=ctemp2 xor $40;
		    if ((ctemp1 and $20)<>0) then ctemp2:=ctemp2 xor $04;
		    if ((f and 1)=0) then ctemp1:=BITSWAP8(ctemp2,7,2,5,4,3,6,1,0)
          else ctemp1:=ctemp2;
		    memoria[f]:=ctemp1;
      end;
      hay_samples:=load_samples('mooncrst.zip',@mooncrst_samples[0],5);
      init_sound_engine(0,3072000,galaxian_despues_instruccion);
      //convertir chars & sprites
      if not(cargar_roms(@memoria_temp[0],@mooncrst_char[0],'mooncrst.zip',0)) then exit;
      convert_chars(512);
      convert_sprt(128);
      if not(cargar_roms(@memoria_temp[0],@mooncrst_pal,'mooncrst.zip',1)) then exit;
  end;
  143:begin  //scramble
      //Main CPU
      main_z80_ll.getbyte:=scramble_getbyte;
      main_z80_ll.putbyte:=scramble_putbyte;
      //Sound CPU
      init_cpu(z80_snd,1,1789750/256);
      snd_z80_ll.getbyte:=scramblesound_getbyte;
      snd_z80_ll.putbyte:=scramblesound_putbyte;
      snd_z80_ll.inbyte:=scramblesound_inbyte;
      snd_z80_ll.outbyte:=scramblesound_outbyte;
      //Sound Chip
      AY8910_init(1789750,0,1,scramble_ay_porta,scramble_ay_portb,nil,nil);
      AY8910_init(1789750,1,1,nil,nil,nil,nil);
      init_sound_engine(1,1789750,scramble_despues_instruccion);
      //PPI 8255
      init_ppi8255(0,port_0_a_read,port_0_b_read,port_0_c_read,nil,nil,nil);
      init_ppi8255(1,nil,nil,scramble_port_1_c_read,scramble_port_1_a_write,scramble_port_1_b_write,scramble_port_1_c_write);
      init_timer(0,3072000*(0.693*(100000+2*10000)*0.00001),jumpbug_blinking,true);
      //cargar roms
      if not(cargar_roms(@memoria[0],@scramble_rom[0],'scramble.zip',0)) then exit;
      if not(cargar_roms(@mem_snd[0],@scramble_sound[0],'scramble.zip',0)) then exit;
      //convertir chars & sprites
      if not(cargar_roms(@memoria_temp[0],@scramble_char[0],'scramble.zip',0)) then exit;
      convert_chars(256);
      convert_sprt(64);
      if not(cargar_roms(@memoria_temp[0],@scramble_pal,'scramble.zip',1)) then exit;
  end;
  144:begin  //super cobra
      //Main CPU
      main_z80_ll.getbyte:=scobra_getbyte;
      main_z80_ll.putbyte:=scobra_putbyte;
      //Sound CPU
      init_cpu(z80_snd,1,1789750/256);
      snd_z80_ll.getbyte:=scramblesound_getbyte;
      snd_z80_ll.putbyte:=scramblesound_putbyte;
      snd_z80_ll.inbyte:=scramblesound_inbyte;
      snd_z80_ll.outbyte:=scramblesound_outbyte;
      //Sound Chip
      AY8910_init(1789750,0,1,scramble_ay_porta,scramble_ay_portb,nil,nil);
      AY8910_init(1789750,1,1,nil,nil,nil,nil);
      init_sound_engine(1,1789750,scramble_despues_instruccion);
      //PPI 8255
      init_ppi8255(0,port_0_a_read,port_0_b_read,port_0_c_read,nil,nil,nil);
      init_ppi8255(1,nil,nil,nil,scramble_port_1_a_write,scramble_port_1_b_write,nil);
      init_timer(0,3072000*(0.693*(100000+2*10000)*0.00001),jumpbug_blinking,true);
      //cargar roms
      if not(cargar_roms(@memoria[0],@scobra_rom[0],'scobra.zip',0)) then exit;
      if not(cargar_roms(@mem_snd[0],@scobra_sound[0],'scobra.zip',0)) then exit;
      //convertir chars & sprites
      if not(cargar_roms(@memoria_temp[0],@scobra_char[0],'scobra.zip',0)) then exit;
      convert_chars(256);
      convert_sprt(64);
      if not(cargar_roms(@memoria_temp[0],@scobra_pal,'scobra.zip',1)) then exit;
  end;
  145:begin  //amidar
      //Main CPU
      main_z80_ll.getbyte:=amidar_getbyte;
      main_z80_ll.putbyte:=amidar_putbyte;
      //Sound CPU
      init_cpu(z80_snd,1,1789750/256);
      snd_z80_ll.getbyte:=scramblesound_getbyte;
      snd_z80_ll.putbyte:=scramblesound_putbyte;
      snd_z80_ll.inbyte:=scramblesound_inbyte;
      snd_z80_ll.outbyte:=scramblesound_outbyte;
      //Sound Chip
      AY8910_init(1789750,0,1,scramble_ay_porta,scramble_ay_portb,nil,nil);
      AY8910_init(1789750,1,1,nil,nil,nil,nil);
      init_sound_engine(1,1789750,scramble_despues_instruccion);
      //PPI 8255
      init_ppi8255(0,port_0_a_read,port_0_b_read,port_0_c_read,nil,nil,nil);
      init_ppi8255(1,nil,nil,port_1_c_read,scramble_port_1_a_write,scramble_port_1_b_write,nil);
      //cargar roms
      if not(cargar_roms(@memoria[0],@amidar_rom[0],'amidar.zip',0)) then exit;
      if not(cargar_roms(@mem_snd[0],@amidar_sound[0],'amidar.zip',0)) then exit;
      //convertir chars & sprites
      if not(cargar_roms(@memoria_temp[0],@amidar_char[0],'amidar.zip',0)) then exit;
      convert_chars(256);
      convert_sprt(64);
      if not(cargar_roms(@memoria_temp[0],@amidar_pal,'amidar.zip',1)) then exit;
  end;
end;
//poner la paleta
for f:=0 to 31 do begin
  ctemp1:=memoria_temp[f];
  colores[f].r:=$21*(ctemp1 and 1)+$47*((ctemp1 shr 1) and 1)+$97*((ctemp1 shr 2) and 1);
  colores[f].g:=$21*((ctemp1 shr 3) and 1)+$47*((ctemp1 shr 4) and 1)+$97*((ctemp1 shr 5) and 1);
  colores[f].b:=0+$47*((ctemp1 shr 6) and 1)+$97*((ctemp1 shr 7) and 1);
  //Para frogger una paleta extra con la parte de arriba mas azul
  if main_vars.tipo_maquina=14 then begin
    colores[f+100].r:=colores[f].r;
    colores[f+100].g:=colores[f].g;
    colores[f+100].b:=colores[f].b;
    if ((colores[f].r=0) and (colores[f].g=0) and (colores[f].b=0)) then colores[f+100].b:=colores[f+100].b+$39;
  end;
end;
//y la paleta del disparo
colores[32].r:=$FF;colores[32].g:=$FF;colores[32].b:=$0;
colores[33].r:=$FF;colores[33].g:=$FF;colores[33].b:=$FF;
//y la de las estrellas de fondo
for f:=0 to 63 do begin
  ctemp1:=(f shr 0) and $03;
  colores[f+34].r:=map[ctemp1];
  ctemp1:=(f shr 2) and $03;
  colores[f+34].g:=map[ctemp1];
  ctemp1:=(f shr 4) and $03;
  colores[f+34].b:=map[ctemp1];
end;
//Color especial Scramble Background
colores[99].r:=0;
colores[99].g:=0;
colores[99].b:=$56;
//32 paleta,2 disparo,64 estrellas,1 fondo azul scramble,1 vacio y 32 fondo azul frogger
set_pal(colores,32+2+64+1+1+32);
//El disparo, creado por hardware aqui lo emulo como si fuera un sprite...
case main_vars.tipo_maquina of
  143,144,145:begin
            init_gfx(2,1,1,1);
            gfx[2].datos^:=0;
          end;
    else begin
        init_gfx(2,1,4,1);
        pos:=gfx[2].datos;
        for f:=0 to 3 do begin
          pos^:=0;
          inc(pos);
        end;
    end;
end;
//iniciar las estrellas de fondo
total_stars:=0;
generator:=0;
for y:=0 to 255 do begin
		for x:=0 to 511 do begin
			bit0:=((not(generator) shr 16) and $01) xor ((generator shr 4) and $01);
			generator:=(generator shl 1) or bit0;
			if ((((not(generator) shr 16) and $01)<>0) and ((generator and $ff)=$ff)) then begin
				ctemp1:= (not(generator shr 8)) and $3f;
				if (ctemp1<>0) then begin
					stars[total_stars].x:=x;
					stars[total_stars].y:=y;
					stars[total_stars].color:=ctemp1+34;
					total_stars:=total_stars+1;
				end;
      end;
		end;
end;
//final
reset_hgalaxian;
iniciar_hgalaxian:=true;
end;

end.
