unit gng_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     m6809,z80,ym_2203,main_engine,controls_engine,gfx_engine,rom_engine,
     cpu_engine,pal_engine,sound_engine,timer_engine;

procedure Cargar_gng;
procedure gng_principal;
procedure reset_gng;
procedure cerrar_gng;
function iniciar_gng:boolean;
//Main CPU
function gng_getbyte(direccion:word): Byte;
procedure gng_putbyte(direccion:word;valor:byte);
//Sound CPU
function sound_getbyte(direccion:word):Byte;
procedure sound_putbyte(direccion:word;valor:byte);
procedure sound_instruccion;
procedure gng_snd_irq;

const
        gng_rom:array[0..3] of tipo_roms=(
        (n:'gg3.bin';l:$8000;p:$8000;crc:$9e01c65e),(n:'gg4.bin';l:$4000;p:$4000;crc:$66606beb),
        (n:'gg5.bin';l:$8000;p:$10000;crc:$d6397b2b),());
        gng_char:tipo_roms=(n:'gg1.bin';l:$4000;p:0;crc:$ecfccf07);
        gng_tiles:array[0..6] of tipo_roms=(
        (n:'gg11.bin';l:$4000;p:0;crc:$ddd56fa9),(n:'gg10.bin';l:$4000;p:$4000;crc:$7302529d),(n:'gg9.bin';l:$4000;p:$8000;crc:$20035bda),
        (n:'gg8.bin';l:$4000;p:$c000;crc:$f12ba271),(n:'gg7.bin';l:$4000;p:$10000;crc:$e525207d),(n:'gg6.bin';l:$4000;p:$14000;crc:$2d77e9b2),());
        gng_sprites:array[0..6] of tipo_roms=(
        (n:'gg17.bin';l:$4000;p:0;crc:$93e50a8f),(n:'gg16.bin';l:$4000;p:$4000;crc:$06d7e5ca),(n:'gg15.bin';l:$4000;p:$8000;crc:$bc1fe02d),
        (n:'gg14.bin';l:$4000;p:$c000;crc:$6aaf12f9),(n:'gg13.bin';l:$4000;p:$10000;crc:$e80c3fca),(n:'gg12.bin';l:$4000;p:$14000;crc:$7780a925),());
        gng_sound:tipo_roms=(n:'gg2.bin';l:$8000;p:0;crc:$615f5b6f);
        //Dip
        gng_dip_a:array [0..5] of def_dip=(
        (mask:$f;name:'Coinage';number:16;dip:((dip_val:$2;dip_name:'4 Coin - 1 Credit'),(dip_val:$5;dip_name:'3 Coin - 1 Credit'),(dip_val:$8;dip_name:'2 Coin - 1 Credit'),(dip_val:$4;dip_name:'3 Coin - 2 Credit'),(dip_val:$1;dip_name:'4 Coin - 3 Credit'),(dip_val:$f;dip_name:'1 Coin - 1 Credit'),(dip_val:$3;dip_name:'3 Coin - 4 Credit'),(dip_val:$7;dip_name:'2 Coin - 3 Credit'),(dip_val:$e;dip_name:'1 Coin - 2 Credit'),(dip_val:$6;dip_name:'2 Coin - 5 Credit'),(dip_val:$d;dip_name:'1 Coin - 3 Credit'),(dip_val:$c;dip_name:'1 Coin - 4 Credit'),(dip_val:$b;dip_name:'1 Coin - 5 Credit'),(dip_val:$a;dip_name:'1 Coin - 6 Credit'),(dip_val:$9;dip_name:'1 Coin - 7 Credit'),(dip_val:$0;dip_name:'Free Play'))),
        (mask:$10;name:'Coinage affects';number:2;dip:((dip_val:$10;dip_name:'Coin A'),(dip_val:$0;dip_name:'Coin B'),(),(),(),(),(),(),(),(),(),(),(),(),(),())),
        (mask:$20;name:'Demo Sounds';number:2;dip:((dip_val:$20;dip_name:'Off'),(dip_val:$0;dip_name:'On'),(),(),(),(),(),(),(),(),(),(),(),(),(),())),
        (mask:$40;name:'Service Mode';number:2;dip:((dip_val:$40;dip_name:'Off'),(dip_val:$0;dip_name:'On'),(),(),(),(),(),(),(),(),(),(),(),(),(),())),
        (mask:$80;name:'Flip Screen';number:2;dip:((dip_val:$80;dip_name:'Off'),(dip_val:$0;dip_name:'On'),(),(),(),(),(),(),(),(),(),(),(),(),(),())),());
        gng_dip_b:array [0..4] of def_dip=(
        (mask:$3;name:'Lives';number:4;dip:((dip_val:$3;dip_name:'3 Lives'),(dip_val:$2;dip_name:'4 Lives'),(dip_val:$1;dip_name:'5 Lives'),(dip_val:$0;dip_name:'7 Lives'),(),(),(),(),(),(),(),(),(),(),(),())),
        (mask:$4;name:'Cabinet';number:2;dip:((dip_val:$0;dip_name:'Upright'),(dip_val:$4;dip_name:'Cocktail'),(),(),(),(),(),(),(),(),(),(),(),(),(),())),
        (mask:$18;name:'Bonus Life';number:4;dip:((dip_val:$18;dip_name:'20K 70K Every 70K'),(dip_val:$10;dip_name:'30K 80K Every 80K'),(dip_val:$8;dip_name:'20K and 80K Only'),(dip_val:$0;dip_name:'30K and 80K Only'),(),(),(),(),(),(),(),(),(),(),(),())),
        (mask:$60;name:'Difficulty';number:4;dip:((dip_val:$40;dip_name:'Easy'),(dip_val:$60;dip_name:'Normal'),(dip_val:$20;dip_name:'Difficult'),(dip_val:$0;dip_name:'Very Difficult'),(),(),(),(),(),(),(),(),(),(),(),())),());

var
 memoria_rom:array[0..4,0..$1FFF] of byte;
 banco,soundlatch:byte;
 scroll_x,scroll_y:word;

implementation
uses principal;

procedure Cargar_Gng;
begin
llamadas_maquina.iniciar:=iniciar_gng;
llamadas_maquina.bucle_general:=gng_principal;
llamadas_maquina.cerrar:=cerrar_gng;
llamadas_maquina.reset:=reset_gng;
llamadas_maquina.fps_max:=59.59;
end;

function iniciar_gng:boolean;
var
  colores:tpaleta;
  f:word;
  memoria_temp:array[0..$1ffff] of byte;
const
    pc_x:array[0..7] of dword=(0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3 );
    pc_y:array[0..7] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16);
    ps_x:array[0..15] of dword=(0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3,
			32*8+0, 32*8+1, 32*8+2, 32*8+3, 33*8+0, 33*8+1, 33*8+2, 33*8+3);
    ps_y:array[0..15] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16,
			8*16, 9*16, 10*16, 11*16, 12*16, 13*16, 14*16, 15*16);
    pt_x:array[0..15] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			16*8+0, 16*8+1, 16*8+2, 16*8+3, 16*8+4, 16*8+5, 16*8+6, 16*8+7);
    pt_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8);
begin
iniciar_gng:=false;
iniciar_audio(false);
//principal
p_final[0].x:=256;
p_final[0].y:=224;
//Background
p_final[1].x:=512;
p_final[1].y:=512;
p_final[1].scroll.long_x:=512;
p_final[1].scroll.long_y:=512;
p_final[1].scroll.max_x:=256;
p_final[1].scroll.max_y:=256;
p_final[1].scroll.mask_x:=511;
p_final[1].scroll.mask_y:=511;
//Foreground
p_final[2].x:=512;
p_final[2].y:=512;
p_final[2].trans:=true;
p_final[2].scroll:=p_final[1].scroll;
//Chars
p_final[3].x:=256;
p_final[3].y:=256;
p_final[3].trans:=true;
//Final
p_final[4].x:=512;
p_final[4].y:=256;
p_final[4].final_mix:=true;
iniciar_video;
//Main CPU
init_cpu(m6809_main,0,1500000/256);
main_6809_ll.getbyte:=gng_getbyte;
main_6809_ll.putbyte:=gng_putbyte;
//Sound CPU
init_cpu(z80_snd,1,3000000/256);
snd_z80_ll.getbyte:=sound_getbyte;
snd_z80_ll.putbyte:=sound_putbyte;
//IRQ Sound CPU
init_timer(1,3000000/(4*60),gng_snd_irq,true);
//Sound Chip
ym2203_Init(0,1,1500000,3000000,4,nil,nil,nil,nil,nil);
ym2203_Init(1,1,1500000,3000000,4,nil,nil,nil,nil,nil);
init_sound_engine(1,3000000,sound_instruccion);
//cargar roms
if not(cargar_roms(@memoria_temp[0],@gng_rom[0],'gng.zip',0)) then exit;
//Pongo las ROMs en su banco
copymemory(@memoria[$8000],@memoria_temp[$8000],$8000);
for f:=0 to 3 do copymemory(@memoria_rom[f,0],@memoria_temp[$10000+(f*$2000)],$2000);
copymemory(@memoria[$6000],@memoria_temp[$6000],$2000);
copymemory(@memoria_rom[4,0],@memoria_temp[$4000],$2000);
//Cargar Sound
if not(cargar_roms(@mem_snd[0],@gng_sound,'gng.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@gng_char,'gng.zip',1)) then exit;
init_gfx(0,8,8,1024);
gfx[0].trans[3]:=true;
gfx[0].trans_alt[0,3]:=true;
des_gfx.pos_planos[0]:=4;
des_gfx.pos_planos[1]:=0;
des_gfx.bit_pixel:=2;
des_gfx.banks:=0;
des_gfx.long_sprites:=16*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//sprites
if not(cargar_roms(@memoria_temp[0],@gng_sprites[0],'gng.zip',0)) then exit;
init_gfx(1,16,16,1024);
gfx[1].trans[15]:=true;
des_gfx.pos_planos[0]:=$c000*8+4;
des_gfx.pos_planos[1]:=$c000*8+0;
des_gfx.pos_planos[2]:=4;
des_gfx.pos_planos[3]:=0;
des_gfx.bit_pixel:=4;
des_gfx.long_sprites:=64*8;
convert_gfx(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//tiles
if not(cargar_roms(@memoria_temp[0],@gng_tiles[0],'gng.zip',0)) then exit;
init_gfx(2,16,16,1024);
gfx[2].trans[0]:=true;
gfx[2].trans[6]:=true;
gfx[2].trans_alt[0,0]:=true;
gfx[2].trans_alt[0,6]:=true;
des_gfx.pos_planos[0]:=$10000*8;
des_gfx.pos_planos[1]:=$8000*8;
des_gfx.pos_planos[2]:=0;
des_gfx.bit_pixel:=3;
des_gfx.long_sprites:=32*8;
convert_gfx(@gfx[2],0,@memoria_temp[0],@pt_x[0],@pt_y[0],false,false);
//Poner colores aleatorios hasta que inicie la paleta
for f:=0 to 255 do begin
  colores[f].r:=random(256);
  colores[f].g:=random(256);
  colores[f].b:=random(256);
end;
set_pal(colores,256);
//Dip
marcade.dswa:=$df;
marcade.dswb:=$7b;
marcade.dswa_val:=@gng_dip_a;
marcade.dswb_val:=@gng_dip_b;
//final
reset_gng;
iniciar_gng:=true;
end;

procedure cerrar_gng;
begin
cerrar_cpus;
YM2203_close(0);
YM2203_close(1);
close_audio;
close_video;
end;

procedure reset_gng;
begin
 reset_6809(main_6809,main_6809_ll);
 reset_z80(snd_z80);
 ym2203_reset(0);
 ym2203_reset(1);
 reset_audio;
 banco:=0;
 marcade.in0:=$FF;
 marcade.in1:=$FF;
 soundlatch:=0;
 scroll_x:=0;
 scroll_y:=0;
end;

procedure update_video_gng;inline;
var
  x,y,f,color,nchar:word;
  atrib:byte;
  flip_x,flip_y:boolean;
begin
//background y foreground
for f:=$0 to $3ff do begin
    atrib:=memoria[$2c00+f];
    color:=atrib and $7;
    if ((gfx[2].buffer[f]) or (gfx[2].color_buffer[color])) then begin
      x:=(f shr 5) shl 4;
      y:=(f and $1f) shl 4;
      nchar:=memoria[$2800+f]+(atrib and $c0) shl 2;
      flip_x:=(atrib and $10)<>0;
      flip_y:=(atrib and $20)<>0;
      put_gfx_flip(x,y,nchar,color shl 3,1,2,flip_x,flip_y);
      if (atrib and 8)=0 then put_gfx_block_trans(x,y,2,16,16)
        else put_gfx_trans_flip(x,y,nchar,color shl 3,2,2,flip_x,flip_y);
      gfx[2].buffer[f]:=false;
    end;
    //chars
    atrib:=memoria[$2400+f];
    color:=atrib and $f;
    if ((gfx[0].buffer[f]) or (gfx[0].color_buffer[color])) then begin
      y:=(f shr 5) shl 3;
      x:=(f and $1f) shl 3;
      nchar:=memoria[$2000+f]+((atrib and $c0) shl 2);
      put_gfx_trans(x,y,nchar,(color shl 2)+$80,3,0);
      gfx[0].buffer[f]:=false;
    end;
end;
fillchar(gfx[0].color_buffer[0],$10,0);
fillchar(gfx[2].color_buffer[0],$8,0);
//scroll del fondo
scroll_x_y(1,4,scroll_x,scroll_y);
//sprites
for f:=$7f downto 0 do begin
  atrib:=buffer_sprites[(f shl 2)+1];
  nchar:=buffer_sprites[f shl 2]+((atrib shl 2) and $300);
  color:=(atrib and $30)+64;
  x:=buffer_sprites[$3+(f shl 2)]+((atrib and $1) shl 8);
  y:=buffer_sprites[$2+(f shl 2)];
  put_gfx_sprite(nchar,color,(atrib and 4)<>0,(atrib and 8)<>0,1);
  actualiza_gfx_sprite_over(x,y,4,1,2,scroll_x,scroll_y);
end;
//chars
actualiza_trozo(0,0,256,256,3,0,0,256,256,4);
actualiza_trozo_final(0,16,256,224,4);
//Actualiza buffer sprites
copymemory(@buffer_sprites[0],@memoria[$1e00],$200);
end;

procedure eventos_gng;
begin
if event.arcade then begin
  if arcade_input.up[0] then marcade.in1:=(marcade.in1 and $f7) else marcade.in1:=(marcade.in1 or $8);
  if arcade_input.down[0] then marcade.in1:=(marcade.in1 and $fb) else marcade.in1:=(marcade.in1 or $4);
  if arcade_input.left[0] then marcade.in1:=(marcade.in1 and $fd) else marcade.in1:=(marcade.in1 or $2);
  if arcade_input.right[0] then marcade.in1:=(marcade.in1 and $fe) else marcade.in1:=(marcade.in1 or $1);
  if arcade_input.but0[0] then marcade.in1:=(marcade.in1 and $df) else marcade.in1:=(marcade.in1 or $20);
  if arcade_input.but1[0] then marcade.in1:=(marcade.in1 and $ef) else marcade.in1:=(marcade.in1 or $10);
  if arcade_input.coin[0] then marcade.in0:=(marcade.in0 and $bf) else marcade.in0:=(marcade.in0 or $40);
  if arcade_input.coin[1] then marcade.in0:=(marcade.in0 and $7f) else marcade.in0:=(marcade.in0 or $80);
  if arcade_input.start[0] then marcade.in0:=(marcade.in0 and $fe) else marcade.in0:=(marcade.in0 or 1);
  if arcade_input.start[1] then marcade.in0:=(marcade.in0 and $fd) else marcade.in0:=(marcade.in0 or 2);
end;
end;

procedure gng_principal;
var
  f:byte;
  frame_m,frame_s:single;
begin
init_controls(false,false,false,true);
frame_m:=main_6809.tframes;
frame_s:=snd_z80.tframes;
while EmuStatus=EsRuning do begin
  for f:=0 to 255 do begin
    //Main CPU
    run_6809(main_6809,main_6809_ll,trunc(frame_m));
    frame_m:=frame_m+main_6809.tframes-main_6809.contador;
    //Sound CPU
    run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
    frame_s:=frame_s+snd_z80.tframes-snd_z80.contador;
    if (f=239) then begin
             update_video_gng;
             main_6809.pedir_irq:=HOLD_LINE;
    end;
  end;
  eventos_gng;
  video_sync;
end;
end;

procedure cambiar_color(pos:word);inline;
var
  tmp_color:byte;
  color:tcolor;
begin
  tmp_color:=buffer_paleta[pos];
  color.r:=pal4bit(tmp_color shr 4);
  color.g:=pal4bit(tmp_color);
  tmp_color:=buffer_paleta[$100+pos];
  color.b:=pal4bit(tmp_color shr 4);
  set_pal_color(color,addr(paleta[pos]));
  case pos of
    0..$3f:gfx[2].color_buffer[pos shr 3]:=true;
    $80..$ff:gfx[0].color_buffer[(pos shr 2) and $f]:=true;
  end;
end;

function gng_getbyte(direccion:word):byte;
begin
case direccion of
  $0..$2fff,$6000..$ffff:gng_getbyte:=memoria[direccion];
  $3000:gng_getbyte:=marcade.in0;
  $3001:gng_getbyte:=marcade.in1;
  $3002:gng_getbyte:=$ff;  //cocktail!
  $3003:gng_getbyte:=marcade.dswa;
  $3004:gng_getbyte:=marcade.dswb;
  $4000..$5fff:gng_getbyte:=memoria_rom[banco,direccion and $1FFF];
end;
end;

procedure gng_putbyte(direccion:word;valor:byte);
begin
if direccion>$3fff then exit;
memoria[direccion]:=valor;
case direccion of
  $2000..$27ff:gfx[0].buffer[direccion and $3ff]:=true;
  $2800..$2fff:gfx[2].buffer[direccion and $3ff]:=true;
  $3800..$39ff:if buffer_paleta[direccion and $1ff]<>valor then begin
                  buffer_paleta[direccion and $1ff]:=valor;
                  cambiar_color(direccion and $ff);
               end;
  $3a00:soundlatch:=valor;
  $3b08:scroll_x:=(scroll_x and $100) or valor;
  $3b09:scroll_x:=(scroll_x and $ff) or ((valor and 1) shl 8);
  $3b0a:scroll_y:=(scroll_y and $100) or valor;
  $3b0b:scroll_y:=(scroll_y and $ff) or ((valor and 1) shl 8);
  $3d00:main_screen.flip_main_screen:=(valor and 1)=0;
  $3e00:banco:=valor and 7;
end;
end;

function sound_getbyte(direccion:word):byte;
begin
if direccion=$c800 then sound_getbyte:=soundlatch
  else sound_getbyte:=mem_snd[direccion];
end;

procedure sound_putbyte(direccion:word;valor:byte);
begin
if direccion<$8000 then exit;
mem_snd[direccion]:=valor;
case direccion of
  $e000:ym2203_Control(0,valor);
  $e001:ym2203_Write_Reg(0,valor);
  $e002:ym2203_Control(1,valor);
  $e003:ym2203_Write_Reg(1,valor);
end;
end;

procedure sound_instruccion;
begin
  ym2203_Update(0);
  ym2203_Update(1);
end;

procedure gng_snd_irq;
begin
  snd_z80.pedir_irq:=HOLD_LINE;
end;

end.
