unit greenberet_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     z80,main_engine,controls_engine,sn_76496,gfx_engine,timer_engine,
     rom_engine,cpu_engine,file_engine,pal_engine,sound_engine;

procedure Cargar_gberet;
procedure gberet_principal;
procedure reset_gberet;
procedure cerrar_gberet;
//Main CPU
function gberet_getbyte(direccion:word): Byte;
procedure gberet_putbyte(direccion:word;valor:byte);
function iniciar_gberet:boolean;
procedure gberet_despues_instruccion;
procedure gberet_hi_score;

const
        gberet_rom:array[0..3] of tipo_roms=(
        (n:'577l03.10c';l:$4000;p:0;crc:$ae29e4ff),(n:'577l02.8c';l:$4000;p:$4000;crc:$240836a5),
        (n:'577l01.7c';l:$4000;p:$8000;crc:$41fa3e1f),());
        gberet_pal:array[0..3] of tipo_roms=(
        (n:'577h09.2f';l:$20;p:0;crc:$c15e7c80),(n:'577h11.6f';l:$100;p:$20;crc:$2a1a992b),
        (n:'577h10.5f';l:$100;p:$120;crc:$e9de1e53),());
        gberet_char:tipo_roms=(n:'577l07.3f';l:$4000;p:0;crc:$4da7bd1b);
        gberet_sprites:array[0..4] of tipo_roms=(
        (n:'577l06.5e';l:$4000;p:0;crc:$0f1cb0ca),(n:'577l05.4e';l:$4000;p:$4000;crc:$523a8b66),
        (n:'577l08.4f';l:$4000;p:$8000;crc:$883933a4),(n:'577l04.3e';l:$4000;p:$c000;crc:$ccecda4c),());

var
 scroll_lineas:array[0..$1f] of parejas;
 interrupt_mask,interrupt_ticks,sound_latch:byte;
 banco_sprites:word;
 timer_hs:byte;

implementation
uses principal;

procedure Cargar_gberet;
begin
llamadas_maquina.iniciar:=iniciar_gberet;
llamadas_maquina.bucle_general:=gberet_principal;
llamadas_maquina.cerrar:=cerrar_gberet;
llamadas_maquina.reset:=reset_gberet;
llamadas_maquina.fps_max:=60.60606060;
end;

function iniciar_gberet:boolean;
var
      colores:tpaleta;
      f:word;
      ctemp1:byte;
      memoria_temp:array[0..$1ffff] of byte;
const
      pc_x:array[0..7] of dword=(0*4, 1*4, 2*4, 3*4, 4*4, 5*4, 6*4, 7*4);
      pc_y:array[0..7] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32);
      ps_x:array[0..15] of dword=(0*4, 1*4, 2*4, 3*4, 4*4, 5*4, 6*4, 7*4,
		32*8+0*4, 32*8+1*4, 32*8+2*4, 32*8+3*4, 32*8+4*4, 32*8+5*4, 32*8+6*4, 32*8+7*4);
      ps_y:array[0..15] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32,
		64*8+0*32, 64*8+1*32, 64*8+2*32, 64*8+3*32, 64*8+4*32, 64*8+5*32, 64*8+6*32, 64*8+7*32);
begin
iniciar_gberet:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=240;
p_final[0].y:=224;
p_final[1].x:=512;
p_final[1].y:=256;
p_final[1].scroll.long_x:=512;
p_final[1].scroll.max_x:=256;
p_final[1].scroll.mask_x:=511;
p_final[2].x:=512;
p_final[2].y:=256;
p_final[2].final_mix:=true;
iniciar_video;
//Main CPU
init_cpu(z80_main,0,3072000/256);
main_z80_ll.getbyte:=gberet_getbyte;
main_z80_ll.putbyte:=gberet_putbyte;
//Sound Chips
SN76496_init(0,1536000);
init_sound_engine(0,3072000,gberet_despues_instruccion);
//Timers
timer_hs:=init_timer(0,10000,gberet_hi_score,true);
//cargar roms
if not(cargar_roms(@memoria[0],@gberet_rom[0],'gberet.zip',0)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@gberet_char,'gberet.zip',1)) then exit;
init_gfx(0,8,8,512);
des_gfx.pos_planos[0]:=0;
des_gfx.pos_planos[1]:=1;
des_gfx.pos_planos[2]:=2;
des_gfx.pos_planos[3]:=3;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=32*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@gberet_sprites[0],'gberet.zip',0)) then exit;
init_gfx(1,16,16,512);
des_gfx.long_sprites:=128*8;
convert_gfx(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//poner la paleta
if not(cargar_roms(@memoria_temp[0],@gberet_pal[0],'gberet.zip',0)) then exit;
for f:=0 to 31 do begin
    ctemp1:=memoria_temp[f];
    colores[f].r:= $21*(ctemp1 and 1)+$47*((ctemp1 shr 1) and 1)+$97*((ctemp1 shr 2) and 1);
    colores[f].g:= $21*((ctemp1 shr 3) and 1)+$47*((ctemp1 shr 4) and 1)+$97*((ctemp1 shr 5) and 1);
    colores[f].b:= 0+$47*((ctemp1 shr 6) and 1)+$97*((ctemp1 shr 7) and 1);
end;
set_pal(colores,32);
//Poner el CLUT
for f:=0 to $FF do begin
  gfx[0].colores[f]:=memoria_temp[$20+f]+$10;
  gfx[1].colores[f]:=memoria_temp[$120+f] and $f;
end;
//final
reset_gberet;
iniciar_gberet:=true;
end;

procedure cerrar_gberet;
begin
save_hi('gberet.hi',@memoria[$d900],60);
cerrar_cpus;
SN76496_close(0);
close_audio;
close_video;
end;

procedure reset_gberet;
var
  f:byte;
begin
 reset_z80(main_z80);
 SN76496_reset(0);
 reset_audio;
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
 banco_sprites:=0;
 interrupt_mask:=0;
 interrupt_ticks:=0;
 sound_latch:=0;
 for f:=0 to $1f do scroll_lineas[f].w:=0;
end;

procedure update_video_gberet;inline;
var
  f,x,y,color,nchar,atrib2:word;
  atrib:byte;
begin
for f:=$7FF downto 0 do begin
  if gfx[0].buffer[f] then begin
    x:=f mod 64;
    y:=f div 64;
    //Color RAM
    //c000-c7ff --> Bits
    // 0-3 --> Color
    // 4 --> flip X
    // 5 --> Flip Y
    // 6 --> Numero Char
    atrib:=memoria[f+$c000];
    color:=(atrib and $f) shl 4;
    nchar:=memoria[f+$c800]+((atrib and $40) shl 2);
    put_gfx_flip(x*8,y*8,nchar,color,1,0,(atrib and $10)<>0,(atrib and $20)<>0);
    gfx[0].buffer[f]:=false;
  end;
end;
//hacer el scroll independiente linea a linea
for f:=0 to 31 do scroll__x_part(1,2,scroll_lineas[f].w,0,f*8,8);
//sprites
for f:=0 to $3F do begin
  atrib2:=$d000+banco_sprites+(f*4);
  atrib:=memoria[$1+atrib2];
  nchar:=memoria[atrib2]+(atrib and $40) shl 2;
  color:=(atrib and $f) shl 4;
  x:=(memoria[$2+atrib2]+(atrib and $80) shl 1);
  y:=memoria[$3+atrib2];
  put_gfx_sprite_mask(nchar,color,(atrib and $10)<>0,(atrib and $20)<>0,1,0,$f);
  actualiza_gfx_sprite(x,y,2,1);
end;
actualiza_trozo_final(8,16,240,224,2);
end;

procedure eventos_gberet;
begin
if event.arcade then begin
  if arcade_input.left[0] then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if arcade_input.down[0] then in0:=(in0 and $F7) else in0:=(in0 or $8);
  if arcade_input.right[0] then in0:=(in0 and $fd) else in0:=(in0 or $2);
  if arcade_input.up[0] then in0:=(in0 and $Fb) else in0:=(in0 or $4);
  if arcade_input.but0[0] then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if arcade_input.but1[0] then in0:=(in0 and $df) else in0:=(in0 or $20);
  if arcade_input.coin[0] then in2:=(in2 and $fe) else in2:=(in2 or $1);
  if arcade_input.coin[1] then in2:=(in2 and $fd) else in2:=(in2 or $2);
  if arcade_input.start[0] then in2:=(in2 and $f7) else in2:=(in2 or $8);
  if arcade_input.start[1] then in2:=(in2 and $ef) else in2:=(in2 or $10);
end;
end;

procedure gberet_principal;
var
  f,ticks_mask:byte;
  frame_m:single;
begin
init_controls(false,false,false,true);
frame_m:=main_z80.tframes;
while EmuStatus=EsRuning do begin
  for f:=0 to 255 do begin
    run_z80(main_z80,main_z80_ll,trunc(frame_m));
    frame_m:=frame_m+main_z80.tframes-main_z80.contador;
    if f=239 then update_video_gberet;
    if (f and $f)=0 then begin //every 16 scanlines
       ticks_mask:=not(interrupt_ticks) and (interrupt_ticks+1); // 0->1
	     interrupt_ticks:=interrupt_ticks+1;
	     // NMI on d0
	    if (ticks_mask and interrupt_mask and 1)<>0 then main_z80.pedir_nmi:=ASSERT_LINE;
	    // IRQ on d4
	    if (ticks_mask and (interrupt_mask shl 2) and 16)<>0 then main_z80.pedir_irq:=ASSERT_LINE;
    end;
  end;
  eventos_gberet;
  video_sync;
end;
end;

function gberet_getbyte(direccion:word):byte;
begin
case direccion of
  $0000..$e03f:gberet_getbyte:=memoria[direccion];
  $f200:gberet_getbyte:=$4a;
  $f600:gberet_getbyte:=$ff;
  $f601:gberet_getbyte:=in1;
  $f602:gberet_getbyte:=in0;
  $f603:gberet_getbyte:=in2;
end;
end;

procedure gberet_putbyte(direccion:word;valor:byte);
var
  ack_mask:byte;
begin
if direccion<$c000 then exit;
memoria[direccion]:=valor;
case direccion of
        $c000..$cfff:gfx[0].buffer[direccion and $7ff]:=true;
        $e000..$e01f:scroll_lineas[direccion and $1f].l:=valor;
        $e020..$e03f:scroll_lineas[direccion and $1f].h:=valor and 1;
        $e043:banco_sprites:=(valor and 8) shr 4;
        $e044:begin
                // bits 0/1/2 = interrupt enable
	              ack_mask:=not(valor) and interrupt_mask; // 1->0
	              if (ack_mask and 1)<>0 then clear_nmi_z80(main_z80);
                if (ack_mask and 6)<>0 then main_z80.pedir_irq:=CLEAR_LINE;
	              interrupt_mask:=valor and 7;
	              // bit 3 = flip screen
                main_screen.flip_main_screen:=(valor and 8)=0;
              end;
        $f200:sound_latch:=valor;
        $f400:SN76496_Write(0,sound_latch);
end;
end;

procedure gberet_despues_instruccion;
begin
  SN76496_Update(0);
end;

procedure gberet_hi_score;
begin
if ((memoria[$db06]=3) and (memoria[$db07]=$30) and (memoria[$db08]=0) and (memoria[$db0b]=$1c)) then begin
    load_hi('gberet.hi',@memoria[$d900],60);
    copymemory(@memoria[$db06],@memoria[$d900],3);
    timer[timer_hs].enabled:=false;
  end;
end;

end.
