unit hw_1942;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     z80,main_engine,controls_engine,gfx_engine,timer_engine,ay_8910,
     rom_engine,cpu_engine,pal_engine,sound_engine;

procedure Cargar_hw1942;
procedure hw1942_principal;
function iniciar_hw1942:boolean;
procedure reset_hw1942;
procedure cerrar_hw1942;
//Main CPU
function hw1942_getbyte(direccion:word): Byte;
procedure hw1942_putbyte(direccion:word;valor:byte);
//SND CPU
function hw1942_snd_getbyte(direccion:word): Byte;
procedure hw1942_snd_putbyte(direccion:word;valor:byte);
procedure hw1942_snd_irq;
procedure hw1942_despues_instruccion;

const
        hw1942_rom:array[0..5] of tipo_roms=(
        (n:'srb-03.m3';l:$4000;p:0;crc:$d9dafcc3),(n:'srb-04.m4';l:$4000;p:$4000;crc:$da0cf924),
        (n:'srb-05.m5';l:$4000;p:$8000;crc:$d102911c),(n:'srb-06.m6';l:$2000;p:$c000;crc:$466f8248),
        (n:'srb-07.m7';l:$4000;p:$10000;crc:$0d31038c),());
        hw1942_snd_rom:tipo_roms=(n:'sr-01.c11';l:$4000;p:0;crc:$bd87f06b);
        hw1942_pal:array[0..6] of tipo_roms=(
        (n:'sb-5.e8';l:$100;p:0;crc:$93ab8153),(n:'sb-6.e9';l:$100;p:$100;crc:$8ab44f7d),
        (n:'sb-7.e10';l:$100;p:$200;crc:$f4ade9a4),(n:'sb-0.f1';l:$100;p:$300;crc:$6047d91b),
        (n:'sb-4.d6';l:$100;p:$400;crc:$4858968d),(n:'sb-8.k3';l:$100;p:$500;crc:$f6fad943),());
        hw1942_char:tipo_roms=(n:'sr-02.f2';l:$2000;p:0;crc:$6ebca191);
        hw1942_tiles:array[0..6] of tipo_roms=(
        (n:'sr-08.a1';l:$2000;p:0;crc:$3884d9eb),(n:'sr-09.a2';l:$2000;p:$2000;crc:$999cf6e0),
        (n:'sr-10.a3';l:$2000;p:$4000;crc:$8edb273a),(n:'sr-11.a4';l:$2000;p:$6000;crc:$3a2726c3),
        (n:'sr-12.a5';l:$2000;p:$8000;crc:$1bd3d8bb),(n:'sr-13.a6';l:$2000;p:$a000;crc:$658f02c4),());
        hw1942_sprites:array[0..4] of tipo_roms=(
        (n:'sr-14.l1';l:$4000;p:0;crc:$2528bec6),(n:'sr-15.l2';l:$4000;p:$4000;crc:$f89287aa),
        (n:'sr-16.n1';l:$4000;p:$8000;crc:$024418f8),(n:'sr-17.n2';l:$4000;p:$c000;crc:$e2c7e489),());

var
 memoria_rom:array[0..2,0..$3fff] of byte;
 scroll:word;
 sound_command,rom_bank,palette_bank:byte;

implementation
uses principal;

procedure Cargar_hw1942;
begin
llamadas_maquina.iniciar:=iniciar_hw1942;
llamadas_maquina.bucle_general:=hw1942_principal;
llamadas_maquina.cerrar:=cerrar_hw1942;
llamadas_maquina.reset:=reset_hw1942;
end;

function iniciar_hw1942:boolean;
var
      colores:tpaleta;
      f:word;
      memoria_temp:array[0..$17fff] of byte;
const
    pc_x:array[0..7] of dword=(0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3);
    pc_y:array[0..7] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16);
    ps_x:array[0..15] of dword=(0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3,
			16*16+0, 16*16+1, 16*16+2, 16*16+3, 16*16+8+0, 16*16+8+1, 16*16+8+2, 16*16+8+3);
    ps_y:array[0..15] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16,
			8*16, 9*16, 10*16, 11*16, 12*16, 13*16, 14*16, 15*16);
    pt_x:array[0..15] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			16*8+0, 16*8+1, 16*8+2, 16*8+3, 16*8+4, 16*8+5, 16*8+6, 16*8+7);
    pt_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8);
begin
iniciar_hw1942:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=224;
p_final[0].y:=256;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[1].final_mix:=true;
p_final[2].x:=256;
p_final[2].y:=512;
p_final[2].scroll.long_y:=512;
p_final[2].scroll.max_y:=256;
p_final[2].scroll.mask_y:=511;
p_final[3].x:=256;
p_final[3].y:=256;
p_final[3].trans:=true;
iniciar_video;
//Main CPU
init_cpu(z80_main,0,4000000/$100);
main_z80_ll.getbyte:=hw1942_getbyte;
main_z80_ll.putbyte:=hw1942_putbyte;
//Sound CPU
init_cpu(z80_snd,1,3000000/$100);
snd_z80_ll.getbyte:=hw1942_snd_getbyte;
snd_z80_ll.putbyte:=hw1942_snd_putbyte;
//Sound Chips
AY8910_init(1500000,0,1,nil,nil,nil,nil);
AY8910_init(1500000,1,1,nil,nil,nil,nil);
init_sound_engine(1,3000000,hw1942_despues_instruccion);
//IRQ Sound CPU
init_timer(1,3000000/(4*60),hw1942_snd_irq,true);
//cargar roms y ponerlas en su sitio
if not(cargar_roms(@memoria_temp[0],@hw1942_rom[0],'1942.zip',0)) then exit;
copymemory(@memoria[0],@memoria_temp[0],$8000);
for f:=0 to 2 do copymemory(@memoria_rom[f,0],@memoria_temp[$8000+(f*$4000)],$4000);
//cargar ROMS sonido
if not(cargar_roms(@mem_snd[0],@hw1942_snd_rom,'1942.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@hw1942_char,'1942.zip',1)) then exit;
init_gfx(0,8,8,$200);
gfx[0].trans[0]:=true;
des_gfx.pos_planos[0]:=4;
des_gfx.pos_planos[1]:=0;
des_gfx.bit_pixel:=2;
des_gfx.banks:=0;
des_gfx.long_sprites:=16*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,true);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@hw1942_sprites[0],'1942.zip',0)) then exit;
init_gfx(1,16,16,$200);
gfx[1].trans[15]:=true;
des_gfx.pos_planos[0]:=512*64*8+4;
des_gfx.pos_planos[1]:=512*64*8+0;
des_gfx.pos_planos[2]:=4;
des_gfx.pos_planos[3]:=0;
des_gfx.bit_pixel:=4;
des_gfx.long_sprites:=64*8;
convert_gfx(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,true);
//tiles
if not(cargar_roms(@memoria_temp[0],@hw1942_tiles[0],'1942.zip',0)) then exit;
init_gfx(2,16,16,$200);
des_gfx.pos_planos[0]:=0;
des_gfx.pos_planos[1]:=$4000*8;
des_gfx.pos_planos[2]:=$4000*8*2;
des_gfx.bit_pixel:=3;
des_gfx.long_sprites:=32*8;
convert_gfx(@gfx[2],0,@memoria_temp[0],@pt_x[0],@pt_y[0],false,true);
//poner la paleta
if not(cargar_roms(@memoria_temp[0],@hw1942_pal[0],'1942.zip',0)) then exit;
for f:=0 to 255 do begin
    colores[f].r:=((memoria_temp[f] and $f) shl 4) or (memoria_temp[f] and $f);
    colores[f].g:=((memoria_temp[f+$100] and $f) shl 4) or (memoria_temp[f+$100] and $f);
    colores[f].b:=((memoria_temp[f+$200] and $f) shl 4) or (memoria_temp[f+$200] and $f);
end;
set_pal(colores,256);
for f:=0 to $ff do begin
  gfx[0].colores[f]:=memoria_temp[$300+f]+$80;  //chars
  gfx[2].colores[f]:=memoria_temp[$400+f];  //tiles
  gfx[2].colores[f+$100]:=memoria_temp[$400+f]+$10;
  gfx[2].colores[f+$200]:=memoria_temp[$400+f]+$20;
  gfx[2].colores[f+$300]:=memoria_temp[$400+f]+$30;
  gfx[1].colores[f]:=memoria_temp[$500+f]+$40;  //sprites
end;
//final
reset_hw1942;
iniciar_hw1942:=true;
end;

procedure cerrar_hw1942;
begin
cerrar_cpus;
ay8910_close(0);
ay8910_close(1);
close_audio;
close_video;
end;

procedure reset_hw1942;
begin
 reset_z80(main_z80);
 reset_z80(snd_z80);
 ay8910_reset(0);
 ay8910_reset(1);
 reset_audio;
 in0:=$FF;
 in1:=$FF;
 scroll:=0;
 rom_bank:=0;
 palette_bank:=0;
 sound_command:=0;
end;

procedure draw_sprites;inline;
var
  f,color,nchar:word;
  x,y:word;
  i,h,atrib:byte;
begin
	for f:=$1f downto 0 do begin
    atrib:=memoria[$cc01+(f*4)];
		nchar:=(memoria[$cc00+(f*4)] and $7f)+(atrib and $20) shl 2+(memoria[$cc00+(f*4)] and $80) shl 1;
		color:=(atrib and $0f) shl 4;
		x:=240-(memoria[$cc03+(f*4)]-$10*(atrib and $10));
		y:=memoria[$cc02+(f*4)];
		// handle double or quadruple height
		i:=(atrib and $c0) shr 6;
		if (i=2) then i:=3;
		for h:=0 to i do begin
      put_gfx_sprite(nchar+h,color,false,false,1);
      actualiza_gfx_sprite(y+16*h,x,1,1);
    end;
  end;
end;

procedure update_video_hw1942;inline;
var
        f,color,nchar,pos:word;
        x,y:word;
        attr:byte;
begin
for f:=0 to $1ff do begin
  //tiles
  if gfx[2].buffer[f] then begin
      x:=f and $f;
      y:=31-(f shr 4);
      pos:=x+((f and $1f0) shl 1);
      attr:=memoria[$d810+pos];
      nchar:=memoria[$d800+pos]+((attr and $80) shl 1);
      color:=((attr and $1f)+(palette_bank*$20)) shl 3;
      put_gfx_flip(x*16,y*16,nchar,color,2,2,(attr and $40)<>0,(attr and $20)<>0);
      gfx[2].buffer[f]:=false;
  end;
end;
for f:=0 to $3ff do begin
  //Chars
  if gfx[0].buffer[f] then begin
    x:=f div 32;
    y:=31-(f mod 32);
    attr:=memoria[f+$d400];
    color:=(attr and $3f) shl 2;
    nchar:=memoria[f+$d000]+((attr and $80) shl 1);
    put_gfx_trans(x*8,y*8,nchar,color,3,0);
    gfx[0].buffer[f]:=false;
  end;
end;
scroll__y(2,1,256-scroll);
draw_sprites;
actualiza_trozo(0,0,256,256,3,0,0,256,256,1);
actualiza_trozo_final(16,0,224,256,1);
end;

procedure eventos_hw1942;
begin
if event.arcade then begin
  if arcade_input.left[0] then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if arcade_input.right[0] then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if arcade_input.up[0] then in1:=(in1 and $F7) else in1:=(in1 or $8);
  if arcade_input.but0[0] then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if arcade_input.but1[0] then in1:=(in1 and $df) else in1:=(in1 or $20);
  if arcade_input.down[0] then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if arcade_input.start[0] then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if arcade_input.start[1] then in0:=(in0 and $fd) else in0:=(in0 or $2);
  if arcade_input.coin[1] then in0:=(in0 and $bf) else in0:=(in0 or $40);
  if arcade_input.coin[0] then in0:=(in0 and $7f) else in0:=(in0 or $80);
end;
end;

procedure hw1942_principal; 
var
  f:byte;
  frame_m,frame_s:single;
begin
init_controls(false,false,false,true);
frame_m:=main_z80.tframes;
frame_s:=snd_z80.tframes;
while EmuStatus=EsRuning do begin
  for f:=0 to $ff do begin
    //Main
    run_z80(main_z80,main_z80_ll,trunc(frame_m));
    frame_m:=frame_m+main_z80.tframes-main_z80.contador;
    //Sound
    run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
    frame_s:=frame_s+snd_z80.tframes-snd_z80.contador;
    case f of
      239:begin //rst 10
          main_z80.im0:=$d7;
          main_z80.pedir_irq:=HOLD_LINE;
          update_video_hw1942;
        end;
      $ff:begin //rst 8
          main_z80.im0:=$cf;
          main_z80.pedir_irq:=HOLD_LINE;
        end;
    end;
  end;
  eventos_hw1942;
  video_sync;
end;
end;

function hw1942_getbyte(direccion:word):byte;
begin
case direccion of
  $0..$7fff,$cc00..$cc7f,$d000..$dbff,$e000..$efff:hw1942_getbyte:=memoria[direccion];
  $8000..$bfff:hw1942_getbyte:=memoria_rom[rom_bank,direccion and $3fff];
  $c000:hw1942_getbyte:=in0;
  $c001:hw1942_getbyte:=in1;
  $c002:hw1942_getbyte:=$ff;
  $c003:hw1942_getbyte:=$77;
  $c004:hw1942_getbyte:=$ff;
end;
end;

procedure hw1942_putbyte(direccion:word;valor:byte);
begin
if direccion<$c000 then exit;
memoria[direccion]:=valor;
case direccion of
        $c800:sound_command:=valor;
        $c802:scroll:=valor or (scroll and $100);
        $c803:scroll:=((valor and $1) shl 8) or (scroll and $ff);
        $c804:if (valor and $10)<>0 then snd_z80.enabled:=false
                else begin
                  if not(snd_z80.enabled) then begin
                    reset_z80(snd_z80);
                    snd_z80.enabled:=true;
                  end;
                end;
        $c805:palette_bank:=valor;
        $c806:rom_bank:=valor and $3;
        $d000..$d7ff:gfx[0].buffer[direccion and $3ff]:=true;
        $d800..$dbff:gfx[2].buffer[(direccion and $f)+((direccion and $3e0) shr 1)]:=true;
end;
end;

function hw1942_snd_getbyte(direccion:word):byte;
begin
if direccion=$6000 then hw1942_snd_getbyte:=sound_command
 else hw1942_snd_getbyte:=mem_snd[direccion];
end;

procedure hw1942_snd_putbyte(direccion:word;valor:byte);
begin
if direccion<$4000 then exit;
mem_snd[direccion]:=valor;
case direccion of
        $8000:AY8910_Control(valor,0);
        $8001:AY8910_Write(valor,0);
        $c000:AY8910_Control(valor,1);
        $c001:AY8910_Write(valor,1);
end;
end;

procedure hw1942_snd_irq;
begin
  snd_z80.pedir_irq:=HOLD_LINE;
end;

procedure hw1942_despues_instruccion;
begin
  ay8910_update(0);
  ay8910_update(1);
end;

end.
