unit knucklejoe_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     z80,m680x,main_engine,controls_engine,ay_8910,gfx_engine,timer_engine,
     sn_76496,rom_engine,cpu_engine,pal_engine,sound_engine;

procedure Cargar_knjoe;
procedure reset_knjoe; 
procedure cerrar_knjoe; 
function iniciar_knjoe:boolean; 
procedure knjoe_principal; 
function knjoe_getbyte(direccion:word): Byte;  
procedure knjoe_putbyte(direccion:word;valor:byte); 
//sound
function snd_getbyte(direccion:word): Byte;  
procedure snd_putbyte(direccion:word;valor:byte); 
procedure out_port1(valor:byte); 
procedure out_port2(valor:byte); 
function in_port1:Byte;  
function in_port2:Byte;  
function ay0_porta_r:byte;
procedure knjoe_sonido;
procedure knjoe_snd_nmi; 

const
        knjoe_rom:array[0..3] of tipo_roms=(
        (n:'kj-1.bin';l:$4000;p:0;crc:$4e4f5ff2),(n:'kj-2.bin';l:$4000;p:$4000;crc:$cb11514b),
        (n:'kj-3.bin';l:$4000;p:$8000;crc:$0f50697b),());
        knjoe_pal:array[0..5] of tipo_roms=(
        (n:'kjclr1.bin';l:$100;p:0;crc:$c3378ac2),(n:'kjclr2.bin';l:$100;p:$100;crc:$2126da97),
        (n:'kjclr3.bin';l:$100;p:$200;crc:$fde62164),(n:'kjprom5.bin';l:$20;p:$300;crc:$5a81dd9f),
        (n:'kjprom4.bin';l:$100;p:$320;crc:$48dc2066),());
        knjoe_sprites:array[0..3] of tipo_roms=(
        (n:'kj-4.bin';l:$8000;p:0;crc:$a499ea10),(n:'kj-6.bin';l:$8000;p:$8000;crc:$815f5c0a),
        (n:'kj-5.bin';l:$8000;p:$10000;crc:$11111759),());
        knjoe_sprites2:array[0..3] of tipo_roms=(
        (n:'kj-7.bin';l:$4000;p:0;crc:$121fcccb),(n:'kj-9.bin';l:$4000;p:$4000;crc:$affbe3eb),
        (n:'kj-8.bin';l:$4000;p:$8000;crc:$e057e72a),());
        knjoe_tiles:array[0..3] of tipo_roms=(
        (n:'kj-10.bin';l:$4000;p:0;crc:$74d3ba33),(n:'kj-11.bin';l:$4000;p:$4000;crc:$8ea01455),
        (n:'kj-12.bin';l:$4000;p:$8000;crc:$33367c41),());
        knjoe_sound:tipo_roms=(n:'kj-13.bin';l:$2000;p:$6000;crc:$0a0be3f5);

var
 sound_command,val_port1,val_port2:byte;
 scroll_x,scroll_y:parejas;
 tile_bank,sprite_bank:byte;

implementation
uses principal;

procedure Cargar_knjoe;
begin
llamadas_maquina.iniciar:=iniciar_knjoe;
llamadas_maquina.bucle_general:=knjoe_principal;
llamadas_maquina.cerrar:=cerrar_knjoe;
llamadas_maquina.reset:=reset_knjoe;
llamadas_maquina.fps_max:=55;
end;

function iniciar_knjoe:boolean; 
var
      f:word;
      colores:tpaleta;
      ctemp1,ctemp2,ctemp3:byte;
      memoria_temp:array[0..$17fff] of byte;
const
  ps_x:array[0..15] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			8*8+0, 8*8+1, 8*8+2, 8*8+3, 8*8+4, 8*8+5, 8*8+6, 8*8+7 );
  ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			16*8, 17*8, 18*8, 19*8, 20*8, 21*8, 22*8, 23*8);
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7);
  pc_y:array[0..7] of dword=(7*8, 6*8, 5*8, 4*8, 3*8, 2*8, 1*8, 0*8);
begin
iniciar_knjoe:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=240;
p_final[0].y:=256;
p_final[1].x:=512;
p_final[1].y:=256;
p_final[1].scroll.long_x:=512;
p_final[1].scroll.max_x:=256;
p_final[1].scroll.mask_x:=511;
p_final[2].x:=512;
p_final[2].y:=256;
p_final[2].sprite_end_x:=256;
p_final[2].sprite_mask_x:=$ff;
p_final[2].final_mix:=true;
iniciar_video;
//Main CPU
init_cpu(z80_main,0,6000000);
main_z80_ll.getbyte:=knjoe_getbyte;
main_z80_ll.putbyte:=knjoe_putbyte;
//Sound CPU
init_cpu(m6800_snd,1,3579545);
snd_6800_ll.getbyte:=snd_getbyte;
snd_6800_ll.putbyte:=snd_putbyte;
snd_6800_ll.out_port1:=out_port1;
snd_6800_ll.out_port2:=out_port2;
snd_6800_ll.in_port1:=in_port1;
snd_6800_ll.in_port2:=in_port2;
init_6800(CPU_M6803,snd_6800);
//sound chips
AY8910_init(3579545 div 4,0,1,ay0_porta_r,nil,nil,nil);
SN76496_init(0,3579545);
SN76496_init(1,3579545);
init_sound_engine(1,3579545/4,knjoe_sonido);
//Timers
init_timer(1,3579545/4/3970,knjoe_snd_nmi,true);
//cargar roms y ponerlas en sus bancos
if not(cargar_roms(@memoria[0],@knjoe_rom[0],'kncljoe.zip',0)) then exit;
//cargar sonido
if not(cargar_roms(@mem_snd[0],@knjoe_sound,'kncljoe.zip',1)) then exit;
//convertir tiles
if not(cargar_roms(@memoria_temp[0],@knjoe_tiles[0],'kncljoe.zip',0)) then exit;
init_gfx(0,8,8,$800);
des_gfx.pos_planos[0]:=2*$800*8*8;
des_gfx.pos_planos[1]:=$800*8*8;
des_gfx.pos_planos[2]:=0;
des_gfx.bit_pixel:=3;
des_gfx.banks:=0;
des_gfx.long_sprites:=8*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@knjoe_sprites[0],'kncljoe.zip',0)) then exit;
init_gfx(1,16,16,$400);
gfx[1].trans[0]:=true;
des_gfx.pos_planos[0]:=2*$400*32*8;
des_gfx.pos_planos[1]:=$400*32*8;
des_gfx.pos_planos[2]:=0;
des_gfx.bit_pixel:=3;
des_gfx.banks:=0;
des_gfx.long_sprites:=32*8;
convert_gfx(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//convertir sprites 2
if not(cargar_roms(@memoria_temp[0],@knjoe_sprites2[0],'kncljoe.zip',0)) then exit;
init_gfx(2,16,16,$200);
gfx[2].trans[0]:=true;
des_gfx.pos_planos[0]:=2*$200*32*8;
des_gfx.pos_planos[1]:=$200*32*8;
des_gfx.pos_planos[2]:=0;
des_gfx.bit_pixel:=3;
des_gfx.banks:=0;
des_gfx.long_sprites:=32*8;
convert_gfx(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//poner la paleta
if not(cargar_roms(@memoria_temp[0],@knjoe_pal[0],'kncljoe.zip',0)) then exit;
for f:=0 to $7f do begin
    colores[f].r:=((memoria_temp[f] and $f) shl 4) or (memoria_temp[f] and $f);
    colores[f].g:=((memoria_temp[f+$100] and $f) shl 4) or (memoria_temp[f+$100] and $f);
    colores[f].b:=((memoria_temp[f+$200] and $f) shl 4) or (memoria_temp[f+$200] and $f);
end;
for f:=0 to $f do begin
    //sprites
		ctemp1:=0;
		ctemp2:=(memoria_temp[f+$300] shr 6) and $01;
		ctemp3:=(memoria_temp[f+$300] shr 7) and $01;
		colores[$80+f].r:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
		ctemp1:=(memoria_temp[f+$300] shr 3) and $01;
		ctemp2:=(memoria_temp[f+$300] shr 4) and $01;
		ctemp3:=(memoria_temp[f+$300] shr 5) and $01;
    colores[$80+f].g:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
		ctemp1:=(memoria_temp[f+$300] shr 0) and $01;
		ctemp2:=(memoria_temp[f+$300] shr 1) and $01;
		ctemp3:=(memoria_temp[f+$300] shr 2) and $01;
    colores[$80+f].b:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
end;
set_pal(colores,$100);
//CLUT
for f:=0 to $7f do begin
  gfx[1].colores[f]:=(memoria_temp[f+$320] and $0f)+$80;
  gfx[2].colores[f]:=(memoria_temp[f+$320] and $0f)+$80;
end;
//final
reset_knjoe;
iniciar_knjoe:=true;
end;

procedure cerrar_knjoe;
begin
cerrar_cpus;
ay8910_close(0);
SN76496_close(0);
SN76496_close(1);
close_audio;
close_video;
end;

procedure reset_knjoe; 
begin
 reset_z80(main_z80);
 reset_6800(snd_6800,snd_6800_ll);
 AY8910_reset(0);
 SN76496_reset(0);
 SN76496_reset(1);
 reset_audio;
 in0:=$FF;
 in1:=$FF;
 sound_command:=0;
 val_port1:=0;
 val_port2:=0;
 tile_bank:=0;
 sprite_bank:=0;
 scroll_x.w:=0;
 scroll_y.w:=0;
end;

procedure update_video_knjoe;inline;
const
  pribase:array[0..3] of word=($e980, $e880, $e900, $e800);
  spr_mask:array[1..2] of word=($3ff,$1ff);
var
  f,nchar,y,x,offs:word;
  i,atrib,color:byte;
begin
//Background
for f:=0 to $7ff do begin
  if gfx[0].buffer[f] then begin
    x:=f mod 64;
    y:=31-(f div 64);
    atrib:=memoria[$c001+(f*2)];
    color:=(atrib and $f) shl 3;
    nchar:=memoria[$c000+(f*2)]+((atrib and $c0) shl 2)+(tile_bank shl 6);
    put_gfx_flip(x*8,y*8,nchar and $7ff,color,1,0,(atrib and $20)<>0,(atrib and $10)<>0);
    gfx[0].buffer[f]:=false;
  end;
end;
scroll__x(1,2,scroll_x.w);
//Sprites
for i:=0 to 3 do begin
		for f:=$1f downto 0 do begin
			offs:=pribase[i]+(f*4);
      y:=memoria[offs];
      x:=memoria[offs+3];
      atrib:=memoria[offs+1];
			nchar:=(memoria[offs+2]+((atrib and $10) shl 5)+((atrib and $20) shl 3)) and spr_mask[1+sprite_bank];
			color:=(atrib and $0f) shl 3;
      put_gfx_sprite(nchar,color,(atrib and $40)<>0,(atrib and $80)=0,1+sprite_bank);
      actualiza_gfx_sprite(x,y,2,1+sprite_bank);
		end;
end;
//Devolver la parte de arriba!
actualiza_trozo(0,0,256,64,1,0,0,256,64,2);
actualiza_trozo_final(8,0,240,256,2);
end;

procedure eventos_knjoe;
begin
if event.arcade then begin
  if arcade_input.up[0] then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if arcade_input.down[0] then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if arcade_input.left[0] then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if arcade_input.right[0] then in1:=(in1 and $f7) else in1:=(in1 or $8);
  if arcade_input.but0[0] then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if arcade_input.but1[0] then in1:=(in1 and $df) else in1:=(in1 or $20);
  if arcade_input.coin[0] then in0:=(in0 and $fb) else in0:=(in0 or $4);
  if arcade_input.coin[1] then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if arcade_input.start[0] then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if arcade_input.start[1] then in0:=(in0 and $fd) else in0:=(in0 or $2);
end;
end;

procedure knjoe_principal;
var
  frame_m,frame_s:single;
begin
init_controls(false,false,false,true);
frame_m:=main_z80.tframes;
frame_s:=snd_6800.tframes;
while EmuStatus=EsRuning do begin
  //main
  run_z80(main_z80,main_z80_ll,trunc(frame_m));
  frame_m:=frame_m+main_z80.tframes-main_z80.contador;
  //snd
  run_6800(snd_6800,snd_6800_ll,trunc(frame_s));
  frame_s:=frame_s+snd_6800.tframes-snd_6800.contador;
  //end
  main_z80.pedir_irq:=HOLD_LINE;
  update_video_knjoe;
  eventos_knjoe;
  video_sync;
end;
end;

function knjoe_getbyte(direccion:word):byte;
begin
case direccion of
  $0..$cfff,$e800..$ffff:knjoe_getbyte:=memoria[direccion];
  $d800:knjoe_getbyte:=in0;
  $d803:knjoe_getbyte:=$ff;
  $d801:knjoe_getbyte:=in1;
  $d802:knjoe_getbyte:=$ff;
  $d804:knjoe_getbyte:=$7f;
end;
end;

procedure knjoe_putbyte(direccion:word;valor:byte);
begin
if direccion<$c000 then exit;
memoria[direccion]:=valor;
case direccion of
    $c000..$cfff:gfx[0].buffer[(direccion and $fff) shr 1]:=true;
    $d000:scroll_x.l:=valor;
    $d001:scroll_x.h:=(valor and 1);
    $d800:if ((valor and $80)=0) then sound_command:=valor and $7f
          	else snd_6800.pedir_irq:=ASSERT_LINE;
    $d801:begin
            if tile_bank<>(valor and $10) then begin
              tile_bank:=valor and $10;
              fillchar(gfx[0].buffer[0],$800,1);
            end;
            if sprite_bank<>((valor and $04) shr 2) then begin
              sprite_bank:=((valor and $04) shr 2);
              fillchar(memoria[$f100],$180,0);
            end;
          end;
    $d802:SN76496_Write(0,valor);
    $d803:SN76496_Write(1,valor);
end;
end;

//sonido
function snd_getbyte(direccion:word):byte;
begin
direccion:=direccion and $7fff;
case direccion of
  $0..$1f:snd_getbyte:=m6803_internal_reg_r(snd_6800,snd_6800_ll,direccion);
  $80..$ff,$2000..$7fff:snd_getbyte:=mem_snd[direccion];
end;

end;

procedure snd_putbyte(direccion:word;valor:byte);
begin
direccion:=direccion and $7fff;
case direccion of
  $0..$1f:m6803_internal_reg_w(snd_6800,snd_6800_ll,direccion,valor);
  $80..$ff:mem_snd[direccion]:=valor;
  $1000..$1fff:snd_6800.pedir_irq:=CLEAR_LINE;
  $2000..$7fff:exit;
end;
end;

procedure out_port1(valor:byte);
begin
  val_port1:=valor;
end;

procedure out_port2(valor:byte);
begin
  if (((val_port2 and $01)<>0) and ((not(valor and $01))<>0)) then begin
		// control or data port? */
		if (val_port2 and $04)<>0 then begin
			if (val_port2 and $08)<>0 then ay8910_control(val_port1,0);
		end else begin
			if (val_port2 and $08)<>0 then AY8910_Write(val_port1,0);
		end;
	end;
  val_port2:=valor;
end;

function in_port1:Byte;
var
  ret:byte;
begin
 ret:=$ff;
 if (val_port2 and $08)<>0 then ret:=AY8910_Read(0);
 in_port1:=ret;
end;

function in_port2:Byte;
begin
  in_port2:=0;
end;

function ay0_porta_r:byte;
begin
  ay0_porta_r:=sound_command;
end;

procedure knjoe_sonido;
begin
  ay8910_update(0);
  SN76496_Update(0);
  SN76496_Update(1);
end;

procedure knjoe_snd_nmi;
begin
  snd_6800.pedir_nmi:=PULSE_LINE;
end;

end.
