unit m72_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     z80,nec_v20_v30,main_engine,controls_engine,gfx_engine,
     ym_2151,rom_engine,cpu_engine,pal_engine,sound_engine,

     sysutils;

procedure Cargar_irem_m72;
procedure irem_m72_principal; 
function iniciar_irem_m72:boolean; 
procedure reset_irem_m72; 
procedure cerrar_irem_m72; 
//RType
function irem_m72_getbyte(direccion:dword):byte; 
procedure irem_m72_putbyte(direccion:dword;valor:byte); 
procedure irem_m72_outword(valor:word;puerto:word); 
function irem_m72_inword(puerto:word):word; 
//Sound
procedure ym2151_snd_irq(numchip:integer;irqstate:integer);
function irem_m72_snd_getbyte(direccion:word): Byte;  
procedure irem_m72_snd_putbyte(direccion:word;valor:byte); 
function irem_m72_snd_inbyte(puerto:word):byte;
procedure irem_m72_snd_outbyte(valor:byte;puerto:word);
procedure snd_despues_instruccion;

const
        //Rtype
        rtype_rom:array[0..4] of tipo_roms=(
        (n:'rt_r-h0-b.1b';l:$10000;p:1;crc:$591c7754),(n:'rt_r-l0-b.3b';l:$10000;p:$0;crc:$a1928df0),
        (n:'rt_r-h1-b.1c';l:$10000;p:$20001;crc:$a9d71eca),(n:'rt_r-l1-b.3c';l:$10000;p:$20000;crc:$0df3573d),());
        rtype_char:array[0..4] of tipo_roms=(
        (n:'rt_b-a0.3c';l:$8000;p:0;crc:$4e212fb0),(n:'rt_b-a1.3d';l:$8000;p:$8000;crc:$8a65bdff),
        (n:'rt_b-a2.3a';l:$8000;p:$10000;crc:$5a4ae5b9),(n:'rt_b-a3.3e';l:$8000;p:$18000;crc:$73327606),());
        rtype_char2:array[0..4] of tipo_roms=(
        (n:'rt_b-b0.3j';l:$8000;p:0;crc:$a7b17491),(n:'rt_b-b1.3k';l:$8000;p:$8000;crc:$b9709686),
        (n:'rt_b-b2.3h';l:$8000;p:$10000;crc:$433b229a),(n:'rt_b-b3.3f';l:$8000;p:$18000;crc:$ad89b072),());
        irem_m72_sprites:array[0..12] of tipo_roms=(
        (n:'rt_r-00.1h';l:$10000;p:0;crc:$dad53bc0),(n:'rt_r-01.1j';l:$8000;p:$10000;crc:$5e441e7f),
        (n:'rt_r-01.1j';l:$8000;p:$18000;crc:$5e441e7f),(n:'rt_r-10.1k';l:$10000;p:$20000;crc:$d6a66298),
        (n:'rt_r-11.1l';l:$8000;p:$30000;crc:$791df4f8),(n:'rt_r-11.1l';l:$8000;p:$38000;crc:$791df4f8),
        (n:'rt_r-20.3h';l:$10000;p:$40000;crc:$fc247c8a),(n:'rt_r-21.3j';l:$8000;p:$50000;crc:$ed793841),
        (n:'rt_r-21.3j';l:$8000;p:$58000;crc:$ed793841),(n:'rt_r-30.3k';l:$10000;p:$60000;crc:$eb02a1cb),
        (n:'rt_r-31.3l';l:$8000;p:$70000;crc:$8558355d),(n:'rt_r-31.3l';l:$8000;p:$78000;crc:$8558355d),());

var
 rom:array[0..$3ffff] of byte;
 spriteram,sprite_work:array[0..$3ff] of byte;
 palette1,palette2:array[0..$bff] of byte;
 ram,videoram1,videoram2:array[0..$3fff] of byte;
 m72_raster_irq_position:word;
 sound_latch,snd_irq_vector:byte;
 scroll_x1,scroll_y1,scroll_x2,scroll_y2:word;
 snd_pedir_irq:boolean;

implementation
uses principal;

procedure Cargar_irem_m72;
begin
llamadas_maquina.iniciar:=iniciar_irem_m72;
llamadas_maquina.bucle_general:=irem_m72_principal;
llamadas_maquina.cerrar:=cerrar_irem_m72;
llamadas_maquina.reset:=reset_irem_m72;
llamadas_maquina.fps_max:=55.017606;
end;

function iniciar_irem_m72:boolean;
const
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7 );
  pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8 );
  ps_x:array[0..15] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			16*8+0, 16*8+1, 16*8+2, 16*8+3, 16*8+4, 16*8+5, 16*8+6, 16*8+7);
  ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8 );
var
  memoria_temp:array[0..$7ffff] of byte;
begin
iniciar_irem_m72:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=384;
p_final[0].y:=256;
p_final[1].x:=512;
p_final[1].y:=512;
p_final[1].scroll.long_x:=512;
p_final[1].scroll.long_y:=512;
p_final[1].scroll.max_x:=512;
p_final[1].scroll.max_y:=256;
p_final[1].scroll.mask_x:=511;
p_final[1].scroll.mask_y:=511;
p_final[2].x:=512;
p_final[2].y:=512;
p_final[2].trans:=true;
p_final[2].scroll:=p_final[1].scroll;
p_final[3].x:=512;
p_final[3].y:=512;
p_final[3].trans:=true;
p_final[3].scroll:=p_final[1].scroll;
p_final[4].x:=512;
p_final[4].y:=512;
p_final[4].trans:=true;
p_final[4].scroll:=p_final[1].scroll;
p_final[5].x:=1024;
p_final[5].y:=512;
p_final[5].final_mix:=true;
iniciar_video;
//cargar roms
if not(cargar_roms16b(@rom[0],@rtype_rom[0],'rtype.zip',0)) then exit;
//Main CPU
init_cpu(nec_main,0,8000000/284);
init_nec(NEC_V30,main_nec);
main_nec_ll.getbyte:=irem_m72_getbyte;
main_nec_ll.putbyte:=irem_m72_putbyte;
main_nec_ll.outword:=irem_m72_outword;
main_nec_ll.inword:=irem_m72_inword;
//Sound CPU
init_cpu(z80_snd,1,(3579545/284));
snd_z80_ll.getbyte:=irem_m72_snd_getbyte;
snd_z80_ll.putbyte:=irem_m72_snd_putbyte;
snd_z80_ll.outbyte:=irem_m72_snd_outbyte;
snd_z80_ll.inbyte:=irem_m72_snd_inbyte;
//Sound Chips
YM2151_Init(0,1,3579545,3579545,nil,ym2151_snd_irq);
init_sound_engine(1,3579545,snd_despues_instruccion);
//convertir chars
if not(cargar_roms(@memoria_temp[0],@rtype_char[0],'rtype.zip',0)) then exit;
init_gfx(0,8,8,$1000);
gfx[0].trans[0]:=true;
des_gfx.pos_planos[3]:=0*8;
des_gfx.pos_planos[2]:=$8000*8;
des_gfx.pos_planos[1]:=$10000*8;
des_gfx.pos_planos[0]:=$18000*8;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=8*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//chars 2
if not(cargar_roms(@memoria_temp[0],@rtype_char2[0],'rtype.zip',0)) then exit;
init_gfx(1,8,8,$1000);
gfx[1].trans[0]:=true;
convert_gfx(@gfx[1],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@irem_m72_sprites[0],'rtype.zip',0)) then exit;
init_gfx(2,16,16,$1000);
gfx[2].trans[0]:=true;
des_gfx.pos_planos[0]:=$60000*8;
des_gfx.pos_planos[1]:=$40000*8;
des_gfx.pos_planos[2]:=$20000*8;
des_gfx.pos_planos[3]:=0;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=32*8;
convert_gfx(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//final
reset_irem_m72;
iniciar_irem_m72:=true;
end;

procedure draw_sprites;inline;
var
  f,nchar,atrib,color,c:word;
  flipx,flipy:boolean;
  w,h,wx,wy:byte;
  x,y:integer;
begin
for f:=0 to $7f do begin
		nchar:=(spriteram[(f*8)+2]+(spriteram[(f*8)+3] shl 8)) and $fff;
		atrib:=spriteram[(f*8)+4]+(spriteram[(f*8)+5] shl 8);
    color:=(atrib and $f) shl 4;
		x:=(spriteram[(f*8)+6]+(spriteram[(f*8)+7] shl 8))-256;
		y:=384-(spriteram[(f*8)+0]+(spriteram[(f*8)+1] shl 8));
		flipx:=(atrib and $800)<>0;
		flipy:=(atrib and $400)<>0;
		w:=1 shl ((atrib and $c000) shr 14);
		h:=1 shl ((atrib and $3000) shr 12);
		y:=y-(16*h);
		for wx:=0 to (w-1) do begin
			for wy:=0 to (h-1) do begin
        c:=nchar;
				if flipx then c:=c+8*(w-1-wx)
				  else c:=c+8*wx;
				if flipy then c:=c+h-1-wy
				  else c:=c+wy;
        put_gfx_sprite(c,color,flipx,flipy,2);
        actualiza_gfx_sprite(x+16*wx,y+16*wy,5,2);
			end;
		end;
end;
end;

procedure update_video_irem_m72;inline;
var
  f,x,y,nchar,atrib,atrib2,color:word;
begin
for f:=0 to $fff do begin
    x:=f mod 64;
    y:=f div 64;
    atrib2:=videoram2[(f*4)+2];
    color:=atrib2 and $f;
      if ((gfx[1].buffer[f]) or (gfx[0].color_buffer[color])) then begin
        //Background
        atrib:=videoram2[(f*4)+1];
        nchar:=videoram2[(f*4)+0]+((atrib and $3f) shl 8);
        if (atrib2 and $80)=0 then begin
          put_gfx_flip(x*8,y*8,nchar,(color shl 4)+256,1,1,(atrib and $40)<>0,(atrib and $80)<>0);
          put_gfx_block_trans(x*8,y*8,2,8,8);
        end else begin
          put_gfx_block(x*8,y*8,1,8,8,0);
          put_gfx_trans_flip(x*8,y*8,nchar,(color shl 4)+256,2,1,(atrib and $40)<>0,(atrib and $80)<>0);
        end;
        gfx[1].buffer[f]:=false;
      end;
      //Foreground
      atrib2:=videoram1[(f*4)+2];
      color:=atrib2 and $f;
      if ((gfx[0].buffer[f]) or (gfx[0].color_buffer[color])) then begin
        atrib:=videoram1[(f*4)+1];
        nchar:=(videoram1[(f*4)+0]+((atrib and $3f) shl 8)) and $fff;
        if (atrib2 and $80)=0 then begin
          put_gfx_trans_flip(x*8,y*8,nchar,(color shl 4)+256,3,0,(atrib and $40)<>0,(atrib and $80)<>0);
          put_gfx_block_trans(x*8,y*8,4,8,8);
        end else begin
          put_gfx_block_trans(x*8,y*8,3,8,8);
          put_gfx_trans_flip(x*8,y*8,nchar,(color shl 4)+256,4,0,(atrib and $40)<>0,(atrib and $80)<>0);
        end;
        gfx[0].buffer[f]:=false;
      end;
end;
fillchar(gfx[0].color_buffer[0],$10,0);
end;

procedure paint_video_irem_m72(linea_o,linea_d:word);inline;
begin
  scroll_x_y(1,5,scroll_x2,scroll_y2+128);
  scroll_x_y(3,5,scroll_x1,scroll_y1+128);
  draw_sprites;
  scroll_x_y(2,5,scroll_x2,scroll_y2+128);
  scroll_x_y(4,5,scroll_x1,scroll_y1+128);
//Actualizar el video desde la linea actual a la ultima pintada
actualiza_trozo(64+32,linea_o+32,384+32,(linea_d-linea_o)+32,5,0,linea_o,384,linea_d-linea_o,0);
end;

procedure eventos_irem_m72;
begin
if event.arcade then begin
  if arcade_input.right[0] then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if arcade_input.left[0] then in0:=(in0 and $Fd) else in0:=(in0 or $2);
  if arcade_input.down[0] then in0:=(in0 and $fb) else in0:=(in0 or $4);
  if arcade_input.up[0] then in0:=(in0 and $F7) else in0:=(in0 or $8);
  if arcade_input.but0[0] then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if arcade_input.but1[0] then in0:=(in0 and $df) else in0:=(in0 or $20);
  if arcade_input.but2[0] then in0:=(in0 and $bf) else in0:=(in0 or $40);
  //in1
  if arcade_input.start[0] then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if arcade_input.start[1] then in1:=(in1 and $Fd) else in1:=(in1 or $2);
  if arcade_input.coin[0] then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if arcade_input.coin[1] then in1:=(in1 and $F7) else in1:=(in1 or $8);
end;
end;

procedure cerrar_irem_m72;
begin
cerrar_cpus;
YM2151_Close(0);
close_audio;
close_video;
end;

procedure reset_irem_m72;
begin
 reset_nec(main_nec);
 reset_z80(snd_z80);
 snd_z80.im0:=$ff;
 YM2151_Reset(0);
 reset_audio;
 in0:=$ff;
 in1:=$ff;
 scroll_x1:=0;
 scroll_x2:=0;
 scroll_y1:=0;
 scroll_y2:=0;
 snd_irq_vector:=0;
 snd_pedir_irq:=false;
end;

procedure snd_irq_set;inline;
begin
  case snd_irq_vector of
    0:snd_z80.im0:=snd_z80.im0 or $20; //Clear Z80
    1:snd_z80.im0:=snd_z80.im0 and $df; //Set Z80
    2:snd_z80.im0:=snd_z80.im0 or $10; //Clear YM2151
    3:snd_z80.im0:=snd_z80.im0 and $ef; //Set YM2151
  end;
end;

procedure irem_m72_principal;
var
  frame_m,frame_s:single;
  f:word;
begin
init_controls(false,false,false,true);
frame_m:=main_nec.tframes;
frame_s:=snd_z80.tframes;
while EmuStatus=EsRuning do begin
 for f:=0 to 283 do begin
    //Main CPU
    run_nec(main_nec,main_nec_ll,trunc(frame_m));
    frame_m:=frame_m+main_nec.tframes-main_nec.contador;
    //Sound CPU
    run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
    frame_s:=frame_s+snd_z80.tframes-snd_z80.contador;
    if snd_pedir_irq then begin
      snd_irq_set;
      snd_pedir_irq:=false;
      snd_z80.pedir_irq:=HOLD_LINE;
    end;
    if ((f<256) and (f=m72_raster_irq_position)) then begin
      main_nec.vect_req:=$22;
      main_nec.pedir_irq:=true;
      paint_video_irem_m72(0,f);
    end;
    if f=256 then begin
      main_nec.vect_req:=$20;
      main_nec.pedir_irq:=true;
      paint_video_irem_m72(m72_raster_irq_position,f);
    end;
 end;
 update_video_irem_m72;
 //form1.statusbar1.Panels[2].Text:=inttostr(scroll_x1.w)+' - '+inttostr(scroll_x2.w);
 eventos_irem_m72;
 video_sync;
end;
end;

function irem_m72_getbyte(direccion:dword):byte;
begin
case direccion of
  0..$3ffff:irem_m72_getbyte:=rom[direccion];
  $40000..$43fff:irem_m72_getbyte:=ram[direccion and $3fff];
  $c0000..$c03ff:irem_m72_getbyte:=sprite_work[direccion and $3ff];
	$c8000..$c8bff:if (direccion and 1)<>0 then irem_m72_getbyte:=$ff
                      else irem_m72_getbyte:=palette1[(direccion and $1ff)+(direccion and $c00)]+$e0;
	$cc000..$ccbff:if (direccion and 1)<>0 then irem_m72_getbyte:=$ff
                    else irem_m72_getbyte:=palette2[(direccion and $1ff)+(direccion and $c00)]+$e0;
	$d0000..$d3fff:irem_m72_getbyte:=videoram1[direccion and $3fff];
	$d8000..$dbfff:irem_m72_getbyte:=videoram2[direccion and $3fff];
	$e0000..$effff:irem_m72_getbyte:=mem_snd[direccion and $ffff];
  $ffff0..$fffff:irem_m72_getbyte:=rom[direccion and $3ffff];
end;
end;

procedure cambiar_color1(num:word);inline;
var
  color:tcolor;
begin
  color.r:=pal5bit(palette1[num]);
  color.g:=pal5bit(palette1[num+$400]);
  color.b:=pal5bit(palette1[num+$800]);
  set_pal_color(color,addr(paleta[num shr 1]));
end;

procedure cambiar_color2(num:word);inline;
var
  color:tcolor;
begin
  color.r:=pal5bit(palette2[num]);
  color.g:=pal5bit(palette2[num+$400]);
  color.b:=pal5bit(palette2[num+$800]);
  num:=num shr 1;
  set_pal_color(color,addr(paleta[num+$100]));
  gfx[0].color_buffer[(num shr 4) and $f]:=true;
end;

procedure irem_m72_putbyte(direccion:dword;valor:byte);
begin
case direccion of
  0..$3ffff,$ffff0..$fffff:exit;
  $40000..$43fff:ram[direccion and $3fff]:=valor;  //ram 1
  $c0000..$c03ff:sprite_work[direccion and $3ff]:=valor; //ram 7
  $c8000..$c8bff:begin //ram 0
                    palette1[(direccion and $1ff)+(direccion and $c00)]:=valor;
                    cambiar_color1(direccion and $1fe);
                 end;
	$cc000..$ccbff:begin
                    palette2[(direccion and $1ff)+(direccion and $c00)]:=valor; //ram 9
                    cambiar_color2(direccion and $1fe);
                 end;
	$d0000..$d3fff:begin  //ram 3
                    videoram1[direccion and $3fff]:=valor;
                    gfx[0].buffer[(direccion and $3fff) shr 2]:=true;
                 end;
	$d8000..$dbfff:begin
                    videoram2[direccion and $3fff]:=valor;  //ram 4
                    gfx[1].buffer[(direccion and $3fff) shr 2]:=true;
                 end;
	$e0000..$effff:mem_snd[direccion and $ffff]:=valor;
end;
end;

procedure irem_m72_outword(valor:word;puerto:word);
begin
case puerto of
  0:begin
      sound_latch:=valor and $ff;
      snd_irq_vector:=1;
      snd_pedir_irq:=true;
    end;
  2:if (valor and $10)=0 then begin
      snd_z80.enabled:=false;
    end else begin
      snd_z80.enabled:=true;
      reset_z80(snd_z80);
      snd_z80.im0:=$ff;
    end;
  4:if valor<>0 then copymemory(@spriteram[0],@sprite_work[0],$400);
  6:m72_raster_irq_position:=valor-128;
  $80:scroll_y1:=valor;  //FG
  $82:scroll_x1:=valor;
  $84:scroll_y2:=valor; //BG
  $86:scroll_x2:=valor;
end;
end;

function irem_m72_inword(puerto:word):word;
begin
  case puerto of
    0:irem_m72_inword:=$ff00+in0;
    2:irem_m72_inword:=$ff00+in1;
    4:irem_m72_inword:=$fdfb;
  end;
end;

function irem_m72_snd_getbyte(direccion:word): Byte;
begin
irem_m72_snd_getbyte:=mem_snd[direccion];
end;

procedure irem_m72_snd_putbyte(direccion:word;valor:byte);
begin
mem_snd[direccion]:=valor;
end;

function irem_m72_snd_inbyte(puerto:word):byte;
begin
case (puerto and $ff) of
  $1:irem_m72_snd_inbyte:=YM2151_status_port_read(0);
  $2:irem_m72_snd_inbyte:=sound_latch;
end;
end;

procedure irem_m72_snd_outbyte(valor:byte;puerto:word);
begin
case (puerto and $ff) of
  $0:YM2151_register_port_write(0,valor);
  $1:YM2151_data_port_write(0,valor);
  $6:begin
      snd_irq_vector:=0;
      snd_pedir_irq:=true;
     end;
end;
end;

procedure ym2151_snd_irq(numchip:integer;irqstate:integer);
begin
  snd_irq_vector:=2+irqstate;
  snd_pedir_irq:=true;
end;

procedure snd_despues_instruccion;
begin
  ym2151_Update(0);
end;

end.
