unit mysteriousstones_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     m6502,main_engine,controls_engine,ay_8910,gfx_engine,
     rom_engine,cpu_engine,pal_engine,sound_engine;

procedure Cargar_MS;
procedure principal_ms;
function iniciar_ms:boolean;
procedure cerrar_ms;
procedure reset_ms;
//Main CPU
function getbyte_ms(direccion:word): Byte;
procedure putbyte_ms(direccion:word;valor:byte);
procedure ms_despues_instruccion; 

const
        ms_rom:array[0..6] of tipo_roms=(
        (n:'rom6.bin';l:$2000;p:$4000;crc:$7bd9c6cd),(n:'rom5.bin';l:$2000;p:$6000;crc:$a83f04a6),
        (n:'rom4.bin';l:$2000;p:$8000;crc:$46c73714),(n:'rom3.bin';l:$2000;p:$A000;crc:$34f8b8a3),
        (n:'rom2.bin';l:$2000;p:$C000;crc:$bfd22cfc),(n:'rom1.bin';l:$2000;p:$E000;crc:$fb163e38),());
        ms_char:array[0..6] of tipo_roms=(
        (n:'ms6';l:$2000;p:$0000;crc:$85c83806),(n:'ms9';l:$2000;p:$2000;crc:$b146c6ab),
        (n:'ms7';l:$2000;p:$4000;crc:$d025f84d),(n:'ms10';l:$2000;p:$6000;crc:$d85015b5),
        (n:'ms8';l:$2000;p:$8000;crc:$53765d89),(n:'ms11';l:$2000;p:$A000;crc:$919ee527),());
        ms_sprite:array[0..6] of tipo_roms=(
        (n:'ms12';l:$2000;p:$0000;crc:$72d8331d),(n:'ms13';l:$2000;p:$2000;crc:$845a1f9b),
        (n:'ms14';l:$2000;p:$4000;crc:$822874b0),(n:'ms15';l:$2000;p:$6000;crc:$4594e53c),
        (n:'ms16';l:$2000;p:$8000;crc:$2f470b0f),(n:'ms17';l:$2000;p:$A000;crc:$38966d1b),());
        ms_pal:tipo_roms=(n:'ic61';l:$20;p:0;crc:$e802d6cf);

var
  scroll,soundlatch,last:byte;
  char_color:byte;
  weights_rg:array[0..2] of double;
  weights_b:array[0..1] of double;

implementation
uses principal;

procedure Cargar_MS;
begin
llamadas_maquina.iniciar:=iniciar_ms;
llamadas_maquina.bucle_general:=principal_ms;
llamadas_maquina.cerrar:=cerrar_ms;
llamadas_maquina.reset:=reset_ms;
llamadas_maquina.fps_max:=((12000000/256)/3)/272;
end;

function cambiar_color(valor:byte):tcolor;
var
  bit0,bit1,bit2:byte;
  color:tcolor;
begin
  //red
  bit0:=(valor shr 0) and $01;
  bit1:=(valor shr 1) and $01;
  bit2:=(valor shr 2) and $01;
  color.r:=combine_3_weights(@weights_rg[0],bit0,bit1,bit2);
  // green
	bit0:=(valor shr 3) and $01;
	bit1:=(valor shr 4) and $01;
	bit2:=(valor shr 5) and $01;
	color.g:=combine_3_weights(@weights_rg[0],bit0,bit1,bit2);
  // blue
  bit0:=(valor shr 6) and $01;
  bit1:=(valor shr 7) and $01;
  color.b:=combine_2_weights(@weights_b[0],bit0,bit1);
  cambiar_color:=color;
end;

function iniciar_ms:boolean;
var
  colores:tpaleta;
  f:byte;
  memoria_temp:array[0..$bfff] of byte;
const
    pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7);
    pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
    ps_x:array[0..15] of dword=(16*8+0, 16*8+1, 16*8+2, 16*8+3, 16*8+4, 16*8+5, 16*8+6, 16*8+7,
			0, 1, 2, 3, 4, 5, 6, 7);
    ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8);
    resistances_rg:array[0..2] of word=(4700,3300,1500);
	  resistances_b:array[0..1] of word=(3300,1500);
begin
iniciar_ms:=false;
iniciar_audio(false);
p_final[0].x:=240;
p_final[0].y:=256;
p_final[1].x:=512;
p_final[1].y:=256;
p_final[1].scroll.long_x:=512;
p_final[1].scroll.max_x:=256;
p_final[1].scroll.mask_x:=511;
p_final[2].x:=256;
p_final[2].y:=256;
p_final[2].final_mix:=true;
p_final[2].sprite_end_x:=512;
p_final[2].sprite_mask_x:=$1ff;
//Chars trans
p_final[6].x:=256;
p_final[6].y:=256;
p_final[6].trans:=true;
iniciar_video;
//Main CPU
init_cpu(m6502_main,0,1500000/272);
main_6502_ll.getbyte:=getbyte_ms;
main_6502_ll.putbyte:=putbyte_ms;
//Sound Chip
AY8910_init(1500000,0,1,nil,nil,nil,nil);
AY8910_init(1500000,1,1,nil,nil,nil,nil);
init_sound_engine(0,1500000,ms_despues_instruccion);
//cargar roms
if not(cargar_roms(@memoria[0],@ms_rom[0],'mystston.zip',0)) then exit;
//Cargar chars
if not(cargar_roms(@memoria_temp[0],@ms_char[0],'mystston.zip',0)) then exit;
init_gfx(0,8,8,2048);
gfx[0].trans[0]:=true;
des_gfx.pos_planos[0]:=$4000*8*2;
des_gfx.pos_planos[1]:=$4000*8;
des_gfx.pos_planos[2]:=0;
des_gfx.bit_pixel:=3;
des_gfx.banks:=0;
des_gfx.long_sprites:=8*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,true);
//sprites
init_gfx(1,16,16,512);
gfx[1].trans[0]:=true;
des_gfx.long_sprites:=32*8;
convert_gfx(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,true);
//Cargar sprites fondo
if not(cargar_roms(@memoria_temp[0],@ms_sprite[0],'mystston.zip',0)) then exit;
init_gfx(2,16,16,512);
convert_gfx(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,true);
//poner la paleta
if not(cargar_roms(@memoria_temp[0],@ms_pal,'mystston.zip',1)) then exit;
compute_resistor_weights(0,	255, -1.0,
			3,@resistances_rg[0],@weights_rg[0],0,4700,
			2,@resistances_b[0],@weights_b[0],0,4700,
			0,nil,nil,0,0);
for f:=24 to 63 do colores[f]:=cambiar_color(memoria_temp[f-24]);
set_pal(colores,64);
//final
reset_ms;
iniciar_ms:=true;
end;

procedure cerrar_ms;
begin
cerrar_cpus;
AY8910_close(0);
AY8910_close(1);
close_audio;
close_video;
end;

procedure reset_ms;
begin
reset_6502(main_6502,main_6502_ll);
ay8910_reset(0);
ay8910_reset(1);
reset_audio;
scroll:=0;
last:=0;
soundlatch:=0;
in0:=$ff;
in1:=$ff;
in2:=$9f;
char_color:=0;
end;

procedure update_video_ms;inline;
var
  f,nchar,color:word;
  x,y:word;
  atrib:byte;
begin
for f:=0 to $1ff do begin
  if gfx[2].buffer[f] then begin
    x:=f mod 32;
    y:=f div 32;
    nchar:=((memoria[$1a00+f] and $1) shl 8)+memoria[$1800+f];
    put_gfx_flip(x*16,y*16,nchar,16,1,2,(x and $10)<>0,false);
    gfx[2].buffer[f]:=false;
  end;
end;
scroll__x(1,2,scroll);
//Sprites
for f:=0 to $17 do begin
  atrib:=memoria[$780+(f*4)];
  if (atrib and 1)<>0 then begin
    x:=240-memoria[$782+(f*4)];
    y:=memoria[$783+(f*4)];
    nchar:=memoria[$781+(f*4)]+((atrib and $10) shl 4);
    color:=(atrib and $8) shl 1;
    put_gfx_sprite(nchar,color,(atrib and 2)<>0,(atrib and 4)<>0,1);
    actualiza_gfx_sprite(x and $ff,y,2,1);
  end;
end;
for f:=0 to $3ff do begin
  if gfx[0].buffer[f] then begin
    x:=f mod 32;
    y:=f div 32;
    nchar:=((memoria[$1400+f] and $07) shl 8)+memoria[$1000+f];
    put_gfx_trans(x*8,y*8,nchar,24+(char_color shl 3),6,0);
    gfx[0].buffer[f]:=false;
  end;
end;
actualiza_trozo(0,0,256,256,6,0,0,256,256,2);
actualiza_trozo_final(8,0,240,256,2);
end;

procedure eventos_ms;
begin
if event.arcade then begin
  if arcade_input.right[0] then in0:=in0 and $fe else in0:=in0 or 1;
  if arcade_input.left[0] then in0:=in0 and $fd else in0:=in0 or 2;
  if arcade_input.up[0] then in0:=in0 and $fb else in0:=in0 or 4;
  if arcade_input.down[0] then in0:=in0 and $f7 else in0:=in0 or 8;
  if arcade_input.but0[0] then in0:=in0 and $ef else in0:=in0 or $10;
  if arcade_input.but1[0] then in0:=in0 and $df else in0:=in0 or $20;
  if arcade_input.coin[0] then begin
      in0:=(in0 and $bf);
      main_6502.pedir_nmi:=PULSE_LINE;
  end else begin
    in0:=(in0 or $40);
  end;
  if arcade_input.coin[1] then begin
      in0:=(in0 and $7f);
      main_6502.pedir_nmi:=PULSE_LINE;
  end else begin
      in0:=(in0 or $80);
  end;
  if arcade_input.start[0] then in1:=in1 and $bf else in1:=in1 or $40;
  if arcade_input.start[1] then in1:=in1 and $7f else in1:=in1 or $80;
end;
end;

procedure principal_ms;
var
  f:word;
  frame:single;
begin
init_controls(false,false,false,true);
frame:=main_6502.tframes;
while EmuStatus=EsRuning do begin
 for f:=0 to 271 do begin
    run_6502(main_6502,main_6502_ll,trunc(frame));
    frame:=frame+main_6502.tframes-main_6502.contador;
    case f of
      8:in2:=in2 and $7F;
      248:begin
            in2:=in2 or $80;
            update_video_ms;
          end;
    end;
    if (f and $f)=8 then main_6502.pedir_irq:=ASSERT_LINE;
 end;
 eventos_ms;
 video_sync;
end;
end;

function getbyte_ms(direccion:word):byte;
begin
case direccion of
  0..$1fff,$4000..$ffff:getbyte_ms:=memoria[direccion];
  $2000..$3fff:case (direccion and $7f) of
                  $00:getbyte_ms:=in0;
                  $10:getbyte_ms:=in1;
                  $20:getbyte_ms:=$fb;
                  $30:getbyte_ms:=in2;
               end;
end;
end;

procedure putbyte_ms(direccion:word;valor:byte);
var
  temp:byte;
begin
if direccion>$3fff then exit;
memoria[direccion]:=valor;
case direccion of
  $1000..$17ff:gfx[0].buffer[direccion and $3ff]:=true;
  $1800..$1bff:gfx[2].buffer[direccion and $1ff]:=true;
  $2000..$3fff:case (direccion and $7f) of
                $00:begin
                      temp:=((valor and $1) shl 1)+((valor and $2) shr 1);
                      if char_color<>temp then begin
                        fillchar(gfx[0].buffer[0],$400,1);
                        char_color:=temp;
                      end;
                    end;
                $10:main_6502.pedir_irq:=CLEAR_LINE;
                $20:scroll:=valor;
                $30:soundlatch:=valor;
                $40:begin
                     if (((last and $20)=$20) and ((valor and $20)=0)) then begin
                        if (last and $10)<>0 then AY8910_Control(soundlatch,0)
                        else AY8910_Write(soundlatch,0);
                     end;
                     if (((last and $80)=$80) and ((valor and $80)=0)) then begin
                        if (last and $40)<>0 then AY8910_Control(soundlatch,1)
                        else AY8910_Write(soundlatch,1);
                     end;
                     last:=valor;
                  end;
                $60..$7f:if buffer_paleta[direccion and $1f]<>valor then begin
                          buffer_paleta[direccion and $1f]:=valor;
                          set_pal_color(cambiar_color(valor),addr(paleta[direccion and $1f]));
                          if (direccion and $1f)>=$10 then fillchar(gfx[2].buffer[0],$200,1);
                         end;
              end;
      end;
end;

procedure ms_despues_instruccion;
begin
  ay8910_update(0);
  ay8910_update(1);
end;

end.
