unit pang_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     z80,kabuki_decript,main_engine,controls_engine,gfx_engine,rom_engine,
     cpu_engine,pal_engine,oki6295,sound_engine;

procedure Cargar_pang;
procedure pang_principal;
function iniciar_pang:boolean;
procedure reset_pang;
procedure cerrar_pang;
//CPU
function pang_getbyte(direccion:word): Byte;
procedure pang_putbyte(direccion:word;valor:byte);
function pang_inbyte(puerto:word):byte;
procedure pang_outbyte(valor:byte;puerto:word);
//Sound
procedure pang_despues_instruccion;

const
        pang_rom:array[0..2] of tipo_roms=(
        (n:'pang6.bin';l:$8000;p:0;crc:$68be52cd),(n:'pang7.bin';l:$20000;p:$10000;crc:$4a2e70f6),());
        pang_oki:tipo_roms=(n:'bb1.bin';l:$20000;p:0;crc:$c52e5b8e);
        pang_sprites:array[0..2] of tipo_roms=(
        (n:'bb10.bin';l:$20000;p:0;crc:$fdba4f6e),(n:'bb9.bin';l:$20000;p:$20000;crc:$39f47a63),());
        pang_char:array[0..4] of tipo_roms=(
        (n:'pang_09.bin';l:$20000;p:0;crc:$3a5883f5),(n:'bb3.bin';l:$20000;p:$20000;crc:$79a8ed08),
        (n:'pang_11.bin';l:$20000;p:$80000;crc:$166a16ae),(n:'bb5.bin';l:$20000;p:$a0000;crc:$2fb3db6c),());

var
 mem_rom_op,mem_rom_dat:array[0..7,0..$3fff] of byte;
 mem_dat:array[0..$7fff] of byte;
 rom_nbank,video_bank:byte;
 obj_ram:array[0..$fff] of byte;
 cpu_loop,vblank:byte;
 pal_bank:word;

implementation
uses principal;

procedure Cargar_pang;
begin
llamadas_maquina.iniciar:=iniciar_pang;
llamadas_maquina.bucle_general:=pang_principal;
llamadas_maquina.cerrar:=cerrar_pang;
llamadas_maquina.reset:=reset_pang;
llamadas_maquina.fps_max:=57.42;
end;

function iniciar_pang:boolean;
var
      f:word;
      memoria_temp,mem_temp2,mem_temp3:array[0..$2ffff] of byte;
      ptemp:pbyte;
const
    pc_x:array[0..7] of dword=(0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3);
    pc_y:array[0..7] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16);
    ps_x:array[0..15] of dword=(0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3,
			32*8+0, 32*8+1, 32*8+2, 32*8+3, 33*8+0, 33*8+1, 33*8+2, 33*8+3);
    ps_y:array[0..15] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16,
			8*16, 9*16, 10*16, 11*16, 12*16, 13*16, 14*16, 15*16);
begin
iniciar_pang:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=384;
p_final[0].y:=240;
p_final[1].x:=512;
p_final[1].y:=256;
p_final[1].trans:=true;
p_final[2].x:=512;
p_final[2].y:=256;
p_final[2].final_mix:=true;
iniciar_video;
//Main CPU
init_cpu(z80_main,0,8000000/256);
main_z80_ll.getbyte:=pang_getbyte;
main_z80_ll.putbyte:=pang_putbyte;
main_z80_ll.inbyte:=pang_inbyte;
main_z80_ll.outbyte:=pang_outbyte;
//Sound Chips
//YM2413  --> Falta!
init_oki6295(0,1000000,OKIM6295_PIN7_HIGH,0,8000000,2);
if not(cargar_roms(oki_6295[0].rom,@pang_oki,'pang.zip',1)) then exit;
init_sound_engine(0,8000000,nil);//pang_despues_instruccion);
//Cargar roms, desencriptar y poner en su sitio las ROMS
if not(cargar_roms(@memoria_temp[0],@pang_rom[0],'pang.zip',0)) then exit;
kabuki_mitchell_decode(@memoria_temp[0],@mem_temp2[0],@mem_temp3[0],8,$01234567,$76543210,$6548,$24);
copymemory(@memoria[0],@mem_temp2[0],$8000);
copymemory(@mem_dat[0],@mem_temp3[0],$8000);
for f:=0 to 7 do copymemory(@mem_rom_op[f,0],@mem_temp2[$10000+(f*$4000)],$4000);
for f:=0 to 7 do copymemory(@mem_rom_dat[f,0],@mem_temp3[$10000+(f*$4000)],$4000);
//convertir chars
getmem(ptemp,$100000);
if not(cargar_roms(ptemp,@pang_char[0],'pang.zip',0)) then exit;
init_gfx(0,8,8,$8000);
gfx[0].trans[15]:=true;
des_gfx.pos_planos[0]:=$8000*16*8+4;
des_gfx.pos_planos[1]:=$8000*16*8+0;
des_gfx.pos_planos[2]:=4;
des_gfx.pos_planos[3]:=0;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=16*8;
convert_gfx(@gfx[0],0,ptemp,@pc_x[0],@pc_y[0],false,false);
//convertir sprites
if not(cargar_roms(ptemp,@pang_sprites[0],'pang.zip',0)) then exit;
init_gfx(1,16,16,$800);
gfx[1].trans[15]:=true;
des_gfx.pos_planos[0]:=$800*64*8+4;
des_gfx.pos_planos[1]:=$800*64*8+0;
des_gfx.pos_planos[2]:=4;
des_gfx.pos_planos[3]:=0;
des_gfx.bit_pixel:=4;
des_gfx.long_sprites:=64*8;
convert_gfx(@gfx[1],0,ptemp,@ps_x[0],@ps_y[0],false,false);
freemem(ptemp);
//final
reset_pang;
iniciar_pang:=true;
end;

procedure reset_pang;
begin
 reset_z80(main_z80);
 reset_audio;
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
 rom_nbank:=0;
 video_bank:=0;
 cpu_loop:=0;
 pal_bank:=0;
 vblank:=0;
end;

procedure cerrar_pang;
begin
cerrar_cpus;
close_oki6295(0);
close_audio;
close_video;
end;

procedure update_video_pang;inline;
var
  x,y,f,color,nchar:word;
  atrib:byte;
begin
fill_full_screen(2,0);
for f:=$0 to $7ff do begin
  atrib:=memoria[$c800+f];
  color:=atrib and $7f;
  if ((gfx[0].buffer[f]) or (gfx[0].color_buffer[color])) then begin
    x:=f and $3f;
    y:=f shr 6;
    nchar:=(memoria[$d000+(f*2)]+(memoria[$d001+(f*2)] shl 8)) and $7fff;
    put_gfx_trans_flip(x*8,y*8,nchar,color shl 4,1,0,(atrib and $80)<>0,false);
    gfx[0].buffer[f]:=false;
  end;
end;
fillchar(gfx[0].color_buffer[0],$80,0);
actualiza_trozo(0,0,512,256,1,0,0,512,256,2);
for f:=$7d downto 0 do begin
  atrib:=obj_ram[(f*$20)+1];
  nchar:=obj_ram[f*$20]+((atrib and $e0) shl 3);
  color:=(atrib and $f) shl 4;
  x:=obj_ram[(f*$20)+3]+((atrib and $10) shl 4);
  y:=((obj_ram[(f*$20)+2]+8) and $ff)-8;
  put_gfx_sprite(nchar,color,false,false,1);
  actualiza_gfx_sprite(x,y,2,1);
end;
actualiza_trozo_final(64,8,384,240,2);
end;

procedure eventos_pang;
begin
if event.arcade then begin
  //IN1
  if arcade_input.right[0] then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if arcade_input.left[0] then in1:=(in1 and $df) else in1:=(in1 or $20);
  if arcade_input.down[0] then in1:=(in1 and $bf) else in1:=(in1 or $40);
  if arcade_input.up[0] then in1:=(in1 and $7f) else in1:=(in1 or $80);
  if arcade_input.but1[0] then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if arcade_input.but0[0] then in1:=(in1 and $f7) else in1:=(in1 or $8);
  //IN2
  if arcade_input.right[1] then in2:=(in2 and $ef) else in2:=(in2 or $10);
  if arcade_input.left[1] then in2:=(in2 and $df) else in2:=(in2 or $20);
  if arcade_input.down[1] then in2:=(in2 and $bf) else in2:=(in2 or $40);
  if arcade_input.up[1] then in2:=(in2 and $7f) else in2:=(in2 or $80);
  if arcade_input.but1[1] then in2:=(in2 and $fb) else in2:=(in2 or $4);
  if arcade_input.but0[1] then in2:=(in2 and $f7) else in2:=(in2 or $8);
  //IN0
  if arcade_input.start[0] then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if arcade_input.start[1] then in0:=(in0 and $fd) else in0:=(in0 or $2);
  if arcade_input.coin[0] then in0:=(in0 and $7f) else in0:=(in0 or $80);
end;
end;

procedure pang_principal;
var
  frame_m:single;
  f:byte;
begin
init_controls(false,false,false,true);
frame_m:=main_z80.tframes;
while EmuStatus=EsRuning do begin
  for f:=0 to $ff do begin
    run_z80(main_z80,main_z80_ll,trunc(frame_m));
    frame_m:=frame_m+main_z80.tframes-main_z80.contador;
    case f of
      0:vblank:=0;
      $80,$ff:begin
                main_z80.pedir_irq:=HOLD_LINE;
                cpu_loop:=(cpu_loop+1) and 1;
              end;
      $f8:vblank:=8;
    end;
  end;
  update_video_pang;
  eventos_pang;
  video_sync;
end;
end;

function pang_getbyte(direccion:word):byte;
begin
case direccion of
  $0..$7fff:if main_z80.opcode then pang_getbyte:=memoria[direccion]
                 else pang_getbyte:=mem_dat[direccion];
  $8000..$bfff:if main_z80.opcode then pang_getbyte:=mem_rom_op[rom_nbank,direccion and $3fff]
                 else pang_getbyte:=mem_rom_dat[rom_nbank,direccion and $3fff];
  $c000..$c7ff:pang_getbyte:=buffer_paleta[(direccion and $7ff)+pal_bank];
  $d000..$dfff:if (video_bank<>0) then pang_getbyte:=obj_ram[direccion and $fff]
                  else pang_getbyte:=memoria[direccion];
  else pang_getbyte:=memoria[direccion];
end;
end;

procedure cambiar_color(pos:word);inline;
var
        tmp_color:byte;
        color:tcolor;
begin
  tmp_color:=buffer_paleta[$1+pos];
  color.r:=pal4bit(tmp_color);
  tmp_color:=buffer_paleta[pos];
  color.g:=pal4bit(tmp_color shr 4);
  color.b:=pal4bit(tmp_color);
  set_pal_color(color,addr(paleta[pos shr 1]));
  gfx[0].color_buffer[(pos shr 5) and $7f]:=true;
end;

procedure pang_putbyte(direccion:word;valor:byte);
begin
if direccion<$c000 then exit;
case direccion of
  $c000..$c7ff:if buffer_paleta[(direccion and $7ff)+pal_bank]<>valor then begin
                  buffer_paleta[(direccion and $7ff)+pal_bank]:=valor;
                  cambiar_color((direccion and $7fe)+pal_bank);
               end;
  $c800..$cfff:begin
                  gfx[0].buffer[direccion and $7ff]:=true;
                  memoria[direccion]:=valor;
               end;
  $d000..$dfff:if (video_bank<>0) then obj_ram[direccion and $fff]:=valor
                else begin
                        memoria[direccion]:=valor;
                        gfx[0].buffer[(direccion and $fff) shr 1]:=true;
                     end;
  $e000..$ffff:memoria[direccion]:=valor;
end;
end;

function pang_inbyte(puerto:word):byte; 
var
  eeprom_bitval:byte;
begin
case (puerto and $ff) of
  0:pang_inbyte:=in0;
  1:pang_inbyte:=in1;
  2:pang_inbyte:=in2;
  5:begin
      eeprom_bitval:=$80;
      pang_inbyte:=eeprom_bitval or $76 or vblank or cpu_loop;
    end;
end;
end;

procedure pang_outbyte(valor:byte;puerto:word); 
begin
case (puerto and $ff) of
  $0:if (valor and $20)<>0 then pal_bank:=$800
        else pal_bank:=0;
  $2:rom_nbank:=valor and $f;
  $5:okim6295_w(0,valor);
  $7:video_bank:=valor;
  $8:;   {  -/          }
  $10:;  {   /  eeprom  }
  $18:;  {  -/          }
end;
end;

procedure pang_despues_instruccion;
begin
end;

end.
