unit popeye_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     z80,main_engine,controls_engine,gfx_engine,ay_8910,
     rom_engine,cpu_engine,misc_functions,pal_engine,sound_engine;

procedure Cargar_popeye;
procedure popeye_principal; 
function iniciar_popeye:boolean;
procedure reset_popeye;
procedure cerrar_popeye;
//Main CPU
function popeye_getbyte(direccion:word): Byte;
procedure popeye_putbyte(direccion:word;valor:byte);
function popeye_inbyte(puerto:word):byte;
procedure popeye_outbyte(valor:byte;puerto:word);
//Sound
procedure popeye_sonido;
function popeye_portar:byte;
procedure popeye_portbw(valor:byte);

const
        popeye_rom:array[0..4] of tipo_roms=(
        (n:'tpp2-c_f.7a';l:$2000;p:0;crc:$9af7c821),(n:'tpp2-c_f.7b';l:$2000;p:$2000;crc:$c3704958),
        (n:'tpp2-c_f.7c';l:$2000;p:$4000;crc:$5882ebf9),(n:'tpp2-c_f.7e';l:$2000;p:$6000;crc:$ef8649ca),());
        popeye_pal:array[0..4] of tipo_roms=(
        (n:'tpp2-c.4a';l:$20;p:0;crc:$375e1602),(n:'tpp2-c.3a';l:$20;p:$20;crc:$e950bea1),
        (n:'tpp2-c.5b';l:$100;p:$40;crc:$c5826883),(n:'tpp2-c.5a';l:$100;p:$140;crc:$c576afba),());
        popeye_char:tipo_roms=(n:'tpp2-v.5n';l:$1000;p:0;crc:$cca61ddd);
        popeye_sprites:array[0..4] of tipo_roms=(
        (n:'tpp2-v.1e';l:$2000;p:0;crc:$0f2cd853),(n:'tpp2-v.1f';l:$2000;p:$2000;crc:$888f3474),
        (n:'tpp2-v.1j';l:$2000;p:$4000;crc:$7e864668),(n:'tpp2-v.1k';l:$2000;p:$6000;crc:$49e1d170),());

var
  prot0,prot1,prot_shift:integer;
  palette_bank:byte;
  popeye_mem_pal:array[0..$1f] of byte;
  fondo_write:array[0..$1fff] of boolean;
  scroll_x:parejas;
  scroll_y,dswbit:byte;

implementation
uses principal;

procedure Cargar_popeye;
begin
llamadas_maquina.iniciar:=iniciar_popeye;
llamadas_maquina.bucle_general:=popeye_principal;
llamadas_maquina.cerrar:=cerrar_popeye;
llamadas_maquina.reset:=reset_popeye;
end;

function iniciar_popeye:boolean; 
var
      colores:tcolor;
      f,pos:word;
      ctemp1,ctemp2,ctemp3,ctemp4:byte;
      memoria_temp:array[0..$7fff] of byte;
const
  ps_x:array[0..15] of dword=(7+($2000*8),6+($2000*8),5+($2000*8),4+($2000*8),
     3+($2000*8),2+($2000*8),1+($2000*8),0+($2000*8),7,6,5,4,3,2,1,0);
  ps_y:array[0..15] of dword=(15*8, 14*8, 13*8, 12*8, 11*8, 10*8, 9*8, 8*8,
	  7*8, 6*8, 5*8, 4*8, 3*8, 2*8, 1*8, 0*8 );
  pc_x:array[0..15] of dword=(7,7, 6,6, 5,5, 4,4, 3,3, 2,2, 1,1, 0,0);
  pc_y:array[0..15] of dword=(0*8,0*8, 1*8,1*8, 2*8,2*8, 3*8,3*8, 4*8,4*8, 5*8,5*8, 6*8,6*8, 7*8,7*8);
begin
iniciar_popeye:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=512;
p_final[0].y:=448;
p_final[1].x:=512;
p_final[1].y:=512;
p_final[1].scroll.long_x:=512;
p_final[1].scroll.long_y:=512;
p_final[1].scroll.max_x:=512;
p_final[1].scroll.max_y:=512;
p_final[1].scroll.mask_x:=511;
p_final[1].scroll.mask_y:=511;
p_final[2].x:=512;
p_final[2].y:=512;
p_final[2].trans:=true;
p_final[3].x:=512;
p_final[3].y:=512;
p_final[3].final_mix:=true;
iniciar_video;
//Main CPU
init_cpu(z80_main,0,4000000);
main_z80_ll.getbyte:=popeye_getbyte;
main_z80_ll.putbyte:=popeye_putbyte;
main_z80_ll.outbyte:=popeye_outbyte;
main_z80_ll.inbyte:=popeye_inbyte;
//Audio chips
AY8910_init(2000000,0,1,popeye_portar,nil,nil,popeye_portbw);
init_sound_engine(0,4000000,popeye_sonido);
//cargar roms y decodificarlas
if not(cargar_roms(@memoria_temp[0],@popeye_rom[0],'popeye.zip',0)) then exit;
for f:=0 to $7fff do begin
  pos:=bitswap16(f,15,14,13,12,11,10,8,7,6,3,9,5,4,2,1,0);
  memoria[f]:=bitswap8(memoria_temp[pos xor $3f],3,4,2,5,1,6,0,7);
end;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@popeye_char,'popeye.zip',1)) then exit;
init_gfx(0,16,16,256);
gfx[0].trans[0]:=true;
des_gfx.pos_planos[0]:=0;
des_gfx.bit_pixel:=1;
des_gfx.banks:=0;
des_gfx.long_sprites:=8*8;
convert_gfx(@gfx[0],0,@memoria_temp[$800],@pc_x[0],@pc_y[0],false,false);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@popeye_sprites[0],'popeye.zip',0)) then exit;
init_gfx(1,16,16,512);
gfx[1].trans[0]:=true;
des_gfx.bit_pixel:=2;
des_gfx.banks:=2;
des_gfx.long_sprites:=16*8;
for f:=0 to 1 do begin
  des_gfx.pos_planos[0]:=0+(f*$1000*8);
  des_gfx.pos_planos[1]:=($4000+f*$1000)*8;
  convert_gfx(@gfx[1],256*f*16*16,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
end;
//poner la paleta chars
if not(cargar_roms(@memoria_temp[0],@popeye_pal[0],'popeye.zip',0)) then exit;
for f:=0 to $23f do memoria_temp[f]:=memoria_temp[f] xor $ff;
copymemory(@popeye_mem_pal[0],@memoria_temp[0],$20);
for f:=0 to 15 do begin
		ctemp4:=f or ((f and 8) shl 1);	// address bits 3 and 4 are tied together */
		// red component */
		ctemp1:=(memoria_temp[ctemp4+$20] shr 0) and $01;
		ctemp2:=(memoria_temp[ctemp4+$20] shr 1) and $01;
		ctemp3:=(memoria_temp[ctemp4+$20] shr 2) and $01;
		colores.r:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
		// green component */
		ctemp1:=(memoria_temp[ctemp4+$20] shr 3) and $01;
		ctemp2:=(memoria_temp[ctemp4+$20] shr 4) and $01;
		ctemp3:=(memoria_temp[ctemp4+$20] shr 5) and $01;
		colores.g:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
		// blue component */
		ctemp1:=0;
		ctemp2:=(memoria_temp[ctemp4+$20] shr 6) and $01;
		ctemp3:=(memoria_temp[ctemp4+$20] shr 7) and $01;
		colores.b:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
    set_pal_color(colores,addr(paleta[16+(2*f)+1]));
end;
//Poner la paleta sprites
for f:=0 to $FF do begin
		// red component */
		ctemp1:=(memoria_temp[$40+f] shr 0) and $01;
		ctemp2:=(memoria_temp[$40+f] shr 1) and $01;
		ctemp3:=(memoria_temp[$40+f] shr 2) and $01;
		colores.r:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
		// green component */
		ctemp1:=(memoria_temp[$40+f] shr 3) and $01;
		ctemp2:=(memoria_temp[$140+f] shr 0) and $01;
		ctemp3:=(memoria_temp[$140+f] shr 1) and $01;
		colores.g:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
		// blue component */
		ctemp1:=0;
		ctemp2:=(memoria_temp[$140+f] shr 2) and $01;
		ctemp3:=(memoria_temp[$140+f] shr 3) and $01;
		colores.b:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
    set_pal_color(colores,addr(paleta[48+f]));
end;
//final
reset_popeye;
iniciar_popeye:=true;
end;

procedure cambiar_paleta(valor:byte);inline;
var
  f,ctemp1,ctemp2,ctemp3,ctemp4:byte;
  colores:tcolor;
begin
  for f:=0 to 15 do begin
    ctemp4:=popeye_mem_pal[f+$10*valor];
		// red component */
		ctemp1:=(ctemp4 shr 0) and $01;
		ctemp2:=(ctemp4 shr 1) and $01;
		ctemp3:=(ctemp4 shr 2) and $01;
		colores.r:=$1c*ctemp1+$31*ctemp2+$47*ctemp3;
		// green component */
		ctemp1:=(ctemp4 shr 3) and $01;
		ctemp2:=(ctemp4 shr 4) and $01;
		ctemp3:=(ctemp4 shr 5) and $01;
		colores.g:=$1c*ctemp1+$31*ctemp2+$47*ctemp3;
		// blue component */
		ctemp1:=(ctemp4 shr 6) and $01;
		ctemp2:=(ctemp4 shr 7) and $01;
		colores.b:=$31*ctemp1+$47*ctemp2;
    set_pal_color(colores,addr(paleta[f]));
   end;
   fillchar(fondo_write[0],$2000,1);
end;

procedure reset_popeye;
begin
 reset_z80(main_z80);
 AY8910_reset(0);
 reset_audio;
 in0:=0;
 in1:=0;
 in2:=0;
 palette_bank:=0;
 cambiar_paleta(0);
end;

procedure cerrar_popeye;
begin
cerrar_cpus;
ay8910_close(0);
close_audio;
close_video;
end;

procedure update_video_popeye;inline;
var
  f,color,nchar:word;
  x,y,sc_y:word;
  ptemp:pword;
  atrib,atrib2:byte;
begin
if scroll_y=0 then fill_full_screen(3,0)
  else begin //Fondo con scroll (lo escribe directo)
    for f:=0 to $1fff do begin
      if fondo_write[f] then begin
        x:=8*(f mod 64);
        sc_y:=4*(f div 64);
        ptemp:=punbuf;
        for y:=0 to 7 do begin
          ptemp^:=paleta[memoria[f+$c000] and $0f];
          inc(ptemp);
        end;
        for y:=0 to 3 do putpixel(x,sc_y+y,8,punbuf,1);
        fondo_write[f]:=false;
      end;
    end;
    scroll_x_y(1,3,199-scroll_x.w,2*scroll_y);
  end;
//Sprites
for f:=0 to $9e do begin
  atrib:=memoria[$8c07+(f*4)];
  atrib2:=memoria[$8c06+(f*4)];
  nchar:=((atrib2 and $7f)+((atrib and $10) shl 3)+((atrib and $04) shl 6)) xor $1ff;
  color:=((atrib and $7)+(palette_bank and $07) shl 3) shl 2;
  put_gfx_sprite(nchar,color+48,(atrib2 and $80)<>0,(atrib and $08)<>0,1);
  x:=(memoria[$8c04+(f*4)] shl 1)-8;
  y:=(256-memoria[$8c05+(f*4)]) shl 1;
  actualiza_gfx_sprite(x,y,3,1);
end;
//Chars
for f:=$0 to $3ff do begin
  if gfx[0].buffer[f] then begin
    x:=f mod 32;
    y:=f div 32;
    nchar:=memoria[$a000+f];
    color:=((memoria[$a400+f]) and $f) shl 1;
    put_gfx_trans(x*16,y*16,nchar,color+16,2,0);
    gfx[0].buffer[f]:=false;
  end;
end;
actualiza_trozo(0,0,512,512,2,0,0,512,512,3);
actualiza_trozo_final(0,32,512,448,3);
end;

procedure eventos_popeye;
begin
if event.arcade then begin
  if arcade_input.up[0] then in0:=(in0 or $4) else in0:=(in0 and $Fb);
  if arcade_input.down[0] then in0:=(in0 or $8) else in0:=(in0 and $F7);
  if arcade_input.left[0] then in0:=(in0 or $2) else in0:=(in0 and $fd);
  if arcade_input.right[0] then in0:=(in0 or $1) else in0:=(in0 and $fe);
  if arcade_input.but0[0] then in0:=(in0 or $10) else in0:=(in0 and $ef);
  if arcade_input.coin[0] then in2:=(in2 or $80) else in2:=(in2 and $7f);
  if arcade_input.coin[1] then in2:=(in2 or $20) else in2:=(in2 and $df);
  if arcade_input.start[0] then in2:=(in2 or $4) else in2:=(in2 and $fb);
  if arcade_input.start[1] then in2:=(in2 or $8) else in2:=(in2 and $f7);
end;
end;

procedure popeye_principal;
var
  frame:single;
begin
init_controls(false,false,false,true);
frame:=main_z80.tframes;
while EmuStatus=EsRuning do begin
  run_z80(main_z80,main_z80_ll,trunc(frame));
  frame:=frame+main_z80.tframes-main_z80.contador;
  if (main_z80.i and 1)<>0 then main_z80.pedir_nmi:=PULSE_LINE;
  update_video_popeye;
  eventos_popeye;
  video_sync;
end;
end;

function popeye_getbyte(direccion:word):Byte;
begin
case direccion of
  $e000:popeye_getbyte:=((prot1 shl prot_shift) or (prot0 shr (8-prot_shift))) and $ff;
  $e001:popeye_getbyte:=0;
    else popeye_getbyte:=memoria[direccion];
end;
end;

procedure popeye_putbyte(direccion:word;valor:byte);
begin
if direccion<$8000 then exit;
memoria[direccion]:=valor;
case direccion of
        $8c00:scroll_x.l:=valor;
        $8c01:scroll_y:=valor;
        $8c02:scroll_x.h:=valor;
        $8c03:if palette_bank<>valor then begin
                palette_bank:=valor;
                cambiar_paleta((valor shr 3) and 1);
              end;
        $a000..$a7ff:gfx[0].buffer[direccion and $3ff]:=true;
        $c000..$dfff:fondo_write[direccion and $1fff]:=true;
        $e000:prot_shift:=valor and $07;
        $e001:begin
                prot0:=prot1;
		            prot1:=valor;
              end;
end;
end;

function popeye_inbyte(puerto:word):byte;
begin
case (puerto and $ff) of
   0:popeye_inbyte:=in0;
   1:popeye_inbyte:=0;
   2:popeye_inbyte:=in2;
   3:popeye_inbyte:=Ay8910_read(0);
end;
end;

procedure popeye_outbyte(valor:byte;puerto:word);
begin
case (puerto and $ff) of
  0:ay8910_control(valor,0);
  1:ay8910_write(valor,0);
end;
end;

function popeye_portar:byte;
begin
	popeye_portar:=($0c or $40) or (($1 or $0c or $30) shl (7-dswbit)) and $80;
end;

procedure popeye_portbw(valor:byte);
begin
  dswbit:=valor shr 1;  //El bit que quiere leer
end;

procedure popeye_sonido;
begin
  ay8910_update(0);
end;

end.
