unit rocnrope_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     m6809,z80,main_engine,controls_engine,gfx_engine,rom_engine,cpu_engine,
     pal_engine,konami_decrypt,konami_snd,sound_engine;

procedure Cargar_rocnrope;
procedure rocnrope_principal;
function iniciar_rocnrope:boolean;
procedure reset_rocnrope;
procedure cerrar_rocnrope;
//main cpu
function rocnrope_getbyte(direccion:word): Byte;  
procedure rocnrope_putbyte(direccion:word;valor:byte); 

const
        rocnrope_rom:array[0..5] of tipo_roms=(
        (n:'rr1.1h';l:$2000;p:$6000;crc:$83093134),(n:'rr2.2h';l:$2000;p:$8000;crc:$75af8697),
        (n:'rr3.3h';l:$2000;p:$a000;crc:$b21372b1),(n:'rr4.4h';l:$2000;p:$c000;crc:$7acb2a05),
        (n:'rnr_h5.vid';l:$2000;p:$e000;crc:$150a6264),());
        rocnrope_snd:array[0..2] of tipo_roms=(
        (n:'rnr_7a.snd';l:$1000;p:0;crc:$75d2c4e2),(n:'rnr_8a.snd';l:$1000;p:$1000;crc:$ca4325ae),());
        rocnrope_sprites:array[0..4] of tipo_roms=(
        (n:'rnr_a11.vid';l:$2000;p:0;crc:$afdaba5e),(n:'rnr_a12.vid';l:$2000;p:$2000;crc:$054cafeb),
        (n:'rnr_a9.vid';l:$2000;p:$4000;crc:$9d2166b2),(n:'rnr_a10.vid';l:$2000;p:$6000;crc:$aff6e22f),());
        rocnrope_chars:array[0..2] of tipo_roms=(
        (n:'rnr_h12.vid';l:$2000;p:0;crc:$e2114539),(n:'rnr_h11.vid';l:$2000;p:$2000;crc:$169a8f3f),());
        rocnrope_pal:array[0..3] of tipo_roms=(
        (n:'a17_prom.bin';l:$20;p:0;crc:$22ad2c3e),(n:'b16_prom.bin';l:$100;p:$20;crc:$750a9677),
        (n:'rocnrope.pr3';l:$100;p:$120;crc:$b5c75a27),());

var
 pedir_irq:boolean;
 mem_opcodes:array[0..$9fff] of byte;

implementation
uses principal;

procedure Cargar_rocnrope;
begin
llamadas_maquina.iniciar:=iniciar_rocnrope;
llamadas_maquina.bucle_general:=rocnrope_principal;
llamadas_maquina.cerrar:=cerrar_rocnrope;
llamadas_maquina.reset:=reset_rocnrope;
end;

function iniciar_rocnrope:boolean; 
var
      colores:tpaleta;
      bit0,bit1,bit2:byte;
      f:word;
      memoria_temp:array[0..$ffff] of byte;
      rweights,gweights,bweights:array[0..3] of double;
const
    pc_x:array[0..7] of dword=(0, 1, 2, 3, 8*8+0, 8*8+1, 8*8+2, 8*8+3);
    pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
    ps_x:array[0..15] of dword=(0, 1, 2, 3, 8*8+0, 8*8+1, 8*8+2, 8*8+3,
			16*8+0, 16*8+1, 16*8+2, 16*8+3, 24*8+0, 24*8+1, 24*8+2, 24*8+3);
    ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			32*8, 33*8, 34*8, 35*8, 36*8, 37*8, 38*8, 39*8);
    resistances_rg:array[0..2] of integer=(1000,470,220);
	  resistances_b:array [0..1] of integer=(470,220);
begin
iniciar_rocnrope:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=224;
p_final[0].y:=256;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[2].x:=256;
p_final[2].y:=256;
p_final[2].final_mix:=true;
iniciar_video;
//Main CPU
init_cpu(m6809_main,0,1536000);
main_6809_ll.getbyte:=rocnrope_getbyte;
main_6809_ll.putbyte:=rocnrope_putbyte;
//Sound CPU
init_cpu(z80_snd,1,1789772);
snd_z80_ll.getbyte:=konamisnd_getbyte;
snd_z80_ll.putbyte:=konamisnd_putbyte;
//Sound Chip
konamisnd_init(4,1,TWO_AY8910,1789772,nil);
//cargar roms y desencriptarlas
if not(cargar_roms(@memoria[0],@rocnrope_rom[0],'rocnrope.zip',0)) then exit;
konami1_decode(@memoria[0],@mem_opcodes[0],$6000);
mem_opcodes[$703d-$6000]:=$98;  //Patch
//roms sonido
if not(cargar_roms(@mem_snd[0],@rocnrope_snd[0],'rocnrope.zip',0)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@rocnrope_chars[0],'rocnrope.zip',0)) then exit;
init_gfx(0,8,8,512);
des_gfx.pos_planos[0]:=$2000*8+4;
des_gfx.pos_planos[1]:=$2000*8+0;
des_gfx.pos_planos[2]:=4;
des_gfx.pos_planos[3]:=0;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=16*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,true);
//sprites
if not(cargar_roms(@memoria_temp[0],@rocnrope_sprites[0],'rocnrope.zip',0)) then exit;
init_gfx(1,16,16,256);
des_gfx.pos_planos[0]:=$4000*8+4;
des_gfx.pos_planos[1]:=$4000*8+0;
des_gfx.pos_planos[2]:=4;
des_gfx.pos_planos[3]:=0;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=64*8;
convert_gfx(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,true);
//paleta
if not(cargar_roms(@memoria_temp[0],@rocnrope_pal[0],'rocnrope.zip',0)) then exit;
compute_resistor_weights(0,	255, -1.0,
			3,@resistances_rg[0],@rweights[0],1000,0,
			3,@resistances_rg[0],@gweights[0],1000,0,
			2,@resistances_b[0],@bweights[0],1000,0);
for f:=0 to $1f do begin
		// red component */
		bit0:=(memoria_temp[f] shr 0) and $01;
		bit1:=(memoria_temp[f] shr 1) and $01;
		bit2:=(memoria_temp[f] shr 2) and $01;
		colores[f].r:=combine_3_weights(@rweights[0], bit0, bit1, bit2);
		// green component */
		bit0:=(memoria_temp[f] shr 3) and $01;
		bit1:=(memoria_temp[f] shr 4) and $01;
		bit2:=(memoria_temp[f] shr 5) and $01;
		colores[f].g:=combine_3_weights(@gweights[0], bit0, bit1, bit2);
		// blue component */
		bit0:=(memoria_temp[f] shr 6) and $01;
		bit1:=(memoria_temp[f] shr 7) and $01;
		colores[f].b:=combine_2_weights(@bweights[0], bit0, bit1);
end;
set_pal(colores,$20);
for f:=0 to $1ff do begin
  gfx[0].colores[f]:=memoria_temp[$20+f] and $f;  //chars
  gfx[1].colores[f]:=memoria_temp[$20+f] and $f;  //sprites
end;
//final
reset_rocnrope;
iniciar_rocnrope:=true;
end;

procedure cerrar_rocnrope;
begin
cerrar_cpus;
konamisnd_close;
close_audio;
close_video;
end;

procedure reset_rocnrope;
begin
 reset_6809(main_6809,main_6809_ll);
 reset_z80(snd_z80);
 konamisnd_reset;
 reset_audio;
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
 pedir_irq:=false;
end;

procedure update_video_rocnrope;inline;
var
  x,y,atrib:byte;
  f:word;
  nchar,color:word;
begin
for f:=0 to $3ff do begin
    if gfx[0].buffer[f] then begin
      x:=f div 32;
      y:=31-(f mod 32);
      atrib:=memoria[$4800+f];
      nchar:=memoria[$4c00+f]+((atrib and $80) shl 1);
      color:=(atrib and $f) shl 4;
      put_gfx_flip(x*8,y*8,nchar,color+256,1,0,(atrib and $20)<>0,(atrib and $40)<>0);
      gfx[0].buffer[f]:=false;
    end;
end;
actualiza_trozo(0,0,256,256,1,0,0,256,256,2);
for f:=$17 downto 0 do begin
		atrib:=memoria[$4000+(f*2)];
    nchar:=memoria[$4401+(f*2)];
    color:=(atrib and $f) shl 4;
    x:=memoria[$4001+(f*2)];
    y:=memoria[$4400+(f*2)];
    put_gfx_sprite_mask(nchar,color,(atrib and $80)=0,(atrib and $40)<>0,1,0,$f);
    actualiza_gfx_sprite(x,y,2,1);
end;
actualiza_trozo_final(16,0,224,256,2);
end;

procedure eventos_rocnrope;
begin
if event.arcade then begin
  //p1
  if arcade_input.left[0] then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if arcade_input.right[0] then in0:=(in0 and $fd) else in0:=(in0 or $2);
  if arcade_input.up[0] then in0:=(in0 and $fb) else in0:=(in0 or $4);
  if arcade_input.down[0] then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if arcade_input.but0[0] then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if arcade_input.but1[0] then in0:=(in0 and $df) else in0:=(in0 or $20);
  //p2
  if arcade_input.left[1] then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if arcade_input.right[1] then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if arcade_input.up[1] then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if arcade_input.down[1] then in1:=(in1 and $f7) else in1:=(in1 or $8);
  if arcade_input.but0[1] then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if arcade_input.but1[1] then in1:=(in1 and $df) else in1:=(in1 or $20);
  //misc
  if arcade_input.coin[0] then in2:=(in2 and $fe) else in2:=(in2 or $1);
  if arcade_input.coin[1] then in2:=(in2 and $fd) else in2:=(in2 or $2);
  if arcade_input.start[0] then in2:=(in2 and $f7) else in2:=(in2 or $8);
  if arcade_input.start[1] then in2:=(in2 and $ef) else in2:=(in2 or $10);
end;
end;

procedure rocnrope_principal; 
var
  frame_m,frame_s:single;
begin
init_controls(false,false,false,true);
frame_m:=main_6809.tframes;
frame_s:=snd_z80.tframes;
while EmuStatus=EsRuning do begin
  //main
  run_6809(main_6809,main_6809_ll,trunc(frame_m));
  frame_m:=frame_m+main_6809.tframes-main_6809.contador;
  if pedir_irq then main_6809.pedir_irq:=HOLD_LINE;
  //snd
  run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
  frame_s:=frame_s+snd_z80.tframes-snd_z80.contador;
  //misc
  update_video_rocnrope;
  eventos_rocnrope;
  video_sync;
end;
end;

function rocnrope_getbyte(direccion:word):byte;
begin
case direccion of
    $3000:rocnrope_getbyte:=$7b;
    $3080:rocnrope_getbyte:=in2;
    $3081:rocnrope_getbyte:=in0;
    $3082:rocnrope_getbyte:=in1;
    $3083:rocnrope_getbyte:=$ff;
    $3100:rocnrope_getbyte:=$3f;
    $6000..$ffff:if main_6809.opcode then rocnrope_getbyte:=mem_opcodes[direccion-$6000]
        else rocnrope_getbyte:=memoria[direccion];
  else rocnrope_getbyte:=memoria[direccion];
end;
end;

procedure rocnrope_putbyte(direccion:word;valor:byte);
begin
case direccion of
  $4800..$4fff:gfx[0].buffer[direccion and $3ff]:=true;
  $8081:if valor<>0 then snd_z80.pedir_irq:=HOLD_LINE;
  $8087:pedir_irq:=(valor and $1)<>0;
  $8100:konami_sound.sound_latch:=valor;
  $8182..$818d:memoria[$fff2+(direccion-$8182)]:=valor;
end;
if direccion<$6000 then memoria[direccion]:=valor;
end;

end.
