unit shaolinsroad_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     m6809,main_engine,controls_engine,sn_76496,gfx_engine,rom_engine,
     cpu_engine,pal_engine,sound_engine;

procedure Cargar_shaolin;
procedure shaolin_principal;
function iniciar_shaolin:boolean;
procedure reset_shaolin;
procedure cerrar_shaolin;
//Main CPU
function shaolin_getbyte(direccion:word): Byte;  
procedure shaolin_putbyte(direccion:word;valor:byte);
procedure shaolin_sound;

const
        shaolin_rom:array[0..3] of tipo_roms=(
        (n:'477-l03.d9';l:$2000;p:$6000;crc:$2598dfdd),(n:'477-l04.d10';l:$4000;p:$8000;crc:$0cf0351a),
        (n:'477-l05.d11';l:$4000;p:$c000;crc:$654037f8),());
        shaolin_char:array[0..2] of tipo_roms=(
        (n:'shaolins.a10';l:$2000;p:0;crc:$ff18a7ed),(n:'shaolins.a11';l:$2000;p:$2000;crc:$5f53ae61),());
        shaolin_sprites:array[0..2] of tipo_roms=(
        (n:'477-k02.h15';l:$4000;p:0;crc:$b94e645b),(n:'477-k01.h14';l:$4000;p:$4000;crc:$61bbf797),());
        shaolin_pal:array[0..5] of tipo_roms=(
        (n:'477j10.a12';l:$100;p:$0;crc:$b09db4b4),(n:'477j11.a13';l:$100;p:$100;crc:$270a2bf3),
        (n:'477j12.a14';l:$100;p:$200;crc:$83e95ea8),(n:'477j09.b8';l:$100;p:$300;crc:$aa900724),
        (n:'477j08.f16';l:$100;p:$400;crc:$80009cf5),());

var
 banco_pal,scroll:byte;
 pedir_nmi:boolean;

implementation
uses principal;

procedure Cargar_shaolin;
begin
llamadas_maquina.iniciar:=iniciar_shaolin;
llamadas_maquina.bucle_general:=shaolin_principal;
llamadas_maquina.cerrar:=cerrar_shaolin;
llamadas_maquina.reset:=reset_shaolin;
end;

function iniciar_shaolin:boolean;
var
      colores:tpaleta;
      f:word;
      ctemp1,ctemp2,ctemp3:byte;
      memoria_temp:array[0..$7fff] of byte;
const
    pc_x:array[0..7] of dword=(0, 1, 2, 3, 8*8+0, 8*8+1, 8*8+2, 8*8+3);
    pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
    ps_x:array[0..15] of dword=(0, 1, 2, 3, 8*8+0, 8*8+1, 8*8+2, 8*8+3,
			16*8+0, 16*8+1, 16*8+2, 16*8+3, 24*8+0, 24*8+1, 24*8+2, 24*8+3);
    ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			32*8, 33*8, 34*8, 35*8, 36*8, 37*8, 38*8, 39*8);
begin
iniciar_shaolin:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=224;
p_final[0].y:=256;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[1].scroll.long_x:=256;
p_final[1].scroll.max_x:=256;
p_final[1].scroll.mask_x:=255;
p_final[2].x:=256;
p_final[2].y:=256;
p_final[2].final_mix:=true;
iniciar_video;
//Main CPU
init_cpu(m6809_main,0,1536000/16);
main_6809_ll.getbyte:=shaolin_getbyte;
main_6809_ll.putbyte:=shaolin_putbyte;
//Sound Chip
SN76496_init(0,1536000);
SN76496_init(1,3072000);
init_sound_engine(0,1536000,shaolin_sound);
//cargar roms
if not(cargar_roms(@memoria[0],@shaolin_rom[0],'shaolins.zip',0)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@shaolin_char[0],'shaolins.zip',0)) then exit;
init_gfx(0,8,8,512);
des_gfx.pos_planos[0]:=512*16*8+4;
des_gfx.pos_planos[1]:=512*16*8+0;
des_gfx.pos_planos[2]:=4;
des_gfx.pos_planos[3]:=0;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=16*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
//sprites
if not(cargar_roms(@memoria_temp[0],@shaolin_sprites[0],'shaolins.zip',0)) then exit;
init_gfx(1,16,16,256);
gfx[1].trans[0]:=true;
des_gfx.pos_planos[0]:=256*64*8+4;
des_gfx.pos_planos[1]:=256*64*8+0;
des_gfx.pos_planos[2]:=4;
des_gfx.pos_planos[3]:=0;
des_gfx.long_sprites:=64*8;
convert_gfx(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
//paleta
if not(cargar_roms(@memoria_temp[0],@shaolin_pal[0],'shaolins.zip',0)) then exit;
for f:=0 to 255 do begin
  colores[f].r:=((memoria_temp[f] and $f) shl 4) or (memoria_temp[f] and $f);
  colores[f].g:=((memoria_temp[f+$100] and $f) shl 4) or (memoria_temp[f+$100] and $f);
  colores[f].b:=((memoria_temp[f+$200] and $f) shl 4) or (memoria_temp[f+$200] and $f);
end;
set_pal(colores,256);
//tabla_colores char & sprites
ctemp1:=0;
for ctemp2:=0 to 255 do begin
	for ctemp3:=0 to 7 do begin
		gfx[0].colores[ctemp2+ctemp3*256]:=(memoria_temp[ctemp1+$300] and $f)+32*ctemp3+16;
    gfx[1].colores[ctemp2+ctemp3*256]:=(memoria_temp[ctemp1+$400] and $f)+32*ctemp3;
  end;
	ctemp1:=ctemp1+1;
end;
//final
reset_shaolin;
iniciar_shaolin:=true;
end;

procedure cerrar_shaolin;
begin
cerrar_cpus;
SN76496_close(0);
SN76496_close(1);
close_audio;
close_video;
end;

procedure reset_shaolin;
begin
 reset_6809(main_6809,main_6809_ll);
 SN76496_reset(0);
 SN76496_reset(1);
 reset_audio;
 banco_pal:=0;
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
 pedir_nmi:=false;
end;

procedure update_video_shaolin;inline;
var
  x,y,f:word;
  color,nchar:word;
  atrib:byte;
begin
for f:=0 to $3ff do begin
    if gfx[0].buffer[f] then begin
      y:=f mod 32;
      x:=31-(f div 32);
      atrib:=memoria[$3800+f];
      color:=((atrib and $f)+($10*banco_pal)) shl 4;
      nchar:=memoria[$3c00+f]+((atrib and $40) shl 2);
      put_gfx_flip(x*8,y*8,nchar,color,1,0,(atrib and $20)<>0,(atrib and $10)<>0);
      gfx[0].buffer[f]:=false;
    end;
end;
scroll__x(1,2,scroll);
actualiza_trozo(0,0,256,32,1,0,0,256,32,2);
for f:=$17 downto 0 do if ((memoria[$3100+(f*32)]<>0) and (memoria[$3106+(f*32)]<>0)) then begin
  atrib:=memoria[$3109+(f*32)];
  color:=((atrib and $f)+($10*banco_pal)) shl 4;
  x:=memoria[$3104+(f*32)];
  y:=240-memoria[$3106+(f*32)];
  nchar:=memoria[$3108+(f*32)];
  put_gfx_sprite(nchar,color,(atrib and $80)<>0,(atrib and $40)=0,1);
  actualiza_gfx_sprite(x-8,y,2,1);
end;
actualiza_trozo_final(16,0,224,256,2);
end;

procedure eventos_shaolin;
begin
if event.arcade then begin
  if arcade_input.down[0] then in1:=(in1 and $f7) else in1:=(in1 or $8);
  if arcade_input.up[0] then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if arcade_input.right[0] then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if arcade_input.left[0] then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if arcade_input.but0[0] then in1:=(in1 and $df) else in1:=(in1 or $20);
  if arcade_input.but1[0] then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if arcade_input.start[0] then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if arcade_input.start[1] then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if arcade_input.coin[0] then in0:=(in0 and $fe) else in0:=(in0 or 1);
  if arcade_input.coin[1] then in0:=(in0 and $fd) else in0:=(in0 or 2);
end;
end;

procedure shaolin_principal;
var
  f:byte;
  frame:single;
begin
init_controls(false,false,false,true);
frame:=main_6809.tframes;
while EmuStatus=EsRuning do begin
  for f:=0 to $f do begin
    run_6809(main_6809,main_6809_ll,trunc(frame));
    frame:=frame+main_6809.tframes-main_6809.contador;
    if f=0 then main_6809.pedir_irq:=HOLD_LINE
      else if (((f mod 2)=0) and pedir_nmi) then main_6809.pedir_nmi:=PULSE_LINE;
  end;
  update_video_shaolin;
  eventos_shaolin;
  video_sync;
end;
end;

function shaolin_getbyte(direccion:word):byte;
begin
case direccion of
  $2800..$2bff,$3000..$33ff,$3800..$ffff:shaolin_getbyte:=memoria[direccion];
  $500:shaolin_getbyte:=$5a;
  $600:shaolin_getbyte:=$FF;
  $700:shaolin_getbyte:=in0;
  $701:shaolin_getbyte:=in1;
  $702:shaolin_getbyte:=in2;
  $703:shaolin_getbyte:=$ff;
end;
end;

procedure shaolin_putbyte(direccion:word;valor:byte);
begin
if direccion>$3fff then exit;
memoria[direccion]:=valor;
case direccion of
  $0:begin
        main_screen.flip_main_screen:=(valor and 1)<>0;
        pedir_nmi:=(valor and $2)<>0;
     end;
  $0300:SN76496_Write(0,valor);
  $0400:SN76496_Write(1,valor);
  $1800:banco_pal:=valor and $7;
  $2000:scroll:=not(valor);
  $3800..$3fff:gfx[0].buffer[direccion and $3ff]:=true;
end;
end;

procedure shaolin_sound;
begin
  SN76496_Update(0);
  SN76496_Update(1);
end;

end.
