unit solomonkey_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     z80,main_engine,controls_engine,ay_8910,gfx_engine,rom_engine,cpu_engine,
     pal_engine,sound_engine,timer_engine;

procedure Cargar_solomon;
procedure solomon_principal;
function iniciar_solomon:boolean;
procedure reset_solomon;
procedure cerrar_solomon;
//Main CPU
function solomon_getbyte(direccion:word): Byte;
procedure solomon_putbyte(direccion:word;valor:byte);
//Sound CPU
function solomon_snd_getbyte(direccion:word): Byte;
procedure solomon_snd_putbyte(direccion:word;valor:byte);
procedure solomon_snd_outbyte(valor:byte;puerto:word);
procedure solomon_despues_instruccion;
procedure solomon_snd_irq;

const
        solomon_rom:array[0..3] of tipo_roms=(
        (n:'6.3f';l:$4000;p:0;crc:$645eb0f3),(n:'7.3h';l:$8000;p:$4000;crc:$1bf5c482),
        (n:'8.3jk';l:$8000;p:$c000;crc:$0a6cdefc),());
        solomon_snd_rom:tipo_roms=(n:'1.3jk';l:$4000;p:0;crc:$fa6e562e);
        solomon_chars:array[0..2] of tipo_roms=(
        (n:'12.3t';l:$8000;p:$0;crc:$b371291c),(n:'11.3r';l:$8000;p:$8000;crc:$6f94d2af),());
        solomon_sprites:array[0..4] of tipo_roms=(
        (n:'2.5lm';l:$4000;p:0;crc:$80fa2be3),(n:'3.6lm';l:$4000;p:$4000;crc:$236106b4),
        (n:'4.7lm';l:$4000;p:$8000;crc:$088fe5d9),(n:'5.8lm';l:$4000;p:$c000;crc:$8366232a),());
        solomon_tiles:array[0..2] of tipo_roms=(
        (n:'10.3p';l:$8000;p:$0;crc:$8310c2a1),(n:'9.3m';l:$8000;p:$8000;crc:$ab7e6c42),());

var
 sound_latch:byte;
 nmi_enable:boolean;

implementation
uses principal;

procedure Cargar_solomon;
begin
llamadas_maquina.iniciar:=iniciar_solomon;
llamadas_maquina.bucle_general:=solomon_principal;
llamadas_maquina.cerrar:=cerrar_solomon;
llamadas_maquina.reset:=reset_solomon;
end;

function iniciar_solomon:boolean;
var
    memoria_temp:array[0..$13fff] of byte;
const
    pc_x:array[0..7] of dword=(0*4, 1*4, 2*4, 3*4, 4*4, 5*4, 6*4, 7*4);
    pc_y:array[0..7] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32);
    ps_x:array[0..15] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			8*8+0, 8*8+1, 8*8+2, 8*8+3, 8*8+4, 8*8+5, 8*8+6, 8*8+7);
    ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			16*8, 17*8, 18*8, 19*8, 20*8, 21*8, 22*8, 23*8);
begin
iniciar_solomon:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=256;
p_final[0].y:=224;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[2].x:=256;
p_final[2].y:=256;
p_final[2].trans:=true;
p_final[3].x:=256;
p_final[3].y:=256;
p_final[3].final_mix:=true;
iniciar_video;
//Main CPU
init_cpu(z80_main,0,4000000/256);
main_z80_ll.getbyte:=solomon_getbyte;
main_z80_ll.putbyte:=solomon_putbyte;
//Sound CPU
init_cpu(z80_snd,1,3072000/256);
snd_z80_ll.getbyte:=solomon_snd_getbyte;
snd_z80_ll.putbyte:=solomon_snd_putbyte;
snd_z80_ll.outbyte:=solomon_snd_outbyte;
init_timer(1,3072000/(60*2),solomon_snd_irq,true);
//Sound Chips
AY8910_init(1500000,0,1,nil,nil,nil,nil);
AY8910_init(1500000,1,1,nil,nil,nil,nil);
AY8910_init(1500000,2,1,nil,nil,nil,nil);
init_sound_engine(1,3072000,solomon_despues_instruccion);
//cargar roms
if not(cargar_roms(@memoria_temp[0],@solomon_rom[0],'solomon.zip',0)) then exit;
copymemory(@memoria[0],@memoria_temp[0],$4000);
copymemory(@memoria[$4000],@memoria_temp[$8000],$4000);
copymemory(@memoria[$8000],@memoria_temp[$4000],$4000);
copymemory(@memoria[$f000],@memoria_temp[$c000],$1000);
//cargar ROMS sonido
if not(cargar_roms(@mem_snd[0],@solomon_snd_rom,'solomon.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@solomon_chars[0],'solomon.zip',0)) then exit;
init_gfx(0,8,8,$800);
gfx[0].trans[0]:=true;
des_gfx.pos_planos[0]:=0;
des_gfx.pos_planos[1]:=1;
des_gfx.pos_planos[2]:=2;
des_gfx.pos_planos[3]:=3;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=32*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//tiles
if not(cargar_roms(@memoria_temp[0],@solomon_tiles[0],'solomon.zip',0)) then exit;
init_gfx(1,8,8,$800);
convert_gfx(@gfx[1],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@solomon_sprites[0],'solomon.zip',0)) then exit;
init_gfx(2,16,16,$400);
gfx[2].trans[0]:=true;
des_gfx.pos_planos[0]:=0;
des_gfx.pos_planos[1]:=512*32*8;
des_gfx.pos_planos[2]:=2*512*32*8;
des_gfx.pos_planos[3]:=3*512*32*8;
des_gfx.bit_pixel:=4;
des_gfx.long_sprites:=32*8;
convert_gfx(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//final
reset_solomon;
iniciar_solomon:=true;
end;

procedure cerrar_solomon;
begin
cerrar_cpus;
ay8910_close(0);
ay8910_close(1);
ay8910_close(2);
close_audio;
close_video;
end;

procedure reset_solomon;
begin
 reset_z80(main_z80);
 reset_z80(snd_z80);
 AY8910_reset(0);
 AY8910_reset(1);
 AY8910_reset(2);
 reset_audio;
 in0:=0;
 in1:=0;
 in2:=0;
 sound_latch:=0;
 nmi_enable:=true;
end;

procedure update_video_solomon;inline;
var
        f,color,nchar:word;
        x,y:word;
        atrib:byte;
begin
for f:=$3ff downto 0 do begin
  //tiles
  atrib:=memoria[$d800+f];
  color:=(atrib and $70) shr 4;
  if ((gfx[1].buffer[f]) or (gfx[1].color_buffer[color])) then begin
    x:=(f and $1f) shl 3;
    y:=(f shr 5) shl 3;
    nchar:=memoria[$dc00+f]+((atrib and $7) shl 8);
    put_gfx_flip(x,y,nchar,(color shl 4)+128,1,1,(atrib and $80)<>0,(atrib and $8)<>0);
    gfx[1].buffer[f]:=false;
  end;
  //Chars
  atrib:=memoria[$d000+f];
  color:=(atrib and $70) shr 4;
  if ((gfx[0].buffer[f]) or (gfx[0].color_buffer[color])) then begin
    x:=(f and $1f) shl 3;
    y:=(f shr 5) shl 3;
    nchar:=memoria[$d400+f]+((atrib and $7) shl 8);
    put_gfx_trans(x,y,nchar,color shl 4,2,0);
    gfx[0].buffer[f]:=false;
  end;
end;
fillchar(gfx[0].color_buffer[0],8,0);
fillchar(gfx[1].color_buffer[0],8,0);
actualiza_trozo(0,0,256,256,1,0,0,256,256,3);
actualiza_trozo(0,0,256,256,2,0,0,256,256,3);
//sprites
for f:=$1f downto 0 do begin
    atrib:=memoria[$e001+(f*4)];
    nchar:=memoria[$e000+(f*4)]+16*(atrib and $10);
		color:=(atrib and $0e) shl 3;
    x:=memoria[$e003+(f*4)];
		y:=241-memoria[$e002+(f*4)];
    put_gfx_sprite(nchar,color,(atrib and $40)<>0,(atrib and $80)<>0,2);
    actualiza_gfx_sprite(x,y,3,2);
end;
actualiza_trozo_final(0,16,256,224,3);
end;

procedure eventos_solomon;
begin
if event.arcade then begin
  //p1
  if arcade_input.right[0] then in0:=(in0 or $1) else in0:=(in0 and $fe);
  if arcade_input.left[0] then in0:=(in0 or $2) else in0:=(in0 and $fd);
  if arcade_input.up[0] then in0:=(in0 or $4) else in0:=(in0 and $fb);
  if arcade_input.down[0] then in0:=(in0 or $8) else in0:=(in0 and $F7);
  if arcade_input.but0[0] then in0:=(in0 or $10)else in0:=(in0 and $ef);
  if arcade_input.but1[0] then in0:=(in0 or $20) else in0:=(in0 and $df);
  //p2
  if arcade_input.right[1] then in1:=(in1 or $1) else in1:=(in1 and $fe);
  if arcade_input.left[1] then in1:=(in1 or $2) else in1:=(in1 and $fd);
  if arcade_input.up[1] then in1:=(in1 or $4) else in1:=(in1 and $fb);
  if arcade_input.down[1] then in1:=(in1 or $8) else in1:=(in1 and $F7);
  if arcade_input.but0[1] then in1:=(in1 or $10)else in1:=(in1 and $ef);
  if arcade_input.but1[1] then in1:=(in1 or $20) else in1:=(in1 and $df);
  //system
  if arcade_input.start[0] then in2:=(in2 or $1) else in2:=(in2 and $fe);
  if arcade_input.start[1] then in2:=(in2 or $2) else in2:=(in2 and $fd);
  if arcade_input.coin[1] then in2:=(in2 or $4) else in2:=(in2 and $fb);
  if arcade_input.coin[0] then in2:=(in2 or $8) else in2:=(in2 and $f7);
end;
end;

procedure solomon_principal;
var
  f:byte;
  frame_m,frame_s:single;
begin
init_controls(false,false,false,true);
frame_m:=main_z80.tframes;
frame_s:=snd_z80.tframes;
while EmuStatus=EsRuning do begin
  for f:=0 to $ff do begin
    //main
    run_z80(main_z80,main_z80_ll,trunc(frame_m));
    frame_m:=frame_m+main_z80.tframes-main_z80.contador;
    //snd
    run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
    frame_s:=frame_s+snd_z80.tframes-snd_z80.contador;
    if f=239 then begin
        if nmi_enable then main_z80.pedir_nmi:=PULSE_LINE;
        update_video_solomon;
    end;
  end;
  eventos_solomon;
  video_sync;
end;
end;

//Main
function solomon_getbyte(direccion:word):byte;
begin
case direccion of
  $e600:solomon_getbyte:=in0;
  $e601:solomon_getbyte:=in1;
  $e602:solomon_getbyte:=in2;
  $e603:if (main_z80.pc=$4cf0) then solomon_getbyte:=main_z80.bc.w and $08 //proteccion ???
            else solomon_getbyte:=0;
  $e604:solomon_getbyte:=2;
  $e605:solomon_getbyte:=0;
  else solomon_getbyte:=memoria[direccion];
end;
end;

procedure cambiar_color(dir:word);inline;
var
  tmp_color:byte;
  color:tcolor;
begin
  tmp_color:=buffer_paleta[dir];
  color.r:=pal4bit(tmp_color);
  color.g:=pal4bit(tmp_color shr 4);
  tmp_color:=buffer_paleta[dir+1];
  color.b:=pal4bit(tmp_color);
  dir:=dir shr 1;
  set_pal_color(color,addr(paleta[dir]));
  case dir of
    0..$7f:gfx[0].color_buffer[dir shr 4]:=true;
    $80..$ff:gfx[1].color_buffer[(dir shr 4) and $7]:=true;
  end;
end;

procedure solomon_putbyte(direccion:word;valor:byte);
begin
if direccion<$c000 then exit;
memoria[direccion]:=valor;
case direccion of
   $d000..$d7ff:gfx[0].buffer[direccion and $3ff]:=true;
   $d800..$dfff:gfx[1].buffer[direccion and $3ff]:=true;
   $e400..$e5ff:if buffer_paleta[direccion and $1ff]<>valor then begin
                    buffer_paleta[direccion and $1ff]:=valor;
                    cambiar_color(direccion and $1fe);
                end;
   $e600:nmi_enable:=valor<>0;
   $e800:begin
            sound_latch:=valor;
            snd_z80.pedir_nmi:=PULSE_LINE;
         end;
   $f000..$ffff:exit;
end;
end;

//Sound
function solomon_snd_getbyte(direccion:word): Byte;
begin
if direccion=$8000 then solomon_snd_getbyte:=sound_latch
 else solomon_snd_getbyte:=mem_snd[direccion];
end;

procedure solomon_snd_putbyte(direccion:word;valor:byte);
begin
if direccion<$4000 then exit;
mem_snd[direccion]:=valor;
end;

procedure solomon_snd_outbyte(valor:byte;puerto:word);
begin
case (puerto and $ff) of
  $10:ay8910_control(valor,0);
	$11:ay8910_write(valor,0);
	$20:ay8910_control(valor,1);
	$21:ay8910_write(valor,1);
	$30:ay8910_control(valor,2);
	$31:ay8910_write(valor,2);
end;
end;

procedure solomon_snd_irq;
begin
  snd_z80.pedir_irq:=HOLD_LINE;
end;

procedure solomon_despues_instruccion;
begin
  ay8910_update(0);
  ay8910_update(1);
  ay8910_update(2);
end;

end.
