unit starforce_hw; //Senjyo

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     z80,z80pio,z80daisy,main_engine,controls_engine,gfx_engine,sn_76496,
     z80ctc,rom_engine,cpu_engine,pal_engine,sound_engine;

procedure Cargar_starforce;
procedure starforce_principal;
function iniciar_starforce:boolean;
procedure reset_starforce;
procedure cerrar_starforce;
//Main CPU
function starforce_getbyte(direccion:word): Byte;
procedure starforce_putbyte(direccion:word;valor:byte);
//Sound CPU
function snd_getbyte(direccion:word): Byte;
procedure snd_putbyte(direccion:word;valor:byte);
function snd_inbyte(puerto:word):byte;
procedure snd_outbyte(valor:byte;puerto:word);
procedure snd_despues_instruccion;
//PIO
procedure pio_int_main(state:byte);
function pio_read_porta:byte;
//CTC
procedure snd_pio_ctc_int(state:byte);

const
        starforce_rom:array[0..2] of tipo_roms=(
        (n:'starforc.3';l:$4000;p:0;crc:$8ba27691),(n:'starforc.2';l:$4000;p:$4000;crc:$0fc4d2d6),());
        starforce_fg:array[0..3] of tipo_roms=(
        (n:'starforc.7';l:$1000;p:0;crc:$f4803339),(n:'starforc.8';l:$1000;p:$1000;crc:$96979684),
        (n:'starforc.9';l:$1000;p:$2000;crc:$eead1d5c),());
        starforce_bg1:array[0..3] of tipo_roms=(
        (n:'starforc.15';l:$2000;p:0;crc:$c3bda12f),(n:'starforc.14';l:$2000;p:$2000;crc:$9e9384fe),
        (n:'starforc.13';l:$2000;p:$4000;crc:$84603285),());
        starforce_bg2:array[0..3] of tipo_roms=(
        (n:'starforc.12';l:$2000;p:0;crc:$fdd9e38b),(n:'starforc.11';l:$2000;p:$2000;crc:$668aea14),
        (n:'starforc.10';l:$2000;p:$4000;crc:$c62a19c1),());
        starforce_bg3:array[0..3] of tipo_roms=(
        (n:'starforc.18';l:$1000;p:0;crc:$6455c3ad),(n:'starforc.17';l:$1000;p:$1000;crc:$68c60d0f),
        (n:'starforc.16';l:$1000;p:$2000;crc:$ce20b469),());
        starforce_sound:tipo_roms=(n:'starforc.1';l:$2000;p:0;crc:$2735bb22);
        starforce_sprites:array[0..3] of tipo_roms=(
        (n:'starforc.6';l:$4000;p:0;crc:$5468a21d),(n:'starforc.5';l:$4000;p:$4000;crc:$f71717f8),
        (n:'starforc.4';l:$4000;p:$8000;crc:$dd9d68a4),());
var
 x1,x2,x3:parejas;
 y1,y2,y3,sound_latch:byte;

implementation
uses principal;

procedure Cargar_starforce;
begin
llamadas_maquina.iniciar:=iniciar_starforce;
llamadas_maquina.bucle_general:=starforce_principal;
llamadas_maquina.cerrar:=cerrar_starforce;
llamadas_maquina.reset:=reset_starforce;
end;

function iniciar_starforce:boolean; 
const
  ps_x:array[0..15] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			8*8+0, 8*8+1, 8*8+2, 8*8+3, 8*8+4, 8*8+5, 8*8+6, 8*8+7);
  ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			16*8, 17*8, 18*8, 19*8, 20*8, 21*8, 22*8, 23*8);
  pbs_x:array[0..31] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			8*8+0, 8*8+1, 8*8+2, 8*8+3, 8*8+4, 8*8+5, 8*8+6, 8*8+7,
			32*8+0, 32*8+1, 32*8+2, 32*8+3, 32*8+4, 32*8+5, 32*8+6, 32*8+7,
			40*8+0, 40*8+1, 40*8+2, 40*8+3, 40*8+4, 40*8+5, 40*8+6, 40*8+7);
  pbs_y:array[0..31] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			16*8, 17*8, 18*8, 19*8, 20*8, 21*8, 22*8, 23*8,
			64*8, 65*8, 66*8, 67*8, 68*8, 69*8, 70*8, 71*8,
			80*8, 81*8, 82*8, 83*8, 84*8, 85*8, 86*8, 87*8);
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 4, 5, 6, 7);
  pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
var
  memoria_temp:array[0..$ffff] of byte;
begin
iniciar_starforce:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=224;
p_final[0].y:=256;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[1].final_mix:=true;
//bg3
p_final[2].x:=512;
p_final[2].y:=256;
p_final[2].scroll.long_x:=512;
p_final[2].scroll.long_y:=256;
p_final[2].scroll.max_x:=256;
p_final[2].scroll.max_y:=256;
p_final[2].scroll.mask_x:=511;
p_final[2].scroll.mask_y:=255;
//chars
p_final[6].x:=256;
p_final[6].y:=256;
p_final[6].trans:=true;
//bg2
p_final[7].x:=512;
p_final[7].y:=256;
p_final[7].trans:=true;
p_final[7].scroll:=p_final[2].scroll;
//bg1
p_final[8].x:=512;
p_final[8].y:=256;
p_final[8].trans:=true;
p_final[8].scroll:=p_final[2].scroll;
iniciar_video;
//Main CPU
init_cpu(z80_main,0,4000000);
main_z80_ll.getbyte:=starforce_getbyte;
main_z80_ll.putbyte:=starforce_putbyte;
//Sound CPU
init_cpu(z80_snd,1,2000000);
snd_z80.daisy:=true;
snd_z80_ll.getbyte:=snd_getbyte;
snd_z80_ll.putbyte:=snd_putbyte;
snd_z80_ll.outbyte:=snd_outbyte;
snd_z80_ll.inbyte:=snd_inbyte;
//Daisy Chain PIO+CTC
z80daisy_init(Z80_PIO_TYPE,Z80_CTC_TYPE,Z80_DAISY_NONE,0,0,0);
z80ctc_init(0,1,2000000,2000000,NOTIMER_2,snd_pio_ctc_int,z80ctc_trg01_w,nil,nil);
z80pio_init(0,pio_int_main,pio_read_porta,nil,nil,nil,nil,nil);
//Chip CPU
SN76496_init(0,2000000);
SN76496_init(1,2000000);
SN76496_init(2,2000000);
init_sound_engine(1,2000000,snd_despues_instruccion);
//cargar roms
if not(cargar_roms(@memoria[0],@starforce_rom[0],'starforc.zip',0)) then exit;
//cargar sonido
if not(cargar_roms(@mem_snd[0],@starforce_sound,'starforc.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@starforce_fg[0],'starforc.zip',0)) then exit;
init_gfx(0,8,8,512);
gfx[0].trans[0]:=true;
des_gfx.pos_planos[0]:=0;
des_gfx.pos_planos[1]:=512*8*8;
des_gfx.pos_planos[2]:=2*512*8*8;
des_gfx.bit_pixel:=3;
des_gfx.banks:=0;
des_gfx.long_sprites:=8*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
//big sprites
if not(cargar_roms(@memoria_temp[0],@starforce_sprites[0],'starforc.zip',0)) then exit;
init_gfx(2,32,32,128);
gfx[2].trans[0]:=true;
des_gfx.pos_planos[1]:=128*32*32;
des_gfx.pos_planos[2]:=2*128*32*32;
des_gfx.long_sprites:=128*8;
convert_gfx(@gfx[2],0,@memoria_temp[0],@pbs_x[0],@pbs_y[0],true,false);
//sprites
init_gfx(1,16,16,512);
gfx[1].trans[0]:=true;
des_gfx.pos_planos[1]:=512*16*16;
des_gfx.pos_planos[2]:=2*512*16*16;
des_gfx.long_sprites:=32*8;
convert_gfx(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
//bg1
if not(cargar_roms(@memoria_temp[0],@starforce_bg1[0],'starforc.zip',0)) then exit;
init_gfx(3,16,16,768);
gfx[3].trans[0]:=true;
des_gfx.pos_planos[1]:=256*16*16;
des_gfx.pos_planos[2]:=2*256*16*16;
des_gfx.banks:=3;
convert_gfx(@gfx[3],0,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
//bg2
if not(cargar_roms(@memoria_temp[0],@starforce_bg2[0],'starforc.zip',0)) then exit;
convert_gfx(@gfx[3],256*16*16,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
//bg3
if not(cargar_roms(@memoria_temp[0],@starforce_bg3[0],'starforc.zip',0)) then exit;
des_gfx.pos_planos[1]:=128*16*16;
des_gfx.pos_planos[2]:=2*128*16*16;
convert_gfx(@gfx[3],512*16*16,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
reset_starforce;
iniciar_starforce:=true;
end;

procedure cerrar_starforce;
begin
cerrar_cpus;
z80pio_close(0);
z80ctc_close(0);
SN76496_close(0);
SN76496_close(1);
SN76496_close(2);
close_audio;
close_video;
end;

procedure reset_starforce;
begin
 z80pio_reset(0);
 z80ctc_reset(0);
 SN76496_reset(0);
 SN76496_reset(1);
 SN76496_reset(2);
 reset_z80(main_z80);
 reset_z80(snd_z80);
 reset_audio;
 in0:=0;
 in1:=0;
 in2:=0;
end;

procedure draw_sprites(prioridad:byte);inline;
var
  nchar,x,y,color,f:word;
  atrib:byte;
begin
for f:=$1f downto 0 do begin
  atrib:=memoria[$9801+(f*4)];
  if ((atrib and $30) shr 4)=prioridad then begin
    nchar:=memoria[$9800+(f*4)];
    y:=memoria[$9803+(f*4)];
    x:=memoria[$9802+(f*4)];
    color:=(atrib and 7) shl 3+320;
    if (memoria[$9800+(f*4)] and $c0)<>$c0 then begin
      put_gfx_sprite(nchar,color,(atrib and $80)<>0,(atrib and $40)<>0,1);
      actualiza_gfx_sprite(x,y,1,1);
    end else begin
      put_gfx_sprite(nchar and $7f,color,(atrib and $80)<>0,(atrib and $40)<>0,2);
      actualiza_gfx_sprite(x,y,1,2);
    end;
  end;
end;
end;

procedure update_video_starforce;inline;
var
        f,color,nchar:word;
        x,y:byte;
const
  color_code:array[0..7] of byte=(0,2,4,6,1,3,5,7);
begin
for f:=0 to $1ff do begin
      //bg3
      color:=(memoria[$a000+f] and $e0) shr 5;
      if gfx[3].buffer[f] then begin
        x:=31-(f div 16);
        y:=f mod 16;
        nchar:=memoria[$a000+f]+512;
        put_gfx(x*16,y*16,nchar,(color shl 3)+192,2,3);
        gfx[3].buffer[f]:=false;
      end;
      //bg2
      color:=(memoria[$a800+f] and $e0) shr 5;
      if (gfx[4].buffer[f] or gfx[4].color_buffer[color]) then begin
        x:=31-(f div 16);
        y:=f mod 16;
        nchar:=memoria[$a800+f]+256;
        put_gfx_trans(x*16,y*16,nchar,(color shl 3)+128,7,3);
        gfx[4].buffer[f]:=false;
     end;
     //bg1
    color:=color_code[((memoria[$b000+f] and $e0) shr 5)];
    if (gfx[5].buffer[f] or gfx[5].color_buffer[color]) then begin
      x:=31-(f div 16);
      y:=f mod 16;
      nchar:=memoria[$b000+f];
      put_gfx_trans(x*16,y*16,nchar,(color shl 3)+64,8,3);
      gfx[5].buffer[f]:=false;
    end;
end;
//chars
for f:=0 to $3ff do begin
    color:=memoria[$9400+f] and $7;
    if (gfx[0].buffer[f] or gfx[0].color_buffer[color]) then begin
      x:=31-(f div 32);
      y:=f mod 32;
      nchar:=memoria[$9000+f]+((memoria[$9400+f] and $10) shl 4);
      put_gfx_trans(x*8,y*8,nchar,color shl 3,6,0);
      gfx[0].buffer[f]:=false;
    end;
end;
fillchar(gfx[0].color_buffer[0],8,0);
fillchar(gfx[3].color_buffer[0],8,0);
fillchar(gfx[4].color_buffer[0],8,0);
fillchar(gfx[5].color_buffer[0],8,0);
draw_sprites(0);
scroll_x_y(2,1,x3.w,y3);
draw_sprites(1);
scroll_x_y(7,1,x2.w,y1);
draw_sprites(2);
scroll_x_y(8,1,x1.w,y1);
draw_sprites(3);
actualiza_trozo(0,0,256,256,6,0,0,256,256,1);
actualiza_trozo_final(16,0,224,256,1);
end;

procedure eventos_starforce;
begin
if event.arcade then begin
  if arcade_input.up[0] then in0:=(in0 or 4) else in0:=(in0 and $fb);
  if arcade_input.down[0] then in0:=(in0 or 8) else in0:=(in0 and $f7);
  if arcade_input.left[0] then in0:=(in0 or 2) else in0:=(in0 and $fd);
  if arcade_input.right[0] then in0:=(in0 or 1) else in0:=(in0 and $fe);
  if arcade_input.coin[0] then in2:=(in2 or 1) else in2:=(in2 and $fe);
  if arcade_input.coin[1] then in2:=(in2 or 2) else in2:=(in2 and $fd);
  if arcade_input.start[0] then in2:=(in2 or 4) else in2:=(in2 and $fb);
  if arcade_input.start[1] then in2:=(in2 or 8) else in2:=(in2 and $f7);
  if arcade_input.but0[0] then in0:=(in0 or $10) else in0:=(in0 and $ef);
end;
end;

procedure starforce_principal;
var
  frame_m,frame_s:single;
begin
init_controls(false,false,false,true);
frame_m:=main_z80.tframes;
frame_s:=snd_z80.tframes;
while EmuStatus=EsRuning do begin
  //Main CPU
  run_z80(main_z80,main_z80_ll,trunc(frame_m));
  frame_m:=frame_m+main_z80.tframes-main_z80.contador;
  main_z80.pedir_irq:=HOLD_LINE;
  //Sound CPU
  run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
  frame_s:=frame_s+snd_z80.tframes-snd_z80.contador;
  update_video_starforce;
  eventos_starforce;
  video_sync;
end;
end;

function starforce_getbyte(direccion:word): Byte;
begin
case direccion of
  $d000:starforce_getbyte:=in0;
  $d001:starforce_getbyte:=in1;
  $d002:starforce_getbyte:=in2;
  $d004:starforce_getbyte:=$c0;
  $d005:starforce_getbyte:=0;
    else starforce_getbyte:=memoria[direccion];
end;
end;

procedure cambiar_color(numero:word);
var
  i,c,data:byte;
  color:tcolor;
begin
  data:=buffer_paleta[numero and $1ff];
  i:= (data shr 6) and $03;
	c:=(data shl 2) and $0c;
	if (c<>0) then c:=c or i;
	color.r:=c*$11;
	c:=(data shr 0) and $0c;
	if (c<>0) then c:=c or i;
	color.g:=c*$11;
	c:= (data shr 2) and $0c;
	if (c<>0) then c:=c or i;
	color.b:=c*$11;
  set_pal_color(color,addr(paleta[numero]));
  case numero of
    0..63:gfx[0].color_buffer[numero shr 3]:=true;
    64..127:gfx[5].color_buffer[(numero shr 3) and $7]:=true;
    128..191:gfx[4].color_buffer[(numero shr 3) and $7]:=true;
    192..255:gfx[3].color_buffer[(numero shr 3) and $7]:=true;
  end;
end;

procedure write_sound_command(valor:byte);
begin
  sound_latch:=valor;
  z80pio_astb_w(0,false);
	z80pio_astb_w(0,true);
end;

procedure starforce_putbyte(direccion:word;valor:byte);
begin
if direccion<$8000 then exit;
memoria[direccion]:=valor;
case direccion of
        $9000..$93ff:gfx[0].buffer[direccion and $3ff]:=true;
        $9c00..$9dff:if buffer_paleta[direccion and $1ff]<>valor then begin
                        buffer_paleta[direccion and $1ff]:=valor;
                        cambiar_color(direccion and $1ff);
                     end;
        $9e20:x3.l:=256-valor;
        $9e21:x3.h:=valor;
        $9e25:y3:=valor;
        $9e28:x2.l:=256-valor;
        $9e29:x2.h:=valor;
        $9e2d:y2:=valor;
        $9e30:x1.l:=256-valor;
        $9e31:x1.h:=valor;
        $9e35:y1:=valor;
        $a000..$a1ff:gfx[3].buffer[direccion and $1ff]:=true;
        $a800..$a9ff:gfx[4].buffer[direccion and $1ff]:=true;
        $b000..$b1ff:gfx[5].buffer[direccion and $1ff]:=true;
        $d004:write_sound_command(valor);
end;
end;

function snd_getbyte(direccion:word): Byte;
begin
//case direccion of
  snd_getbyte:=mem_snd[direccion];
end;

procedure snd_putbyte(direccion:word;valor:byte);
begin
if direccion<$4000 then exit;
mem_snd[direccion]:=valor;
case direccion of
  $8000:SN76496_Write(0,valor);
  $9000:SN76496_Write(1,valor);
  $a000:SN76496_Write(2,valor);
end;
end;

function snd_inbyte(puerto:word):byte;
begin
case (puerto and $FF) of
    $0..$3:snd_inbyte:=z80pio_ba_cd_r(0,puerto and $3);
    $8..$b:snd_inbyte:=z80ctc_r(0,puerto and $3);
end;
end;

procedure snd_outbyte(valor:byte;puerto:word);
begin
case (puerto and $FF) of
  $0..$3:z80pio_ba_cd_w(0,puerto and $3,valor);
  $8..$b:z80ctc_w(0,puerto and $3,valor);
end;
end;

procedure snd_despues_instruccion;
begin
  SN76496_Update(0);
  SN76496_Update(1);
  SN76496_Update(2);
end;

//PIO
procedure pio_int_main(state:byte);
begin
  if state<>0 then snd_z80.pedir_irq:=ASSERT_LINE
    else snd_z80.pedir_irq:=CLEAR_LINE;
end;

function pio_read_porta:byte;
begin
  pio_read_porta:=sound_latch;
end;

//CTC
procedure snd_pio_ctc_int(state:byte);
begin
  if state<>0 then snd_z80.pedir_irq:=ASSERT_LINE
    else snd_z80.pedir_irq:=CLEAR_LINE;
end;

end.
