unit superbasketball_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     m6809,z80,main_engine,controls_engine,sn_76496,vlm_5030,gfx_engine,
     dac,rom_engine,cpu_engine,pal_engine,konami_decrypt,sound_engine;

procedure Cargar_sbasketb;
procedure sbasketb_principal;
function iniciar_sbasketb:boolean;
procedure reset_sbasketb;
procedure cerrar_sbasketb;
//Main CPU
function sbasketb_getbyte(direccion:word):byte;
procedure sbasketb_putbyte(direccion:word;valor:byte);
//Sound CPU
function sbasketb_snd_getbyte(direccion:word):byte;
procedure sbasketb_snd_putbyte(direccion:word;valor:byte);
procedure sbasketb_sound;

const
        sbasketb_rom:array[0..3] of tipo_roms=(
        (n:'405g05.14j';l:$2000;p:$6000;crc:$336dc0ab),(n:'405i03.11j';l:$4000;p:$8000;crc:$d33b82dd),
        (n:'405i01.9j';l:$4000;p:$c000;crc:$1c09cc3f),());
        sbasketb_char:tipo_roms=(n:'405e12.22f';l:$4000;p:0;crc:$e02c54da);
        sbasketb_sprites:array[0..3] of tipo_roms=(
        (n:'405h06.14g';l:$4000;p:0;crc:$cfbbff07),(n:'405h08.17g';l:$4000;p:$4000;crc:$c75901b6),
        (n:'405h10.20g';l:$4000;p:$8000;crc:$95bc5942),());
        sbasketb_pal:array[0..5] of tipo_roms=(
        (n:'405e17.5a';l:$100;p:$0;crc:$b4c36d57),(n:'405e16.4a';l:$100;p:$100;crc:$0b7b03b8),
        (n:'405e18.6a';l:$100;p:$200;crc:$9e533bad),(n:'405e20.19d';l:$100;p:$300;crc:$8ca6de2f),
        (n:'405e19.16d';l:$100;p:$400;crc:$e0bc782f),());
        sbasketb_vlm:tipo_roms=(n:'405e15.11f';l:$2000;p:$0;crc:$01bb5ce9);
        sbasketb_snd:tipo_roms=(n:'405e13.7a';l:$2000;p:$0;crc:$1ec7458b);

var
 pedir_snd_irq,pedir_irq:boolean;
 sound_latch,chip_latch:byte;
 scroll,sbasketb_palettebank,sprite_select:byte;
 mem_opcodes:array[0..$9fff] of byte;
 last_addr:word;

implementation
uses principal;

procedure Cargar_sbasketb;
begin
llamadas_maquina.iniciar:=iniciar_sbasketb;
llamadas_maquina.bucle_general:=sbasketb_principal;
llamadas_maquina.cerrar:=cerrar_sbasketb;
llamadas_maquina.reset:=reset_sbasketb;
end;

function iniciar_sbasketb:boolean;
var
      colores:tpaleta;
      f,j:word;
      memoria_temp:array[0..$bfff] of byte;
const
    pc_x:array[0..7] of dword=(0*4, 1*4, 2*4, 3*4, 4*4, 5*4, 6*4, 7*4);
    pc_y:array[0..7] of dword=(0*4*8, 1*4*8, 2*4*8, 3*4*8, 4*4*8, 5*4*8, 6*4*8, 7*4*8);
    ps_x:array[0..15] of dword=(0*4, 1*4,  2*4,  3*4,  4*4,  5*4,  6*4,  7*4,
			8*4, 9*4, 10*4, 11*4, 12*4, 13*4, 14*4, 15*4);
    ps_y:array[0..15] of dword=(0*4*16, 1*4*16,  2*4*16,  3*4*16,  4*4*16,  5*4*16,  6*4*16,  7*4*16,
			8*4*16, 9*4*16, 10*4*16, 11*4*16, 12*4*16, 13*4*16, 14*4*16, 15*4*16);
begin
iniciar_sbasketb:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=224;
p_final[0].y:=256;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[1].scroll.long_x:=256;
p_final[1].scroll.max_x:=256;
p_final[1].scroll.mask_x:=255;
p_final[2].x:=256;
p_final[2].y:=256;
p_final[2].final_mix:=true;
iniciar_video;
//Main CPU
init_cpu(m6809_main,0,1400000);
main_6809_ll.getbyte:=sbasketb_getbyte;
main_6809_ll.putbyte:=sbasketb_putbyte;
//Sound CPU
init_cpu(z80_snd,1,3579545);
snd_z80_ll.getbyte:=sbasketb_snd_getbyte;
snd_z80_ll.putbyte:=sbasketb_snd_putbyte;
//Sound Chip
SN76496_init(0,1789772);
vlm5030_init(4,3579545,$2000,1,3579545);
if not(cargar_roms(chip_vlm.rom,@sbasketb_vlm,'sbasketb.zip',1)) then exit;
dac_init(0);
init_sound_engine(1,3579545,sbasketb_sound);
//cargar roms
if not(cargar_roms(@memoria[0],@sbasketb_rom[0],'sbasketb.zip',0)) then exit;
konami1_decode(@memoria[0],@mem_opcodes[0],$6000);
//cargar snd roms
if not(cargar_roms(@mem_snd[0],@sbasketb_snd,'sbasketb.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@sbasketb_char,'sbasketb.zip',1)) then exit;
init_gfx(0,8,8,512);
des_gfx.pos_planos[0]:=0;
des_gfx.pos_planos[1]:=1;
des_gfx.pos_planos[2]:=2;
des_gfx.pos_planos[3]:=3;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=8*4*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],true,false);
//sprites
if not(cargar_roms(@memoria_temp[0],@sbasketb_sprites[0],'sbasketb.zip',0)) then exit;
init_gfx(1,16,16,384);
gfx[1].trans[0]:=true;
des_gfx.long_sprites:=32*4*8;
convert_gfx(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],true,false);
//paleta
if not(cargar_roms(@memoria_temp[0],@sbasketb_pal[0],'sbasketb.zip',0)) then exit;
for f:=0 to $ff do begin
  colores[f].r:=((memoria_temp[f] and $f) shl 4) or (memoria_temp[f] and $f);
  colores[f].g:=((memoria_temp[f+$100] and $f) shl 4) or (memoria_temp[f+$100] shr 4);
  colores[f].b:=((memoria_temp[f+$200] and $f) shl 4) or (memoria_temp[f+$200] and $f);
end;
set_pal(colores,256);
for f:=0 to 255 do begin
    gfx[0].colores[f]:=(memoria_temp[$300+f] and $f) or $f0;
		for j:=0 to 15 do gfx[1].colores[(j shl 8) or f]:=((j shl 4) or (memoria_temp[f + $400] and $0f));
end;
//final
reset_sbasketb;
iniciar_sbasketb:=true;
end;

procedure cerrar_sbasketb;
begin
cerrar_cpus;
SN76496_close(0);
vlm5030_close;
dac_close(0);
close_audio;
close_video;
end;

procedure reset_sbasketb;
begin
 reset_6809(main_6809,main_6809_ll);
 reset_z80(snd_z80);
 vlm5030_reset;
 dac_reset(0);
 reset_audio;
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
 pedir_snd_irq:=false;
 pedir_irq:=false;
 sound_latch:=0;
 chip_latch:=0;
 scroll:=0;
 sbasketb_palettebank:=0;
 sprite_select:=0;
 last_addr:=0;
end;

procedure update_video_sbasketb;inline;
var
  x,y:byte;
  f:word;
  nchar,color,offset:word;
  atrib:byte;
begin
for f:=0 to $3ff do begin
   if gfx[0].buffer[f] then begin
      x:=31-(f div 32);
      y:=f mod 32;
      atrib:=memoria[$3000+f];
      nchar:=memoria[$3400+f]+((atrib and $20) shl 3);
      color:=(atrib and $f) shl 4;
      put_gfx_flip(x*8,y*8,nchar,color,1,0,(atrib and $80)<>0,(atrib and $40)<>0);
      gfx[0].buffer[f]:=false;
   end;
end;
//La parte de arriba es fija...
actualiza_trozo(0,0,256,48,1,0,0,256,48,2);
scroll__x_part(1,2,scroll,0,48,208);
offset:=(sprite_select and $1)*$100;
for f:=0 to $3f do begin
  atrib:=memoria[$3801+offset+(f*4)];
  nchar:=memoria[$3800+offset+(f*4)]+((atrib and $20) shl 3);
  y:=memoria[$3802+offset+(f*4)];
  x:=240-(memoria[$3803+offset+(f*4)]);
  color:=((atrib and $0f)+16*sbasketb_palettebank) shl 4;
  put_gfx_sprite(nchar,color,(atrib and $80)<>0,(atrib and $40)<>0,1);
  actualiza_gfx_sprite(x,y,2,1);
end;
actualiza_trozo_final(16,0,224,256,2);
end;

procedure eventos_sbasketb;
begin
if event.arcade then begin
  if arcade_input.down[0] then in1:=(in1 and $f7) else in1:=(in1 or $8);
  if arcade_input.up[0] then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if arcade_input.right[0] then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if arcade_input.left[0] then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if arcade_input.but0[0] then in1:=(in1 and $df) else in1:=(in1 or $20);
  if arcade_input.but1[0] then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if arcade_input.but2[0] then in1:=(in1 and $bf) else in1:=(in1 or $40);
  if arcade_input.start[0] then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if arcade_input.start[1] then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if arcade_input.coin[0] then in0:=(in0 and $fe) else in0:=(in0 or 1);
  if arcade_input.coin[1] then in0:=(in0 and $fd) else in0:=(in0 or 2);
end;
end;

procedure sbasketb_principal;
var
  frame_m,frame_s:single;
begin
init_controls(false,false,false,true);
frame_m:=main_6809.tframes;
frame_s:=snd_z80.tframes;
while EmuStatus=EsRuning do begin
  //main
  run_6809(main_6809,main_6809_ll,trunc(frame_m));
  frame_m:=frame_m+main_6809.tframes-main_6809.contador;
  main_6809.pedir_irq:=HOLD_LINE;
  //sound
  run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
  frame_s:=frame_s+snd_z80.tframes-snd_z80.contador;
  //General
  update_video_sbasketb;
  eventos_sbasketb;
  video_sync;
end;
end;

function sbasketb_getbyte(direccion:word):byte;
begin
case direccion of
  $2000..$3bff:sbasketb_getbyte:=memoria[direccion];
  $3e00:sbasketb_getbyte:=in0;
  $3e01:sbasketb_getbyte:=in1;
  $3e02:sbasketb_getbyte:=$ff;
  $3e80:sbasketb_getbyte:=$68;
  $3f00:sbasketb_getbyte:=$ff;
  $6000..$ffff:if main_6809.opcode then sbasketb_getbyte:=mem_opcodes[direccion-$6000]
                  else sbasketb_getbyte:=memoria[direccion];
 end;
end;

procedure sbasketb_putbyte(direccion:word;valor:byte);
begin
if direccion>$5FFF then exit;
memoria[direccion]:=valor;
case direccion of
  $3000..$37ff:gfx[0].buffer[direccion and $3ff]:=true;
  $3c20:sbasketb_palettebank:=valor;
  $3c80:main_screen.flip_main_screen:=(valor and $1)<>0;
  $3c81:pedir_irq:=(valor<>0);
  $3c85:sprite_select:=valor;
  $3d00:sound_latch:=valor;
  $3d80:snd_z80.pedir_irq:=HOLD_LINE;
  $3f80:scroll:=256-valor;
end;
end;

function sbasketb_snd_getbyte(direccion:word):byte;
var
  clock:integer;
begin
case direccion of
  0..$1fff,$4000..$43ff:sbasketb_snd_getbyte:=mem_snd[direccion];
  $6000:sbasketb_snd_getbyte:=sound_latch;
  $8000:begin
          clock:=snd_z80.contador div 1024;
          sbasketb_snd_getbyte:=(clock and $3) or ((vLM5030_BSY and 1) shl 2);
        end;
end;
end;

procedure sbasketb_snd_putbyte(direccion:word;valor:byte);
var
  changes,offset:integer;
begin
if direccion<$2000 then exit;
mem_snd[direccion]:=valor;
case direccion of
    $a000:VLM5030_data_w(valor);
    $c000..$dfff:begin
                  offset:=direccion and $1fff;
                  changes:=offset xor last_addr;
                  // A4 VLM5030 ST pin */
                  if (changes and $10)<>0 then VLM5030_ST((offset and $10) shl 4);
                  // A5 VLM5030 RST pin */
                  if (changes and $20)<>0 then VLM5030_RST((offset and $20) shl 5);
                  last_addr:=offset;
                 end;
    $e000:dac_data_w(0,valor);
    $e001:chip_latch:=valor;
    $e002:SN76496_Write(0,chip_latch);
end;
end;

procedure sbasketb_sound;
begin
  SN76496_Update(0);
  DAC_update(0);
end;

end.
