unit tigerroad_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     m68000,main_engine,controls_engine,gfx_engine,z80,ym_2203,
     rom_engine,cpu_engine,pal_engine,sound_engine;

procedure Cargar_tigeroad;
procedure tigeroad_principal;
function iniciar_tigeroad:boolean;
procedure reset_tigeroad;
procedure cerrar_tigeroad;
//Main CPU
function tigeroad_getword(direccion:dword):word;
procedure tigeroad_putword(direccion:dword;valor:word);
//Sound CPU
function tigeroad_snd_getbyte(direccion:word): Byte;
procedure tigeroad_snd_putbyte(direccion:word;valor:byte);
procedure snd_irq(numchip:integer;irqstate:integer);
procedure tigeroad_despues_instruccion;

const
        //Tiger Road
        tigeroad_rom:array[0..2] of tipo_roms=(
        (n:'tru02.bin';l:$20000;p:0;crc:$8d283a95),(n:'tru04.bin';l:$20000;p:$1;crc:$72e2ef20),());
        tigeroad_char:tipo_roms=(n:'tr01.bin';l:$8000;p:0;crc:$74a9f08c);
        tigeroad_fondo:array[0..8] of tipo_roms=(
        (n:'tr-01a.bin';l:$20000;p:0;crc:$a8aa2e59),(n:'tr-04a.bin';l:$20000;p:$20000;crc:$8863a63c),
        (n:'tr-02a.bin';l:$20000;p:$40000;crc:$1a2c5f89),(n:'tr05.bin';l:$20000;p:$60000;crc:$5bf453b3),
        (n:'tr-03a.bin';l:$20000;p:$80000;crc:$1e0537ea),(n:'tr-06a.bin';l:$20000;p:$a0000;crc:$b636c23a),
        (n:'tr-07a.bin';l:$20000;p:$c0000;crc:$5f907d4d),(n:'tr08.bin';l:$20000;p:$e0000;crc:$adee35e2),());
        tigeroad_fondo_rom:tipo_roms=(n:'tr13.bin';l:$8000;p:0;crc:$a79be1eb);
        tigeroad_sprites:array[0..4] of tipo_roms=(
        (n:'tr-09a.bin';l:$20000;p:0;crc:$3d98ad1e),(n:'tr-10a.bin';l:$20000;p:$20000;crc:$8f6f03d7),
        (n:'tr-11a.bin';l:$20000;p:$40000;crc:$cd9152e5),(n:'tr-12a.bin';l:$20000;p:$60000;crc:$7d8a99d0),());
        tigeroad_sound:tipo_roms=(n:'tru05.bin';l:$8000;p:0;crc:$f9a7c9bf);
        //F1 Dream
        f1dream_rom:array[0..2] of tipo_roms=(
        (n:'06j_02.bin';l:$20000;p:0;crc:$3c2ec697),(n:'06k_03.bin';l:$20000;p:$1;crc:$85ebad91),());
        f1dream_char:tipo_roms=(n:'10d_01.bin';l:$8000;p:0;crc:$361caf00);
        f1dream_fondo:array[0..6] of tipo_roms=(
        (n:'03f_12.bin';l:$10000;p:0;crc:$bc13e43c),(n:'01f_10.bin';l:$10000;p:$10000;crc:$f7617ad9),
        (n:'03h_14.bin';l:$10000;p:$20000;crc:$e33cd438),(n:'02f_11.bin';l:$10000;p:$30000;crc:$4aa49cd7),
        (n:'17f_09.bin';l:$10000;p:$40000;crc:$ca622155),(n:'02h_13.bin';l:$10000;p:$50000;crc:$2a63961e),());
        f1dream_fondo_rom:tipo_roms=(n:'07l_15.bin';l:$8000;p:0;crc:$978758b7);
        f1dream_sprites:array[0..4] of tipo_roms=(
        (n:'03b_06.bin';l:$10000;p:0;crc:$5e54e391),(n:'02b_05.bin';l:$10000;p:$10000;crc:$cdd119fd),
        (n:'03d_08.bin';l:$10000;p:$20000;crc:$811f2e22),(n:'02d_07.bin';l:$10000;p:$30000;crc:$aa9a1233),());
        f1dream_sound:tipo_roms=(n:'12k_04.bin';l:$8000;p:0;crc:$4b9a7524);

type
    tipo_func_proteccion=procedure(valor:word);

var
 scroll_x,scroll_y:word;
 rom:array[0..$3ffff] of byte;
 ram:array[0..$3fff] of byte;
 sprite_ram:array[0..$1010] of byte;
 video_ram:array[0..$7ff] of byte;
 fondo_rom:array[0..$7fff] of byte;
 pintar_fondo:boolean;
 fondo_bank,sound_latch:byte;
 mask_sprite,mask_back:word;
 func_proteccion:tipo_func_proteccion;

implementation
uses principal;

procedure Cargar_tigeroad;
begin
llamadas_maquina.iniciar:=iniciar_tigeroad;
llamadas_maquina.bucle_general:=tigeroad_principal;
llamadas_maquina.cerrar:=cerrar_tigeroad;
llamadas_maquina.reset:=reset_tigeroad;
llamadas_maquina.fps_max:=60.08;
end;

procedure f1dream_protec(valor:word);
const
  f1dream_613ea_lookup:array[0..15] of word=(
    $0052, $0031, $00a7, $0043, $0007, $008a, $00b1, $0066, $009f, $00cc, $0009, $004d, $0033, $0028, $00d0, $0025);
  f1dream_613eb_lookup:array[0..255] of word=(
    $0001, $00b5, $00b6, $00b6, $00b6, $00b6, $00b6, $00b6, $00b7, $0001, $00b8, $002f, $002f, $002f, $002f, $00b9,
    $00aa, $0031, $00ab, $00ab, $00ab, $00ac, $00ad, $00ad, $00ae, $00af, $00b0, $00b1, $00b2, $00b3, $00b4, $0091,
    $009c, $009d, $009e, $009f, $00a0, $00a1, $00a2, $00a3, $00a4, $00a5, $00a6, $00a7, $00a8, $00a9, $009b, $0091,
    $00bc, $0092, $000b, $0009, $0093, $0094, $0095, $0096, $0097, $0073, $0001, $0098, $0099, $009a, $009b, $0091,
    $00bc, $007b, $000b, $0008, $0087, $0088, $0089, $008a, $007f, $008b, $008c, $008d, $008e, $008f, $0090, $0091,
    $00bd, $007b, $000b, $0007, $007c, $007d, $007e, $0001, $007f, $0080, $0081, $0082, $0083, $0084, $0085, $0086,
    $00bc, $0070, $000b, $0006, $0071, $0072, $0073, $0001, $0074, $000d, $0075, $0076, $0077, $0078, $0079, $007a,
    $00bc, $00ba, $000a, $0005, $0065, $0066, $0067, $0068, $0068, $0069, $006a, $006b, $006c, $006d, $006e, $006f,
    $00bc, $0059, $0001, $0004, $005a, $005b, $0001, $005c, $005d, $005e, $005f, $0060, $0061, $0062, $0063, $0064,
    $0014, $004d, $0001, $0003, $004e, $004f, $0050, $0051, $0052, $0001, $0053, $0054, $0055, $0056, $0057, $0058,
    $0014, $0043, $0001, $0002, $0044, $0045, $0046, $0047, $0048, $0049, $00bb, $004a, $004b, $004c, $0001, $0001,
    $0014, $002b, $0001, $0038, $0039, $003a, $003b, $0031, $003c, $003d, $003e, $003f, $0040, $0041, $0042, $0001,
    $0014, $002d, $0001, $002e, $002f, $0030, $0031, $0032, $0033, $0034, $0035, $0036, $0001, $0014, $0037, $0001,
    $0014, $0021, $0022, $0023, $0024, $0025, $0026, $0027, $0028, $0029, $0001, $0001, $0001, $002a, $002b, $002c,
    $0014, $0015, $0016, $0017, $0018, $0019, $001a, $001b, $001c, $001d, $001e, $001e, $001e, $001e, $001f, $0020,
    $000c, $000d, $000e, $0001, $000f, $0010, $0011, $0012, $000d, $000d, $000d, $000d, $000d, $000d, $000d, $0013);
  f1dream_17b74_lookup:array[0..127] of word=(
    $0003, $0040, $0005, $0080, $0003, $0080, $0005, $00a0, $0003, $0040, $0005, $00c0, $0003, $0080, $0005, $00e0,
    $0003, $0040, $0006, $0000, $0003, $0080, $0006, $0020, $0003, $0040, $0006, $0040, $0003, $0080, $0006, $0060,
    $0000, $00a0, $0009, $00e0, $0000, $00e0, $000a, $0000, $0000, $00a0, $000a, $0020, $0000, $00e0, $000a, $0040,
    $0000, $00a0, $000a, $0060, $0000, $00e0, $000a, $0080, $0000, $00a0, $000a, $00a0, $0000, $00e0, $000a, $00c0,
    $0003, $0040, $0005, $0080, $0003, $0080, $0005, $00a0, $0003, $0040, $0005, $00c0, $0003, $0080, $0005, $00e0,
    $0003, $0040, $0006, $0000, $0003, $0080, $0006, $0020, $0003, $0040, $0006, $0040, $0003, $0080, $0006, $0060,
    $0000, $00a0, $0009, $00e0, $0000, $00e0, $000a, $0000, $0000, $00a0, $000a, $0020, $0000, $00e0, $000a, $0040,
    $0000, $00a0, $000a, $0060, $0000, $00e0, $000a, $0080, $0000, $00a0, $000a, $00a0, $0000, $00e0, $000a, $00c0);
  f1dream_2450_lookup:array[0..31] of word=(
    $0003, $0080, $0006, $0060, $0000, $00e0, $000a, $00c0, $0003, $0080, $0006, $0060, $0000, $00e0, $000a, $00c0,
    $0003, $0080, $0006, $0060, $0000, $00e0, $000a, $00c0, $0003, $0080, $0006, $0060, $0000, $00e0, $000a, $00c0);
var
  value,temp:word;
  indx:integer;
begin
  value:=$ff00;
  case main_68000.ppc.l of
    $244c:begin	// Called once, when a race is started
		        indx:=ram[$3ff1] or (ram[$3ff0] shl 8);
            temp:=f1dream_2450_lookup[indx];
            ram[$3fe6]:=temp shr 8;
            ram[$3fe7]:=temp and $ff;
            temp:=f1dream_2450_lookup[indx+1];
            ram[$3fe8]:=temp shr 8;
            ram[$3fe9]:=temp and $ff;
            temp:=f1dream_2450_lookup[indx+2];
            ram[$3fea]:=temp shr 8;
            ram[$3feb]:=temp and $ff;
            temp:=f1dream_2450_lookup[indx+3];
            ram[$3fec]:=temp shr 8;
            ram[$3fed]:=temp and $ff;
	        end;
	  $613a:begin // Called for every sprite on-screen
            temp:=ram[$3ff7] or (ram[$3ff6] shl 8);
		        if (temp<15) then begin
        			indx:=f1dream_613ea_lookup[temp]-(ram[$3ff5] or (ram[$3ff4] shl 8));
        			if (indx>255) then begin
        				indx:=(indx shl 4)+temp;
        				value:=f1dream_613eb_lookup[indx and $ff];
			        end;
		        end;
		        ram[$3ff2]:=value shr 8;
            ram[$3ff3]:=value and $ff;
          end;
    $17b70:begin // Called only before a real race, not a time trial
            temp:=ram[$3ff1] or (ram[$3ff0] shl 8);
        		if (temp>=$04) then indx:=128
		          else if (temp>$02) then indx:=96
		            else if (temp=$02) then indx:=64
		              else if (temp=$01) then indx:=32
		                else indx:=0;
		        indx:=indx+(ram[$3fef] or (ram[$3fee] shl 8));
		        if (indx<128) then begin
              temp:=f1dream_17b74_lookup[indx];
              ram[$3fe6]:=temp shr 8;
              ram[$3fe7]:=temp and $ff;
              temp:=f1dream_17b74_lookup[indx+1];
              ram[$3fe8]:=temp shr 8;
              ram[$3fe9]:=temp and $ff;
              temp:=f1dream_17b74_lookup[indx+2];
              ram[$3fea]:=temp shr 8;
              ram[$3feb]:=temp and $ff;
              temp:=f1dream_17b74_lookup[indx+3];
              ram[$3fec]:=temp shr 8;
              ram[$3fed]:=temp and $ff;
		        end else begin
        			ram[$3fe6]:=$ff;
              ram[$3fe7]:=0;
        			ram[$3fe8]:=$ff;
              ram[$3fe9]:=0;
        			ram[$3fea]:=$ff;
              ram[$3feb]:=0;
        			ram[$3fec]:=$ff;
              ram[$3fed]:=0;
		        end;
	        end;
	  $27f8,$511a,$5142,$516a:sound_latch:=ram[$3ffd]+(ram[$3ffc] shl 8); // The main CPU stuffs the byte for the soundlatch into $fffffd
  end;
end;

procedure tiger_road_sound(valor:word);
begin
  sound_latch:=valor shr 8;
end;

function iniciar_tigeroad:boolean;
var
  memoria_temp:pbyte;
const
  pb_x:array[0..31] of dword=(0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3,
		64*8+0, 64*8+1, 64*8+2, 64*8+3, 64*8+8+0, 64*8+8+1, 64*8+8+2, 64*8+8+3,
		2*64*8+0, 2*64*8+1, 2*64*8+2, 2*64*8+3, 2*64*8+8+0, 2*64*8+8+1, 2*64*8+8+2, 2*64*8+8+3,
		3*64*8+0, 3*64*8+1, 3*64*8+2, 3*64*8+3, 3*64*8+8+0, 3*64*8+8+1, 3*64*8+8+2, 3*64*8+8+3);
  pb_y:array[0..31] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16,
		8*16, 9*16, 10*16, 11*16, 12*16, 13*16, 14*16, 15*16,
		16*16, 17*16, 18*16, 19*16, 20*16, 21*16, 22*16, 23*16,
		24*16, 25*16, 26*16, 27*16, 28*16, 29*16, 30*16, 31*16);
  pc_x:array[0..7] of dword=(0, 1, 2, 3, 8+0, 8+1, 8+2, 8+3);
  pc_y:array[0..7] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16 );
  ps_x:array[0..15] of dword=(0, 1, 2, 3, 4, 5, 6, 7,
			16*8+0, 16*8+1, 16*8+2, 16*8+3, 16*8+4, 16*8+5, 16*8+6, 16*8+7 );
  ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
			8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8 );

procedure tiger_road_chars;
begin
init_gfx(0,8,8,$800);
gfx[0].trans[3]:=true;
des_gfx.pos_planos[0]:=4;
des_gfx.pos_planos[1]:=0;
des_gfx.bit_pixel:=2;
des_gfx.banks:=0;
des_gfx.long_sprites:=16*8;
convert_gfx(@gfx[0],0,memoria_temp,@pc_x[0],@pc_y[0],false,false);
end;

procedure tiger_road_tiles(nchars:word);
var
  f:byte;
begin
init_gfx(1,32,32,nchars);
for f:=0 to 8 do gfx[1].trans[f]:=true;
des_gfx.pos_planos[0]:=nchars*256*8+4;
des_gfx.pos_planos[1]:=nchars*256*8+0;
des_gfx.pos_planos[2]:=4;
des_gfx.pos_planos[3]:=0;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=256*8;
convert_gfx(@gfx[1],0,memoria_temp,@pb_x[0],@pb_y[0],false,false);
end;

procedure tiger_road_sprites(nchars:word);
begin
init_gfx(2,16,16,nchars);
gfx[2].trans[15]:=true;
des_gfx.pos_planos[0]:=nchars*32*8*3;
des_gfx.pos_planos[1]:=nchars*32*8*2;
des_gfx.pos_planos[2]:=nchars*32*8*1;
des_gfx.pos_planos[3]:=nchars*32*8*0;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=32*8;
convert_gfx(@gfx[2],0,memoria_temp,@ps_x[0],@ps_y[0],false,false);
end;

begin
iniciar_tigeroad:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=256;
p_final[0].y:=224;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[1].trans:=true;
p_final[2].x:=288;
p_final[2].y:=288;
p_final[2].scroll.long_x:=288;
p_final[2].scroll.long_y:=288;
p_final[2].scroll.max_x:=256;
p_final[2].scroll.max_y:=256;
p_final[2].scroll.mask_x:=255;
p_final[2].scroll.mask_y:=255;
p_final[3].x:=256;
p_final[3].y:=256;
p_final[3].final_mix:=true;
p_final[3].sprite_end_x:=512;
p_final[3].sprite_mask_x:=$1ff;
p_final[3].sprite_end_y:=512;
p_final[3].sprite_mask_y:=$1ff;
p_final[4].x:=288;
p_final[4].y:=288;
p_final[4].trans:=true;
p_final[4].scroll:=p_final[2].scroll;
iniciar_video;
//Main CPU
init_cpu(m68000_main,0,10000000);
main_68000_ll.getword:=tigeroad_getword;
main_68000_ll.putword:=tigeroad_putword;
//Sound CPU
init_cpu(z80_snd,1,3579545);
snd_z80_ll.getbyte:=tigeroad_snd_getbyte;
snd_z80_ll.putbyte:=tigeroad_snd_putbyte;
//sound chips
YM2203_Init(0,1,3579545,3579545,1,nil,nil,nil,nil,snd_irq);
YM2203_Init(1,1,3579545,3579545,1,nil,nil,nil,nil,nil);
init_sound_engine(1,3579545,tigeroad_despues_instruccion);
getmem(memoria_temp,$100000);
case main_vars.tipo_maquina of
  52:begin
        func_proteccion:=tiger_road_sound;
        if not(cargar_roms16b(@rom[0],@tigeroad_rom[0],'tigeroad.zip',0)) then exit;
        if not(cargar_roms(@mem_snd[0],@tigeroad_sound,'tigeroad.zip',1)) then exit;
        //convertir chars
        if not(cargar_roms(memoria_temp,@tigeroad_char,'tigeroad.zip',1)) then exit;
        tiger_road_chars;
        //background
        mask_sprite:=$fff;
        mask_back:=$7ff;
        if not(cargar_roms(@fondo_rom[0],@tigeroad_fondo_rom,'tigeroad.zip',1)) then exit;
        if not(cargar_roms(memoria_temp,@tigeroad_fondo,'tigeroad.zip',0)) then exit;
        tiger_road_tiles($800);
        //sprites
        if not(cargar_roms(memoria_temp,@tigeroad_sprites,'tigeroad.zip',0)) then exit;
        tiger_road_sprites($1000);
     end;
  53:begin
        func_proteccion:=f1dream_protec;
        if not(cargar_roms16b(@rom[0],@f1dream_rom[0],'f1dream.zip',0)) then exit;
        if not(cargar_roms(@mem_snd[0],@f1dream_sound,'f1dream.zip',1)) then exit;
        //convertir chars
        if not(cargar_roms(memoria_temp,@f1dream_char,'f1dream.zip',1)) then exit;
        tiger_road_chars;
        //background
        mask_sprite:=$7ff;
        mask_back:=$3ff;
        if not(cargar_roms(@fondo_rom[0],@f1dream_fondo_rom,'f1dream.zip',1)) then exit;
        if not(cargar_roms(memoria_temp,@f1dream_fondo,'f1dream.zip',0)) then exit;
        tiger_road_tiles($300);
        //sprites
        if not(cargar_roms(memoria_temp,@f1dream_sprites,'f1dream.zip',0)) then exit;
        tiger_road_sprites($800);
     end;
end;
//final
freemem(memoria_temp);
reset_tigeroad;
iniciar_tigeroad:=true;
end;

procedure cerrar_tigeroad;
begin
cerrar_cpus;
ym2203_close(0);
ym2203_close(1);
close_audio;
close_video;
end;

procedure reset_tigeroad;
begin
 reset_68000(main_68000,main_68000_ll);
 reset_z80(snd_z80);
 ym2203_reset(0);
 ym2203_reset(1);
 reset_audio;
 in0:=$FF;
 in1:=$FF;
 if main_vars.tipo_maquina=52 then in2:=$fb
  else in2:=$bb;
 scroll_x:=0;
 scroll_y:=0;
 pintar_fondo:=true;
 fondo_bank:=0;
 sound_latch:=0;
end;

procedure draw_fondo;inline;
var
  nchar,color,pos:word;
  x,y,f,data,atrib,sx,sy:byte;
begin
for f:=0 to $50 do begin
  x:=f div 9;
  y:=f mod 9;
  sx:=(x+((scroll_x and $fe0) shr 5)) and $7f;
  sy:=(y+((scroll_y and $fe0) shr 5)) and $7f;
  pos:=(((sx and 7) shl 1)+(((127-sy) and $7) shl 4)+((sx shr 3) shl 7)+(((127-sy) shr 3) shl 11)) and $7fff;
  data:=fondo_rom[pos];
  atrib:=fondo_rom[pos+1];
  nchar:=(data+((atrib and $c0) shl 2)+(fondo_bank shl 10)) and mask_back;
  color:=(atrib and $0f) shl 4;
  put_gfx_flip(x shl 5,y shl 5,nchar,color,2,1,(atrib and $20)<>0,false);
  if (atrib and $10)<>0 then put_gfx_trans_flip(x shl 5,y shl 5,nchar,color,4,1,(atrib and $20)<>0,false)
    else put_gfx_block_trans(x shl 5,y shl 5,4,32,32);
end;
pintar_fondo:=false;
end;

procedure update_video_tigeroad;inline;
var
  f,color,x,y,nchar,atrib:word;
begin
//background
if pintar_fondo then draw_fondo;
scroll_x_y(2,3,scroll_x and $1f,scroll_y and $1f);
//sprites
for f:=$9f downto 0 do begin
    nchar:=((sprite_ram[(f*8)] shl 8)+sprite_ram[(f*8)+1]) and mask_sprite;
    atrib:=(sprite_ram[(f*8)+2] shl 8)+sprite_ram[(f*8)+3];
  	y:=240-((sprite_ram[(f*8)+4] shl 8)+sprite_ram[(f*8)+5]);
		x:=(sprite_ram[(f*8)+6] shl 8)+sprite_ram[(f*8)+7];
		color:=(((atrib shr 2) and $f) shl 4)+$100;
    put_gfx_sprite(nchar,color,(atrib and 2)<>0,(atrib and 1)<>0,2);
    actualiza_gfx_sprite(x,y,3,2);
end;
scroll_x_y(4,3,scroll_x and $1f,scroll_y and $1f);
//foreground
for f:=$0 to $3ff do begin
  atrib:=video_ram[f*2];
  color:=atrib and $f;
  if ((gfx[0].buffer[f]) or (gfx[0].color_buffer[color])) then begin
    x:=f mod 32;
    y:=f div 32;
    nchar:=video_ram[(f*2)+1]+((atrib and $c0) shl 2)+((atrib and $20) shl 5);
    put_gfx_trans_flip(x*8,y*8,nchar,(color shl 2)+512,1,0,false,(atrib and $10)<>0);
    gfx[0].buffer[f]:=false;
  end;
end;
fillchar(gfx[0].color_buffer[0],$10,0);
actualiza_trozo(0,0,256,256,1,0,0,256,256,3);
actualiza_trozo_final(0,16,256,224,3);
end;

procedure eventos_tigeroad;
begin
if event.arcade then begin
  if arcade_input.up[0] then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if arcade_input.down[0] then in0:=(in0 and $Fb) else in0:=(in0 or $4);
  if arcade_input.left[0] then in0:=(in0 and $fd) else in0:=(in0 or $2);
  if arcade_input.right[0] then in0:=(in0 and $Fe) else in0:=(in0 or $1);
  if arcade_input.but1[0] then in0:=(in0 and $df) else in0:=(in0 or $20);
  if arcade_input.but0[0] then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if arcade_input.coin[0] then in1:=(in1 and $bf) else in1:=(in1 or $40);
  if arcade_input.coin[1] then in1:=(in1 and $7f) else in1:=(in1 or $80);
  if arcade_input.start[0] then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if arcade_input.start[1] then in1:=(in1 and $fd) else in1:=(in1 or $2);
end;
end;

procedure tigeroad_principal;
var
  frame_m,frame_s:single;
begin
init_controls(false,false,false,true);
frame_m:=main_68000.tframes;
frame_s:=snd_z80.tframes;
while EmuStatus=EsRuning do begin
  //Main CPU
  run_68000(main_68000,main_68000_ll,trunc(frame_m));
  frame_m:=frame_m+main_68000.tframes-main_68000.contador;
  main_68000.irq[2]:=HOLD_LINE;
  //Sound CPU
  run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
  frame_s:=frame_s+snd_z80.tframes-snd_z80.contador;
  update_video_tigeroad;
  eventos_tigeroad;
  video_sync;
end;
end;

procedure cambiar_color(tmp_color,numero:word);inline;
var
  color:tcolor;
begin
  color.r:=pal4bit(tmp_color shr 8);
  color.g:=pal4bit(tmp_color shr 4);
  color.b:=pal4bit(tmp_color);
  set_pal_color(color,addr(paleta[numero]));
  case numero of
    0..$ff:pintar_fondo:=true;
    512..575:gfx[0].color_buffer[(numero shr 2) and $f]:=true;
  end;
end;

function tigeroad_getword(direccion:dword):word;
var
  tempw:word;
begin
direccion:=direccion and $fffffe;
case direccion of
  0..$3ffff:tigeroad_getword:=rom[direccion+1] or (rom[direccion] shl 8);
  $fe4000:tigeroad_getword:=$ff00 or in0;
  $fe4002:tigeroad_getword:=(in1 shl 8) or $ff;
  $fe4004:tigeroad_getword:=(in2 shl 8) or $ff;
  $fe0800..$fe1807:begin
                      tempw:=direccion-$fe0800;
                      tigeroad_getword:=sprite_ram[tempw+1] or (sprite_ram[tempw] shl 8);
                   end;
  $fec000..$fec7ff:tigeroad_getword:=video_ram[(direccion and $7ff)+1] or (video_ram[direccion and $7ff] shl 8);
  $ff8200..$ff867f:begin
                      tempw:=direccion-$ff8200;
                      tigeroad_getword:=buffer_paleta[tempw+1] or (buffer_paleta[tempw] shl 8);
                   end;
  $ffc000..$ffffff:tigeroad_getword:=ram[(direccion and $3fff)+1] or (ram[direccion and $3fff] shl 8);
end;
end;

procedure tigeroad_putword(direccion:dword;valor:word);
var
  tempw:word;
  bank:byte;
begin
direccion:=direccion and $fffffe;
case direccion of
  $0..$3ffff:exit;
  $fe0800..$fe1807:begin
                      tempw:=direccion-$fe0800;
                      sprite_ram[tempw+1]:=valor and $ff;
                      sprite_ram[tempw]:=valor shr 8;
                   end;
  $fe4000:begin  //video control
             bank:=(valor shr 10) and $1;
          	 if (fondo_bank<>bank) then begin
			          fondo_bank:=bank;
          			pintar_fondo:=true;
             end;
             main_screen.flip_main_screen:=((valor shr 8) and $2)<>0;
          end;
  $fe4002:func_proteccion(valor);
  $fe8000:if scroll_x<>(valor and $fff) then begin
             if abs((scroll_x and $fe0)-(valor and $fe0))>31 then pintar_fondo:=true;
             scroll_x:=valor and $fff;
          end;
  $fe8002:begin
             tempw:=(-valor-256) and $fff;
             if scroll_y<>tempw then begin
              if abs((scroll_y and $fe0)-(tempw and $fe0))>31 then
                pintar_fondo:=true;
              scroll_y:=tempw;
             end;
          end;
  $fec000..$fec7ff:begin
                      video_ram[(direccion and $7ff)+1]:=valor and $ff;
                      video_ram[direccion and $7ff]:=valor shr 8;
                      gfx[0].buffer[(direccion and $7ff) shr 1]:=true;
                   end;
  $ff8200..$ff867f:begin
                      tempw:=direccion-$ff8200;
                      buffer_paleta[tempw+1]:=valor and $ff;
                      buffer_paleta[tempw]:=valor shr 8;
                      cambiar_color(valor,tempw shr 1);
                   end;
  $ffc000..$ffffff:begin
                      ram[(direccion and $3fff)+1]:=valor and $ff;
                      ram[direccion and $3fff]:=valor shr 8;
                   end;
end;
end;

function tigeroad_snd_getbyte(direccion:word):byte;
begin
case direccion of
   $8000:tigeroad_snd_getbyte:=ym2203_Read_Status(0);
   $a000:tigeroad_snd_getbyte:=ym2203_Read_Status(1);
   $e000:tigeroad_snd_getbyte:=sound_latch;
   else tigeroad_snd_getbyte:=mem_snd[direccion];
end;
end;

procedure tigeroad_snd_putbyte(direccion:word;valor:byte);
begin
case direccion of
  $0..$7fff:exit;
  $8000:ym2203_Control(0,valor);
  $8001:ym2203_Write_Reg(0,valor);
  $a000:ym2203_Control(1,valor);
  $a001:ym2203_Write_Reg(1,valor);
  else mem_snd[direccion]:=valor;
end;
end;

procedure snd_irq(numchip:integer;irqstate:integer);
begin
  if (irqstate=1) then snd_z80.pedir_irq:=ASSERT_LINE
    else snd_z80.pedir_irq:=CLEAR_LINE;
end;

procedure tigeroad_despues_instruccion;
begin
  ym2203_Update(0);
  ym2203_Update(1);
end;

end.
