unit toki_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     z80,m68000,main_engine,controls_engine,gfx_engine,ym_3812,oki6295,
     seibu_sound,rom_engine,cpu_engine,pal_engine,sound_engine,misc_functions;

procedure Cargar_toki;
procedure toki_principal;
function iniciar_toki:boolean;
procedure reset_toki;
procedure cerrar_toki;
//Main CPU
function toki_getword(direccion:dword):word;
procedure toki_putword(direccion:dword;valor:word);
//Sound CPU
function toki_snd_getbyte(direccion:word): Byte;
procedure toki_snd_putbyte(direccion:word;valor:byte);
procedure toki_sound_act;
procedure snd_irq(numchip:integer;irqstate:integer);

const
        toki_rom:array[0..4] of tipo_roms=(
        (n:'l10_6.bin';l:$20000;p:0;crc:$94015d91),(n:'k10_4e.bin';l:$20000;p:$1;crc:$531bd3ef),
        (n:'tokijp.005';l:$10000;p:$40000;crc:$d6a82808),(n:'tokijp.003';l:$10000;p:$40001;crc:$a01a5b10),());
        toki_char:array[0..2] of tipo_roms=(
        (n:'tokijp.001';l:$10000;p:0;crc:$8aa964a2),(n:'tokijp.002';l:$10000;p:$10000;crc:$86e87e48),());
        toki_sprites:array[0..2] of tipo_roms=(
        (n:'toki.ob1';l:$80000;p:0;crc:$a27a80ba),(n:'toki.ob2';l:$80000;p:$80000;crc:$fa687718),());
        toki_tiles1:tipo_roms=(n:'toki.bk1';l:$80000;p:0;crc:$fdaa5f4b);
        toki_tiles2:tipo_roms=(n:'toki.bk2';l:$80000;p:0;crc:$d86ac664);
        toki_sound:array[0..2] of tipo_roms=(
        (n:'tokijp.008';l:$2000;p:0;crc:$6c87c4c5),(n:'tokijp.007';l:$10000;p:$10000;crc:$a67969c4),());
        toki_adpcm:tipo_roms=(n:'tokijp.009';l:$20000;p:0;crc:$ae7a6b8b);

var
 rom:array[0..$5ffff] of byte;
 ram:array[0..$d7ff] of byte;
 sound_rom:array[0..1,0..$7fff] of byte;
 decrypt:array[0..$1fff] of byte;
 snd_bank,irq1,irq2:byte;
 sprite_ram,bg1_ram,bg2_ram,fg_ram:array[0..$7ff] of byte;
 scroll_x1,scroll_y1,scroll_x2,scroll_y2:parejas;
 prioridad_pant:boolean;

implementation
uses principal;

procedure Cargar_toki;
begin
llamadas_maquina.iniciar:=iniciar_toki;
llamadas_maquina.bucle_general:=toki_principal;
llamadas_maquina.cerrar:=cerrar_toki;
llamadas_maquina.reset:=reset_toki;
llamadas_maquina.fps_max:=59.61;
end;

function iniciar_toki:boolean; 
const
  pc_x:array[0..7] of dword=(3, 2, 1, 0, 8+3, 8+2, 8+1, 8+0);
  pc_y:array[0..7] of dword=(0*16, 1*16, 2*16, 3*16, 4*16, 5*16, 6*16, 7*16);
  ps_x:array[0..15] of dword=(3, 2, 1, 0, 16+3, 16+2, 16+1, 16+0,
			64*8+3, 64*8+2, 64*8+1, 64*8+0, 64*8+16+3, 64*8+16+2, 64*8+16+1, 64*8+16+0);
  ps_y:array[0..15] of dword=(0*32, 1*32, 2*32, 3*32, 4*32, 5*32, 6*32, 7*32,
			8*32, 9*32, 10*32, 11*32, 12*32, 13*32, 14*32, 15*32);
var
   memoria_temp,ptemp:pbyte;
   f:dword;
   memoria_temp2:array[0..$1ffff] of byte;
begin
iniciar_toki:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=256;
p_final[0].y:=224;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[1].trans:=true;
p_final[2].x:=512;
p_final[2].y:=512;
p_final[2].trans:=true;
p_final[2].scroll.long_x:=512;
p_final[2].scroll.long_y:=512;
p_final[2].scroll.max_x:=256;
p_final[2].scroll.max_y:=256;
p_final[2].scroll.mask_x:=511;
p_final[2].scroll.mask_y:=511;
p_final[3].x:=256;
p_final[3].y:=256;
p_final[3].final_mix:=true;
p_final[3].sprite_end_x:=512;
p_final[3].sprite_mask_x:=$1ff;
p_final[3].sprite_end_y:=512;
p_final[3].sprite_mask_y:=$1ff;
p_final[4].x:=512;
p_final[4].y:=512;
p_final[4].trans:=true;
p_final[4].scroll:=p_final[2].scroll;
iniciar_video;
getmem(memoria_temp,$100000);
//cargar roms
if not(cargar_roms16b(@rom[0],@toki_rom[0],'toki.zip',0)) then exit;
//cargar sonido, desencriptar y poner bancos
if not(cargar_roms(memoria_temp,@toki_sound,'toki.zip',0)) then exit;
decript_seibu_sound(memoria_temp,@decrypt[0],@mem_snd[0]);
ptemp:=memoria_temp;
inc(ptemp,$10000);copymemory(@sound_rom[0,0],ptemp,$8000);
inc(ptemp,$8000);copymemory(@sound_rom[1,0],ptemp,$8000);
//Main CPU
init_cpu(m68000_main,0,10000000/256);
main_68000_ll.getword:=toki_getword;
main_68000_ll.putword:=toki_putword;
//Sound CPU
init_cpu(z80_snd,1,3579545/256);
snd_z80_ll.getbyte:=toki_snd_getbyte;
snd_z80_ll.putbyte:=toki_snd_putbyte;
//Sound Chips
ym3812_init(0,1,3579545,3579545,snd_irq,1);
init_oki6295(0,1000000,OKIM6295_PIN7_HIGH,1,3579545,3);
init_sound_engine(1,3579545,toki_sound_act);
if not(cargar_roms(@memoria_temp2[0],@toki_adpcm,'toki.zip',1)) then exit;
ptemp:=oki_6295[0].rom;
for f:=0 to $1ffff do begin
  ptemp^:=memoria_temp2[BITSWAP24(f,23,22,21,20,19,18,17,16,13,14,15,12,11,10,9,8,7,6,5,4,3,2,1,0)];
  inc(ptemp);
end;
//convertir chars
if not(cargar_roms(memoria_temp,@toki_char,'toki.zip',0)) then exit;
init_gfx(0,8,8,4096);
gfx[0].trans[15]:=true;
des_gfx.pos_planos[0]:=4096*16*8+0;
des_gfx.pos_planos[1]:=4096*16*8+4;
des_gfx.pos_planos[2]:=0;
des_gfx.pos_planos[3]:=4;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=16*8;
convert_gfx(@gfx[0],0,memoria_temp,@pc_x[0],@pc_y[0],false,false);
//sprites
if not(cargar_roms(memoria_temp,@toki_sprites,'toki.zip',0)) then exit;
init_gfx(1,16,16,8192);
gfx[1].trans[15]:=true;
des_gfx.pos_planos[0]:=2*4;
des_gfx.pos_planos[1]:=3*4;
des_gfx.pos_planos[2]:=0*4;
des_gfx.pos_planos[3]:=1*4;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=128*8;
convert_gfx(@gfx[1],0,memoria_temp,@ps_x[0],@ps_y[0],false,false);
//tiles
if not(cargar_roms(memoria_temp,@toki_tiles1,'toki.zip',1)) then exit;
init_gfx(2,16,16,4096);
gfx[2].trans[15]:=true;
convert_gfx(@gfx[2],0,memoria_temp,@ps_x[0],@ps_y[0],false,false);
if not(cargar_roms(memoria_temp,@toki_tiles2,'toki.zip',1)) then exit;
init_gfx(3,16,16,4096);
gfx[3].trans[15]:=true;
convert_gfx(@gfx[3],0,memoria_temp,@ps_x[0],@ps_y[0],false,false);
//final
freemem(memoria_temp);
reset_toki;
iniciar_toki:=true;
end;

procedure cerrar_toki;
begin
cerrar_cpus;
ym3812_close(0);
close_oki6295(0);
close_audio;
close_video;
end;

procedure reset_toki;
begin
 reset_68000(main_68000,main_68000_ll);
 reset_z80(snd_z80);
 YM3812_Reset(0);
 reset_oki6295(0);
 seibu_reset;
 reset_audio;
 in0:=$FF;
 in1:=$FF;
 in2:=0;
 scroll_x1.w:=0;
 scroll_y1.w:=0;
 scroll_x2.w:=0;
 scroll_y2.w:=0;
 snd_bank:=0;
end;

procedure update_video_toki;inline;
var
        f:word;
        color:word;
        sy,x,y,nchar,atrib,atrib2,atrib3:word;
begin
for f:=0 to $3ff do begin
  //Background 1
  atrib:=bg1_ram[$1+(f*2)]+(bg1_ram[(f*2)] shl 8);
  color:=atrib shr 12;
  if ((gfx[2].buffer[f]) or (gfx[2].color_buffer[color])) then begin
    x:=f mod 32;
    y:=f div 32;
    nchar:=atrib and $fff;
    if prioridad_pant then put_gfx(x*16,y*16,nchar,(color shl 4)+$200,2,2)
      else put_gfx_trans(x*16,y*16,nchar,(color shl 4)+$200,2,2);
    gfx[2].buffer[f]:=false;
  end;
  //Background 2
  atrib:=bg2_ram[$1+(f*2)]+(bg2_ram[(f*2)] shl 8);
  color:=atrib shr 12;
  if ((gfx[3].buffer[f]) or (gfx[3].color_buffer[color])) then begin
    x:=f mod 32;
    y:=f div 32;
    nchar:=atrib and $fff;
    if prioridad_pant then put_gfx_trans(x*16,y*16,nchar,(color shl 4)+$300,4,3)
      else put_gfx(x*16,y*16,nchar,(color shl 4)+$300,4,3);
    gfx[3].buffer[f]:=false;
  end;
  //Foreground
  atrib:=fg_ram[$1+(f*2)]+(fg_ram[(f*2)] shl 8);
  color:=atrib shr 12;
  if ((gfx[0].buffer[f]) or (gfx[0].color_buffer[color])) then begin
    x:=f mod 32;
    y:=f div 32;
    nchar:=atrib and $fff;
    put_gfx_trans(x*8,y*8,nchar,(color shl 4)+$100,1,0);
    gfx[0].buffer[f]:=false;
  end;
end;
fillchar(gfx[0].color_buffer[0],$10,0);
fillchar(gfx[2].color_buffer[0],$10,0);
fillchar(gfx[3].color_buffer[0],$10,0);
if prioridad_pant then begin
  scroll_x_y(2,3,scroll_x1.w,scroll_y1.w);
  scroll_x_y(4,3,scroll_x2.w,scroll_y2.w);
end else begin
  scroll_x_y(4,3,scroll_x2.w,scroll_y2.w);
  scroll_x_y(2,3,scroll_x1.w,scroll_y1.w);
end;
for f:=$ff downto 0 do begin
    atrib:=(sprite_ram[(f*8)+0] shl 8)+sprite_ram[(f*8)+1];
    atrib2:=(sprite_ram[(f*8)+4] shl 8)+sprite_ram[(f*8)+5];
		if ((atrib2<>$f000) and (atrib<>$ffff)) then begin
			x:=atrib2+(atrib and $f0);
			sy:=(atrib and $0f) shl 4;
			y:=((sprite_ram[(f*8)+6] shl 8)+sprite_ram[(f*8)+7])+sy;
      atrib3:=(sprite_ram[(f*8)+2] shl 8)+sprite_ram[(f*8)+3];
			color:=(atrib3 shr 8) and $f0;
			nchar:=(atrib3 and $fff)+((atrib2 and $8000) shr 3);
      put_gfx_sprite(nchar,color,(atrib and $100)<>0,false,1);
      actualiza_gfx_sprite(x,y,3,1);
    end;
end;
actualiza_trozo(0,0,256,256,1,0,0,256,256,3);
actualiza_trozo_final(0,16,256,224,3);
end;

procedure eventos_toki;
begin
if event.arcade then begin
  if arcade_input.up[0] then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if arcade_input.down[0] then in0:=(in0 and $Fd) else in0:=(in0 or $2);
  if arcade_input.left[0] then in0:=(in1 and $fb) else in0:=(in0 or $4);
  if arcade_input.right[0] then in0:=(in0 and $F7) else in0:=(in0 or $8);
  if arcade_input.but1[0] then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if arcade_input.but0[0] then in0:=(in0 and $df) else in0:=(in0 or $20);
  if arcade_input.coin[0] then in2:=(in2 or $1) else in2:=(in2 and $fe);
  if arcade_input.coin[1] then in2:=(in2 or $2) else in2:=(in2 and $fd);
  if arcade_input.start[0] then in1:=(in1 and $f7) else in1:=(in1 or $8);
  if arcade_input.start[1] then in1:=(in1 and $ef) else in1:=(in1 or $10);
end;
end;

procedure toki_principal;
var
  frame_m,frame_s:single;
  f:byte;
begin
init_controls(false,false,false,true);
frame_m:=main_68000.tframes;
frame_s:=snd_z80.tframes;
while EmuStatus=EsRuning do begin
   for f:=0 to $ff do begin
     //Main CPU
     run_68000(main_68000,main_68000_ll,trunc(frame_m));
     frame_m:=frame_m+main_68000.tframes-main_68000.contador;
     //Sound CPU
     run_z80(snd_z80,snd_z80_ll,trunc(frame_s));
     frame_s:=frame_s+snd_z80.tframes-snd_z80.contador;
     //Main Loop
     if f=239 then main_68000.irq[1]:=HOLD_LINE;
   end;
   update_video_toki;
   eventos_toki;
   video_sync;
end;
end;

procedure cambiar_color(tmp_color,numero:word);inline;
var
  color:tcolor;
begin
  color.b:=pal4bit(tmp_color shr 8);
  color.g:=pal4bit(tmp_color shr 4);
  color.r:=pal4bit(tmp_color);
  set_pal_color(color,addr(paleta[numero]));
  case numero of
    256..511:gfx[0].color_buffer[(numero shr 4) and $f]:=true;
    512..767:gfx[2].color_buffer[(numero shr 4) and $f]:=true;
    768..1023:gfx[3].color_buffer[(numero shr 4) and $f]:=true;
  end;
end;

function toki_getword(direccion:dword):word;
begin
direccion:=direccion and $fffffe;
case direccion of
    $0..$5ffff:toki_getword:=rom[direccion+1] or (rom[direccion] shl 8);
    $60000..$6d7ff:toki_getword:=ram[(direccion and $ffff)+1] or (ram[(direccion and $ffff)] shl 8);
    $6d800..$6dfff:toki_getword:=sprite_ram[(direccion and $7ff)+1] or (sprite_ram[direccion and $7ff] shl 8);
    $6e000..$6e7ff:toki_getword:=buffer_paleta[(direccion and $7ff)+1] or (buffer_paleta[direccion and $7ff] shl 8);
    $6e800..$6efff:toki_getword:=bg1_ram[(direccion and $7ff)+1] or (bg1_ram[direccion and $7ff] shl 8);
    $6f000..$6f7ff:toki_getword:=bg2_ram[(direccion and $7ff)+1] or (bg2_ram[direccion and $7ff] shl 8);
    $6f800..$6ffff:toki_getword:=fg_ram[(direccion and $7ff)+1] or (fg_ram[direccion and $7ff] shl 8);
    $80000..$8000d:toki_getword:=seibu_get(direccion and $e);
    $c0000:toki_getword:=$ffdf;
    $c0002:toki_getword:=$ff00 or in0;
    $c0004:toki_getword:=in1;
end;
end;

procedure toki_putword(direccion:dword;valor:word);
begin
direccion:=direccion and $fffffe;
if direccion<$60000 then exit;
case direccion of
  $60000..$6d7ff:begin
                  ram[direccion and $ffff]:=valor shr 8;
                  ram[(direccion and $ffff)+1]:=valor and $ff;
                 end;
  $6d800..$6dfff:begin
                    sprite_ram[direccion and $7ff]:=valor shr 8;
                    sprite_ram[(direccion and $7ff)+1]:=valor and $ff;
                 end;
  $6e000..$6e7ff:begin
                    buffer_paleta[direccion and $7ff]:=valor shr 8;
                    buffer_paleta[(direccion and $7ff)+1]:=valor and $ff;
                    cambiar_color(valor,((direccion and $7ff) shr 1));
                 end;
  $6e800..$6efff:begin
                    bg1_ram[direccion and $7ff]:=valor shr 8;
                    bg1_ram[(direccion and $7ff)+1]:=valor and $ff;
                    gfx[2].buffer[(direccion and $7ff) shr 1]:=true;
                 end;
  $6f000..$6f7ff:begin
                    bg2_ram[direccion and $7ff]:=valor shr 8;
                    bg2_ram[(direccion and $7ff)+1]:=valor and $ff;
                    gfx[3].buffer[(direccion and $7ff) shr 1]:=true;
                 end;
  $6f800..$6ffff:begin
                    fg_ram[direccion and $7ff]:=valor shr 8;
                    fg_ram[(direccion and $7ff)+1]:=valor and $ff;
                    gfx[0].buffer[(direccion and $7ff) shr 1]:=true;
                 end;
  $80000..$8000d:seibu_put(direccion and $e,valor);
  $a0000..$a005f:case (direccion and $ff) of
                    $0a:scroll_x1.h:=(valor and $10) shr 4;
                    $0c:scroll_x1.l:=((valor and $7f) shl 1) or ((valor and $80) shr 7);
                    $1a:scroll_y1.h:=(valor and $10) shr 4;
                    $1c:scroll_y1.l:=((valor and $7f) shl 1) or ((valor and $80) shr 7);
                    $2a:scroll_x2.h:=(valor and $10) shr 4;
                    $2c:scroll_x2.l:=((valor and $7f) shl 1) or ((valor and $80) shr 7);
                    $3a:scroll_y2.h:=(valor and $10) shr 4;
                    $3c:scroll_y2.l:=((valor and $7f) shl 1) or ((valor and $80) shr 7);
                    $50:if prioridad_pant<>((valor and $100)<>0) then begin
                          prioridad_pant:=(valor and $100)<>0;
                          fillchar(gfx[2].buffer[0],$400,1);
                          fillchar(gfx[3].buffer[0],$400,1);
                        end;
                 end;
end;
end;

function toki_snd_getbyte(direccion:word):byte;
begin
case direccion of
  0..$1fff:if snd_z80.opcode then toki_snd_getbyte:=decrypt[direccion]
              else toki_snd_getbyte:=mem_snd[direccion];
  $2000..$27ff:toki_snd_getbyte:=mem_snd[direccion];
  $4008:toki_snd_getbyte:=YM3812_status_port(0);
  $4010:toki_snd_getbyte:=sound_latch[0];
  $4011:toki_snd_getbyte:=sound_latch[1];
  $4012:if sub2main_pending then toki_snd_getbyte:=1
          else toki_snd_getbyte:=0;
  $4013:toki_snd_getbyte:=in2;
  $6000:toki_snd_getbyte:=okim6295_r(0);
  $8000..$ffff:toki_snd_getbyte:=sound_rom[snd_bank,direccion and $7fff];
end;
end;

procedure toki_snd_putbyte(direccion:word;valor:byte);
begin
case direccion of
  0..$1fff,$8000..$ffff:exit;
  $2000..$27ff:mem_snd[direccion]:=valor;
  $4000:begin
          main2sub_pending:=false;
        	sub2main_pending:=true;
        end;
  $4001:;//seibu_update_irq_lines(RESET_ASSERT);
  $4002:;
  $4003:seibu_update_irq_lines(RST18_CLEAR);
  $4007:snd_bank:=valor and 1;
  $4008:ym3812_control_port(0,valor);
  $4009:ym3812_write_port(0,valor);
  $4018:sub2main[0]:=valor;
  $4019:sub2main[1]:=valor;
  $6000:okim6295_w(0,valor);
end;
end;

procedure toki_sound_act;
begin
  ym3812_Update(0);
end;

procedure snd_irq(numchip:integer;irqstate:integer);
begin
  if irqstate=0 then seibu_update_irq_lines(RST10_CLEAR)
    else seibu_update_irq_lines(RST10_ASSERT);
end;

end.
