unit xaindsleena_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     m6809,m6805,ym_2203,main_engine,controls_engine,gfx_engine,
     rom_engine,cpu_engine,pal_engine,sound_engine;

procedure Cargar_xain;
procedure xain_principal; 
function iniciar_xain:boolean; 
procedure reset_xain; 
procedure cerrar_xain; 
//CPU
function xain_getbyte(direccion:word): Byte;  
procedure xain_putbyte(direccion:word;valor:byte); 
//Sub CPU
function xain_sub_getbyte(direccion:word): Byte;  
procedure xain_sub_putbyte(direccion:word;valor:byte); 
//Sound CPU
function xain_snd_getbyte(direccion:word): Byte;  
procedure xain_snd_putbyte(direccion:word;valor:byte); 
procedure sound_instruccion; 
procedure snd_irq(numchip:integer;irqstate:integer); 
//MCU CPU
function mcu_xain_hw_getbyte(direccion:word): Byte;  
procedure mcu_xain_hw_putbyte(direccion:word;valor:byte); 

const
        xain_rom:array[0..2] of tipo_roms=(
        (n:'s-10.7d';l:$8000;p:$0;crc:$370164be),(n:'s-11.7c';l:$8000;p:$8000;crc:$d22bf859),());
        xain_sub:array[0..2] of tipo_roms=(
        (n:'s-2.3b';l:$8000;p:$0;crc:$a1a860e2),(n:'s-1.2b';l:$8000;p:$8000;crc:$948b9757),());
        xain_snd:tipo_roms=(n:'s-3.4s';l:$8000;p:$8000;crc:$a5318cb8);
        xain_mcu:tipo_roms=(n:'p1-0.113';l:$800;p:$0;crc:$a432a907);
        xain_char:tipo_roms=(n:'s-12.8b';l:$8000;p:0;crc:$83c00dd8);
        xain_tiles1:array[0..6] of tipo_roms=(
        (n:'s-6.4h';l:$8000;p:0;crc:$5c6c453c),(n:'s-5.4l';l:$8000;p:$8000;crc:$59d87a9a),
        (n:'s-4.4m';l:$8000;p:$10000;crc:$84884a2e),(n:'s-7.4f';l:$8000;p:$20000;crc:$8d637639),
        (n:'s-8.4d';l:$8000;p:$28000;crc:$71eec4e6),(n:'s-9.4c';l:$8000;p:$30000;crc:$7fc9704f),());
        xain_tiles2:array[0..8] of tipo_roms=(
        (n:'s-21.16i';l:$8000;p:0;crc:$11eb4247),(n:'s-22.15i';l:$8000;p:$8000;crc:$422b536e),
        (n:'s-23.14i';l:$8000;p:$10000;crc:$828c1b0c),(n:'s-24.13i';l:$8000;p:$18000;crc:$d37939e0),
        (n:'s-13.16g';l:$8000;p:$20000;crc:$8f0aa1a7),(n:'s-14.15g';l:$8000;p:$28000;crc:$45681910),
        (n:'s-15.14g';l:$8000;p:$30000;crc:$a8eeabc8),(n:'s-16.13g';l:$8000;p:$38000;crc:$e59a2f27),());
        xain_sprites:array[0..8] of tipo_roms=(
        (n:'s-25.10i';l:$8000;p:0;crc:$252976ae),(n:'s-26.9i';l:$8000;p:$8000;crc:$e6f1e8d5),
        (n:'s-27.8i';l:$8000;p:$10000;crc:$785381ed),(n:'s-28.7i';l:$8000;p:$18000;crc:$59754e3d),
        (n:'s-17.10g';l:$8000;p:$20000;crc:$4d977f33),(n:'s-18.9g';l:$8000;p:$28000;crc:$3f3b62a0),
        (n:'s-19.8g';l:$8000;p:$30000;crc:$76641ee3),(n:'s-20.7g';l:$8000;p:$38000;crc:$37671f36),());

var
 main_rom,sub_rom:array[0..1,0..$3FFF] of byte;
 banco_main,banco_sub,soundlatch,xain_pri,vblank:byte;
 scroll_x_p1,scroll_y_p1,scroll_x_p0,scroll_y_p0:parejas;
 //mcu
 mcu_mem:array[0..$7ff] of byte;
 port_c_in,port_c_out,port_b_out,port_b_in,port_a_in,port_a_out:byte;
 ddr_a,ddr_b,ddr_c:byte;
 mcu_ready,mcu_accept,main_accept,from_main,main_ready,from_mcu:byte;

implementation
uses principal;

procedure Cargar_xain;
begin
llamadas_maquina.iniciar:=iniciar_xain;
llamadas_maquina.bucle_general:=xain_principal;
llamadas_maquina.cerrar:=cerrar_xain;
llamadas_maquina.reset:=reset_xain;
llamadas_maquina.fps_max:=6000000/384/272;
end;

function iniciar_xain:boolean; 
var
  f:word;
  memoria_temp:array[0..$3ffff] of byte;
const
    pc_x:array[0..7] of dword=(1,0,8*8+1,8*8+0,16*8+1,16*8+0,24*8+1,24*8+0);
    pc_y:array[0..7] of dword=(0*8,1*8,2*8,3*8,4*8,5*8,6*8,7*8);
    ps_x:array[0..15] of dword=(3, 2, 1, 0, 16*8+3, 16*8+2, 16*8+1, 16*8+0,
	  32*8+3,32*8+2 ,32*8+1 ,32*8+0 ,48*8+3 ,48*8+2 ,48*8+1 ,48*8+0);
    ps_y:array[0..15] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8,
	  8*8, 9*8, 10*8, 11*8, 12*8, 13*8, 14*8, 15*8);
begin
iniciar_xain:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=256;
p_final[0].y:=240;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[1].trans:=true;
p_final[2].x:=512;
p_final[2].y:=512;
p_final[2].trans:=true;
p_final[2].scroll.long_x:=512;
p_final[2].scroll.long_y:=512;
p_final[2].scroll.max_x:=256;
p_final[2].scroll.max_y:=256;
p_final[2].scroll.mask_x:=511;
p_final[2].scroll.mask_y:=511;
p_final[3].x:=512;
p_final[3].y:=512;
p_final[3].trans:=true;
p_final[3].scroll:=p_final[2].scroll;
p_final[4].x:=512;
p_final[4].y:=512;
p_final[4].final_mix:=true;
p_final[4].sprite_end_x:=256;
p_final[4].sprite_mask_x:=$ff;
p_final[4].sprite_end_y:=256;
p_final[4].sprite_mask_y:=$ff;
iniciar_video;
//Main CPU
init_cpu(m6809_main,0,1500000/272);
main_6809_ll.getbyte:=xain_getbyte;
main_6809_ll.putbyte:=xain_putbyte;
//Sub CPU
init_cpu(m6809_misc,1,1500000/272);
misc_6809_ll.getbyte:=xain_sub_getbyte;
misc_6809_ll.putbyte:=xain_sub_putbyte;
//Sound CPU
init_cpu(m6809_snd,2,1500000/272);
snd_6809_ll.getbyte:=xain_snd_getbyte;
snd_6809_ll.putbyte:=xain_snd_putbyte;
//MCU CPU
init_cpu(m6805_main,3,3000000/272);
init_m6805(main_6805,tipo_m68705);
main_6805_ll.getbyte:=mcu_xain_hw_getbyte;
main_6805_ll.putbyte:=mcu_xain_hw_putbyte;
//Sound Chip
ym2203_Init(0,2,3000000,1500000,1,nil,nil,nil,nil,snd_irq);
ym2203_Init(1,2,3000000,1500000,1,nil,nil,nil,nil,nil);
init_sound_engine(2,1500000,sound_instruccion);
//Main roms
if not(cargar_roms(@memoria_temp[0],@xain_rom[0],'xsleena.zip',0)) then exit;
//Pongo las ROMs en su banco
copymemory(@memoria[$8000],@memoria_temp[$0],$8000);
for f:=0 to 1 do copymemory(@main_rom[f,0],@memoria_temp[$8000+(f*$4000)],$4000);
//Sub roms
if not(cargar_roms(@memoria_temp[0],@xain_sub[0],'xsleena.zip',0)) then exit;
//Pongo las ROMs en su banco
copymemory(@mem_misc[$8000],@memoria_temp[$0],$8000);
for f:=0 to 1 do copymemory(@sub_rom[f,0],@memoria_temp[$8000+(f*$4000)],$4000);
//Cargar Sound
if not(cargar_roms(@mem_snd[0],@xain_snd,'xsleena.zip',1)) then exit;
//Cargar MCU
if not(cargar_roms(@mcu_mem[0],@xain_mcu,'xsleena.zip',1)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@xain_char,'xsleena.zip',1)) then exit;
init_gfx(0,8,8,$400);
gfx[0].trans[0]:=true;
des_gfx.pos_planos[0]:=0;
des_gfx.pos_planos[1]:=2;
des_gfx.pos_planos[2]:=4;
des_gfx.pos_planos[3]:=6;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=32*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//convertir sprites
if not(cargar_roms(@memoria_temp[0],@xain_sprites[0],'xsleena.zip',0)) then exit;
init_gfx(1,16,16,$800);
gfx[1].trans[0]:=true;
des_gfx.pos_planos[0]:=$8000*4*8+0;
des_gfx.pos_planos[1]:=$8000*4*8+4;
des_gfx.pos_planos[2]:=0;
des_gfx.pos_planos[3]:=4;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=64*8;
convert_gfx(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//convertir tiles1
if not(cargar_roms(@memoria_temp[0],@xain_tiles1[0],'xsleena.zip',0)) then exit;
init_gfx(2,16,16,$800);
gfx[2].trans[0]:=true;
convert_gfx(@gfx[2],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//convertir tiles2
if not(cargar_roms(@memoria_temp[0],@xain_tiles2[0],'xsleena.zip',0)) then exit;
init_gfx(3,16,16,$800);
gfx[3].trans[0]:=true;
convert_gfx(@gfx[3],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//final
reset_xain;
iniciar_xain:=true;
end;

procedure cerrar_xain;
begin
cerrar_cpus;
YM2203_close(0);
YM2203_close(1);
close_audio;
close_video;
end;

procedure reset_xain;
begin
 reset_6809(main_6809,main_6809_ll);
 reset_6809(misc_6809,misc_6809_ll);
 reset_6809(snd_6809,snd_6809_ll);
 reset_6805(main_6805,main_6805_ll);
 ym2203_reset(0);
 ym2203_reset(1);
 reset_audio;
 banco_main:=0;
 banco_sub:=0;
 in0:=$FF;
 in1:=$FF;
 soundlatch:=0;
 vblank:=0;
 //mcu
 port_a_in:=0;
 port_a_out:=0;
 ddr_a:=0;
 port_b_in:=0;
 port_b_out:=0;
 ddr_b:=0;
 port_c_in:=0;
 port_c_out:=0;
 ddr_c:=0;
 mcu_accept:=1;
 mcu_ready:=1;
 main_ready:=0;
 main_accept:=0;
 from_main:=0;
 from_mcu:=0;
end;

procedure update_video_xain;
procedure chars(trans:boolean);inline;
var
  x,y,color,f,nchar:word;
  atrib:byte;
begin
  for f:=$0 to $3ff do begin
    atrib:=memoria[$2400+f];
    color:=(atrib and $e0) shr 5;
    if ((gfx[0].buffer[f]) or (gfx[0].color_buffer[color])) then begin
      y:=f div 32;
      x:=f mod 32;
      nchar:=memoria[$2000+f]+((atrib and $3) shl 8);
      if trans then put_gfx_trans(x*8,y*8,nchar,color shl 4,1,0)
        else put_gfx(x*8,y*8,nchar,color shl 4,1,0);
      gfx[0].buffer[f]:=false;
    end;
  end;
  actualiza_trozo(0,0,256,256,1,0,0,256,256,4);
end;
procedure sprites;inline;
var
  x,y,color,f,nchar:word;
  atrib:byte;
begin
for f:=0 to $5f do begin
  atrib:=memoria[$3801+(f*4)];
  nchar:=memoria[$3802+(f*4)] or ((atrib and 7) shl 8);
  if nchar<>0 then begin
    color:=((atrib and $38) shl 1)+128;
    x:=238-memoria[$3803+(f*4)];
    y:=240-memoria[$3800+(f*4)];
    if (atrib and $80)<>0 then begin
      put_gfx_sprite_diff(nchar,color,(atrib and $40)<>0,false,1,0,0);
      put_gfx_sprite_diff(nchar+1,color,(atrib and $40)<>0,false,1,0,16);
      actualiza_gfx_sprite_size(x,y-16,4,16,32);
    end else begin
      put_gfx_sprite(nchar,color,(atrib and $40)<>0,false,1);
      actualiza_gfx_sprite(x,y,4,1);
    end;
  end;
end;
end;
procedure tiles_0(trans:boolean);inline;
var
  x,y,color,f,nchar:word;
  atrib:byte;
  pos:word;
begin
  for f:=$0 to $3ff do begin
    y:=f div 32;
    x:=f mod 32;
    pos:=(x and $0f)+((y and $0f) shl 4)+((x and $10) shl 4)+((y and $10) shl 5);
    atrib:=memoria[$3400+pos];
    color:=(atrib and $70) shr 4;
    if ((gfx[2].buffer[pos]) or (gfx[2].color_buffer[color])) then begin
      nchar:=memoria[$3000+pos]+((atrib and $7) shl 8);
      if trans then put_gfx_trans_flip(x*16,y*16,nchar,(color shl 4)+384,2,2,(atrib and $80)<>0,false)
        else put_gfx_flip(x*16,y*16,nchar,(color shl 4)+384,2,2,(atrib and $80)<>0,false);
      gfx[2].buffer[pos]:=false;
    end;
  end;
  scroll_x_y(2,4,scroll_x_p0.w,scroll_y_p0.w);
end;
procedure tiles_1(trans:boolean);inline;
var
  x,y,color,f,nchar:word;
  atrib:byte;
  pos:word;
begin
  for f:=$0 to $3ff do begin
    y:=f div 32;
    x:=f mod 32;
    pos:=(x and $0f)+((y and $0f) shl 4)+((x and $10) shl 4)+((y and $10) shl 5);
    atrib:=memoria[$2c00+pos];
    color:=(atrib and $70) shr 4;
    if ((gfx[3].buffer[pos]) or (gfx[3].color_buffer[color])) then begin
      nchar:=memoria[$2800+pos]+((atrib and $7) shl 8);
      if trans then put_gfx_trans_flip(x*16,y*16,nchar,(color shl 4)+256,3,3,(atrib and $80)<>0,false)
        else put_gfx_flip(x*16,y*16,nchar,(color shl 4)+256,3,3,(atrib and $80)<>0,false);
      gfx[3].buffer[pos]:=false;
    end;
  end;
  scroll_x_y(3,4,scroll_x_p1.w,scroll_y_p1.w);
end;
begin
case xain_pri of
  0:begin  //bg2 bg1 sprt char
      tiles_0(false);
      tiles_1(true);
      sprites;
      chars(true);
    end;
  1:begin  //bg1 bg2 sprt char
      tiles_1(false);
      tiles_0(true);
      sprites;
      chars(true);
    end;
  2:begin  //char bg2 sprt bg1
      chars(false);
      tiles_0(true);
      sprites;
      tiles_1(true);
    end;
  3:begin  //char bg1 sprt bg2
      chars(false);
      tiles_1(true);
      sprites;
      tiles_0(true);
    end;
  4:begin  //bg2 char sprt bg1
      tiles_0(false);
      chars(true);
      sprites;
      tiles_1(true);
    end;
  5:begin  //bg1 char sprt bg2
      tiles_1(false);
      chars(true);
      sprites;
      tiles_0(true);
    end;
  6:begin  //bg2 sprt bg1 char
      tiles_0(false);
      sprites;
      tiles_1(true);
      chars(true);
    end;
  7:begin  //bg1 sprt bg2 char
      tiles_1(false);
      sprites;
      tiles_0(true);
      chars(true);
    end;
end;
fillchar(gfx[0].color_buffer[0],8,0);
fillchar(gfx[2].color_buffer[0],8,0);
fillchar(gfx[3].color_buffer[0],8,0);
actualiza_trozo_final(0,8,256,240,4);
end;

procedure eventos_xain;
begin
if event.arcade then begin
  if arcade_input.up[0] then in0:=(in0 and $fb) else in0:=(in0 or $4);
  if arcade_input.down[0] then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if arcade_input.left[0] then in0:=(in0 and $fd) else in0:=(in0 or $2);
  if arcade_input.right[0] then in0:=(in0 and $fe) else in0:=(in0 or $1);
  if arcade_input.but0[0] then in0:=(in0 and $df) else in0:=(in0 or $20);
  if arcade_input.but1[0] then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if arcade_input.coin[0] then in1:=(in1 and $bf) else in1:=(in1 or $40);
  if arcade_input.coin[1] then in1:=(in1 and $7f) else in1:=(in1 or $80);
  if arcade_input.start[0] then in0:=(in0 and $bf) else in0:=(in0 or $40);
  if arcade_input.start[1] then in0:=(in0 and $7f) else in0:=(in0 or $80);
end;
end;

procedure xain_principal;
var
  f:word;
  frame_m,frame_s,frame_snd,frame_mcu:single;
begin
init_controls(false,false,false,true);
frame_m:=main_6809.tframes;
frame_s:=misc_6809.tframes;
frame_snd:=snd_6809.tframes;
frame_mcu:=main_6805.tframes;
while EmuStatus=EsRuning do begin
  for f:=0 to 271 do begin
    //main
    run_6809(main_6809,main_6809_ll,trunc(frame_m));
    frame_m:=frame_m+main_6809.tframes-main_6809.contador;
    //sub
    run_6809(misc_6809,misc_6809_ll,trunc(frame_s));
    frame_s:=frame_s+misc_6809.tframes-misc_6809.contador;
    //snd
    run_6809(snd_6809,snd_6809_ll,trunc(frame_snd));
    frame_snd:=frame_snd+snd_6809.tframes-snd_6809.contador;
    //mcu
    run_6805(main_6805,main_6805_ll,trunc(frame_mcu));
    frame_mcu:=frame_mcu+main_6805.tframes-main_6805.contador;
    case f of
      120:update_video_xain;
      239:begin
            vblank:=$20;
            update_video_xain;
          end;
      251:main_6809.pedir_nmi:=ASSERT_LINE;
      271:vblank:=0;
    end;
    if (((f and 8)<>0) and (f<>0)) then main_6809.pedir_firq:=ASSERT_LINE;
  end;
  eventos_xain;
  video_sync;
end;
end;

//MCU
function mcu_status_r:byte;inline;
var
  res:byte;
begin
	res:=0;
  if (mcu_ready=1) then res:=res or $01;
  if (mcu_accept=1) then res:=res or $02;
	mcu_status_r:=res shl 3;
end;

function mcu_xain_hw_getbyte(direccion:word):byte;
begin
direccion:=direccion and $7ff;
case direccion of
  0:mcu_xain_hw_getbyte:=(port_a_out and ddr_a) or (port_a_in and not(ddr_a));
	1:mcu_xain_hw_getbyte:=(port_b_out and ddr_b) or (port_b_in and not(ddr_b));
	2:begin
      port_c_in:=0;
    	if (mcu_accept=0) then port_c_in:=port_c_in or $01;
    	if (mcu_ready<>0) then port_c_in:=port_c_in or $02;
    	mcu_xain_hw_getbyte:=(port_c_out and ddr_c) or (port_c_in and not(ddr_c));
    end;
  else mcu_xain_hw_getbyte:=mcu_mem[direccion];
end;
end;

procedure mcu_xain_hw_putbyte(direccion:word;valor:byte);
begin
direccion:=direccion and $7ff;
case direccion of
  0:port_a_out:=valor;
	1:begin
      if (((ddr_b and $02)<>0) and ((not(valor) and $02)<>0)) then begin
    		port_a_in:=from_main;
    	end else begin
        if (((ddr_b and $02)<>0) and ((not(port_b_out) and $02)<>0) and ((valor and $02)<>0)) then begin
    		  mcu_accept:=1;
    		  irq_request_6805(main_6805,0,CLEAR_LINE);
        end;
    	end;
    	if (((ddr_b and $04)<>0) and ((valor and $04)<>0) and ((not(port_b_out) and $04)<>0)) then begin
    		from_mcu:=port_a_out;
    		mcu_ready:=0;
    	end;
    	port_b_out:=valor;
    end;
	2:port_c_out:=valor;
	4:ddr_a:=valor;
	5:ddr_b:=valor;
	6:ddr_c:=valor;
  $10..$7f:mcu_mem[direccion]:=valor;
end;
end;

function xain_getbyte(direccion:word):byte;
begin
    case direccion of
        $3a00:xain_getbyte:=in0;
        $3a01:xain_getbyte:=in1;
        $3a03:xain_getbyte:=$ff;
        $3a02:xain_getbyte:=$3f;
        $3a04:begin
                mcu_ready:=1;
                xain_getbyte:=from_mcu;
              end;
        $3a05:xain_getbyte:=vblank+$c7+mcu_status_r; //VBlank
        $3a06:begin
                mcu_ready:=1;
	              mcu_accept:=1;
                irq_request_6805(main_6805,0,CLEAR_LINE);
                xain_getbyte:=$ff;
              end;
        $4000..$7fff:xain_getbyte:=main_rom[banco_main,direccion and $3FFF]
    else xain_getbyte:=memoria[direccion];
    end;
end;

procedure cambiar_color(pos:word);inline;
var
  tmp_color:byte;
  color:tcolor;
begin
  tmp_color:=buffer_paleta[pos];
  color.r:=pal4bit(tmp_color);
  color.g:=pal4bit(tmp_color shr 4);
  tmp_color:=buffer_paleta[pos+$200];
  color.b:=pal4bit(tmp_color);
  set_pal_color(color,addr(paleta[pos]));
  case pos of
    0..127:gfx[0].color_buffer[pos shr 4]:=true;
    256..383:gfx[3].color_buffer[(pos shr 4) and $7]:=true;
    384..511:gfx[2].color_buffer[(pos shr 4) and $7]:=true;
  end;
end;

procedure xain_putbyte(direccion:word;valor:byte);
begin
if direccion>$3FFF then exit;
memoria[direccion]:=valor;
case direccion of
        $2000..$27ff:gfx[0].buffer[direccion and $3ff]:=true;
        $2800..$2fff:gfx[3].buffer[direccion and $3ff]:=true;
        $3000..$37ff:gfx[2].buffer[direccion and $3ff]:=true;
        $3a00:scroll_x_p1.l:=valor;
        $3a01:scroll_x_p1.h:=valor and 1;
        $3a02:scroll_y_p1.l:=valor;
        $3a03:scroll_y_p1.h:=valor and 1;
        $3a04:scroll_x_p0.l:=valor;
        $3a05:scroll_x_p0.h:=valor and 1;
        $3a06:scroll_y_p0.l:=valor;
        $3a07:scroll_y_p0.h:=valor and 1;
        $3a08:begin
                soundlatch:=valor;
                snd_6809.pedir_irq:=HOLD_LINE;
              end;
        $3a09:clear_nmi_6809(main_6809);
        $3a0a:main_6809.pedir_firq:=CLEAR_LINE;
        $3a0b:main_6809.pedir_irq:=CLEAR_LINE;
        $3a0c:misc_6809.pedir_irq:=ASSERT_LINE;
        $3a0e:begin
                from_main:=valor;
	              mcu_accept:=0;
                irq_request_6805(main_6805,0,ASSERT_LINE);
              end;
        $3a0f:begin
                if (xain_pri<>valor and $7) then begin
                  xain_pri:=valor and $7;
                  fillchar(gfx[0].buffer[0],$400,0);
                  fillchar(gfx[2].buffer[0],$400,0);
                  fillchar(gfx[3].buffer[0],$400,0);
                end;
                banco_main:=(valor shr 3) and 1;
              end;
        $3c00..$3fff:if buffer_paleta[direccion and $3ff]<>valor then begin
                        buffer_paleta[direccion and $3ff]:=valor;
                        cambiar_color(direccion and $1ff);
                     end;
end;
end;

function xain_sub_getbyte(direccion:word):byte;
begin
  case direccion of
      0..$1fff:xain_sub_getbyte:=memoria[direccion];
      $4000..$7fff:xain_sub_getbyte:=sub_rom[banco_sub,direccion and $3FFF]
      else xain_sub_getbyte:=mem_misc[direccion];
  end;
end;

procedure xain_sub_putbyte(direccion:word;valor:byte);
begin
if direccion>$3FFF then exit;
mem_misc[direccion]:=valor;
case direccion of
  0..$1fff:memoria[direccion]:=valor;
  $2000:main_6809.pedir_irq:=ASSERT_LINE;
  $2800:misc_6809.pedir_irq:=CLEAR_LINE;
  $3000:banco_sub:=valor and 1;
end;
end;

function xain_snd_getbyte(direccion:word):byte;
begin
if direccion=$1000 then xain_snd_getbyte:=soundlatch
  else xain_snd_getbyte:=mem_snd[direccion];
end;

procedure xain_snd_putbyte(direccion:word;valor:byte);
begin
if direccion>$4000 then exit;
case direccion of
  $2800:ym2203_Control(0,valor);
  $2801:ym2203_Write_Reg(0,valor);
  $3000:ym2203_Control(1,valor);
  $3001:ym2203_Write_Reg(1,valor);
end;
mem_snd[direccion]:=valor;
end;

procedure snd_irq(numchip:integer;irqstate:integer);
begin
  if (irqstate=1) then snd_6809.pedir_firq:=ASSERT_LINE
    else snd_6809.pedir_firq:=CLEAR_LINE;
end;

procedure sound_instruccion;
begin
  ym2203_Update(0);
  ym2203_Update(1);
end;

end.
