unit yiearkungfu_hw;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     m6809,main_engine,controls_engine,sn_76496,vlm_5030,gfx_engine,
     timer_engine,rom_engine,cpu_engine,pal_engine,sound_engine;

procedure Cargar_yiear;
procedure yiear_principal;
function iniciar_yiear:boolean;
procedure reset_yiear;
procedure cerrar_yiear;
//Main CPU
function yiear_getbyte(direccion:word): Byte;
procedure yiear_putbyte(direccion:word;valor:byte);
procedure yiear_despues_instruccion;
procedure yiear_snd_nmi; 

const
        yiear_rom:array[0..2] of tipo_roms=(
        (n:'i08.10d';l:$4000;p:$8000;crc:$e2d7458b),(n:'i07.8d';l:$4000;p:$c000;crc:$7db7442e),());
        yiear_char:array[0..2] of tipo_roms=((n:'g16_1.bin';l:$2000;p:0;crc:$b68fd91d),
        (n:'g15_2.bin';l:$2000;p:$2000;crc:$d9b167c6),());
        yiear_sprites:array[0..4] of tipo_roms=(
        (n:'g04_5.bin';l:$4000;p:0;crc:$45109b29),(n:'g03_6.bin';l:$4000;p:$4000;crc:$1d650790),
        (n:'g06_3.bin';l:$4000;p:$8000;crc:$e6aa945b),(n:'g05_4.bin';l:$4000;p:$c000;crc:$cc187c22),());
        yiear_pal:tipo_roms=(n:'yiear.clr';l:$20;p:$0;crc:$c283d71f);
        yiear_vlm:tipo_roms=(n:'a12_9.bin';l:$2000;p:$0;crc:$f75a1539);

var
 pedir_irq,pedir_nmi:boolean;
 sound_latch:byte;

implementation
uses principal;

procedure Cargar_yiear;
begin
llamadas_maquina.iniciar:=iniciar_yiear;
llamadas_maquina.bucle_general:=yiear_principal;
llamadas_maquina.cerrar:=cerrar_yiear;
llamadas_maquina.reset:=reset_yiear;
llamadas_maquina.fps_max:=60.58;
end;

function iniciar_yiear:boolean;
var
      colores:tpaleta;
      f:word;
      ctemp1,ctemp2,ctemp3:byte;
      memoria_temp:array[0..$ffff] of byte;
const
    pc_x:array[0..7] of dword=(0, 1, 2, 3, 8*8+0, 8*8+1, 8*8+2, 8*8+3);
    pc_y:array[0..7] of dword=(0*8, 1*8, 2*8, 3*8, 4*8, 5*8, 6*8, 7*8);
    ps_x:array[0..15] of dword=(0*8*8+0, 0*8*8+1, 0*8*8+2, 0*8*8+3, 1*8*8+0, 1*8*8+1, 1*8*8+2, 1*8*8+3,
	  2*8*8+0, 2*8*8+1, 2*8*8+2, 2*8*8+3, 3*8*8+0, 3*8*8+1, 3*8*8+2, 3*8*8+3);
    ps_y:array[0..15] of dword=(0*8,  1*8,  2*8,  3*8,  4*8,  5*8,  6*8,  7*8,
	  32*8, 33*8, 34*8, 35*8, 36*8, 37*8, 38*8, 39*8);
begin
iniciar_yiear:=false;
iniciar_audio(false);
//Pantallas:  principal+char y sprites
p_final[0].x:=256;
p_final[0].y:=224;
p_final[1].x:=256;
p_final[1].y:=256;
p_final[2].sprite_mask_x:=$ff;
p_final[2].sprite_mask_y:=$ff;
p_final[2].x:=256;
p_final[2].y:=256;
p_final[2].final_mix:=true;
iniciar_video;
//Main CPU
init_cpu(m6809_main,0,1536000);
main_6809_ll.getbyte:=yiear_getbyte;
main_6809_ll.putbyte:=yiear_putbyte;
//Sound Chip
SN76496_init(0,1536000);
init_sound_engine(0,1536000,yiear_despues_instruccion);
//cargar rom sonido
vlm5030_init(2,3579545,$2000,0,1536000);
if not(cargar_roms(chip_vlm.rom,@yiear_vlm,'yiear.zip',1)) then exit;
//NMI sonido
init_timer(0,1536000/480,yiear_snd_nmi,true);
//cargar roms
if not(cargar_roms(@memoria[0],@yiear_rom[0],'yiear.zip',0)) then exit;
//convertir chars
if not(cargar_roms(@memoria_temp[0],@yiear_char[0],'yiear.zip',0)) then exit;
init_gfx(0,8,8,512);
des_gfx.pos_planos[0]:=4;
des_gfx.pos_planos[1]:=0;
des_gfx.pos_planos[2]:=$2000*8+4;
des_gfx.pos_planos[3]:=$2000*8+0;
des_gfx.bit_pixel:=4;
des_gfx.banks:=0;
des_gfx.long_sprites:=16*8;
convert_gfx(@gfx[0],0,@memoria_temp[0],@pc_x[0],@pc_y[0],false,false);
//sprites
if not(cargar_roms(@memoria_temp[0],@yiear_sprites[0],'yiear.zip',0)) then exit;
init_gfx(1,16,16,512);
gfx[1].trans[0]:=true;
des_gfx.pos_planos[0]:=4;
des_gfx.pos_planos[1]:=0;
des_gfx.pos_planos[2]:=$8000*8+4;
des_gfx.pos_planos[3]:=$8000*8+0;
des_gfx.long_sprites:=64*8;
convert_gfx(@gfx[1],0,@memoria_temp[0],@ps_x[0],@ps_y[0],false,false);
//paleta
if not(cargar_roms(@memoria_temp[0],@yiear_pal,'yiear.zip',1)) then exit;
for f:=0 to 31 do begin
  ctemp1:=memoria_temp[f] and 1;
  ctemp2:=(memoria_temp[f] shr 1) and 1;
  ctemp3:=(memoria_temp[f] shr 2) and 1;
  colores[f].r:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
  ctemp1:=(memoria_temp[f] shr 3) and 1;
  ctemp2:=(memoria_temp[f] shr 4) and 1;
  ctemp3:=(memoria_temp[f] shr 5) and 1;
  colores[f].g:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
  ctemp1:=0;
  ctemp2:=(memoria_temp[f] shr 6) and 1;
  ctemp3:=(memoria_temp[f] shr 7) and 1;
  colores[f].b:=$21*ctemp1+$47*ctemp2+$97*ctemp3;
end;
set_pal(colores,32);
//final
reset_yiear;
iniciar_yiear:=true;
end;

procedure cerrar_yiear; 
begin
cerrar_cpus;
SN76496_close(0);
vlm5030_close;
close_audio;
close_video;
end;

procedure reset_yiear;
begin
 reset_6809(main_6809,main_6809_ll);
 SN76496_reset(0);
 vlm5030_reset;
 reset_audio;
 in0:=$FF;
 in1:=$FF;
 in2:=$FF;
 pedir_irq:=false;
 pedir_nmi:=false;
 sound_latch:=0;
end;

procedure update_video_yiear;
var
  x,y:byte;
  f,nchar,atrib:word;
begin
for f:=0 to $3ff do begin
    if gfx[0].buffer[f] then begin
      x:=f and $1f;
      y:=f shr 5;
      atrib:=memoria[$5800+(f*2)];
      nchar:=memoria[$5801+(f*2)]+((atrib and $10) shl 4);
      put_gfx_flip(x*8,y*8,nchar,16,1,0,(atrib and $80)<>0,(atrib and $40)<>0);
      gfx[0].buffer[f]:=false;
    end;
end;
actualiza_trozo(0,0,256,256,1,0,0,256,256,2);
for f:=$17 downto 0 do begin
  atrib:=memoria[$5000+(f*2)];
  nchar:=memoria[$5401+(f*2)]+((atrib and 1) shl 8);
  x:=memoria[$5400+(f*2)];
  y:=240-memoria[$5001+(f*2)];
  if f<$13 then y:=y+1;
  put_gfx_sprite(nchar,0,(atrib and $40)=0,(atrib and $80)<>0,1);
  actualiza_gfx_sprite(x,y,2,1);
end;
actualiza_trozo_final(0,16,256,224,2);
end;

procedure eventos_yiear;
begin
if event.arcade then begin
  if arcade_input.down[0] then in1:=(in1 and $f7) else in1:=(in1 or $8);
  if arcade_input.up[0] then in1:=(in1 and $fb) else in1:=(in1 or $4);
  if arcade_input.right[0] then in1:=(in1 and $fd) else in1:=(in1 or $2);
  if arcade_input.left[0] then in1:=(in1 and $fe) else in1:=(in1 or $1);
  if arcade_input.but0[0] then in1:=(in1 and $df) else in1:=(in1 or $20);
  if arcade_input.but1[0] then in1:=(in1 and $ef) else in1:=(in1 or $10);
  if arcade_input.start[0] then in0:=(in0 and $f7) else in0:=(in0 or $8);
  if arcade_input.start[1] then in0:=(in0 and $ef) else in0:=(in0 or $10);
  if arcade_input.coin[0] then in0:=(in0 and $fe) else in0:=(in0 or 1);
  if arcade_input.coin[1] then in0:=(in0 and $fd) else in0:=(in0 or 2);
end;
end;

procedure yiear_principal;
var
  frame:single;
begin
init_controls(false,false,false,true);
frame:=main_6809.tframes;
while EmuStatus=EsRuning do begin
  run_6809(main_6809,main_6809_ll,trunc(frame));
  frame:=frame+main_6809.tframes-main_6809.contador;
  if pedir_irq then main_6809.pedir_irq:=HOLD_LINE;
  update_video_yiear;
  eventos_yiear;
  video_sync;
end;
end;

function yiear_getbyte(direccion:word):byte;
begin
case direccion of
  $0:yiear_getbyte:=VLM5030_BSY;
  $4c00:yiear_getbyte:=$59;
  $4d00:yiear_getbyte:=$FF;
  $4e00:yiear_getbyte:=in0;
  $4e01:yiear_getbyte:=in1;
  $4e02:yiear_getbyte:=in2;
  $4e03:yiear_getbyte:=$FF;
  else yiear_getbyte:=memoria[direccion];
end;
end;

procedure yiear_putbyte(direccion:word;valor:byte);
begin
if direccion>$7FFF then exit;
memoria[direccion]:=valor;
case direccion of
  $4000:begin
          pedir_irq:=((valor and $4)<>0);
          pedir_nmi:=((valor and $2)<>0);
        end;
  $4800:sound_latch:=valor;
  $4900:SN76496_Write(0,sound_latch);
  $4a00:begin
           VLM5030_ST((valor shr 1) and 1);
	         VLM5030_RST((valor shr 2) and 1);
        end;
  $4b00:VLM5030_data_w(valor);
  $5800..$5fff:gfx[0].buffer[(direccion and $7ff) shr 1]:=true;
end;
end;

procedure yiear_snd_nmi;
begin
  if pedir_nmi then main_6809.pedir_nmi:=PULSE_LINE;
end;

procedure yiear_despues_instruccion;
begin
  SN76496_Update(0);
end;

end.
