unit m68000;

{
06/01/09 - Version 1.0 - Aqui empieza todo!!
15/02/10 - Version 2.0 - Renovado el emulador
  analizados todos los bits de los opcodes.
06/08/10 - Corregidos
           Opcode ABCD
           EA indirecto indexado con desplazamiento tipo word y aadido long (corrige Rastan)
           Opcodes tipo $e cantidad de repeticiones cuando es un registro (corrige demo F1 dream)
           Corregidas las condiciones de salto (corrige Snow Bros)
           Aadidos dos opcodes de movep
           Aadido un opcode bclr 32 bits
           Limpieza opcodes bclr, bset, bcmp, bchg
05/09/10   Corregido movem
20/09/10   Corregido sbcd
23/09/10   Corregido asl.b
25/12/10   Aadido TAS y algunos modos de direccionamiento
20/04/11   Aadidos mas modos de dir en movem y corregido privilegio en 'move from sr'
           corregido flag 'c' en cmpi.l
}

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     sysutils,dialogs,main_engine,timer_engine;

type
        band_68000=record
                t,s,i,x,n,z,v,c:boolean;
                im:byte;
        end;
        reg_68000=record
                pc:dparejas;
                ppc:dparejas;
                d:array[0..7] of dparejas;
                a:array[0..7] of dparejas;
                usp,isp,sp:pdparejas;
                temp:dparejas;
                cc:band_68000;
                contador:integer;
                numero_cpu:byte;
                tframes:single;
                opcode,prefetch:boolean;
                ea:dword;
                irq:array[0..7] of byte;
                enabled:boolean;
        end;
        preg_68000=^reg_68000;
        pband_68000=^band_68000;
        llam_68000 = record
            getword:function (direccion: dword):word;
            putword:procedure (direccion:dword;valor:word);
        end;

procedure reset_68000(r:preg_68000;ll:llam_68000);
procedure run_68000(r:preg_68000;ll:llam_68000;maximo:dword);

implementation

procedure reset_68000(r:preg_68000;ll:llam_68000);
var
  f:byte;
begin
r.cc.s:=true;
r.cc.z:=true;
r.prefetch:=false;
r.cc.im:=7;
r.sp:=addr(r.a[7]);
r.isp:=addr(r.a[7]);
r.usp:=addr(r.temp);
r.opcode:=true;
r.sp.wh:=ll.getword(0);
r.sp.wl:=ll.getword(2);
r.pc.wh:=ll.getword(4);
r.pc.wl:=ll.getword(6);
for f:=0 to 7 do r.irq[f]:=CLEAR_LINE;
r.enabled:=true;
end;

procedure poner_band(r:preg_68000;pila:word);inline;
var
  temp:dword;
begin
if (r.cc.s and ((pila and $2000)=0)) then begin //quita supervisor
  temp:=r.a[7].l;
  r.usp:=addr(r.a[7]);
  r.a[7].l:=r.temp.l;
  r.isp:=addr(r.temp);
  r.temp.l:=temp;
  r.cc.s:=false;
end else begin
  if (not(r.cc.s) and ((pila and $2000)<>0)) then begin //pone supervisor
    temp:=r.a[7].l;
    r.isp:=addr(r.a[7]);
    r.a[7].l:=r.temp.l;
    r.usp:=addr(r.temp);
    r.temp.l:=temp;
    r.cc.s:=true;
  end;
end;
r.cc.t:=(pila and $8000)<>0;
r.cc.im:=(pila shr 8) and 7;
r.cc.x:=(pila and $10)<>0;
r.cc.n:=(pila and $8)<>0;
r.cc.z:=(pila and $4)<>0;
r.cc.v:=(pila and $2)<>0;
r.cc.c:=(pila and $1)<>0;
end;

function coger_band(r:preg_68000):word;inline;
var
  pila:word;
begin
pila:=0;
if r.cc.t then pila:=$8000;
if r.cc.s then pila:=pila or $2000;
pila:=pila or (r.cc.im shl 8);
if r.cc.x then pila:=pila or $10;
if r.cc.n then pila:=pila or $8;
if r.cc.z then pila:=pila or $4;
if r.cc.v then pila:=pila or $2;
if r.cc.c then pila:=pila or $1;
coger_band:=pila;
end;

function getbyte(ll:llam_68000;addr:dword):byte;inline;
var
  tempw:word;
begin
  tempw:=ll.getword(addr);
  if (addr and 1)<>0 then getbyte:=tempw and $ff
    else getbyte:=tempw shr 8;
end;

procedure putbyte(ll:llam_68000;addr:dword;val:byte);inline;
var
  tempw:word;
begin
tempw:=ll.getword(addr and $fffffe);
if (addr and 1)<>0 then ll.putword(addr,(tempw and $ff00) or val)
  else ll.putword(addr,(tempw and $ff) or (val shl 8));
end;

function calc_move_time_bw(dir,des:byte):byte;inline;
const
  time_table:array[0..5,0..4] of byte=(
  (04,08,12,14,16), //Dn An
  (08,12,16,18,20), //(An) (An)+ #xxx
  (10,14,18,20,22), //-(An)
  (12,16,20,22,24), //d(An) xxx.W d(PC)
  (14,18,22,24,26), //d(An,ix) d(PC,ix)
  (16,20,24,26,28)); //xxx.L
var
  pos1,pos2:byte;
begin
case dir of
  $0..$f:pos1:=0; // Dn y An
  $10..$1f,$3c:pos1:=1;  // (An) (An)+ #nnnn
  $20..$27:pos1:=2; // -(An)
  $28..$2f,$38,$3a:pos1:=3; // d(An) xxx.W d(PC)
  $30..$37,$3b:pos1:=4; // d(An,ix) d(PC,ix)
  $39:pos1:=5;//xxx.L
end;
case des of
  $0..$f:pos2:=0; // Dn y An
  $10..$27:pos2:=1;  // (An) (An)+ -(An)
  $28..$2f,$38:pos2:=2; // d(An) xxx.W
  $30..$37,$3b:pos2:=3; // d(An,ix)
  $39:pos2:=4;//xxx.L
end;
calc_move_time_bw:=time_table[pos1,pos2];
end;

function calc_move_time_l(dir,des:byte):byte;inline;
const
  time_table:array[0..5,0..4] of byte=(
  (04,12,16,18,20), //Dn An
  (12,20,24,26,28), //(An) (An)+ #xxx
  (14,22,26,28,30), //-(An)
  (16,24,28,30,32), //d(An) xxx.W d(PC)
  (18,26,30,32,34), //d(An,ix) d(PC,ix)
  (20,28,32,34,36)); //xxx.L
var
  pos1,pos2:byte;
begin
case dir of
  $0..$f:pos1:=0; // Dn y An
  $10..$1f,$3c:pos1:=1;  // (An) (An)+ #nnnn
  $20..$27:pos1:=2; // -(An)
  $28..$2f,$38,$3a:pos1:=3; // d(An) xxx.W d(PC)
  $30..$37,$3b:pos1:=4; // d(An,ix) d(PC,ix)
  $39:pos1:=5;//xxx.L
end;
case des of
  $0..$f:pos2:=0; // Dn y An
  $10..$27:pos2:=1;  // (An) (An)+ -(An)
  $28..$2f,$38:pos2:=2; // d(An) xxx.W
  $30..$37,$3b:pos2:=3; // d(An,ix)
  $39:pos2:=4;//xxx.L
end;
calc_move_time_l:=time_table[pos1,pos2];
end;

function leerdir_b(r:preg_68000;ll:llam_68000;dir:byte):byte;
var
  des:byte;
  desp:word;
begin
case dir of
  $0..$7:begin //registro DX Dn
            leerdir_b:=r.d[dir and $7].l0;
            exit;
         end;
  $8..$f:begin //registro AX An
            leerdir_b:=r.a[dir and $7].l0;
            exit;
         end;
  $10..$17:r.ea:=r.a[dir and $7].l;  //Registro indirecto AX (An)
  $18..$1f:begin  //indirecto con postincremento (An)+
              r.ea:=r.a[dir and $7].l;
              r.a[dir and $7].l:=r.ea+1;
           end;
  $20..$27:begin //AX predecremento -(An)
              r.a[(dir and $7)].l:=r.a[(dir and $7)].l-1;
              r.ea:=r.a[dir and $7].l;
           end;
  $28..$2f:begin  //AX indirecto con desplazamiento d(An)
              desp:=ll.getword(r.pc.l);
              r.pc.l:=r.pc.l+2;
              r.ea:=r.a[dir and $7].l+smallint(desp);
           end;
  $30..$37:begin  //AX indirecto indexado con desplazamiento d(An,ix)
              desp:=ll.getword(r.pc.l);
              r.pc.l:=r.pc.l+2;
              des:=desp and $ff;
              if (desp and $8000)<>0 then begin
                if (desp and $800)<>0 then r.ea:=r.a[dir and $7].l+r.a[(desp shr 12) and $7].l+shortint(des)
                  else r.ea:=r.a[dir and $7].l+smallint(r.a[(desp shr 12) and $7].wl)+shortint(des);
              end else begin
                if (desp and $800)<>0 then r.ea:=r.a[dir and $7].l+r.d[(desp shr 12) and $7].l+shortint(des)
                  else r.ea:=r.a[dir and $7].l+smallint(r.d[(desp shr 12) and $7].wl)+shortint(des);
              end;
           end;
  $38:begin //word indirecto xxx.W
        r.ea:=smallint(ll.getword(r.pc.l));
        r.pc.l:=r.pc.l+2;
      end;
  $39:begin  //indirecto long xxx.L
        r.ea:=ll.getword(r.pc.l) shl 16;
        r.ea:=r.ea or ll.getword(r.pc.l+2);
        r.pc.l:=r.pc.l+4;
      end;
  $3a:begin //d(PC)
        r.ea:=r.pc.l+smallint(ll.getword(r.pc.l));
        r.pc.l:=r.pc.l+2;
      end;
  $3b:begin  //d(PC,ix)
        desp:=ll.getword(r.pc.l);
        des:=desp and $ff;
        if (desp and $8000)<>0 then begin
          if (desp and $800)<>0 then r.ea:=r.pc.l+r.a[(desp shr 12) and $7].l+shortint(des)
            else r.ea:=r.pc.l+smallint(r.a[(desp shr 12) and $7].wl)+shortint(des);
        end else begin
          if (desp and $800)<>0 then r.ea:=r.pc.l+r.d[(desp shr 12) and $7].l+shortint(des)
            else r.ea:=r.pc.l+smallint(r.d[(desp shr 12) and $7].wl)+shortint(des);
        end;
        r.pc.l:=r.pc.l+2;
      end;
  $3c:begin  //inmediato word  #nnnn
        r.ea:=r.pc.l;
        leerdir_b:=ll.getword(r.ea) and $ff;
        r.pc.l:=r.pc.l+2;
        exit;
      end
  else MessageDlg('Mierda direccionamiento origen.b - '+inttohex(r.pc.l,10)+' - '+inttohex(dir,2), mtInformation,[mbOk], 0);
end;
r.opcode:=false;
leerdir_b:=getbyte(ll,r.ea);
r.opcode:=true;
end;

procedure ponerdir_b2(r:preg_68000;ll:llam_68000;des,res:byte);
begin
case des of
           $0..$7:r.d[des and $7].l0:=res;  //registro DX
           $8..$f:r.a[des and $7].l0:=res;  //registro AX
           $10..$17,  //Registro indirecto AX
           $18..$1f,  //indirecto con postincremento
           $20..$27, //AX predecremento
           $28..$2f,  ////AX indirecto con desplazamiento
           $30..$37,  //AX indirecto indexado con desplazamiento
           $38,$39:putbyte(ll,r.ea,res);
           else MessageDlg('Mierda direccionamiento poner_b2 - '+inttohex(des,2)+' - '+inttohex(r.pc.l,10), mtInformation,[mbOk], 0);
        end;
end;

procedure ponerdir_b(r:preg_68000;ll:llam_68000;des,res:byte);
var
  desp:word;
  despl:byte;
begin
case des of
           $0..$7:begin //registro DX
                    r.d[des and $7].l0:=res;
                    exit;
                  end;
           $8..$f:begin //registro AX
                    r.a[des and $7].l0:=res;
                    exit;
                  end;
           $10..$17:r.ea:=r.a[des and $7].l;  //Registro indirecto AX
           $18..$1f:begin  //indirecto con postincremento
                      r.ea:=r.a[des and $7].l;
                      r.a[des and $7].l:=r.a[des and $7].l+1;
                    end;
           $20..$27:begin //AX predecremento
                      r.a[(des and $7)].l:=r.a[(des and $7)].l-1;
                      r.ea:=r.a[(des and $7)].l;
                    end;
           $28..$2f:begin  ////AX indirecto con desplazamiento
                      desp:=ll.getword(r.pc.l);
                      r.pc.l:=r.pc.l+2;
                      r.ea:=r.a[des and $7].l+smallint(desp);
                    end;
           $30..$37:begin  //AX indirecto indexado con desplazamiento
                      desp:=ll.getword(r.pc.l);
                      r.pc.l:=r.pc.l+2;
                      despl:=desp and $ff;
                      if (desp and $8000)<>0 then begin
                        if (desp and $800)<>0 then r.ea:=r.a[des and $7].l+r.a[(desp shr 12) and $7].l+shortint(despl)
                          else r.ea:=r.a[des and $7].l+smallint(r.a[(desp shr 12) and $7].wl)+shortint(despl);
                      end else begin
                        if (desp and $800)<>0 then r.ea:=r.a[des and $7].l+r.d[(desp shr 12) and $7].l+shortint(despl)
                          else r.ea:=r.a[des and $7].l+smallint(r.d[(desp shr 12) and $7].wl)+shortint(despl);
                      end;
           end;
           $38:begin //word indirecto
                  r.ea:=smallint(ll.getword(r.pc.l));
                  r.pc.l:=r.pc.l+2;
               end;
           $39:begin //indirecto long
                  r.ea:=ll.getword(r.pc.l) shl 16;
                  r.ea:=r.ea or ll.getword(r.pc.l+2);
                  r.pc.l:=r.pc.l+4;
                 end;
           else MessageDlg('Mierda direccionamiento poner_b - '+inttohex(des,2)+' - '+inttohex(r.ppc.l,10), mtInformation,[mbOk], 0);
end;
putbyte(ll,r.ea,res);
end;

function leerdir_w(r:preg_68000;ll:llam_68000;dir:byte):word;
var
  desp:dword;
  des:byte;
begin
case dir of
  $0..$7:begin //registro DX
            leerdir_w:=r.d[dir and $7].wl;
            exit;
         end;
  $8..$f:begin //registro AX
            leerdir_w:=r.a[dir and $7].wl;
            exit;
         end;
  $10..$17:r.ea:=r.a[dir and $7].l;  //Registro indirecto AX
  $18..$1f:begin // (registro de direccion)+
            r.ea:=r.a[(dir and $7)].l;
            r.a[(dir and $7)].l:=r.ea+2;
           end;
  $20..$27:begin //AX predecremento
              r.a[(dir and $7)].l:=r.a[(dir and $7)].l-2;
              r.ea:=r.a[(dir and $7)].l;
           end;
  $28..$2f:begin  //AX indirecto con desplazamiento
              desp:=ll.getword(r.pc.l);
              r.pc.l:=r.pc.l+2;
              r.ea:=r.a[dir and $7].l+smallint(desp);
           end;
  $30..$37:begin  //AX indirecto indexado con desplazamiento
              desp:=ll.getword(r.pc.l);
              r.pc.l:=r.pc.l+2;
              des:=desp and $ff;
              if (desp and $8000)<>0 then begin
                if (desp and $800)<>0 then r.ea:=r.a[dir and $7].l+r.a[(desp shr 12) and $7].l+shortint(des)
                  else r.ea:=r.a[dir and $7].l+smallint(r.a[(desp shr 12) and $7].wl)+shortint(des);
              end else begin
                if (desp and $800)<>0 then r.ea:=r.a[dir and $7].l+r.d[(desp shr 12) and $7].l+shortint(des)
                  else r.ea:=r.a[dir and $7].l+smallint(r.d[(desp shr 12) and $7].wl)+shortint(des);
              end;
           end;
  $38:begin //word indirecto
        r.ea:=smallint(ll.getword(r.pc.l));
        r.pc.l:=r.pc.l+2;
      end;
  $39:begin  //indirecto inmediato l
        r.ea:=ll.getword(r.pc.l) shl 16;
        r.ea:=r.ea or ll.getword(r.pc.l+2);
        r.pc.l:=r.pc.l+4;
     end;
  $3a:begin
        desp:=ll.getword(r.pc.l);
        r.ea:=r.pc.l+smallint(desp);
        r.pc.l:=r.pc.l+2;
      end;
  $3b:begin
        desp:=ll.getword(r.pc.l);
        des:=desp and $ff;
        if (desp and $8000)<>0 then begin
          if (desp and $800)<>0 then r.ea:=r.pc.l+r.a[(desp shr 12) and $7].l+shortint(des)
            else r.ea:=r.pc.l+smallint(r.a[(desp shr 12) and $7].wl)+shortint(des);
        end else begin
          if (desp and $800)<>0 then r.ea:=r.pc.l+r.d[(desp shr 12) and $7].l+shortint(des)
            else r.ea:=r.pc.l+smallint(r.d[(desp shr 12) and $7].wl)+shortint(des);
        end;
        r.pc.l:=r.pc.l+2;
      end;
  $3c:begin  //inmediato
        r.ea:=r.pc.l;
        leerdir_w:=ll.getword(r.ea);
        r.pc.l:=r.pc.l+2;
        exit;
      end;
else MessageDlg('Mierda error de direccionamiento origen.w - '+inttostr(r.pc.l)+' - '+inttostr(dir), mtInformation,[mbOk], 0);
end;
r.opcode:=false;
leerdir_w:=ll.getword(r.ea);
r.opcode:=true;
end;

procedure ponerdir_w2(r:preg_68000;ll:llam_68000;des:byte;res:word);
begin
case des of
  $0..$7:r.d[des and $7].wl:=res; //registro DX
  $8..$f:begin
            if (res and $8000)<>0 then MessageDlg('Mierda > $8000 ponerdir.w', mtInformation,[mbOk], 0);
            r.a[des and $7].wl:=res; //registro AX
         end;
  $10..$17,  // indirecto con AX
  $18..$1f, // (registro de direccion)+
  $20..$27, //AX predecremento
  $28..$2f,  //  AX indirecto con desplazamiento
  $30..$37,  //AX indirecto indexado con desplazamiento
  $38, //word indirecto
  $39:ll.putword(r.ea,res);  //indirecto long
    else MessageDlg('Mierda error de direccionamiento lea destino.w - '+inttohex(des,2)+' - '+inttohex(r.pc.l,$10), mtInformation,[mbOk], 0);
end;
end;

procedure ponerdir_w(r:preg_68000;ll:llam_68000;des:byte;res:word);
var
  desp:word;
  despl:byte;
begin
case des of
  $0..$7:begin //registro DX
            r.d[des and $7].wl:=res;
            exit;
         end;
  $8..$f:begin //registro AX
            if (res and $8000)<>0 then MessageDlg('Mierda > $8000 ponerdir.w', mtInformation,[mbOk], 0);
            r.a[des and $7].wl:=res;
            exit;
         end;
  $10..$17:r.ea:=r.a[(des and $7)].l;  // indirecto con AX
  $18..$1f:begin // (registro de direccion)+
              r.ea:=r.a[(des and $7)].l;
              r.a[(des and $7)].l:=r.a[(des and $7)].l+2;
           end;
  $20..$27:begin //AX predecremento
              r.a[(des and $7)].l:=r.a[(des and $7)].l-2;
              r.ea:=r.a[(des and $7)].l;
           end;
  $28..$2f:begin  //  AX indirecto con desplazamiento
              desp:=ll.getword(r.pc.l);
              r.pc.l:=r.pc.l+2;
              r.ea:=r.a[des and $7].l+smallint(desp);
           end;
  $30..$37:begin  //AX indirecto indexado con desplazamiento
              desp:=ll.getword(r.pc.l);
              r.pc.l:=r.pc.l+2;
              despl:=desp and $ff;
              if (desp and $8000)<>0 then begin
                if (desp and $800)<>0 then r.ea:=r.a[des and $7].l+r.a[(desp shr 12) and $7].l+shortint(despl)
                  else r.ea:=r.a[des and $7].l+smallint(r.a[(desp shr 12) and $7].wl)+shortint(despl);
              end else begin
                if (desp and $800)<>0 then r.ea:=r.a[des and $7].l+r.d[(desp shr 12) and $7].l+shortint(despl)
                  else r.ea:=r.a[des and $7].l+smallint(r.d[(desp shr 12) and $7].wl)+shortint(despl);
              end;
           end;
  $38:begin //word indirecto
        r.ea:=smallint(ll.getword(r.pc.l));
        r.pc.l:=r.pc.l+2;
      end;
  $39:begin  //indirecto long
        r.ea:=ll.getword(r.pc.l) shl 16;
        r.ea:=r.ea or ll.getword(r.pc.l+2);
        r.pc.l:=r.pc.l+4;
      end;
  else MessageDlg('Mierda error de direccionamiento destino.w - '+inttostr(des)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
end;
ll.putword(r.ea,res);
end;

function leerdir_l(r:preg_68000;ll:llam_68000;dir:byte):dword;
var
  desp:word;
  des:byte;
begin
case dir of
  $0..$7:begin //registro DX
            leerdir_l:=r.d[dir and 7].l;
            exit;
         end;
  $8..$f:begin //registro AX
            leerdir_l:=r.a[dir and 7].l;
            exit;
         end;
  $10..$17:r.ea:=r.a[(dir and $7)].l;  //Registro indirecto AX
  $18..$1f:begin // registro AX con post incremento
            r.ea:=r.a[dir and $7].l;
            r.a[dir and $7].l:=r.a[dir and $7].l+4;
           end;
  $20..$27:begin //AX predecremento
            r.a[(dir and $7)].l:=r.a[(dir and $7)].l-4;
            r.ea:=r.a[(dir and $7)].l;
           end;
  $28..$2f:begin  ////AX indirecto con desplazamiento
              desp:=ll.getword(r.pc.l);
              r.pc.l:=r.pc.l+2;
              r.ea:=r.a[dir and $7].l+smallint(desp);
           end;
  $30..$37:begin  //AX indirecto indexado con desplazamiento
              desp:=ll.getword(r.pc.l);
              r.pc.l:=r.pc.l+2;
              des:=desp and $ff;
              if (desp and $8000)<>0 then begin
                if (desp and $800)<>0 then r.ea:=r.a[dir and $7].l+r.a[(desp shr 12) and $7].l+shortint(des)
                  else r.ea:=r.a[dir and $7].l+smallint(r.a[(desp shr 12) and $7].wl)+shortint(des);
              end else begin
                if (desp and $800)<>0 then r.ea:=r.a[dir and $7].l+r.d[(desp shr 12) and $7].l+shortint(des)
                  else r.ea:=r.a[dir and $7].l+smallint(r.d[(desp shr 12) and $7].wl)+shortint(des);
              end;
           end;
  $38:begin //word indirecto
        r.ea:=smallint(ll.getword(r.pc.l));
        r.pc.l:=r.pc.l+2;
      end;
  $39:begin  //indirecto long
        r.ea:=(ll.getword(r.pc.l) shl 16) or ll.getword(r.pc.l+2);
        r.pc.l:=r.pc.l+4;
      end;
  $3a:begin
        desp:=ll.getword(r.pc.l);
        r.ea:=r.pc.l+smallint(desp);
        r.pc.l:=r.pc.l+2;
      end;
  $3b:begin
        desp:=ll.getword(r.pc.l);
        des:=desp and $ff;
        if (desp and $8000)<>0 then begin
          if (desp and $800)<>0 then r.ea:=r.pc.l+r.a[(desp shr 12) and $7].l+shortint(des)
            else r.ea:=r.pc.l+smallint(r.a[(desp shr 12) and $7].wl)+shortint(des);
        end else begin
          if (desp and $800)<>0 then r.ea:=r.pc.l+r.d[(desp shr 12) and $7].l+shortint(des)
            else r.ea:=r.pc.l+smallint(r.d[(desp shr 12) and $7].wl)+shortint(des);
        end;
        r.pc.l:=r.pc.l+2;
      end;
  $3c:begin // inmediato
        leerdir_l:=(ll.getword(r.pc.l) shl 16) or ll.getword(r.pc.l+2);
        r.ea:=r.pc.l;
        r.pc.l:=r.pc.l+4;
        exit;
      end;
  else MessageDlg('Mierda error de direccionamiento origen.l - '+inttostr(dir)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
end;
r.opcode:=false;
leerdir_l:=(ll.getword(r.ea) shl 16) or ll.getword(r.ea+2);
r.opcode:=true;
end;

procedure ponerdir_l2(r:preg_68000;ll:llam_68000;des:byte;res:dword);
begin
case des of
  $0..$7:r.d[des and $7].l:=res;
  $8..$f:r.a[des and $7].l:=res; //registro AX
  $10..$17, //indirecto AX
  $18..$1f,  // (registro de direccion)+
  $20..$27,   // -(registro de direccion)
  $28..$2f,    //  AX indirecto con desplazamiento
  $30..$37,    //AX indirecto indexado con desplazamiento
  $38,$39:begin  //indirecto inmediato l
            ll.putword(r.ea,res shr 16);
            ll.putword(r.ea+2,res and $FFFF);
          end;
  else MessageDlg('Mierda error de direccionamiento corto destino.l - '+inttohex(des,4)+' - '+inttohex(r.pc.l,10), mtInformation,[mbOk], 0);
end;
end;

procedure ponerdir_l(r:preg_68000;ll:llam_68000;des:byte;res:dword);
var
  desp:word;
  despl:byte;
begin
case des of
  $0..$7:begin //registro DX
            r.d[des and $7].l:=res;
            exit;
         end;
  $8..$f:begin //registro AX
            r.a[des and $7].l:=res;
            exit;
         end;
  $10..$17:r.ea:=r.a[des and $7].l; //indirecto AX
  $18..$1f:begin // (registro de direccion)+
              r.ea:=r.a[(des and $7)].l;
              r.a[(des and $7)].l:=r.ea+4;
           end;
  $20..$27:begin // -(registro de direccion)
              r.a[(des and $7)].l:=r.a[(des and $7)].l-4;
              r.ea:=r.a[(des and $7)].l;
           end;
  $28..$2f:begin  //  AX indirecto con desplazamiento
              desp:=ll.getword(r.pc.l);
              r.pc.l:=r.pc.l+2;
              r.ea:=r.a[des and $7].l+smallint(desp);
           end;
  $30..$37:begin  //AX indirecto indexado con desplazamiento
              desp:=ll.getword(r.pc.l);
              r.pc.l:=r.pc.l+2;
              despl:=desp and $ff;
              if (desp and $8000)<>0 then begin
                if (desp and $800)<>0 then r.ea:=r.a[des and $7].l+r.a[(desp shr 12) and $7].l+shortint(despl)
                  else r.ea:=r.a[des and $7].l+smallint(r.a[(desp shr 12) and $7].wl)+shortint(despl);
              end else begin
                if (desp and $800)<>0 then r.ea:=r.a[des and $7].l+r.d[(desp shr 12) and $7].l+shortint(despl)
                  else r.ea:=r.a[des and $7].l+smallint(r.d[(desp shr 12) and $7].wl)+shortint(despl);
              end;
           end;
  $38:begin //word indirecto
        r.ea:=smallint(ll.getword(r.pc.l));
        r.pc.l:=r.pc.l+2;
      end;
  $39:begin  //indirecto inmediato l
        r.ea:=(ll.getword(r.pc.l) shl 16) or ll.getword(r.pc.l+2);
        r.pc.l:=r.pc.l+4;
      end;
  else MessageDlg('Mierda error de direccionamiento destino.l - '+inttohex(des,4)+' - '+inttohex(r.pc.l,10), mtInformation,[mbOk], 0);
end;
ll.putword(r.ea,res shr 16);
ll.putword(r.ea+2,res and $FFFF);
end;

function leerdir_ea(r:preg_68000;ll:llam_68000;dir:byte):dword;
var
  res:dword;
  tempw:word;
  tempb:byte;
begin
case dir of
  $10..$1f,$20..$27:res:=r.a[dir and 7].l;
  $28..$2f:begin
              tempw:=ll.getword(r.pc.l);
              r.pc.l:=r.pc.l+2;
              res:=r.a[dir and $7].l+smallint(tempw);
            end;
  $30..$37:begin
              tempw:=ll.getword(r.pc.l);
              r.pc.l:=r.pc.l+2;
              tempb:=tempw and $ff;
              if (tempw and $8000)<>0 then begin
                if (tempw and $800)<>0 then res:=r.a[dir and $7].l+r.a[(tempw shr 12) and $7].l+shortint(tempb)
                  else res:=r.a[dir and $7].l+smallint(r.a[(tempw shr 12) and $7].wl)+shortint(tempb);
              end else begin
                if (tempw and $800)<>0 then res:=r.a[dir and $7].l+r.d[(tempw shr 12) and $7].l+shortint(tempb)
                  else res:=r.a[dir and $7].l+smallint(r.d[(tempw shr 12) and $7].wl)+shortint(tempb);
              end;
            end;
  $38:begin
        res:=smallint(ll.getword(r.pc.l));
        r.pc.l:=r.pc.l+2;
      end;
  $39:begin
        res:=ll.getword(r.pc.l) shl 16;
        res:=res or ll.getword(r.pc.l+2);
        r.pc.l:=r.pc.l+4;
      end;
  $3a:begin
        tempw:=ll.getword(r.pc.l);
        res:=r.pc.l+smallint(tempw);
        r.pc.l:=r.pc.l+2;
      end;
  $3b:begin
        tempw:=ll.getword(r.pc.l);
        tempb:=tempw and $ff;
        if (tempw and $8000)<>0 then begin
          if (tempw and $800)<>0 then res:=r.pc.l+r.a[(tempw shr 12) and $7].l+shortint(tempb)
            else res:=r.pc.l+smallint(r.a[(tempw shr 12) and $7].wl)+shortint(tempb);
        end else begin
          if (tempw and $800)<>0 then res:=r.pc.l+r.d[(tempw shr 12) and $7].l+shortint(tempb)
            else res:=r.pc.l+smallint(r.d[(tempw shr 12) and $7].wl)+shortint(tempb);
        end;
        r.pc.l:=r.pc.l+2;
      end;
  else MessageDlg('Mierda EA error en dir '+inttohex(dir,2)+' - '+inttohex(r.pc.l,10), mtInformation,[mbOk], 0);
end;
leerdir_ea:=res;
end;

function condicion(r:preg_68000;tipo:byte):boolean;inline;
begin
  case tipo of
    $00:condicion:=true;
    $01:condicion:=false;
    $02:condicion:=(not(r.cc.c) and not(r.cc.z)); //hi
    $03:condicion:=(r.cc.c or r.cc.z); //LS
    $04:condicion:=not(r.cc.c); //cc
    $05:condicion:=r.cc.c;  //cs
    $06:condicion:=not(r.cc.z); //ne
    $07:condicion:=r.cc.z;  //eq
    $08:condicion:=not(r.cc.v); //vc
    $09:condicion:=r.cc.v; //vs
    $0a:condicion:=not(r.cc.n); //plus
    $0b:condicion:=r.cc.n; //mi
    $0c:condicion:=not(r.cc.n xor r.cc.v); //ge
    $0d:condicion:=r.cc.n xor r.cc.v;  //lt
    $0e:condicion:=(not(r.cc.n xor r.cc.v) and not(r.cc.z)); //gt
    $0f:condicion:=((r.cc.n xor r.cc.v)) or r.cc.z; //le
  end;
end;

procedure run_68000(r:preg_68000;ll:llam_68000;maximo:dword);
var
  instruccion,tempw,tempw2:word;
  dir,dest,orig,tempb,tempb2,tempb3,f:byte;
  templ,templ2,templ3:dword;
  pcontador:integer;
  remainder,quotient,divisor:integer;
begin
r.contador:=0;
while r.contador<maximo do begin
if not(r.enabled) then begin
  r.contador:=maximo;
  exit;
end;
pcontador:=r.contador;
for f:=7 downto 1 do begin
    if ((r.cc.im<f) and (r.irq[f]<>CLEAR_LINE)) then begin
      r.prefetch:=false;
      r.contador:=r.contador+44;
      tempw:=coger_band(r);
      poner_band(r,tempw or $2000);
      r.sp.l:=r.sp.l-6;
      ll.putword(r.sp.l,tempw);
      ll.putword(r.sp.l+2,r.pc.wh);
      ll.putword(r.sp.l+4,r.pc.wl);
      r.opcode:=false;
      r.pc.wh:=ll.getword($64+((f-1)*4));
      r.pc.wl:=ll.getword($64+2+((f-1)*4));
      r.opcode:=true;
      if r.irq[f]=HOLD_LINE then r.irq[f]:=CLEAR_LINE;
      r.cc.im:=f;
      break;
    end;
end;
r.opcode:=true;
instruccion:=ll.getword(r.pc.l);
r.ppc:=r.pc;
r.pc.l:=r.pc.l+2;
dir:=instruccion and $3f;
dest:=(instruccion shr 9) and 7;
orig:=instruccion and 7;
case (instruccion shr 12) of //cojo solo el primer nibble
   $0:case (instruccion shr 6) and $3f of
        $0:begin
            tempb:=ll.getword(r.pc.l);
            r.pc.l:=r.pc.l+2;
            if dir<>$3c then begin  //ori.b
              if (dir shr 3)<>0 then r.contador:=r.contador+12
                else r.contador:=r.contador+8;
              tempb2:=leerdir_b(r,ll,dir) or tempb;
              ponerdir_b2(r,ll,dir,tempb2);
              r.cc.n:=(tempb2 and $80)<>0;
              r.cc.z:=(tempb2=0);
              r.cc.c:=false;
              r.cc.v:=false;
            end else begin   //ori.b toc
              r.contador:=r.contador+20;
              tempb2:=(coger_band(r) and $ff) or tempb;
              r.cc.x:=(tempb2 and $10)<>0;
              r.cc.n:=(tempb2 and $8)<>0;
              r.cc.z:=(tempb2 and $4)<>0;
              r.cc.v:=(tempb2 and $2)<>0;
              r.cc.c:=(tempb2 and $1)<>0;
            end;
           end;
        $1:begin
            tempw:=ll.getword(r.pc.l);
            r.pc.l:=r.pc.l+2;
            if dir<>$3c then begin //ori.w
              if (dir shr 3)<>0 then r.contador:=r.contador+12
                else r.contador:=r.contador+8;
              tempw2:=leerdir_w(r,ll,dir) or tempw;
              ponerdir_w2(r,ll,dir,tempw2);
              r.cc.n:=(tempw2 and $8000)<>0;
              r.cc.z:=(tempw2=0);
              r.cc.c:=false;
              r.cc.v:=false;
            end else begin
              if r.cc.s then begin //ori.w tos
                r.contador:=r.contador+20;
                tempw2:=coger_band(r) or tempw;
                poner_band(r,tempw2);
              end else begin
                MessageDlg('Error de privilegio '+inttohex(r.pc.l,10), mtInformation,[mbOk], 0);
              end;
            end;
           end;
        $2:begin  //ori.l
            if (dir shr 3)<>0 then r.contador:=r.contador+20
              else r.contador:=r.contador+16;
            templ:=ll.getword(r.pc.l) shl 16;
            templ:=templ or ll.getword(r.pc.l+2);
            r.pc.l:=r.pc.l+4;
            templ2:=leerdir_l(r,ll,dir) or templ;
            ponerdir_l2(r,ll,dir,templ2);
            r.cc.n:=((templ2 shr 24) and $80)<>0;
            r.cc.z:=(templ2=0);
            r.cc.c:=false;
            r.cc.v:=false;
           end;
  $4,$c,$14,$1c,$24,$2c,$34,$3c:begin  //btst dinamico
              case ((instruccion shr 3) and $7) of
                $00:begin  //32 bits
                      r.contador:=r.contador+6;
                      templ:=1 shl (r.d[dest].l0 and $1f);
                      r.cc.z:=(r.d[orig].l and templ)=0;
                    end;
                $01:begin //movep.w er
                      r.contador:=r.contador+16;
                      tempw:=ll.getword(r.pc.l);
                      if (tempw and $8000)<>0 then MessageDlg('Mierda! movep btst>$8000', mtInformation,[mbOk], 0);
                      templ:=r.a[orig].l+tempw;
                      r.pc.l:=r.pc.l+2;
                      r.d[dest].h0:=getbyte(ll,templ);
                      r.d[dest].l0:=getbyte(ll,templ+2);
                    end;
                else begin //8bits
                      tempb:=1 shl (r.d[dest].l0 and $7);
                      r.contador:=r.contador+4;
                      tempb2:=leerdir_b(r,ll,dir);
                      r.cc.z:=(tempb2 and tempb)=0;
                    end;
              end;
           end;
  $5,$d,$15,$1d,$25,$2d,$35,$3d:begin  //bchg dinamico
              case ((instruccion shr 3) and $7) of
                0:begin //bchg 32bits
                     r.contador:=r.contador+8;
                     templ:=1 shl (r.d[dest].l0 and $1f);
                     r.cc.z:=(r.d[orig].l and templ)=0;
                     r.d[orig].l:=r.d[orig].l xor templ;
                  end;
                1:begin  //movep.l er
                    r.contador:=r.contador+24;
                    tempw:=ll.getword(r.pc.l);
                    if (tempw and $8000)<>0 then MessageDlg('Mierda! movep bchg>$8000', mtInformation,[mbOk], 0);
                    templ:=r.a[orig].l+tempw;
                    r.pc.l:=r.pc.l+2;
                    r.d[dest].h1:=getbyte(ll,templ);
                    r.d[dest].l1:=getbyte(ll,templ+2);
                    r.d[dest].h0:=getbyte(ll,templ+4);
                    r.d[dest].l0:=getbyte(ll,templ+6);
                  end;
                  else begin //bchg 8 bits
                     r.contador:=r.contador+8;
                     tempb:=1 shl (r.d[dest].l0 and $7);
                     tempb2:=leerdir_b(r,ll,dir);
                     r.cc.z:=(tempb2 and tempb)=0;
                     tempb2:=tempb2 xor tempb;
                     ponerdir_b2(r,ll,dir,tempb2);
                  end;
              end;
            end;
  $6,$e,$16,$1e,$26,$2e,$36,$3e:begin
              case ((instruccion shr 3) and $7) of
                $0:begin //bclr 32 bits
                      r.contador:=r.contador+10;
                      templ:=1 shl (r.d[dest].l0 and $1f);
                      r.cc.z:=(r.d[orig].l and templ)=0;
                      r.d[orig].l:=r.d[orig].l and not(templ);
                   end;
                $1:begin //+++ movep.w
                      r.contador:=r.contador+16;
                      tempw:=ll.getword(r.pc.l);
                      if (tempw and $8000)<>0 then MessageDlg('Mierda! movep bclr>$8000', mtInformation,[mbOk], 0);
                      templ:=r.a[orig].l+tempw;
                      r.pc.l:=r.pc.l+2;
                      putbyte(ll,templ,r.d[dest].h0);
                      putbyte(ll,templ+2,r.d[dest].l0);
                    end;  //bclr dinamico
                else begin //bclr 8 bits
                      r.contador:=r.contador+8;
                      tempb:=1 shl (r.d[dest].l0 and $7);
                      tempb2:=leerdir_b(r,ll,dir);
                      r.cc.z:=(tempb2 and tempb)=0;
                      tempb2:=tempb2 and not(tempb);
                      ponerdir_b2(r,ll,dir,tempb2);
                end;
              end;
           end;
  7,$f,$17,$1f,$27,$2f,$37,$3f:begin //+++++++ bset dinamico
              case ((instruccion shr 3) and $7) of
                $00:begin  //32 bits
                     r.contador:=r.contador+8;
                     templ:=1 shl (r.d[dest].l0 and $1f);
                     r.cc.z:=(r.d[orig].l and templ)=0;
                     r.d[orig].l:=r.d[orig].l or templ;
                    end;
                $01:begin  //movep
                      r.contador:=r.contador+24;
                      MessageDlg('Mierda movep bset', mtInformation,[mbOk], 0);
                    end;
                else begin  //8bits
                      r.contador:=r.contador+8;
                      tempb:=1 shl (r.d[dest].l0 and $7);
                      tempb2:=leerdir_b(r,ll,dir);
                      r.cc.z:=(tempb2 and tempb)=0;
                      tempb2:=tempb2 or tempb;
                      ponerdir_b2(r,ll,dir,tempb2);
                end;
              end;
            end;
        $8:begin  //++++++ andi.b
            tempb:=ll.getword(r.pc.l);
            r.pc.l:=r.pc.l+2;
            if dir<>$3c then begin
              if (dir shr 3)<>0 then r.contador:=r.contador+12
                  else r.contador:=r.contador+8;
              tempb2:=leerdir_b(r,ll,dir) and tempb;
              ponerdir_b2(r,ll,dir,tempb2);
              r.cc.n:=(tempb2 and $80)<>0;
              r.cc.z:=(tempb2=0);
              r.cc.v:=false;
              r.cc.c:=false;
            end else begin
              r.contador:=r.contador+20;
              tempb2:=(coger_band(r) and $ff) and tempb;
              r.cc.x:=(tempb2 and $10)<>0;
              r.cc.n:=(tempb2 and $8)<>0;
              r.cc.z:=(tempb2 and $4)<>0;
              r.cc.v:=(tempb2 and $2)<>0;
              r.cc.c:=(tempb2 and $1)<>0;
            end;
          end;
        $9:begin  //++++++ andi.w
            tempw:=ll.getword(r.pc.l);
            r.pc.l:=r.pc.l+2;
            if dir<>$3c then begin
              if (dir shr 3)<>0 then r.contador:=r.contador+12
                else r.contador:=r.contador+8;
              tempw2:=leerdir_w(r,ll,dir) and tempw;
              ponerdir_w2(r,ll,dir,tempw2);
              r.cc.n:=(tempw2 and $8000)<>0;
              r.cc.z:=(tempw2=0);
              r.cc.v:=false;
              r.cc.c:=false;
            end else begin  // andi.w tos
              if r.cc.s then begin
                 r.contador:=r.contador+20;
                 tempw2:=coger_band(r) and tempw;
                 poner_band(r,tempw2);
              end else begin
                MessageDlg('Error de Privilegio '+inttohex(r.pc.l,10), mtInformation,[mbOk], 0);
              end;
            end;
          end;
        $a:begin  //++++++ andi.l
            if (dir shr 3)<>0 then r.contador:=r.contador+20
              else r.contador:=r.contador+14;
            templ:=ll.getword(r.pc.l) shl 16;
            templ:=templ or ll.getword(r.pc.l+2);
            r.pc.l:=r.pc.l+4;
            templ2:=leerdir_l(r,ll,dir) and templ;
            ponerdir_l2(r,ll,dir,templ2);
            r.cc.n:=((templ2 shr 24) and $80)<>0;
            r.cc.z:=(templ2=0);
            r.cc.v:=false;
            r.cc.c:=false;
          end;
        $10:begin //++++++ subi.b
              if (dir shr 3)<>0 then r.contador:=r.contador+12
                else r.contador:=r.contador+8;
              tempb:=ll.getword(r.pc.l) and $ff;
              r.pc.l:=r.pc.l+2;
              tempb2:=leerdir_b(r,ll,dir);
              tempw:=tempb2-tempb;
              ponerdir_b2(r,ll,dir,(tempw and $ff));
              r.cc.v:=(((tempb xor tempb2) and (tempw xor tempb2)) and $80)<>0;
              r.cc.c:=(tempw and $100)<>0;
              r.cc.x:=r.cc.c;
              r.cc.n:=(tempw and $80)<>0;
              r.cc.z:=((tempw and $ff)=0);
            end;
        $11:begin //++++++ subi.w
              if (dir shr 3)<>0 then r.contador:=r.contador+12
                else r.contador:=r.contador+8;
              tempw:=ll.getword(r.pc.l);
              r.pc.l:=r.pc.l+2;
              tempw2:=leerdir_w(r,ll,dir);
              templ:=tempw2-tempw;
              ponerdir_w2(r,ll,dir,(templ and $ffff));
              r.cc.v:=((((tempw xor tempw2) and (templ xor tempw2)) shr 8) and $80)<>0;
              r.cc.c:=(templ and $10000)<>0;
              r.cc.x:=r.cc.c;
              r.cc.n:=(templ and $8000)<>0;
              r.cc.z:=((templ and $ffff)=0);
            end;
        $12:begin //++++++ subi.l
              if (dir shr 3)<>0 then r.contador:=r.contador+20
                else r.contador:=r.contador+16;
              templ:=ll.getword(r.pc.l) shl 16;
              templ:=templ or ll.getword(r.pc.l+2);
              r.pc.l:=r.pc.l+4;
              templ2:=leerdir_l(r,ll,dir);
              templ3:=templ2-templ;
              ponerdir_l2(r,ll,dir,templ3);
              r.cc.n:=((templ3 shr 24) and $80)<>0;
              r.cc.z:=(templ3=0);
	            r.cc.v:=((((templ xor templ2) and (templ3 xor templ2)) shr 24) and $80)<>0;
	            r.cc.c:=((((templ and templ3) or (not(templ2) and (templ or templ3))) shr 23) and $100)<>0;
              r.cc.x:=r.cc.c;
            end;
        $18:begin //+++++++ addi.b
              if (dir shr 3)<>0 then r.contador:=r.contador+12
                else r.contador:=r.contador+8;
              tempb:=ll.getword(r.pc.l) and $ff;
              r.pc.l:=r.pc.l+2;
              tempb2:=leerdir_b(r,ll,dir);
              tempw:=tempb+tempb2;
              ponerdir_b2(r,ll,dir,(tempw and $ff));
              r.cc.v:=(((tempb xor tempw) and (tempb2 xor tempw)) and $80)<>0;
              r.cc.c:=(tempw and $100)<>0;
              r.cc.x:=r.cc.c;
              r.cc.n:=(tempw and $80)<>0;
              r.cc.z:=((tempw and $ff)=0);
            end;
        $19:begin //+++++++ addi.w
              if (dir shr 3)<>0 then r.contador:=r.contador+12
                else r.contador:=r.contador+8;
              tempw:=ll.getword(r.pc.l);
              r.pc.l:=r.pc.l+2;
              tempw2:=leerdir_w(r,ll,dir);
              templ:=tempw+tempw2;
              ponerdir_w2(r,ll,dir,(templ and $ffff));
              r.cc.v:=((((tempw xor templ) and (tempw2 xor templ)) shr 8) and $80)<>0;
              r.cc.c:=(templ and $10000)<>0;
              r.cc.x:=r.cc.c;
              r.cc.n:=(templ and $8000)<>0;
              r.cc.z:=((templ and $ffff)=0);
            end;
        $1a:begin //+++++++ addi.l
              if (dir shr 3)<>0 then r.contador:=r.contador+20
                else r.contador:=r.contador+16;
              templ:=ll.getword(r.pc.l) shl 16;
              templ:=templ or ll.getword(r.pc.l+2);
              r.pc.l:=r.pc.l+4;
              templ2:=leerdir_l(r,ll,dir);
              templ3:=templ+templ2;
              ponerdir_l2(r,ll,dir,templ3);
              r.cc.n:=((templ3 shr 24) and $80)<>0;
              r.cc.z:=(templ3=0);
              r.cc.v:=((((templ xor templ3) and (templ2 xor templ3)) shr 24) and $80)<>0;
              r.cc.c:=(((((templ and templ3) or (not(templ2) and (templ or templ3)))) shr 23) and $100)<>0;
              r.cc.x:=r.cc.c;
            end;
        $20:begin //+++++++ btst
              tempw:=ll.getword(r.pc.l);
              r.pc.l:=r.pc.l+2;
              if dir<8 then begin
                r.contador:=r.contador+10;
                r.cc.z:=((r.d[orig].l shr (tempw and $1f)) and 1)=0
              end else begin
                   r.contador:=r.contador+8;
                   tempb:=leerdir_b(r,ll,dir);
                   r.cc.z:=((tempb shr (tempw and $7)) and 1)=0;
              end;
            end;
        $21:begin //+++++ bchg
              r.contador:=r.contador+12;
              tempw:=ll.getword(r.pc.l);
              r.pc.l:=r.pc.l+2;
              if dir<8 then begin
                r.cc.z:=((r.d[orig].l shr (tempw and $1f)) and 1)=0;
                r.d[orig].l:=r.d[orig].l xor (1 shl (tempw and $1f));
              end else begin
                tempb:=leerdir_b(r,ll,dir);
                r.cc.z:=((tempb shr (tempw and $7)) and 1)=0;
                tempb:=tempb xor (1 shl (tempw and $7));
                ponerdir_b2(r,ll,dir,tempb);
              end;
            end;
        $22:begin //+++++ bclr
              tempw:=ll.getword(r.pc.l);
              r.pc.l:=r.pc.l+2;
              if dir<8 then begin //32bits
                r.contador:=r.contador+14;
                r.cc.z:=((r.d[orig].l shr (tempw and $1f)) and 1)=0;
                r.d[dir].l:=r.d[orig].l and not(1 shl (tempw and $1f));
              end else begin //8 bits
                r.contador:=r.contador+12;
                tempb:=leerdir_b(r,ll,dir);
                r.cc.z:=((tempb shr (tempw and $7)) and 1)=0;
                tempb:=tempb and not(1 shl (tempw and $7));
                ponerdir_b2(r,ll,dir,tempb);
              end;
            end;
        $23:begin //++++++ bset
              r.contador:=r.contador+12;
              tempw:=ll.getword(r.pc.l);
              r.pc.l:=r.pc.l+2;
              if dir<8 then begin //32bits
                r.cc.z:=((r.d[orig].l shr (tempw and $1f)) and 1)=0;
                r.d[dir].l:=r.d[orig].l or (1 shl (tempw and $1f));
              end else begin //8 bits
                tempb:=leerdir_b(r,ll,dir);
                r.cc.z:=((tempb shr (tempw and $7)) and 1)=0;
                tempb:=tempb or (1 shl (tempw and $7));
                ponerdir_b2(r,ll,dir,tempb);
              end;
            end;
        $28:begin  //+++++ eori.b
              tempb:=ll.getword(r.pc.l);
              r.pc.l:=r.pc.l+2;
              if dir<>$3c then begin
                if (dir shr 3)<>0 then r.contador:=r.contador+12
                  else r.contador:=r.contador+8;
                tempb2:=leerdir_b(r,ll,dir) xor tempb;
                ponerdir_b2(r,ll,dir,tempb2);
                r.cc.v:=false;
                r.cc.c:=false;
                r.cc.n:=(tempb2 and $80)<>0;
                r.cc.z:=(tempb2=0);
              end else begin //eori toc
                r.contador:=r.contador+20;
                tempb2:=(coger_band(r) and $ff) xor tempb;
                r.cc.x:=(tempb2 and $10)<>0;
                r.cc.n:=(tempb2 and $8)<>0;
                r.cc.z:=(tempb2 and $4)<>0;
                r.cc.v:=(tempb2 and $2)<>0;
                r.cc.c:=(tempb2 and $1)<>0;
              end;
            end;
        $29:begin  //+++++ eori.w
              tempw:=ll.getword(r.pc.l);
              r.pc.l:=r.pc.l+2;
              if dir<>$3c then begin
                if (dir shr 3)<>0 then r.contador:=r.contador+12
                  else r.contador:=r.contador+8;
                tempw2:=leerdir_w(r,ll,dir) xor tempw;
                ponerdir_w2(r,ll,dir,tempw2);
                r.cc.v:=false;
                r.cc.c:=false;
                r.cc.n:=(tempw2 and $8000)<>0;
                r.cc.z:=(tempw2=0);
              end else begin
                r.contador:=r.contador+20;
                MessageDlg('Mierda eori.w tos', mtInformation,[mbOk], 0);
              end;
            end;
        $2a:begin  //eori.l
              if (dir shr 3)<>0 then r.contador:=r.contador+20
                else r.contador:=r.contador+16;
              templ:=ll.getword(r.pc.l) shl 16;
              templ:=templ or ll.getword(r.pc.l+2);
              r.pc.l:=r.pc.l+4;
              templ2:=leerdir_l(r,ll,dir) xor templ;
              ponerdir_l2(r,ll,dir,templ2);
              r.cc.v:=false;
              r.cc.c:=false;
              r.cc.n:=((templ2 shr 24) and $80)<>0;
              r.cc.z:=(templ2=0);
            end;
        $30:begin //  cmpi.b
              r.contador:=r.contador+8;
              tempb:=ll.getword(r.pc.l) and $ff;
              r.pc.l:=r.pc.l+2;
              tempb2:=leerdir_b(r,ll,dir);
              tempw:=tempb2-tempb;
              r.cc.n:=(tempw and $80)<>0;
              r.cc.z:=((tempw and $ff)=0);
	            r.cc.v:=(((tempb xor tempb2) and (tempw xor tempb2)) and $80)<>0;
	            r.cc.c:=(tempw and $100)<>0;
              end;
        $31:begin // +++++ cmpi.w
              r.contador:=r.contador+8;
              tempw:=ll.getword(r.pc.l);
              r.pc.l:=r.pc.l+2;
              tempw2:=leerdir_w(r,ll,dir);
              templ:=tempw2-tempw;
              r.cc.n:=(templ and $8000)<>0;
              r.cc.z:=((templ and $ffff)=0);
	            r.cc.v:=((((tempw xor tempw2) and (templ xor tempw2)) shr 8) and $80)<>0;
	            r.cc.c:=(templ and $10000)<>0;
            end;
        $32:begin  //++++ cmpi.l
              if (dir shr 3)<>0 then r.contador:=r.contador+12
                else r.contador:=r.contador+14;
              templ:=ll.getword(r.pc.l) shl 16;
              templ:=templ or ll.getword(r.pc.l+2);
              r.pc.l:=r.pc.l+4;
              templ2:=leerdir_l(r,ll,dir);
              templ3:=templ2-templ;
              r.cc.n:=((templ3 shr 24) and $80)<>0;
              r.cc.z:=(templ3=0);
	            r.cc.v:=((((templ xor templ2) and (templ3 xor templ2)) shr 24) and $80)<>0;
	            r.cc.c:=((((templ and templ3) or (not(templ2) and (templ or templ3))) shr 23) and $100)<>0;
            end;
        else MessageDlg('Instruccion $0: '+inttohex((instruccion shr 6) and $3f,10)+' - '+inttohex(r.pc.l,10), mtInformation,[mbOk], 0);
      end;
   $1:begin  //+++++++++++++++ move.b
        tempb:=leerdir_b(r,ll,dir);
        tempb2:=dest or (((instruccion shr 6) and $7) shl 3);
        ponerdir_b(r,ll,tempb2,tempb);
        r.contador:=r.contador+calc_move_time_bw(dir,tempb2);
        r.cc.v:=false;
        r.cc.c:=false;
        r.cc.n:=(tempb and $80)<>0;
        r.cc.z:=(tempb=0);
      end;
   $2:if (instruccion shr 6) and $7=1 then begin //++++++++  movea.l
        r.contador:=r.contador+4;
        r.a[dest].l:=leerdir_l(r,ll,dir);
      end else begin // ++++++++++++++  move.l
        templ:=leerdir_l(r,ll,dir);
        tempb2:=dest or (((instruccion shr 6) and $7) shl 3);
        ponerdir_l(r,ll,tempb2,templ);
        r.contador:=r.contador+calc_move_time_l(dir,tempb2);
        r.cc.v:=false;
        r.cc.c:=false;
        r.cc.n:=((templ shr 24) and $80)<>0;
        r.cc.z:=(templ=0);
      end;
   $3:if (instruccion shr 6) and $7=1 then begin //+++++++++++++++ movea.w
        r.contador:=r.contador+4;
        r.a[dest].l:=smallint(leerdir_w(r,ll,dir));
      end else begin //++++++++++++++++++++ move.w
        tempw:=leerdir_w(r,ll,dir);
        tempb2:=dest or (((instruccion shr 6) and $7) shl 3);
        ponerdir_w(r,ll,tempb2,tempw);
        r.contador:=r.contador+calc_move_time_bw(dir,tempb2);
        r.cc.v:=false;
        r.cc.c:=false;
        r.cc.n:=(tempw and $8000)<>0;
        r.cc.z:=(tempw=0);
      end;
   $4:case (instruccion shr 6) and $3f of
          $03:begin //++++++++  move from sr
                if dir<8 then r.contador:=r.contador+6
                  else r.contador:=r.contador+8;
                ponerdir_w(r,ll,dir,coger_band(r));
              end;
$7,$f,$17,$1f,$27,$2f,$37,$3f:begin // lea
                r.a[dest].l:=leerdir_ea(r,ll,dir);
                case dir of
                  $10..$17:r.contador:=r.contador+4;  //(An)
                  $28..$2f,$38,$3a:r.contador:=r.contador+8; //d(An) xxx.W d(PC)
                  $30..$37,$3b,$39:r.contador:=r.contador+12; //d(An,ix) d(PC,ix) xxx.L
                end
              end;
          $08:begin //++++++  clr.b
                if (dir shr 3)<>0 then r.contador:=r.contador+8
                  else r.contador:=r.contador+4;
                ponerdir_b(r,ll,dir,0);
                r.cc.n:=false;
                r.cc.v:=false;
                r.cc.c:=false;
                r.cc.z:=true;
              end;
          $09:begin //++++++ clr.w
                if (dir shr 3)<>0 then r.contador:=r.contador+8
                  else r.contador:=r.contador+4;
                ponerdir_w(r,ll,dir,0);
                r.cc.n:=false;
                r.cc.v:=false;
                r.cc.c:=false;
                r.cc.z:=true;
              end;
          $0a:begin //++++++  clr.l
                if (dir shr 3)<>0 then r.contador:=r.contador+12
                  else r.contador:=r.contador+6;
                ponerdir_l(r,ll,dir,0);
                r.cc.n:=false;
                r.cc.v:=false;
                r.cc.c:=false;
                r.cc.z:=true;
              end;
          $10:begin  //++++ neg.b
                if (dir shr 3)<>0 then r.contador:=r.contador+8
                  else r.contador:=r.contador+4;
                tempb:=leerdir_b(r,ll,dir);
                tempw:=0-tempb;
                r.cc.n:=(tempw and $80)<>0;
                r.cc.c:=(tempw and $100)<>0;
                r.cc.x:=r.cc.c;
                r.cc.z:=(tempw and $ff)=0;
                r.cc.v:=((tempb and tempw) and $80)<>0;
                ponerdir_b2(r,ll,dir,tempw and $ff);
              end;
          $11:begin  //++++ neg.w
                if (dir shr 3)<>0 then r.contador:=r.contador+8
                  else r.contador:=r.contador+4;
                tempw:=leerdir_w(r,ll,dir);
                templ:=0-tempw;
                r.cc.n:=(templ and $8000)<>0;
                r.cc.c:=(templ and $10000)<>0;
                r.cc.x:=r.cc.c;
                r.cc.z:=(templ and $ffff)=0;
                r.cc.v:=(((tempw and templ) shr 8) and $80)<>0;
                ponerdir_w2(r,ll,dir,templ and $ffff);
              end;
          $12:begin  //++++ neg.l
                if (dir shr 3)<>0 then r.contador:=r.contador+12
                  else r.contador:=r.contador+6;
                templ:=leerdir_l(r,ll,dir);
                templ2:=0-templ;
                r.cc.n:=((templ2 shr 24) and $80)<>0;
                r.cc.c:=((((templ and templ2) or (not(0) and (templ or templ2))) shr 23) and $100)<>0;
                r.cc.x:=r.cc.c;
                r.cc.z:=(templ2=0);
                r.cc.v:=(((templ and templ2) shr 24) and $80)<>0;
                ponerdir_l2(r,ll,dir,templ2);
              end;
          $13:begin  //++++ move to ccr
                r.contador:=r.contador+12;
                tempw:=leerdir_w(r,ll,dir);
                r.cc.x:=(tempw and $10)<>0;
                r.cc.n:=(tempw and $8)<>0;
                r.cc.z:=(tempw and $4)<>0;
                r.cc.v:=(tempw and $2)<>0;
                r.cc.c:=(tempw and $1)<>0;
              end;
          $18:begin //not.b
                if (dir shr 3)<>0 then r.contador:=r.contador+8
                  else r.contador:=r.contador+4;
                tempb:=not(leerdir_b(r,ll,dir));
                ponerdir_b2(r,ll,dir,tempb);
                r.cc.c:=false;
                r.cc.v:=false;
                r.cc.n:=(tempb and $80)<>0;
                r.cc.z:=(tempb=0);
              end;
          $19:begin //not.w
                if (dir shr 3)<>0 then r.contador:=r.contador+8
                  else r.contador:=r.contador+4;
                tempw:=not(leerdir_w(r,ll,dir));
                ponerdir_w2(r,ll,dir,tempw);
                r.cc.c:=false;
                r.cc.v:=false;
                r.cc.n:=(tempw and $8000)<>0;
                r.cc.z:=(tempw=0);
              end;
          $1a:begin //not.l
                if (dir shr 3)<>0 then r.contador:=r.contador+12
                  else r.contador:=r.contador+6;
                templ:=not(leerdir_l(r,ll,dir));
                ponerdir_l2(r,ll,dir,templ);
                r.cc.c:=false;
                r.cc.v:=false;
                r.cc.n:=((templ shr 24) and $80)<>0;
                r.cc.z:=(templ=0);
              end;
          $1b:if r.cc.s then begin //++++ move to sr
                r.contador:=r.contador+12;
                tempw:=leerdir_w(r,ll,dir);
                poner_band(r,tempw);
              end else MessageDlg('Mierda error de privilegio MOVE TO SR'+inttostr(r.pc.l), mtInformation,[mbOk], 0);
          $21:begin //+++++ pea
                case dir of
               $0..$7:begin  //+++++++++ swap!!!
                        r.contador:=r.contador+4;
                        templ:=(r.d[orig].wl shl 16) or r.d[orig].wh;
                        r.cc.c:=false;
                        r.cc.v:=false;
                        r.cc.n:=((templ shr 24) and $80)<>0;
                        r.cc.z:=(templ=0);
                        r.d[orig].l:=templ;
                   end;
                   $39:begin
                        r.contador:=r.contador+20;
                        templ:=ll.getword(r.pc.l) shl 16;
                        templ:=templ or ll.getword(r.pc.l+2);
                        r.pc.l:=r.pc.l+4;
                        r.sp.l:=r.sp.l-4;
                        ll.putword(r.sp.l,templ shr 16);
                        ll.putword(r.sp.l+2,templ and $FFFF);
                      end;
                   $3a:begin
                          r.contador:=r.contador+16;
                          tempw:=ll.getword(r.pc.l);
                          templ:=r.pc.l+smallint(tempw);
                          r.pc.l:=r.pc.l+2;
                          r.sp.l:=r.sp.l-4;
                          ll.putword(r.sp.l,templ shr 16);
                          ll.putword(r.sp.l+2,templ and $FFFF);
                       end;
                   else MessageDlg('Mierda pea error de direccionamiento '+inttostr(dir)+' - '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                end;
              end;
          $22:begin
                if (dir shr 3)=0 then begin //+++++ ext.w
                   r.contador:=r.contador+4;
                   tempb:=r.d[orig].l0;
                   if (tempb and $80)<>0 then tempw:=$FF00 or tempb
                      else tempw:=tempb;
                   r.cc.c:=false;
                   r.cc.v:=false;
                   r.cc.n:=(tempw and $8000)<>0;
                   r.cc.z:=(tempw=0);
                   r.d[orig].wl:=tempw;
                end else begin  //++++ movem.w
                  r.contador:=r.contador+8;
                  tempw:=ll.getword(r.pc.l);
                  r.pc.l:=r.pc.l+2;
                  tempw2:=tempw;
                  tempb2:=0;
                  for tempb:=0 to 15 do begin
                    if (tempw2 and 1)<>0 then tempb2:=tempb2+1;
                    tempw2:=tempw2 shr 1;
                  end;
                  r.contador:=r.contador+(tempb2 shl 2);
                  case dir of
                    $10..$17,$28..$2f,$39:begin
                              templ:=leerdir_ea(r,ll,dir);
                              if (tempw and $0001)<>0 then begin
                                ll.putword(templ,r.d[0].wl);
                                templ:=templ+2;
                              end;
                              if (tempw and $0002)<>0 then begin
                                ll.putword(templ,r.d[1].wl);
                                templ:=templ+2
                              end;
                              if (tempw and $0004)<>0 then begin
                                ll.putword(templ,r.d[2].wl);
                                templ:=templ+2;
                              end;
                              if (tempw and $0008)<>0 then begin
                                ll.putword(templ,r.d[3].wl);
                                templ:=templ+2;
                              end;
                              if (tempw and $0010)<>0 then begin
                                ll.putword(templ,r.d[4].wl);
                                templ:=templ+2;
                              end;
                              if (tempw and $0020)<>0 then begin
                                ll.putword(templ,r.d[5].wl);
                                templ:=templ+2;
                              end;
                              if (tempw and $0040)<>0 then begin
                                ll.putword(templ,r.d[6].wl);
                                templ:=templ+2;
                              end;
                              if (tempw and $0080)<>0 then begin
                                ll.putword(templ,r.d[7].wl);
                                templ:=templ+2;
                              end;
                              if (tempw and $0100)<>0 then begin
                                ll.putword(templ,r.a[0].wl);
                                templ:=templ+2;
                              end;
                              if (tempw and $0200)<>0 then begin
                                ll.putword(templ,r.a[1].wl);
                                templ:=templ+2;
                              end;
                              if (tempw and $0400)<>0 then begin
                                ll.putword(templ,r.a[2].wl);
                                templ:=templ+2;
                              end;
                              if (tempw and $0800)<>0 then begin
                                ll.putword(templ,r.a[3].wl);
                                templ:=templ+2;
                              end;
                              if (tempw and $1000)<>0 then begin
                                ll.putword(templ,r.a[4].wl);
                                templ:=templ+2;
                              end;
                              if (tempw and $2000)<>0 then begin
                                ll.putword(templ,r.a[5].wl);
                                templ:=templ+2;
                              end;
                              if (tempw and $4000)<>0 then begin
                                ll.putword(templ,r.a[6].wl);
                                templ:=templ+2;
                              end;
                              if (tempw and $8000)<>0 then begin
                                ll.putword(templ,r.a[7].wl);
                              end;
                             end;
                    $20..$27:begin
                            if (tempw and $0001)<>0 then ponerdir_w(r,ll,dir,r.a[7].wl);
                            if (tempw and $0002)<>0 then ponerdir_w(r,ll,dir,r.a[6].wl);
                            if (tempw and $0004)<>0 then ponerdir_w(r,ll,dir,r.a[5].wl);
                            if (tempw and $0008)<>0 then ponerdir_w(r,ll,dir,r.a[4].wl);
                            if (tempw and $0010)<>0 then ponerdir_w(r,ll,dir,r.a[3].wl);
                            if (tempw and $0020)<>0 then ponerdir_w(r,ll,dir,r.a[2].wl);
                            if (tempw and $0040)<>0 then ponerdir_w(r,ll,dir,r.a[1].wl);
                            if (tempw and $0080)<>0 then ponerdir_w(r,ll,dir,r.a[0].wl);
                            if (tempw and $0100)<>0 then ponerdir_w(r,ll,dir,r.d[7].wl);
                            if (tempw and $0200)<>0 then ponerdir_w(r,ll,dir,r.d[6].wl);
                            if (tempw and $0400)<>0 then ponerdir_w(r,ll,dir,r.d[5].wl);
                            if (tempw and $0800)<>0 then ponerdir_w(r,ll,dir,r.d[4].wl);
                            if (tempw and $1000)<>0 then ponerdir_w(r,ll,dir,r.d[3].wl);
                            if (tempw and $2000)<>0 then ponerdir_w(r,ll,dir,r.d[2].wl);
                            if (tempw and $4000)<>0 then ponerdir_w(r,ll,dir,r.d[1].wl);
                            if (tempw and $8000)<>0 then ponerdir_w(r,ll,dir,r.d[0].wl);
                          end;
                    else MessageDlg('Mierda movem.w $22 '+inttohex(dir,2)+' - '+inttohex(r.pc.l,10), mtInformation,[mbOk], 0);
                  end;
                end;
              end;
          $23:if (dir shr 3)=0 then begin //+++++ ext.l
                   r.contador:=r.contador+4;
                   tempw:=r.d[orig].wl;
                   if (tempw and $8000)<>0 then templ:=$FFFF0000 or tempw
                      else templ:=tempw;
                   r.cc.c:=false;
                   r.cc.v:=false;
                   r.cc.n:=((templ shr 24) and $80)<>0;
                   r.cc.z:=(templ=0);
                   r.d[orig].l:=templ;
              end else begin //+++++ movem.l d=0 los bits de dir son destino
                r.contador:=r.contador+8;
                tempw:=ll.getword(r.pc.l);
                r.pc.l:=r.pc.l+2;
                tempw2:=tempw;
                tempb2:=0;
                for tempb:=0 to 15 do begin
                  if (tempw2 and 1)<>0 then tempb2:=tempb2+1;
                  tempw2:=tempw2 shr 1;
                end;
                r.contador:=r.contador+(tempb2 shl 3);
                case dir of
                  $10..$17,$28..$2f,$39:begin
                              templ:=leerdir_ea(r,ll,dir);
                              if (tempw and $0001)<>0 then begin
                                ll.putword(templ,r.d[0].wh);
                                ll.putword(templ+2,r.d[0].wl);
                                templ:=templ+4;
                              end;
                              if (tempw and $0002)<>0 then begin
                                ll.putword(templ,r.d[1].wh);
                                ll.putword(templ+2,r.d[1].wl);
                                templ:=templ+4;
                              end;
                              if (tempw and $0004)<>0 then begin
                                ll.putword(templ,r.d[2].wh);
                                ll.putword(templ+2,r.d[2].wl);
                                templ:=templ+4;
                              end;
                              if (tempw and $0008)<>0 then begin
                                ll.putword(templ,r.d[3].wh);
                                ll.putword(templ+2,r.d[3].wl);
                                templ:=templ+4;
                              end;
                              if (tempw and $0010)<>0 then begin
                                ll.putword(templ,r.d[4].wh);
                                ll.putword(templ+2,r.d[4].wl);
                                templ:=templ+4;
                              end;
                              if (tempw and $0020)<>0 then begin
                                ll.putword(templ,r.d[5].wh);
                                ll.putword(templ+2,r.d[5].wl);
                                templ:=templ+4;
                              end;
                              if (tempw and $0040)<>0 then begin
                                ll.putword(templ,r.d[6].wh);
                                ll.putword(templ+2,r.d[6].wl);
                                templ:=templ+4;
                              end;
                              if (tempw and $0080)<>0 then begin
                                ll.putword(templ,r.d[7].wh);
                                ll.putword(templ+2,r.d[7].wl);
                                templ:=templ+4;
                              end;
                              if (tempw and $0100)<>0 then begin
                                ll.putword(templ,r.a[0].wh);
                                ll.putword(templ+2,r.a[0].wl);
                                templ:=templ+4;
                              end;
                              if (tempw and $0200)<>0 then begin
                                ll.putword(templ,r.a[1].wh);
                                ll.putword(templ+2,r.a[1].wl);
                                templ:=templ+4;
                              end;
                              if (tempw and $0400)<>0 then begin
                                ll.putword(templ,r.a[2].wh);
                                ll.putword(templ+2,r.a[2].wl);
                                templ:=templ+4;
                              end;
                              if (tempw and $0800)<>0 then begin
                                ll.putword(templ,r.a[3].wh);
                                ll.putword(templ+2,r.a[3].wl);
                                templ:=templ+4;
                              end;
                              if (tempw and $1000)<>0 then begin
                                ll.putword(templ,r.a[4].wh);
                                ll.putword(templ+2,r.a[4].wl);
                                templ:=templ+4;
                              end;
                              if (tempw and $2000)<>0 then begin
                                ll.putword(templ,r.a[5].wh);
                                ll.putword(templ+2,r.a[5].wl);
                                templ:=templ+4;
                              end;
                              if (tempw and $4000)<>0 then begin
                                ll.putword(templ,r.a[6].wh);
                                ll.putword(templ+2,r.a[6].wl);
                                templ:=templ+4;
                              end;
                              if (tempw and $8000)<>0 then begin
                                ll.putword(templ,r.a[7].wh);
                                ll.putword(templ+2,r.a[7].wl);
                              end;
                             end;
                  $20..$27:begin
                            if (tempw and $0001)<>0 then ponerdir_l(r,ll,dir,r.a[7].l);
                            if (tempw and $0002)<>0 then ponerdir_l(r,ll,dir,r.a[6].l);
                            if (tempw and $0004)<>0 then ponerdir_l(r,ll,dir,r.a[5].l);
                            if (tempw and $0008)<>0 then ponerdir_l(r,ll,dir,r.a[4].l);
                            if (tempw and $0010)<>0 then ponerdir_l(r,ll,dir,r.a[3].l);
                            if (tempw and $0020)<>0 then ponerdir_l(r,ll,dir,r.a[2].l);
                            if (tempw and $0040)<>0 then ponerdir_l(r,ll,dir,r.a[1].l);
                            if (tempw and $0080)<>0 then ponerdir_l(r,ll,dir,r.a[0].l);
                            if (tempw and $0100)<>0 then ponerdir_l(r,ll,dir,r.d[7].l);
                            if (tempw and $0200)<>0 then ponerdir_l(r,ll,dir,r.d[6].l);
                            if (tempw and $0400)<>0 then ponerdir_l(r,ll,dir,r.d[5].l);
                            if (tempw and $0800)<>0 then ponerdir_l(r,ll,dir,r.d[4].l);
                            if (tempw and $1000)<>0 then ponerdir_l(r,ll,dir,r.d[3].l);
                            if (tempw and $2000)<>0 then ponerdir_l(r,ll,dir,r.d[2].l);
                            if (tempw and $4000)<>0 then ponerdir_l(r,ll,dir,r.d[1].l);
                            if (tempw and $8000)<>0 then ponerdir_l(r,ll,dir,r.d[0].l);
                          end;
                    else MessageDlg('Mierda movem.l $23 '+inttohex(dir,2)+' - '+inttohex(r.pc.l,10), mtInformation,[mbOk], 0);
                  end;
                end;
          $28:begin //+++++ tst.b
                r.contador:=r.contador+4;
                tempb:=leerdir_b(r,ll,dir);
                r.cc.v:=false;
                r.cc.c:=false;
                r.cc.n:=(tempb and $80)<>0;
  	            r.cc.z:=(tempb=0);
              end;
          $29:begin //+++++ tst.w
                r.contador:=r.contador+4;
                tempw:=leerdir_w(r,ll,dir);
                r.cc.v:=false;
                r.cc.c:=false;
                r.cc.n:=(tempw and $8000)<>0;
  	            r.cc.z:=(tempw=0);
              end;
          $2a:begin //+++++ tst.l
                r.contador:=r.contador+4;
                templ:=leerdir_l(r,ll,dir);
                r.cc.v:=false;
                r.cc.c:=false;
                r.cc.n:=((templ shr 24) and $80)<>0;
  	            r.cc.z:=(templ=0);
              end;
          $2b:begin //tas
                r.contador:=r.contador+4;
                tempb:=r.d[dir].l0;
                r.cc.z:=(tempb=0);
                r.cc.n:=(tempb and $80)<>0;
                r.cc.v:=false;
                r.cc.c:=false;
                r.d[dir].l0:=tempb or $80;
              end;
          $32:begin //movem.w  bits dir son origen
                r.contador:=r.contador+12;
                tempw:=ll.getword(r.pc.l);
                r.pc.l:=r.pc.l+2;
                tempw2:=tempw;
                  tempb2:=0;
                  for tempb:=0 to 15 do begin
                    if (tempw2 and 1)<>0 then tempb2:=tempb2+1;
                    tempw2:=tempw2 shr 1;
                  end;
                  r.contador:=r.contador+(tempb2 shl 2);
                case dir of
                  $10..$17,$28..$37:begin
                            templ:=leerdir_ea(r,ll,dir);
                            if (tempw and $0001)<>0 then begin
                              r.d[0].l:=smallint(ll.getword(templ));
                              templ:=templ+2;
                            end;
                            if (tempw and $0002)<>0 then begin
                              r.d[1].l:=smallint(ll.getword(templ));
                              templ:=templ+2;
                            end;
                            if (tempw and $0004)<>0 then begin
                              r.d[2].l:=smallint(ll.getword(templ));
                              templ:=templ+2;
                            end;
                            if (tempw and $0008)<>0 then begin
                              r.d[3].l:=smallint(ll.getword(templ));
                              templ:=templ+2;
                            end;
                            if (tempw and $0010)<>0 then begin
                              r.d[4].l:=smallint(ll.getword(templ));
                              templ:=templ+2;
                            end;
                            if (tempw and $0020)<>0 then begin
                              r.d[5].l:=smallint(ll.getword(templ));
                              templ:=templ+2;
                            end;
                            if (tempw and $0040)<>0 then begin
                              r.d[6].l:=smallint(ll.getword(templ));
                              templ:=templ+2;
                            end;
                            if (tempw and $0080)<>0 then begin
                              r.d[7].l:=smallint(ll.getword(templ));
                              templ:=templ+2;
                            end;
                            if (tempw and $0100)<>0 then begin
                              r.a[0].l:=smallint(ll.getword(templ));
                              templ:=templ+2;
                            end;
                            if (tempw and $0200)<>0 then begin
                              r.a[1].l:=smallint(ll.getword(templ));
                              templ:=templ+2;
                            end;
                            if (tempw and $0400)<>0 then begin
                              r.a[2].l:=smallint(ll.getword(templ));
                              templ:=templ+2;
                            end;
                            if (tempw and $0800)<>0 then begin
                              r.a[3].l:=smallint(ll.getword(templ));
                              templ:=templ+2;
                            end;
                            if (tempw and $1000)<>0 then begin
                              r.a[4].l:=smallint(ll.getword(templ));
                              templ:=templ+2;
                            end;
                            if (tempw and $2000)<>0 then begin
                              r.a[5].l:=smallint(ll.getword(templ));
                              templ:=templ+2;
                            end;
                            if (tempw and $4000)<>0 then begin
                              r.a[6].l:=smallint(ll.getword(templ));
                              templ:=templ+2;
                            end;
                            if (tempw and $8000)<>0 then begin
                              r.a[7].l:=smallint(ll.getword(templ));
                            end;
                           end;
                  $18..$1f:begin
                            if (tempw and $0001)<>0 then r.d[0].l:=smallint(leerdir_w(r,ll,dir));
                            if (tempw and $0002)<>0 then r.d[1].l:=smallint(leerdir_w(r,ll,dir));
                            if (tempw and $0004)<>0 then r.d[2].l:=smallint(leerdir_w(r,ll,dir));
                            if (tempw and $0008)<>0 then r.d[3].l:=smallint(leerdir_w(r,ll,dir));
                            if (tempw and $0010)<>0 then r.d[4].l:=smallint(leerdir_w(r,ll,dir));
                            if (tempw and $0020)<>0 then r.d[5].l:=smallint(leerdir_w(r,ll,dir));
                            if (tempw and $0040)<>0 then r.d[6].l:=smallint(leerdir_w(r,ll,dir));
                            if (tempw and $0080)<>0 then r.d[7].l:=smallint(leerdir_w(r,ll,dir));
                            if (tempw and $0100)<>0 then r.a[0].l:=smallint(leerdir_w(r,ll,dir));
                            if (tempw and $0200)<>0 then r.a[1].l:=smallint(leerdir_w(r,ll,dir));
                            if (tempw and $0400)<>0 then r.a[2].l:=smallint(leerdir_w(r,ll,dir));
                            if (tempw and $0800)<>0 then r.a[3].l:=smallint(leerdir_w(r,ll,dir));
                            if (tempw and $1000)<>0 then r.a[4].l:=smallint(leerdir_w(r,ll,dir));
                            if (tempw and $2000)<>0 then r.a[5].l:=smallint(leerdir_w(r,ll,dir));
                            if (tempw and $4000)<>0 then r.a[6].l:=smallint(leerdir_w(r,ll,dir));
                            if (tempw and $8000)<>0 then r.a[7].l:=smallint(leerdir_w(r,ll,dir));
                        end
                  else MessageDlg('Mierda movem.w $32 '+inttohex(dir,2)+' - '+inttohex(r.pc.l,10), mtInformation,[mbOk], 0);
                end;
              end;
          $33:begin //movem.l  bits dir son origen
                r.contador:=r.contador+12;
                tempw:=ll.getword(r.pc.l);
                r.pc.l:=r.pc.l+2;
                tempw2:=tempw;
                tempb2:=0;
                for tempb:=0 to 15 do begin
                    if (tempw2 and 1)<>0 then tempb2:=tempb2+1;
                    tempw2:=tempw2 shr 1;
                end;
                r.contador:=r.contador+(tempb2 shl 3);
                case dir of
                $10..$17,$28..$2f,$39,$3a:begin
                      templ:=leerdir_ea(r,ll,dir);
                      if (tempw and $0001)<>0 then begin
                         r.d[0].wh:=ll.getword(templ);
                         r.d[0].wl:=ll.getword(templ+2);
                         templ:=templ+4;
                      end;
                      if (tempw and $0002)<>0 then begin
                         r.d[1].wh:=ll.getword(templ);
                         r.d[1].wl:=ll.getword(templ+2);
                         templ:=templ+4;
                      end;
                      if (tempw and $0004)<>0 then begin
                         r.d[2].wh:=ll.getword(templ);
                         r.d[2].wl:=ll.getword(templ+2);
                         templ:=templ+4;
                      end;
                      if (tempw and $0008)<>0 then begin
                         r.d[3].wh:=ll.getword(templ);
                         r.d[3].wl:=ll.getword(templ+2);
                         templ:=templ+4;
                      end;
                      if (tempw and $0010)<>0 then begin
                         r.d[4].wh:=ll.getword(templ);
                         r.d[4].wl:=ll.getword(templ+2);
                         templ:=templ+4;
                      end;
                      if (tempw and $0020)<>0 then begin
                         r.d[5].wh:=ll.getword(templ);
                         r.d[5].wl:=ll.getword(templ+2);
                         templ:=templ+4;
                      end;
                      if (tempw and $0040)<>0 then begin
                         r.d[6].wh:=ll.getword(templ);
                         r.d[6].wl:=ll.getword(templ+2);
                         templ:=templ+4;
                      end;
                      if (tempw and $0080)<>0 then begin
                         r.d[7].wh:=ll.getword(templ);
                         r.d[7].wl:=ll.getword(templ+2);
                         templ:=templ+4;
                      end;
                      if (tempw and $0100)<>0 then begin
                         r.a[0].wh:=ll.getword(templ);
                         r.a[0].wl:=ll.getword(templ+2);
                         templ:=templ+4;
                      end;
                      if (tempw and $0200)<>0 then begin
                         r.a[1].wh:=ll.getword(templ);
                         r.a[1].wl:=ll.getword(templ+2);
                         templ:=templ+4;
                      end;
                      if (tempw and $0400)<>0 then begin
                         r.a[2].wh:=ll.getword(templ);
                         r.a[2].wl:=ll.getword(templ+2);
                         templ:=templ+4;
                      end;
                      if (tempw and $0800)<>0 then begin
                         r.a[3].wh:=ll.getword(templ);
                         r.a[3].wl:=ll.getword(templ+2);
                         templ:=templ+4;
                      end;
                      if (tempw and $1000)<>0 then begin
                         r.a[4].wh:=ll.getword(templ);
                         r.a[4].wl:=ll.getword(templ+2);
                         templ:=templ+4;
                      end;
                      if (tempw and $2000)<>0 then begin
                         r.a[5].wh:=ll.getword(templ);
                         r.a[5].wl:=ll.getword(templ+2);
                         templ:=templ+4;
                      end;
                      if (tempw and $4000)<>0 then begin
                         r.a[6].wh:=ll.getword(templ);
                         r.a[6].wl:=ll.getword(templ+2);
                         templ:=templ+4;
                      end;
                      if (tempw and $8000)<>0 then begin
                         r.a[7].wh:=ll.getword(templ);
                         r.a[7].wl:=ll.getword(templ+2);
                      end;
                end;
                $18..$1f:begin
                            if (tempw and $0001)<>0 then r.d[0].l:=leerdir_l(r,ll,dir); //D0
                            if (tempw and $0002)<>0 then r.d[1].l:=leerdir_l(r,ll,dir);
                            if (tempw and $0004)<>0 then r.d[2].l:=leerdir_l(r,ll,dir);
                            if (tempw and $0008)<>0 then r.d[3].l:=leerdir_l(r,ll,dir);
                            if (tempw and $0010)<>0 then r.d[4].l:=leerdir_l(r,ll,dir);
                            if (tempw and $0020)<>0 then r.d[5].l:=leerdir_l(r,ll,dir);
                            if (tempw and $0040)<>0 then r.d[6].l:=leerdir_l(r,ll,dir);
                            if (tempw and $0080)<>0 then r.d[7].l:=leerdir_l(r,ll,dir);
                            if (tempw and $0100)<>0 then r.a[0].l:=leerdir_l(r,ll,dir);
                            if (tempw and $0200)<>0 then r.a[1].l:=leerdir_l(r,ll,dir);
                            if (tempw and $0400)<>0 then r.a[2].l:=leerdir_l(r,ll,dir);
                            if (tempw and $0800)<>0 then r.a[3].l:=leerdir_l(r,ll,dir);
                            if (tempw and $1000)<>0 then r.a[4].l:=leerdir_l(r,ll,dir);
                            if (tempw and $2000)<>0 then r.a[5].l:=leerdir_l(r,ll,dir);
                            if (tempw and $4000)<>0 then r.a[6].l:=leerdir_l(r,ll,dir);
                            if (tempw and $8000)<>0 then r.a[7].l:=leerdir_l(r,ll,dir);
                        end;
                 else MessageDlg('Mierda movem.l $33 '+inttohex(dir,2)+' - '+inttohex(r.pc.l,10), mtInformation,[mbOk], 0);
                end;
              end;
          $39:case dir of
           $0..$f:begin //trap
                     r.prefetch:=false;
                     r.contador:=r.contador+38;
                     tempw:=coger_band(r);
                     poner_band(r,tempw or $2000);
                     r.sp.l:=r.sp.l-6;
                     ll.putword(r.sp.l+4,r.pc.wl);
                     ll.putword(r.sp.l+2,r.pc.wh);
                     ll.putword(r.sp.l,tempw);
                     r.pc.wh:=ll.getword($80+((instruccion and $f)*4));
                     r.pc.wl:=ll.getword($80+2+((instruccion and $f)*4));
                  end;
         $10..$17:begin //link
                    r.contador:=r.contador+16;
                    tempw:=ll.getword(r.pc.l);
                    r.pc.l:=r.pc.l+2;
                    r.sp.l:=r.sp.l-4;
                    ll.putword(r.sp.l,r.a[orig].wh);
                    ll.putword(r.sp.l+2,r.a[orig].wl);
                    r.a[orig].l:=r.sp.l;
                    r.sp.l:=r.sp.l+smallint(tempw);
                  end;
          $18..$1f:begin  //ulnk
                    r.contador:=r.contador+12;
                    r.sp.l:=r.a[orig].l;
                    r.a[orig].wh:=ll.getword(r.sp.l);
                    r.a[orig].wl:=ll.getword(r.sp.l+2);
                    r.sp.l:=r.sp.l+4;
                  end;
          $20..$2f:begin
                    r.contador:=r.contador+4;
                    if ((instruccion shr 3) and 1)=1 then r.a[orig].l:=r.usp.l //+++ move fru
                        else r.usp.l:=r.a[orig].l;  //move tou
                   end;
              $30:begin  //reset
                    if r.cc.s then begin
                      r.prefetch:=false;
                      r.contador:=r.contador+44;
                    end else MessageDlg('Mierda error de privilegio reset'+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                  end;
              $31:r.contador:=r.contador+4; //++++ nop
              $33:begin  //++++ rte
                    if r.cc.s then begin
                      r.prefetch:=false;
                      r.contador:=r.contador+20;
                      tempw:=ll.getword(r.sp.l);
                      r.pc.wh:=ll.getword(r.sp.l+2);
                      r.pc.wl:=ll.getword(r.sp.l+4);
                      r.sp.l:=r.sp.l+6;
                      poner_band(r,tempw);
                    end else MessageDlg('Mierda error de privilegio rte'+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                  end;
              $35:begin //+++++ rts
                    r.prefetch:=false;
                    r.contador:=r.contador+16;
                    r.pc.wh:=ll.getword(r.sp.l);
                    r.pc.wl:=ll.getword(r.sp.l+2);
                    r.sp.l:=r.sp.l+4;
                  end;
              $37:begin //++++++ rtr
                    r.prefetch:=false;
                    r.contador:=r.contador+20;
                    poner_band(r,ll.getword(r.sp.l));
                    r.pc.wh:=ll.getword(r.sp.l+2);
                    r.pc.wl:=ll.getword(r.sp.l+4);
                    r.sp.l:=r.sp.l+6;
                  end
                else MessageDlg('Instruccion $4b - $39 desconocida - '+inttohex(instruccion and $3f,2)+' - '+inttohex(r.pc.l,10), mtInformation,[mbOk], 0);
              end;
          $3a:begin //jsr
                r.prefetch:=false;
                templ:=leerdir_ea(r,ll,dir);
                r.sp.l:=r.sp.l-4;
                ll.putword(r.sp.l,r.pc.wh);
                ll.putword(r.sp.l+2,r.pc.wl);
                r.pc.l:=templ;
                case dir of
                  $10..$17:r.contador:=r.contador+16;  //(An)
                  $28..$2f,$38,$3a:r.contador:=r.contador+18; //d(An) xxx.W d(PC)
                  $30..$37,$3b:r.contador:=r.contador+22; //d(An,ix) d(PC,ix)
                  $39:r.contador:=r.contador+20; //xxx.L
                end
              end;
          $3b:begin //jmp
                r.prefetch:=false;
                r.pc.l:=leerdir_ea(r,ll,dir);
                case dir of
                  $10..$17:r.contador:=r.contador+8;  //(An)
                  $28..$2f,$38,$3a:r.contador:=r.contador+10; //d(An) xxx.W d(PC)
                  $30..$37,$3b:r.contador:=r.contador+14; //d(An,ix) d(PC,ix)
                  $39:r.contador:=r.contador+12; //xxx.L
                end
              end;
          else MessageDlg('Instruccion $4: '+inttohex((instruccion shr 6) and $3f,2)+' - '+inttohex(r.ppc.l,10), mtInformation,[mbOk], 0);
      end;
   $5:case ((instruccion shr 6) and $7) of
          $0:begin  //addq.b
                if (dir shr 3)<>0 then r.contador:=r.contador+8
                    else r.contador:=r.contador+4;
                tempb:=((dest-1) and $7)+1;
                tempb2:=leerdir_b(r,ll,dir);
                tempw:=tempb+tempb2;
                ponerdir_b2(r,ll,dir,(tempw and $ff));
                r.cc.n:=(tempw and $80)<>0;
    	          r.cc.z:=((tempw and $ff)=0);
                r.cc.c:=(tempw and $100)<>0;
                r.cc.x:=r.cc.c;
                r.cc.v:=(((tempb xor tempw) and (tempb2 xor tempw)) and $80)<>0;
             end;
          $1:begin  //addq.w
                tempb:=((dest-1) and $7)+1;
                if (dir shr 3)>1 then r.contador:=r.contador+8
                  else r.contador:=r.contador+4;
                if (dir shr 3)<>1 then begin
                  tempw:=leerdir_w(r,ll,dir);
                  templ:=tempw+tempb;
                  ponerdir_w2(r,ll,dir,(templ and $ffff));
                  r.cc.n:=(templ and $8000)<>0;
    	            r.cc.z:=((templ and $ffff)=0);
                  r.cc.c:=(templ and $10000)<>0;
                  r.cc.x:=r.cc.c;
                  r.cc.v:=((((tempb xor templ) and (tempw xor templ)) shr 8) and $80)<>0;
                end else begin
                  r.a[orig].l:=r.a[orig].l+tempb;
                end;
             end;
          $2:begin //addq.l
                tempb:=((dest-1) and $7)+1;
                if (dir shr 3)>1 then r.contador:=r.contador+12
                  else r.contador:=r.contador+8;
                if (dir shr 3)<>1 then begin
                  templ:=leerdir_l(r,ll,dir);
                  templ2:=templ+tempb;
                  ponerdir_l2(r,ll,dir,templ2);
                  r.cc.n:=((templ shr 24) and $80)<>0;
    	            r.cc.z:=(templ=0);
                  r.cc.c:=((((tempb and templ2) or (not(templ) and (tempb or templ2))) shr 23) and $100)<>0;
                  r.cc.x:=r.cc.c;
                  r.cc.v:=((((tempb xor templ2) and (templ xor templ2)) shr 24) and $80)<>0;
                end else begin
                  r.a[orig].l:=r.a[orig].l+tempb;
                end;
             end;
          $3,$7:if ((dir shr 3) and $7)=1 then begin //dbcc, dbt y dbf
                      r.contador:=r.contador+12;
                      r.prefetch:=false;
                      if not(condicion(r,(instruccion shr 8) and $f)) then begin
                          r.d[orig].wl:=r.d[orig].wl-1;
                          if r.d[orig].wl<>$FFFF then begin
                              r.contador:=r.contador-2;
                              tempw:=ll.getword(r.pc.l);
                              r.pc.l:=r.pc.l+smallint(tempw);
                          end else r.pc.l:=r.pc.l+2;
                      end else r.pc.l:=r.pc.l+2;
                end else begin //scc, st y sf
                    if (dir shr 3)<>0 then r.contador:=r.contador+8
                        else r.contador:=r.contador+4;
                    if condicion(r,(instruccion shr 8) and $f) then ponerdir_b(r,ll,dir,$ff)
                        else ponerdir_b(r,ll,dir,0);
             end;
          $4:begin  //subq.b
                tempb:=((dest-1) and $7)+1;
                if (dir shr 3)<>0 then r.contador:=r.contador+8
                    else r.contador:=r.contador+4;
                tempb2:=leerdir_b(r,ll,dir);
                tempw:=tempb2-tempb;
                ponerdir_b2(r,ll,dir,(tempw and $ff));
                r.cc.n:=(tempw and $80)<>0;
                r.cc.z:=((tempw and $ff)=0);
                r.cc.c:=(tempw and $100)<>0;
                r.cc.x:=r.cc.c;
                r.cc.v:=(((tempb xor tempb2) and (tempw xor tempb2)) and $80)<>0;
             end;
          $5:begin  //subq.w
                tempb:=((dest-1) and $7)+1;
                if (dir shr 3)<>0 then r.contador:=r.contador+8
                    else r.contador:=r.contador+4;
                if (dir shr 3)<>1 then begin
                    tempw:=leerdir_w(r,ll,dir);
                    templ:=tempw-tempb;
                    ponerdir_w2(r,ll,dir,(templ and $ffff));
                    r.cc.n:=(templ and $8000)<>0;
                    r.cc.z:=((templ and $ffff)=0);
                    r.cc.c:=(templ and $10000)<>0;
                    r.cc.x:=r.cc.c;
                    r.cc.v:=((((tempb xor tempw) and (templ xor tempw)) shr 8) and $80)<>0;
                end else begin
                    r.a[orig].l:=r.a[orig].l-tempb;
                end;
             end;
          $6:begin  //subq.l
                tempb:=((dest-1) and $7)+1;
                if (dir shr 3)>1 then r.contador:=r.contador+12
                  else r.contador:=r.contador+8;
                if (dir shr 3)<>1 then begin
                  templ2:=leerdir_l(r,ll,dir);
                  templ:=templ2-tempb;
                  ponerdir_l2(r,ll,dir,templ);
                  r.cc.n:=((templ shr 24) and $80)<>0;
                  r.cc.z:=(templ=0);
                  r.cc.v:=((((tempb xor templ2) and (templ xor templ2)) shr 24) and $80)<>0;
                  r.cc.c:=((((tempb and templ) or (not(templ2) and (tempb or templ))) shr 23) and $100)<>0;
                  r.cc.x:=r.cc.c;
                end else begin
                  r.a[orig].l:=r.a[orig].l-tempb;
                end;
             end;
      end; //del case $5
   $6:case (instruccion shr 8) and $f of
          0:begin  //+++++ BRA
              r.contador:=r.contador+10;
              tempb:=instruccion and $FF;
              r.prefetch:=false;
              case tempb of
                $00:begin //desplazamiento 16bits
                      tempw:=ll.getword(r.pc.l);
                      r.pc.l:=r.pc.l+smallint(tempw);
                    end;
                $ff:begin  //desplazamiento 32bits
                      MessageDlg('Mierda! BRA de 32bits '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                   end;
                else begin //desplazamiento 8bits
                     r.pc.l:=r.pc.l+shortint(tempb);
                end;
              end;
            end;
          1:begin  //+++++ BSR
              tempb:=instruccion and $FF;
              r.contador:=r.contador+18;
              r.prefetch:=false;
              case tempb of
                $00:begin //desplazamiento 16bits
                       tempw:=ll.getword(r.pc.l);
                       r.sp.l:=r.sp.l-4;
                       ll.putword(r.sp.l,(r.pc.l+2) shr 16);
                       ll.putword(r.sp.l+2,(r.pc.l+2) and $FFFF);
                       r.pc.l:=r.pc.l+smallint(tempw);
                    end;
                $ff:begin  //desplazamiento 32bits
                        MessageDlg('Mierda! BSR de 32bits '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                    end;
                else begin //desplazamiento 8bits
                        r.sp.l:=r.sp.l-4;
                        ll.putword(r.sp.l,r.pc.l shr 16);
                        ll.putword(r.sp.l+2,r.pc.l and $FFFF);
                        r.pc.l:=r.pc.l+shortint(tempb);
                    end;
              end;
            end
          else if condicion(r,(instruccion shr 8) and $f) then begin  //++++++ Bcc
                r.contador:=r.contador+10;
                tempb:=(instruccion and $ff);
                r.prefetch:=false;
                case tempb of
                  $00:begin //desplazamiento de 16bits
                        tempw:=ll.getword(r.pc.l);
                        r.pc.l:=r.pc.l+smallint(tempw);
                      end;
                  $ff:begin
                        MessageDlg('Mierda! BCC de 32bits '+inttostr(r.ppc.l), mtInformation,[mbOk], 0);
                      end;
                    else begin  //desplazamiento de 8bits
                            r.pc.l:=r.pc.l+shortint(tempb);
                         end;
                  end;
          end else begin //sino hace el salto comprobar si hay 16bits de desplazamiento
              r.contador:=r.contador+8;
              tempb:=(instruccion and $ff);
              case tempb of
                $00:r.pc.l:=r.pc.l+2;
                $ff:MessageDlg('Mierda! BCC de 32bits no tomado! '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
              end;
          end;
      end;
   $7:begin //+++++++++++++++++ moveq
        r.contador:=r.contador+4;
        r.d[dest].l:=shortint(instruccion and $ff);
        r.cc.c:=false;
        r.cc.v:=false;
        r.cc.z:=(r.d[dest].l=0);
        r.cc.n:=((r.d[dest].l shr 24) and $80)<>0;
      end;
   $8:case ((instruccion shr 6) and $7) of
        $0:begin //or.b er
              r.contador:=r.contador+4;
              tempb:=leerdir_b(r,ll,dir);
              tempb2:=r.d[dest].l0 or tempb;
              r.d[dest].l0:=tempb2;
              r.cc.n:=(tempb2 and $80)<>0;
              r.cc.z:=(tempb2=0);
              r.cc.c:=false;
              r.cc.v:=false;
           end;
        $1:begin  //or.w er
              r.contador:=r.contador+4;
              tempw:=leerdir_w(r,ll,dir);
              tempw2:=r.d[dest].wl or tempw;
              r.d[dest].wl:=tempw2;
              r.cc.n:=(tempw2 and $8000)<>0;
              r.cc.z:=(tempw2=0);
              r.cc.c:=false;
              r.cc.v:=false;
           end;
        $2:begin  //or.l er
              r.contador:=r.contador+6;
              templ:=leerdir_l(r,ll,dir);
              templ2:=r.d[dest].l or templ;
              r.d[dest].l:=templ2;
              r.cc.n:=((templ2 shr 24) and $80)<>0;
              r.cc.z:=(templ2=0);
              r.cc.c:=false;
              r.cc.v:=false;
           end;
        $3:begin  //divu
              r.contador:=r.contador+140;
              tempw:=leerdir_w(r,ll,dir);
              if tempw<>0 then begin
                  templ:=r.d[dest].l div tempw;
                  if(templ<$10000) then begin
              			r.cc.z:=(templ<>0);
                    r.cc.n:=(templ and $8000)<>0;
              			r.cc.v:=false;
              			r.cc.c:=false;
                    templ2:=r.d[dest].l mod tempw;
                    templ3:=(templ and $ffff) or ((templ2 and $ffff) shl 16);
                    r.d[dest].l:=templ3;
                  end else begin
                    r.cc.v:=true;
                  end;
              end else begin
                  MessageDlg('Mierda! Division por 0'+inttostr(r.pc.l), mtInformation,[mbOk], 0);
              end;
           end;
        $4:case ((dir shr 3) and $7) of
                 $0:begin  //sbcd rr
                       r.contador:=r.contador+6;
                       tempb:=r.d[dest].l0;
                       tempb2:=r.d[orig].l0;
                       if r.cc.x then tempw:=(tempb and $f)-(tempb2 and $f)-1
                         else tempw:=(tempb and $f)-(tempb2 and $f);
                       r.cc.v:=false;
                       if tempw>9 then tempw:=tempw-6;
                       tempw:=tempw+(tempb and $f0)-(tempb2 and $f0);
                       if (tempw>$99) then begin
                         tempw:=tempw+$a0;
                         r.cc.x:=true;
                         r.cc.c:=true;
                         r.cc.n:=true;
                       end else begin
                         r.cc.n:=false;
                         r.cc.x:=false;
                         r.cc.c:=false;
                       end;
                       r.cc.z:=(tempw and $ff)=0;
                       r.d[dest].l0:=tempw and $ff;
                    end;
                 $1:begin  //sbcd mm
                      r.contador:=r.contador+18;
                      case (instruccion and $fff) of
                        $10f,$30f,$50f,$70f,$90f,$b0f,$d0f:begin
                               MessageDlg('Instruccion sbcd ay7 '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                             end;
                        $f04..$f0e:begin
                               MessageDlg('Instruccion sbcd ax7 '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                             end;
                        $f0f:begin
                               MessageDlg('Instruccion sbcd axy7 '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                             end;
                        else begin
                          r.a[orig].l:=r.a[orig].l-1;
                          tempb2:=getbyte(ll,r.a[orig].l);
                          r.a[dest].l:=r.a[dest].l-1;
                          tempb:=getbyte(ll,r.a[dest].l);
                          if r.cc.x then tempw:=(tempb and $f)-(tempb2 and $f)-1
                            else tempw:=(tempb and $f)-(tempb2 and $f);
                          r.cc.v:=false;
                          if tempw>9 then tempw:=tempw-6;
                          tempw:=tempw+(tempb and $f0)-(tempb2 and $f0);
                          if (tempw>$99) then begin
                             tempw:=tempw+$a0;
                             r.cc.x:=true;
                             r.cc.c:=true;
                             r.cc.n:=true;
                          end else begin
                             r.cc.n:=false;
                             r.cc.x:=false;
                             r.cc.c:=false;
                          end;
                          r.cc.z:=(tempw and $ff)=0;
                          putbyte(ll,r.a[dest].l,tempw and $ff)
                        end;
                      end;
                    end;
                 else begin  //or.b re
                    r.contador:=r.contador+8;
                    tempb:=r.d[dest].l0;
                    tempb2:=leerdir_b(r,ll,dir) or tempb;
                    ponerdir_b2(r,ll,dir,tempb2);
                    r.cc.n:=(tempb2 and $80)<>0;
                    r.cc.z:=(tempb2=0);
                    r.cc.c:=false;
                    r.cc.v:=false;
                 end;
           end;
        $5:begin //or.w re
              r.contador:=r.contador+8;
              tempw:=r.d[dest].wl;
              tempw2:=leerdir_w(r,ll,dir) or tempw;
              ponerdir_w2(r,ll,dir,tempw2);
              r.cc.n:=(tempw2 and $8000)<>0;
              r.cc.z:=(tempw2=0);
              r.cc.c:=false;
              r.cc.v:=false;
           end;
        $6:begin //or.l re
              r.contador:=r.contador+12;
              templ:=r.d[dest].l;
              templ2:=leerdir_l(r,ll,dir) or templ;
              ponerdir_l2(r,ll,dir,templ2);
              r.cc.n:=((templ2 shr 24) and $80)<>0;
              r.cc.z:=(templ2=0);
              r.cc.c:=false;
              r.cc.v:=false;
           end;
        $7:begin  //divs
              r.contador:=r.contador+158;
              divisor:=smallint(leerdir_w(r,ll,dir));
              if divisor<>0 then begin
                  templ:=r.d[dest].l;
                  if ((templ=$80000000) and (divisor=-1)) then begin
              			r.cc.z:=true;
              			r.cc.n:=false;
              			r.cc.v:=false;
                    r.cc.c:=false;
              			r.d[dest].l:=0;
                  end else begin
  		              quotient:=integer(templ) div divisor;
	  	              remainder:=integer(templ) mod divisor;
		                if (quotient=smallint(quotient)) then begin
                      r.cc.z:=(quotient<>0);
                      r.cc.n:=(quotient and $8000)<>0;
                      r.cc.v:=false;
                      r.cc.c:=false;
                			r.d[dest].l:=((quotient and $ffff) or (remainder shl 16)) and $ffffffff;
		                end else r.cc.v:=true;
                  end;
              end else begin
                  MessageDlg('Mierda! Division por 0'+inttostr(r.pc.l), mtInformation,[mbOk], 0);
              end;
           end;
      end;  //del case $8
    $9:case ((instruccion shr 6) and $7) of
        $0:begin  //sub.b er
              r.contador:=r.contador+4;
              tempb:=leerdir_b(r,ll,dir);
              tempb2:=r.d[dest].l0;
              tempw:=tempb2-tempb;
              r.d[dest].l0:=tempw and $ff;
              r.cc.n:=(tempw and $80)<>0;
              r.cc.c:=(tempw and $100)<>0;
              r.cc.x:=r.cc.c;
              r.cc.v:=(((tempb xor tempb2) and (tempw xor tempb2)) and $80)<>0;
              r.cc.z:=(tempw and $ff)=0;
           end;
        $1:begin  //sub.w er
              r.contador:=r.contador+4;
              tempw:=leerdir_w(r,ll,dir);
              tempw2:=r.d[dest].wl;
              templ:=tempw2-tempw;
              r.d[dest].wl:=templ and $ffff;
              r.cc.n:=(templ and $8000)<>0;
              r.cc.c:=(templ and $10000)<>0;
              r.cc.x:=r.cc.c;
              r.cc.v:=((((tempw xor tempw2) and (templ xor tempw2)) shr 8) and $80)<>0;
              r.cc.z:=(templ and $ffff)=0;
           end;
        $2:begin  //sub.l er
              r.contador:=r.contador+6;
              templ:=leerdir_l(r,ll,dir);
              templ2:=r.d[dest].l;
              templ3:=templ2-templ;
              r.d[dest].l:=templ3;
              r.cc.n:=((templ3 shr 24) and $80)<>0;
              r.cc.z:=(templ3=0);
              r.cc.v:=((((templ xor templ2) and (templ3 xor templ2)) shr 24) and $80)<>0;
              r.cc.c:=((((templ and templ3) or (not(templ2) and (templ or templ3))) shr 23) and $100)<>0;
           end;
        $3:begin
              r.contador:=r.contador+8;
              tempw:=leerdir_w(r,ll,dir);
              r.a[dest].l:=r.a[dest].l-smallint(tempw);
           end;
        $4:case ((instruccion shr 3) and $7) of
              $0:begin  //subx.b rr
                     r.contador:=r.contador+4;
                     tempb:=r.d[orig].l0;
                     tempb2:=r.d[dest].l0;
                     if r.cc.x then tempw:=tempb2-tempb-1
                        else tempw:=tempb2-tempb;
                     r.d[dest].l0:=tempw and $ff;
                     r.cc.n:=(tempw and $80)<>0;
                     r.cc.c:=(tempw and $100)<>0;
                     r.cc.x:=r.cc.c;
                     r.cc.v:=(((tempb xor tempb2) and (tempw xor tempb2)) and $80)<>0;
                     r.cc.z:=(tempw and $ff)=0;
                 end;
              $1:begin  //subx.b mm
                     r.contador:=r.contador+18;
                     MessageDlg('Instruccion subx.b mm '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                 end;
              else begin //sub.b re
                   r.contador:=r.contador+8;
                   tempb:=r.d[dest].l0;
                   tempb2:=leerdir_b(r,ll,dir);
                   tempw:=tempb2-tempb;
                   ponerdir_b2(r,ll,dir,tempw and $ff);
                   r.cc.n:=(tempw and $80)<>0;
                   r.cc.c:=(tempw and $100)<>0;
                   r.cc.x:=r.cc.c;
                   r.cc.v:=(((tempb xor tempb2) and (tempw xor tempb2)) and $80)<>0;
                   r.cc.z:=(tempw and $ff)=0;
              end;
           end;
        $5:case ((instruccion shr 3) and $7) of
                 $0:begin  //subx.w rr
                     tempw:=r.d[orig].wl;
                     tempw2:=r.d[dest].wl;
                     if r.cc.x then templ:=tempw2-tempw-1
                        else templ:=tempw2-tempw;
                     r.cc.n:=(templ and $8000)<>0;
                     r.cc.c:=(templ and $10000)<>0;
                     r.cc.x:=r.cc.c;
                     r.cc.v:=((((tempw xor tempw2) and (templ xor tempw2)) shr 8) and $80)<>0;
                     r.cc.z:=(templ and $ffff)=0;
                     r.d[dest].wl:=templ and $ffff;
                     r.contador:=r.contador+4;
                    end;
                 $1:begin  //subx.w mm
                      MessageDlg('Instruccion subx.w mm '+inttohex(r.pc.l,10), mtInformation,[mbOk], 0);
                      r.contador:=r.contador+18;
                    end;
                 else begin //sub.w re
                    r.contador:=r.contador+8;
                    tempw:=r.d[dest].wl;
                    tempw2:=leerdir_w(r,ll,dir);
                    templ:=tempw2-tempw;
                    ponerdir_w2(r,ll,dir,templ and $ffff);
                    r.cc.n:=(templ and $8000)<>0;
                    r.cc.c:=(templ and $10000)<>0;
                    r.cc.x:=r.cc.c;
                    r.cc.v:=((((tempw xor tempw2) and (templ xor tempw2)) shr 8) and $80)<>0;
                    r.cc.z:=(templ and $ffff)=0;
                 end;
           end;
        $6:case ((instruccion shr 3) and $7) of
                 $0:begin  //subx.l rr
                      r.contador:=r.contador+8;
                      templ:=r.d[orig].l;
                      templ2:=r.d[dest].l;
                      if r.cc.x then templ3:=templ2-templ-1
                         else templ3:=templ2-templ;
                      r.d[dest].l:=templ3;
                      r.cc.n:=((templ3 shr 24) and $80)<>0;
                      r.cc.z:=(templ3=0);
                      r.cc.v:=((((templ xor templ2) and (templ3 xor templ2)) shr 24) and $80)<>0;
                      r.cc.c:=((((templ and templ3) or (not(templ2) and (templ or templ3))) shr 23) and $100)<>0;
                      r.cc.x:=r.cc.c;
                    end;
                 $1:begin  //subx.l mm
                      MessageDlg('Instruccion subx.l mm '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                      r.contador:=r.contador+30;
                    end;
                 else begin  //sub.l re
                      r.contador:=r.contador+12;
                      templ:=r.d[dest].l;
                      templ2:=leerdir_l(r,ll,dir);
                      templ3:=templ2-templ;
                      ponerdir_l2(r,ll,dir,templ3);
                      r.cc.n:=((templ3 shr 24) and $80)<>0;
                      r.cc.z:=(templ3=0);
                      r.cc.v:=((((templ xor templ2) and (templ3 xor templ2)) shr 24) and $80)<>0;
                      r.cc.c:=((((templ and templ3) or (not(templ2) and (templ or templ3))) shr 23) and $100)<>0;
                 end;
           end;
        $7:begin  //suba.l
              r.contador:=r.contador+6;
              r.a[dest].l:=r.a[dest].l-leerdir_l(r,ll,dir);
           end;
       end;  //del case $9
   $b:case ((instruccion shr 6) and $7) of
        $0:begin //cmp.b
              r.contador:=r.contador+4;
              tempb:=leerdir_b(r,ll,dir);
              tempb2:=r.d[dest].l0;
              tempw:=tempb2-tempb;
              r.cc.n:=(tempw and $80)<>0;
              r.cc.z:=((tempw and $ff)=0);
              r.cc.v:=(((tempb xor tempb2) and (tempw xor tempb2)) and $80)<>0;
              r.cc.c:=(tempw and $100)<>0;
           end;
        $1:begin  //cmp.w
              r.contador:=r.contador+4;
              tempw:=leerdir_w(r,ll,dir);
              tempw2:=r.d[dest].wl;
              templ:=tempw2-tempw;
              r.cc.n:=(templ and $8000)<>0;
              r.cc.z:=((templ and $ffff)=0);
              r.cc.v:=((((tempw xor tempw2) and (templ xor tempw2)) shr 8) and $80)<>0;
              r.cc.c:=(templ and $10000)<>0;
           end;
        $2:begin //cmp.l
              r.contador:=r.contador+6;
              templ:=leerdir_l(r,ll,dir);
              templ2:=r.d[dest].l;
              templ3:=templ2-templ;
              r.cc.n:=((templ3 shr 24) and $80)<>0;
              r.cc.z:=(templ3=0);
              r.cc.v:=((((templ xor templ2) and (templ3 xor templ2)) shr 24) and $80)<>0;
              r.cc.c:=((((templ and templ3) or (not(templ2) and (templ or templ3))) shr 23) and $100)<>0;
            end;
         $3:begin  //cmpa.w
              r.contador:=r.contador+6;
              templ:=cardinal(smallint(leerdir_w(r,ll,dir)));
              templ2:=r.a[dest].l;
              templ3:=templ2-templ;
              r.cc.n:=((templ3 shr 24) and $80)<>0;
	            r.cc.z:=(templ3=0);
  	          r.cc.v:=((((templ xor templ2) and (templ3 xor templ2)) shr 24) and $80)<>0;
	            r.cc.c:=((((templ and templ3) or (not(templ2) and (templ or templ3))) shr 23) and $100)<>0;
            end;
         $4:if ((instruccion shr 3) and $7)=1 then begin
                r.contador:=r.contador+12;
                case (instruccion and $fff) of
                  $10f,$30f,$50f,$70f,$90f,$b0f,$d0f:begin
                      MessageDlg('Instruccion cmpm.b ay7 '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                    end;
                  $f04..$f0e:begin
                      MessageDlg('Instruccion cmpm.b ax7 '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                    end;
                  $f0f:begin
                      MessageDlg('Instruccion cmpm.b axy7 '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                    end;
                  else begin //cmpm.b
                      tempb:=getbyte(ll,r.a[orig].l);
                      r.a[orig].l:=r.a[orig].l+1;
                      tempb2:=getbyte(ll,r.a[dest].l);
                      r.a[dest].l:=r.a[dest].l+1;
                      tempw:=tempb2-tempb;
                      r.cc.n:=(tempw and $80)<>0;
                      r.cc.z:=((tempw and $ff)=0);
                      r.cc.v:=(((tempb xor tempb2) and (tempw xor tempb2)) and $80)<>0;
                      r.cc.c:=(tempw and $100)<>0;
                  end;
                end;
            end else begin //eor.b
                if (dir shr 3)<>0 then r.contador:=r.contador+8
                  else r.contador:=r.contador+4;
                tempb:=leerdir_b(r,ll,dir);
                tempb2:=tempb xor r.d[dest].l0;
                ponerdir_b2(r,ll,dir,tempb2);
                r.cc.n:=(tempb2 and $80)<>0;
                r.cc.z:=(tempb2=0);
                r.cc.v:=false;
                r.cc.c:=false;
            end;
         $5:begin
              if ((instruccion shr 3) and $7)=1 then begin //cmpm.w
                r.contador:=r.contador+12;
                tempw:=ll.getword(r.a[orig].l);
                r.a[orig].l:=r.a[orig].l+2;
                tempw2:=ll.getword(r.a[dest].l);
                r.a[dest].l:=r.a[dest].l+2;
                templ:=tempw2-tempw;
                r.cc.n:=(templ and $8000)<>0;
                r.cc.z:=((templ and $ffff)=0);
                r.cc.v:=((((tempw xor tempw2) and (templ xor tempw2)) shr 8) and $80)<>0;
                r.cc.c:=(templ and $10000)<>0;
              end else begin //eor.w
                if (dir shr 3)<>0 then r.contador:=r.contador+8
                  else r.contador:=r.contador+4;
                tempw:=leerdir_w(r,ll,dir);
                tempw2:=tempw xor r.d[dest].wl;
                ponerdir_w2(r,ll,dir,tempw2);
                r.cc.n:=(tempw2 and $8000)<>0;
                r.cc.z:=(tempw2=0);
                r.cc.v:=false;
                r.cc.c:=false;
              end;
            end;
         $6:begin
              if ((instruccion shr 3) and $7)=1 then begin //cmpm.l
                r.contador:=r.contador+20;
                templ:=ll.getword(r.a[orig].l) shl 16;
                templ:=templ or ll.getword(r.a[orig].l+2);
                r.a[orig].l:=r.a[orig].l+4;
                templ2:=ll.getword(r.a[dest].l) shl 16;
                templ2:=templ2 or ll.getword(r.a[dest].l+2);
                r.a[dest].l:=r.a[dest].l+4;
                templ3:=templ2-templ;
                r.cc.n:=((templ3 shr 24) and $80)<>0;
	              r.cc.z:=(templ3=0);
	              r.cc.v:=((((templ xor templ2) and (templ3 xor templ2)) shr 24) and $80)<>0;
	              r.cc.c:=((((templ and templ3) or (not(templ2) and (templ or templ3))) shr 23) and $100)<>0;
              end else begin  //eor.l
                if (dir shr 3)<>0 then r.contador:=r.contador+12
                  else r.contador:=r.contador+8;
                templ:=leerdir_l(r,ll,dir);
                templ2:=templ xor r.d[dest].l;
                ponerdir_l2(r,ll,dir,templ2);
                r.cc.n:=((templ2 shr 24) and $80)<>0;
                r.cc.z:=(templ2=0);
                r.cc.v:=false;
                r.cc.c:=false;
              end;
            end;
         $7:begin //cmpa.l
              r.contador:=r.contador+6;
              templ:=leerdir_l(r,ll,dir);
              templ2:=r.a[dest].l;
              templ3:=templ2-templ;
              r.cc.n:=((templ3 shr 24) and $80)<>0;
	            r.cc.z:=(templ3=0);
	            r.cc.v:=((((templ xor templ2) and (templ3 xor templ2)) shr 24) and $80)<>0;
	            r.cc.c:=((((templ and templ3) or (not(templ2) and (templ or templ3))) shr 23) and $100)<>0;
            end;
       end;  //del case principal $b
   $c:case ((instruccion shr 6) and $7) of
            $0:begin  //and.b re
                 r.contador:=r.contador+4;
                 tempb:=leerdir_b(r,ll,dir);
                 tempb2:=r.d[dest].l0 and tempb;
                 r.d[dest].l0:=tempb2;
                 r.cc.n:=(tempb2 and $80)<>0;
                 r.cc.z:=(tempb2=0);
                 r.cc.c:=false;
                 r.cc.v:=false;
               end;
            $1:begin  //and.w re
                 r.contador:=r.contador+4;
                 tempw:=leerdir_w(r,ll,dir);
                 tempw2:=r.d[dest].wl and tempw;
                 r.d[dest].wl:=tempw2;
                 r.cc.n:=(tempw2 and $8000)<>0;
                 r.cc.z:=(tempw2=0);
                 r.cc.c:=false;
                 r.cc.v:=false;
               end;
            $2:begin  //and.l re
                 r.contador:=r.contador+6;
                 templ:=leerdir_l(r,ll,dir);
                 templ2:=r.d[dest].l and templ;
                 r.d[dest].l:=templ2;
                 r.cc.n:=((templ2 shr 24) and $80)<>0;
                 r.cc.z:=(templ2=0);
                 r.cc.c:=false;
                 r.cc.v:=false;
               end;
            $3:begin //mulu
                 r.contador:=r.contador+54;
                 tempw:=leerdir_w(r,ll,dir);
                 tempw2:=r.d[dest].wl;
                 templ:=tempw*tempw2;
                 r.d[dest].l:=templ;
                 r.cc.z:=(templ=0);
                 r.cc.n:=((templ shr 24) and $80)<>0;
                 r.cc.v:=false;
                 r.cc.c:=false;
               end;
            $4:case ((dir shr 3) and $7) of
                 $0:begin  //abcd rr
                      r.contador:=r.contador+6;
                      tempb:=r.d[orig].l0;
                      tempb2:=r.d[dest].l0;
                      if r.cc.x then tempw:=(tempb and $f)+(tempb2 and $f)+1
                         else tempw:=(tempb and $f)+(tempb2 and $f);
                      r.cc.v:=((not(tempw) and $80)<>0);
                      if (tempw>9) then tempw:=tempw+6;
                      tempw:=tempw+(tempb and $f0)+(tempb2 and $f0);
                      r.cc.c:=tempw>$99;
                      r.cc.x:=r.cc.c;
                    	if r.cc.c then tempw:=tempw-$a0;
                      r.cc.v:=r.cc.v and ((tempw and $80)<>0);
             	        r.cc.n:=(tempw and $80)<>0;
                      r.cc.z:=(tempw and $ff)=0;
                      r.d[dest].l0:=tempw and $ff;
                    end;
                 $1:begin  //abcd mm
                      r.contador:=r.contador+18;
                      case (instruccion and $fff) of
                        $10f,$30f,$50f,$70f,$90f,$b0f,$d0f:begin
                               MessageDlg('Instruccion abcd ay7 '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                             end;
                        $f04..$f0e:begin
                               MessageDlg('Instruccion abcd ax7 '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                             end;
                        $f0f:begin
                               MessageDlg('Instruccion abcd axy7 '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                             end;
                        else begin
                               r.a[orig].l:=r.a[orig].l-1;
                               tempb:=getbyte(ll,r.a[orig].l);
                               r.a[dest].l:=r.a[dest].l-1;
                               tempb2:=getbyte(ll,r.a[dest].l);
                               if r.cc.x then tempw:=(tempb and $f)+(tempb2 and $f)+1
                                  else tempw:=(tempb and $f)+(tempb2 and $f);
                               r.cc.v:=(not(tempw) and $80)<>0;
                               if (tempw>9) then tempw:=tempw+6;
       	                       tempw:=(tempw and $ff)+(tempb and $f0)+(tempb2 and $f0);
                               r.cc.c:=tempw>$99;
                               r.cc.x:=r.cc.c;
                             	 if r.cc.c then tempw:=tempw-$a0;
                               r.cc.v:=r.cc.v and ((tempw and $80)<>0);
            	                 r.cc.n:=(tempw and $80)<>0;
                               r.cc.z:=(tempw and $ff)=0;
                               putbyte(ll,r.a[dest].l,tempw and $ff)
                        end;
                      end;
                    end;
                 else begin  //and.b re
                      r.contador:=r.contador+8;
                      tempb:=r.d[dest].l0;
                      tempb2:=leerdir_b(r,ll,dir) and tempb;
                      ponerdir_b2(r,ll,dir,tempb2);
                      r.cc.n:=(tempb2 and $80)<>0;
                    	r.cc.z:=(tempb2=0);
                    	r.cc.c:=false;
                    	r.cc.v:=false;
                 end;
               end;
            $5:case ((dir shr 3) and $7) of
                 $0:begin //exg dd
                      r.contador:=r.contador+6;
                      templ:=r.d[dest].l;
                      r.d[dest].l:=r.d[orig].l;
                      r.d[orig].l:=templ;
                    end;
                 $1:begin //exg aa
                      r.contador:=r.contador+6;
                      templ:=r.a[dest].l;
                      r.a[dest].l:=r.a[orig].l;
                      r.a[orig].l:=templ;
                    end;
                 else begin //and.w re
                      r.contador:=r.contador+8;
                      tempw:=r.d[dest].wl;
                      tempw2:=leerdir_w(r,ll,dir) and tempw;
                      ponerdir_w2(r,ll,dir,tempw2);
                      r.cc.n:=(tempw2 and $8000)<>0;
                      r.cc.z:=(tempw2=0);
                      r.cc.c:=false;
                      r.cc.v:=false;
                 end;
               end;
            $6:if ((dir shr 3) and $7)=1 then begin  //exg da
                 r.contador:=r.contador+6;
                 templ:=r.d[dest].l;
                 r.d[dest].l:=r.a[orig].l;
                 r.a[orig].l:=templ;
               end else begin  //and.l re
                 r.contador:=r.contador+12;
                 templ:=r.d[dest].l;
                 templ2:=leerdir_l(r,ll,dir) and templ;
                 ponerdir_l2(r,ll,dir,templ2);
                 r.cc.n:=((templ2 shr 24) and $80)<>0;
                 r.cc.z:=(templ2=0);
                 r.cc.c:=false;
                 r.cc.v:=false;
               end;
            $7:begin //muls
                 r.contador:=r.contador+54;
                 remainder:=smallint(leerdir_w(r,ll,dir));
                 quotient:=smallint(r.d[dest].wl);
                 templ:=remainder*quotient;
                 r.d[dest].l:=templ;
                 r.cc.z:=(templ=0);
               	 r.cc.n:=((templ shr 24) and $80)<>0;
                 r.cc.v:=false;
                 r.cc.c:=false;
               end;
      end;  //del $c
   $d:case ((instruccion shr 6) and $7) of
            $0:begin  //add.b er
                 r.contador:=r.contador+4;
                 tempb:=leerdir_b(r,ll,dir);
                 tempb2:=r.d[dest].l0;
                 tempw:=tempb+tempb2;
                 r.d[dest].l0:=tempw and $ff;
                 r.cc.n:=(tempw and $80)<>0;
                 r.cc.z:=((tempw and $ff)=0);
	               r.cc.v:=((((tempb xor tempw) and (tempb2 xor tempw))) and $80)<>0;
                 r.cc.c:=(tempw and $100)<>0;
	               r.cc.x:=r.cc.c;
               end;
            $1:begin  //add.w er
                 r.contador:=r.contador+4;
                 tempw:=leerdir_w(r,ll,dir);
                 tempw2:=r.d[dest].wl;
                 templ:=tempw+tempw2;
                 r.d[dest].wl:=templ and $ffff;
                 r.cc.n:=(templ and $8000)<>0;
                 r.cc.c:=(templ and $10000)<>0;
                 r.cc.x:=r.cc.c;
                 r.cc.v:=((((tempw xor templ) and (tempw2 xor templ)) shr 8) and $80)<>0;
                 r.cc.z:=((templ and $ffff)=0);
               end;
            $2:begin  //add.l er
                 r.contador:=r.contador+6;
                 templ:=leerdir_l(r,ll,dir);
                 templ2:=r.d[dest].l;
                 templ3:=templ+templ2;
                 r.d[dest].l:=templ3;
                 r.cc.n:=((templ3 shr 24) and $80)<>0;
                 r.cc.z:=(templ3=0);
	               r.cc.v:=((((templ xor templ3) and (templ2 xor templ3)) shr 24) and $80)<>0;
                 r.cc.c:=((((templ and templ2) or (not(templ3) and (templ or templ2))) shr 23) and $100)<>0;
	               r.cc.x:=r.cc.c;
               end;
            $3:begin  //adda.w
                 r.contador:=r.contador+8;
                 tempw:=leerdir_w(r,ll,dir);
                 r.a[dest].l:=r.a[dest].l+smallint(tempw);
               end;
            $4:case ((dir shr 3) and $7) of
                 $0:begin  //addx.b rr
                      r.contador:=r.contador+4;
                      tempb:=r.d[orig].l0;
                      tempb2:=r.d[dest].l0;
                      if r.cc.x then tempw:=1+tempb+tempb2
                        else tempw:=tempb+tempb2;
                      r.d[dest].l0:=tempw and $ff;
                      r.cc.n:=(tempw and $80)<>0;
                      r.cc.z:=((tempw and $ff)=0);
	                    r.cc.v:=((((tempb xor tempw) and (tempb2 xor tempw))) and $80)<>0;
                      r.cc.c:=(tempw and $100)<>0;
	                    r.cc.x:=r.cc.c;
                    end;
                 $1:begin  //addx.b mm
                      r.contador:=r.contador+18;
                      case (instruccion and $fff) of
                        $10f,$30f,$50f,$70f,$90f,$b0f,$d0f:begin
                               MessageDlg('Instruccion addx.b ay7 '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                             end;
                        $f04..$f0e:begin
                               MessageDlg('Instruccion addx.b ax7 '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                             end;
                        $f0f:begin
                               MessageDlg('Instruccion addx.b axy7 '+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                             end;
                        else begin
                          MessageDlg('Instruccion addx.b'+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                        end;
                      end;
                    end;
                    else begin  //add.b re
                      r.contador:=r.contador+8;
                      tempb:=r.d[dest].l0;
                      tempb2:=leerdir_b(r,ll,dir);
                      tempw:=tempb+tempb2;
                      ponerdir_b2(r,ll,dir,tempw and $ff);
                      r.cc.n:=(tempw and $80)<>0;
                      r.cc.z:=((tempw and $ff)=0);
	                    r.cc.v:=((((tempb xor tempw) and (tempb2 xor tempw))) and $80)<>0;
                      r.cc.c:=(tempw and $100)<>0;
	                    r.cc.x:=r.cc.c;
                 end;
               end;
            $5:case ((instruccion shr 3) and $7) of
                 $0:begin  //addx.w rr
                      r.contador:=r.contador+4;
                      tempw:=r.d[orig].wl;
                      tempw2:=r.d[dest].wl;
                      if r.cc.x then templ:=1+tempw+tempw2
                        else templ:=tempw+tempw2;
                      r.d[dest].wl:=templ and $ffff;
                      r.cc.n:=(templ and $8000)<>0;
                      r.cc.z:=((templ and $ffff)=0);
      	              r.cc.v:=((((tempw xor templ) and (tempw2 xor templ))) and $8000)<>0;
                      r.cc.c:=(templ and $10000)<>0;
	                    r.cc.x:=r.cc.c;
                    end;
                 $1:begin  //addx.w mm
                      MessageDlg('Instruccion addx.w mm'+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                    end;
                 else begin  //add.w re
                    r.contador:=r.contador+8;
                    tempw:=r.d[dest].wl;
                    tempw2:=leerdir_w(r,ll,dir);
                    templ:=tempw+tempw2;
                    ponerdir_w2(r,ll,dir,templ and $ffff);
                    r.cc.n:=(templ and $8000)<>0;
                    r.cc.c:=(templ and $10000)<>0;
    	              r.cc.x:=r.cc.c;
                    r.cc.v:=((((tempw xor templ) and (tempw2 xor templ)) shr 8) and $80)<>0;
            	      r.cc.z:=((templ and $ffff)=0);
                 end;
               end;
            $6:case ((instruccion shr 3) and $7) of
                 $0:begin  //addx.l rr
                      r.contador:=r.contador+8;
                      templ:=r.d[orig].l;
                      templ2:=r.d[dest].l;
                      if r.cc.x then templ3:=1+templ+templ2
                        else templ3:=templ+templ2;
                      r.d[dest].l:=templ3;
                      r.cc.n:=((templ3 shr 24) and $80)<>0;
                      r.cc.z:=(templ3=0);
    	                r.cc.v:=((((templ xor templ3) and (templ2 xor templ3)) shr 24) and $80)<>0;
                      r.cc.c:=((((templ and templ2) or (not(templ3) and (templ or templ2))) shr 23) and $100)<>0;
	                    r.cc.x:=r.cc.c;
                    end;
                 $1:begin  //addx.l mm
                      MessageDlg('Instruccion addx.l mm'+inttostr(r.pc.l), mtInformation,[mbOk], 0);
                    end;
                 else begin  //add.l re
                    r.contador:=r.contador+12;
                    templ:=r.d[dest].l;
                    templ2:=leerdir_l(r,ll,dir);
                    templ3:=templ+templ2;
                    ponerdir_l2(r,ll,dir,templ3);
                    r.cc.n:=((templ3 shr 24) and $80)<>0;
                    r.cc.z:=(templ3=0);
    	              r.cc.v:=((((templ xor templ3) and (templ2 xor templ3)) shr 24) and $80)<>0;
                    r.cc.c:=((((templ and templ2) or (not(templ3) and (templ or templ2))) shr 23) and $100)<>0;
	                  r.cc.x:=r.cc.c;
                 end;
               end;
            $7:begin
                 r.contador:=r.contador+6;
                 r.a[dest].l:=r.a[dest].l+leerdir_l(r,ll,dir);
               end;
      end;  //del case $d
   $e:if (instruccion shr 6) and $3=$3 then begin
        case (instruccion shr 8) and $f of
               $0:begin //asr.w
                    r.contador:=r.contador+8;
                    tempw:=leerdir_w(r,ll,dir);
                    r.cc.c:=(tempw and $1)<>0;
                    if (tempw and $8000)<>0 then tempw:=(tempw shr 1) or $8000
                      else tempw:=tempw shr 1;
                    ponerdir_w2(r,ll,dir,tempw);
                    r.cc.n:=(tempw and $8000)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(tempw=0);
                    r.cc.x:=r.cc.c;
                  end;
               $2:begin  //lsr.w
                    r.contador:=r.contador+8;
                    tempw:=leerdir_w(r,ll,dir);
                    r.cc.c:=(tempw and $1)<>0;
                    tempw:=tempw shr 1;
                    ponerdir_w2(r,ll,dir,tempw);
                    r.cc.n:=false;
                    r.cc.v:=false;
                    r.cc.z:=(tempw=0);
                    r.cc.x:=r.cc.c;
                 end;
               $3:begin  //lsl.w
                    r.contador:=r.contador+8;
                    tempw:=leerdir_w(r,ll,dir);
                    r.cc.c:=(tempw and $8000)<>0;
                    tempw:=tempw shl 1;
                    ponerdir_w2(r,ll,dir,tempw);
                    r.cc.n:=(tempw and $8000)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(tempw=0);
                    r.cc.x:=r.cc.c;
                 end;
               $4:begin //roxr.w
                    r.contador:=r.contador+8;
                    tempw:=leerdir_w(r,ll,dir);
                    r.cc.c:=(tempw and $1)<>0;
                    if r.cc.x then tempw:=(tempw shr 1) or $8000
                      else tempw:=tempw shr 1;
                    r.cc.x:=r.cc.c;
                    ponerdir_w2(r,ll,dir,tempw);
                    r.cc.n:=(tempw and $8000)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(tempw=0);
                 end;
               $7:begin //rol.w
                    r.contador:=r.contador+8;
                    tempw:=leerdir_w(r,ll,dir);
                    tempw2:=tempw shr 1;
                    r.cc.c:=((tempw shr 7) and $1)<>0;
                    ponerdir_w2(r,ll,dir,tempw2);
                    r.cc.n:=(tempw2 and $8000)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(tempw2=0);
                  end;
          else MessageDlg('Instruccion $E ''11''. '+inttostr((instruccion shr 8) and $f)+' - '+inttohex(r.ppc.l,10), mtInformation,[mbOk], 0);
        end;
      end else begin
          if ((instruccion shr 5) and 1)=1 then tempb:=r.d[(instruccion shr 9)and 7].l and $3f
            else tempb:=(((instruccion shr 9)-1) and $7)+1;
          r.contador:=r.contador+(tempb*2);
          case (instruccion shr $3) and $3f of
           $00,$04:begin //asr.b
                    r.contador:=r.contador+6;
                    tempb3:=r.d[orig].l0;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(tempb3 and 1)<>0;
                      tempb3:=tempb3 shr 1;
                    end;
                    r.cc.n:=false;
                    r.cc.v:=((tempb>7) and r.cc.c); //overflow
                    r.cc.x:=r.cc.c;
                    r.cc.z:=(tempb3=0);
                    r.d[orig].l0:=tempb3;
                   end;
           $01,$05:begin //++++++ lsr.b
                    r.contador:=r.contador+6;
                    tempb3:=r.d[orig].l0;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(tempb3 and 1)<>0;
                      tempb3:=tempb3 shr 1;
                    end;
                    r.cc.n:=false;
                    r.cc.v:=false;
                    r.cc.x:=r.cc.c;
                    r.cc.z:=(tempb3=0);
                    r.d[orig].l0:=tempb3;
                 end;
         $02,$06:begin //roxr.b
                    r.contador:=r.contador+6;
                    tempb3:=r.d[orig].l0;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(tempb3 and $1)<>0;
                      if r.cc.x then tempb3:=(tempb3 shr 1) or $80
                        else tempb3:=tempb3 shr 1;
                      r.cc.x:=r.cc.c;
                    end;
                    r.cc.n:=(tempb3 and $80)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(tempb3=0);
                    r.d[orig].l0:=tempb3;
                 end;
         $03,$07:begin // +++++ ror.b
                  r.contador:=r.contador+6;
                  tempb3:=r.d[orig].l0;
                  for tempb2:=1 to tempb do begin
                    r.cc.c:=(tempb3 and 1)<>0;
                    if r.cc.c then tempb3:=(tempb3 shr 1) or $80
                      else tempb3:=tempb3 shr 1;
                  end;
                  r.cc.n:=(tempb3 and $80)<>0;
                  r.cc.v:=false;
                  r.cc.z:=(tempb3=0);
                  r.d[orig].l0:=tempb3;
                end;
        $08,$0c:begin //+++++ asr.w
                    r.contador:=r.contador+6;
                    tempw:=r.d[orig].wl;
                    if (tempw and $8000)<>0 then begin
                        tempw2:=$8000;
                        r.cc.n:=true;
                    end else begin
                        tempw2:=0;
                        r.cc.n:=false;
                    end;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(tempw and 1)<>0;
                      tempw:=(tempw shr 1) or tempw2;
                    end;
                    r.cc.v:=((tempb>7) and r.cc.c); //overflow
                    r.cc.x:=r.cc.c;
                    r.cc.z:=(tempw=0);
                    r.d[orig].wl:=tempw;
                 end;
         $09,$0d:begin //++++++ lsr.w
                    r.contador:=r.contador+6;
                    tempw:=r.d[orig].wl;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(tempw and 1)<>0;
                      tempw:=tempw shr 1;
                    end;
                    r.cc.n:=false;
                    r.cc.v:=false;
                    r.cc.x:=r.cc.c;
                    r.cc.z:=(tempw=0);
                    r.d[orig].wl:=tempw;
                 end;
         $0a,$0e:begin //roxr.w
                    r.contador:=r.contador+6;
                    tempw:=r.d[orig].wl;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(tempw and $1)<>0;
                      if r.cc.x then tempw:=(tempw shr 1) or $8000
                        else tempw:=tempw shr 1;
                      r.cc.x:=r.cc.c;
                    end;
                    r.cc.n:=(tempw and $8000)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(tempw=0);
                    r.d[orig].wl:=tempw;
                 end;
         $0b,$0f:begin  //++++ ror.w
                    r.contador:=r.contador+6;
                    tempw:=r.d[orig].wl;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(tempw and 1)<>0;
                      if r.cc.c then tempw:=(tempw shr 1) or $8000
                        else tempw:=tempw shr 1;
                    end;
                    r.cc.n:=(tempw and $8000)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(tempw=0);
                    r.d[orig].wl:=tempw;
                 end;
         $10,$14:begin //++++++ asr.l
                    r.contador:=r.contador+8;
                    templ:=r.d[orig].l;
                    if (templ and $80000000)<>0 then begin
                      templ2:=$80000000;
                      r.cc.n:=true;
                    end else begin
                      templ2:=0;
                      r.cc.n:=false;
                    end;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(templ and 1)<>0;
                      templ:=(templ shr 1) or templ2;
                    end;
                    r.cc.v:=((tempb>7) and r.cc.c); //overflow
                    r.cc.x:=r.cc.c;
                    r.cc.z:=(templ=0);
                    r.d[orig].l:=templ;
                 end;
         $11,$15:begin //++++++ lsr.l
                    r.contador:=r.contador+8;
                    templ:=r.d[orig].l;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(templ and 1)<>0;
                      templ:=templ shr 1;
                    end;
                    r.cc.n:=false;
                    r.cc.v:=false;
                    r.cc.x:=r.cc.c;
                    r.cc.z:=(templ=0);
                    r.d[orig].l:=templ;
                 end;
         $12,$16:begin  //roxr.l
                    r.contador:=r.contador+8;
                    templ:=r.d[orig].l;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(templ and $1)<>0;
                      if r.cc.x then templ:=(templ shr 1) or $80000000
                        else templ:=templ shr 1;
                      r.cc.x:=r.cc.c;
                    end;
                    r.cc.n:=((templ shr 24) and $80)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(templ=0);
                    r.d[orig].l:=templ;
                 end;
         $13,$17:begin //ror.l
                    r.contador:=r.contador+8;
                    templ:=r.d[orig].l;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(templ and 1)<>0;
                      if r.cc.c then templ:=(templ shr 1) or $80000000
                        else templ:=templ shr 1;
                    end;
                    r.cc.n:=((templ shr 24) and $80)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(templ=0);
                    r.d[orig].l:=templ;
                 end;
         $20,$24:begin //asl.b
                    r.contador:=r.contador+6;
                    tempb3:=r.d[orig].l0;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(tempb3 and $80)<>0;
                      tempb3:=tempb3 shl 1;
                    end;
                    r.cc.v:=((tempb>7) and r.cc.c); //overflow
                    r.cc.n:=(tempb3 and $80)<>0;
                    r.cc.z:=(tempb3=0);
                    r.cc.x:=r.cc.c;
                    r.d[orig].l0:=tempb3;
             end;
         $21,$25:begin  //lsl.b
                    r.contador:=r.contador+6;
                    tempb3:=r.d[orig].l0;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(tempb3 and $80)<>0;
                      tempb3:=tempb3 shl 1;
                    end;
                    r.cc.n:=(tempb3 and $80)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(tempb3=0);
                    r.cc.x:=r.cc.c;
                    r.d[orig].l0:=tempb3;
                 end;
         $22,$26:begin //roxl.b
                    r.contador:=r.contador+6;
                    tempb3:=r.d[orig].l0;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(tempb3 and $80)<>0;
                      if r.cc.x then tempb3:=(tempb3 shl 1) or 1
                        else tempb3:=tempb3 shl 1;
                      r.cc.x:=r.cc.c;
                    end;
                    r.cc.n:=(tempb3 and $80)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(tempb3=0);
                    r.d[orig].l0:=tempb3;
                 end;
         $23,$27:begin //++++ rol.b
                    r.contador:=r.contador+6;
                    tempb3:=r.d[orig].l0;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(tempb3 and $80)<>0;
                      if r.cc.c then tempb3:=(tempb3 shl 1) or 1
                        else tempb3:=tempb3 shl 1;
                    end;
                    r.cc.n:=(tempb3 and $80)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(tempb3=0);
                    r.d[orig].l0:=tempb3;
                 end;
         $28,$2c:begin  //++++ asl.w
                    r.contador:=r.contador+6;
                    tempw:=r.d[orig].wl;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(tempw and $8000)<>0;
                      tempw:=tempw shl 1;
                    end;
                    r.cc.v:=((tempb>7) and r.cc.c); //overflow
                    r.cc.n:=(tempw and $8000)<>0;
                    r.cc.z:=(tempw=0);
                    r.cc.x:=r.cc.c;
                    r.d[orig].wl:=tempw;
                 end;
         $29,$2d:begin  //lsl.w
                    r.contador:=r.contador+6;
                    tempw:=r.d[orig].wl;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(tempw and $8000)<>0;
                      tempw:=tempw shl 1;
                    end;
                    r.cc.n:=(tempw and $8000)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(tempw=0);
                    r.cc.x:=r.cc.c;
                    r.d[orig].wl:=tempw;
                 end;
         $2a,$2e:begin //roxl.w
                    r.contador:=r.contador+6;
                    tempw:=r.d[orig].wl;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(tempw and $8000)<>0;
                      if r.cc.x then tempw:=(tempw shl 1) or 1
                        else tempw:=tempw shl 1;
                      r.cc.x:=r.cc.c;
                    end;
                    r.cc.n:=(tempw and $8000)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(tempw=0);
                    r.d[orig].wl:=tempw;
                 end;
         $2b,$2f:begin  //++++ rol.w
                    r.contador:=r.contador+6;
                    tempw:=r.d[orig].wl;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(tempw and $8000)<>0;
                      if r.cc.c then tempw:=(tempw shl 1) or 1
                        else tempw:=tempw shl 1;
                    end;
                    r.cc.n:=(tempw and $8000)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(tempw=0);
                    r.d[orig].wl:=tempw;
                 end;
         $30,$34:begin  //++++ asl.l
                    r.contador:=r.contador+8;
                    templ:=r.d[orig].l;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=((templ shr 24) and $80)<>0;
                      templ:=templ shl 1;
                    end;
                    r.cc.v:=((tempb>7) and r.cc.c);  //overflow
                    r.cc.n:=((templ shr 24) and $80)<>0;
                    r.cc.z:=(templ=0);
                    r.cc.x:=r.cc.c;
                    r.d[orig].l:=templ;
                 end;
         $31,$35:begin  //++++ lsl.l
                    r.contador:=r.contador+8;
                    templ:=r.d[orig].l;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=((templ shr 24) and $80)<>0;
                      templ:=templ shl 1;
                    end;
                    r.cc.n:=((templ shr 24) and $80)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(templ=0);
                    r.cc.x:=r.cc.c;
                    r.d[orig].l:=templ;
                 end;
         $32:begin  //rolx.l
                    r.contador:=r.contador+8;
                    templ:=r.d[orig].l;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=((templ shr 24) and $80)<>0;
                      if r.cc.x then templ:=(templ shl 1) or 1
                        else templ:=templ shl 1;
                      r.cc.x:=r.cc.c;
                    end;
                    r.cc.n:=((templ shr 24) and $80)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(templ=0);
                    r.d[orig].l:=templ;
             end;
         $33,$37:begin  //++++ rol.l
                    r.contador:=r.contador+8;
                    templ:=r.d[orig].l;
                    for tempb2:=1 to tempb do begin
                      r.cc.c:=(templ and $80000000)<>0;
                      if r.cc.c then templ:=(templ shl 1) or 1
                        else templ:=templ shl 1;
                    end;
                    r.cc.n:=((templ shr 24) and $80)<>0;
                    r.cc.v:=false;
                    r.cc.z:=(templ=0);
                    r.d[orig].l:=templ;
                 end;
             else MessageDlg('Instruccion $E no es ''11''. '+inttohex((instruccion shr 3) and $3f,10)+' - '+inttohex(r.ppc.l,10), mtInformation,[mbOk], 0);
          end;
      end;  //del case $e
   $f:begin  //emulacion 1111
        r.prefetch:=false;
        r.contador:=r.contador+4;
        tempw:=coger_band(r);
        poner_band(r,tempw or $2000);
        r.sp.l:=r.sp.l-6;
        ll.putword(r.sp.l,tempw);
        ll.putword(r.sp.l+2,r.pc.wh);
        ll.putword(r.sp.l+4,r.pc.wl-2);
        r.pc.wh:=ll.getword($b*4);
        r.pc.wl:=ll.getword(($b*4)+2);
      end;
   else MessageDlg('Instruccion: '+inttostr(instruccion)+' (primer nibble). PC='+inttostr(r.pc.l), mtInformation,[mbOk], 0);
end;
//if r.prefetch then r.contador:=r.contador-4;
update_timer(r.contador-pcontador,r.numero_cpu);
r.prefetch:=true;
end;  //del while
end;

end.
