unit nec_v20_v30;

//ecef

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     main_engine,dialogs,sysutils;

const
  NEC_V20=0;
  NEC_V30=1;
  NEC_V33=2;
  parity_table:array[0..$ff] of boolean=(
  true, false, false, true, false, true, true, false, false, true, true, false, true, false, false, true, false, true, true, false, true, false,
  false, true, true, false, false, true, false, true, true, false, false, true, true, false, true, false, false, true, true, false, false, true,
  false, true, true, false, true, false, false, true, false, true, true, false, false, true, true, false, true, false, false, true, false, true,
  true, false, true, false, false, true, true, false, false, true, false, true, true, false, true, false, false, true, false, true, true, false,
  false, true, true, false, true, false, false, true, true, false, false, true, false, true, true, false, false, true, true, false, true, false,
  false, true, false, true, true, false, true, false, false, true, true, false, false, true, false, true, true, false, false, true, true, false,
  true, false, false, true, true, false, false, true, false, true, true, false, true, false, false, true, false, true, true, false, false, true,
  true, false, true, false, false, true, true, false, false, true, false, true, true, false, false, true, true, false, true, false, false, true,
  false, true, true, false, true, false, false, true, true, false, false, true, false, true, true, false, true, false, false, true, false, true,
  true, false, false, true, true, false, true, false, false, true, false, true, true, false, true, false, false, true, true, false, false, true,
  false, true, true, false, false, true, true, false, true, false, false, true, true, false, false, true, false, true, true, false, true, false,
  false, true, false, true, true, false, false, true, true, false, true, false, false, true);
  DS1=0;
  PS=1;
  SS=2;
  DS0=3;

type
        band_nec=record
          S,A,O,Z,C,P,T,I,D,M:boolean;
        end;
        reg_nec=record
                ip:word;
                aw,cw,dw,bw,d:parejas;
                sp,bp,ix,iy:parejas;
                f:band_nec;
                ds1,ps,ds0,ss:word;
                ea:dword;
                vect,vect_req:byte;
                prefix_base:dword;
                prefetch_count:integer;
                prefetch_size,prefetch_cycles:byte;
                prefetch_reset,seg_prefix:boolean;
                ea_calculated:boolean;
                no_interrupt:boolean;
                pedir_irq,irq_pending:boolean;
                contador:integer;
                numero_cpu:byte;
                tframes:single;
                opcode:boolean;
                tipo_cpu:byte;
        end;
        preg_nec=^reg_nec;
        pband_nec=^band_nec;
        llam_nec = record
                      getbyte:function(direccion:dWord):Byte;
                      putbyte:procedure(direccion:dword;valor:byte);
                      outbyte: procedure (valor:byte;puerto:word);
                      inbyte:function(puerto:word):byte;
                      outword: procedure (valor:word;puerto:word);
                      inword:function(puerto:word):word;
                    end;

procedure reset_nec(r:preg_nec);
procedure run_nec(r:preg_nec;ll:llam_nec;maximo:integer);
procedure init_nec(tipo:byte;r:preg_nec);
function DefaultBase(Seg:byte;r:preg_nec):dword;
function fetch(r:preg_nec;ll:llam_nec):byte;
procedure nec_interrupt(vect_num:word;r:preg_nec;ll:llam_nec);

implementation
uses nec_ea;

var
  prev_icount:integer;

procedure init_nec(tipo:byte;r:preg_nec);
begin
  case tipo of
    0:;
    1:begin
        	r.prefetch_size:=6;		// 3 words */
	        r.prefetch_cycles:= 2;		// two cycles per byte / four per word */
          r.tipo_cpu:=tipo;
      end;
  end;
end;

procedure reset_nec(r:preg_nec);
begin
r.ip:= 0;
r.f.T:=false;
r.f.i:=false;
r.f.D:=false;
r.f.S:=false;
r.f.A:=false;
r.f.O:=false;
r.f.Z:=false;
r.f.C:=false;
r.f.P:=false;
r.f.M:=true;
r.prefetch_reset:=true;
r.pedir_irq:=false;
r.ps:=$ffff;
end;

procedure write_word(dir:dword;x:word;ll:llam_nec);inline;
begin
  ll.putbyte(dir,x and $ff);
  ll.putbyte(dir+1,x shr 8);
end;

function read_word(dir:dword;ll:llam_nec):word;inline;
var
  tmp:word;
begin
  tmp:=ll.getbyte(dir);
  read_word:=tmp+(ll.getbyte(dir+1) shl 8);
end;

procedure prefetch(r:preg_nec);
begin
  dec(r.prefetch_count);
end;

function fetch(r:preg_nec;ll:llam_nec):byte;
begin
  prefetch(r);
	fetch:=ll.getbyte((r.ps shl 4)+r.ip);
  inc(r.ip);
end;

function fetchword(r:preg_nec;ll:llam_nec):word;inline;
begin
  fetchword:=fetch(r,ll)+(fetch(r,ll) shl 8);
end;

procedure do_prefetch(r:preg_nec;previous_icount:integer);
var
  diff:integer;
begin
  diff:=previous_ICount-r.contador;
	{ The implementation is not accurate, but comes close.
     * It does not respect that the V30 will fetch two bytes
     * at once directly, but instead uses only 2 cycles instead
     * of 4. There are however only very few sources publicy
     * available and they are vague.}
	while (r.prefetch_count<0) do begin
		r.prefetch_count:=r.prefetch_count+1;
		if (diff>r.prefetch_cycles) then diff:=diff-r.prefetch_cycles
  		else inc(r.contador,r.prefetch_cycles);
	end;
	if r.prefetch_reset then begin
		r.prefetch_count:=0;
		r.prefetch_reset:=false;
		exit;
	end;
	while ((diff >= r.prefetch_cycles) and (r.prefetch_count<r.prefetch_size)) do begin
		diff:=diff-r.prefetch_cycles;
		r.prefetch_count:=r.prefetch_count+1;
	end;
end;

procedure CLKS(clk_v20,clk_v30,clk_v33:byte;r:preg_nec);inline;
begin
  case r.tipo_cpu of
    0:inc(r.contador,clk_v20);
    1:inc(r.contador,clk_v30);
    2:inc(r.contador,clk_v33);
  end;
end;

procedure CLKW(v20o,v30o,v33o,v20e,v30e,v33e:byte;addr:word;r:preg_nec);inline;
begin
  case r.tipo_cpu of
    0:if (addr and 1)<>0 then inc(r.contador,v20o)
        else inc(r.contador,v20e);
    1:if (addr and 1)<>0 then inc(r.contador,v30o)
        else inc(r.contador,v30e);
    2:if (addr and 1)<>0 then inc(r.contador,v33o)
        else inc(r.contador,v33e);
  end;
end;

procedure CLKM(v20,v30,v33,v20m,v30m,v33m,ModRM:byte;r:preg_nec);inline;
begin
   case r.tipo_cpu of
    0:if (ModRM>=$c0) then inc(r.contador,v20)
        else inc(r.contador,v20m);
    1:if (ModRM>=$c0) then inc(r.contador,v30)
        else inc(r.contador,v30m);
    2:if (ModRM>=$c0) then inc(r.contador,v33)
        else inc(r.contador,v33m);
   end;
end;

procedure CLKR(v20o,v30o,v33o,v20e,v30e,v33e,vall:byte;ModRM:word;r:preg_nec);inline;
begin
if (ModRM>=$c0) then begin
  inc(r.contador,vall);
end else begin
  if (r.ea and 1)<>0 then begin
    case r.tipo_cpu of
      0:inc(r.contador,v20o);
      1:inc(r.contador,v30o);
      2:inc(r.contador,v33o);
    end;
  end else begin
    case r.tipo_cpu of
      0:inc(r.contador,v20e);
      1:inc(r.contador,v30e);
      2:inc(r.contador,v33e);
    end;
  end;
end;
end;

function RegByte(ModRM:byte;r:preg_nec):byte;inline;
//AL, CL, DL, BL, AH, CH, DH, BH
begin
case ((ModRM and $38) shr 3) of
  0:RegByte:=r.aw.l;
  1:RegByte:=r.cw.l;
  2:RegByte:=r.dw.l;
  3:RegByte:=r.bw.l;
  4:RegByte:=r.aw.h;
  5:RegByte:=r.cw.h;
  6:RegByte:=r.dw.h;
  7:RegByte:=r.bw.h;
end;
end;

function GetRMByte(ModRM:byte;r:preg_nec;ll:llam_nec):byte;inline;
//AL, CL, DL, BL, AH, CH, DH, BH
begin
if (ModRM>=$c0) then begin
    case (modRM and $7) of
      0:GetRMByte:=r.aw.l;
      1:GetRMByte:=r.cw.l;
      2:GetRMByte:=r.dw.l;
      3:GetRMByte:=r.bw.l;
      4:GetRMByte:=r.aw.h;
      5:GetRMByte:=r.cw.h;
      6:GetRMByte:=r.dw.h;
      7:GetRMByte:=r.bw.h;
    end;
end else begin
    r.ea:=GetEA(ModRM,r,ll);
    GetRMByte:=ll.getbyte(r.ea);
end;
end;

function RegWord(ModRM:byte;r:preg_nec):word;inline;
//AW, CW, DW, BW, SP, BP, IX, IY
begin
case ((ModRM and $38) shr 3) of
  0:RegWord:=r.aw.w;
  1:RegWord:=r.cw.w;
  2:RegWord:=r.dw.w;
  3:RegWord:=r.bw.w;
  4:RegWord:=r.sp.w;
  5:RegWord:=r.bp.w;
  6:RegWord:=r.ix.w;
  7:RegWord:=r.iy.w;
end;
end;

function GetRMWord(ModRM:byte;r:preg_nec;ll:llam_nec):word;inline;
//AW, CW, DW, BW, SP, BP, IX, IY
begin
if (ModRM>=$c0) then begin
    case (ModRM and 7) of
      0:GetRMWord:=r.aw.w;
      1:GetRMWord:=r.cw.w;
      2:GetRMWord:=r.dw.w;
      3:GetRMWord:=r.bw.w;
      4:GetRMWord:=r.sp.w;
      5:GetRMWord:=r.bp.w;
      6:GetRMWord:=r.ix.w;
      7:GetRMWord:=r.iy.w;
    end;
end else begin
    r.ea:=GetEA(ModRM,r,ll);
    GetRMWord:=read_word(r.ea,ll);
end;
end;

procedure PutbackRMByte(ModRM,valor:byte;r:preg_nec;ll:llam_nec);inline;
begin
	if (ModRM>=$c0) then begin
    case (modRM and $7) of
      0:r.aw.l:=valor;
      1:r.cw.l:=valor;
      2:r.dw.l:=valor;
      3:r.bw.l:=valor;
      4:r.aw.h:=valor;
      5:r.cw.h:=valor;
      6:r.dw.h:=valor;
      7:r.bw.h:=valor;
    end;
  end else begin
    r.ea:=GetEA(ModRM,r,ll);
    ll.putbyte(r.ea,valor);
  end;
end;

procedure PutBackRegByte(ModRM,valor:byte;r:preg_nec);inline;
//AL, CL, DL, BL, AH, CH, DH, BH
begin
case ((ModRM and $38) shr 3) of
  0:r.aw.l:=valor;
  1:r.cw.l:=valor;
  2:r.dw.l:=valor;
  3:r.bw.l:=valor;
  4:r.aw.h:=valor;
  5:r.cw.h:=valor;
  6:r.dw.h:=valor;
  7:r.bw.h:=valor;
end;
end;

procedure PutbackRMWord(ModRM:byte;valor:word;r:preg_nec;ll:llam_nec);inline;
//AW, CW, DW, BW, SP, BP, IX, IY
begin
	if (ModRM>=$c0) then begin
    case (modRM and $7) of
      0:r.aw.w:=valor;
      1:r.cw.w:=valor;
      2:r.dw.w:=valor;
      3:r.bw.w:=valor;
      4:r.sp.w:=valor;
      5:r.bp.w:=valor;
      6:r.ix.w:=valor;
      7:r.iy.w:=valor;
    end;
  end else begin
    r.ea:=GetEA(ModRM,r,ll);
    write_word(r.ea,valor,ll);
  end;
end;

procedure PutBackRegWord(ModRM:byte;valor:word;r:preg_nec);inline;
//AW, CW, DW, BW, SP, BP, IX, IY
begin
case ((ModRM and $38) shr 3) of
  0:r.aw.w:=valor;
  1:r.cw.w:=valor;
  2:r.dw.w:=valor;
  3:r.bw.w:=valor;
  4:r.sp.w:=valor;
  5:r.bp.w:=valor;
  6:r.ix.w:=valor;
  7:r.iy.w:=valor;
end;
end;

procedure PutImmRMByte(ModRM:byte;r:preg_nec;ll:llam_nec);inline;
var
  valor:byte;
begin
	if (ModRM>=$c0)	then begin
    valor:=fetch(r,ll);
    case (modRM and $7) of
      0:r.aw.l:=valor;
      1:r.cw.l:=valor;
      2:r.dw.l:=valor;
      3:r.bw.l:=valor;
      4:r.aw.h:=valor;
      5:r.cw.h:=valor;
      6:r.dw.h:=valor;
      7:r.bw.h:=valor;
    end;
  end	else begin
		r.ea:=GetEA(ModRM,r,ll);
    ll.putbyte(r.ea,fetch(r,ll));
	end;
end;

procedure PutImmRMWord(ModRM:byte;r:preg_nec;ll:llam_nec);inline;
//AW, CW, DW, BW, SP, BP, IX, IY
var
  valor:word;
begin
	if (ModRM>=$c0) then begin
    valor:=FETCHWORD(r,ll);
    case (modRM and $7) of
      0:r.aw.w:=valor;
      1:r.cw.w:=valor;
      2:r.dw.w:=valor;
      3:r.bw.w:=valor;
      4:r.sp.w:=valor;
      5:r.bp.w:=valor;
      6:r.ix.w:=valor;
      7:r.iy.w:=valor;
    end;
	end else begin
    r.ea:=GetEA(ModRM,r,ll);
		valor:=FETCHWORD(r,ll);
    write_word(r.ea,valor,ll);
	end;
end;

procedure SetSZPF_Byte(x:byte;r:preg_nec);inline;
begin
 r.f.S:=(x and $80)<>0;
 r.f.Z:=(x=0);
 r.f.P:=parity_table[x];
end;

procedure SetSZPF_Word(x:word;r:preg_nec);inline;
begin
  r.f.s:=(x and $8000)<>0;
  r.f.z:=(x=0);
  r.f.p:=parity_table[x and $ff];
end;

function DefaultBase(Seg:byte;r:preg_nec):dword;inline;
begin
  if (r.seg_prefix and ((Seg=DS0) or (Seg=SS))) then begin
    DefaultBase:=r.prefix_base;
  end else begin
    case Seg of
      DS1:DefaultBase:=r.ds1 shl 4;
      PS:DefaultBase:=r.ps shl 4;
      SS:DefaultBase:=r.ss shl 4;
      DS0:DefaultBase:=r.ds0 shl 4;
    end;
   end;
end;

function GetMemB(Seg:byte;Off:word;r:preg_nec;ll:llam_nec):byte;inline;
begin
 GetMemB:=ll.getbyte(DefaultBase(Seg,r)+Off);
end;

function GetMemW(Seg:byte;Off:word;r:preg_nec;ll:llam_nec):word;inline;
begin
 GetMemW:=read_word(DefaultBase(Seg,r)+Off,ll);
end;

procedure PutMemB(Seg:byte;Off:word;x:byte;r:preg_nec;ll:llam_nec);inline;
begin
   ll.putbyte(DefaultBase(Seg,r)+Off,x);
end;

procedure PutMemW(Seg:byte;Off,x:word;r:preg_nec;ll:llam_nec);inline;
begin
   write_word(DefaultBase(Seg,r)+Off,x,ll);
end;

function IncWordReg(tmp:word;r:preg_nec):word;inline;
var
  tmp1:word;
begin
	tmp1:=tmp+1;
	r.f.O:=(tmp=$7fff);
  r.f.A:=((tmp1 xor (tmp xor 1)) and $10)<>0;
	SetSZPF_Word(tmp1,r);
	IncWordReg:=tmp1;
end;

function DecWordReg(tmp:word;r:preg_nec):word;inline;
var
  tmp1:word;
begin
	tmp1:=tmp-1;
	r.f.O:=(tmp=$8000);
  r.f.A:=((tmp1 xor (tmp xor 1)) and $10)<>0;
	SetSZPF_Word(tmp1,r);
	DecWordReg:=tmp1;
end;

procedure ExpandFlags(temp:word;r:preg_nec);inline;
begin
  r.f.c:=(temp and 1)<>0;
  r.f.p:=(temp and 4)<>0;
  r.f.a:=(temp and $10)<>0;
  r.f.z:=(temp and $40)<>0;
  r.f.s:=(temp and $80)<>0;
  r.f.t:=(temp and $100)<>0;
  r.f.I:=(temp and $200)<>0;
  r.f.D:=(temp and $400)<>0;
  r.f.o:=(temp and $800)<>0;
  r.f.m:=(temp and $8000)<>0;
end;

function CompressFlags(r:preg_nec):word;inline;
var
  temp:word;
begin
  temp:=0;
  if r.f.c then temp:=1;
  if r.f.p then inc(temp,4);
  if r.f.a then inc(temp,$10);
  if r.f.z then inc(temp,$40);
  if r.f.s then inc(temp,$80);
  if r.f.t then inc(temp,$100);
  if r.f.I then inc(temp,$200);
  if r.f.D then inc(temp,$400);
  if r.f.o then inc(temp,$800);
  if r.f.m then inc(temp,$8000);
  CompressFlags:=temp;
end;

//INSTRUCIONES
procedure PUSH(val:word;r:preg_nec;ll:llam_nec);inline;
begin
   r.sp.w:=r.sp.w-2;
   write_word((r.ss shl 4)+r.sp.w,val,ll);
end;

function POP(r:preg_nec;ll:llam_nec):word;inline;
begin
   pop:=read_word((r.ss shl 4)+r.sp.w,ll);
   r.sp.w:=r.sp.w+2;
end;

function ANDB(src,dst:byte;r:preg_nec):byte;inline;
begin
  dst:=dst and src;
  r.f.C:=false;
  r.f.O:=false;
  r.f.A:=false;
  SetSZPF_Byte(dst,r);
  ANDB:=dst;
end;

function ANDW(src,dst:word;r:preg_nec):word;inline;
begin
  dst:=dst and src;
  r.f.c:=false;
  r.f.o:=false;
  r.f.a:=false;
  SetSZPF_Word(dst,r);
  andw:=dst;
end;

function ADDB(src,dst:byte;r:preg_nec):byte;inline;
var
  res:word;
begin
  res:=dst+src;
  r.f.C:=(res and $100)<>0;
  r.f.O:=((res xor src) and (res xor dst) and $80)<>0;
  r.f.a:=((res xor (src xor dst)) and $10)<>0;
  SetSZPF_Byte(res,r);
  ADDB:=res and $ff;
end;

function ADDW(src,dst:word;r:preg_nec):word;inline;
var
  res:dword;
begin
 res:=dst+src;
 r.f.C:=(res and $10000)<>0;
 r.f.O:=((res xor src) and (res xor dst) and $8000)<>0;
 r.f.a:=((res xor (src xor dst)) and $10)<>0;
 SetSZPF_Word(res,r);
 ADDW:=res and $ffff;
end;

function ORB(src,dst:byte;r:preg_nec):byte;inline;
begin
   dst:=dst or src;
   r.f.c:=false;
   r.f.O:=false;
   r.f.A:=false;
   SetSZPF_Byte(dst,r);
   ORB:=dst;
end;

function SUBB(src,dst:byte;r:preg_nec):byte;inline;
var
  res:word;
begin
   res:=dst-src;
   r.f.c:=(res and $100)<>0;
   r.f.o:=((dst xor src) and (dst xor res) and $80)<>0;
   r.f.a:=((res xor (src xor dst)) and $10)<>0;
   SetSZPF_Byte(res,r);
   SUBB:=res and $ff;
end;

function SUBW(src,dst:word;r:preg_nec):word;inline;
var
  res:dword;
begin
 res:=dst-src;
 r.f.c:=(res and $10000)<>0;
 r.f.O:=((dst xor src) and (dst xor res) and $8000)<>0;
 r.f.a:=((res xor (src xor dst)) and $10)<>0;
 SetSZPF_Word(res,r);
 SUBW:=res and $ffff;
end;

function XORB(src,dst:byte;r:preg_nec):byte;inline;
begin
  dst:=dst xor src;
  r.f.c:=false;
  r.f.o:=false;
  r.f.a:=false;
  SetSZPF_Byte(dst,r);
  XORB:=dst;
end;

function XORW(src,dst:word;r:preg_nec):word;inline;
begin
  dst:=dst xor src;
  r.f.c:=false;
  r.f.o:=false;
  r.f.a:=false;
  SetSZPF_Word(dst,r);
  XORW:=dst;
end;

function SHR_BYTE(c,dst,ModRM:byte;r:preg_nec;ll:llam_nec):byte;inline;
begin
   inc(r.contador,c);
   dst:=dst shr (c-1);
   r.f.c:=(dst and 1)<>0;
   dst:=dst shr 1;
   SetSZPF_Byte(dst,r);
   PutbackRMByte(ModRM,dst,r,ll);
   SHR_BYTE:=dst;
end;

function SHR_WORD(c:byte;dst:word;ModRM:byte;r:preg_nec;ll:llam_nec):word;inline;
begin
  inc(r.contador,c);
  dst:=dst shr (c-1);
  r.f.c:=(dst and 1)<>0;
  dst:=dst shr 1;
  SetSZPF_Word(dst,r);
  PutbackRMWord(ModRM,dst,r,ll);
  SHR_WORD:=dst;
end;

function SHL_BYTE(c,dst,ModRM:byte;r:preg_nec;ll:llam_nec):byte;inline;
begin
   inc(r.contador,c);
   dst:=dst shl c;
   r.f.c:=(dst and 1)<>0;
   SetSZPF_Byte(dst,r);
   PutbackRMByte(ModRM,dst,r,ll);
   SHL_BYTE:=dst;
end;

function SHL_WORD(c:byte;dst:word;ModRM:byte;r:preg_nec;ll:llam_nec):word;inline;
begin
  inc(r.contador,c);
  dst:=dst shl c;
  r.f.c:=(dst and 1)<>0;
  SetSZPF_Word(dst,r);
  PutbackRMWord(ModRM,dst,r,ll);
  SHL_WORD:=dst;
end;

function ROR_WORD(dst:word;r:preg_nec):word;inline;
begin
   r.f.c:=(dst and $1)<>0;
   if r.f.c then ROR_WORD:=(dst shr 1)+$8000
    else ROR_WORD:=(dst shr 1);
end;

function ROLC_BYTE(dst:byte;r:preg_nec):byte;inline;
var
  temp:word;
begin
   temp:=(dst shl 1);
   if r.f.c then inc(temp);
   r.f.c:=(temp and $100)<>0;
   ROLC_BYTE:=temp;
end;

function ROLC_WORD(dst:word;r:preg_nec):word;inline;
var
  temp:dword;
begin
 temp:=(dst shl 1);
 if r.f.c then inc(temp);
 r.f.c:=(temp and $10000)<>0;
 ROLC_WORD:=temp and $ffff;
end;

function RORC_BYTE(dst:byte;r:preg_nec):byte;inline;
var
  temp:word;
begin
 if r.f.c then temp:=$100+dst
  else temp:=dst;
 r.f.c:=(dst and $1)<>0;
 RORC_BYTE:=temp shr 1;
end;

function RORC_WORD(dst:word;r:preg_nec):word;inline;
var
  temp:dword;
begin
 if r.f.c then temp:=$10000+dst
  else temp:=dst;
 r.f.c:=(dst and $1)<>0;
 RORC_WORD:=temp shr 1;
end;

procedure ADD4S(r:preg_nec;ll:llam_nec);inline;
const
  table:array [0..2] of byte=(18,19,19);
var
  di,si:word;
  count,i:byte;
  tmp,tmp2,v1,v2,carry:byte;
  result:word;
begin
	count:=(r.cw.l+1) div 2;
	di:=r.iy.w;
	si:=r.ix.w;
	if r.seg_prefix then MessageDlg('Warning: seg_prefix defined for add4s', mtInformation,[mbOk],0);
  r.f.Z:=false;
  r.f.c:=false;
	for i:=0 to (count-1) do begin
    inc(r.contador,table[r.tipo_cpu]);
		tmp:=GetMemB(DS0,si,r,ll);
		tmp2:=GetMemB(DS1,di,r,ll);
		v1:= (tmp shr 4)*10 + (tmp and $f);
		v2:= (tmp2 shr 4)*10 + (tmp2 and $f);
    if r.f.c then carry:=1
      else carry:=0;
		result:=v1+v2+carry;
    r.f.c:=(result>99);
		result:=result mod 100;
		v1:= ((result div 10) shl 4)+(result mod 10);
		PutMemB(DS1,di,v1,r,ll);
		r.f.z:=(v1<>0);
		inc(si);
		inc(di);
	end;
end;

//MACROS INSTRUCCIONES
procedure i_pushf(r:preg_nec;ll:llam_nec);inline;
var
  tmp:word;
begin
  tmp:=CompressFlags(r);
  PUSH(tmp,r,ll);
  CLKS(12,8,3,r);
end;

procedure i_popf(r:preg_nec;ll:llam_nec);inline;
var
  tmp:word;
begin
   tmp:=POP(r,ll);
   ExpandFlags(tmp,r);
   CLKS(12,8,5,r);
   if r.f.t then MessageDlg('trap despues o_popf', mtInformation,[mbOk],0);
end;

procedure i_jmp(flag:boolean;r:preg_nec;ll:llam_nec);inline;
var
  tmp:byte;
begin
	r.prefetch_reset:=true;
	tmp:=FETCH(r,ll);
	if flag then begin
    if ((tmp and $80)<>0) then r.ip:=r.ip-($100-tmp)
      else r.ip:=r.ip+tmp;
    clks(3,10,10,r);
	end;
end;

procedure i_movsb(r:preg_nec;ll:llam_nec);inline;
var
  tmp:byte;
  df:integer;
begin
  tmp:=GetMemB(DS0,r.ix.w,r,ll);
  PutMemB(DS1,r.iy.w,tmp,r,ll);
  if r.f.d then df:=-(2*1)+1
    else df:=-(2*0)+1;
  r.ix.w:=r.ix.w+df;
  r.iy.w:=r.iy.w+df;
  CLKS(8,8,6,r);
end;

procedure i_movsw(r:preg_nec;ll:llam_nec);inline;
var
  tmp:word;
  df:integer;
begin
  tmp:=GetMemW(DS0,r.ix.w,r,ll);
  PutMemW(DS1,r.iy.w,tmp,r,ll);
  if r.f.d then df:=-(4*1)+2
    else df:=-(4*0)+2;
  r.ix.w:=r.ix.w+df;
  r.iy.w:=r.iy.w+df;
  CLKS(16,16,10,r);
end;

procedure i_lodsb(r:preg_nec;ll:llam_nec);inline;
var
  df:integer;
begin
  r.aw.l:=GetMemB(DS0,r.ix.w,r,ll);
  if r.f.d then df:=-(2*1)+1
    else df:=-(2*0)+1;
  r.ix.w:=r.ix.w+df;
  CLKS(4,4,3,r);
end;

procedure i_stosb(r:preg_nec;ll:llam_nec);inline;
var
  df:integer;
begin
  PutMemB(DS1,r.iy.w,r.aw.l,r,ll);
  if r.f.d then df:=-(2*1)+1
    else df:=-(2*0)+1;
  r.iy.w:=r.iy.w+df;
  CLKS(4,4,3,r);
end;

procedure i_lodsw(r:preg_nec;ll:llam_nec);inline;
var
  df:integer;
begin
  r.aw.w:=GetMemW(DS0,r.ix.w,r,ll);
  if r.f.d then df:=-(4*1)+2
    else df:=-(4*0)+2;
  r.ix.w:=r.ix.w+df;
  CLKW(8,8,5,8,4,3,r.ix.w,r);
end;

procedure i_stosw(r:preg_nec;ll:llam_nec);inline;
var
  df:integer;
begin
  PutMemW(DS1,r.iy.w,r.aw.w,r,ll);
  if r.f.d then df:=-(4*1)+2
    else df:=-(4*0)+2;
  r.iy.w:=r.iy.w+df;
  CLKW(8,8,5,8,4,3,r.iy.w,r);
end;

procedure i_scasb(r:preg_nec;ll:llam_nec);inline;
var
  df:integer;
  src,dst:byte;
begin
  src:=GetMemB(DS1,r.iy.w,r,ll);
  dst:=r.aw.l;
  SUBB(src,dst,r);
  if r.f.d then df:=-(2*1)+1
    else df:=-(2*0)+1;
  r.iy.w:=r.iy.w+df;
  CLKS(4,4,3,r);
end;

procedure i_scasw(r:preg_nec;ll:llam_nec);inline;
var
  df:integer;
  src,dst:word;
begin
  src:=GetMemW(DS1,r.iy.w,r,ll);
  dst:=r.aw.w;
  SUBW(src,dst,r);
  if r.f.d then df:=-(4*1)+2
    else df:=-(4*0)+2;
  r.iy.w:=r.iy.w+df;
  CLKW(8,8,5,8,4,3,r.iy.w,r);
end;

procedure ejecuta_instruccion(instruccion:byte;r:preg_nec;ll:llam_nec);
var
  tempw,tempw2:word;
  tempb,tempb2,tempb3,c:byte;
begin
case instruccion of
    $00:begin  //i_add_br8
          tempb:=FETCH(r,ll);
          tempb2:=RegByte(tempb,r);  //src
          tempb3:=GetRMByte(tempb,r,ll);  //dst
          tempb3:=ADDB(tempb2,tempb3,r);
          PutbackRMByte(tempb,tempb3,r,ll);
          CLKM(2,2,2,16,16,7,tempb,r);
        end;
    $01:begin  //i_add_wr16
          tempb:=FETCH(r,ll);
	        tempw:=RegWord(tempb,r);  //src
          tempw2:=GetRMWord(tempb,r,ll);  //dst
          tempw2:=ADDW(tempw,tempw2,r);
          PutbackRMWord(tempb,tempw2,r,ll);
          CLKR(24,24,11,24,16,7,2,tempb,r);
        end;
    $02:begin //i_add_r8b
          tempb:= FETCH(r,ll);
	        tempb2:=RegByte(tempb,r); //dst
          tempb3:=GetRMByte(tempb,r,ll);  //src
          tempb2:=ADDB(tempb3,tempb2,r);
          PutBackRegByte(tempb,tempb2,r);
          CLKM(2,2,2,11,11,6,tempb,r);
        end;
    $03:begin //add_r16w
          tempb:=FETCH(r,ll);
        	tempw:=RegWord(tempb,r);  //dst
          tempw2:=GetRMWord(tempb,r,ll);  //src
          tempw:=ADDW(tempw2,tempw,r);
          PutBackRegWord(tempb,tempw,r);
          CLKR(15,15,8,15,11,6,2,tempb,r);
        end;
    $05:begin  //i_add_axd16)
          tempw:=FETCH(r,ll);  //src
	        tempw2:=r.aw.w;  //dst
          tempw:=tempw+(FETCH(r,ll) shl 8);
          r.aw.w:=ADDW(tempw,tempw2,r);
          CLKS(4,4,2,r);
        end;
    $06:begin  //i_push_es
          PUSH(r.ds1,r,ll);
          CLKS(12,8,3,r);
        end;
    $07:begin //i_pop_es
          r.ds1:=POP(r,ll);
          CLKS(12,8,5,r);
        end;
    $0a:begin  //i_or_r8b
          tempb:=fetch(r,ll);
	        tempb2:=RegByte(tempb,r);  //dst
          tempb3:=GetRMByte(tempb,r,ll);  //src
          tempb2:=ORB(tempb3,tempb2,r);
          PutBackRegByte(tempb,tempb2,r);
          CLKM(2,2,2,11,11,6,tempb,r);
        end;
    $0c:begin //i_or_ald8
          tempb:=FETCH(r,ll);  //src
	        tempb2:=r.aw.l;  //dst
          r.aw.l:=ORB(tempb,tempb2,r);
          CLKS(4,4,2,r);
        end;
    $0f:begin  //i_pre_nec
	        case (FETCH(r,ll)) of
		        {case 0x10 : BITOP_BYTE;	CLKS(3,3,4); tmp2 = nec_state->regs.b[CL] & 0x7;	nec_state->ZeroVal = (tmp & (1<<tmp2)) ? 1 : 0;	nec_state->CarryVal=nec_state->OverVal=0; break; /* Test */
		        case 0x11 : BITOP_WORD;	CLKS(3,3,4); tmp2 = nec_state->regs.b[CL] & 0xf;	nec_state->ZeroVal = (tmp & (1<<tmp2)) ? 1 : 0;	nec_state->CarryVal=nec_state->OverVal=0; break; /* Test */
		        case 0x12 : BITOP_BYTE;	CLKS(5,5,4); tmp2 = nec_state->regs.b[CL] & 0x7;	tmp &= ~(1<<tmp2);	PutbackRMByte(ModRM,tmp);	break; /* Clr */
		        case 0x13 : BITOP_WORD;	CLKS(5,5,4); tmp2 = nec_state->regs.b[CL] & 0xf;	tmp &= ~(1<<tmp2);	PutbackRMWord(ModRM,tmp);	break; /* Clr */
		        case 0x14 : BITOP_BYTE;	CLKS(4,4,4); tmp2 = nec_state->regs.b[CL] & 0x7;	tmp |= (1<<tmp2);	PutbackRMByte(ModRM,tmp);	break; /* Set */
		        case 0x15 : BITOP_WORD;	CLKS(4,4,4); tmp2 = nec_state->regs.b[CL] & 0xf;	tmp |= (1<<tmp2);	PutbackRMWord(ModRM,tmp);	break; /* Set */
		        case 0x16 : BITOP_BYTE;	CLKS(4,4,4); tmp2 = nec_state->regs.b[CL] & 0x7;	BIT_NOT;			PutbackRMByte(ModRM,tmp);	break; /* Not */
		        case 0x17 : BITOP_WORD;	CLKS(4,4,4); tmp2 = nec_state->regs.b[CL] & 0xf;	BIT_NOT;			PutbackRMWord(ModRM,tmp);	break; /* Not */

		        case 0x18 : BITOP_BYTE;	CLKS(4,4,4); tmp2 = (FETCH()) & 0x7;	nec_state->ZeroVal = (tmp & (1<<tmp2)) ? 1 : 0;	nec_state->CarryVal=nec_state->OverVal=0; break; /* Test */
		        case 0x19 : BITOP_WORD;	CLKS(4,4,4); tmp2 = (FETCH()) & 0xf;	nec_state->ZeroVal = (tmp & (1<<tmp2)) ? 1 : 0;	nec_state->CarryVal=nec_state->OverVal=0; break; /* Test */
		        case 0x1a : BITOP_BYTE;	CLKS(6,6,4); tmp2 = (FETCH()) & 0x7;	tmp &= ~(1<<tmp2);		PutbackRMByte(ModRM,tmp);	break; /* Clr */
		        case 0x1b : BITOP_WORD;	CLKS(6,6,4); tmp2 = (FETCH()) & 0xf;	tmp &= ~(1<<tmp2);		PutbackRMWord(ModRM,tmp);	break; /* Clr */
		        case 0x1c : BITOP_BYTE;	CLKS(5,5,4); tmp2 = (FETCH()) & 0x7;	tmp |= (1<<tmp2);		PutbackRMByte(ModRM,tmp);	break; /* Set */
		        case 0x1d : BITOP_WORD;	CLKS(5,5,4); tmp2 = (FETCH()) & 0xf;	tmp |= (1<<tmp2);		PutbackRMWord(ModRM,tmp);	break; /* Set */
		        case 0x1e : BITOP_BYTE;	CLKS(5,5,4); tmp2 = (FETCH()) & 0x7;	BIT_NOT;				PutbackRMByte(ModRM,tmp);	break; /* Not */
		        case 0x1f : BITOP_WORD;	CLKS(5,5,4); tmp2 = (FETCH()) & 0xf;	BIT_NOT;				PutbackRMWord(ModRM,tmp);	break; /* Not */}

		        $20:begin
                  ADD4S(r,ll);
                  CLKS(7,7,2,r);
                end;
{		        case 0x22 :	SUB4S; CLKS(7,7,2); break;
        		case 0x26 :	CMP4S; CLKS(7,7,2); break;
        		case 0x28 : ModRM = FETCH(); tmp = GetRMByte(ModRM); tmp <<= 4; tmp |= nec_state->regs.b[AL] & 0xf; nec_state->regs.b[AL] = (nec_state->regs.b[AL] & 0xf0) | ((tmp>>8)&0xf); tmp &= 0xff; PutbackRMByte(ModRM,tmp); CLKM(13,13,9,28,28,15); break;
        		case 0x2a : ModRM = FETCH(); tmp = GetRMByte(ModRM); tmp2 = (nec_state->regs.b[AL] & 0xf)<<4; nec_state->regs.b[AL] = (nec_state->regs.b[AL] & 0xf0) | (tmp&0xf); tmp = tmp2 | (tmp>>4);	PutbackRMByte(ModRM,tmp); CLKM(17,17,13,32,32,19); break;
        		case 0x31 : ModRM = FETCH(); ModRM=0; logerror("%06x: Unimplemented bitfield INS\n",PC(nec_state)); break;
        		case 0x33 : ModRM = FETCH(); ModRM=0; logerror("%06x: Unimplemented bitfield EXT\n",PC(nec_state)); break;
        		case 0x92 : CLK(2); break; /* V25/35 FINT */
        		case 0xe0 : ModRM = FETCH(); ModRM=0; logerror("%06x: V33 unimplemented BRKXA (break to expansion address)\n",PC(nec_state)); break;
        		case 0xf0 : ModRM = FETCH(); ModRM=0; logerror("%06x: V33 unimplemented RETXA (return from expansion address)\n",PC(nec_state)); break;
        		case 0xff : ModRM = FETCH(); ModRM=0; logerror("%06x: unimplemented BRKEM (break to 8080 emulation mode)\n",PC(nec_state)); break;}
		        else MessageDlg('$F otro...', mtInformation,[mbOk],0);
          end;
        end;
    $10:begin  //i_adc_br8
          tempb:=FETCH(r,ll);
	        tempb2:=RegByte(tempb,r);  //src
          tempb3:=GetRMByte(tempb,r,ll);  //dst
          if r.f.c then inc(tempb2);
          tempb3:=ADDB(tempb2,tempb3,r);
          PutbackRMByte(tempb,tempb3,r,ll);
          CLKM(2,2,2,16,16,7,tempb,r);
        end;
    $1e:begin //i_push_ds
          PUSH(r.ds0,r,ll);
          CLKS(12,8,3,r);
        end;
    $1f:begin //i_pop_ds
          r.ds0:=POP(r,ll);
          CLKS(12,8,5,r);
        end;
    $22:begin //i_and_r8b
          tempb:=FETCH(r,ll);
          tempb2:=RegByte(tempb,r);  //dst
          tempb3:=GetRMByte(tempb,r,ll);  //src
          tempb2:=ANDB(tempb3,tempb2,r);
          PutBackRegByte(tempb,tempb2,r);
          CLKM(2,2,2,11,11,6,tempb,r);
        end;
    $23:begin //i_and_r16w
          tempb:=FETCH(r,ll);
	        tempw:=RegWord(tempb,r);  //dst
          tempw2:=GetRMWord(tempb,r,ll);  //src
          tempw:=ANDW(tempw2,tempw,r);
          PutBackRegWord(tempb,tempw,r);
          CLKR(15,15,8,15,11,6,2,tempb,r);
        end;
    $24:begin //and_ald8
          tempb:=FETCH(r,ll); //src
          tempb2:=r.aw.l; //dst
          r.aw.l:=ANDB(tempb,tempb2,r);
          CLKS(4,4,2,r);
        end;
    $25:begin  //i_and_axd16
          tempw:=FETCH(r,ll);  //src
        	tempw2:=r.aw.w;  //dst
          tempw:=tempw+(FETCH(r,ll) shl 8);
          r.aw.w:=ANDW(tempw,tempw2,r);
          CLKS(4,4,2,r);
        end;
    $26:begin //i_es
          r.seg_prefix:=true;
          r.prefix_base:=r.ds1 shl 4;
          inc(r.contador,2);
          ejecuta_instruccion(fetch(r,ll),r,ll);
          r.seg_prefix:=false;
        end;
    $28:begin  //i_sub_br8
          tempb:=FETCH(r,ll);
	        tempb2:=RegByte(tempb,r);  //src
          tempb3:=GetRMByte(tempb,r,ll);  //dst
          tempb3:=SUBB(tempb2,tempb3,r);
          PutbackRMByte(tempb,tempb3,r,ll);
          CLKM(2,2,2,16,16,7,tempb,r);
        end;
    $29:begin  //i_sub_wr16
          tempb:=FETCH(r,ll);
	        tempw:=RegWord(tempb,r);  //src
          tempw2:=GetRMWord(tempb,r,ll);  //dst
          tempw2:=SUBW(tempw,tempw2,r);
          PutbackRMWord(tempb,tempw2,r,ll);
          CLKR(24,24,11,24,16,7,2,tempb,r);
        end;
    $2a:begin  //i_sub_r8b
          tempb:=FETCH(r,ll);
	        tempb2:=RegByte(tempb,r); //dst
          tempb3:=GetRMByte(tempb,r,ll);  //src
          tempb2:=SUBB(tempb3,tempb2,r);
          PutBackRegByte(tempb,tempb2,r);
          CLKM(2,2,2,11,11,6,tempb,r);
        end;
    $2b:begin //sub_r16w
           tempb:=FETCH(r,ll);
           tempw:=RegWord(tempb,r);  //dst
           tempw2:=GetRMWord(tempb,r,ll); //src
           tempw:=SUBW(tempw2,tempw,r);
           PutBackRegWord(tempb,tempw,r);
           CLKR(15,15,8,15,11,6,2,tempb,r);
        end;
    $2c:begin  //i_sub_ald8
           tempb:=FETCH(r,ll);  //src
	         tempb2:=r.aw.l;  //dst
           r.aw.l:=SUBB(tempb,tempb2,r);
           CLKS(4,4,2,r);
        end;
    $2d:begin  //i_sub_axd16
           tempw:=FETCH(r,ll);  //src
           tempw2:=r.aw.w;  //dst
           tempw:=tempw+(FETCH(r,ll) shl 8);
           r.aw.w:=SUBW(tempw,tempw2,r);
           CLKS(4,4,2,r);
        end;
    $30:begin  //i_xor_br8
           tempb:=FETCH(r,ll);
           tempb2:=RegByte(tempb,r);  //src
           tempb3:=GetRMByte(tempb,r,ll);  //dst
           tempb3:=XORB(tempb2,tempb3,r);
           PutbackRMByte(tempb,tempb3,r,ll);
           CLKM(2,2,2,16,16,7,tempb,r);
        end;
    $32:begin //i_xor_r8b
            tempb:=FETCH(r,ll);
            tempb2:=RegByte(tempb,r);  //dst
            tempb3:=GetRMByte(tempb,r,ll);  //src
            tempb2:=XORB(tempb3,tempb2,r);
            PutBackRegByte(tempb,tempb2,r);
            CLKM(2,2,2,11,11,6,tempb,r);
        end;
    $33:begin //xor_r16w
          tempb:=FETCH(r,ll);
        	tempw:=RegWord(tempb,r);  //dst
          tempw2:=GetRMWord(tempb,r,ll); //src
          tempw:=XORW(tempw2,tempw,r);
          PutBackRegWord(tempb,tempw,r);
          CLKR(15,15,8,15,11,6,2,tempb,r);
        end;
    $35:begin  //i_xor_axd16
          tempw:=FETCH(r,ll);  //src
	        tempw2:=r.aw.w;  //dst
          tempw:=tempw+(FETCH(r,ll) shl 8);
          r.aw.w:=XORW(tempw,tempw2,r);
          CLKS(4,4,2,r);
        end;
    $36:begin  //i_ss
          r.seg_prefix:=true;
          r.prefix_base:=r.ss shl 4;
          inc(r.contador,2);
          ejecuta_instruccion(fetch(r,ll),r,ll);
          r.seg_prefix:=false;
        end;
    $38:begin  //i_cmp_br8
          tempb:=FETCH(r,ll);
	        tempb2:=RegByte(tempb,r);  //src
          tempb3:= GetRMByte(tempb,r,ll);  //dst
          SUBB(tempb2,tempb3,r);
          CLKM(2,2,2,11,11,6,tempb,r);
        end;
    $39:begin  //i_cmp_wr16
          tempb:=FETCH(r,ll);
          tempw:=RegWord(tempb,r);  //src
          tempw2:=GetRMWord(tempb,r,ll);  //dst
          SUBW(tempw,tempw2,r);
          CLKR(15,15,8,15,11,6,2,tempb,r);
        end;
    $3a:begin  //i_cmp_r8b
          tempb:=FETCH(r,ll);
	        tempb2:=RegByte(tempb,r);   //dst
          tempb3:=GetRMByte(tempb,r,ll);  //src
          SUBB(tempb3,tempb2,r);
          CLKM(2,2,2,11,11,6,tempb,r);
        end;
    $3b:begin //i_cmp_r16w
          tempb:=FETCH(r,ll);
          tempw:=RegWord(tempb,r);	 //dst
          tempw2:=GetRMWord(tempb,r,ll); //src
          SUBW(tempw2,tempw,r);
          CLKR(15,15,8,15,11,6,2,tempb,r);
        end;
    $3c:begin  //i_cmp_ald8
          tempb:=FETCH(r,ll);  //src
          tempb2:=r.aw.l;  //dst
          SUBB(tempb,tempb2,r);
          CLKS(4,4,2,r);
        end;
    $3d:begin  //i_cmp_axd16
          tempw:=FETCH(r,ll);  //src
        	tempw2:=r.aw.w;  //dst
          tempw:=tempw+(FETCH(r,ll) shl 8);
          SUBW(tempw,tempw2,r);
          CLKS(4,4,2,r);
        end;
    $40:begin //inc_ax
          r.aw.w:=IncWordReg(r.AW.w,r);
          inc(r.contador,2);
        end;
    $41:begin //inc_cx
          r.cw.w:=IncWordReg(r.CW.w,r);
          inc(r.contador,2);
        end;
    $42:begin //inc_dx
          r.dw.w:=IncWordReg(r.DW.w,r);
          inc(r.contador,2);
        end;
    $43:begin //inc_bx
          r.bw.w:=IncWordReg(r.BW.w,r);
          inc(r.contador,2);
        end;
    $44:begin //inc_sp
          r.sp.w:=IncWordReg(r.SP.w,r);
          inc(r.contador,2);
        end;
    $45:begin //inc_bp
          r.bp.w:=IncWordReg(r.BP.w,r);
          inc(r.contador,2);
        end;
    $46:begin //inc_si
          r.ix.w:=IncWordReg(r.IX.w,r);
          inc(r.contador,2);
        end;
    $47:begin //inc_di
          r.iy.w:=IncWordReg(r.IY.w,r);
          inc(r.contador,2);
        end;
    $48:begin //dec_ax
          r.aw.w:=decWordReg(r.AW.w,r);
          inc(r.contador,2);
        end;
    $49:begin //dec_cx
          r.cw.w:=DecWordReg(r.CW.w,r);
          inc(r.contador,2);
        end;
    $4a:begin //dec_dx
          r.dw.w:=DecWordReg(r.DW.w,r);
          inc(r.contador,2);
        end;
    $4b:begin //dec_bx
          r.bw.w:=DecWordReg(r.BW.w,r);
          inc(r.contador,2);
        end;
    $4c:begin //dec_sp
          r.sp.w:=DecWordReg(r.SP.w,r);
          inc(r.contador,2);
        end;
    $4d:begin //dec_bp
          r.bp.w:=DecWordReg(r.BP.w,r);
          inc(r.contador,2);
        end;
    $4e:begin //dec_si
          r.ix.w:=DecWordReg(r.IX.w,r);
          inc(r.contador,2);
        end;
    $4f:begin //dec_di
          r.iy.w:=DecWordReg(r.IY.w,r);
          inc(r.contador,2);
        end;
    $50:begin //i_push_ax
          PUSH(r.aw.w,r,ll);
          CLKS(12,8,3,r);
        end;
    $51:begin //i_push_cx
          PUSH(r.cw.w,r,ll);
          CLKS(12,8,3,r);
        end;
    $52:begin //i_push_dx
          PUSH(r.dw.w,r,ll);
          CLKS(12,8,3,r);
        end;
    $53:begin //i_push_bx
          PUSH(r.bw.w,r,ll);
          CLKS(12,8,3,r);
        end;
    $54:begin //i_push_sp
          PUSH(r.sp.w,r,ll);
          CLKS(12,8,3,r);
        end;
    $55:begin //i_push_bp
          PUSH(r.bp.w,r,ll);
          CLKS(12,8,3,r);
        end;
    $56:begin //i_push_si
          PUSH(r.ix.w,r,ll);
          CLKS(12,8,3,r);
        end;
    $57:begin //i_push_di
          PUSH(r.iy.w,r,ll);
          CLKS(12,8,3,r);
        end;
    $58:begin //i_pop_ax
          r.aw.w:=POP(r,ll);
          CLKS(12,8,5,r);
        end;
    $59:begin //i_pop_cx
          r.cw.w:=POP(r,ll);
          CLKS(12,8,5,r);
        end;
    $5a:begin //i_pop_dx
          r.dw.w:=POP(r,ll);
          CLKS(12,8,5,r);
        end;
    $5b:begin //i_pop_bx
          r.bw.w:=POP(r,ll);
          CLKS(12,8,5,r);
        end;
    $5c:begin //i_pop_sp
          r.sp.w:=POP(r,ll);
          CLKS(12,8,5,r);
        end;
    $5d:begin //i_pop_bp
          r.bp.w:=POP(r,ll);
          CLKS(12,8,5,r);
        end;
    $5e:begin //i_pop_si
          r.ix.w:=POP(r,ll);
          CLKS(12,8,5,r);
        end;
    $5f:begin //i_pop_di
          r.iy.w:=POP(r,ll);
          CLKS(12,8,5,r);
        end;
    $60:begin //i_pusha
	        tempw:=r.sp.w;
	        PUSH(r.aw.w,r,ll);
          PUSH(r.cw.w,r,ll);
	        PUSH(r.dw.w,r,ll);
	        PUSH(r.bw.w,r,ll);
          PUSH(tempw,r,ll);
	        PUSH(r.bp.w,r,ll);
	        PUSH(r.ix.w,r,ll);
	        PUSH(r.iy.w,r,ll);
	        CLKS(67,35,20,r);
        end;
    $61:begin //i_popa
	        r.iy.w:=POP(r,ll);
          r.ix.w:=POP(r,ll);
          r.bp.w:=POP(r,ll);
          tempw:=POP(r,ll);
          r.bw.w:=POP(r,ll);
          r.dw.w:=POP(r,ll);
          r.cw.w:=POP(r,ll);
          r.aw.w:=POP(r,ll);
          CLKS(75,43,22,r);
        end;
    $70:begin //jo
          i_JMP(r.f.o,r,ll);
          CLKS(4,4,3,r);
        end;
    $71:begin //jno
          i_JMP(not(r.f.o),r,ll);
          CLKS(4,4,3,r);
        end;
    $72:begin //i_jc
          i_JMP(r.f.c,r,ll);
          CLKS(4,4,3,r);
        end;
    $73:begin //i_jnc
          i_JMP(not(r.f.c),r,ll);
          CLKS(4,4,3,r);
        end;
    $74:begin
          i_JMP(r.f.z,r,ll);
          CLKS(4,4,3,r);
        end;
    $75:begin //jnz
          i_JMP(not(r.f.Z),r,ll);
          CLKS(4,4,3,r);
        end;
    $76:begin //i_jce
          i_JMP((r.f.c or r.f.z),r,ll);
          CLKS(4,4,3,r);
        end;
    $77:begin //i_jnce
          i_JMP(not(r.f.c or r.f.z),r,ll);
          CLKS(4,4,3,r);
        end;
    $78:begin  //i_js
          i_JMP(r.f.s,r,ll);
          CLKS(4,4,3,r);
        end;
    $79:begin //i_jns
          i_JMP(not(r.f.s),r,ll);
          CLKS(4,4,3,r);
        end;
    $7a:begin //i_jp
          i_JMP(r.f.p,r,ll);
          CLKS(4,4,3,r);
        end;
    $7b:begin  //i_jnp
          i_JMP(not(r.f.p),r,ll);
          CLKS(4,4,3,r);
        end;
    $7c:begin //i_jl
          i_JMP(((r.f.s<>r.f.o) and not(r.f.z)),r,ll);
          CLKS(4,4,3,r);
        end;
    $7d:begin //i_jnl
          i_JMP((r.f.z or (r.f.s=r.f.O)),r,ll);
          CLKS(4,4,3,r);
        end;
    $7e:begin //i_jle
          i_JMP((r.f.z or (r.f.s<>r.f.O)),r,ll);
          CLKS(4,4,3,r);
        end;
    $7f:begin //i_jnle
          i_JMP(((r.f.s=r.f.O) and not(r.f.z)),r,ll);
          CLKS(4,4,3,r);
        end;
    $80:begin //80pre
          tempb:=fetch(r,ll);
          tempb2:=GetRMByte(tempb,r,ll); //dst
          tempb3:=FETCH(r,ll);  //src
    	    if (tempb>=$c0) then CLKS(4,4,2,r)
            else if ((tempb and $38)=$38) then CLKS(13,13,6,r)
                else CLKS(18,18,7,r);
      	  case (tempb and $38) of
	          $00:begin //ADDB
                  tempb2:=ADDB(tempb3,tempb2,r);
                  PutbackRMByte(tempb,tempb2,r,ll);
                end;
      	    $08:begin  //ORB
                  tempb2:=ORB(tempb3,tempb2,r);
                  PutbackRMByte(tempb,tempb2,r,ll);
                end;
      	    $10:MessageDlg('$80 ADDB CF', mtInformation,[mbOk],0);// src+=CF;	ADDB;	PutbackRMByte(ModRM,dst);
      	    $18:MessageDlg('$80 SUBB CF', mtInformation,[mbOk],0);// src+=CF;	SUBB;	PutbackRMByte(ModRM,dst);
        		$20:begin //ANDB
                  tempb2:=ANDB(tempb3,tempb2,r);
                  PutbackRMByte(tempb,tempb2,r,ll);
                  SetSZPF_Byte(tempb2,r);
                end;
    	      $28:begin
                  tempb2:=SUBB(tempb3,tempb2,r);
                  PutbackRMByte(tempb,tempb2,r,ll);
                end;
      	    $30:begin  //XORB
                  tempb2:=XORB(tempb3,tempb2,r);
                  PutbackRMByte(tempb,tempb2,r,ll);
                end;
      	    $38:SUBB(tempb3,tempb2,r);		 // CMPB
          end;
        end;
    $81:begin //81pre
          tempb:=fetch(r,ll);
          tempw:=GetRMWord(tempb,r,ll);  //dst
          tempw2:=fetchword(r,ll);  //src
        	if (tempb>=$c0) then CLKS(4,4,2,r)
            else if ((tempb and $38)=$38) then CLKW(17,17,8,17,13,6,r.ea,r)
              else CLKW(26,26,11,26,18,7,r.EA,r);
          case (tempb and $38) of
            $00:begin  //ADDW
                  tempw:=ADDW(tempw2,tempw,r);
                  PutbackRMWord(tempb,tempw,r,ll);
                end;
  	        $08:MessageDlg('$81 ORW', mtInformation,[mbOk],0);// ORW;				PutbackRMWord(ModRM,dst);	break;
      	    $10:MessageDlg('$81 ADDW CF', mtInformation,[mbOk],0);// src+=CF;	ADDW;	PutbackRMWord(ModRM,dst);	break;
      	    $18:MessageDlg('$81 SUBW CF', mtInformation,[mbOk],0);// src+=CF;	SUBW;	PutbackRMWord(ModRM,dst);	break;
        		$20:begin //ANDW
                  tempw:=ANDW(tempw2,tempw,r);
                  PutBackRMWord(tempb,tempw,r,ll);
                end;
       	    $28:begin
                  tempw:=SUBW(tempw2,tempw,r);
                  PutbackRMWord(tempb,tempw,r,ll);
                end;
      	    $30:MessageDlg('$81 XORW', mtInformation,[mbOk],0);// XORW;			PutbackRMWord(ModRM,dst);	break;
      	    $38:SUBW(tempw2,tempw,r);	// CMP
          end;
        end;
    $83:begin //i_83pre
          tempb:=fetch(r,ll);
          tempw:=GetRMWord(tempb,r,ll);  //dst
          tempw2:=FETCH(r,ll); //src
          if (tempw2 and $80)<>0 then tempw2:=tempw2+$ff00;
          if (tempb>=$c0) then CLKS(4,4,2,r)
            else if ((tempb and $38)=$38) then CLKW(17,17,8,17,13,6,r.EA,r)
              else CLKW(26,26,11,26,18,7,r.EA,r);
          case (tempb and $38) of
      	    $00:begin  //ADDW
                  tempw:=ADDW(tempw2,tempw,r);
                  PutbackRMWord(tempb,tempw,r,ll);
                end;
  	        $08:MessageDlg('$83 ORW', mtInformation,[mbOk],0);// ORW;				PutbackRMWord(ModRM,dst);	break;
      	    $10:MessageDlg('$83 ADDW CF', mtInformation,[mbOk],0);// src+=CF;	ADDW;	PutbackRMWord(ModRM,dst);	break;
      	    $18:MessageDlg('$83 SUBW CF', mtInformation,[mbOk],0);// src+=CF;	SUBW;	PutbackRMWord(ModRM,dst);	break;
        		$20:MessageDlg('$83 ANDW', mtInformation,[mbOk],0);// ANDW;			PutbackRMWord(ModRM,dst);	break;
       	    $28:begin
                  tempw:=SUBW(tempw2,tempw,r);
                  PutbackRMWord(tempb,tempw,r,ll);
                end;
      	    $30:MessageDlg('$83 XORW', mtInformation,[mbOk],0);// XORW;			PutbackRMWord(ModRM,dst);	break;
      	    $38:SUBW(tempw2,tempw,r);	// CMP
          end;
        end;
    $85:begin  //i_test_wr16
          tempb:=FETCH(r,ll);
          tempw:=RegWord(tempb,r);	//src
          tempw2:=GetRMWord(tempb,r,ll);  //dst
          ANDW(tempw,tempw2,r);
          CLKR(14,14,8,14,10,6,2,tempb,r);
        end;
    $87:begin  //i_xchg_wr16
          tempb:=FETCH(r,ll);
	        tempw:=RegWord(tempb,r);  //src
          tempw2:=GetRMWord(tempb,r,ll);  //dst
          PutBackRegWord(tempb,tempw2,r);
          PutbackRMWord(tempb,tempw,r,ll);
          CLKR(24,24,12,24,16,8,3,tempb,r);
        end;
    $88:begin  //i_mov_br8
          tempb:=fetch(r,ll);
          tempb2:=RegByte(tempb,r);  //src
          PutBackRMByte(tempb,tempb2,r,ll);
          CLKM(2,2,2,9,9,3,tempb,r);
        end;
    $89:begin  //i_mov_wr16
          tempb:=fetch(r,ll);
          tempw:=RegWord(tempb,r);  //src
          PutBackRMWord(tempb,tempw,r,ll);
          CLKR(13,13,5,13,9,3,2,tempb,r);
        end;
    $8a:begin //i_mov_r8b
          tempb:=fetch(r,ll);
          tempb2:=GetRMByte(tempb,r,ll);  //src
          PutBackRegByte(tempb,tempb2,r);
          CLKM(2,2,2,11,11,5,tempb,r);
        end;
    $8b:begin //i_mov_r16w
          tempb:=fetch(r,ll);
          tempw:=GetRMWord(tempb,r,ll); //src
          PutBackRegWord(tempb,tempw,r);
          CLKR(15,15,7,15,11,5,2,tempb,r);
        end;
    $8e:begin //mov_sregw
          tempb:=fetch(r,ll);
          tempw:=GetRMWord(tempb,r,ll); //src
          CLKR(15,15,7,15,11,5,2,tempb,r);
          case (tempb and $38) of
        	    $00:r.ds1:=tempw; // mov es,ew */
              $08:r.ps:=tempw; // mov cs,ew */
	            $10:r.ss:=tempw; // mov ss,ew */
	            $18:r.ds0:=tempw;// mov ds,ew */
              else MessageDlg('$8e Mov Sreg invalido', mtInformation,[mbOk],0);
          end;
          r.no_interrupt:=true;
        end;
    $8f:begin   //i_popw
          tempb:=fetch(r,ll);
          tempw:=POP(r,ll);
          PutBackRMWord(tempb,tempw,r,ll);
          inc(r.contador,21);
        end;
    $90:inc(r.contador,3); //nop
    $98:begin  //i_cbw
          if (r.aw.l and $80)<>0 then r.aw.h:=$ff
            else r.aw.h:=0;
          inc(r.contador,2);
        end;
    $9a:begin //i_call_far
          tempw:=FETCHWORD(r,ll);  //tmp
          tempw2:=FETCHWORD(r,ll);  //tmp2
          PUSH(r.ps,r,ll);
          PUSH(r.ip,r,ll);
          r.ip:=tempw;
          r.ps:=tempw2;
          r.prefetch_reset:=true;
          CLKW(29,29,13,29,21,9,r.sp.w,r);
        end;
    $9c:i_pushf(r,ll);
    $9d:i_popf(r,ll);
    $a0:begin //mov_aldisp
          tempw:=FETCHWORD(r,ll);
          r.aw.l:=ll.getbyte(DefaultBase(DS0,r)+tempw);
          CLKS(10,10,5,r);
        end;
    $a1:begin //mov_axdisp
          tempw:=FETCHWORD(r,ll);
          r.aw.w:=read_word(DefaultBase(DS0,r)+tempw,ll);
          CLKW(14,14,7,14,10,5,tempw,r);
        end;
    $a2:begin //i_mov_dispal
          tempw:=FETCHWORD(r,ll);  //addr
          PutMemB(DS0,tempw,r.aw.l,r,ll);
          CLKS(9,9,3,r);
        end;
    $a3:begin  //i_mov_dispax
          tempw:=FETCHWORD(r,ll);
          PutMemW(DS0,tempw,r.aw.w,r,ll);
          CLKW(13,13,5,13,9,3,tempw,r);
        end;
    $a4:i_movsb(r,ll);
    $a5:i_movsw(r,ll);
    $a8:begin  //i_test_ald8
          tempb:=FETCH(r,ll);  //src
          ANDB(tempb,r.aw.l,r);
          CLKS(4,4,2,r);
        end;
    $a9:begin //i_test_axd16
          tempw:=FETCH(r,ll);  //src
	        tempw2:=r.aw.w;  //dst
          tempw:=tempw+(FETCH(r,ll) shl 8);
          ANDW(tempw,tempw2,r);
          CLKS(4,4,2,r);
        end;
    $aa:i_stosb(r,ll);
    $ab:i_stosw(r,ll);
    $ac:i_lodsb(r,ll);
    $ad:i_lodsw(r,ll);
    $ae:i_scasb(r,ll);
    $af:i_scasw(r,ll);
    $b0:begin //mov_ald8
          r.aw.l:=FETCH(r,ll);
          CLKS(4,4,2,r);
        end;
    $b1:begin //mov_cld8
          r.cw.l:=FETCH(r,ll);
          CLKS(4,4,2,r);
        end;
    $b2:begin //mov_dld8
          r.dw.l:=FETCH(r,ll);
          CLKS(4,4,2,r);
        end;
    $b3:begin //mov_bld8
          r.bw.l:=FETCH(r,ll);
          CLKS(4,4,2,r);
        end;
    $b4:begin //mov_ahd8
          r.aw.h:=FETCH(r,ll);
          CLKS(4,4,2,r);
        end;
    $b5:begin //mov_chd8
          r.cw.h:=FETCH(r,ll);
          CLKS(4,4,2,r);
        end;
    $b6:begin //mov_dhd8
          r.dw.h:=FETCH(r,ll);
          CLKS(4,4,2,r);
        end;
    $b7:begin //mov_bhd8
          r.bw.h:=FETCH(r,ll);
          CLKS(4,4,2,r);
        end;
    $b8:begin //mov_axd16
          r.aw.l:=fetch(r,ll);
          r.aw.h:=fetch(r,ll);
          CLKS(4,4,2,r);
        end;
    $b9:begin //mov_cxd16
          r.cw.l:=fetch(r,ll);
          r.cw.h:=fetch(r,ll);
          CLKS(4,4,2,r);
        end;
    $ba:begin //mov_dxd16
          r.dw.l:=fetch(r,ll);
          r.dw.h:=fetch(r,ll);
          CLKS(4,4,2,r);
        end;
    $bb:begin //mov_bxd16
          r.bw.l:=fetch(r,ll);
          r.bw.h:=fetch(r,ll);
          CLKS(4,4,2,r);
        end;
    $bc:begin //mov_spd16
          r.sp.l:=fetch(r,ll);
          r.sp.h:=fetch(r,ll);
          CLKS(4,4,2,r);
        end;
    $bd:begin //mov_bpd16
          r.bp.l:=fetch(r,ll);
          r.bp.h:=fetch(r,ll);
          CLKS(4,4,2,r);
        end;
    $be:begin //mov_sid16
          r.ix.l:=fetch(r,ll);
          r.ix.h:=fetch(r,ll);
          CLKS(4,4,2,r);
        end;
    $bf:begin //mov_did16
          r.iy.l:=fetch(r,ll);
          r.iy.h:=fetch(r,ll);
          CLKS(4,4,2,r);
        end;
    $c0:begin  //i_rotshft_bd8
	        tempb:=fetch(r,ll);
          tempb2:=GetRMByte(tempb,r,ll);  //src
          tempb3:=tempb2;  //dst
	        c:=FETCH(r,ll);
	        CLKM(7,7,2,19,19,6,tempb,r);
	        if (c<>0) then case (tempb and $38) of
		          $00:MessageDlg('$c0 ROL_BYTE!', mtInformation,[mbOk],0); // do { ROL_BYTE;  c--; CLK(1); } while (c>0); PutbackRMByte(ModRM,(BYTE)dst); break;
		          $08:MessageDlg('$c0 ROR_BYTE!', mtInformation,[mbOk],0);// do { ROR_BYTE;  c--; CLK(1); } while (c>0); PutbackRMByte(ModRM,(BYTE)dst); break;
		          $10:MessageDlg('$c0 ROLC_BYTE!', mtInformation,[mbOk],0);// do { ROLC_BYTE; c--; CLK(1); } while (c>0); PutbackRMByte(ModRM,(BYTE)dst); break;
		          $18:MessageDlg('$c0 RORC_BYTE!', mtInformation,[mbOk],0);// do { RORC_BYTE; c--; CLK(1); } while (c>0); PutbackRMByte(ModRM,(BYTE)dst); break;
		          $20:SHL_BYTE(c,tempb3,tempb,r,ll);
		          $28:SHR_BYTE(c,tempb3,tempb,r,ll);
		          $30:MessageDlg('$c0 SHLA_BYTE indefinido!', mtInformation,[mbOk],0);
		          $38:MessageDlg('$c0 SHRA_BYTE!', mtInformation,[mbOk],0);// SHRA_BYTE(c); break;
	        end;
        end;
    $c1:begin  //i_rotshft_wd8
	        tempb:=fetch(r,ll);
          tempw:=GetRMWord(tempb,r,ll);  //src
          tempw2:=tempw;  //dst
	        c:=FETCH(r,ll);
	        CLKM(7,7,2,27,19,6,tempb,r);
          if (c<>0) then case (tempb and $38) of
		          $00:MessageDlg('$c1 ROL_WORD!', mtInformation,[mbOk],0);// do { ROL_WORD;  c--; CLK(1); } while (c>0); PutbackRMWord(ModRM,(WORD)dst); break;
		          $08:MessageDlg('$c1 ROR_WORD!', mtInformation,[mbOk],0); // do { ROR_WORD;  c--; CLK(1); } while (c>0); PutbackRMWord(ModRM,(WORD)dst); break;
		          $10:MessageDlg('$c1 ROLC_WORD!', mtInformation,[mbOk],0);// do { ROLC_WORD; c--; CLK(1); } while (c>0); PutbackRMWord(ModRM,(WORD)dst); break;
		          $18:MessageDlg('$c1 RORC_WORD!', mtInformation,[mbOk],0); // do { RORC_WORD; c--; CLK(1); } while (c>0); PutbackRMWord(ModRM,(WORD)dst); break;
		          $20:SHL_WORD(c,tempw2,tempb,r,ll);
		          $28:SHR_WORD(c,tempw2,tempb,r,ll);
		          $30:MessageDlg('$c1 SHLA_WORD indefinido!', mtInformation,[mbOk],0);
		          $38:MessageDlg('$c1 SHRA_WORD!', mtInformation,[mbOk],0); //SHRA_WORD(c); break;
	        end;
        end;
    $c3:begin //i_ret
          r.ip:=POP(r,ll);
          r.prefetch_reset:=true;
          CLKS(19,19,10,r);
        end;
    $c6:begin //i_mov_bd8
          tempb:=fetch(r,ll);
          PutImmRMByte(tempb,r,ll);
          if tempb>=$c0 then inc(r.contador,4)
            else inc(r.contador,11);
        end;
    $c7:begin  //i_mov_wd16
          tempb:=fetch(r,ll);
          PutImmRMWord(tempb,r,ll);
          if tempb>=$c0 then inc(r.contador,4)
            else inc(r.contador,15);
        end;
    $cb:begin  //i_retf
          r.ip:=POP(r,ll);
          r.ps:=POP(r,ll);
          r.prefetch_reset:=true;
          CLKS(29,29,16,r);
        end;
    $cf:begin  //i_iret
          r.ip:=POP(r,ll);
          r.ps:=POP(r,ll);
          i_popf(r,ll);
          r.f.m:=true;
          r.prefetch_reset:=true;
          CLKS(39,39,19,r);
        end;
    $d0:begin  //i_rotshft_b
	        tempb:=fetch(r,ll);
          tempb2:=GetRMByte(tempb,r,ll);  //src
          tempb3:=tempb2;  //dst
        	CLKM(6,6,2,16,16,7,tempb,r);
          case (tempb and $38) of
        		$00:MessageDlg('$d0 ROL_BYTE', mtInformation,[mbOk],0);// ROL_BYTE;  PutbackRMByte(ModRM,(BYTE)dst); nec_state->OverVal = (src^dst)&0x80; break;
        		$08:MessageDlg('$d0 ROR_BYTE', mtInformation,[mbOk],0);// ROR_BYTE;  PutbackRMByte(ModRM,(BYTE)dst); nec_state->OverVal = (src^dst)&0x80; break;
        		$10:begin
                  tempb3:=ROLC_BYTE(tempb3,r);
                  PutbackRMByte(tempb,tempb3,r,ll);
                  r.f.o:=((tempb2 xor tempb3) and $80)<>0;
                end;
        		$18:begin
                  tempb3:=RORC_BYTE(tempb3,r);
                  PutbackRMByte(tempb,tempb3,r,ll);
                  r.f.o:=((tempb2 xor tempb3) and $80)<>0;
                end;
        		$20:begin  //SHL_BYTE
                  tempb3:=SHL_BYTE(1,tempb3,tempb,r,ll);
                  r.f.o:=((tempb2 xor tempb3) and $80)<>0;
                end;
        		$28:begin
                  tempb3:=SHR_BYTE(1,tempb3,tempb,r,ll);
                  r.f.o:=((tempb2 xor tempb3) and $80)<>0;
                end;
        		$30:MessageDlg('$d0 SHLA_BYTE Invalido!', mtInformation,[mbOk],0);
        		$38:MessageDlg('$d0 SHRA_BYTE', mtInformation,[mbOk],0);// SHRA_BYTE(1); nec_state->OverVal = 0; break;
	        end;
        end;
    $d1:begin  //i_rotshft_w
          tempb:=fetch(r,ll);
          tempw:=GetRMWord(tempb,r,ll); //src
          tempw2:=tempw;  //dst
          CLKM(6,6,2,24,16,7,tempb,r);
	        case (tempb and $38) of
            $00:MessageDlg('$d1 ROL_WORD', mtInformation,[mbOk],0);// ROL_WORD;  PutbackRMWord(ModRM,(WORD)dst); nec_state->OverVal = (src^dst)&0x8000; break;
		        $08:begin
                  tempw2:=ROR_WORD(tempw2,r);
                  PutbackRMWord(tempb,tempw2,r,ll);
                  r.f.o:=((tempw xor tempw2) and $8000)<>0;
                end;
		        $10:MessageDlg('$d1 ROLC_WORD', mtInformation,[mbOk],0); //ROLC_WORD; PutbackRMWord(ModRM,(WORD)dst); nec_state->OverVal = (src^dst)&0x8000; break;
		        $18:MessageDlg('$d1 RORC_WORD', mtInformation,[mbOk],0);//RORC_WORD; PutbackRMWord(ModRM,(WORD)dst); nec_state->OverVal = (src^dst)&0x8000; break;
		        $20:MessageDlg('$d1 SHL_WORD', mtInformation,[mbOk],0);//SHL_WORD(1); nec_state->OverVal = (src^dst)&0x8000;  break;
		        $28:begin
                  tempw2:=SHR_WORD(1,tempw2,tempb,r,ll);
                  r.f.o:=((tempw xor tempw2) and $8000)<>0;
                end;
		        $30:MessageDlg('$d1 SHLA_WORD Invalido!', mtInformation,[mbOk],0);
		        $38:MessageDlg('$d1 SHRA_WORD', mtInformation,[mbOk],0);//SHRA_WORD(1); nec_state->OverVal = 0; break;
	        end;
        end;
    $d2:begin //i_rotshft_bcl
          tempb:=fetch(r,ll);
          tempb2:=GetRMByte(tempb,r,ll);  //src
          tempb3:=tempb2;  //dst
          c:=r.cw.l;
	        CLKM(7,7,2,19,19,6,tempb,r);
	        if (c<>0) then case (tempb and $38) of
		        $00:MessageDlg('$d2 ROL_BYTE', mtInformation,[mbOk],0); // do { ROL_BYTE;  c--; CLK(1); } while (c>0); PutbackRMByte(ModRM,(BYTE)dst); break;
		        $08:MessageDlg('$d2 ROR_BYTE', mtInformation,[mbOk],0); // do { ROR_BYTE;  c--; CLK(1); } while (c>0); PutbackRMByte(ModRM,(BYTE)dst); break;
            $10:begin
                   while (c>0) do begin
                      tempb3:=ROLC_BYTE(tempb3,r);
                      dec(c);
                      inc(r.contador);
                   end;
                   PutbackRMByte(tempb,tempb3,r,ll);
                end;
		        $18:begin
                   while (c>0) do begin
                      tempb3:=RORC_BYTE(tempb3,r);
                      dec(c);
                      inc(r.contador);
                   end;
                   PutbackRMByte(tempb,tempb3,r,ll);
                end;
		        $20:MessageDlg('$d2 SHL_BYTE', mtInformation,[mbOk],0);// SHL_BYTE(c); break;
		        $28:MessageDlg('$d2 SHR_BYTE', mtInformation,[mbOk],0); // SHR_BYTE(c); break;
		        $30:MessageDlg('$d2 SHLA_BYTE Invalido!', mtInformation,[mbOk],0);
		        $38:MessageDlg('$d2 SHRA_BYTE', mtInformation,[mbOk],0); // SHRA_BYTE(c); break;
	        end;
        end;
    $e1:begin //i_loope
            tempb:=FETCH(r,ll);
            dec(r.cw.w);
            if (r.f.Z and (r.cw.w<>0)) then begin
                if ((tempb and $80)<>0) then r.ip:=r.ip-($100-tempb)
                  else r.ip:=r.ip+tempb;
                CLKS(14,14,6,r);
            end else begin
              CLKS(5,5,3,r);
            end;
        end;
    $e2:begin //dbnz
            tempb:=FETCH(r,ll);
            dec(r.cw.w);
            if (r.cw.w<>0) then begin
              if ((tempb and $80)<>0) then r.ip:=r.ip-($100-tempb)
                else r.ip:=r.ip+tempb;
              CLKS(13,13,6,r);
            end else begin
              CLKS(5,5,3,r);
            end;
        end;
    $e5:begin //inax
         tempb:=FETCH(r,ll);
         r.aw.w:=ll.inword(tempb);
         CLKW(13,13,7,13,9,5,tempb,r);
        end;
    $e7:begin //outax
          tempb:=FETCH(r,ll);
          ll.outword(r.aw.w,tempb);
          CLKW(12,12,5,12,8,3,tempb,r);
        end;
    $e8:begin //i_call_d16
          tempw:=FETCHWORD(r,ll);
          PUSH(r.ip,r,ll);
          if (tempw and $8000)<>0 then r.ip:=r.ip-($10000-tempw)
            else r.ip:=r.ip+tempw;
          r.prefetch_reset:=true;
          inc(r.contador,24);
        end;
    $e9:begin //jmp_d16
          tempw:=FETCHWORD(r,ll);
          if (tempw and $8000)<>0 then r.ip:=r.ip-($10000-tempw)
            else r.ip:=r.ip+tempw;
          r.prefetch_reset:=true;
          inc(r.contador,15);
        end;
    $ea:begin  //jump_far
           tempw:=fetchword(r,ll);
           tempw2:=fetchword(r,ll);
           r.ip:=tempw;
           r.ps:=tempw2;
           r.prefetch_reset:=true;
           inc(r.contador,27);
        end;
    $eb:begin //i_jmp_d8
            tempb:=FETCH(r,ll);
            inc(r.contador,12);
            if ((tempb and $80)<>0) then r.ip:=r.ip-($100-tempb)
                else r.ip:=r.ip+tempb;
        end;
    $f3:begin //repe
            tempb:=fetch(r,ll);  //next
            tempw:=r.cw.w;  //c
            case tempb of // Segments */
        	    $26:begin
                    r.seg_prefix:=TRUE;
                    r.prefix_base:=r.ds1 shl 4;
                    tempb:=fetch(r,ll);
                    inc(r.contador,2);
                  end;
        	    $2e:begin
                    r.seg_prefix:=TRUE;
                    r.prefix_base:=r.ps shl 4;
                    tempb:=fetch(r,ll);
                    inc(r.contador,2);
                  end;
      	      $36:begin
                    r.seg_prefix:=TRUE;
                    r.prefix_base:=r.ss shl 4;
                    tempb:=fetch(r,ll);
                    inc(r.contador,2);
                  end;
        	    $3e:begin
                    r.seg_prefix:=TRUE;
                    r.prefix_base:=r.ds0 shl 4;
                    tempb:=fetch(r,ll);
                    inc(r.contador,2);
                  end;
            end;
            inc(r.contador,2);
            case tempb of
        	    $6c:begin
                    if (tempw<>0) then begin
                       while (tempw>0) do begin
                          MessageDlg('$f3 i_insb', mtInformation,[mbOk],0);
                          tempw:=tempw-1;
                       end;
                       r.cw.w:=tempw;
                    end;
                  end;
        	    $6d:begin
                    if (tempw<>0) then begin
                       while (tempw>0) do begin
                          MessageDlg('$f3 i_insw', mtInformation,[mbOk],0);
                          tempw:=tempw-1;
                       end;
                       r.cw.w:=tempw;
                    end;
                  end;
        	    $6e:begin
                    if (tempw<>0) then begin
                       while (tempw>0) do begin
                          MessageDlg('$f3 i_outsb', mtInformation,[mbOk],0);
                          tempw:=tempw-1;
                       end;
                       r.cw.w:=tempw;
                    end;
                  end;
        	    $6f:begin
                    if (tempw<>0) then begin
                       while (tempw>0) do begin
                          MessageDlg('$f3 i_outsw', mtInformation,[mbOk],0);
                          tempw:=tempw-1;
                       end;
                       r.cw.w:=tempw;
                    end;
                  end;
        	    $a4:begin
                    while (tempw>0) do begin
                       i_movsb(r,ll);
                       tempw:=tempw-1;
                    end;
                    r.cw.w:=tempw;
                  end;
        	    $a5:begin
                    while (tempw>0) do begin
                       i_movsw(r,ll);
                       tempw:=tempw-1;
                    end;
                    r.cw.w:=tempw;
                  end;
        	    $a6:begin
                    if (tempw>0) then begin
                       while (tempw>0) do begin
                          MessageDlg('$f3 i_cmpsb', mtInformation,[mbOk],0);
                          tempw:=tempw-1;
                       end;
                       r.cw.w:=tempw;
                    end;
                  end;
        	    $a7:begin
                    if (tempw<>0) then begin
                       while (tempw>0) do begin
                          MessageDlg('$f3 i_cmpsw', mtInformation,[mbOk],0);
                          tempw:=tempw-1;
                       end;
                       r.cw.w:=tempw;
                    end;
                  end;
        	    $aa:begin
                    while (tempw>0) do begin
                       i_stosb(r,ll);
                       tempw:=tempw-1;
                    end;
                    r.cw.w:=tempw;
                  end;
        	    $ab:begin
                    while (tempw>0) do begin
                       i_stosw(r,ll);
                       tempw:=tempw-1;
                    end;
                    r.cw.w:=tempw;
                  end;
        	    $ac:begin
                    while (tempw>0) do begin
                       i_lodsb(r,ll);
                       tempw:=tempw-1;
                    end;
                    r.cw.w:=tempw;
                  end;
        	    $ad:begin
                    while (tempw>0) do begin
                       i_lodsw(r,ll);
                       tempw:=tempw-1;
                    end;
                    r.cw.w:=0;
                  end;
        	    $ae:if (tempw<>0) then begin
                    repeat
                       i_scasb(r,ll);
                       tempw:=tempw-1;
                    until not((tempw>0) and r.f.z);
                    r.cw.w:=tempw;
                  end;
        	    $af:if (tempw<>0) then begin
                    repeat
                       i_scasw(r,ll);
                       tempw:=tempw-1;
                    until not((tempw>0) and r.f.z);
                    r.cw.w:=tempw;
                  end;
          		else MessageDlg('$f3 REPE invalido', mtInformation,[mbOk],0);
            end;
          	r.seg_prefix:=FALSE;
        end;
    $f6:begin //i_f6pre
	         tempb:=fetch(r,ll);
           tempb2:=GetRMByte(tempb,r,ll); //tmp
           case (tempb and $38) of
		          $00:begin //TEST
                    tempb2:=tempb2 and FETCH(r,ll);
                    r.f.c:=false;
                    r.f.o:=false;
                    SetSZPF_Byte(tempb2,r);
                    if (tempb>=$c0) then inc(r.contador,4)
                      else inc(r.contador,11);
                  end;
		          $08:MessageDlg('Opcode indefinido $f6 08', mtInformation,[mbOk], 0);
		          $10:MessageDlg('$f6 NOT', mtInformation,[mbOk], 0); // PutbackRMByte(ModRM,~tmp); nec_state->icount-=(ModRM >=0xc0 )?2:16; break; /* NOT */
		          $18:MessageDlg('$f6 NEG', mtInformation,[mbOk], 0); // nec_state->CarryVal=(tmp!=0); tmp=(~tmp)+1; SetSZPF_Byte(tmp); PutbackRMByte(ModRM,tmp&0xff); nec_state->icount-=(ModRM >=0xc0 )?2:16; break; /* NEG */
		          $20:MessageDlg('$f6 MULU', mtInformation,[mbOk], 0); // uresult = nec_state->regs.b[AL]*tmp; nec_state->regs.w[AW]=(WORD)uresult; nec_state->CarryVal=nec_state->OverVal=(nec_state->regs.b[AH]!=0); nec_state->icount-=(ModRM >=0xc0 )?30:36; break; /* MULU */
		          $28:MessageDlg('$f6 MUL', mtInformation,[mbOk], 0); // result = (INT16)((INT8)nec_state->regs.b[AL])*(INT16)((INT8)tmp); nec_state->regs.w[AW]=(WORD)result; nec_state->CarryVal=nec_state->OverVal=(nec_state->regs.b[AH]!=0); nec_state->icount-=(ModRM >=0xc0 )?30:36; break; /* MUL */
              $30:MessageDlg('$f6 DIVUB', mtInformation,[mbOk], 0); // if (tmp) { DIVUB; } else nec_interrupt(nec_state, 0,0); nec_state->icount-=(ModRM >=0xc0 )?43:53; break;
		          $38:MessageDlg('$f6 DIVB', mtInformation,[mbOk], 0); // if (tmp) { DIVB;  } else nec_interrupt(nec_state, 0,0); nec_state->icount-=(ModRM >=0xc0 )?43:53; break;
           end;
        end;
    $f7:begin  //i_f7pre
           tempb:=fetch(r,ll);
           tempw:=GetRMWord(tempb,r,ll);  //tmp
           case (tempb and $38) of
          		$00:begin  // TEST
                    tempw2:=FETCHWORD(r,ll);
                    tempw:=tempw and tempw2;
                    r.f.c:=false;
                    r.f.o:=false;
                    SetSZPF_Word(tempw,r);
                    if (tempb>=$c0) then inc(r.contador,4)
                      else inc(r.contador,11);
                  end;
          		$08:MessageDlg('Opcode indefinido $f7 08', mtInformation,[mbOk], 0);
          		$10:begin  // NOT
                    PutbackRMWord(tempb,not(tempw),r,ll);
                    if (tempb>=$c0) then inc(r.contador,2)
                      else inc(r.contador,16);
                  end;
          		$18:begin  //NEG
                    r.f.c:=(tempw<>0);
                    tempw:=not(tempw)+1;
                    SetSZPF_Word(tempw,r);
                    PutbackRMWord(tempb,tempw,r,ll);
                    if (tempb>=$c0) then inc(r.contador,2)
                      else inc(r.contador,16);
                  end;
          		$20:MessageDlg('$f7 MULU', mtInformation,[mbOk], 0); //uresult = nec_state->regs.w[AW]*tmp; nec_state->regs.w[AW]=uresult&0xffff; nec_state->regs.w[DW]=((UINT32)uresult)>>16; nec_state->CarryVal=nec_state->OverVal=(nec_state->regs.w[DW]!=0); nec_state->icount-=(ModRM >=0xc0 )?30:36; break; /* MULU */
          		$28:MessageDlg('$f7 MUL', mtInformation,[mbOk], 0); // result = (INT32)((INT16)nec_state->regs.w[AW])*(INT32)((INT16)tmp); nec_state->regs.w[AW]=result&0xffff; nec_state->regs.w[DW]=result>>16; nec_state->CarryVal=nec_state->OverVal=(nec_state->regs.w[DW]!=0); nec_state->icount-=(ModRM >=0xc0 )?30:36; break; /* MUL */
          		$30:MessageDlg('$f7 DIVUW', mtInformation,[mbOk], 0); // if (tmp) { DIVUW; } else nec_interrupt(nec_state, 0,0); nec_state->icount-=(ModRM >=0xc0 )?43:53; break;
           		$38:MessageDlg('$f7 DIVW', mtInformation,[mbOk], 0); // if (tmp) { DIVW;  } else nec_interrupt(nec_state, 0,0); nec_state->icount-=(ModRM >=0xc0 )?43:53; break;
           end;
        end;
    $f8:begin //i_clc
           r.f.c:=false;
           inc(r.contador,2);
        end;
    $f9:begin //i_stc
           r.f.c:=true;
           inc(r.contador,2);
        end;
    $fa:begin //di
           r.f.I:=false;
           inc(r.contador,2);
        end;
    $fb:begin //ei
           r.f.I:=true;
           inc(r.contador,2);
        end;
    $fc:begin //cld
           r.f.d:=false;
           inc(r.contador,2);
        end;
    $fd:begin //std
           r.f.d:=true;
           inc(r.contador,2);
        end;
    $fe:begin  //fepre
           tempb2:=fetch(r,ll);  //modmr
           tempb:=GetRMByte(tempb2,r,ll);  //src
           case (tempb2 and $38) of
    	        $00:begin  // INC
                     tempb3:=tempb+1;
                     r.f.O:=(tempb=$7f);
                     r.f.A:=((tempb3 xor (tempb xor 1)) and $10)<>0;
                     SetSZPF_Byte(tempb3,r);
                     PutbackRMByte(tempb2,tempb3,r,ll);
                     CLKM(2,2,2,16,16,7,tempb2,r);
                  end;
		          $08:begin // DEC
                     tempb3:=tempb-1;
                     r.f.O:=(tempb=$80);
                     r.f.A:=((tempb3 xor (tempb xor 1)) and $10)<>0;
                     SetSZPF_Byte(tempb3,r);
                     PutbackRMByte(tempb2,tempb3,r,ll);
                     CLKM(2,2,2,16,16,7,tempb2,r);
                  end;
              else MessageDlg('Intruccion FE no implementada', mtInformation,[mbOk], 0);
           end;
        end;
    $ff:begin  //i_ffpre
          tempb:=fetch(r,ll);
          tempw:=GetRMWord(tempb,r,ll);  //tmp
          case (tempb and $38) of
          	  $00:begin  //INC
                    tempw2:=tempw+1;  //tmp1
                    r.f.o:=(tempw=$7fff);
                    r.f.a:=((tempw2 xor (tempw xor 1)) and $10)<>0;
                    SetSZPF_Word(tempw2,r);
                    PutbackRMWord(tempb,tempw2,r,ll);
                    CLKM(2,2,2,24,16,7,tempb,r);
                  end;
        		  $08:begin  //DEC
                    tempw2:=tempw-1;  //tmp1
                    r.f.o:=(tempw=$8000);
                    r.f.a:=((tempw2 xor (tempw xor 1)) and $10)<>0;
                    SetSZPF_Word(tempw2,r);
                    PutbackRMWord(tempb,tempw2,r,ll);
                    CLKM(2,2,2,24,16,7,tempb,r);
                  end;
        		  $10:begin // CALL */
                    PUSH(r.ip,r,ll);
                    r.ip:=tempw;
                    r.prefetch_reset:=true;
                    if (tempb>=$c0) then inc(r.contador,16)
                      else inc(r.contador,20);
                  end;
         		  $18:MessageDlg('FF CALL_FAR', mtInformation,[mbOk], 0); // tmp1 = nec_state->sregs[PS]; nec_state->sregs[PS] = GetnextRMWord; PUSH(tmp1); PUSH(nec_state->ip); nec_state->ip = tmp; CHANGE_PC; nec_state->icount-=(ModRM >=0xc0 )?16:26; break; /* CALL FAR */
        		  $20:begin
                    r.ip:=tempw;
                    r.prefetch_reset:=true;
                    inc(r.contador,13);
                  end;
        		  $28:MessageDlg('FF JMP_FAR', mtInformation,[mbOk], 0); //nec_state->ip = tmp; nec_state->sregs[PS] = GetnextRMWord; CHANGE_PC; nec_state->icount-=15; break; /* JMP FAR */
        		  $30:begin
                    PUSH(tempw,r,ll);
                    inc(r.contador,4);
                  end;
        		  else MessageDlg('Intruccion FF no implementada', mtInformation,[mbOk], 0);
          end;
        end;
    else MessageDlg('Intruccion desconocida NEC PC: '+inttohex(((r.ps shl 4)+r.ip)-1,10)+' INST: '+inttohex(instruccion,4), mtInformation,[mbOk], 0);
  end; //del case
end;

procedure nec_interrupt(vect_num:word;r:preg_nec;ll:llam_nec);
begin
  if r.no_interrupt then begin
    if not(r.irq_pending) then r.vect:=vect_num;
    r.irq_pending:=true;
    r.no_interrupt:=false;
    exit;
  end;
  if not(r.f.I) then begin
    if not(r.irq_pending) then r.vect:=vect_num;
    r.irq_pending:=true;
    exit;
  end;
  if vect_num=$100 then vect_num:=r.vect;
  r.pedir_irq:=false;
  r.irq_pending:=false;
  i_pushf(r,ll);
  r.f.T:=false;
  r.f.I:=false;
	PUSH(r.ps,r,ll);
	PUSH(r.ip,r,ll);
  r.ip:=read_word(vect_num*4,ll);
  r.ps:=read_word(vect_num*4+2,ll);
	r.prefetch_reset:=true;
end;

procedure run_nec(r:preg_nec;ll:llam_nec;maximo:integer);
var
  instruccion:byte;
begin
r.contador:=0;
while r.contador<maximo do begin
  //IRQ's
  prev_icount:=r.contador;
  if r.irq_pending then nec_interrupt($100,r,ll)
    else if r.pedir_irq then nec_interrupt(r.vect_req,r,ll);
  r.opcode:=true;
  instruccion:=fetch(r,ll);
  r.opcode:=false;
  r.ea_calculated:=false;
  ejecuta_instruccion(instruccion,r,ll);
  do_prefetch(r,prev_ICount);
  r.no_interrupt:=false;
end; //del while
end;

end.
