unit z80;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     main_engine,z80daisy,timer_engine,dialogs,sysutils;

type
  band_z80 = record
     c,n,p_v,bit3,h,bit5,z,s:boolean;
  end;
  preg_z80=^reg_z80;
  pband_z80=^band_z80;
  reg_z80 = record
        ppc,pc,sp:word;
        bc,de,hl:parejas;
        bc2,de2,hl2:parejas;
        ix,iy:parejas;
        iff1,iff2,halt:boolean;
        pedir_irq,pedir_nmi,nmi_state:byte;
        a,a2,i,r:byte;
        f,f2:band_z80;
        contador:dword;
        im,im2_lo,im0:byte;
        daisy,opcode,after_ei:boolean;
        numero_cpu:byte;
        tframes:single;
        enabled:boolean;
        estados_demas:word;
  end;
  llam_z80 = record
        getbyte: function (direccion: Word): Byte;  
        putbyte: procedure (direccion:word;valor:byte); 
        outbyte: procedure (valor:byte;puerto:word); 
        inbyte: function(puerto:word):byte;
        despues_instruccion:procedure(estados_t:word);
        raised_z80: procedure;
  end;
const
        z80t:array[0..255] of byte=(
      //0  1  2  3  4  5  6  7  8  9  a  b  c  d  e  f
        4,10, 7, 6, 4, 4, 7, 4, 4,11, 7, 6, 4, 4, 7, 4,  //0                          *
        8,10, 7, 6, 4, 4, 7, 4,12,11, 7, 6, 4, 4, 7, 4,  //10
        7,10,16, 6, 4, 4, 7, 4, 7,11,16, 6, 4, 4, 7, 4,  //20
        7,10,13, 6,11,11,10, 4, 7,11,13, 6, 4, 4, 7, 4,  //30
        4, 4, 4, 4, 4, 4, 7, 4, 4, 4, 4, 4, 4, 4, 7, 4,  //40
        4, 4, 4, 4, 4, 4, 7, 4, 4, 4, 4, 4, 4, 4, 7, 4,  //50
        4, 4, 4, 4, 4, 4, 7, 4, 4, 4, 4, 4, 4, 4, 7, 4,  //60
        7, 7, 7, 7, 7, 7, 4, 7, 4, 4, 4, 4, 4, 4, 7, 4,  //70
        4, 4, 4, 4, 4, 4, 7, 4, 4, 4, 4, 4, 4, 4, 7, 4,  //80
        4, 4, 4, 4, 4, 4, 7, 4, 4, 4, 4, 4, 4, 4, 7, 4,  //90
        4, 4, 4, 4, 4, 4, 7, 4, 4, 4, 4, 4, 4, 4, 7, 4,  //A0
        4, 4, 4, 4, 4, 4, 7, 4, 4, 4, 4, 4, 4, 4, 7, 4,  //B0
        5,10,10,10,10,11, 7,11, 5,10,10, 0,10,17, 7,11,  //C0
        5,10,10,11,10,11, 7,11, 5, 4,10,11,10, 0, 7,11,  //D0
        5,10,10,19,10,11, 7,11, 5, 4,10, 4,10, 0, 7,11,  //E0
        5,10,10, 4,10,11, 7,11, 5, 6,10, 4,10, 0, 7,11); //F0

        paridad:array [0..255] of boolean=(
        True,False,False,True,False,True,True,False,False,True,True,
        False,True,False,False,True,False,True,True,False,True,False,
        False,True,True,False,False,True,False,True,True,False,False,
        True,True,False,True,False,False,True,True,False,False,True,
        False,True,True,False,True,False,False,True,False,True,True,
        False,False,True,True,False,True,False,False,True,False,True,
        True,False,True,False,False,True,True,False,False,True,False,
        True,True,False,True,False,False,True,False,True,True,False,
        False,True,True,False,True,False,False,True,True,False,False,
        True,False,True,True,False,False,True,True,False,True,False,
        False,True,False,True,True,False,True,False,False,True,True,
        False,False,True,False,True,True,False,False,True,True,False,
        True,False,False,True,True,False,False,True,False,True,True,
        False,True,False,False,True,False,True,True,False,False,True,
        True,False,True,False,False,True,True,False,False,True,False,
        True,True,False,False,True,True,False,True,False,False,True,
        False,True,True,False,True,False,False,True,True,False,False,
        True,False,True,True,False,True,False,False,True,False,True,
        True,False,False,True,True,False,True,False,False,True,False,
        True,True,False,True,False,False,True,True,False,False,True,
        False,True,True,False,False,True,True,False,True,False,False,
        True,True,False,False,True,False,True,True,False,True,False,
        False,True,False,True,True,False,False,True,True,False,True,
        False,False,True);

procedure reset_z80(r:preg_z80);
procedure run_z80(r:preg_z80;ll:llam_z80;maximo:dword);
procedure clear_nmi_z80(r:preg_z80);
{aritmetica 8 bits}
procedure add_8(r:preg_z80;valor:byte);inline;
procedure adc_8(r:preg_z80;valor:byte);inline;
procedure sub_8(r:preg_z80;valor:byte);inline;
procedure sbc_8(r:preg_z80;valor:byte);inline;
procedure dec_8(r:preg_z80;reg:pbyte);inline;
procedure inc_8(r:preg_z80;reg:pbyte);inline;
{aritmetica 16bits}
procedure add_16(r:preg_z80;reg:pparejas;valor:word);inline;
{logica}
procedure cp_a(r:preg_z80;valor:byte);inline;
procedure and_a(r:preg_z80;valor:byte);inline;
procedure or_a(r:preg_z80;valor:byte);inline;
procedure xor_a(r:preg_z80;valor:byte);inline;
procedure srl_8(r:preg_z80;reg:pbyte);inline;
procedure rrc_8(r:preg_z80;reg:pbyte);inline;
procedure rlc_8(r:preg_z80;reg:pbyte);inline;
procedure rr_8(r:preg_z80;reg:pbyte);inline;
procedure rl_8(r:preg_z80;reg:pbyte);inline;
procedure sra_8(r:preg_z80;reg:pbyte);inline;
procedure sla_8(r:preg_z80;reg:pbyte);inline;
procedure sll_8(r:preg_z80;reg:pbyte);inline;
{pila}
procedure push_sp(sp:pparejas;ll:llam_z80;reg:pparejas);inline;
procedure pop_sp(sp:pparejas;ll:llam_z80;reg:pparejas);inline;

implementation
uses z80_dd,z80_ed,z80_cb;

procedure reset_z80(r:preg_z80);
begin
        r.contador:=0;
        r.sp:=$0;
        r.pc:=0;
        r.a:=0;r.bc.w:=0;r.de.w:=0;r.hl.w:=0;
        r.a2:=0;r.bc2.w:=0;r.de2.w:=0;r.hl2.w:=0;
        r.ix.w:=$ffff;
        r.iy.w:=$ffff;
        r.iff1:=false;
        r.iff2:=false;
        r.i:=0;
        r.r:=0;
        r.im:=0;
        r.f.c:=false;r.f.n:=false;r.f.p_v:=false;r.f.bit3:=false;r.f.h:=false;r.f.bit5:=false;r.f.z:=true;r.f.s:=false;
        r.f2.c:=false;r.f2.n:=false;r.f2.p_v:=false;r.f2.bit3:=false;r.f2.h:=false;r.f2.bit5:=false;r.f2.z:=false;r.f2.s:=false;
        r.pedir_nmi:=CLEAR_LINE;
        r.nmi_state:=CLEAR_LINE;
        r.pedir_irq:=CLEAR_LINE;
        r.halt:=false;
        r.im2_lo:=$FF;
        r.im0:=$FF;
        r.opcode:=false;
        r.after_ei:=false;
        r.enabled:=true;
end;

procedure clear_nmi_z80(r:preg_z80);
begin
  r.pedir_nmi:=CLEAR_LINE;
  r.nmi_state:=CLEAR_LINE;
end;

function nmi_z80(r:preg_z80;ll:llam_z80):byte;inline;
begin
nmi_z80:=0;
r.halt:=false;
if r.nmi_state<>CLEAR_LINE then exit;
push_sp(@r.sp,ll,@r.pc);
r.IFF1:=false;
r.pc:=$66;
nmi_z80:=11;
if (r.pedir_nmi=PULSE_LINE) then r.pedir_nmi:=CLEAR_LINE;
if (r.pedir_nmi=ASSERT_LINE) then r.nmi_state:=ASSERT_LINE;
end;

function irq_z80(r:preg_z80;ll:llam_z80):byte;inline;
var
  posicion:parejas;
begin
irq_z80:=0;
r.halt:=false;
if not(r.iff1) then exit; //se esta ejecutando otra
if addr(ll.raised_z80)<>nil then ll.raised_z80;
if r.pedir_irq=HOLD_LINE then r.pedir_irq:=CLEAR_LINE;
push_sp(@r.sp,ll,@r.pc);
r.IFF2:=false;
r.IFF1:=false;
Case r.im of
        0:begin
            if r.daisy then MessageDlg('Mierda!!! Daisy chain en IM0!!', mtInformation,[mbOk], 0);
            case r.im0 of  //hago la intruccion que viene del bus
              $cf:r.pc:=$8;
              $d7:r.pc:=$10;
              $df:r.pc:=$18;
              $e7:r.pc:=$20;
              $ef:r.pc:=$28;
              $f7:r.pc:=$30;
              $ff:r.pc:=$38;
              else MessageDlg('Mierda!!! IM0 desconocido...'+inttostr(r.im0), mtInformation,[mbOk], 0)
            end;
            irq_z80:=13;
          end;
        1:begin
            r.pc:=$38;
            irq_z80:=13;
        end;
        2:begin
            if r.daisy then posicion.l:=z80daisy_ack
              else posicion.l:=r.im2_lo;
            posicion.h:=r.i;
            r.pc:=ll.getbyte(posicion.w)+(ll.getbyte(posicion.w+1) shl 8);
            irq_z80:=19;
        end;
end; {del case}
end;

procedure run_z80(r:preg_z80;ll:llam_z80;maximo:dword);
var
 instruccion,temp:byte;
 posicion:parejas;
 ban_temp:band_z80;
 irq_temp:boolean;
 cantidad_t:word;
begin
irq_temp:=false;
r.contador:=0;
while r.contador<maximo do begin
if not(r.enabled) then begin
  r.contador:=maximo;
  exit;
end;
r.estados_demas:=0;
r.ppc:=r.pc;
if not(r.after_ei) then begin
  if r.pedir_nmi<>CLEAR_LINE then begin
    r.estados_demas:=nmi_z80(r,ll);
  end else begin
      if r.daisy then irq_temp:=z80daisy_state;
      if (irq_temp or (r.pedir_irq<>CLEAR_LINE)) then r.estados_demas:=irq_z80(r,ll);
    end;
end else begin
  r.after_ei:=false;
end;
if not(r.halt) then begin
  r.opcode:=true;
  instruccion:=ll.getbyte(r.pc);
  r.opcode:=false;
  r.pc:=r.pc+1;
  r.r:=((r.r+1) and $7f) or (r.r and $80);
  case instruccion of
        $00,$40,$49,$52,$5b,$64,$6d,$7f:{nop};
        $01:begin {ld BC,nn}
                r.bc.l:=ll.getbyte(r.pc);
                r.bc.h:=ll.getbyte(r.pc+1);
                r.pc:=r.pc+2;
            end;
        $02:ll.putbyte(r.bc.w,r.a);{ld (BC),A}
        $03:r.bc.w:=r.bc.w+1;  {inc BC}
        $04:inc_8(r,@r.bc.h); {inc B}
        $05:dec_8(r,@r.bc.h); {dec B}
        $06:begin {ld B,n}
                r.bc.h:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
            end;
        $07:begin   {rlca}
               r.f.c:=(r.a and $80)<>0;
               if r.f.c then r.a:=((r.a shl 1) or 1)
                  else r.a:=r.a shl 1;
               r.f.bit5:=(r.a and $20)<>0;
               r.f.bit3:=(r.a and 8)<>0;
               r.f.h:=false;
               r.f.n:=false;
            end;
        $08:begin { ex AF,AF'}
                ban_temp:=r.f;
                r.f:=r.f2;
                r.f2:=ban_temp;
                temp:=r.a;
                r.a:=r.a2;
                r.a2:=temp;
            end;
        $09:add_16(r,@r.hl,r.bc.w); {add HL,BC}
        $0a:r.a:=ll.getbyte(r.bc.w); {ld A,(BC)}
        $0b:r.bc.w:=r.bc.w-1;  {dec BC}
        $0c:inc_8(r,@r.bc.l); {inc C}
        $0d:dec_8(r,@r.bc.l); {dec C}
        $0e:begin {ld C,n}
                r.bc.l:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
            end;
        $0f:begin   {rrca}
                r.f.c:=(r.a and 1)<>0;
                if r.f.c then r.a:=((r.a shr 1) or $80)
                    else r.a:=r.a shr 1;
                r.f.bit5:=(r.a and $20) <>0;
                r.f.bit3:=(r.a and 8)<>0;
                r.f.h:=false;
                r.f.n:=false;
            end;
        $10:begin {dnjz (PC+e)}
                r.bc.h:=r.bc.h-1;
                r.pc:=r.pc+1;
                if r.bc.h<>0 then begin
                        temp:=ll.getbyte(r.pc-1);
                        r.pc:=r.pc+shortint(temp);
                        r.estados_demas:=r.estados_demas+5;
                end;
            end;
        $11:begin {ld DE,nn}
                r.de.l:=ll.getbyte(r.pc);
                r.de.h:=ll.getbyte(r.pc+1);
                r.pc:=r.pc+2;
            end;
        $12:ll.putbyte(r.de.w,r.a);  {ld (DE),A}
        $13:r.de.w:=r.de.w+1;  {inc DE}
        $14:inc_8(r,@r.de.h); {inc D}
        $15:dec_8(r,@r.de.h); {dec D}
        $16:begin {ld D,n}
                r.de.h:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
            end;
        $17:begin  {rla}
                r.f.h:=(r.a and $80)<>0;
                if r.f.c then r.a:=((r.a shl 1) or 1)
                    else r.a:=r.a shl 1;
                r.f.bit5:=(r.a and $20)<>0;
                r.f.bit3:=(r.a and 8)<>0;
                r.f.c:=r.f.h;
                r.f.h:=false;
                r.f.n:=false;
            end;
        $18:begin   {jr e}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                r.pc:=r.pc+shortint(temp);
            end;
        $19:add_16(r,@r.hl,r.de.w); {add HL,DE}
        $1a:r.a:=ll.getbyte(r.de.w); {ld A,(DE)}
        $1b:r.de.w:=r.de.w-1;  {dec DE}
        $1c:inc_8(r,@r.de.l); {inc E}
        $1d:dec_8(r,@r.de.l); {dec E}
        $1e:begin {ld E,n}
                r.de.l:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
            end;
        $1f:begin {rra}
                r.f.h:=(r.a and 1)<>0;
                if r.f.c then r.a:=((r.a shr 1) or $80)
                    else r.a:=r.a shr 1;
                r.f.n:=false;
                r.f.c:=r.f.h;
                r.f.h:=false;
                r.f.bit5:=(r.a and $20)<>0;
                r.f.bit3:=(r.a and 8)<>0;
            end;
        $20:begin  {jp NZ,(PC+e)}
                r.pc:=r.pc+1;
                if not(r.f.z) then begin
                        temp:=ll.getbyte(r.pc-1);
                        r.pc:=r.pc+shortint(temp);
                        r.estados_demas:=r.estados_demas+5;
                end;
            end;
        $21:begin {ld HL,nn}
                r.hl.l:=ll.getbyte(r.pc);
                r.hl.h:=ll.getbyte(r.pc+1);
                r.pc:=r.pc+2;
            end;
        $22:begin {ld (nn),HL}
                posicion.l:=ll.getbyte(r.pc);
                posicion.h:=ll.getbyte(r.pc+1);
                r.pc:=r.pc+2;
                ll.putbyte(posicion.w,r.hl.l);
                ll.putbyte(posicion.w+1,r.hl.h);
            end;
        $23:r.hl.w:=r.hl.w+1;  {inc HL}
        $24:inc_8(r,@r.hl.h); {inc H}
        $25:dec_8(r,@r.hl.h); {dec H}
        $26:begin {ld H,n}
                r.hl.h:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
            end;
        $27:begin   {daa}
                temp:=0;
                if (r.f.h or ((r.a and $0f)>9)) then temp:=temp or 6;
                if (r.f.c or (r.a>$9f)) then temp:=temp or $60;
                if ((r.a>$8f) and ((r.a and $0F) > 9)) then temp:=temp or $60;
                if (r.a>$99) then r.f.c:=True;
                if r.f.n then begin
                        r.f.h:=(((r.a and $0f)-(temp and $0f)) and $10)<>0;
                        r.a:=r.a-temp;
                end else begin
                        r.f.h:=(((r.a and $0f)+(temp and $0f)) and $10)<>0;
                        r.a:=r.a+temp;
                end;
                r.f.p_v:=paridad[r.a];
                r.f.s:=(r.a and $80) <>0;
                r.f.z:=(r.a=0);
                r.f.bit5:=(r.a and $20)<>0;
                r.f.bit3:=(r.a and 8)<>0;
            end;
        $28:begin  {jp Z,(PC+e)}
                r.pc:=r.pc+1;
                if r.f.z then begin
                        temp:=ll.getbyte(r.pc-1);
                        r.pc:=r.pc+shortint(temp);
                        r.estados_demas:=r.estados_demas+5;
                end;
            end;
        $29:add_16(r,@r.hl,r.hl.w); {add HL,HL}
        $2a:begin  {ld HL,(nn)}
                posicion.h:=ll.getbyte(r.pc+1);
                posicion.l:=ll.getbyte(r.pc);
                r.pc:=r.pc+2;
                r.hl.l:=ll.getbyte(posicion.w);
                r.hl.h:=ll.getbyte(posicion.w+1);
            end;
        $2b:r.hl.w:=r.hl.w-1;  {dec HL}
        $2c:inc_8(r,@r.hl.l); {inc L}
        $2d:dec_8(r,@r.hl.l); {dec L}
        $2e:begin {ld L,n}
                r.hl.l:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
            end;
        $2f:begin {cpl}
                r.a:=r.a xor $FF;
                r.f.bit5:=(r.a and $20)<>0;
                r.f.bit3:=(r.a and 8)<>0;
                r.f.h:=true;
                r.f.n:=true;
            end;
        $30:begin  {jp NC,(PC+e)}
                r.pc:=r.pc+1;
                if not(r.f.c) then begin
                        temp:=ll.getbyte(r.pc-1);
                        r.pc:=r.pc+shortint(temp);
                        r.estados_demas:=r.estados_demas+5;
                end;
            end;
        $31:begin {ld SP,nn}
                r.sp:=ll.getbyte(r.pc)+(ll.getbyte(r.pc+1) shl 8);
                r.pc:=r.pc+2;
            end;
        $32:begin {ld (nn),A}
                posicion.h:=ll.getbyte(r.pc+1);
                posicion.l:=ll.getbyte(r.pc);
                r.pc:=r.pc+2;
                ll.putbyte(posicion.w,r.a);
            end;
        $33:r.sp:=r.sp+1;  {inc SP}
        $34:begin  {inc (HL)}
                temp:=ll.getbyte(r.hl.w);
                inc_8(r,@temp);
                ll.putbyte(r.hl.w,temp);
            end;
        $35:begin  {dec (HL)}
                temp:=ll.getbyte(r.hl.w);
                dec_8(r,@temp);
                ll.putbyte(r.hl.w,temp);
            end;
        $36:begin {ld (HL),n}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                ll.putbyte(r.hl.w,temp);
            end;
        $37:begin  {scf}
                r.f.bit5:=(r.a and $20)<>0;
                r.f.bit3:=(r.a and 8)<>0;
                r.f.c:=true;
                r.f.h:=false;
                r.f.n:=false;
            end;
        $38:begin  {jp C,(PC+e)}
                r.pc:=r.pc+1;
                if r.f.c then begin
                        temp:=ll.getbyte(r.pc-1);
                        r.pc:=r.pc+shortint(temp);
                        r.estados_demas:=r.estados_demas+5;
                end;
            end;
        $39:add_16(r,@r.hl,r.sp); {add HL,SP}
        $3a:begin {ld A,(nn)}
                posicion.h:=ll.getbyte(r.pc+1);
                posicion.l:=ll.getbyte(r.pc);
                r.pc:=r.pc+2;
                r.a:=ll.getbyte(posicion.w);
            end;
        $3b:r.sp:=r.sp-1;  {dec SP}
        $3c:inc_8(r,@r.a); {inc A}
        $3d:dec_8(r,@r.a); {dec A}
        $3e:begin {ld A,n}
                r.a:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
            end;
        $3f:begin   {ccf}
                r.f.bit5:=(r.a and $20)<>0;
                r.f.bit3:=(r.a and 8)<>0;
                r.f.h:=r.f.c;
                r.f.n:=false;
                r.f.c:=not(r.f.c);
            end;
        {'$'40: igual que el nop ld B,B}
        $41:r.bc.h:=r.bc.l; {ld B,C}
        $42:r.bc.h:=r.de.h; {ld B,D}
        $43:r.bc.h:=r.de.l; {ld B,E}
        $44:r.bc.h:=r.hl.h; {ld B,H}
        $45:r.bc.h:=r.hl.l; {ld B,L}
        $46:r.bc.h:=ll.getbyte(r.hl.w); {ld B,(HL)}
        $47:r.bc.h:=r.a; {ld B,A}
        $48:r.bc.l:=r.bc.h; {ld C,B}
        {'$'49: igual que el nop ld C,C}
        $4a:r.bc.l:=r.de.h; {ld C,D}
        $4b:r.bc.l:=r.de.l; {ld C,E}
        $4c:r.bc.l:=r.hl.h; {ld C,H}
        $4d:r.bc.l:=r.hl.l; {ld C,L}
        $4e:r.bc.l:=ll.getbyte(r.hl.w); {ld C,(HL)}
        $4f:r.bc.l:=r.a; {ld C,A}
        $50:r.de.h:=r.bc.h; {ld D,B}
        $51:r.de.h:=r.bc.l; {ld D,C}
        {'$'52 igual que el nop ld D,D}
        $53:r.de.h:=r.de.l; {ld D,E}
        $54:r.de.h:=r.hl.h; {ld D,H}
        $55:r.de.h:=r.hl.l; {ld D,L}
        $56:r.de.h:=ll.getbyte(r.hl.w); {ld D,(HL)}
        $57:r.de.h:=r.a; {ld D,A}
        $58:r.de.l:=r.bc.h; {ld E,B}
        $59:r.de.l:=r.bc.l; {ld E,C}
        $5a:r.de.l:=r.de.h; {ld E,D}
        {'$'5b igual que el nop ld E,E}
        $5c:r.de.l:=r.hl.h; {ld E,H}
        $5d:r.de.l:=r.hl.l; {ld E,L}
        $5e:r.de.l:=ll.getbyte(r.hl.w); {ld E,(HL)}
        $5f:r.de.l:=r.a; {ld E,A}
        $60:r.hl.h:=r.bc.h; {ld H,B}
        $61:r.hl.h:=r.bc.l; {ld H,C}
        $62:r.hl.h:=r.de.h; {ld H,D}
        $63:r.hl.h:=r.de.l; {ld H,E}
        {'$'64: igual que el nop ld H,H}
        $65:r.hl.h:=r.hl.l; {ld H,L}
        $66:r.hl.h:=ll.getbyte(r.hl.w); {ld H,(HL)}
        $67:r.hl.h:=r.a; {ld H,A}
        $68:r.hl.l:=r.bc.h; {ld L,B}
        $69:r.hl.l:=r.bc.l; {ld L,C}
        $6a:r.hl.l:=r.de.h; {ld L,D}
        $6b:r.hl.l:=r.de.l; {ld L,E}
        $6c:r.hl.l:=r.hl.h; {ld L,H}
        {'$'6d: igual que el nop ld L,L}
        $6e:r.hl.l:=ll.getbyte(r.hl.w); {ld L,(HL)}
        $6f:r.hl.l:=r.a; {ld L,A}
        $70:ll.putbyte(r.hl.w,r.bc.h); {ld (HL),B}
        $71:ll.putbyte(r.hl.w,r.bc.l); {ld (HL),C}
        $72:ll.putbyte(r.hl.w,r.de.h); {ld (HL),D}
        $73:ll.putbyte(r.hl.w,r.de.l); {ld (HL),E}
        $74:ll.putbyte(r.hl.w,r.hl.h); {ld (HL),H}
        $75:ll.putbyte(r.hl.w,r.hl.l); {ld (HL),L}
        $76:r.halt:=true; {halt}
        $77:ll.putbyte(r.hl.w,r.a); {ld (HL),A}
        $78:r.a:=r.bc.h; {ld A,B}
        $79:r.a:=r.bc.l; {ld A,C}
        $7a:r.a:=r.de.h; {ld A,D}
        $7b:r.a:=r.de.l; {ld A,E}
        $7c:r.a:=r.hl.h; {ld A,H}
        $7d:r.a:=r.hl.l; {ld A,L}
        $7e:r.a:=ll.getbyte(r.hl.w); {ld A,(HL)}
        {'$'7f: igual que el nop ld A,A}
        $80:add_8(r,r.bc.h); {add A,B}
        $81:add_8(r,r.bc.l); {add A,C}
        $82:add_8(r,r.de.h); {add A,D}
        $83:add_8(r,r.de.l); {add A,E}
        $84:add_8(r,r.hl.h); {add A,H}
        $85:add_8(r,r.hl.l); {add A,L}
        $86:add_8(r,ll.getbyte(r.hl.w));  {add A,(HL)}
        $87:add_8(r,r.a); {add A,A}
        $88:adc_8(r,r.bc.h); {adc A,B}
        $89:adc_8(r,r.bc.l); {adc A,C}
        $8a:adc_8(r,r.de.h); {adc A,D}
        $8b:adc_8(r,r.de.l); {adc A,E}
        $8c:adc_8(r,r.hl.h); {adc A,H}
        $8d:adc_8(r,r.hl.l); {adc A,L}
        $8e:adc_8(r,ll.getbyte(r.hl.w)); {adc A,(HL)}
        $8f:adc_8(r,r.a); {adc A,A}
        $90:sub_8(r,r.bc.h); {sub B}
        $91:sub_8(r,r.bc.l); {sub C}
        $92:sub_8(r,r.de.h); {sub D}
        $93:sub_8(r,r.de.l); {sub E}
        $94:sub_8(r,r.hl.h); {sub H}
        $95:sub_8(r,r.hl.l); {sub L}
        $96:sub_8(r,ll.getbyte(r.hl.w));  {sub (HL)}
        $97:sub_8(r,r.a); {sub A}
        $98:sbc_8(r,r.bc.h); {sbc A,B}
        $99:sbc_8(r,r.bc.l); {sbc A,C}
        $9a:sbc_8(r,r.de.h); {sbc A,D}
        $9b:sbc_8(r,r.de.l); {sbc A,E}
        $9c:sbc_8(r,r.hl.h); {sbc A,H}
        $9d:sbc_8(r,r.hl.l); {sbc A,L}
        $9e:sbc_8(r,ll.getbyte(r.hl.w)); {sbc A,(HL)}
        $9f:sbc_8(r,r.a); {sbc A,A}
        $a0:and_a(r,r.bc.h);  {and A,B}
        $a1:and_a(r,r.bc.l);  {and A,C}
        $a2:and_a(r,r.de.h);  {and A,D}
        $a3:and_a(r,r.de.l); {and A,E}
        $a4:and_a(r,r.hl.h); {and A,H}
        $a5:and_a(r,r.hl.l); {and A,L}
        $a6:and_a(r,ll.getbyte(r.hl.w)); {and A,(HL)}
        $a7:and_a(r,r.a); {and A,A}
        $a8:xor_a(r,r.bc.h); {xor A,B}
        $a9:xor_a(r,r.bc.l); {xor A,C}
        $aa:xor_a(r,r.de.h); {xor A,D}
        $ab:xor_a(r,r.de.l); {xor A,E}
        $ac:xor_a(r,r.hl.h); {xor A,H}
        $ad:xor_a(r,r.hl.l); {xor A,L}
        $ae:xor_a(r,ll.getbyte(r.hl.w)); {xor A,(HL)}
        $af:begin {xor A,A}
                r.a:=0;
                r.f.s:=false;
                r.f.z:=true;
                r.f.bit5:=false;
                r.f.h:=false;
                r.f.bit3:=false;
                r.f.p_v:=true;
                r.f.n:=false;
                r.f.c:=false;
             end;
        $b0:or_a(r,r.bc.h); {or B}
        $b1:or_a(r,r.bc.l); {or C}
        $b2:or_a(r,r.de.h); {or D}
        $b3:or_a(r,r.de.l); {or E}
        $b4:or_a(r,r.hl.h); {or H}
        $b5:or_a(r,r.hl.l); {or L}
        $b6:or_a(r,ll.getbyte(r.hl.w));   {or (HL)}
        $b7:or_a(r,r.a); {or A}
        $b8:cp_a(r,r.bc.h); {cp B}
        $b9:cp_a(r,r.bc.l); {cp C}
        $ba:cp_a(r,r.de.h); {cp D}
        $bb:cp_a(r,r.de.l); {cp E}
        $bc:cp_a(r,r.hl.h); {cp H}
        $bd:cp_a(r,r.hl.l); {cp L}
        $be:cp_a(r,ll.getbyte(r.hl.w)); {cp (HL)}
        $bf:cp_a(r,r.a); {cp A}
        $c0:if not(r.f.z) then begin {ret NZ}
                pop_sp(@r.sp,ll,@r.pc);
                r.estados_demas:=r.estados_demas+6;
             end;
        $c1:pop_sp(@r.sp,ll,@r.bc);  {pop BC}
        $c2:if not(r.f.z) then begin {jp NZ,nn}
                        posicion.h:=ll.getbyte(r.pc+1);
                        posicion.l:=ll.getbyte(r.pc);
                        r.pc:=posicion.w;
            end else r.pc:=r.pc+2;
        $c3:begin {jp nn}
                posicion.h:=ll.getbyte(r.pc+1);
                posicion.l:=ll.getbyte(r.pc);
                r.pc:=posicion.w;
             end;
        $c4:begin   {call NZ,nn}
                r.pc:=r.pc+2;
                if not(r.f.z) then begin
                        push_sp(@r.sp,ll,@r.pc);
                        posicion.h:=ll.getbyte(r.pc-1);
                        posicion.l:=ll.getbyte(r.pc-2);
                        r.pc:=posicion.w;
                        r.estados_demas:=r.estados_demas+7;
                end;
             end;
        $c5:push_sp(@r.sp,ll,@r.bc);  {push BC}
        $c6:begin {add A,n}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                add_8(r,temp);
             end;
        $c7:begin  {rst 00H}
                push_sp(@r.sp,ll,@r.pc);
                r.pc:=0;
             end;
        $c8:if r.f.z then begin {ret Z}
                pop_sp(@r.sp,ll,@r.pc);
                r.estados_demas:=r.estados_demas+6;
             end;
        $c9:pop_sp(@r.sp,ll,@r.pc);  {ret}
        $ca:if r.f.z then begin {jp Z,nn}
                posicion.h:=ll.getbyte(r.pc+1);
                posicion.l:=ll.getbyte(r.pc);
                r.pc:=posicion.w;
            end else r.pc:=r.pc+2;
        $cb:r.estados_demas:=r.estados_demas+exec_cb(r,ll);
        $cc:begin   {call Z,nn}
                r.pc:=r.pc+2;
                if r.f.z then begin
                        push_sp(@r.sp,ll,@r.pc);
                        posicion.h:=ll.getbyte(r.pc-1);
                        posicion.l:=ll.getbyte(r.pc-2);
                        r.pc:=posicion.w;
                        r.estados_demas:=r.estados_demas+7;
                end;
             end;
        $cd:begin   {call nn}
                posicion.h:=ll.getbyte(r.pc+1);
                posicion.l:=ll.getbyte(r.pc);
                r.pc:=r.pc+2;
                push_sp(@r.sp,ll,@r.pc);
                r.pc:=posicion.w;
             end;
        $ce:begin   {adc A,n}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                adc_8(r,temp);
             end;
        $cf:begin  {rst 08H}
                push_sp(@r.sp,ll,@r.pc);
                r.pc:=$8;
             end;
        $d0:if not(r.f.c) then begin {ret NC}
                pop_sp(@r.sp,ll,@r.pc);
                r.estados_demas:=r.estados_demas+6;
             end;
        $d1:pop_sp(@r.sp,ll,@r.de);  {pop DE}
        $d2:if not(r.f.c) then begin {jp NC,nn}
                posicion.h:=ll.getbyte(r.pc+1);
                posicion.l:=ll.getbyte(r.pc);
                r.pc:=posicion.w;
             end else r.pc:=r.pc+2;
        $d3:begin {out (n),A}
                posicion.l:=ll.getbyte(r.pc);
                posicion.h:=r.a;
                r.pc:=r.pc+1;
                if addr(ll.outbyte)<>nil then ll.outbyte(r.a,posicion.w);
             end;
        $d4:begin   {call NC,nn}
                r.pc:=r.pc+2;
                if not(r.f.c) then begin
                        push_sp(@r.sp,ll,@r.pc);
                        posicion.h:=ll.getbyte(r.pc-1);
                        posicion.l:=ll.getbyte(r.pc-2);
                        r.pc:=posicion.w;
                        r.estados_demas:=r.estados_demas+7;
                end;
             end;
        $d5:push_sp(@r.sp,ll,@r.de);  {push DE}
        $d6:begin {sub n}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                sub_8(r,temp);
             end;
        $d7:begin  {rst 10H}
                push_sp(@r.sp,ll,@r.pc);
                r.pc:=$10;
             end;
        $d8:if r.f.c then begin {ret C}
                pop_sp(@r.sp,ll,@r.pc);
                r.estados_demas:=r.estados_demas+6;
             end;
        $d9:begin {exx}
                posicion:=r.bc;
                r.bc:=r.bc2;
                r.bc2:=posicion;
                posicion:=r.de;
                r.de:=r.de2;
                r.de2:=posicion;
                posicion:=r.hl;
                r.hl:=r.hl2;
                r.hl2:=posicion;
             end;
        $da:if r.f.c then begin {jp C,nn}
                posicion.h:=ll.getbyte(r.pc+1);
                posicion.l:=ll.getbyte(r.pc);
                r.pc:=posicion.w;
            end else r.pc:=r.pc+2;
        $db:begin  {in A,(n)}
             posicion.l:=ll.getbyte(r.pc);
             r.pc:=r.pc+1;
             posicion.h:=r.a;
             if addr(ll.inbyte)<>nil then r.a:=ll.inbyte(posicion.w)
              else r.a:=$ff;
             end;
        $dc:begin   {call C,nn}
                r.pc:=r.pc+2;
                if r.f.c then begin
                        push_sp(@r.sp,ll,@r.pc);
                        posicion.h:=ll.getbyte(r.pc-1);
                        posicion.l:=ll.getbyte(r.pc-2);
                        r.pc:=posicion.w;
                        r.estados_demas:=r.estados_demas+7;
                end;
             end;
        $dd:r.estados_demas:=r.estados_demas+exec_dd_fd(r,ll,true);
        $de:begin {sbc A,n}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                sbc_8(r,temp);
            end;
        $df:begin  {rst 18H}
                push_sp(@r.sp,ll,@r.pc);
                r.pc:=$18;
             end;
        $e0:if not(r.f.p_v) then begin {ret PO}
                pop_sp(@r.sp,ll,@r.pc);
                r.estados_demas:=r.estados_demas+6;
             end;
        $e1:pop_sp(@r.sp,ll,@r.hl);  {pop HL}
        $e2:if not(r.f.p_v) then begin {jp PO,nn}
                posicion.h:=ll.getbyte(r.pc+1);
                posicion.l:=ll.getbyte(r.pc);
                r.pc:=posicion.w;
            end else r.pc:=r.pc+2;
        $e3:begin   {ex (sp),hl}
                pop_sp(@r.sp,ll,@posicion);
                push_sp(@r.sp,ll,@r.hl);
                r.hl:=posicion;
             end;
        $e4:begin   {call PO,nn}
                r.pc:=r.pc+2;
                if not(r.f.p_v) then begin
                        push_sp(@r.sp,ll,@r.pc);
                        posicion.h:=ll.getbyte(r.pc-1);
                        posicion.l:=ll.getbyte(r.pc-2);
                        r.pc:=posicion.w;
                        r.estados_demas:=r.estados_demas+7;
                end;
             end;
        $e5:push_sp(@r.sp,ll,@r.hl);  {push HL}
        $e6:begin {and A,n}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                and_a(r,temp);
             end;
        $e7:begin  {rst 20H}
                push_sp(@r.sp,ll,@r.pc);
                r.pc:=$20;
             end;
        $e8:if r.f.p_v then begin {ret PE}
                pop_sp(@r.sp,ll,@r.pc);
                r.estados_demas:=r.estados_demas+6;
             end;
        $e9:r.pc:=r.hl.w; {jp (HL)}
        $ea:if r.f.p_v then begin {jp PE,nn}
                posicion.h:=ll.getbyte(r.pc+1);
                posicion.l:=ll.getbyte(r.pc);
                r.pc:=posicion.w;
            end else r.pc:=r.pc+2;
        $eb:begin { ex DE,HL}
                posicion:=r.de;
                r.de:=r.hl;
                r.hl:=posicion;
             end;
        $ec:begin   {call PE,nn}
                r.pc:=r.pc+2;
                if r.f.p_v then begin
                        push_sp(@r.sp,ll,@r.pc);
                        posicion.h:=ll.getbyte(r.pc-1);
                        posicion.l:=ll.getbyte(r.pc-2);
                        r.pc:=posicion.w;
                        r.estados_demas:=r.estados_demas+7;
                end;
             end;
        $ed:r.estados_demas:=r.estados_demas+exec_ed(r,ll);
        $ee:begin  {xor A,n}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                xor_a (r,temp);
              end;
        $ef:begin  {rst 28H}
                push_sp(@r.sp,ll,@r.pc);
                r.pc:=$28;
             end;
        $f0:if not(r.f.s) then begin {ret NP}
                pop_sp(@r.sp,ll,@r.pc);
                r.estados_demas:=r.estados_demas+6;
             end;
        $f1:begin  {pop AF}
                pop_sp(@r.sp,ll,@posicion);
                r.a:=posicion.h;
                if (posicion.l and 128)<>0 then r.f.s:=true else r.f.s:=false;
                if (posicion.l and 64)<>0 then r.f.z:=true else r.f.z:=false;
                if (posicion.l and 32)<>0 then r.f.bit5:=true else r.f.bit5:=false;
                if (posicion.l and 16)<>0 then r.f.h:=true else r.f.h:=false;
                if (posicion.l and 8)<>0 then r.f.bit3:=true else r.f.bit3:=false;
                if (posicion.l and 4)<>0 then r.f.p_v:=true else r.f.p_v:=false;
                if (posicion.l and 2)<>0 then r.f.n:=true else r.f.n:=false;
                if (posicion.l and 1)<>0 then r.f.c:=true else r.f.c:=false;
                end;
        $f2:if not(r.f.s) then begin {jp P,nn}
                posicion.h:=ll.getbyte(r.pc+1);
                posicion.l:=ll.getbyte(r.pc);
                r.pc:=posicion.w;
             end else r.pc:=r.pc+2;
        $f3:begin {di}
                r.iff1:=false;
                r.iff2:=false;
              end;
        $f4:begin   {call P,nn}
                r.pc:=r.pc+2;
                if not(r.f.s) then begin
                        push_sp(@r.sp,ll,@r.pc);
                        posicion.h:=ll.getbyte(r.pc-1);
                        posicion.l:=ll.getbyte(r.pc-2);
                        r.pc:=posicion.w;
                        r.estados_demas:=r.estados_demas+7;
                end;
             end;
        $f5:begin  {push AF}
                posicion.h:=r.a;
                posicion.l:=0;
                if r.f.s then posicion.l:=posicion.l or $80;
                if r.f.z then posicion.l:=posicion.l or $40;
                if r.f.bit5 then posicion.l:=posicion.l or $20;
                if r.f.h then posicion.l:=posicion.l or $10;
                if r.f.bit3 then posicion.l:=posicion.l or 8;
                if r.f.p_v then posicion.l:=posicion.l or 4;
                if r.f.n then posicion.l:=posicion.l or 2;
                if r.f.c then posicion.l:=posicion.l or 1;
                push_sp(@r.sp,ll,@posicion);
             end;
        $f6:begin {or n}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                or_a(r,temp);
             end;
        $f7:begin  {rst 30H}
                push_sp(@r.sp,ll,@r.pc);
                r.pc:=$30;
             end;
        $f8:if r.f.s then begin {ret M}
                pop_sp(@r.sp,ll,@r.pc);
                r.estados_demas:=r.estados_demas+6;
             end;
        $f9:r.sp:=r.hl.w; {ld SP,HL}
        $fa:if r.f.s then begin {jp M,nn}
                posicion.h:=ll.getbyte(r.pc+1);
                posicion.l:=ll.getbyte(r.pc);
                r.pc:=posicion.w;
            end else r.pc:=r.pc+2;
        $fb:begin   {ei}
                r.iff1:=true;
                r.iff2:=true;
                r.after_ei:=true;
             end;
        $fc:begin   {call M,nn}
                r.pc:=r.pc+2;
                if r.f.s then begin
                        push_sp(@r.sp,ll,@r.pc);
                        posicion.h:=ll.getbyte(r.pc-1);
                        posicion.l:=ll.getbyte(r.pc-2);
                        r.pc:=posicion.w;
                        r.estados_demas:=r.estados_demas+7;
                end;
             end;
        $fd:r.estados_demas:=r.estados_demas+exec_dd_fd(r,ll,false);
        $fe:begin  {cp n}
                temp:=ll.getbyte(r.pc);
                r.pc:=r.pc+1;
                cp_a(r,temp);
            end;
        $ff:begin  {rst 38H}
                push_sp(@r.sp,ll,@r.pc);
                r.pc:=$38;
             end;
  end; {del case}
  cantidad_t:=z80t[instruccion]+r.estados_demas;
  if addr(ll.despues_instruccion)<>nil then ll.despues_instruccion(cantidad_t);
  r.contador:=r.contador+cantidad_t;
  update_timer(cantidad_t,r.numero_cpu);
end else begin
  if addr(ll.despues_instruccion)<>nil then ll.despues_instruccion(4);
  r.contador:=r.contador+4;
  update_timer(4,r.numero_cpu);
end;
end; {del while}
end;

procedure add_8(r:preg_z80;valor:byte);inline;
var
        temp:byte;
begin
 temp:=r.a+valor;
 r.f.p_v:=(((r.a Xor (Not (valor))) And $0ffff) And (r.a Xor temp) And $80) <> 0;
 r.f.h :=(((r.a And 15) + (valor And 15)) And 16) <> 0;
 r.f.s:= (temp and $80) <>0;
 r.f.z:=(temp=0);
 r.f.bit5:=(temp and $20) <>0;
 r.f.bit3:=(temp and 8) <>0;
 r.f.n:=false;
 r.f.c:=((r.a+valor) and $100)<>0;
 r.a:=temp;
end;

procedure adc_8(r:preg_z80;valor:byte);inline;
var
        carry:byte;
        temp:byte;
begin
 if r.f.c then carry:=1 else carry:=0;
 temp:=r.a+valor+carry;
 r.f.p_v := (((r.a Xor (Not valor)) And $0ffff) And ((r.a Xor temp) And 128)) <> 0;
 r.f.h := (((r.a And 15) + (valor And 15) + carry) And 16) <> 0;
 r.f.s:= (temp and $80) <>0; {modificar signo}
 r.f.z:=(temp=0); {modificar si es zero}
 r.f.bit5:=(temp and 32) <>0;
 r.f.bit3:=(temp and 8) <>0;
 r.f.n:=false; {la bandera de suma}
 r.f.c:=((r.a+valor+carry) and $100)<>0;       {modificar carry}
 r.a:=temp;
end;

procedure sub_8(r:preg_z80;valor:byte);inline;
var
        temp,temp2:integer;
begin
 temp2:=r.a-valor;
 temp:=temp2 and $FF;
 r.f.h:=(((r.a and $0f) - (valor and $0f)) and $10) <> 0;
 r.f.p_v:=(((r.a xor valor) and (r.a xor temp)) and 128) <>0; {desbordamiento}
 r.f.s:= (temp and $80) <>0; {modificar signo}
 r.f.z:=(temp=0); {modificar si es zero}
 r.f.bit5:=(temp and 32) <>0;
 r.f.bit3:=(temp and 8) <> 0;
 r.f.n:=true; {la bandera de resta}
 r.f.c:=(temp2 and $100)<>0;  {carry}
 r.a:=temp;
end;

procedure sbc_8(r:preg_z80;valor:byte);inline;
var
        carry,temp:byte;
begin
 if r.f.c then carry:=1 else carry:=0;
 temp:=r.a-valor-carry;
 r.f.h:=(((r.a and $0f) - (valor and $0f) - carry) and $10) <> 0;
 r.f.p_v:=(((r.a xor valor) and (r.a xor temp)) and $80) <>0; {desbordamiento}
 r.f.s:= (temp and $80) <>0; {modificar signo}
 r.f.z:=(temp=0); {modificar si es zero}
 r.f.bit5:=(temp and $20) <>0;
 r.f.bit3:=(temp and 8) <>0;
 r.f.n:=true; {la bandera de resta}
 r.f.c:=((r.a-valor-carry) and $100)<>0;       {modificar carry}
 r.a:=temp;
end;

procedure dec_8(r:preg_z80;reg:pbyte);inline;
begin
 r.f.h:=(((reg^ and $0F) -1) and $10) <> 0; {bit de signo nibble}
 r.f.p_v:=(reg^=128); {desbordamiento}
 reg^:=reg^-1;
 r.f.s:= (reg^ and 128) <>0; {modificar signo}
 r.f.z:=(reg^=0); {modificar si es zero}
 r.f.bit5:=(reg^ and 32) <> 0;
 r.f.bit3:=(reg^ and 8) <> 0;
 r.f.n:=true; {la bandera de resta}
end;

procedure inc_8(r:preg_z80;reg:pbyte);inline;
begin
 r.f.h:=(((reg^ and $0F) +1) and $10) <> 0; {bit de signo nibble}
 r.f.p_v:=(reg^=127); {desbordamiento}
 reg^:=reg^+1;
 r.f.s:= (reg^ and $80) <>0; {modificar signo}
 r.f.z:=(reg^=0); {modificar si es zero}
 r.f.bit5:=(reg^ and $20) <> 0;
 r.f.bit3:=(reg^ and 8) <> 0;
 r.f.n:=false; {la bandera de suma}
end;

procedure add_16(r:preg_z80;reg:pparejas;valor:word);inline;
var
        temp:word;
begin
    temp:= reg^.w + valor;
    r.f.bit3:=(temp And $800) <> 0;
    r.f.bit5:=(temp And $2000) <> 0;
    r.f.c:=((reg^.w + valor) And $10000) <> 0;
    r.f.h:=(((reg^.w And $0FFF) + (valor And $0FFF)) And $1000) <> 0;
    r.f.n:=False;
    reg^.w:=temp;
end;

procedure and_a(r:preg_z80;valor:byte);inline;
begin
 r.a:=r.a and valor;
 r.f.s:= (r.a and $80) <> 0; {modificar signo}
 r.f.z:=(r.a=0); {modificar si es zero}
 r.f.bit5:=(r.a and $20) <> 0;
 r.f.h:=true; {bit de signo nibble}
 r.f.bit3:=(r.a and 8) <> 0;
 r.f.p_v:=paridad[r.a]; {modificar si paridad}
 r.f.n:=false; {la bandera de suma}
 r.f.c:=false; {modificar carry}
end;

procedure or_a(r:preg_z80;valor:byte);inline;
begin
 r.a:=r.a or valor;
 r.f.s:=(r.a and $80) <> 0; {modificar signo}
 r.f.z:=(r.a=0); {modificar si es zero}
 r.f.bit5:=(r.a and $20) <> 0;
 r.f.h:=false; {bit de signo nibble}
 r.f.bit3:=(r.a and 8) <> 0;
 r.f.p_v:=paridad[r.a]; {modificar si paridad}
 r.f.n:=false; {la bandera de suma}
 r.f.c:=false; {modificar carry}
end;

procedure xor_a(r:preg_z80;valor:byte);inline;
begin
 r.a:=r.a xor valor;
 r.f.s:=(r.a and $80)<>0; {modificar signo}
 r.f.z:=(r.a=0); {modificar si es zero}
 r.f.bit5:=(r.a and $20) <> 0;
 r.f.h:= false; {bit de signo nibble}
 r.f.bit3:=(r.a and 8) <> 0 ;
 r.f.p_v:=paridad[r.a]; {modificar si paridad}
 r.f.n:=false; {la bandera de suma}
 r.f.c:=false; {modificar carry}
end;

procedure rlc_8(r:preg_z80;reg:pbyte);inline; ///OK 100%
begin
 r.f.c:=(reg^ and $80)<>0;
 if r.f.c then reg^:=((reg^ shl 1) or 1) else reg^:=reg^ shl 1;
 r.f.bit5:=(reg^ and $20)<>0;
 r.f.bit3:=(reg^ and 8)<>0;
 r.f.p_v:=paridad[reg^];
 r.f.h:=false;
 r.f.n:=false;
 r.f.z:=(reg^=0);
 r.f.s:=(reg^ and $80)<>0;
end;

procedure srl_8(r:preg_z80;reg:pbyte);inline;
begin
 r.f.h:=false;
 r.f.n:=false;
 r.f.c:=(reg^ and 1)<>0;
 reg^:=reg^ shr 1;
 r.f.bit5:=(reg^ and $20)<>0;
 r.f.bit3:=(reg^ and 8)<>0;
 r.f.p_v:=paridad[reg^];
 r.f.z:=(reg^=0);
 r.f.s:=(reg^ and $80)<>0;
end;

procedure rr_8(r:preg_z80;reg:pbyte);inline;
begin
 r.f.n:=r.f.c;
 r.f.c:=(reg^ and 1)<>0;
 if r.f.n then reg^:=((reg^ shr 1) or $80) else reg^:=(reg^ shr 1);
 r.f.h:=false;
 r.f.n:=false;
 r.f.p_v:=paridad[reg^];
 r.f.s:=(reg^ and $80)<>0;
 r.f.z:=(reg^=0);
 r.f.bit5:=(reg^ and $20)<>0;
 r.f.bit3:=(reg^ and 8)<>0;
end;

procedure rrc_8(r:preg_z80;reg:pbyte);inline; /// OK 100%
begin
 r.f.c:=(reg^ and $1)<>0;
 if r.f.c then reg^:=((reg^ shr 1) or $80) else reg^:=(reg^ shr 1);
 r.f.bit5:=(reg^ and $20)<>0;
 r.f.bit3:=(reg^ and 8)<>0;
 r.f.p_v:=paridad[reg^];
 r.f.h:=false;
 r.f.n:=false;
 r.f.z:=(reg^=0);
 r.f.s:=(reg^ and $80)<>0;
end;

procedure rl_8(r:preg_z80;reg:pbyte);inline;
begin
 r.f.n:=r.f.c;
 r.f.c:=(reg^ and $80)<>0;
 if r.f.n then reg^:=((reg^ shl 1) or 1) else reg^:=reg^ shl 1;
 r.f.h:=false;
 r.f.n:=false;
 r.f.p_v:=paridad[reg^];
 r.f.s:=(reg^ and $80)<>0;
 r.f.z:=(reg^=0);
 r.f.bit5:=(reg^ and $20)<>0;
 r.f.bit3:=(reg^ and 8)<>0;
end;

procedure sra_8(r:preg_z80;reg:pbyte);inline;  // OK 100%
begin
 r.f.c:=(reg^ and $1)<>0;
 reg^:=(reg^ shr 1) or (reg^ and $80);
 r.f.h:=false;
 r.f.n:=false;
 r.f.p_v:=paridad[reg^];
 r.f.s:=(reg^ and $80)<>0;
 r.f.z:=(reg^=0);
 r.f.bit5:=(reg^ and $20)<>0;
 r.f.bit3:=(reg^ and 8)<>0;
end;

procedure sla_8(r:preg_z80;reg:pbyte);inline;
begin
 r.f.c:=(reg^ and $80)<>0;
 reg^:=reg^ shl 1;
 r.f.h:=false;
 r.f.n:=false;
 r.f.p_v:=paridad[reg^];
 r.f.s:=(reg^ and $80)<>0;
 r.f.z:=(reg^=0);
 r.f.bit5:=(reg^ and $20)<>0;
 r.f.bit3:=(reg^ and 8)<>0;
end;

procedure sll_8(r:preg_z80;reg:pbyte);inline;
begin
 r.f.c:=(reg^ and $80)<>0;
 reg^:=(reg^ shl 1) or 1;
 r.f.h:=false;
 r.f.n:=false;
 r.f.p_v:=paridad[reg^];
 r.f.s:=(reg^ and $80)<>0;
 r.f.z:=(reg^=0);
 r.f.bit5:=(reg^ and $20)<>0;
 r.f.bit3:=(reg^ and 8)<>0;
end;

procedure cp_a(r:preg_z80;valor:byte);inline;
var
        temp:byte;
begin
 temp:=r.a-valor;
 r.f.s:=(temp and $80) <>0; {modificar signo}
 r.f.z:=(temp=0); {modificar si es zero}
 r.f.bit5:=(valor and $20)<>0;
 r.f.h:=(((r.a and $0F) - (valor and $0F)) and $10) <> 0;
 r.f.bit3:=(valor and 8)<>0;
 r.f.p_v:=((r.a xor valor) and (r.a xor temp) and $80) <>0; {desbordamiento}
 r.f.n:=true; {la bandera de resta}
 r.f.c:=(r.a-valor)<0;  {carry}
end;

procedure push_sp(sp:pparejas;ll:llam_z80;reg:pparejas);inline;
begin
sp.w:=sp.w-2;
ll.putbyte(sp.w+1,reg.h);
ll.putbyte(sp.w,reg.l);
end;

procedure pop_sp(sp:pparejas;ll:llam_z80;reg:pparejas);inline;
begin
reg.l:=ll.getbyte(sp.w);
reg.h:=ll.getbyte(sp.w+1);
sp.w:=sp.w+2;
end;

end.

