unit z80_sp;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}main_engine,z80,z80daisy;

type
 tipo_retraso=record
              retraso: procedure(direccion:word);
              retraso_puerto: function(direccion:word):byte;
              end;

procedure run_z80_sp(r:preg_z80;ll:llam_z80;maximo:dword);
procedure spec_putbyte(posicion:word;valor:byte;r:preg_z80;ll:llam_z80);
function spec_getbyte(posicion:word;r:preg_z80;ll:llam_z80):byte;
procedure spec_outbyte(valor:byte;posicion:word;r:preg_z80;ll:llam_z80);
function spec_inbyte(posicion:word;r:preg_z80;ll:llam_z80):byte;

implementation
uses z80_dd_sp,z80_ed_sp,z80_cb_sp,spectrum_misc;

procedure spec_outbyte(valor:byte;posicion:word;r:preg_z80;ll:llam_z80);
var
  estados:byte;
begin
ll.outbyte(valor,posicion);
estados:=spec_retraso.retraso_puerto(posicion);
inc(r.contador,estados);
end;

function spec_inbyte(posicion:word;r:preg_z80;ll:llam_z80):byte;
var
  estados:byte;
begin
spec_inbyte:=ll.inbyte(posicion);
estados:=spec_retraso.retraso_puerto(posicion);
inc(r.contador,estados);
end;

procedure spec_putbyte(posicion:word;valor:byte;r:preg_z80;ll:llam_z80);
begin
ll.putbyte(posicion,valor);
spec_retraso.retraso(posicion);
inc(r.contador,3);
end;

function spec_getbyte(posicion:word;r:preg_z80;ll:llam_z80):byte;
begin
spec_getbyte:=ll.getbyte(posicion);
spec_retraso.retraso(posicion);
inc(r.contador,3);
end;

procedure irq_z80_sp(r:preg_z80;ll:llam_z80);
var
  posicion:parejas;
begin
r.halt:=false;
if not(r.iff1) then exit; //se esta ejecutando otra
r.r:=((r.r+1) and $7f) or (r.r and $80);
dec(r.sp,2);
ll.putbyte(r.sp+1,r.pc shr 8);
ll.putbyte(r.sp,r.pc and $ff);
r.IFF2:= false;
r.IFF1:= False;
Case r.im of
        0,1:begin
              r.pc:= $38; //13t
              inc(r.contador,13);
            end;
        2:begin //19t
                if r.daisy then posicion.l:=z80daisy_ack
                    else posicion.l:=r.im2_lo;
                posicion.h:=r.i;
                r.pc:=ll.getbyte(posicion.w)+(ll.getbyte(posicion.w+1) shl 8);
                inc(r.contador,19);
        end;
end;
r.pedir_irq:=CLEAR_LINE;
end;

procedure run_z80_sp(r:preg_z80;ll:llam_z80;maximo:dword);
var
 instruccion,temp:byte;
 posicion:parejas;
 ban_temp:band_z80;
 pcontador:byte;
 irq_temp:boolean;
begin
irq_temp:=false;
while r.contador<maximo do begin
pcontador:=r.contador;
if not(r.after_ei) then begin
  if r.daisy then irq_temp:=z80daisy_state;
  if (irq_temp or (r.pedir_irq<>CLEAR_LINE)) then irq_z80_sp(r,ll);
end else r.after_ei:=false;
if not(r.halt) then begin
  spec_retraso.retraso(r.pc);inc(r.contador,4);
  instruccion:=ll.getbyte(r.pc);
  r.pc:=r.pc+1;
  r.r:=((r.r+1) and $7f) or (r.r and $80);
  case instruccion of
        $00,$40,$49,$52,$5b,$64,$6d,$7f:{nop >4t<};
        $01:begin {ld BC,nn >10t<}
                r.bc.l:=spec_getbyte(r.pc,r,ll);
                r.bc.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
            end;
        $02:spec_putbyte(r.bc.w,r.a,r,ll); {ld (BC),A >7t<}
        $03:begin  {inc BC >6t<}
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              inc(r.bc.w);
            end;
        $04:inc_8(r,@r.bc.h); {inc B >4t<}
        $05:dec_8(r,@r.bc.h); {dec B >4t<}
        $06:begin {ld B,n >7t<}
                r.bc.h:=spec_getbyte(r.pc,r,ll);
                inc(r.pc);
            end;
        $07:begin   {rlca >4t<}
               r.f.c:=(r.a and $80)<>0;
               if r.f.c then r.a:=((r.a shl 1) or 1) else r.a:=r.a shl 1;
               r.f.bit5:=(r.a and $20)<>0;
               r.f.bit3:=(r.a and 8)<>0;
               r.f.h:=false;
               r.f.n:=false;
            end;
        $08:begin { ex AF,AF' >4t<}
                ban_temp:=r.f;
                r.f:=r.f2;
                r.f2:=ban_temp;
                temp:=r.a;
                r.a:=r.a2;
                r.a2:=temp;
            end;
        $09:begin {add HL,BC >11t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                add_16(r,@r.hl,r.bc.w);
            end;
        $0a:r.a:=spec_getbyte(r.bc.w,r,ll); {ld A,(BC) >7t<}
        $0b:begin {dec BC >6t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                dec(r.bc.w);
            end;
        $0c:inc_8(r,@r.bc.l); {inc C >4t<}
        $0d:dec_8(r,@r.bc.l); {dec C >4t<}
        $0e:begin {ld C,n >7t<}
                r.bc.l:=spec_getbyte(r.pc,r,ll);
                inc(r.pc);
            end;
        $0f:begin   {rrca >4t<}
                r.f.c:=(r.a and 1)<>0;
                if r.f.c then r.a:=((r.a shr 1) or $80) else r.a:=r.a shr 1;
                r.f.bit5:=(r.a and $20) <>0;
                r.f.bit3:=(r.a and 8)<>0;
                r.f.h:=false;
                r.f.n:=false;
            end;
        $10:begin {dnjz (PC+e) >8t o 13t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                temp:=spec_getbyte(r.pc,r,ll);
                dec(r.bc.h);
                if r.bc.h<>0 then begin
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  r.pc:=r.pc+shortint(temp);
                end;
                inc(r.pc);
            end;
        $11:begin {ld DE,nn >10t<}
                r.de.l:=spec_getbyte(r.pc,r,ll);
                r.de.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
            end;
        $12:spec_putbyte(r.de.w,r.a,r,ll);  {ld (DE),A >7t<}
        $13:begin {inc DE >6t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                inc(r.de.w);
            end;
        $14:inc_8(r,@r.de.h); {inc D >4t<}
        $15:dec_8(r,@r.de.h); {dec D >4t<}
        $16:begin {ld D,n >7t<}
                r.de.h:=spec_getbyte(r.pc,r,ll);
                inc(r.pc);
            end;
        $17:begin  {rla >4t<}
                r.f.h:=(r.a and $80)<>0;
                if r.f.c then r.a:=((r.a shl 1) or 1) else r.a:=r.a shl 1;
                r.f.bit5:=(r.a and $20)<>0;
                r.f.bit3:=(r.a and 8)<>0;
                r.f.c:=r.f.h;
                r.f.h:=false;
                r.f.n:=false;
            end;
        $18:begin   {jr e >12t<}
                temp:=spec_getbyte(r.pc,r,ll);
                spec_retraso.retraso(r.pc);inc(r.contador);
                spec_retraso.retraso(r.pc);inc(r.contador);
                spec_retraso.retraso(r.pc);inc(r.contador);
                spec_retraso.retraso(r.pc);inc(r.contador);
                spec_retraso.retraso(r.pc);inc(r.contador);
                inc(r.pc);
                r.pc:=r.pc+shortint(temp);
            end;
        $19:begin  {add HL,DE >11t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                add_16(r,@r.hl,r.de.w);
            end;
        $1a:r.a:=spec_getbyte(r.de.w,r,ll); {ld A,(DE) >7t<}
        $1b:begin {dec DE >6t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                dec(r.de.w);
            end;
        $1c:inc_8(r,@r.de.l); {inc E >4t<}
        $1d:dec_8(r,@r.de.l); {dec E >4t<}
        $1e:begin {ld E,n >7t<}
                r.de.l:=spec_getbyte(r.pc,r,ll);
                inc(r.pc);
            end;
        $1f:begin {rra >4t<}
                r.f.h:=(r.a and 1)<>0;
                if r.f.c then r.a:=((r.a shr 1) or $80) else r.a:=r.a shr 1;
                r.f.n:=false;
                r.f.c:=r.f.h;
                r.f.h:=false;
                r.f.bit5:=(r.a and $20)<>0;
                r.f.bit3:=(r.a and 8)<>0;
            end;
        $20:begin  //jp NZ,(PC+e) >7t o 12t<
                temp:=spec_getbyte(r.pc,r,ll);
                if not(r.f.z) then begin
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  r.pc:=r.pc+shortint(temp);
                end;
                inc(r.pc);
            end;
        $21:begin {ld HL,nn >10t<}
                r.hl.l:=spec_getbyte(r.pc,r,ll);
                r.hl.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
            end;
        $22:begin {ld (nn),HL >16t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                spec_putbyte(posicion.w,r.hl.l,r,ll);
                spec_putbyte(posicion.w+1,r.hl.h,r,ll);
            end;
        $23:begin  {inc HL >6t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                inc(r.hl.w);
            end;
        $24:inc_8(r,@r.hl.h); {inc H >4t<}
        $25:dec_8(r,@r.hl.h); {dec H >4t<}
        $26:begin {ld H,n >7t<}
                r.hl.h:=spec_getbyte(r.pc,r,ll);
                inc(r.pc);
            end;
        $27:begin   {daa >4t<}
                temp:=0;
                If (r.f.h Or ((r.a And $0F)> 9)) Then temp:=temp or 6;
                If (r.f.c Or (r.a > $9F)) Then temp:=temp or $60;
                If ((r.a > $8F) And ((r.a And $0F) > 9)) Then temp:=temp or $60;
                If (r.a > $99) Then r.f.c:=True;
                If r.f.n Then begin
                        r.f.h:=(((r.a and $0f)-(temp and $0f)) and $10)<>0;
                        r.a:=r.a-temp;
                end else begin
                        r.f.h:=(((r.a and $0f)+(temp and $0f)) and $10)<>0;
                        r.a:=r.a+temp;
                end;
                r.f.p_v:=paridad[r.a];
                r.f.s:=(r.a and $80) <>0;
                r.f.z:=(r.a=0);
                r.f.bit5:=(r.a and $20)<>0;
                r.f.bit3:=(r.a and 8)<>0;
            end;
        $28:begin //jp Z,(PC+e) >7t o 12t<
                temp:=spec_getbyte(r.pc,r,ll);
                inc(r.pc);
                if r.f.z then begin
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  spec_retraso.retraso(r.pc);inc(r.contador); 
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  spec_retraso.retraso(r.pc);inc(r.contador); 
                  spec_retraso.retraso(r.pc);inc(r.contador); 
                  r.pc:=r.pc+shortint(temp);
                end;
            end;
        $29:begin  {add HL,HL >11t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                add_16(r,@r.hl,r.hl.w);
            end;
        $2a:begin  {ld HL,(nn) >16t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                r.hl.l:=spec_getbyte(posicion.w,r,ll);
                r.hl.h:=spec_getbyte(posicion.w+1,r,ll);
            end;
        $2b:begin   {dec HL >6t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                dec(r.hl.w);
            end;
        $2c:inc_8(r,@r.hl.l); {inc L >4t<}
        $2d:dec_8(r,@r.hl.l); {dec L >4t<}
        $2e:begin {ld L,n >7t<}
                r.hl.l:=spec_getbyte(r.pc,r,ll);
                inc(r.pc);
            end;
        $2f:begin {cpl >4t<}
                r.a:=r.a xor $FF;
                r.f.bit5:=(r.a and $20)<>0;
                r.f.bit3:=(r.a and 8)<>0;
                r.f.h:=true;
                r.f.n:=true;
            end;
        $30:begin //jp NC,(PC+e) >7t o 12t<
                temp:=spec_getbyte(r.pc,r,ll);
                if not(r.f.c) then begin
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  r.pc:=r.pc+shortint(temp);
                end;
                inc(r.pc);
            end;
        $31:begin {ld SP,nn >10t<}
                r.sp:=spec_getbyte(r.pc,r,ll)+(spec_getbyte(r.pc+1,r,ll) shl 8);
                inc(r.pc,2);
            end;
        $32:begin {ld (nn),A >13t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                spec_putbyte(posicion.w,r.a,r,ll);
            end;
        $33:begin  {inc SP >6t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                inc(r.sp);
            end;
        $34:begin  {inc (HL) >11t<}
                temp:=spec_getbyte(r.hl.w,r,ll);
                spec_retraso.retraso(r.hl.w);inc(r.contador); 
                inc_8(r,@temp);
                spec_putbyte(r.hl.w,temp,r,ll);
            end;
        $35:begin  {dec (HL) >11t<}
                temp:=spec_getbyte(r.hl.w,r,ll);
                spec_retraso.retraso(r.hl.w);inc(r.contador);
                dec_8(r,@temp);
                spec_putbyte(r.hl.w,temp,r,ll);
            end;
        $36:begin {ld (HL),n >10t<}
                temp:=spec_getbyte(r.pc,r,ll);
                inc(r.pc);
                spec_putbyte(r.hl.w,temp,r,ll);
            end;
        $37:begin  {scf >4t<}
                r.f.bit5:=(r.a and $20)<>0;
                r.f.bit3:=(r.a and 8)<>0;
                r.f.c:=true;
                r.f.h:=false;
                r.f.n:=false;
            end;
        $38:begin //jp C,(PC+e) >7t o 12t<
              temp:=spec_getbyte(r.pc,r,ll);
              if r.f.c then begin
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  spec_retraso.retraso(r.pc);inc(r.contador);
                  r.pc:=r.pc+shortint(temp);
              end;
              inc(r.pc);
            end;
        $39:begin {add HL,SP >11t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                add_16(r,@r.hl,r.sp);
            end;
        $3a:begin {ld A,(nn) >13<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                r.a:=spec_getbyte(posicion.w,r,ll);
            end;
        $3b:begin   {dec SP >6t<}
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              dec(r.sp);
           end;
        $3c:inc_8(r,@r.a); {inc A >4t<}
        $3d:dec_8(r,@r.a); {dec A >4t<}
        $3e:begin {ld A,n >7t<}
                r.a:=spec_getbyte(r.pc,r,ll);
                inc(r.pc);
            end;
        $3f:begin   {ccf >4t<}
                r.f.bit5:=(r.a and $20)<>0;
                r.f.bit3:=(r.a and 8)<>0;
                r.f.h:=r.f.c;
                r.f.n:=false;
                r.f.c:=not(r.f.c);
            end;
        {'$'40: igual que el nop ld B,B}
        $41:r.bc.h:=r.bc.l; {ld B,C >4t<}
        $42:r.bc.h:=r.de.h; {ld B,D >4t<}
        $43:r.bc.h:=r.de.l; {ld B,E >4t<}
        $44:r.bc.h:=r.hl.h; {ld B,H >4t<}
        $45:r.bc.h:=r.hl.l; {ld B,L >4t<}
        $46:r.bc.h:=spec_getbyte(r.hl.w,r,ll); {ld B,(HL) >7t<}
        $47:r.bc.h:=r.a; {ld B,A >4t<}
        $48:r.bc.l:=r.bc.h; {ld C,B >4t<}
        {'$'49: igual que el nop ld C,C}
        $4a:r.bc.l:=r.de.h; {ld C,D >4t<}
        $4b:r.bc.l:=r.de.l; {ld C,E >4t<}
        $4c:r.bc.l:=r.hl.h; {ld C,H >4t<}
        $4d:r.bc.l:=r.hl.l; {ld C,L >4t<}
        $4e:r.bc.l:=spec_getbyte(r.hl.w,r,ll); {ld C,(HL) >7t<}
        $4f:r.bc.l:=r.a; {ld C,A >4t<}
        $50:r.de.h:=r.bc.h; {ld D,B >4t<}
        $51:r.de.h:=r.bc.l; {ld D,C >4t<}
        {'$'52 igual que el nop ld D,D}
        $53:r.de.h:=r.de.l; {ld D,E >4t<}
        $54:r.de.h:=r.hl.h; {ld D,H >4t<}
        $55:r.de.h:=r.hl.l; {ld D,L >4t<}
        $56:r.de.h:=spec_getbyte(r.hl.w,r,ll); {ld D,(HL) >7t<}
        $57:r.de.h:=r.a; {ld D,A >4t<}
        $58:r.de.l:=r.bc.h; {ld E,B >4t<}
        $59:r.de.l:=r.bc.l; {ld E,C >4t<}
        $5a:r.de.l:=r.de.h; {ld E,D >4t<}
        {'$'5b igual que el nop ld E,E}
        $5c:r.de.l:=r.hl.h; {ld E,H >4t<}
        $5d:r.de.l:=r.hl.l; {ld E,L >4t<}
        $5e:r.de.l:=spec_getbyte(r.hl.w,r,ll); {ld E,(HL) >7t<}
        $5f:r.de.l:=r.a; {ld E,A >4t<}
        $60:r.hl.h:=r.bc.h; {ld H,B >4t<}
        $61:r.hl.h:=r.bc.l; {ld H,C >4t<}
        $62:r.hl.h:=r.de.h; {ld H,D >4t<}
        $63:r.hl.h:=r.de.l; {ld H,E >4t<}
        {'$'64: igual que el nop ld H,H}
        $65:r.hl.h:=r.hl.l; {ld H,L >4t<}
        $66:r.hl.h:=spec_getbyte(r.hl.w,r,ll); {ld H,(HL) >7t<}
        $67:r.hl.h:=r.a; {ld H,A >4t<}
        $68:r.hl.l:=r.bc.h; {ld L,B >4t<}
        $69:r.hl.l:=r.bc.l; {ld L,C >4t<}
        $6a:r.hl.l:=r.de.h; {ld L,D >4t<}
        $6b:r.hl.l:=r.de.l; {ld L,E >4t<}
        $6c:r.hl.l:=r.hl.h; {ld L,H >4t<}
        {'$'6d: igual que el nop ld L,L}
        $6e:r.hl.l:=spec_getbyte(r.hl.w,r,ll); {ld L,(HL) >7t<}
        $6f:r.hl.l:=r.a; {ld L,A >4t<}
        $70:spec_putbyte(r.hl.w,r.bc.h,r,ll); {ld (HL),B >7t<}
        $71:spec_putbyte(r.hl.w,r.bc.l,r,ll); {ld (HL),C >7t<}
        $72:spec_putbyte(r.hl.w,r.de.h,r,ll); {ld (HL),D >7t<}
        $73:spec_putbyte(r.hl.w,r.de.l,r,ll); {ld (HL),E >7t<}
        $74:spec_putbyte(r.hl.w,r.hl.h,r,ll); {ld (HL),H >7t<}
        $75:spec_putbyte(r.hl.w,r.hl.l,r,ll); {ld (HL),L >7t<}
        $76:r.halt:=true; {halt >4t<}
        $77:spec_putbyte(r.hl.w,r.a,r,ll); {ld (HL),A >7t<}
        $78:r.a:=r.bc.h; {ld A,B >4t<}
        $79:r.a:=r.bc.l; {ld A,C >4t<}
        $7a:r.a:=r.de.h; {ld A,D >4t<}
        $7b:r.a:=r.de.l; {ld A,E >4t<}
        $7c:r.a:=r.hl.h; {ld A,H >4t<}
        $7d:r.a:=r.hl.l; {ld A,L >4t<}
        $7e:r.a:=spec_getbyte(r.hl.w,r,ll); {ld A,(HL) >7t<}
        {'$'7f: igual que el nop ld A,A}
        $80:add_8(r,r.bc.h); {add A,B >4t<}
        $81:add_8(r,r.bc.l); {add A,C >4t<}
        $82:add_8(r,r.de.h); {add A,D >4t<}
        $83:add_8(r,r.de.l); {add A,E >4t<}
        $84:add_8(r,r.hl.h); {add A,H >4t<}
        $85:add_8(r,r.hl.l); {add A,L >4t<}
        $86:add_8(r,spec_getbyte(r.hl.w,r,ll));  {add A,(HL) >7t<}
        $87:add_8(r,r.a); {add A,A >4t<}
        $88:adc_8(r,r.bc.h); {adc A,B >4t<}
        $89:adc_8(r,r.bc.l); {adc A,C >4t<}
        $8a:adc_8(r,r.de.h); {adc A,D >4t<}
        $8b:adc_8(r,r.de.l); {adc A,E >4t<}
        $8c:adc_8(r,r.hl.h); {adc A,H >4t<}
        $8d:adc_8(r,r.hl.l); {adc A,L >4t<}
        $8e:adc_8(r,spec_getbyte(r.hl.w,r,ll)); {adc A,(HL) >7t<}
        $8f:adc_8(r,r.a); {adc A,A >4t<}
        $90:sub_8(r,r.bc.h); {sub B >4t<}
        $91:sub_8(r,r.bc.l); {sub C >4t<}
        $92:sub_8(r,r.de.h); {sub D >4t<}
        $93:sub_8(r,r.de.l); {sub E >4t<}
        $94:sub_8(r,r.hl.h); {sub H >4t<}
        $95:sub_8(r,r.hl.l); {sub L >4t<}
        $96:sub_8(r,spec_getbyte(r.hl.w,r,ll)); {sub (HL) >4t<}
        $97:sub_8(r,r.a); {sub A  >4t<}
        $98:sbc_8(r,r.bc.h); {sbc A,B >4t<}
        $99:sbc_8(r,r.bc.l); {sbc A,C >4t<}
        $9a:sbc_8(r,r.de.h); {sbc A,D >4t<}
        $9b:sbc_8(r,r.de.l); {sbc A,E >4t<}
        $9c:sbc_8(r,r.hl.h); {sbc A,H >4t<}
        $9d:sbc_8(r,r.hl.l); {sbc A,L >4t<}
        $9e:sbc_8(r,spec_getbyte(r.hl.w,r,ll)); {sbc A,(HL) >7t<}
        $9f:sbc_8(r,r.a); {sbc A,A >4t<}
        $a0:and_a(r,r.bc.h);  {and A,B >4t<}
        $a1:and_a(r,r.bc.l);  {and A,C >4t<}
        $a2:and_a(r,r.de.h);  {and A,D >4t<}
        $a3:and_a(r,r.de.l); {and A,E >4t<}
        $a4:and_a(r,r.hl.h); {and A,H >4t<}
        $a5:and_a(r,r.hl.l); {and A,L >4t<}
        $a6:and_a(r,spec_getbyte(r.hl.w,r,ll)); {and A,(HL) >7t<}
        $a7:and_a(r,r.a); {and A,A >4t<}
        $a8:xor_a(r,r.bc.h); {xor A,B >4t<}
        $a9:xor_a(r,r.bc.l); {xor A,C >4t<}
        $aa:xor_a(r,r.de.h); {xor A,D >4t<}
        $ab:xor_a(r,r.de.l); {xor A,E >4t<}
        $ac:xor_a(r,r.hl.h); {xor A,H >4t<}
        $ad:xor_a(r,r.hl.l); {xor A,L >4t<}
        $ae:xor_a(r,spec_getbyte(r.hl.w,r,ll)); {xor A,(HL) >7t<}
        $af:begin {xor A,A >4t<}
                r.a:=0;
                r.f.s:=false;
                r.f.z:=true;
                r.f.bit5:=false;
                r.f.h:=false;
                r.f.bit3:=false;
                r.f.p_v:=true;
                r.f.n:=false;
                r.f.c:=false;
             end;
        $b0:or_a(r,r.bc.h); {or B >4t<}
        $b1:or_a(r,r.bc.l); {or C >4t<}
        $b2:or_a(r,r.de.h); {or D >4t<}
        $b3:or_a(r,r.de.l); {or E >4t<}
        $b4:or_a(r,r.hl.h); {or H >4t<}
        $b5:or_a(r,r.hl.l); {or L >4t<}
        $b6:or_a(r,spec_getbyte(r.hl.w,r,ll));   {or (HL) >7t<}
        $b7:or_a(r,r.a); {or A >4t<}
        $b8:cp_a(r,r.bc.h); {cp B >4t<}
        $b9:cp_a(r,r.bc.l); {cp C >4t<}
        $ba:cp_a(r,r.de.h); {cp D >4t<}
        $bb:cp_a(r,r.de.l); {cp E >4t<}
        $bc:cp_a(r,r.hl.h); {cp H >4t<}
        $bd:cp_a(r,r.hl.l); {cp L >4t<}
        $be:cp_a(r,spec_getbyte(r.hl.w,r,ll)); {cp (HL) >7t<}
        $bf:cp_a(r,r.a); {cp A >4t<}
        $c0:begin {ret NZ >5t<}
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              if not(r.f.z) then begin
                  spec_retraso.retraso(r.sp);inc(r.contador,3);
                  spec_retraso.retraso(r.sp+1);inc(r.contador,3);
                  pop_sp(@r.sp,ll,@r.pc);
              end;
             end;
        $c1:begin  //pop BC  >10t<
              spec_retraso.retraso(r.sp);inc(r.contador,3);
              spec_retraso.retraso(r.sp+1);inc(r.contador,3);
              pop_sp(@r.sp,ll,@r.bc);
            end;
        $c2:begin //jp NZ,nn >10t<
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                if not(r.f.z) then begin
                  r.pc:=posicion.w;
                end;
            end;
        $c3:begin //jp nn >10t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                r.pc:=posicion.w;
             end;
        $c4:begin {call NZ,nn >10t o 17t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                if not(r.f.z) then begin
                  spec_retraso.retraso(r.pc-1);inc(r.contador);
                  push_sp(@r.sp,ll,@r.pc);
                  spec_retraso.retraso(r.sp);inc(r.contador,3);
                  spec_retraso.retraso(r.sp+1);inc(r.contador,3);
                  r.pc:=posicion.w;
                end;
             end;
        $c5:begin {push BC >11t<}
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              push_sp(@r.sp,ll,@r.bc);
              spec_retraso.retraso(r.sp);inc(r.contador,3);
              spec_retraso.retraso(r.sp+1);inc(r.contador,3);
            end;
        $c6:begin {add A,n >7t<}
                temp:=spec_getbyte(r.pc,r,ll);
                inc(r.pc);
                add_8(r,temp);
             end;
        $c7:begin  {rst 00H >11t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso(r.sp-1);inc(r.contador,3);
                spec_retraso.retraso(r.sp-2);inc(r.contador,3);
                push_sp(@r.sp,ll,@r.pc);
                r.pc:=0;
             end;
        $c8:begin {ret Z >5t o 11t<}
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              if r.f.z then begin
                  spec_retraso.retraso(r.sp);inc(r.contador,3);
                  spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
                  pop_sp(@r.sp,ll,@r.pc);
              end;
            end;
        $c9:begin //ret >10t<
              spec_retraso.retraso(r.sp);inc(r.contador,3); 
              spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
              pop_sp(@r.sp,ll,@r.pc);
            end;
        $ca:begin {jp Z,nn >10t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                if r.f.z then r.pc:=posicion.w;
            end;
        $cb:exec_cb_sp(r,ll);
        $cc:begin {call Z,nn >10t o 17t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                if r.f.z then begin
                  spec_retraso.retraso(r.pc-1);inc(r.contador); 
                  push_sp(@r.sp,ll,@r.pc);
                  spec_retraso.retraso(r.sp);inc(r.contador,3); 
                  spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
                  r.pc:=posicion.w;
                end;
            end;
        $cd:begin   {call nn >17t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                spec_retraso.retraso(r.pc+1);inc(r.contador); 
                inc(r.pc,2);
                push_sp(@r.sp,ll,@r.pc);
                spec_retraso.retraso(r.sp);inc(r.contador,3); 
                spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
                r.pc:=posicion.w;
             end;
        $ce:begin   {adc A,n >7t<}
                temp:=spec_getbyte(r.pc,r,ll);
                inc(r.pc);
                adc_8(r,temp);
             end;
        $cf:begin  {rst 08H >11t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso(r.sp-1);inc(r.contador,3); 
                spec_retraso.retraso(r.sp-2);inc(r.contador,3); 
                push_sp(@r.sp,ll,@r.pc);
                r.pc:=$8;
             end;
        $d0:begin {ret NC >5t o 11t<}
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              if not(r.f.c) then begin
                  spec_retraso.retraso(r.sp);inc(r.contador,3); 
                  spec_retraso.retraso(r.sp+1);inc(r.contador,3);
                  pop_sp(@r.sp,ll,@r.pc);
              end;
             end;
        $d1:begin
              spec_retraso.retraso(r.sp);inc(r.contador,3); 
              spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
              pop_sp(@r.sp,ll,@r.de);  {pop DE >10t<}
            end;
        $d2:begin //jp NC,nn >10t<
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                if not(r.f.c) then r.pc:=posicion.w;
             end;
        $d3:begin //out (n),A >11t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=r.a;
                inc(r.pc);
                spec_outbyte(r.a,posicion.w,r,ll);
             end;
        $d4:begin {call NC,nn >10t o 17t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                if not(r.f.c) then begin
                  spec_retraso.retraso(r.pc-1);inc(r.contador);
                  push_sp(@r.sp,ll,@r.pc);
                  spec_retraso.retraso(r.sp);inc(r.contador,3); 
                  spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
                  r.pc:=posicion.w;
                end;
             end;
        $d5:begin  {push DE >11t<}
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              push_sp(@r.sp,ll,@r.de);
              spec_retraso.retraso(r.sp);inc(r.contador,3); 
              spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
            end;
        $d6:begin {sub n >7t<}
                temp:=spec_getbyte(r.pc,r,ll);
                inc(r.pc);
                sub_8(r,temp);
             end;
        $d7:begin  {rst 10H >11t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso(r.sp-1);inc(r.contador,3); 
                spec_retraso.retraso(r.sp-2);inc(r.contador,3); 
                push_sp(@r.sp,ll,@r.pc);
                r.pc:=$10;
             end;
        $d8:begin {ret C >5t o 11t<}
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              if r.f.c then begin
                  spec_retraso.retraso(r.sp);inc(r.contador,3); 
                  spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
                  pop_sp(@r.sp,ll,@r.pc);
              end;
            end;
        $d9:begin {exx >4t<}
                posicion:=r.bc;
                r.bc:=r.bc2;
                r.bc2:=posicion;
                posicion:=r.de;
                r.de:=r.de2;
                r.de2:=posicion;
                posicion:=r.hl;
                r.hl:=r.hl2;
                r.hl2:=posicion;
             end;
        $da:begin  {jp C,nn >10t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                if r.f.c then r.pc:=posicion.w;
            end;
        $db:begin  {in A,(n) >11t<}
             posicion.l:=spec_getbyte(r.pc,r,ll);
             inc(r.pc);
             posicion.h:=r.a;
             r.a:=spec_inbyte(posicion.w,r,ll);
             end;
        $dc:begin  {call C,nn >10t o 17t<}
              posicion.l:=spec_getbyte(r.pc,r,ll);
              posicion.h:=spec_getbyte(r.pc+1,r,ll);
              inc(r.pc,2);
              if r.f.c then begin
                spec_retraso.retraso(r.pc-1);inc(r.contador); 
                push_sp(@r.sp,ll,@r.pc);
                spec_retraso.retraso(r.sp);inc(r.contador,3); 
                spec_retraso.retraso(r.sp+1);inc(r.contador,3);
                r.pc:=posicion.w;
              end;
             end;
        $dd:exec_dd_fd_sp(r,ll,true);
        $de:begin {sbc A,n >7t<}
                temp:=spec_getbyte(r.pc,r,ll);
                inc(r.pc);
                sbc_8(r,temp);
            end;
        $df:begin  {rst 18H >11t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso(r.sp-1);inc(r.contador,3); 
                spec_retraso.retraso(r.sp-2);inc(r.contador,3); 
                push_sp(@r.sp,ll,@r.pc);
                r.pc:=$18;
             end;
        $e0:begin {ret PO >5t o 11t<}
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              if not(r.f.p_v) then begin
                  spec_retraso.retraso(r.sp);inc(r.contador,3);
                  spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
                  pop_sp(@r.sp,ll,@r.pc);
              end;
             end;
        $e1:begin {pop HL >10t<}
              spec_retraso.retraso(r.sp);inc(r.contador,3);
              spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
              pop_sp(@r.sp,ll,@r.hl);
            end;
        $e2:begin  {jp PO,nn >10t<}
              posicion.l:=spec_getbyte(r.pc,r,ll);
              posicion.h:=spec_getbyte(r.pc+1,r,ll);
              inc(r.pc,2);
              if not(r.f.p_v) then r.pc:=posicion.w;
            end;
        $e3:begin   {ex (sp),hl >19t<}
                spec_retraso.retraso(r.sp);inc(r.contador,3);
                spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
                pop_sp(@r.sp,ll,@posicion);
                spec_retraso.retraso(r.sp+1);inc(r.contador);
                push_sp(@r.sp,ll,@r.hl);
                spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
                spec_retraso.retraso(r.sp);inc(r.contador,3); 
                spec_retraso.retraso(r.sp);inc(r.contador); 
                spec_retraso.retraso(r.sp);inc(r.contador);
                r.hl:=posicion;
             end;
        $e4:begin  {call PO,nn >10 o 17t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                if not(r.f.p_v) then begin
                  spec_retraso.retraso(r.pc-1);inc(r.contador); 
                  push_sp(@r.sp,ll,@r.pc);
                  spec_retraso.retraso(r.sp);inc(r.contador,3); 
                  spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
                  r.pc:=posicion.w;
                end;
             end;
        $e5:begin  //push HL >11t<
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              push_sp(@r.sp,ll,@r.hl);
              spec_retraso.retraso(r.sp);inc(r.contador,3);
              spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
            end;
        $e6:begin {and A,n >7t<}
                temp:=spec_getbyte(r.pc,r,ll);
                inc(r.pc);
                and_a(r,temp);
             end;
        $e7:begin  {rst 20H >11t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso(r.sp-1);inc(r.contador,3); 
                spec_retraso.retraso(r.sp-2);inc(r.contador,3); 
                push_sp(@r.sp,ll,@r.pc);
                r.pc:=$20;
             end;
        $e8:begin {ret PE >5t o 11t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                if r.f.p_v then begin
                    spec_retraso.retraso(r.sp);inc(r.contador,3); 
                    spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
                    pop_sp(@r.sp,ll,@r.pc);
                end;
             end;
        $e9:r.pc:=r.hl.w; {jp (HL) >4t<}
        $ea:begin {jp PE,nn >10t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                if r.f.p_v then r.pc:=posicion.w;
            end;
        $eb:begin { ex DE,HL >4t<}
                posicion:=r.de;
                r.de:=r.hl;
                r.hl:=posicion;
             end;
        $ec:begin  {call PE,nn >10t o 17t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                if r.f.p_v then begin
                  spec_retraso.retraso(r.pc-1);inc(r.contador); 
                  push_sp(@r.sp,ll,@r.pc);
                  spec_retraso.retraso(r.sp);inc(r.contador,3); 
                  spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
                  r.pc:=posicion.w;
                end;
             end;
        $ed:exec_ed_sp(r,ll);
        $ee:begin  {xor A,n >7t<}
                temp:=spec_getbyte(r.pc,r,ll);
                inc(r.pc);
                xor_a (r,temp);
              end;
        $ef:begin  {rst 28H >11t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso(r.sp-1);inc(r.contador,3);
                spec_retraso.retraso(r.sp-2);inc(r.contador,3); 
                push_sp(@r.sp,ll,@r.pc);
                r.pc:=$28;
             end;
        $f0:begin {ret NP >5t o 11t<}
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              if not(r.f.s) then begin
                  spec_retraso.retraso(r.sp);inc(r.contador,3); 
                  spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
                  pop_sp(@r.sp,ll,@r.pc);
              end;
             end;
        $f1:begin  {pop AF >10t<}
                spec_retraso.retraso(r.sp);inc(r.contador,3); 
                spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
                pop_sp(@r.sp,ll,@posicion);
                r.a:=posicion.h;
                r.f.s:=(posicion.l and 128)<>0;
                r.f.z:=(posicion.l and 64)<>0;
                r.f.bit5:=(posicion.l and 32)<>0;
                r.f.h:=(posicion.l and 16)<>0;
                r.f.bit3:=(posicion.l and 8)<>0;
                r.f.p_v:=(posicion.l and 4)<>0;
                r.f.n:=(posicion.l and 2)<>0;
                r.f.c:=(posicion.l and 1)<>0;
                end;
        $f2:begin {jp P,nn >10t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                if not(r.f.s) then r.pc:=posicion.w;
             end;
        $f3:begin {di >4t<}
                r.iff1:=false;
                r.iff2:=false;
              end;
        $f4:begin {call P,nn >10t o 17t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                if not(r.f.s) then begin
                  spec_retraso.retraso(r.pc-1);inc(r.contador); 
                  push_sp(@r.sp,ll,@r.pc);
                  spec_retraso.retraso(r.sp);inc(r.contador,3); 
                  spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
                  r.pc:=posicion.w;
                end;
             end;
        $f5:begin  {push AF >11t<}
                posicion.h:=r.a;
                posicion.l:=0;
                if r.f.s then posicion.l:=posicion.l or $80;
                if r.f.z then posicion.l:=posicion.l or $40;
                if r.f.bit5 then posicion.l:=posicion.l or $20;
                if r.f.h then posicion.l:=posicion.l or $10;
                if r.f.bit3 then posicion.l:=posicion.l or 8;
                if r.f.p_v then posicion.l:=posicion.l or 4;
                if r.f.n then posicion.l:=posicion.l or 2;
                if r.f.c then posicion.l:=posicion.l or 1;
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                push_sp(@r.sp,ll,@posicion);
                spec_retraso.retraso(r.sp);inc(r.contador,3); 
                spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
             end;
        $f6:begin {or n >7t<}
                temp:=spec_getbyte(r.pc,r,ll);
                inc(r.pc);
                or_a(r,temp);
             end;
        $f7:begin  {rst 30H >11t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
                spec_retraso.retraso(r.sp-1);inc(r.contador,3); 
                spec_retraso.retraso(r.sp-2);inc(r.contador,3); 
                push_sp(@r.sp,ll,@r.pc);
                r.pc:=$30;
             end;
        $f8:begin {ret M >5t o 11t<}
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
              if r.f.s then begin
                 spec_retraso.retraso(r.sp);inc(r.contador,3); 
                 spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
                 pop_sp(@r.sp,ll,@r.pc);
              end;
             end;
        $f9:begin  {ld SP,HL >6t<}
              r.sp:=r.hl.w;
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
              spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador); 
            end;
        $fa:begin {jp M,nn >10t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                if r.f.s then r.pc:=posicion.w;
            end;
        $fb:begin   {ei >4t<}
                r.iff1:=true;
                r.iff2:=true;
                r.after_ei:=true;
             end;
        $fc:begin {call M,nn >10t o 17t<}
                posicion.l:=spec_getbyte(r.pc,r,ll);
                posicion.h:=spec_getbyte(r.pc+1,r,ll);
                inc(r.pc,2);
                if r.f.s then begin
                  spec_retraso.retraso(r.pc-1);inc(r.contador); 
                  push_sp(@r.sp,ll,@r.pc);
                  spec_retraso.retraso(r.sp);inc(r.contador,3); 
                  spec_retraso.retraso(r.sp+1);inc(r.contador,3); 
                  r.pc:=posicion.w;
                end;
             end;
        $fd:exec_dd_fd_sp(r,ll,false);
        $fe:begin  {cp n >7t<}
                temp:=spec_getbyte(r.pc,r,ll);
                inc(r.pc);
                cp_a(r,temp);
            end;
        $ff:begin  {rst 38H >11t<}
                spec_retraso.retraso((r.i shl 8)+r.r);inc(r.contador);
                spec_retraso.retraso(r.sp-1);inc(r.contador,3);
                spec_retraso.retraso(r.sp-2);inc(r.contador,3);
                push_sp(@r.sp,ll,@r.pc);
                r.pc:=$38;
             end;
  end; {del case}
  spectrum_despues_instruccion(r.contador-pcontador);
end else begin
  r.contador:=r.contador+4;
  spectrum_despues_instruccion(4);
end;
end; {del while}
end;

end.
