unit controls_engine;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses sdl,main_engine;

type
    def_mouse = record
        x,y:word;
        button1,button2:boolean;
    end;
    def_event = record
        mouse,keyboard,arcade:boolean;
        emouse,ejoystick,ekeyboard,earcade:boolean;
    end;
    def_arcade = record
        coin,start,up,down,left,right,but0,but1,but2,but3,but4,but5:array[0..1] of boolean;
        ncoin,nstart,nup,ndown,nleft,nright,nbut0,nbut1,nbut2,nbut3,nbut4,nbut5,jbut0,jbut1,jbut2,jbut3,jbut4,jbut5:array[0..1] of word;
        use_key:array[0..1] of boolean;
        num_joystick:array[0..1] of byte;
        joy_ax0,joy_ax1:array[0..1] of integer;
    end;
    def_marcade=record
        in0,in1,in2,in3,in4,in5:word;
        dswa,dswb,dswc:word;
        dswa_val,dswb_val,dswc_val:pdef_dip;
    end;

procedure evalue_controls;
procedure init_controls(evalue_mouse,evalue_keyboard,evalue_joystick,evalue_arcade:boolean);
procedure open_joystick(player:byte);
procedure close_joystick(num:byte);

var
    joystick_def:array[0..1] of psdl_joystick;
    raton:def_mouse;
    arcade_input:def_arcade;
    event:def_event;
    keyboard:array [0..65000] of boolean;
    marcade:def_marcade;
    in0,in1,in2,in3,in4:byte;

implementation
uses principal;

procedure open_joystick(player:byte);inline;
begin
  joystick_def[player]:=SDL_JoystickOpen(arcade_input.num_joystick[player]);
end;

procedure close_joystick(num:byte);inline;
begin
  SDL_JoystickClose(joystick_def[num]);
  joystick_def[num]:=nil;
end;

procedure init_controls(evalue_mouse,evalue_keyboard,evalue_joystick,evalue_arcade:boolean);
var
  f:byte;
begin
for f:=0 to 1 do begin
  arcade_input.up[f]:=false;
  arcade_input.down[f]:=false;
  arcade_input.left[f]:=false;
  arcade_input.right[f]:=false;
  arcade_input.but0[f]:=false;
  arcade_input.but1[f]:=false;
  arcade_input.but2[f]:=false;
  arcade_input.but3[f]:=false;
  arcade_input.but4[f]:=false;
  arcade_input.but5[f]:=false;
  arcade_input.coin[f]:=false;
  arcade_input.start[f]:=false;
end;
raton.button1:=false;
raton.button2:=false;
raton.x:=0;
raton.y:=0;
event.mouse:=false;
event.arcade:=false;
event.keyboard:=false;
event.emouse:=evalue_mouse;
event.ekeyboard:=evalue_keyboard;
event.ejoystick:=evalue_joystick;
event.earcade:=evalue_arcade;
fillchar(keyboard[0],65000,0);
if joystick_def[0]<>nil then close_joystick(arcade_input.num_joystick[0]);
if joystick_def[1]<>nil then close_joystick(arcade_input.num_joystick[1]);
open_joystick(0);
open_joystick(1);
if joystick_def[0]=nil then arcade_input.use_key[0]:=true;
if joystick_def[1]=nil then arcade_input.use_key[1]:=true;
end;

procedure evaluar_arcade_basic(tevento:byte;keystate:PKeyStateArr);inline;
begin
case tevento of
      SDL_KEYUP:begin
        if (keystate[arcade_input.ncoin[0]]=0) then begin
          arcade_input.coin[0]:=false;
          event.arcade:=true;
        end;
        if (keystate[arcade_input.ncoin[1]]=0) then begin
          arcade_input.coin[1]:=false;
          event.arcade:=true;
        end;
        if (keystate[arcade_input.nstart[0]]=0) then begin
          arcade_input.start[0]:=false;
          event.arcade:=true;
        end;
        if (keystate[arcade_input.nstart[1]]=0) then begin
          arcade_input.start[1]:=false;
          event.arcade:=true;
        end;
      end;
      SDL_KEYDOWN:begin
        if (keystate[arcade_input.ncoin[0]]<>0) then begin
          event.arcade:=true;
          arcade_input.coin[0]:=true;
        end;
        if (keystate[arcade_input.ncoin[1]]<>0) then begin
            arcade_input.coin[1]:=true;
            event.arcade:=true;
        end;
        if (keystate[arcade_input.nstart[0]]<>0) then begin
            arcade_input.start[0]:=true;
            event.arcade:=true;
        end;
        if (keystate[arcade_input.nstart[1]]<>0) then begin
            arcade_input.start[1]:=true;
            event.arcade:=true;
        end;
      end;
end;
end;

procedure evaluar_arcade_keyb(tevento:byte;keystate:PKeyStateArr;player:byte);
begin
case tevento of
      SDL_KEYUP:begin
        if (keystate[arcade_input.nup[player]]=0) then begin
          arcade_input.up[player]:=false;
          event.arcade:=true;
        end;
        if (keystate[arcade_input.ndown[player]]=0) then begin
          arcade_input.down[player]:=false;
          event.arcade:=true;
        end;
        if (keystate[arcade_input.nleft[player]]=0) then begin
          arcade_input.left[player]:=false;
          event.arcade:=true;
        end;
        if (keystate[arcade_input.nright[player]]=0) then begin
          arcade_input.right[player]:=false;
          event.arcade:=true;
        end;
        if (keystate[arcade_input.nbut0[player]]=0) then begin
          arcade_input.but0[player]:=false;
          event.arcade:=true;
        end;
        if (keystate[arcade_input.nbut1[player]]=0) then begin
          arcade_input.but1[player]:=false;
          event.arcade:=true;
        end;
        if (keystate[arcade_input.nbut2[player]]=0) then begin
          arcade_input.but2[player]:=false;
          event.arcade:=true;
        end;
        if (keystate[arcade_input.nbut3[player]]=0) then begin
          arcade_input.but3[player]:=false;
          event.arcade:=true;
        end;
        if (keystate[arcade_input.nbut4[player]]=0) then begin
          arcade_input.but4[player]:=false;
          event.arcade:=true;
        end;
        if (keystate[arcade_input.nbut5[player]]=0) then begin
          arcade_input.but5[player]:=false;
          event.arcade:=true;
        end;
      end;
      SDL_KEYDOWN:begin
        if (keystate[arcade_input.nup[player]]<>0) then begin
          arcade_input.up[player]:=true;
          event.arcade:=true;
        end;
        if (keystate[arcade_input.ndown[player]]<>0) then begin
          arcade_input.down[player]:=true;
          event.arcade:=true;
        end;
        if (keystate[arcade_input.nleft[player]]<>0) then begin
          arcade_input.left[player]:=true;
          event.arcade:=true;
        end;
        if (keystate[arcade_input.nright[player]]<>0) then begin
          arcade_input.right[player]:=true;
          event.arcade:=true;
        end;
        if (keystate[arcade_input.nbut0[player]]<>0) then begin
          arcade_input.but0[player]:=true;
          event.arcade:=true;
        end;
        if (keystate[arcade_input.nbut1[player]]<>0) then begin
          arcade_input.but1[player]:=true;
          event.arcade:=true;
        end;
        if (keystate[arcade_input.nbut2[player]]<>0) then begin
          arcade_input.but2[player]:=true;
          event.arcade:=true;
        end;
        if (keystate[arcade_input.nbut3[player]]<>0) then begin
          arcade_input.but3[player]:=true;
          event.arcade:=true;
        end;
        if (keystate[arcade_input.nbut4[player]]<>0) then begin
          arcade_input.but4[player]:=true;
          event.arcade:=true;
        end;
        if (keystate[arcade_input.nbut5[player]]<>0) then begin
          arcade_input.but5[player]:=true;
          event.arcade:=true;
        end;
      end;
end;
end;

procedure evaluar_arcade_joy(tevent,player:byte);
var
  valor:integer;
begin
if SDL_NumJoysticks=0 then exit;
SDL_JoystickUpdate();
case tevent of
  SDL_JOYBUTTONDOWN,SDL_JOYBUTTONUP:begin
    arcade_input.but0[player]:=SDL_JoystickGetButton(joystick_def[player],arcade_input.jbut0[player])<>0;
    arcade_input.but1[player]:=SDL_JoystickGetButton(joystick_def[player],arcade_input.jbut1[player])<>0;
    arcade_input.but2[player]:=SDL_JoystickGetButton(joystick_def[player],arcade_input.jbut2[player])<>0;
    arcade_input.but3[player]:=SDL_JoystickGetButton(joystick_def[player],arcade_input.jbut3[player])<>0;
    arcade_input.but4[player]:=SDL_JoystickGetButton(joystick_def[player],arcade_input.jbut4[player])<>0;
    arcade_input.but5[player]:=SDL_JoystickGetButton(joystick_def[player],arcade_input.jbut5[player])<>0;
    event.arcade:=true;
  end;
  SDL_JOYAXISMOTION:begin
    valor:=SDL_JoystickGetAxis(joystick_def[player],0);
    if valor<>arcade_input.joy_ax0[player] then begin
      event.arcade:=true;
      arcade_input.left[player]:=(valor<-3200);
      arcade_input.right[player]:=(valor>3200);
      arcade_input.joy_ax0[player]:=valor;
    end;
    valor:=SDL_JoystickGetAxis(joystick_def[player],1);
    if valor<>arcade_input.joy_ax1[player] then begin
      event.arcade:=true;
      arcade_input.up[player]:=(valor<-3200);
      arcade_input.down[player]:=(valor>3200);
      arcade_input.joy_ax1[player]:=valor;
    end;
  end;
end;
end;

procedure evaluar_raton(tevent:TSDL_Event);
var
  sc_mul:byte;
function video_mult:byte;
begin
  case main_screen.video_mode of
    1,3,6:video_mult:=1;
    2,4:video_mult:=2;
    5:video_mult:=3;
  end;
end;
begin
event.mouse:=false;
case tevent.type_ of
  SDL_MOUSEMOTION:begin  //Movimiento
    sc_mul:=video_mult;
    raton.x:=tevent.motion.x div sc_mul;
    raton.y:=tevent.motion.y div sc_mul;
    event.mouse:=true;
  end;
  SDL_MOUSEBUTTONUP:begin  //Levantar boton
    event.mouse:=true;
    case tevent.button.button of
        SDL_BUTTON_LEFT:raton.button1:=false;
        SDL_BUTTON_RIGHT:raton.button2:=false;
    end;
  end;
  SDL_MOUSEBUTTONDOWN:begin
    event.mouse:=true;
    case tevent.button.button of
        SDL_BUTTON_LEFT:raton.button1:=true;
        SDL_BUTTON_RIGHT:raton.button2:=true;
    end;
  end;
end;
end;

procedure evaluar_teclado(tevento:byte;keystate:PKeyStateArr);
begin
event.keyboard:=false;
case tevento of
  SDL_KEYUP:begin
          event.keyboard:=true;
          if (keystate[SDLK_ESCAPE]=0) then keyboard[SDLK_ESCAPE]:=false;
          if (keystate[SDLK_CAPSLOCK]=0) then keyboard[SDLK_CAPSLOCK]:=false;
          if (keystate[SDLK_TAB]=0) then keyboard[SDLK_TAB]:=false;
          if (keystate[SDLK_SLASH]=0) then keyboard[SDLK_SLASH]:=false;
          if (keystate[SDLK_QUOTE]=0) then keyboard[SDLK_QUOTE]:=false;
          if (keystate[SDLK_PERIOD]=0) then keyboard[SDLK_PERIOD]:=false;
          if (keystate[SDLK_SEMICOLON]=0) then keyboard[SDLK_SEMICOLON]:=false;
          if (keystate[SDLK_BACKSLASH]=0) then keyboard[SDLK_BACKSLASH]:=false;
          if (keystate[SDLK_LESS]=0) then keyboard[SDLK_LESS]:=false;
          if (keystate[SDLK_HOME]=0) then keyboard[SDLK_HOME]:=false;
          if (keystate[SDLK_INSERT]=0) then keyboard[SDLK_INSERT]:=false;
          if (keystate[SDLK_RIGHT]=0) then keyboard[SDLK_RIGHT]:=false;
          if (keystate[SDLK_LEFT]=0) then keyboard[SDLK_LEFT]:=false;
          if (keystate[SDLK_DOWN]=0) then keyboard[SDLK_DOWN]:=false;
          if (keystate[SDLK_UP]=0) then keyboard[SDLK_UP]:=false;
          if (keystate[SDLK_RALT]=0) then keyboard[SDLK_RALT]:=false;
          if (keystate[SDLK_LALT]=0) then keyboard[SDLK_LALT]:=false;
          if (keystate[SDLK_RSHIFT]=0) then keyboard[SDLK_RSHIFT]:=false;
          if (keystate[SDLK_LSHIFT]=0) then keyboard[SDLK_LSHIFT]:=false;
          if (keystate[SDLK_RCTRL]=0) then keyboard[SDLK_RCTRL]:=false;
          if (keystate[SDLK_LCTRL]=0) then keyboard[SDLK_LCTRL]:=false;
          if (keystate[SDLK_RETURN]=0) then keyboard[SDLK_RETURN]:=false;
          if (keystate[SDLK_BACKSPACE]=0) then keyboard[SDLK_BACKSPACE]:=false;
          if (keystate[SDLK_MINUS]=0) then keyboard[SDLK_MINUS]:=false;
          if (keystate[SDLK_COMMA]=0) then keyboard[SDLK_COMMA]:=false;
          if (keystate[SDLK_SPACE]=0) then keyboard[SDLK_SPACE]:=false;
          if (keystate[SDLK_0]=0) then keyboard[SDLK_0]:=false;
          if (keystate[SDLK_1]=0) then keyboard[SDLK_1]:=false;
          if (keystate[SDLK_2]=0) then keyboard[SDLK_2]:=false;
          if (keystate[SDLK_3]=0) then keyboard[SDLK_3]:=false;
          if (keystate[SDLK_4]=0) then keyboard[SDLK_4]:=false;
          if (keystate[SDLK_5]=0) then keyboard[SDLK_5]:=false;
          if (keystate[SDLK_6]=0) then keyboard[SDLK_6]:=false;
          if (keystate[SDLK_7]=0) then keyboard[SDLK_7]:=false;
          if (keystate[SDLK_8]=0) then keyboard[SDLK_8]:=false;
          if (keystate[SDLK_9]=0) then keyboard[SDLK_9]:=false;
          if (keystate[SDLK_F1]=0) then keyboard[SDLK_F1]:=false;
          if (keystate[SDLK_F2]=0) then keyboard[SDLK_F2]:=false;
          if (keystate[SDLK_F3]=0) then keyboard[SDLK_F3]:=false;
          if (keystate[SDLK_F4]=0) then keyboard[SDLK_F4]:=false;
          if (keystate[SDLK_F5]=0) then keyboard[SDLK_F5]:=false;
          if (keystate[SDLK_F6]=0) then keyboard[SDLK_F6]:=false;
          if (keystate[SDLK_F7]=0) then keyboard[SDLK_F7]:=false;
          if (keystate[SDLK_F8]=0) then keyboard[SDLK_F8]:=false;
          if (keystate[SDLK_F9]=0) then keyboard[SDLK_F9]:=false;
          if (keystate[SDLK_F10]=0) then keyboard[SDLK_F10]:=false;
          if (keystate[SDLK_F11]=0) then keyboard[SDLK_F11]:=false;
          if (keystate[SDLK_F12]=0) then keyboard[SDLK_F12]:=false;
          if (keystate[SDLK_A]=0) then keyboard[SDLK_A]:=false;
          if (keystate[SDLK_B]=0) then keyboard[SDLK_B]:=false;
          if (keystate[SDLK_C]=0) then keyboard[SDLK_C]:=false;
          if (keystate[SDLK_D]=0) then keyboard[SDLK_D]:=false;
          if (keystate[SDLK_E]=0) then keyboard[SDLK_E]:=false;
          if (keystate[SDLK_F]=0) then keyboard[SDLK_F]:=false;
          if (keystate[SDLK_G]=0) then keyboard[SDLK_G]:=false;
          if (keystate[SDLK_H]=0) then keyboard[SDLK_H]:=false;
          if (keystate[SDLK_I]=0) then keyboard[SDLK_I]:=false;
          if (keystate[SDLK_J]=0) then keyboard[SDLK_J]:=false;
          if (keystate[SDLK_K]=0) then keyboard[SDLK_K]:=false;
          if (keystate[SDLK_L]=0) then keyboard[SDLK_L]:=false;
          if (keystate[SDLK_M]=0) then keyboard[SDLK_M]:=false;
          if (keystate[SDLK_N]=0) then keyboard[SDLK_N]:=false;
          if (keystate[SDLK_O]=0) then keyboard[SDLK_O]:=false;
          if (keystate[SDLK_P]=0) then keyboard[SDLK_P]:=false;
          if (keystate[SDLK_Q]=0) then keyboard[SDLK_Q]:=false;
          if (keystate[SDLK_R]=0) then keyboard[SDLK_R]:=false;
          if (keystate[SDLK_S]=0) then keyboard[SDLK_S]:=false;
          if (keystate[SDLK_T]=0) then keyboard[SDLK_T]:=false;
          if (keystate[SDLK_U]=0) then keyboard[SDLK_U]:=false;
          if (keystate[SDLK_V]=0) then keyboard[SDLK_V]:=false;
          if (keystate[SDLK_W]=0) then keyboard[SDLK_W]:=false;
          if (keystate[SDLK_X]=0) then keyboard[SDLK_X]:=false;
          if (keystate[SDLK_Y]=0) then keyboard[SDLK_Y]:=false;
          if (keystate[SDLK_Z]=0) then keyboard[SDLK_Z]:=false;
          if (keystate[SDLK_EQUALS]=0) then keyboard[SDLK_EQUALS]:=false;
  end;
  SDL_KEYDOWN:begin
          event.keyboard:=true;
          if (keystate[SDLK_EQUALS]<>0) then keyboard[SDLK_EQUALS]:=true;
          if (keystate[SDLK_ESCAPE]<>0) then keyboard[SDLK_ESCAPE]:=true;
          if (keystate[SDLK_CAPSLOCK]<>0) then keyboard[SDLK_CAPSLOCK]:=true;
          if (keystate[SDLK_TAB]<>0) then keyboard[SDLK_TAB]:=true;
          if (keystate[SDLK_SLASH]<>0) then keyboard[SDLK_SLASH]:=true;
          if (keystate[SDLK_QUOTE]<>0) then keyboard[SDLK_QUOTE]:=true;
          if (keystate[SDLK_PERIOD]<>0) then keyboard[SDLK_PERIOD]:=true;
          if (keystate[SDLK_LESS]<>0) then keyboard[SDLK_LESS]:=true;
          if (keystate[SDLK_SEMICOLON]<>0) then keyboard[SDLK_SEMICOLON]:=true;
          if (keystate[SDLK_BACKSLASH]<>0) then keyboard[SDLK_BACKSLASH]:=true;
          if (keystate[SDLK_HOME]<>0) then keyboard[SDLK_HOME]:=true;
          if (keystate[SDLK_INSERT]<>0) then keyboard[SDLK_INSERT]:=true;
          if (keystate[SDLK_RIGHT]<>0) then keyboard[SDLK_RIGHT]:=true;
          if (keystate[SDLK_LEFT]<>0) then keyboard[SDLK_LEFT]:=true;
          if (keystate[SDLK_DOWN]<>0) then keyboard[SDLK_DOWN]:=true;
          if (keystate[SDLK_UP]<>0) then keyboard[SDLK_UP]:=true;
          if (keystate[SDLK_RALT]<>0) then keyboard[SDLK_RALT]:=true;
          if (keystate[SDLK_LALT]<>0) then keyboard[SDLK_LALT]:=true;
          if (keystate[SDLK_RSHIFT]<>0) then keyboard[SDLK_RSHIFT]:=true;
          if (keystate[SDLK_LSHIFT]<>0) then keyboard[SDLK_LSHIFT]:=true;
          if (keystate[SDLK_RCTRL]<>0) then keyboard[SDLK_RCTRL]:=true;
          if (keystate[SDLK_LCTRL]<>0) then keyboard[SDLK_LCTRL]:=true;
          if (keystate[SDLK_RETURN]<>0) then keyboard[SDLK_RETURN]:=true;
          if (keystate[SDLK_BACKSPACE]<>0) then keyboard[SDLK_BACKSPACE]:=true;
          if (keystate[SDLK_MINUS]<>0) then keyboard[SDLK_MINUS]:=true;
          if (keystate[SDLK_COMMA]<>0) then keyboard[SDLK_COMMA]:=true;
          if (keystate[SDLK_SPACE]<>0) then keyboard[SDLK_SPACE]:=true;
          if (keystate[SDLK_0]<>0) then keyboard[SDLK_0]:=true;
          if (keystate[SDLK_1]<>0) then keyboard[SDLK_1]:=true;
          if (keystate[SDLK_2]<>0) then keyboard[SDLK_2]:=true;
          if (keystate[SDLK_3]<>0) then keyboard[SDLK_3]:=true;
          if (keystate[SDLK_4]<>0) then keyboard[SDLK_4]:=true;
          if (keystate[SDLK_5]<>0) then keyboard[SDLK_5]:=true;
          if (keystate[SDLK_6]<>0) then keyboard[SDLK_6]:=true;
          if (keystate[SDLK_7]<>0) then keyboard[SDLK_7]:=true;
          if (keystate[SDLK_8]<>0) then keyboard[SDLK_8]:=true;
          if (keystate[SDLK_9]<>0) then keyboard[SDLK_9]:=true;
          if (keystate[SDLK_F1]<>0) then keyboard[SDLK_F1]:=true;
          if ((keystate[SDLK_F2]<>0) and (keyboard[SDLK_RSHIFT])) then keyboard[SDLK_F2]:=true;
          if ((keystate[SDLK_F3]<>0) and (keyboard[SDLK_RSHIFT])) then keyboard[SDLK_F3]:=true;
          if ((keystate[SDLK_F4]<>0) and not(main_screen.pantalla_completa) and ((keyboard[SDLK_RSHIFT]))) then keyboard[SDLK_F4]:=true;
          if (keystate[SDLK_F5]<>0) then keyboard[SDLK_F5]:=true;
          if (keystate[SDLK_F6]<>0) then keyboard[SDLK_F6]:=true;
          if (keystate[SDLK_F7]<>0) then keyboard[SDLK_F7]:=true;
          if (keystate[SDLK_F8]<>0) then keyboard[SDLK_F8]:=true;
          if (keystate[SDLK_F9]<>0) then keyboard[SDLK_F9]:=true;
          if (keystate[SDLK_F10]<>0) then keyboard[SDLK_F10]:=true;
          if (keystate[SDLK_F12]<>0) then keyboard[SDLK_F12]:=true;
          if (keystate[SDLK_A]<>0) then keyboard[SDLK_A]:=true;
          if (keystate[SDLK_B]<>0) then keyboard[SDLK_B]:=true;
          if (keystate[SDLK_C]<>0) then keyboard[SDLK_C]:=true;
          if (keystate[SDLK_D]<>0) then keyboard[SDLK_D]:=true;
          if (keystate[SDLK_E]<>0) then keyboard[SDLK_E]:=true;
          if (keystate[SDLK_F]<>0) then keyboard[SDLK_F]:=true;
          if (keystate[SDLK_G]<>0) then keyboard[SDLK_G]:=true;
          if (keystate[SDLK_H]<>0) then keyboard[SDLK_H]:=true;
          if (keystate[SDLK_I]<>0) then keyboard[SDLK_I]:=true;
          if (keystate[SDLK_J]<>0) then keyboard[SDLK_J]:=true;
          if (keystate[SDLK_K]<>0) then keyboard[SDLK_K]:=true;
          if (keystate[SDLK_L]<>0) then keyboard[SDLK_L]:=true;
          if (keystate[SDLK_M]<>0) then keyboard[SDLK_M]:=true;
          if (keystate[SDLK_N]<>0) then keyboard[SDLK_N]:=true;
          if (keystate[SDLK_O]<>0) then keyboard[SDLK_O]:=true;
          if (keystate[SDLK_P]<>0) then keyboard[SDLK_P]:=true;
          if (keystate[SDLK_Q]<>0) then keyboard[SDLK_Q]:=true;
          if (keystate[SDLK_R]<>0) then keyboard[SDLK_R]:=true;
          if (keystate[SDLK_S]<>0) then keyboard[SDLK_S]:=true;
          if (keystate[SDLK_T]<>0) then keyboard[SDLK_T]:=true;
          if (keystate[SDLK_U]<>0) then keyboard[SDLK_U]:=true;
          if (keystate[SDLK_V]<>0) then keyboard[SDLK_V]:=true;
          if (keystate[SDLK_W]<>0) then keyboard[SDLK_W]:=true;
          if (keystate[SDLK_X]<>0) then keyboard[SDLK_X]:=true;
          if (keystate[SDLK_Y]<>0) then keyboard[SDLK_Y]:=true;
          if (keystate[SDLK_Z]<>0) then keyboard[SDLK_Z]:=true;
  end;
end;
end;

procedure evalue_controls;
var
  keystate:PKeyStateArr;
  sdl_event:TSDL_Event;
begin
  if SDL_PollEvent(@sdl_event)=0 then exit;
  keystate:=PKeyStateArr(SDL_GetKeyState(nil));
  event.arcade:=false;
  event.keyboard:=false;
  event.mouse:=false;
  //Primero las teclas independientes de los drivers
  if ((keystate[SDLK_F3]<>0) and not(keyboard[SDLK_RSHIFT])) then Form1.Reset1Click(nil);
  if ((keystate[SDLK_F2]<>0) and not(keyboard[SDLK_RSHIFT])) then Form1.fFast(nil);
  if ((keystate[SDLK_F4]<>0) and not(main_screen.pantalla_completa) and not(keyboard[SDLK_RSHIFT])) then begin
      if addr(llamadas_maquina.grabar_snapshot)<>nil then llamadas_maquina.grabar_snapshot;
      keystate[SDLK_F4]:=0;
  end;
  if (keystate[SDLK_F11]<>0) then form1.fSlow(nil);
  //Arcade
  if event.earcade then begin
    evaluar_arcade_basic(sdl_event.type_,keystate);
    if arcade_input.use_key[0] then evaluar_arcade_keyb(sdl_event.type_,keystate,0)
      else evaluar_arcade_joy(sdl_event.type_,0);
    if arcade_input.use_key[1] then evaluar_arcade_keyb(sdl_event.type_,keystate,1)
      else evaluar_arcade_joy(sdl_event.type_,1);
  end;
  //Raton
  if event.emouse then evaluar_raton(sdl_event);
  //Joy Stick
  if event.ejoystick then begin
    if arcade_input.use_key[0] then evaluar_arcade_keyb(sdl_event.type_,keystate,0)
      else evaluar_arcade_joy(sdl_event.type_,0);
  end;
  //Teclado
  if event.ekeyboard then evaluar_teclado(sdl_event.type_,keystate);
end;

end.
