unit cpu_engine;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface

uses z80,m6809,m6502,m68000,m680x,tms32010,mb88xx,nec_v20_v30,
  hd6309,lr35902,m6805,mcs51,hu6280,pal_engine,main_engine;

var
  main_z80,snd_z80,misc_z80:preg_z80;
  main_z80_ll,snd_z80_ll,misc_z80_ll:llam_z80;
  main_6809,snd_6809,misc_6809:preg_6809;
  main_6809_ll,snd_6809_ll,misc_6809_ll:llam_6809;
  main_6309:preg_6309;
  main_6309_ll:llam_6309;
  main_6502,snd_6502:preg_6502;
  main_6502_ll,snd_6502_ll:llam_6502;
  main_68000,snd_68000:preg_68000;
  main_68000_ll,snd_68000_ll:llam_68000;
  main_6800_ll,snd_6800_ll:llam_6800;
  main_6800,snd_6800:preg_6800;
  cpu_tms32010:preg_tms32010;
  ll_tms32010:llam_tms32010;
  cpu_mb88xx:preg_mb88xx;
  ll_mb88xx:llam_mb88xx;
  main_nec:preg_nec;
  main_nec_ll:llam_nec;
  main_lr:preg_lr;
  main_lr_ll:llam_lr;
  main_6805:preg_6805;
  main_6805_ll:llam_6805;
  main_mcs51:preg_mcs51;
  main_mcs51_ll:llam_mcs51;
  main_h6280:preg_h6280;
  main_h6280_ll:llam_h6280;
  //Basic memory...
  memoria,mem_snd,mem_misc:array[0..$ffff] of byte;

const
  z80_main=0;
  z80_snd=1;
  z80_misc=2;
  m6809_main=3;
  m6809_snd=4;
  m6809_misc=5;
  m6502_main=6;
  m6502_snd=7;
  m68000_main=8;
  m68000_snd=9;
  m6800_main=10;
  m6800_snd=11;
  tms_32010=12;
  mb_88xx=13;
  nec_main=14;
  hd6309_main=15;
  lr35902_main=16;
  m6805_main=17;
  mcs51_main=18;
  deco16_main=19;
  nes_main=20;
  h6280_main=21;

procedure cerrar_cpus;
procedure init_cpu(cpu_type,num:byte;tframes:single);

implementation
uses principal;

procedure cerrar_cpus;
begin
if main_z80<>nil then begin
  freemem(main_z80);
  main_z80:=nil;
end;
if snd_z80<>nil then begin
  freemem(snd_z80);
  snd_z80:=nil;
end;
if misc_z80<>nil then begin
  freemem(misc_z80);
  misc_z80:=nil;
end;
if main_6809<>nil then begin
  freemem(main_6809);
  main_6809:=nil;
end;
if misc_6809<>nil then begin
  freemem(misc_6809);
  misc_6809:=nil;
end;
if snd_6809<>nil then begin
  freemem(snd_6809);
  snd_6809:=nil;
end;
if main_6502<>nil then begin
  freemem(main_6502);
  main_6502:=nil;
end;
if snd_6502<>nil then begin
  freemem(snd_6502);
  snd_6502:=nil;
end;
if main_68000<>nil then begin
  freemem(main_68000);
  main_68000:=nil;
end;
if snd_68000<>nil then begin
  freemem(snd_68000);
  snd_68000:=nil;
end;
if main_6800<>nil then begin
  freemem(main_6800);
  main_6800:=nil;
end;
if snd_6800<>nil then begin
  freemem(snd_6800);
  snd_6800:=nil;
end;
if cpu_tms32010<>nil then begin
  freemem(cpu_tms32010);
  cpu_tms32010:=nil;
end;
if cpu_mb88xx<>nil then begin
  freemem(cpu_mb88xx);
  cpu_mb88xx:=nil;
end;
if main_nec<>nil then begin
  freemem(main_nec);
  main_nec:=nil;
end;
if main_6309<>nil then begin
  freemem(main_6309);
  main_6309:=nil;
end;
if main_lr<>nil then begin
  freemem(main_lr);
  main_lr:=nil;
end;
if main_6805<>nil then begin
  freemem(main_6805);
  main_6805:=nil;
end;
if main_mcs51<>nil then begin
  freemem(main_mcs51);
  main_mcs51:=nil;
end;
if main_h6280<>nil then begin
  freemem(main_h6280);
  main_h6280:=nil;
end;
fillchar(paleta[0],max_colores*4,0);
fillchar(memoria[0],$10000,0);
fillchar(mem_snd[0],$10000,0);
fillchar(buffer_paleta[0],max_colores*2,1);
end;

procedure init_cpu(cpu_type,num:byte;tframes:single);
begin
  case cpu_type of
    z80_main:begin
                getmem(main_z80,sizeof(reg_z80));
                fillchar(main_z80^,sizeof(reg_z80),0);
                main_z80.numero_cpu:=num;
                main_z80.tframes:=tframes/llamadas_maquina.fps_max;
                main_z80.daisy:=false;
                main_z80_ll.outbyte:=nil;
                main_z80_ll.inbyte:=nil;
             end;
    z80_snd:begin
                getmem(snd_z80,sizeof(reg_z80));
                fillchar(snd_z80^,sizeof(reg_z80),0);
                snd_z80.numero_cpu:=num;
                snd_z80.tframes:=tframes/llamadas_maquina.fps_max;
                snd_z80.daisy:=false;
                snd_z80_ll.outbyte:=nil;
                snd_z80_ll.inbyte:=nil;
             end;
    z80_misc:begin
                getmem(misc_z80,sizeof(reg_z80));
                fillchar(misc_z80^,sizeof(reg_z80),0);
                misc_z80.numero_cpu:=num;
                misc_z80.tframes:=tframes/llamadas_maquina.fps_max;
                misc_z80.daisy:=false;
                misc_z80_ll.outbyte:=nil;
                misc_z80_ll.inbyte:=nil;
             end;
    m6809_main:begin
                getmem(main_6809,sizeof(reg_6809));
                fillchar(main_6809^,sizeof(reg_6809),0);
                main_6809.numero_cpu:=num;
                main_6809.tframes:=tframes/llamadas_maquina.fps_max;
               end;
    m6809_snd:begin
                getmem(snd_6809,sizeof(reg_6809));
                fillchar(snd_6809^,sizeof(reg_6809),0);
                snd_6809.numero_cpu:=num;
                snd_6809.tframes:=tframes/llamadas_maquina.fps_max;
               end;
    m6809_misc:begin
                getmem(misc_6809,sizeof(reg_6809));
                fillchar(misc_6809^,sizeof(reg_6809),0);
                misc_6809.numero_cpu:=num;
                misc_6809.tframes:=tframes/llamadas_maquina.fps_max;
               end;
    m6502_main:begin
                getmem(main_6502,sizeof(reg_6502));
                fillchar(main_6502^,sizeof(reg_6502),0);
                main_6502.numero_cpu:=num;
                main_6502.tipo_cpu:=CPU_M6502;
                main_6502.tframes:=tframes/llamadas_maquina.fps_max;
               end;
    m6502_snd:begin
                getmem(snd_6502,sizeof(reg_6502));
                fillchar(snd_6502^,sizeof(reg_6502),0);
                snd_6502.numero_cpu:=num;
                snd_6502.tipo_cpu:=CPU_M6502;
                snd_6502.tframes:=tframes/llamadas_maquina.fps_max;
               end;
    m68000_main:begin
                getmem(main_68000,sizeof(reg_68000));
                fillchar(main_68000^,sizeof(reg_68000),0);
                main_68000.numero_cpu:=num;
                main_68000.tframes:=tframes/llamadas_maquina.fps_max;
               end;
    m68000_snd:begin
                getmem(snd_68000,sizeof(reg_68000));
                fillchar(snd_68000^,sizeof(reg_68000),0);
                snd_68000.numero_cpu:=num;
                snd_68000.tframes:=tframes/llamadas_maquina.fps_max;
               end;
    m6800_main:begin
                getmem(main_6800,sizeof(reg_6800));
                fillchar(main_6800^,sizeof(reg_6800),0);
                main_6800.numero_cpu:=num;
                main_6800.tframes:=tframes/4/llamadas_maquina.fps_max;
                main_6800_ll.out_port1:=nil;
                main_6800_ll.out_port2:=nil;
                main_6800_ll.out_port3:=nil;
                main_6800_ll.out_port4:=nil;
                main_6800_ll.in_port1:=nil;
                main_6800_ll.in_port2:=nil;
                main_6800_ll.in_port3:=nil;
                main_6800_ll.in_port4:=nil;
               end;
    m6800_snd:begin
                getmem(snd_6800,sizeof(reg_6800));
                fillchar(snd_6800^,sizeof(reg_6800),0);
                snd_6800.numero_cpu:=num;
                snd_6800.tframes:=tframes/4/llamadas_maquina.fps_max;
                snd_6800_ll.out_port1:=nil;
                snd_6800_ll.out_port2:=nil;
                snd_6800_ll.out_port3:=nil;
                snd_6800_ll.out_port4:=nil;
                snd_6800_ll.in_port1:=nil;
                snd_6800_ll.in_port2:=nil;
                snd_6800_ll.in_port3:=nil;
                snd_6800_ll.in_port4:=nil;
               end;
    tms_32010:begin
                getmem(cpu_tms32010,sizeof(reg_tms32010));
                fillchar(cpu_tms32010^,sizeof(reg_tms32010),0);
                cpu_tms32010.numero_cpu:=num;
                cpu_tms32010.tframes:=tframes/4/llamadas_maquina.fps_max;
              end;
    mb_88xx:begin
                getmem(cpu_mb88xx,sizeof(reg_mb88xx));
                fillchar(cpu_mb88xx^,sizeof(reg_mb88xx),0);
                cpu_mb88xx.numero_cpu:=num;
                cpu_mb88xx.tframes:=tframes/6/llamadas_maquina.fps_max;
                ll_mb88xx.port_k:=nil;
                ll_mb88xx.port_p_r:=nil;
                ll_mb88xx.port_o:=nil;
                ll_mb88xx.port_p_w:=nil;
                ll_mb88xx.port_r_r:=nil;
                ll_mb88xx.port_r_w:=nil;
            end;
    nec_main:begin
                getmem(main_nec,sizeof(reg_nec));
                fillchar(main_nec^,sizeof(reg_nec),0);
                main_nec.numero_cpu:=num;
                main_nec.tframes:=tframes/llamadas_maquina.fps_max;
             end;
    hd6309_main:begin
                getmem(main_6309,sizeof(reg_6309));
                fillchar(main_6309^,sizeof(reg_6309),0);
                main_6309.numero_cpu:=num;
                main_6309.tframes:=tframes/4/llamadas_maquina.fps_max;
               end;
    lr35902_main:begin
                getmem(main_lr,sizeof(reg_lr));
                fillchar(main_lr^,sizeof(reg_lr),0);
                main_lr.numero_cpu:=num;
                main_lr.tframes:=tframes/llamadas_maquina.fps_max;
               end;
    m6805_main:begin
                getmem(main_6805,sizeof(reg_6805));
                fillchar(main_6805^,sizeof(reg_6805),0);
                main_6805.numero_cpu:=num;
                main_6805.tframes:=tframes/4/llamadas_maquina.fps_max;
               end;
    mcs51_main:begin
                getmem(main_mcs51,sizeof(reg_mcs51));
                fillchar(main_mcs51^,sizeof(reg_mcs51),0);
                main_mcs51.numero_cpu:=num;
                main_mcs51.tframes:=tframes/12/llamadas_maquina.fps_max;
                main_mcs51_ll.out_port0:=nil;
                main_mcs51_ll.out_port1:=nil;
                main_mcs51_ll.out_port2:=nil;
                main_mcs51_ll.out_port3:=nil;
                main_mcs51_ll.in_port0:=nil;
                main_mcs51_ll.in_port1:=nil;
                main_mcs51_ll.in_port2:=nil;
                main_mcs51_ll.in_port3:=nil;
               end;
    deco16_main:begin
                getmem(main_6502,sizeof(reg_6502));
                fillchar(main_6502^,sizeof(reg_6502),0);
                main_6502.numero_cpu:=num;
                main_6502.tipo_cpu:=CPU_DECO16;
                main_6502.tframes:=tframes/llamadas_maquina.fps_max;
                main_6502_ll.deco16_io[0]:=nil;
                main_6502_ll.deco16_io[1]:=nil;
               end;
    nes_main:begin
                getmem(main_6502,sizeof(reg_6502));
                fillchar(main_6502^,sizeof(reg_6502),0);
                main_6502.numero_cpu:=num;
                main_6502.tipo_cpu:=CPU_NES;
                main_6502.tframes:=tframes/llamadas_maquina.fps_max;
               end;
    h6280_main:begin
                getmem(main_h6280,sizeof(reg_h6280));
                fillchar(main_h6280^,sizeof(reg_h6280),0);
                main_h6280.numero_cpu:=num;
                main_h6280.tframes:=tframes/llamadas_maquina.fps_max;
               end;
  end;
end;

end.
