unit main_engine;

{$ifdef fpc}{$mode delphi}{$H+}{$DEFINE IN_LAZARUS}{$endif}

interface
uses sdl,{$IFDEF WINDOWS}windows,{$ENDIF}
     {$ifdef linux}LCLType,{$endif}
     controls,forms,sysutils,misc_functions,pal_engine,timer_engine,
     gfx_engine,sound_engine,arcade_config;

const
        pant_sprites=20;
        pant_doble=21;
        pant_rot=22;
        max_pantalla=22;
        max_pant_visible=19;

        CLEAR_LINE=0;
        HOLD_LINE=1;
        ASSERT_LINE=2;
        PULSE_LINE=3;
        INPUT_LINE_NMI=$20;

        MAX_DIP_VALUES=$f;

        MAX_PUNBUF=768;

type
        tllamadas_globales = record
           iniciar:function:boolean;
           bucle_general:procedure;
           reset:procedure;
           cerrar:procedure;
           cintas:function:boolean;
           cartuchos:function:boolean;
           grabar_snapshot:procedure;
           caption:string;
           configurar:procedure;
           acepta_config:procedure;
           fps_max:single;
           velocidad_cpu:dword;
           end;
        scroll_tipo=record
          long_x,long_y:word;  //Longitud de la pantalla
          max_x,max_y:word;    //Longitud que debe copiar
          mask_x,mask_y:word;  //Mascara del scroll
        end;
        Parejas = record
          case byte of
             0: (l, h: byte);
             1: (w: Word);
          end;
        pparejas=^parejas;
        DParejas = record
          case byte of
             0: (l0,h0,l1,h1: byte);
             1: (wl,wh: Word);
             2: (l:dword);
          end;
        pdparejas=^dparejas;
        tpantalla=record
                x:word;  //ancho
                y:word;  //alto
                x_real,y_real:word; //tamao real en caso de rotacion
                trans:boolean;  //es transparente?
                final_mix:boolean;
                sprite_end_x,sprite_end_y,sprite_mask_x,sprite_mask_y:word;
                scroll:scroll_tipo;
        end;
        tmain_screen=record
          video_mode:byte;
          flip_main_screen,rot90_screen,rol90_screen,pantalla_completa,rapido:boolean;
        end;
        def_dip_value=record
          dip_val:word;
          dip_name:string;
        end;
        def_dip=record
          mask:word;
          name:string;
          number:byte;
          dip:array[0..MAX_DIP_VALUES] of def_dip_value;
        end;
        pdef_dip=^def_dip;
        TEmuStatus=(EsPause, EsRuning, EsStoped);

//Video
procedure iniciar_video;
procedure close_video;
procedure cambiar_video;
procedure pasar_pantalla_completa;
//Update final screen
procedure actualiza_trozo_principal(x1,y1,x2,y2:word);
procedure actualiza_trozo(o_x1,o_y1,o_x2,o_y2:word;sitio:byte;d_x1,d_y1,d_x2,d_y2:word;dest:byte);
procedure actualiza_trozo_final(o_x1,o_y1,o_x2,o_y2:word;sitio:byte);
procedure video_sync;
//misc
procedure change_caption(nombre:string);
procedure reset_dsp;
//linux misc
{$ifdef linux}
procedure copymemory(dest,source:pointer;size:integer);
{$endif}

var
        //video
        p_final:array[0..max_pantalla] of tpantalla;
        pantalla:array[0..max_pantalla] of PSDL_Surface;
        punbuf:pword;
        main_screen:tmain_screen;
        videoflags:dword=0;
        //Misc
        llamadas_maquina:tllamadas_globales;
        {$ifdef windows}
        cont_sincroniza,cont_micro:int64;
        valor_sync:single;
        {$endif}
        {$ifdef linux}
        cont_sincroniza:dword;
        cont_micro,valor_sync:single;
        {$endif}
        EmuStatus,EmuStatusTemp:TEmuStatus;

implementation
uses principal,controls_engine;

procedure cambiar_video;
//Si el sistema usa la pantalla SDL arreglos visuales
procedure uses_sdl_window;
begin
{$ifdef linux}
form1.groupbox4.visible:=false;
{$endif}
case main_vars.tipo_maquina of
     0..9,1000..1003:begin
             fix_screen_pos(350,110);
             form1.Panel2.width:=350;
             form1.Panel2.height:=49;
             form1.Panel2.Align:=alLeft;
             form1.Panel2.Anchors:=[akTop,akLeft,akRight];
             form1.BitBtn9.top:=4;
             form1.BitBtn9.left:=24;
             form1.BitBtn10.top:=4;
             form1.BitBtn10.left:=64;
             form1.BitBtn11.top:=4;
             form1.BitBtn11.left:=111;
             form1.BitBtn12.top:=4;
             form1.BitBtn12.left:=159;
             form1.BitBtn14.top:=4;
             form1.BitBtn14.left:=206;
          end;
     else fix_screen_pos(350,70);
end;
end;

var
  x,y:word;
begin
x:=p_final[0].x*mul_video;
y:=p_final[0].y*mul_video;
pantalla[0]:=SDL_SetVideoMode(x,y,16,videoflags);
form1.n1x1.Checked:=false;
form1.n2x1.Checked:=false;
form1.scanlines1.Checked:=false;
form1.scanlines2x1.Checked:=false;
form1.n3x1.Checked:=false;
form1.FullScreen1.Checked:=false;
case main_screen.video_mode of
  1:form1.n1x1.Checked:=true;
  2:form1.n2x1.Checked:=true;
  3:form1.scanlines1.Checked:=true;
  4:form1.scanlines2x1.Checked:=true;
  5:form1.n3x1.Checked:=true;
  6:form1.FullScreen1.checked:=true;
end;
//Si el video el *2 necesito una temporal
pantalla[pant_doble]:=SDL_AllocSurface(videoflags,x,y,16,pantalla[0].format.RMask,pantalla[0].format.GMask,pantalla[0].format.BMask,pantalla[0].format.AMask);
{$IFDEF IN_DELPHI}
if main_screen.pantalla_completa then begin
  child.clientWidth:=50;
  child.clientHeight:=50;
end else begin
  child.clientWidth:=x;
  child.clientHeight:=y;
end;
x:=child.width;
case main_vars.tipo_maquina of
  0..9:x:=x+60;
  10..999:begin
       if x<260 then x:=260;
        x:=x+10;
       end;
    else begin
      if x<260 then x:=260;
      x:=x+60;
  end;
end;
fix_screen_pos(x,child.height+60);
if form1.Panel2.visible then x:=x-60;
child.Left:=(x-child.width) div 2;
{$endif}
{$ifdef IN_LAZARUS}
//Arreglos visuales...
{$ifdef linux}
//En linux uso la pantalla de SDL...
uses_sdl_window;
{$else}
if main_screen.pantalla_completa then begin
  form1.panel4.Width:=50;
  form1.panel4.Height:=50;
end else begin
  form1.panel4.Width:=x;
  form1.panel4.Height:=y;
  form1.GroupBox4.Width:=x+15;
  form1.GroupBox4.Height:=y+25;
end;
if main_vars.tipo_maquina<10 then begin
  form1.groupbox1.Left:=x+23;
  x:=x+70;
end else begin
  if main_vars.tipo_maquina<1000 then begin
    if x<230 then x:=230;
    x:=x+20;
  end else begin
    if x<180 then x:=180;
    x:=x+70;
  end;
end;
y:=y+90;
fix_screen_pos(x,y);
if ((main_vars.tipo_maquina<1000) and (main_vars.tipo_maquina>9)) then form1.groupbox4.Left:=((form1.Width-form1.panel4.width) div 2)-6
  else if (main_vars.tipo_maquina<10) then form1.groupbox4.Left:=0;
form1.panel4.top:=0;
form1.Panel4.Left:=5;
{$endif}
{$endif}
//pongo el nombre de la maquina...
change_caption(llamadas_maquina.caption);
end;

procedure InicializeSDL;
var
  videoInfo:PSDL_VideoInfo;
begin
// Initialize the SDL library
  {$ifdef windows}
  if (SDL_init(SDL_INIT_VIDEO or SDL_INIT_JOYSTICK or SDL_INIT_NOPARACHUTE)<0) then halt(0);
  {$endif}
  {$ifdef linux}
  if (SDL_init(SDL_INIT_VIDEO or SDL_INIT_JOYSTICK or SDL_INIT_NOPARACHUTE or SDL_INIT_AUDIO)<0) then halt(0);
  {$endif}
  //Fetch the video info
  videoInfo:=SDL_GetVideoInfo;
  videoFlags:=videoFlags or SDL_DOUBLEBUF;  // Enable double buffering
  if main_screen.pantalla_completa then videoFlags:=videoFlags or SDL_FULLSCREEN;
  //This checks to see if surfaces can be stored in memory
  if (videoInfo.hw_available<>0) then videoFlags:=videoFlags or SDL_HWSURFACE
    else videoFlags := videoFlags or SDL_SWSURFACE;
  //This checks if hardware blits can be done
  if (videoInfo.blit_hw<>0) then videoFlags:=videoFlags or SDL_HWACCEL;
end;

procedure iniciar_video;
var
  f:word;
  h:byte;
begin
if videoflags=0 then inicializeSDL;
//Puntero general del pixels
getmem(punbuf,MAX_PUNBUF);
//creo la pantalla general
cambiar_video;
//Creo la pantalla de los sprites
pantalla[pant_sprites]:=SDL_AllocSurface(videoflags,64,64,16,pantalla[0].format.RMask,pantalla[0].format.GMask,pantalla[0].format.BMask,pantalla[0].format.AMask);
SDL_Setcolorkey(pantalla[pant_sprites],SDL_SRCCOLORKEY,set_trans_color);
paleta[max_colores]:=set_trans_color;
//Pantallas restantes
for f:=1 to max_pant_visible do
  if p_final[f].x<>0 then begin                  //Aado 32 por la derecha y 32 por la izquierda
    if p_final[f].final_mix then begin
      if p_final[f].sprite_end_x=0 then p_final[f].sprite_end_x:=p_final[f].x;
      if p_final[f].sprite_mask_x=0 then p_final[f].sprite_mask_x:=p_final[f].x-1;
      if p_final[f].sprite_end_y=0 then p_final[f].sprite_end_y:=p_final[f].y;
      if p_final[f].sprite_mask_y=0 then p_final[f].sprite_mask_y:=p_final[f].y-1;
      p_final[f].x:=p_final[f].x+64;
      p_final[f].y:=p_final[f].y+64;
      pantalla[pant_rot]:=SDL_AllocSurface(videoflags,p_final[f].x,p_final[f].y,16,pantalla[0].format.RMask,pantalla[0].format.GMask,pantalla[0].format.BMask,pantalla[0].format.AMask);
    end;
    pantalla[f]:=SDL_AllocSurface(videoflags,p_final[f].x,p_final[f].y,16,pantalla[0].format.RMask,pantalla[0].format.GMask,pantalla[0].format.BMask,pantalla[0].format.AMask);
    //Y si son transparentes las creo
    if p_final[f].trans then SDL_Setcolorkey(pantalla[f],SDL_SRCCOLORKEY,set_trans_color);
  end;
//reseterar todas las variables
for h:=0 to 5 do begin
    for f:=0 to max_colors-1 do gfx[h].colores[f]:=f;
    fillchar(gfx[h].trans,32,0);
    fillchar(gfx[h].buffer,$800,1);
end;
sdl_showcursor(0);
end;

procedure pasar_pantalla_completa;
begin
exit;
if not(main_screen.pantalla_completa) then pantalla[0]:=SDL_SetVideoMode(p_final[0].x,p_final[0].y,16,videoflags or SDL_FULLSCREEN)
  else pantalla[0]:=SDL_SetVideoMode(p_final[0].x,p_final[0].y,16,videoflags);
main_screen.pantalla_completa:=not(main_screen.pantalla_completa);
end;

procedure close_video;
var
  h:byte;
  f:word;
begin
//reseterar todas las variables
for h:=0 to 5 do begin
    if gfx[h].datos<>nil then freemem(gfx[h].datos);
    gfx[h].datos:=nil;
end;
for f:=0 to max_pantalla do begin
  if pantalla[f]<>nil then SDL_FreeSurface(pantalla[f]);
  pantalla[f]:=nil;
  fillchar(p_final[f],sizeof(tpantalla),0);
end;
if punbuf<>nil then freemem(punbuf);
punbuf:=nil;
end;

procedure actualiza_trozo_principal(x1,y1,x2,y2:word);
var
  punt,punt2,punt3,punt4:pword;
  f,i,h:word;
begin
if main_screen.flip_main_screen then begin
  h:=0;
  for i:=pantalla[0].h-1 downto 0 do begin
    punt:=pantalla[0].pixels;
    inc(punt,(i*pantalla[0].pitch) shr 1);
    punt2:=pantalla[pant_doble].pixels;
    inc(punt2,(h*pantalla[pant_doble].pitch+(p_final[0].x*2)-2) shr 1);
    h:=h+1;
    for f:=p_final[0].x-1 downto 0 do begin
      punt2^:=punt^;
      inc(punt);
      inc(punt2);
    end;
  end;
  actualiza_trozo(0,0,p_final[0].x,p_final[0].y,pant_doble,0,0,p_final[0].x,p_final[0].y,0);
end;
case main_screen.video_mode of
  1:begin
      actualiza_trozo(x1,y1,x2,y2,pant_doble,x1,y1,x2,y2,0);
      SDL_UpdateRect(pantalla[0],x1,y1,x2,y2);
    end;
  2:begin
        for i:=y1 to (y1+(y2-1)) do begin
         punt:=pantalla[pant_doble].pixels;
         inc(punt,(i*pantalla[pant_doble].pitch+x1*2) shr 1);
         punt2:=pantalla[0].pixels;
         inc(punt2,((i*2)*pantalla[0].pitch+x1*4) shr 1);
         punt3:=pantalla[0].pixels;
         inc(punt3,(((i*2)+1)*pantalla[0].pitch+x1*4) shr 1);
         for f:=x1 to (x1+x2-1) do begin
          punt2^:=punt^;
          punt3^:=punt^;
          inc(punt2);
          inc(punt3);
          punt2^:=punt^;
          punt3^:=punt^;
          inc(punt2);
          inc(punt3);
          inc(punt);
         end;
        end;
        SDL_UpdateRect(pantalla[0],x1*2,y1*2,x2*2,y2*2);
        end;
  3:begin
      if (y1 and 1)=1 then exit;
      for i:=y1 to (y1+(y2-1)) do begin
        punt:=pantalla[pant_doble].pixels;
        inc(punt,(i*pantalla[pant_doble].pitch+x1*2) shr 1);
        punt2:=pantalla[0].pixels;
        inc(punt2,(i*pantalla[0].pitch+x1*2) shr 1);
        for f:=x1 to (x1+x2-1) do begin
          punt2^:=punt^;
          inc(punt);
          inc(punt2);
        end;
      end;
      SDL_UpdateRect(pantalla[0],x1,y1,x2,y2);
    end;
  4:begin
        for i:=y1 to (y1+(y2-1)) do begin
         punt:=pantalla[pant_doble].pixels;
         inc(punt,(i*pantalla[pant_doble].pitch+x1*2) shr 1);
         punt2:=pantalla[0].pixels;
         inc(punt2,((i*2)*pantalla[0].pitch+x1*4) shr 1);
         for f:=x1 to (x1+x2-1) do begin
          punt2^:=punt^;
          inc(punt2);
          punt2^:=punt^;
          inc(punt2);
          inc(punt);
         end;
        end;
        SDL_UpdateRect(pantalla[0],x1*2,y1*2,x2*2,y2*2);
        end;
  5:begin
        for i:=y1 to (y1+(y2-1)) do begin
         punt:=pantalla[pant_doble].pixels;
         inc(punt,(i*pantalla[pant_doble].pitch+x1*2) shr 1);
         punt2:=pantalla[0].pixels;
         inc(punt2,((i*3)*pantalla[0].pitch+x1*3*2) shr 1);
         punt3:=pantalla[0].pixels;
         inc(punt3,(((i*3)+1)*pantalla[0].pitch+x1*3*2) shr 1);
         punt4:=pantalla[0].pixels;
         inc(punt4,(((i*3)+2)*pantalla[0].pitch+x1*3*2) shr 1);
         for f:=x1 to (x1+x2-1) do begin
          for h:=0 to 2 do begin
            punt2^:=punt^;
            punt3^:=punt^;
            punt4^:=punt^;
            inc(punt2);
            inc(punt3);
            inc(punt4);
          end;
            inc(punt);
         end;
         SDL_UpdateRect(pantalla[0],x1*3,y1*3,x2*3,y2*3);
        end;
      end;
  end;
end;

procedure actualiza_trozo(o_x1,o_y1,o_x2,o_y2:word;sitio:byte;d_x1,d_y1,d_x2,d_y2:word;dest:byte);
var
  origen,destino:sdl_rect;
begin
origen.x:=o_x1;
origen.y:=o_y1;
origen.w:=o_x2;
origen.h:=o_y2;
destino.x:=d_x1;
destino.y:=d_y1;
destino.w:=d_x2;
destino.h:=d_y2;
if p_final[dest].final_mix then begin
  destino.x:=destino.x+32;
  destino.y:=destino.y+32;
end;
SDL_BlitSurface(pantalla[sitio],@origen,pantalla[dest],@destino);
end;

procedure actualiza_trozo_final(o_x1,o_y1,o_x2,o_y2:word;sitio:byte);
var
  origen,destino:sdl_rect;
  y,x:word;
  porig,pdest:pword;
  orig_p,dest_p:word;
begin
if main_screen.rot90_screen then begin
  orig_p:=pantalla[sitio].pitch shr 1;
  dest_p:=pantalla[pant_rot].pitch shr 1;
  for y:=0 to (p_final[0].x_real+47) do begin
    porig:=pantalla[sitio].pixels;
    inc(porig,y*orig_p);
    pdest:=pantalla[pant_rot].pixels;
    inc(pdest,p_final[0].x_real+63-y);
    for x:=0 to (p_final[0].y_real+63) do begin
      pdest^:=porig^;
      inc(porig);
      inc(pdest,dest_p);
    end;
  end;
  sitio:=pant_rot;
  origen.y:=o_x1+32;
  origen.x:=o_y1+32;
  origen.h:=o_x2;
  origen.w:=o_y2;
end else begin
if main_screen.rol90_screen then begin
  orig_p:=pantalla[sitio].pitch shr 1;
  dest_p:=pantalla[pant_rot].pitch shr 1;
  for y:=0 to (p_final[0].x_real+47) do begin
    porig:=pantalla[sitio].pixels;
    inc(porig,y*orig_p);
    pdest:=pantalla[pant_rot].pixels;
    inc(pdest,(p_final[0].x_real+63)*dest_p+y);
    for x:=0 to (p_final[0].y_real+63) do begin
      pdest^:=porig^;
      inc(porig);
      dec(pdest,dest_p);
    end;
  end;
  sitio:=pant_rot;
  origen.y:=o_x1+32;
  origen.x:=o_y1+32;
  origen.h:=o_x2;
  origen.w:=o_y2;
end else begin
  origen.x:=o_x1+32;
  origen.y:=o_y1+32;
  origen.w:=o_x2;
  origen.h:=o_y2;
end;
end;
destino.x:=0;
destino.y:=0;
destino.w:=pantalla[0].w;
destino.h:=pantalla[0].h;
SDL_BlitSurface(pantalla[sitio],@origen,pantalla[0],@destino);
end;

procedure actualiza_video;
var
  punt,punt2,punt3,punt4:pword;
  f,i,h:word;
begin
if main_screen.flip_main_screen then begin
  h:=0;
  for i:=p_final[0].y-1 downto 0 do begin
    punt:=pantalla[0].pixels;
    inc(punt,(i*pantalla[0].pitch) shr 1);
    punt2:=pantalla[pant_doble].pixels;
    inc(punt2,((h*pantalla[pant_doble].pitch) shr 1)+(p_final[0].x-1));
    h:=h+1;
    for f:=p_final[0].x-1 downto 0 do begin
      punt2^:=punt^;
      inc(punt);
      dec(punt2);
    end;
  end;
  actualiza_trozo(0,0,p_final[0].x,p_final[0].y,pant_doble,0,0,p_final[0].x,p_final[0].y,0);
end;
case main_screen.video_mode of
  1:;
  2:begin
        for i:=0 to p_final[0].y-1 do begin
          punt:=pantalla[0].pixels;
          inc(punt,(i*pantalla[0].pitch) shr 1);
          punt2:=pantalla[pant_doble].pixels;
          inc(punt2,((i*2)*pantalla[pant_doble].pitch) shr 1);
          punt3:=pantalla[pant_doble].pixels;
          inc(punt3,(((i*2)+1)*pantalla[pant_doble].pitch) shr 1);
          for f:=0 to p_final[0].x-1 do begin
              punt2^:=punt^;
              punt3^:=punt^;
              inc(punt2);
              inc(punt3);
              punt2^:=punt^;
              punt3^:=punt^;
              inc(punt2);
              inc(punt3);
              inc(punt);
          end;
       end;
       actualiza_trozo(0,0,p_final[0].x*2,p_final[0].y*2,pant_doble,0,0,p_final[0].x*2,p_final[0].y*2,0);
    end;
  3:begin
        for i:=0 to (p_final[0].y div 2)-1 do begin
           punt:=pantalla[0].pixels;
           inc(punt,((i*2)* pantalla[0].pitch) shr 1);
           punt2:=pantalla[pant_doble].pixels;
           inc(punt2,((i*2)*pantalla[pant_doble].pitch) shr 1);
           copymemory(punt2,punt,p_final[0].x*2);
        end;
        actualiza_trozo(0,0,p_final[0].x,p_final[0].y,pant_doble,0,0,p_final[0].x,p_final[0].y,0);
        end;
  4:begin
        for i:=0 to p_final[0].y-1 do begin
           punt:=pantalla[0].pixels;
           inc(punt,(i*pantalla[0].pitch) shr 1);
           punt2:=pantalla[pant_doble].pixels;
           inc(punt2,((i*2)*pantalla[pant_doble].pitch) shr 1);
           for f:=0 to p_final[0].x-1 do begin
              punt2^:=punt^;
              inc(punt2);
              punt2^:=punt^;
              inc(punt2);
              inc(punt);
           end;
        end;
        actualiza_trozo(0,0,p_final[0].x*2,p_final[0].y*2,pant_doble,0,0,p_final[0].x*2,p_final[0].y*2,0);
    end;
  5:begin
        for i:=0 to p_final[0].y-1 do begin
           punt:=pantalla[0].pixels;
           inc(punt,(i*pantalla[0].pitch) shr 1);
           punt2:=pantalla[pant_doble].pixels;
           inc(punt2,((i*3)*pantalla[pant_doble].pitch) shr 1);
           punt3:=pantalla[pant_doble].pixels;
           inc(punt3,(((i*3)+1)*pantalla[pant_doble].pitch) shr 1);
           punt4:=pantalla[pant_doble].pixels;
           inc(punt4,(((i*3)+2)*pantalla[pant_doble].pitch) shr 1);
           for f:=0 to p_final[0].x-1 do begin
              for h:=0 to 2 do begin
                punt2^:=punt^;
                punt3^:=punt^;
                punt4^:=punt^;
                inc(punt2);
                inc(punt3);
                inc(punt4);
              end;
              inc(punt);
           end;
        end;
        actualiza_trozo(0,0,p_final[0].x*3,p_final[0].y*3,pant_doble,0,0,p_final[0].x*3,p_final[0].y*3,0);
        end;
  end;
SDL_Flip(pantalla[0])
end;

procedure change_caption(nombre:string);
begin
{$IFDEF IN_DELPHI}
  child.Caption:=nombre;
{$ENDIF}
{$IFDEF IN_LAZARUS}
  {$ifdef linux}
  SDL_WM_SetCaption(pchar(nombre),nil);
  {$else}
  form1.GroupBox4.Caption:=nombre;
  {$endif}
{$ENDIF}
end;

{$ifdef windows}
procedure video_sync;
var
        l2:int64;
        res:single;
begin
main_vars.frames_sec:=main_vars.frames_sec+1;
actualiza_video;
evalue_controls;
if main_screen.rapido then exit;
QueryPerformanceCounter(Int64((@l2)^));
res:=(l2-cont_sincroniza);
while (res<valor_sync) do begin
  QueryPerformanceCounter(Int64((@l2)^));
  res:=(l2-cont_sincroniza);
end;
QueryPerformanceCounter(Int64((@cont_sincroniza)^));
end;
{$endif}

{$ifdef linux}
procedure copymemory(dest,source:pointer;size:integer);inline;
begin
move(source^,dest^,size);
end;

procedure video_sync;
var
  res:dword;
begin
application.ProcessMessages;
main_vars.frames_sec:=main_vars.frames_sec+1;
actualiza_video;
evalue_controls;
if main_screen.rapido then exit;
res:=0;
while res<valor_sync do res:=sdl_getticks()-cont_sincroniza;
valor_sync:=cont_micro-(res-valor_sync);
cont_sincroniza:=sdl_getticks();
end;
{$endif}

procedure reset_dsp;
begin
llamadas_maquina.cartuchos:=nil;
llamadas_maquina.grabar_snapshot:=nil;
llamadas_maquina.cintas:=nil;
llamadas_maquina.iniciar:=nil;
llamadas_maquina.reset:=nil;
llamadas_maquina.cerrar:=nil;
if ((main_vars.tipo_maquina>9) and (main_vars.tipo_maquina<1000)) then llamadas_maquina.configurar:=arcade_config.activate_arcade_config
  else llamadas_maquina.configurar:=nil;
llamadas_maquina.acepta_config:=nil;
llamadas_maquina.bucle_general:=nil;
llamadas_maquina.fps_max:=60;
main_vars.vactual:=0;
fila_dibujo:=0;
main_vars.mensaje_general:='';
sound_status.canales_usados:=-1;
form1.timer1.Enabled:=false;
main_screen.rot90_screen:=false;
main_screen.rol90_screen:=false;
main_screen.flip_main_screen:=false;
main_screen.rapido:=false;
reset_timer;
marcade.dswa_val:=nil;
marcade.dswb_val:=nil;
marcade.dswc_val:=nil;
{$ifdef linux}
cont_sincroniza:=sdl_getticks();
{$endif}
end;

end.
