unit misc_functions;

{$ifdef fpc}{$mode delphi}{$H+}{$DEFINE IN_LAZARUS}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     {$ifdef IN_DELPHI}pngimage,{$endif}
     {$IFDEF IN_LAZARUS}crc,{$ENDIF}
     sysutils,forms,controls;
type
  TSistema = (StNes, StColecovision, STGb, StChip8);

function sacar_word(datos:pbyte):word;inline;
function extension_fichero(nombre:string):string;
procedure fix_screen_pos(width,height:word);
function calc_crc(p: pointer; ByteCount:dword):dword;
function mul_video:byte;
//bit func
function bit(data:word;bitpos:byte):boolean;
function bit_n(data:dword;bitpos:byte):byte;
function BITSWAP8(val,B7,B6,B5,B4,B3,B2,B1,B0:byte):byte;
function BITSWAP16(val:word;B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0:byte):word;
function BITSWAP24(val:dword;B23,B22,B21,B20,B19,B18,B17,B16,B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0:byte):dword;
//Open Systems ROM
function OpenRom(Sistema:TSistema;var name:string):boolean;

implementation
uses principal,main_engine;

function sacar_word(datos:pbyte):word;inline;
var
  salida:word;
begin
salida:=datos^;
inc(datos);
sacar_word:=salida+(datos^ shl 8);
end;

procedure fix_screen_pos(width,height:word);
begin
{$ifdef linux}
form1.BorderStyle:=bsSizeable;
{$endif}
{$IFDEF IN_DELPHI}
{$ifdef ver230}
form1.BorderStyle:=bsSizeable;
{$endif}
{$endif}
if width<>0 then form1.ClientWidth:=width;
if height<>0 then form1.ClientHeight:=height;
{$ifdef linux}
form1.BorderStyle:=bsSingle;
{$endif}
{$IFDEF IN_DELPHI}
{$ifdef ver230}
form1.BorderStyle:=bsSingle;
{$endif}
{$endif}
form1.statusbar1.Panels[2].Width:=form1.statusbar1.width-60-100-25-25;
form1.statusbar1.Panels[0].Width:=60;
form1.statusbar1.Panels[1].Width:=125;
form1.statusbar1.Panels[3].Width:=25;
//botones
form1.BitBtn2.left:=(form1.statusbar1.width div 2)-134;
form1.BitBtn3.left:=(form1.statusbar1.width div 2)-104;
form1.BitBtn4.left:=(form1.statusbar1.width div 2)-76;
form1.BitBtn5.left:=(form1.statusbar1.width div 2)-45;
form1.BitBtn6.left:=(form1.statusbar1.width div 2)-17;
form1.btncfg.left:=(form1.statusbar1.width div 2)+13;
form1.BitBtn8.left:=(form1.statusbar1.width div 2)+43;
form1.BitBtn13.left:=(form1.statusbar1.width div 2)+74;
form1.BitBtn19.left:=(form1.statusbar1.width div 2)+106;
end;


function bit(data:word;bitpos:byte):boolean;inline;
begin
   bit:=((data shr bitpos) and 1)<>0;
end;

function bit_n(data:dword;bitpos:byte):byte;inline;
begin
   bit_n:=(data shr bitpos) and 1;
end;

function BITSWAP8(val,B7,B6,B5,B4,B3,B2,B1,B0:byte):byte;inline;
var
  src:byte;
begin
     src:=0;
		 if BIT(val,B7) then src:=src or (1 shl 7);
		 if BIT(val,B6) then src:=src or (1 shl 6);
		 if BIT(val,B5) then src:=src or (1 shl 5);
		 if BIT(val,B4) then src:=src or (1 shl 4);
		 if BIT(val,B3) then src:=src or (1 shl 3);
		 if BIT(val,B2) then src:=src or (1 shl 2);
		 if BIT(val,B1) then src:=src or (1 shl 1);
		 if BIT(val,B0) then src:=src or (1 shl 0);
     bitswap8:=src;
end;

function BITSWAP16(val:word;B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0:byte):word;inline;
var
  src:word;
begin
     src:=0;
     if BIT(val,B15) then src:=src or (1 shl 15);
		 if BIT(val,B14) then src:=src or (1 shl 14);
		 if BIT(val,B13) then src:=src or (1 shl 13);
		 if BIT(val,B12) then src:=src or (1 shl 12);
		 if BIT(val,B11) then src:=src or (1 shl 11);
		 if BIT(val,B10) then src:=src or (1 shl 10);
		 if BIT(val,B9) then src:=src or (1 shl 9);
		 if BIT(val,B8) then src:=src or (1 shl 8);
		 if BIT(val,B7) then src:=src or (1 shl 7);
		 if BIT(val,B6) then src:=src or (1 shl 6);
		 if BIT(val,B5) then src:=src or (1 shl 5);
		 if BIT(val,B4) then src:=src or (1 shl 4);
		 if BIT(val,B3) then src:=src or (1 shl 3);
		 if BIT(val,B2) then src:=src or (1 shl 2);
		 if BIT(val,B1) then src:=src or (1 shl 1);
		 if BIT(val,B0) then src:=src or (1 shl 0);
     bitswap16:=src;
end;

function BITSWAP24(val:dword;B23,B22,B21,B20,B19,B18,B17,B16,B15,B14,B13,B12,B11,B10,B9,B8,B7,B6,B5,B4,B3,B2,B1,B0:byte):dword;inline;
var
  src:dword;
begin
     src:=0;
     if BIT(val,B23) then src:=src or (1 shl 23);
		 if BIT(val,B22) then src:=src or (1 shl 22);
		 if BIT(val,B21) then src:=src or (1 shl 21);
		 if BIT(val,B20) then src:=src or (1 shl 20);
		 if BIT(val,B19) then src:=src or (1 shl 19);
		 if BIT(val,B18) then src:=src or (1 shl 18);
		 if BIT(val,B17) then src:=src or (1 shl 17);
		 if BIT(val,B16) then src:=src or (1 shl 16);
     if BIT(val,B15) then src:=src or (1 shl 15);
		 if BIT(val,B14) then src:=src or (1 shl 14);
		 if BIT(val,B13) then src:=src or (1 shl 13);
		 if BIT(val,B12) then src:=src or (1 shl 12);
		 if BIT(val,B11) then src:=src or (1 shl 11);
		 if BIT(val,B10) then src:=src or (1 shl 10);
		 if BIT(val,B9) then src:=src or (1 shl 9);
		 if BIT(val,B8) then src:=src or (1 shl 8);
		 if BIT(val,B7) then src:=src or (1 shl 7);
		 if BIT(val,B6) then src:=src or (1 shl 6);
		 if BIT(val,B5) then src:=src or (1 shl 5);
		 if BIT(val,B4) then src:=src or (1 shl 4);
		 if BIT(val,B3) then src:=src or (1 shl 3);
		 if BIT(val,B2) then src:=src or (1 shl 2);
		 if BIT(val,B1) then src:=src or (1 shl 1);
		 if BIT(val,B0) then src:=src or (1 shl 0);
     bitswap24:=src;
end;

function extension_fichero(nombre:string):string;
var
  f:word;
  final_,final2:string;
begin
final_:=extractfileext(nombre);
final2:='';
if final_<>'' then for f:=1 to length(final_) do begin
  final_[f]:=upcase(final_[f]);
  if final_[f]<>'.' then final2:=final2+final_[f];
end;
extension_fichero:=final2;
end;

function mul_video:byte;
begin
case main_screen.video_mode of
   1,3,6:mul_video:=1;
   2,4:mul_video:=2;
   5:mul_video:=3;
end;
end;

{$ifdef IN_DELPHI}
function calc_crc(p:pointer;ByteCount:dword):dword;
begin
calc_crc:=not(update_crc($FFFFFFFF,p,bytecount));
end;
{$endif}

{$ifdef IN_LAZARUS}
function calc_crc(p:pointer;ByteCount:dword):dword;
var
   crc:cardinal;
begin
crc:=crc32(0,nil,0);
crc:=CRC32(crc,p,bytecount);
calc_crc:=crc;
end;
{$endif}

//Abrir Dialog conforme sistema
function OpenRom(Sistema:TSistema;var name:string):boolean;
begin
case Sistema of
  StColecovision:begin
         form1.opendialog1.InitialDir:=Directory.ColecoVision;
         form1.OpenDialog1.Filter:='ColecoVision Files (*.col;*.rom;*.csn;*.bin;*.zip)|*.col;*.rom;*.csn;*.bin;*.zip';
       end;
  Stnes:begin
         form1.opendialog1.InitialDir:=Directory.Nes;
         form1.OpenDialog1.Filter:='NES Files (*.nes;*zip)|*.nes;*.zip';
       end;
  Stgb:begin
         form1.opendialog1.InitialDir:=Directory.GameBoy;
         form1.OpenDialog1.Filter:='GB Files (*.gb;*.gbc;*zip)|*.gb;*.gbc;*.zip';
       end;
  StChip8:begin
         form1.opendialog1.InitialDir:=Directory.Chip8;
         form1.OpenDialog1.Filter:='Chip-8 Files (*.ch8;*.bin;*zip)|*.ch8;*.bin;*.zip';
       end;
end;
OpenRom:=form1.OpenDialog1.execute;
name:=form1.OpenDialog1.FileName;
end;

end.
