unit snapshot;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}sysutils,spectrum_misc,ay_8910,dialogs,
     forms,cpu_engine,file_engine,init_games;

function abrir_sna(datos:pbyte;long:integer):boolean;
function abrir_sp(datos:pbyte;long:integer):boolean;
function abrir_zx(datos:pbyte;long:integer):boolean;
function abrir_szx(data:pbyte;long:integer):boolean;
function abrir_z80(datos:pbyte;long:integer;es_dsp:boolean):boolean;
function grabar_sna(nombre:string):boolean;
function grabar_szx(nombre:string):boolean;
function grabar_z80(nombre:string;es_dsp:boolean):boolean;
procedure descomprimir_z80(destino,origen:pbyte;longitud:word);

implementation
uses spectrum_48k,spectrum_128k,spectrum_3,principal,main_engine;

//Function extract Word from pointer
function sacar_word(datos:pbyte):word;
var
  salida:word;
begin
salida:=datos^;
inc(datos);
sacar_word:=salida+(datos^ shl 8);
end;

function abrir_szx(data:pbyte;long:integer):boolean;
var
  longitud,lbloque:integer;
  temp,tmaquina:byte;
  cadena:string;
  datos:boolean;
  temp2:parejas;
  ram_sp:pbyte;
  temp3:word;
  temp4:integer;
  new_maquina:byte;
begin
abrir_szx:=false;
longitud:=0;
cadena:='';
for temp:=0 to 3 do begin
  cadena:=cadena+chr(data^);
  inc(data);inc(longitud);
end;
if cadena<>'ZXST' then exit;
getmem(ram_sp,16384);
inc(data,2);inc(longitud,2);
tmaquina:=data^;
case tmaquina of
  0:new_maquina:=5;
  1:new_maquina:=0;
  2:new_maquina:=1;
  3:new_maquina:=4;
  4:new_maquina:=3;
  5:new_maquina:=2;
    else begin
      freemem(ram_sp);
      exit;
    end;
end;
llamadas_maquina.cerrar;
main_vars.tipo_maquina:=new_maquina;
case new_maquina of
  0,5:begin
      reset_dsp;
      todos_false;
      Cargar_Spectrum48K;
      if not(iniciar_48k) then begin
        freemem(ram_sp);
        exit;
      end;
      if new_maquina=0 then main_vars.tipo_maquina:=tipo_cambio_maquina(form1.Spectrum48K1)
        else main_vars.tipo_maquina:=tipo_cambio_maquina(form1.Spectrum16K1);
    end;
  1,4:begin
      reset_dsp;
      todos_false;
      Cargar_Spectrum128K;
      if not(iniciar_128k) then begin
        freemem(ram_sp);
        exit;
      end;
      if new_maquina=1 then main_vars.tipo_maquina:=tipo_cambio_maquina(form1.Spectrum128K1)
        else main_vars.tipo_maquina:=tipo_cambio_maquina(form1.Spectrum21);
    end;
  2,3:begin  //Spectrum +2A +3
      reset_dsp;
      todos_false;
      Cargar_Spectrum3;
      if not(iniciar_3) then begin
        freemem(ram_sp);
        exit;
      end;
      if new_maquina=2 then main_vars.tipo_maquina:=tipo_cambio_maquina(form1.Spectrum31)
        else main_vars.tipo_maquina:=tipo_cambio_maquina(form1.Spectrum2A1);
    end;
  else exit;
end;
inc(data,2);inc(longitud,2);
while longitud<>long do begin
  cadena:='';
  for temp:=0 to 3 do begin
        cadena:=cadena+chr(data^);
        inc(data);inc(longitud);
  end;
  lbloque:=sacar_word(data);
  inc(data,2);inc(longitud,2);
  lbloque:=sacar_word(data)*65536+lbloque;
  inc(data,2);inc(longitud,2);
  datos:=false;
  if cadena='Z80R' then begin
    datos:=true;
    temp2.w:=sacar_word(data);
    inc(data,2);inc(longitud,2); //AF
    spec_z80.a:=temp2.l;
    spec_z80.f.s:=(temp2.h and 128)<>0;
    spec_z80.f.z:=(temp2.h and 64)<>0;
    spec_z80.f.bit5:=(temp2.h and 32)<>0;
    spec_z80.f.h:=(temp2.h and 16)<>0;
    spec_z80.f.bit3:=(temp2.h and 8)<>0;
    spec_z80.f.p_v:=(temp2.h and 4)<>0;
    spec_z80.f.n:=(temp2.h and 2)<>0;
    spec_z80.f.c:=(temp2.h and 1)<>0;
    spec_z80.bc.w:=sacar_word(data);
    inc(data,2);inc(longitud,2); //BC
    spec_z80.de.w:=sacar_word(data);
    inc(data,2);inc(longitud,2); //DE
    spec_z80.hl.w:=sacar_word(data);
    inc(data,2);inc(longitud,2); //HL
    temp2.w:=sacar_word(data);
    inc(data,2);inc(longitud,2); //AF2
    spec_z80.a2:=temp2.l;
    spec_z80.f2.s:=(temp2.h and 128)<>0;
    spec_z80.f2.z:=(temp2.h and 64)<>0;
    spec_z80.f2.bit5:=(temp2.h and 32)<>0;
    spec_z80.f2.h:=(temp2.h and 16)<>0;
    spec_z80.f2.bit3:=(temp2.h and 8)<>0;
    spec_z80.f2.p_v:=(temp2.h and 4)<>0;
    spec_z80.f2.n:=(temp2.h and 2)<>0;
    spec_z80.f2.c:=(temp2.h and 1)<>0;
    spec_z80.bc2.w:=sacar_word(data);
    inc(data,2);inc(longitud,2); //BC2
    spec_z80.de2.w:=sacar_word(data);
    inc(data,2);inc(longitud,2); //DE2
    spec_z80.hl2.w:=sacar_word(data);
    inc(data,2);inc(longitud,2); //HL2
    spec_z80.ix.w:=sacar_word(data);
    inc(data,2);inc(longitud,2); //IX
    spec_z80.iy.w:=sacar_word(data);
    inc(data,2);inc(longitud,2); //IY
    spec_z80.sp:=sacar_word(data);
    inc(data,2);inc(longitud,2); //SP
    spec_z80.pc:=sacar_word(data);
    inc(data,2);inc(longitud,2); //PC
    spec_z80.i:=data^;
    inc(data);inc(longitud); //I
    spec_z80.r:=data^;
    inc(data);inc(longitud); //R
    temp:=data^;spec_z80.iff1:=temp<>0;
    inc(data);inc(longitud); //IFF1
    temp:=data^;spec_z80.iff2:=temp<>0;
    inc(data);inc(longitud); //IFF2
    spec_z80.im:=data^;
    inc(data);inc(longitud); //IM
    inc(data,5);inc(longitud,5);
    temp:=data^;spec_z80.halt:=(temp=2);
    inc(data,3);inc(longitud,3);
  end;
  if cadena='SPCR' then begin
    datos:=true;
    borde.color:=data^;
    inc(data);inc(longitud);
    temp:=data^;
    inc(data);inc(longitud);
    case tmaquina of
      2,3:spec128_outbyte(temp,$7ffd);
      4,5:spec3_outbyte(temp,$7ffd);
    end;
    temp:=data^;
    inc(data);inc(longitud);
    case tmaquina of
      4,5:spec3_outbyte(temp,$1ffd);
    end;
    temp:=data^;
    inc(data);inc(longitud);
    temp:=(temp and $f8) or borde.color;
    case tmaquina of
      0,1:spec48_outbyte(temp,$fe);
      2,3:spec128_outbyte(temp,$fe);
      4,5:spec3_outbyte(temp,$fe);
    end;
    inc(data,4);inc(longitud,4);
  end;
  if cadena='RAMP' then begin
    datos:=true;
    temp3:=sacar_word(data);
    inc(data,2);
    temp:=data^;
    inc(data);
    if temp3=1 then Decompress_zlib(data,lbloque-3,pointer(ram_sp),temp4)
      else ram_sp:=data;
    case tmaquina of
      1:case temp of
          0:copymemory(@memoria[$c000],ram_sp,$4000);
          2:copymemory(@memoria[$8000],ram_sp,$4000);
          5:copymemory(@memoria[$4000],ram_sp,$4000);
        end;
      2,3:copymemory(@memoria_128k[temp,0],ram_sp,$4000);
      4,5:copymemory(@memoria_3[temp,0],ram_sp,$4000);
      0:copymemory(@memoria[$4000],ram_sp,$4000);
    end;
    inc(data,lbloque-3);
    inc(longitud,lbloque);
  end;
  if ((cadena='AY'+chr(0)+chr(0)) and (tmaquina<>1)) then begin
    datos:=true;
    inc(data);inc(longitud);
    temp:=data^;
    inc(data);inc(longitud);
    for temp3:=0 to $f do begin
      AY8910_Control(temp3,0);
      if tmaquina=2 then spec128_outbyte(data^,$bffd)
        else spec3_outbyte(data^,$bffd);
      inc(data);inc(longitud);
    end;
    AY8910_Control(temp,0);
  end;
  if not(datos) then begin
    inc(data,lbloque);
    inc(longitud,lbloque);
  end;
end;
freemem(ram_sp);
abrir_szx:=true;
end;

function abrir_zx(datos:pbyte;long:integer):boolean;
var
  puntero:pbyte;
  buffer:array[0..50] of byte;
  temp:word;
begin
abrir_zx:=false;
if long<>49486 then exit;
llamadas_maquina.cerrar;
main_vars.tipo_maquina:=0;
reset_dsp;
todos_false;
Cargar_Spectrum48K;  //solo puede ser 48k o 16K!!!
if not(iniciar_48k) then exit;
main_vars.tipo_maquina:=tipo_cambio_maquina(form1.Spectrum48K1);
puntero:=datos;
inc(puntero,132);
copymemory(@memoria[$4000],puntero,49152);
inc(puntero,49152);
//este formato viene de Amiga, por lo tanto tiene invertido el byte mas significativo
inc(puntero,142);
spec_z80.iff1:=(puntero^=1);
inc(puntero,8);
copymemory(@buffer[0],puntero,50);
spec_z80.bc.w:=buffer[0]*256+buffer[1];
spec_z80.bc2.w:=buffer[2]*256+buffer[3];
spec_z80.de.w:=buffer[4]*256+buffer[5];
spec_z80.de2.w:=buffer[6]*256+buffer[6];
spec_z80.hl.w:=buffer[8]*256+buffer[9];
spec_z80.hl2.w:=buffer[10]*256+buffer[11];
spec_z80.ix.w:=buffer[12]*256+buffer[13];
spec_z80.iy.w:=buffer[14]*256+buffer[15];
spec_z80.i:=buffer[16];
spec_z80.r:=buffer[17];
spec_z80.a2:=buffer[21];
spec_z80.a:=buffer[23];
spec_z80.f2.s:=(buffer[25] and 128)<>0;
spec_z80.f2.z:=(buffer[25] and 64)<>0;
spec_z80.f2.bit5:=(buffer[25] and 32)<>0;
spec_z80.f2.h:=(buffer[25] and 16)<>0;
spec_z80.f2.bit3:=(buffer[25] and 8)<>0;
spec_z80.f2.p_v:=(buffer[25] and 4)<>0;
spec_z80.f2.n:=(buffer[25] and 2)<>0;
spec_z80.f2.c:=(buffer[25] and 1)<>0;
spec_z80.f.s:=(buffer[27] and 128)<>0;
spec_z80.f.z:=(buffer[27] and 64)<>0;
spec_z80.f.bit5:=(buffer[27] and 32)<>0;
spec_z80.f.h:=(buffer[27] and 16)<>0;
spec_z80.f.bit3:=(buffer[27] and 8)<>0;
spec_z80.f.p_v:=(buffer[27] and 4)<>0;
spec_z80.f.n:=(buffer[27] and 2)<>0;
spec_z80.f.c:=(buffer[27] and 1)<>0;
spec_z80.pc:=buffer[30]*256+buffer[31];
spec_z80.sp:=buffer[34]*256+buffer[35];
temp:=buffer[40]*256+buffer[41];
case temp of
  0:spec_z80.im:=1;
  1:spec_z80.im:=2;
  65535:spec_z80.im:=0;
end;
abrir_zx:=true;
end;

function abrir_sp(datos:pbyte;long:integer):boolean;
var
        buffer:array[0..37] of byte;
        puntero:pbyte;
        cadena:string;
        longitud:word;
begin
abrir_sp:=false;
puntero:=datos;
copymemory(@buffer[0],puntero,38);
inc(puntero,38);
llamadas_maquina.cerrar;
main_vars.tipo_maquina:=0;
reset_dsp;
todos_false;
Cargar_Spectrum48K;  //solo puede ser 48k o 16K!!!
if not(iniciar_48k) then exit;
main_vars.tipo_maquina:=tipo_cambio_maquina(form1.Spectrum48K1);
cadena:=chr(buffer[0])+chr(buffer[1]);
if cadena<>'SP' then exit;
longitud:=sacar_word(@buffer[2]); //longitud
if longitud+38<long then exit;
copymemory(@memoria[sacar_word(@buffer[4])],puntero,longitud);
spec_z80.bc.w:=sacar_word(@buffer[6]);
spec_z80.de.w:=sacar_word(@buffer[8]);
spec_z80.hl.w:=sacar_word(@buffer[10]);
spec_z80.a:=buffer[13];
spec_z80.f.s:=(buffer[12] and 128)<>0;
spec_z80.f.z:=(buffer[12] and 64)<>0;
spec_z80.f.bit5:=(buffer[12] and 32)<>0;
spec_z80.f.h:=(buffer[12] and 16)<>0;
spec_z80.f.bit3:=(buffer[12] and 8)<>0;
spec_z80.f.p_v:=(buffer[12] and 4)<>0;
spec_z80.f.n:=(buffer[12] and 2)<>0;
spec_z80.f.c:=(buffer[12] and 1)<>0;
spec_z80.ix.w:=sacar_word(@buffer[14]);
spec_z80.iy.w:=sacar_word(@buffer[16]);
spec_z80.bc2.w:=sacar_word(@buffer[18]);
spec_z80.de2.w:=sacar_word(@buffer[20]);
spec_z80.hl2.w:=sacar_word(@buffer[22]);
spec_z80.a2:=buffer[25];
spec_z80.f2.s:=(buffer[24] and 128)<>0;
spec_z80.f2.z:=(buffer[24] and 64)<>0;
spec_z80.f2.bit5:=(buffer[24] and 32)<>0;
spec_z80.f2.h:=(buffer[24] and 16)<>0;
spec_z80.f2.bit3:=(buffer[24] and 8)<>0;
spec_z80.f2.p_v:=(buffer[24] and 4)<>0;
spec_z80.f2.n:=(buffer[24] and 2)<>0;
spec_z80.f2.c:=(buffer[24] and 1)<>0;
spec_z80.r:=buffer[26];
spec_z80.i:=buffer[27];
spec_z80.sp:=sacar_word(@buffer[28]);
spec_z80.pc:=sacar_word(@buffer[30]);
borde.color:=buffer[34];
spec_z80.iff1:=buffer[36]<>0;
if (buffer[36] and 8)<>0 then spec_z80.im:=0
        else if (buffer[36] and 2)<>0 then spec_z80.im:=2 else spec_z80.im:=1;
abrir_sp:=true;
end;

procedure descomprimir_z80(destino,origen:pbyte;longitud:word);
var
        pdestino,porigen:pbyte;
        g,contador,f:word;
begin
pdestino:=destino;
porigen:=origen;
f:=0;
//t:=0;
while (f<longitud) do begin
        if porigen^=$ed then begin
                inc(porigen);
                inc(f);
                if porigen^=$ed then begin
                        inc(porigen);
                        inc(f);
                        contador:=porigen^;
                        inc(porigen);
                        inc(f);
                        for g:=1 to contador do begin
                                pdestino^:=porigen^;
                                inc(pdestino);
                                //inc(t);
                        end;
                        inc(porigen);
                        inc(f);
                end else begin
                        pdestino^:=$ed;
                        inc(pdestino);
                        //inc(t);
                end;
        end else begin
                pdestino^:=porigen^;
                inc(pdestino);
                inc(porigen);
                inc(f);
                //inc(t);
        end;
end;
//if t<>16384 then halt(0);
end;

function comprimir_z80(origen,destino:pbyte):word;
var
  porigen,porigen_4,pdestino:pbyte;
  contador:word;
  long,total:word;
  base:byte;
begin
porigen:=origen;
pdestino:=destino;
total:=0;
long:=0;
while total<16384 do begin
  base:=porigen^;  //primer byte
  porigen_4:=porigen;
  inc(porigen);
  inc(total);
  contador:=1;
  if (porigen^=base) then begin
    while ((porigen^=base) and (contador<>255) and (total<>16384)) do begin
      inc(porigen);
      inc(contador);
      inc(total);
    end;
    if ((contador>4) or (base=$ed)) then begin
      pdestino^:=$ed;inc(pdestino);
      pdestino^:=$ed;inc(pdestino);
      pdestino^:=contador;inc(pdestino);
      pdestino^:=base;inc(pdestino);
      inc(long,4);
    end else begin
        copymemory(pdestino,porigen_4,contador);
        inc(pdestino,contador);
        inc(long,contador);
    end;
  end else begin   //son bytes sueltos
    pdestino^:=base;
    inc(pdestino);
    inc(long);
    if base=$ed then begin  //si el byte es $ed hay que meter el siguiente, para no meter tres ed seguidos!!!
      pdestino^:=porigen^;
      inc(total);
      inc(long);
      inc(pdestino);
      inc(porigen);
    end;
  end;
  if total=16383 then begin  //si estoy en el ultimo byte no puedo comprimir
      pdestino^:=porigen^;
      inc(total);
      inc(long);
  end;
end;  //del while
if long>16384 then begin
  copymemory(destino,origen,16384);
  comprimir_z80:=$FFFF;
end else comprimir_z80:=long;
end;

function abrir_z80(datos:pbyte;long:integer;es_dsp:boolean):boolean;
var
        buffer:array[0..29] of byte;
        buffer2:array[0..49151] of byte;
        buffer3:array[0..56] of byte;
        buffer4:array[0..3] of byte;
        f,pos_memoria:integer;
        g,contador:word;
        puntero:pointer;
        new_maquina:byte;
begin
abrir_z80:=false;
getmem(puntero,16384);
copymemory(@buffer[0],datos,30);
inc(datos,30);dec(long,30);
if ((buffer[6]=0) and (buffer[7]=0)) then begin  //version 2.xx o 3.xx
        g:=sacar_word(datos);    //si g=23 es version 2, si 54 o 55 es version 3
        inc(datos,2);dec(long,2);
        copymemory(@buffer3[2],datos,g);
        inc(datos,g);dec(long,g);
        case buffer3[4] of
                0,1:new_maquina:=0;  //Modo 48k
                3:if g=23 then new_maquina:=1
                    else new_maquina:=0;
                4,5,6:new_maquina:=1;  //Modo 128K
                7,8:new_maquina:=2;  //Modo +3
                12:new_maquina:=3; //Modo +2A
                13:new_maquina:=4; //Modo +2
                else begin
                  freemem(puntero);
                  exit;
                end;
        end;  //del case
        llamadas_maquina.cerrar;
        main_vars.tipo_maquina:=new_maquina;
        case new_maquina of
          0:begin  //es 48K
            reset_dsp;
            todos_false;
            Cargar_Spectrum48K;
            if not(iniciar_48k) then begin
              freemem(puntero);
              exit;
            end;
            main_vars.tipo_maquina:=tipo_cambio_maquina(form1.Spectrum48K1);
          end;
          1,4:begin //es 128k
             reset_dsp;
             todos_false;
             Cargar_Spectrum128K;
             if not(iniciar_128k) then begin
                freemem(puntero);
                exit;
             end;
             if new_maquina=1 then main_vars.tipo_maquina:=tipo_cambio_maquina(form1.Spectrum128K1)
                else main_vars.tipo_maquina:=tipo_cambio_maquina(form1.Spectrum21);
             spec128_outbyte(buffer3[5],$7ffd);
             for f:=0 to $f do begin
               AY8910_Control(f,0);
               spec128_outbyte(buffer3[9+f],$bffd);
             end;
             AY8910_Control(buffer3[8],0);
             end;
          2,3:begin
             reset_dsp;
             todos_false;
             Cargar_Spectrum3;
             if not(iniciar_3) then begin
                freemem(puntero);
                exit;
             end;
             if new_maquina=2 then main_vars.tipo_maquina:=tipo_cambio_maquina(form1.Spectrum31)
                else main_vars.tipo_maquina:=tipo_cambio_maquina(form1.Spectrum2A1);
             spec3_outbyte(buffer3[5],$7ffd);
             spec3_outbyte(buffer3[56],$1ffd);
             for f:=0 to $f do begin
               AY8910_Control(f,0);
               spec3_outbyte(buffer3[9+f],$bffd);
             end;
             AY8910_Control(buffer3[8],0);
             end;
        end;
        spec_z80.pc:=sacar_word(@buffer3[2]);
        while long>0 do begin
                copymemory(@buffer4[0],datos,3);
                inc(datos,3);dec(long,3);
                contador:=sacar_word(@buffer4[0]);
                case main_vars.tipo_maquina of
                    0:begin
                        case buffer4[2] of
                          0:pos_memoria:=0;
                          4:pos_memoria:=$8000;
                          5:pos_memoria:=$c000;
                          8:pos_memoria:=$4000;
                          else begin
                            freemem(puntero);
                            exit;
                          end;
                        end;
                        if contador=$FFFF then begin
                          copymemory(@memoria[pos_memoria],datos,16384);
                          inc(datos,16384);dec(long,16384);
                        end else begin
                          if es_dsp then Decompress_zlib(datos,contador,puntero,f)
                            else descomprimir_z80(puntero,datos,contador);
                          copymemory(@memoria[pos_memoria],puntero,16384);
                          inc(datos,contador);dec(long,contador);
                        end;
                    end;
                  1,4:begin
                        case buffer4[2] of
                          0,1:begin
                                if contador=$FFFF then begin
                                        copymemory(@memoria_128k[buffer4[2],0],datos,16384);
                                        inc(datos,16384);dec(long,16384);
                                end else begin
                                        if es_dsp then Decompress_zlib(pointer(datos),contador,puntero,f)
                                          else descomprimir_z80(puntero,datos,contador);
                                        copymemory(@memoria_128k[buffer4[2],0],puntero,16384);
                                        inc(datos,contador);dec(long,contador);
                                end;
                              end;
                          3,4,5,6,7,8,9,10:begin
                                                if contador=$FFFF then begin
                                                   copymemory(@memoria_128k[buffer4[2]-3,0],datos,16384);
                                                   inc(datos,16384);dec(long,16384);
                                                end else begin
                                                  if es_dsp then Decompress_zlib(datos,contador,puntero,f)
                                                    else descomprimir_z80(puntero,datos,contador);
                                                  copymemory(@memoria_128k[buffer4[2]-3,0],puntero,16384);
                                                  inc(datos,contador);dec(long,contador);
                                                end;
                                           end;
                          else begin
                                freemem(puntero);
                                exit;
                          end;
                        end;
                   end;
                2,3:begin //es +3
                   case buffer4[2] of
                          0,1:begin
                                if contador=$FFFF then begin
                                        copymemory(@memoria_3[buffer4[2],0],datos,16384);
                                        inc(datos,16384);dec(long,16384);
                                end else begin
                                        if es_dsp then Decompress_zlib(pointer(datos),contador,puntero,f)
                                          else descomprimir_z80(puntero,datos,contador);
                                        copymemory(@memoria_3[buffer4[2],0],puntero,16384);
                                        inc(datos,contador);dec(long,contador);
                                end;
                              end;
                          3,4,5,6,7,8,9,10:begin
                                                if contador=$FFFF then begin
                                                   copymemory(@memoria_3[buffer4[2]-3,0],datos,16384);
                                                   inc(datos,16384);dec(long,16384);
                                                end else begin
                                                  if es_dsp then Decompress_zlib(datos,contador,puntero,f)
                                                    else descomprimir_z80(puntero,datos,contador);
                                                  copymemory(@memoria_3[buffer4[2]-3,0],puntero,16384);
                                                  inc(datos,contador);dec(long,contador);
                                                end;
                                           end;
                          else begin
                                freemem(puntero);
                                exit;
                          end;
                        end;
                end;
                end;
        end;
end else begin //version 1.XX solo 48k
        llamadas_maquina.cerrar;
        main_vars.tipo_maquina:=0;
        reset_dsp;
        todos_false;
        Cargar_Spectrum48K;
        if not(iniciar_48k) then begin
            freemem(puntero);
            exit;
        end;
        main_vars.tipo_maquina:=tipo_cambio_maquina(form1.Spectrum48K1);
        spec_z80.pc:=sacar_word(@buffer[6]);
        if (buffer[12] and $20)<>0 then begin //comprimido
                descomprimir_z80(@memoria[16384],datos,long-4);
                inc(datos,long-4);
                copymemory(@buffer2[0],datos,4);
                if ((buffer2[0]<>0) and (buffer2[1]<>$ed) and (buffer2[2]<>$ed) and (buffer2[3]<>0)) then begin
                    freemem(puntero);
                    exit;
                end;
        end else //sin comprimir
                copymemory(@memoria[0],datos,49152);
end;
spec_z80.a:=buffer[0];
spec_z80.f.s:=(buffer[1] and 128)<>0;
spec_z80.f.z:=(buffer[1] and 64)<>0;
spec_z80.f.bit5:=(buffer[1] and 32)<>0;
spec_z80.f.h:=(buffer[1] and 16)<>0;
spec_z80.f.bit3:=(buffer[1] and 8)<>0;
spec_z80.f.p_v:=(buffer[1] and 4)<>0;
spec_z80.f.n:=(buffer[1] and 2)<>0;
spec_z80.f.c:=(buffer[1] and 1)<>0;
spec_z80.bc.w:=sacar_word(@buffer[2]);
spec_z80.hl.w:=sacar_word(@buffer[4]);
spec_z80.sp:=sacar_word(@buffer[8]);
spec_z80.i:=buffer[10];
spec_z80.r:=buffer[11] and $7f;
if buffer[12]=255 then buffer[12]:=1;
if (buffer[12] and 1)<>0 then spec_z80.r:=(spec_z80.r or $80);
borde.color:=(buffer[12] and $0e) shr 1;
spec_z80.de.w:=sacar_word(@buffer[13]);
spec_z80.bc2.w:=sacar_word(@buffer[15]);
spec_z80.de2.w:=sacar_word(@buffer[17]);
spec_z80.hl2.w:=sacar_word(@buffer[19]);
spec_z80.a2:=buffer[21];
spec_z80.f2.s:=(buffer[22] and 128)<>0;
spec_z80.f2.z:=(buffer[22] and 64)<>0;
spec_z80.f2.bit5:=(buffer[22] and 32)<>0;
spec_z80.f2.h:=(buffer[22] and 16)<>0;
spec_z80.f2.bit3:=(buffer[22] and 8)<>0;
spec_z80.f2.p_v:=(buffer[22] and 4)<>0;
spec_z80.f2.n:=(buffer[22] and 2)<>0;
spec_z80.f2.c:=(buffer[22] and 1)<>0;
spec_z80.iy.w:=sacar_word(@buffer[23]);
spec_z80.ix.w:=sacar_word(@buffer[25]);
if (buffer[27]=0) then spec_z80.iff1:=false
        else spec_z80.iff1:=true;
if (buffer[28]=0) then spec_z80.iff2:=false
        else spec_z80.iff2:=true;
spec_z80.im:=buffer[29] and 3;
freemem(puntero);
abrir_z80:=true;
end;

function abrir_sna(datos:pbyte;long:integer):boolean;
var
        buffer:array[0..26] of byte;
        buffer2:array[0..3] of byte;
        buffer3:array[0..16383] of byte;
        f:word;
begin
abrir_sna:=false;
if long<49179 then exit;
copymemory(@buffer[0],datos,27);
inc(datos,27);dec(long,27);
llamadas_maquina.cerrar;
if long>49152 then begin
        main_vars.tipo_maquina:=1;
        reset_dsp;
        todos_false;
        Cargar_Spectrum128K;
        if not(iniciar_128k) then exit;
        main_vars.tipo_maquina:=tipo_cambio_maquina(form1.Spectrum128K1);
        copymemory(@memoria_128k[5],datos,16384);
        inc(datos,16384);
        copymemory(@memoria_128k[2],datos,16384);
        inc(datos,16384);
        copymemory(@buffer3[0],datos,16384);
        inc(datos,16384);
        copymemory(@buffer2[0],datos,4);
        inc(datos,4);
        for f:=0 to 7 do
           if ((f<>2) and (f<>5) and (f<>(buffer2[2] and $7))) then begin
                copymemory(@memoria_128k[f],datos,16384);
                inc(datos,16384);
           end;
        spec_z80.pc:=sacar_word(@buffer2[0]);
        copymemory(@memoria_128k[(buffer2[2] and $7)],@buffer3[0],16384);
        spec_z80.sp:=sacar_word(@buffer[23]);
        spec128_outbyte(buffer2[2],$7ffd);
end else begin
        main_vars.tipo_maquina:=tipo_cambio_maquina(form1.Spectrum48K1);
        reset_dsp;
        todos_false;
        Cargar_Spectrum48K;
        if not(iniciar_48k) then exit;
        main_vars.tipo_maquina:=tipo_cambio_maquina(form1.Spectrum48K1);
        copymemory(@memoria[16384],datos,long);
        spec_z80.sp:=sacar_word(@buffer[23]);
        spec_z80.pc:=sacar_word(@memoria[spec_z80.sp]);
        inc(spec_z80.sp,2);
end;
spec_z80.i:=buffer[0];
spec_z80.hl2.w:=sacar_word(@buffer[1]);
spec_z80.de2.w:=sacar_word(@buffer[3]);
spec_z80.bc2.w:=sacar_word(@buffer[5]);
spec_z80.a2:=buffer[8];
spec_z80.f2.s:=(buffer[7] and 128)<>0;
spec_z80.f2.z:=(buffer[7] and 64)<>0;
spec_z80.f2.bit5:=(buffer[7] and 32)<>0;
spec_z80.f2.h:=(buffer[7] and 16)<>0;
spec_z80.f2.bit3:=(buffer[7] and 8)<>0;
spec_z80.f2.p_v:=(buffer[7] and 4)<>0;
spec_z80.f2.n:=(buffer[7] and 2)<>0;
spec_z80.f2.c:=(buffer[7] and 1)<>0;
spec_z80.hl.w:=sacar_word(@buffer[9]);
spec_z80.de.w:=sacar_word(@buffer[11]);
spec_z80.bc.w:=sacar_word(@buffer[13]);
spec_z80.iy.w:=sacar_word(@buffer[15]);
spec_z80.ix.w:=sacar_word(@buffer[17]);
spec_z80.iff2:=(buffer[19] and 4)<>0;
spec_z80.iff1:=(buffer[19] and 2)<>0;
spec_z80.r:=buffer[20];
spec_z80.a:=buffer[22];
spec_z80.f.s:=(buffer[21] and 128)<>0;
spec_z80.f.z:=(buffer[21] and 64)<>0;
spec_z80.f.bit5:=(buffer[21] and 32)<>0;
spec_z80.f.h:=(buffer[21] and 16)<>0;
spec_z80.f.bit3:=(buffer[21] and 8)<>0;
spec_z80.f.p_v:=(buffer[21] and 4)<>0;
spec_z80.f.n:=(buffer[21] and 2)<>0;
spec_z80.f.c:=(buffer[21] and 1)<>0;
spec_z80.im:=buffer[25];
borde.color:=buffer[26];
abrir_sna:=true;
end;

function grabar_sna(nombre:string):boolean;
var
        fichero:file of byte;
        buffer:array[0..26] of byte;
        temp:byte;
        datos:integer;
begin
grabar_sna:=false;
{$I-}
assignfile(fichero,nombre);
rewrite(fichero);
buffer[0]:=spec_z80.i;
buffer[1]:=spec_z80.hl2.l;
buffer[2]:=spec_z80.hl2.h;
buffer[3]:=spec_z80.de2.l;
buffer[4]:=spec_z80.de2.h;
buffer[5]:=spec_z80.bc2.l;
buffer[6]:=spec_z80.bc2.h;
temp:=0;
if spec_z80.f2.s then temp:=temp or $80;
if spec_z80.f2.z then temp:=temp or $40;
if spec_z80.f2.bit5 then temp:=temp or $20;
if spec_z80.f2.h then temp:=temp or $10;
if spec_z80.f2.bit3 then temp:=temp or 8;
if spec_z80.f2.p_v then temp:=temp or 4;
if spec_z80.f2.n then temp:=temp or 2;
if spec_z80.f2.c then temp:=temp or 1;
buffer[7]:=temp;
buffer[8]:=spec_z80.a2;
buffer[9]:=spec_z80.hl.l;
buffer[10]:=spec_z80.hl.h;
buffer[11]:=spec_z80.de.l;
buffer[12]:=spec_z80.de.h;
buffer[13]:=spec_z80.bc.l;
buffer[14]:=spec_z80.bc.h;
buffer[15]:=spec_z80.iy.l;
buffer[16]:=spec_z80.iy.h;
buffer[17]:=spec_z80.ix.l;
buffer[18]:=spec_z80.ix.h;
if spec_z80.iff1 then temp:=temp or 2;
if spec_z80.iff2 then temp:=temp or 4;
buffer[19]:=temp;
buffer[20]:=spec_z80.r;
temp:=0;
if spec_z80.f.s then temp:=temp or $80;
if spec_z80.f.z then temp:=temp or $40;
if spec_z80.f.bit5 then temp:=temp or $20;
if spec_z80.f.h then temp:=temp or $10;
if spec_z80.f.bit3 then temp:=temp or 8;
if spec_z80.f.p_v then temp:=temp or 4;
if spec_z80.f.n then temp:=temp or 2;
if spec_z80.f.c then temp:=temp or 1;
buffer[21]:=temp;
buffer[22]:=spec_z80.a;
buffer[25]:=spec_z80.im;
buffer[26]:=borde.color;
{$I-}
case main_vars.tipo_maquina of
        0,5:begin
             memoria[spec_z80.sp-1]:=spec_z80.pc shr 8;
             memoria[spec_z80.sp-2]:=spec_z80.pc and $ff;
             dec(spec_z80.sp,2);
             buffer[23]:=spec_z80.sp and $ff;
             buffer[24]:=spec_z80.sp shr 8;
             inc(spec_z80.sp,2);
             blockwrite(fichero,buffer[0],27,datos);
             if datos<>27 then exit;
             blockwrite(fichero,memoria[16384],49152,datos);
             if datos<>49152 then exit;
          end;
        1,4:begin
             buffer[23]:=spec_z80.sp and $ff;
             buffer[24]:=spec_z80.sp shr 8;
             blockwrite(fichero,buffer[0],27,datos);
             if datos<>27 then exit;
             blockwrite(fichero,memoria_128k[5,0],16384,datos);
             if datos<>16384 then exit;
             blockwrite(fichero,memoria_128k[2,0],16384,datos);
             if datos<>16384 then exit;
             blockwrite(fichero,memoria_128k[marco[3],0],16384,datos);
             if datos<>16384 then exit;
             buffer[0]:=spec_z80.pc shr 8;
             buffer[1]:=spec_z80.pc and $ff;
             buffer[2]:=old_7ffd;
             buffer[3]:=0;
             blockwrite(fichero,buffer[0],4,datos);
             if datos<>4 then exit;
             for temp:=0 to 7 do
                if ((temp<>2) and (temp<>5) and (temp<>marco[3])) then begin
                        blockwrite(fichero,memoria_128k[temp,0],16384,datos);
                        if datos<>16384 then exit;
                end;

          end;
        else exit;
end;
{$I+}
grabar_sna:=true;
close(fichero);
end;

function grabar_z80(nombre:string;es_dsp:boolean):boolean;
var
        r:integer;
        fichero:file of byte;
        buffer:array[0..87] of byte;
        comprimido:pbyte;
        buffer3:array[0..2] of byte;
        temp:byte;
        datos:integer;
begin
grabar_z80:=false;
{$I-}
//Grabo snapshot version 3, por el +3
assignfile(fichero,nombre);
rewrite(fichero);
buffer[0]:=spec_z80.a;
temp:=0;
if spec_z80.f.s then temp:=temp or $80;
if spec_z80.f.z then temp:=temp or $40;
if spec_z80.f.bit5 then temp:=temp or $20;
if spec_z80.f.h then temp:=temp or $10;
if spec_z80.f.bit3 then temp:=temp or 8;
if spec_z80.f.p_v then temp:=temp or 4;
if spec_z80.f.n then temp:=temp or 2;
if spec_z80.f.c then temp:=temp or 1;
buffer[1]:=temp;
buffer[2]:=spec_z80.bc.l;
buffer[3]:=spec_z80.bc.h;
buffer[4]:=spec_z80.hl.l;
buffer[5]:=spec_z80.hl.h;
buffer[6]:=0;
buffer[7]:=0;
buffer[8]:=spec_z80.sp and $ff;
buffer[9]:=spec_z80.sp shr 8;
buffer[10]:=spec_z80.i;
buffer[11]:=spec_z80.r;
temp:=$20;
if (spec_z80.r and $80)=1 then temp:=temp+1;
temp:=temp+(borde.color shl 1);
buffer[12]:=temp;
buffer[13]:=spec_z80.de.l;
buffer[14]:=spec_z80.de.h;
buffer[15]:=spec_z80.bc2.l;
buffer[16]:=spec_z80.bc2.h;
buffer[17]:=spec_z80.de2.l;
buffer[18]:=spec_z80.de2.h;
buffer[19]:=spec_z80.hl2.l;
buffer[20]:=spec_z80.hl2.h;
buffer[21]:=spec_z80.a2;
temp:=0;
if spec_z80.f2.s then temp:=temp or $80;
if spec_z80.f2.z then temp:=temp or $40;
if spec_z80.f2.bit5 then temp:=temp or $20;
if spec_z80.f2.h then temp:=temp or $10;
if spec_z80.f2.bit3 then temp:=temp or 8;
if spec_z80.f2.p_v then temp:=temp or 4;
if spec_z80.f2.n then temp:=temp or 2;
if spec_z80.f2.c then temp:=temp or 1;
buffer[22]:=temp;
buffer[23]:=spec_z80.iy.l;
buffer[24]:=spec_z80.iy.h;
buffer[25]:=spec_z80.ix.l;
buffer[26]:=spec_z80.ix.h;
if spec_z80.iff1 then buffer[27]:=1
  else buffer[27]:=0;
if spec_z80.iff2 then buffer[28]:=1
  else buffer[28]:=0;
buffer[29]:=spec_z80.im;
buffer[30]:=55;
buffer[31]:=0;
buffer[32]:=spec_z80.pc and $ff;
buffer[33]:=spec_z80.pc shr 8;
case main_vars.tipo_maquina of
  0,5:buffer[34]:=0;
  1,4:begin
      buffer[34]:=4;
      buffer[35]:=old_7ffd;
      buffer[38]:=PSG[0].latch;
      for datos:=0 to 15 do buffer[39+datos]:=PSG[0].regs[datos];
    end;
  2,3:begin
      buffer[34]:=7;
      buffer[35]:=old_7ffd;
      buffer[38]:=PSG[0].latch;
      buffer[86]:=old_1ffd;
      for datos:=0 to 15 do buffer[39+datos]:=PSG[0].regs[datos];
    end;
end;
buffer[36]:=0;
buffer[37]:=1;
blockwrite(fichero,buffer[0],87,datos);
getmem(comprimido,$FFFF);
case main_vars.tipo_maquina of
  0,5:begin
      buffer3[2]:=8;
      if es_dsp then Compress_zlib(@memoria[$4000],16384,pointer(comprimido),r)
        else r:=comprimir_z80(@memoria[$4000],comprimido);
      if r=$FFFF then begin
          buffer3[0]:=$FF;
          buffer3[1]:=$FF;
          r:=$4000;
      end else begin
          buffer3[0]:=r mod 256;
          buffer3[1]:=r div 256;
      end;
      blockwrite(fichero,buffer3[0],3,datos);
      blockwrite(fichero,comprimido^,r,datos);
      buffer3[2]:=4;
      if es_dsp then Compress_zlib(@memoria[$8000],16384,pointer(comprimido),r)
        else r:=comprimir_z80(@memoria[$8000],comprimido);
      if r=$FFFF then begin
          buffer3[0]:=$FF;
          buffer3[1]:=$FF;
          r:=$4000;
      end else begin
          buffer3[0]:=r mod 256;
          buffer3[1]:=r div 256;
      end;
      blockwrite(fichero,buffer3[0],3,datos);
      blockwrite(fichero,comprimido^,r,datos);
      buffer3[2]:=5;
      if es_dsp then Compress_zlib(@memoria[$c000],16384,pointer(comprimido),r)
        else r:=comprimir_z80(@memoria[$c000],comprimido);
      if r=$FFFF then begin
          buffer3[0]:=$FF;
          buffer3[1]:=$FF;
          r:=$4000;
      end else begin
          buffer3[0]:=r mod 256;
          buffer3[1]:=r div 256;
      end;
      blockwrite(fichero,buffer3[0],3,datos);
      blockwrite(fichero,comprimido^,r,datos);
    end;
    1,4:for temp:=3 to 10 do begin
        if es_dsp then Compress_zlib(@memoria_128k[temp-3,0],16384,pointer(comprimido),r)
          else r:=comprimir_z80(@memoria_128k[temp-3,0],comprimido);
        if r=$FFFF then begin
          buffer3[0]:=$FF;
          buffer3[1]:=$FF;
          r:=$4000;
        end else begin
          buffer3[0]:=r mod 256;
          buffer3[1]:=r div 256;
        end;
        buffer3[2]:=temp;
        blockwrite(fichero,buffer3[0],3,datos);
        blockwrite(fichero,comprimido^,r,datos);
      end;
    2,3:for temp:=3 to 10 do begin
        if es_dsp then Compress_zlib(@memoria_3[temp-3,0],16384,pointer(comprimido),r)
          else r:=comprimir_z80(@memoria_3[temp-3,0],comprimido);
        if r=$FFFF then begin
          buffer3[0]:=$FF;
          buffer3[1]:=$FF;
          r:=$4000;
        end else begin
          buffer3[0]:=r mod 256;
          buffer3[1]:=r div 256;
        end;
        buffer3[2]:=temp;
        blockwrite(fichero,buffer3[0],3,datos);
        blockwrite(fichero,comprimido^,r,datos);
      end;
end;
freemem(comprimido);
{$I+}
grabar_z80:=true;
close(fichero);
end;

function pagina_ram(numero:byte;destino:pbyte):integer;
var
  puntero,puntero2:pbyte;
  long:integer;
begin
getmem(puntero,$4000);
case main_vars.tipo_maquina of
  0:case numero of
        0:puntero2:=@memoria[$c000];
        2:puntero2:=@memoria[$8000];
        5:puntero2:=@memoria[$4000];
    end;
  1,4:puntero2:=@memoria_128k[numero,0];
  2,3:puntero2:=@memoria_3[numero,0];
  5:puntero2:=@memoria[$4000];
end;
Compress_zlib(puntero2,$4000,pointer(puntero),long);
//Ahora pongo los datos
puntero2:=destino;
puntero2^:=ord('R');inc(puntero2);
puntero2^:=ord('A');inc(puntero2);
puntero2^:=ord('M');inc(puntero2);
puntero2^:=ord('P');inc(puntero2);
puntero2^:=((long+3) mod 256);inc(puntero2); //longitud
puntero2^:=((long+3) div 256);inc(puntero2);
puntero2^:=0;inc(puntero2);
puntero2^:=0;inc(puntero2);
puntero2^:=1;inc(puntero2);   //word comprimido
puntero2^:=0;inc(puntero2);  //Comprimido
puntero2^:=numero;inc(puntero2); //Numero pagina
copymemory(puntero2,puntero,long);
pagina_ram:=long+11;
freemem(puntero);
end;

function grabar_szx(nombre:string):boolean;
var
  cadena:string;
  salida:pbyte;
  cantidad,datos:integer;
  f:byte;
  fichero:file of byte;
  buffer:array[0..80] of byte;
begin
grabar_szx:=false;
{$I-}
assignfile(fichero,nombre);
rewrite(fichero);
buffer[0]:=ord('Z');
buffer[1]:=ord('X');
buffer[2]:=ord('S');
buffer[3]:=ord('T');
buffer[4]:=1;
buffer[5]:=1;
case main_vars.tipo_maquina of
  0:buffer[6]:=1;
  1:buffer[6]:=2;
  2:buffer[6]:=5;
  3:buffer[6]:=4;
  4:buffer[6]:=3;
  5:buffer[6]:=0;
end;
buffer[7]:=0;
blockwrite(fichero,buffer[0],8,datos);
buffer[0]:=ord('C');
buffer[1]:=ord('R');
buffer[2]:=ord('T');
buffer[3]:=ord('R');
buffer[4]:=36;
buffer[5]:=0;
buffer[6]:=0;
buffer[7]:=0;
cadena:='DSP Emulator                    ';
for f:=1 to 32 do buffer[7+f]:=ord(cadena[f]);
buffer[40]:=0;
buffer[41]:=4;
buffer[42]:=0;
buffer[43]:=7;
blockwrite(fichero,buffer[0],44,datos);
//Registros
buffer[0]:=ord('Z');
buffer[1]:=ord('8');
buffer[2]:=ord('0');
buffer[3]:=ord('R');
buffer[4]:=37;
buffer[5]:=0;
buffer[6]:=0;
buffer[7]:=0;
buffer[8]:=spec_z80.a;
buffer[9]:=0;
if spec_z80.f.s then inc(buffer[9],128);
if spec_z80.f.z then inc(buffer[9],64);
if spec_z80.f.bit5 then inc(buffer[9],32);
if spec_z80.f.h then inc(buffer[9],16);
if spec_z80.f.bit3 then inc(buffer[9],8);
if spec_z80.f.p_v then inc(buffer[9],4);
if spec_z80.f.n then inc(buffer[9],2);
if spec_z80.f.c then inc(buffer[9]);
buffer[10]:=spec_z80.bc.l;
buffer[11]:=spec_z80.bc.h;
buffer[12]:=spec_z80.de.l;
buffer[13]:=spec_z80.de.h;
buffer[14]:=spec_z80.hl.l;
buffer[15]:=spec_z80.hl.h;
buffer[16]:=spec_z80.a2;
buffer[17]:=0;
if spec_z80.f2.s then inc(buffer[17],128);
if spec_z80.f2.z then inc(buffer[17],64);
if spec_z80.f2.bit5 then inc(buffer[17],32);
if spec_z80.f2.h then inc(buffer[17],16);
if spec_z80.f2.bit3 then inc(buffer[17],8);
if spec_z80.f2.p_v then inc(buffer[17],4);
if spec_z80.f2.n then inc(buffer[17],2);
if spec_z80.f2.c then inc(buffer[17]);
buffer[18]:=spec_z80.bc2.l;
buffer[19]:=spec_z80.bc2.h;
buffer[20]:=spec_z80.de2.l;
buffer[21]:=spec_z80.de2.h;
buffer[22]:=spec_z80.hl2.l;
buffer[23]:=spec_z80.hl2.h;
buffer[24]:=spec_z80.ix.l;
buffer[25]:=spec_z80.ix.h;
buffer[26]:=spec_z80.iy.l;
buffer[27]:=spec_z80.iy.h;
buffer[28]:=spec_z80.sp and $ff;
buffer[29]:=spec_z80.sp shr 8;
buffer[30]:=spec_z80.pc and $ff;
buffer[31]:=spec_z80.pc shr 8;
buffer[32]:=spec_z80.i;
buffer[33]:=spec_z80.r;
if spec_z80.iff1 then buffer[34]:=1 else buffer[34]:=0;
if spec_z80.iff2 then buffer[35]:=1 else buffer[35]:=0;
buffer[36]:=spec_z80.im;
buffer[37]:=0;
buffer[38]:=0;
buffer[39]:=0;
buffer[40]:=0; //dword
buffer[41]:=0;
if spec_z80.halt then buffer[42]:=2 else buffer[42]:=0;
buffer[43]:=0;
buffer[44]:=0;
blockwrite(fichero,buffer[0],45,datos);
buffer[0]:=ord('S');
buffer[1]:=ord('P');
buffer[2]:=ord('C');
buffer[3]:=ord('R');
buffer[4]:=8;
buffer[5]:=0;
buffer[6]:=0;
buffer[7]:=0;
buffer[8]:=borde.color;
buffer[9]:=old_7ffd;
buffer[10]:=old_1ffd;
buffer[11]:=0;
buffer[12]:=0;
buffer[13]:=0;
buffer[14]:=0;
buffer[15]:=0;
blockwrite(fichero,buffer[0],16,datos);
getmem(salida,$4100);
case main_vars.tipo_maquina of
  0:begin //Spectrum 48k
      cantidad:=pagina_ram(0,salida);
      blockwrite(fichero,salida^,cantidad,datos);
      cantidad:=pagina_ram(2,salida);
      blockwrite(fichero,salida^,cantidad,datos);
      cantidad:=pagina_ram(5,salida);
      blockwrite(fichero,salida^,cantidad,datos);
    end;
  1,2,3,4:begin
      for f:=0 to 7 do begin
        cantidad:=pagina_ram(f,salida);
        blockwrite(fichero,salida^,cantidad,datos);
      end;
      //Y despues el AY
      buffer[0]:=ord('A');
      buffer[1]:=ord('Y');
      buffer[2]:=0;
      buffer[3]:=0;
      buffer[4]:=18;
      buffer[5]:=0;
      buffer[6]:=0;
      buffer[7]:=0;
      buffer[8]:=0;
      buffer[9]:=PSG[0].latch;
      for f:=0 to 15 do buffer[10+f]:=PSG[0].regs[f];
      blockwrite(fichero,buffer[0],26,datos);
    end;
    5:begin //Spectrum 16k
        cantidad:=pagina_ram(5,salida);
        blockwrite(fichero,salida^,cantidad,datos);
    end;
end;
freemem(salida);
grabar_szx:=true;
{$I+}
close(fichero);
end;

end.
