unit ay_8910;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}sound_engine;

const
  AY_AFINE = 0;
  AY_ACOARSE = 1;
  AY_BFINE = 2;
  AY_BCOARSE = 3;
  AY_CFINE = 4;
  AY_CCOARSE = 5;
  AY_NOISEPER = 6;
  AY_ENABLE = 7;
  AY_AVOL = 8;
  AY_BVOL = 9;
  AY_CVOL = 10;
  AY_EFINE = 11;
  AY_ECOARSE = 12;
  AY_ESHAPE = 13;
  AY_PORTA = 14;
  AY_PORTB = 15;
  STEP=$1000;
  MAX_OUTPUT=$7FFF;

type
  read_port=function:byte;
  write_port=procedure (valor:byte);
  AY8910 = record
    clock:integer;
    Regs:array[0..15] of byte;
    UpdateStep:integer;
    PeriodA,PeriodB,PeriodC,PeriodN,PeriodE: integer;
    CountA,CountB,CountC,CountN,CountE: integer;
    VolA,VolB,VolC,VolE: integer;
    EnvelopeA,EnvelopeB,EnvelopeC: integer;
    OutputA,OutputB,OutputC,OutputN: integer;
    latch:byte;
    CountEnv: shortint;
    Hold: integer;
    Alternate: integer;
    Attack: integer;
    Holding: integer;
    RNG:integer;
    lastenable:smallint;
    porta_read,portb_read:read_port;
    porta_write,portb_write:write_port;
    tsample,amp:byte;
  end;
  pAy8910=^ay8910;

var
  salida_ay:array[0..3] of integer;
  psg:array[0..3] of pay8910;
  vol_table:array[0..31] of double;

procedure AY8910_Write(v:byte;num:byte);
procedure AY8910_Control(v:byte;num:byte);
function AY8910_Read(num:byte):byte;
procedure AY8910_reset(num:byte);
procedure AY8910_init(clock:integer;num,amp:byte;porta_read,portb_read:read_port;porta_write,portb_write:write_port);
procedure AY8910_init_internal(clock:integer;num,amp:byte;porta_read,portb_read:read_port;porta_write,portb_write:write_port);
procedure ay8910_update(num:byte);
function ay8910_update_internal(num:byte):pinteger;
procedure AY8910_close(num:byte);

implementation
uses principal;

procedure AYWriteReg(r,v:byte;num:byte);inline;
var
    old: integer;
    AYPSG:pay8910;
begin
  AYPSG:=psg[num];
  AYPSG.Regs[r]:=v;
  case r of
    AY_AFINE, AY_ACOARSE:begin
        AYPSG.Regs[AY_ACOARSE] := AYPSG.Regs[AY_ACOARSE] and $F;
        old := AYPSG.PeriodA;
        AYPSG.PeriodA:=cardinal((AYPSG.Regs[AY_AFINE] + (256 * AYPSG.Regs[AY_ACOARSE]))*AYPSG.UpdateStep);
        if (AYPSG.PeriodA = 0) then AYPSG.PeriodA:=cardinal(AYPSG.UpdateStep);
        AYPSG.CountA := AYPSG.CountA + (AYPSG.PeriodA - old);
        if (AYPSG.CountA <= 0) then AYPSG.CountA := 1;
      end;
    AY_BFINE, AY_BCOARSE:begin
        AYPSG.Regs[AY_BCOARSE] := AYPSG.Regs[AY_BCOARSE] and $F;
        old := AYPSG.PeriodB;
        AYPSG.PeriodB := trunc((AYPSG.Regs[AY_BFINE] + (256 * AYPSG.Regs[AY_BCOARSE]))* AYPSG.UpdateStep);
        if (AYPSG.PeriodB = 0) then AYPSG.PeriodB := trunc(AYPSG.UpdateStep);
        AYPSG.CountB := AYPSG.CountB + AYPSG.PeriodB - old;
        if (AYPSG.CountB <= 0) then AYPSG.CountB := 1
      end;
    AY_CFINE, AY_CCOARSE:begin
        AYPSG.Regs[AY_CCOARSE] := AYPSG.Regs[AY_CCOARSE] and $F;
        old := AYPSG.PeriodC;
        AYPSG.PeriodC := trunc((AYPSG.Regs[AY_CFINE] + (256 * AYPSG.Regs[AY_CCOARSE]))*AYPSG.UpdateStep);
        if (AYPSG.PeriodC = 0) then AYPSG.PeriodC := trunc(AYPSG.UpdateStep);
        AYPSG.CountC := AYPSG.CountC + (AYPSG.PeriodC - old);
        if (AYPSG.CountC <= 0) then AYPSG.CountC := 1;
      end;
    AY_NOISEPER:begin
        AYPSG.Regs[AY_NOISEPER] := AYPSG.Regs[AY_NOISEPER] and $1F;
        old := AYPSG.PeriodN;
        AYPSG.PeriodN := trunc(AYPSG.Regs[AY_NOISEPER] * AYPSG.UpdateStep);
        if (AYPSG.PeriodN = 0) then AYPSG.PeriodN := trunc(AYPSG.UpdateStep);
        AYPSG.CountN := AYPSG.CountN + (AYPSG.PeriodN - old);
        if (AYPSG.CountN <= 0) then AYPSG.CountN := 1;
      end;
    AY_ENABLE:begin
        if ((ayPSg.lastEnable = -1) or ((ayPSG.lastEnable and $40)<>(ayPSG.Regs[AY_ENABLE] and $40))) then begin
			      // write out 0xff if port set to input */
			      if (addr(ayPSG.PortA_write)<>nil) then begin
              if (ayPSG.Regs[AY_ENABLE] and $40)<>0 then ayPSG.porta_write(ayPSG.Regs[AY_PORTA])
                else aypsg.porta_write($ff);
            end;
        end;
		    if ((ayPSG.lastEnable=-1) or ((ayPSG.lastEnable and $80)<>(ayPSG.Regs[AY_ENABLE] and $80))) then begin
			    // write out 0xff if port set to input */
			    if (addr(ayPSG.portb_write)<>nil) then begin
            if (ayPSG.Regs[AY_ENABLE] and $80)<>0 then ayPSG.portb_write(ayPSG.Regs[AY_PORTB])
                else aypsg.portb_write($ff);
          end;
        end;
		    ayPSG.lastEnable:= ayPSG.Regs[AY_ENABLE];
    end;
    AY_AVOL:begin
        AYPSG.Regs[AY_AVOL] := AYPSG.Regs[AY_AVOL] and $1F;
        AYPSG.EnvelopeA := AYPSG.Regs[AY_AVOL] and $10;
        if AYPSG.Regs[AY_AVOL]<>0 then old:=AYPSG.Regs[AY_AVOL]*2+1 else old:=0;
        if AYPSG.EnvelopeA <> 0 then AYPSG.VolA := AYPSG.VolE else AYPSG.VolA:=trunc(Vol_Table[old]);
      end;
    AY_BVOL:begin
        AYPSG.Regs[AY_BVOL] := AYPSG.Regs[AY_BVOL] and $1F;
        AYPSG.EnvelopeB := AYPSG.Regs[AY_BVOL] and $10;
        if AYPSG.Regs[AY_BVOL]<>0 then old:=AYPSG.Regs[AY_BVOL]*2+1 else old:=0;
        if AYPSG.EnvelopeB <> 0 then AYPSG.VolB := AYPSG.VolE else AYPSG.VolB :=trunc(Vol_Table[old]);
      end;
    AY_CVOL:begin
        AYPSG.Regs[AY_CVOL] := AYPSG.Regs[AY_CVOL] and $1F;
        AYPSG.EnvelopeC := AYPSG.Regs[AY_CVOL] and $10;
        if AYPSG.Regs[AY_CVOL]<>0 then old:=AYPSG.Regs[AY_CVOL]*2+1 else old:=0;
        if AYPSG.EnvelopeC <> 0 then AYPSG.VolC := AYPSG.VolE else AYPSG.VolC :=trunc(Vol_Table[old]);
      end;
    AY_EFINE, AY_ECOARSE:begin
        old := AYPSG.PeriodE;
        AYPSG.PeriodE := trunc((AYPSG.Regs[AY_EFINE] + (256 * AYPSG.Regs[AY_ECOARSE]))* AYPSG.UpdateStep);
        if (AYPSG.PeriodE = 0) then AYPSG.PeriodE := trunc(AYPSG.UpdateStep/2);
        AYPSG.CountE := AYPSG.CountE + (AYPSG.PeriodE - old);
        if (AYPSG.CountE <= 0) then AYPSG.CountE := 1
      end;
    AY_ESHAPE:begin
          AYPSG.Regs[AY_ESHAPE] := AYPSG.Regs[AY_ESHAPE] and $F;
          if ((AYPSG.Regs[AY_ESHAPE] and $4)<>0) then AYPSG.Attack := $1f
              else AYPSG.Attack := $0;
          if ((AYPSG.Regs[AY_ESHAPE] and $8) = 0) then begin
			      AYPSG.Hold:= 1;
			      AYPSG.Alternate:= AYPSG.Attack;
		      end else begin
            AYPSG.Hold:= AYPSG.Regs[AY_ESHAPE] and $1;
			      AYPSG.Alternate:= AYPSG.Regs[AY_ESHAPE] and $2;
          end;
          AYPSG.CountE := AYPSG.PeriodE;
          AYPSG.CountEnv := $1F;
          AYPSG.Holding := 0;
          AYPSG.VolE :=trunc(Vol_Table[AYPSG.CountEnv xor AYPSG.Attack]);
          if (AYPSG.EnvelopeA <> 0) then AYPSG.VolA := AYPSG.VolE;
          if (AYPSG.EnvelopeB <> 0) then AYPSG.VolB := AYPSG.VolE;
          if (AYPSG.EnvelopeC <> 0) then AYPSG.VolC := AYPSG.VolE;
      end;
      AY_PORTA:if addr(AYPSG.porta_write)<>nil then aypsg.porta_write(v)
                  else aypsg.Regs[AY_PORTA]:=v;
      AY_PORTB:if addr(AYPSG.portb_write)<>nil then AYPSG.portb_write(v)
                else aypsg.Regs[AY_PORTB]:=v;
  end; //case
end;

procedure AY8910_reset(num:byte);
  var
    i: byte;
    aypsg:pay8910;
begin
    aypsg:=psg[num];
    aypsg.latch:=0;
    aypsg.OutputA := 0;
    aypsg.OutputB := 0;
    aypsg.OutputC := 0;
    aypsg.OutputN := $FF;
    aypsg.RNG:=1;
    aypsg.lastenable:=-1;
  For i := 0 To 13 do AYWriteReg(i, 0,num);
end;

function AYReadReg(r: byte;num:byte):Byte;
var
  aypsg:pay8910;
begin
  aypsg:=psg[num];
  case r of
      AY_PORTA:if (addr(AYPSG.porta_read)<>nil) then aypsg.Regs[AY_PORTA]:=aypsg.porta_read;
      AY_PORTB:if (addr(AYPSG.portb_read)<>nil) then aypsg.Regs[AY_PORTB]:=aypsg.portb_read;
  end;
  AYReadReg:=AYPSG.Regs[r];
end;

function AY8910_Read(num:byte):byte;
var
  aypsg:pay8910;
begin
  aypsg:=psg[num];
  AY8910_Read:=AYReadReg(AYPSG.latch,num);
end;

procedure AY8910_Write(v:byte;num:byte);
var
  aypsg:pay8910;
begin
  aypsg:=psg[num];
  AYWriteReg(AYPSG.latch,v,num);
end;

procedure AY8910_Control(v:byte;num:byte);
var
  aypsg:pay8910;
begin
  aypsg:=psg[num];
  AYPSG.latch:=v and $f;
end;

procedure AY8910_close(num:byte);
begin
if psg[num]<>nil then begin
  freemem(psg[num]);
  psg[num]:=nil;
end;
end;

procedure init_table;
var
  i:integer;
  l_out:double;
begin
  l_out:=MAX_OUTPUT/4;
  for i:=31 downto 0 do begin
    Vol_Table[i]:=trunc(l_out+0.5);	// roun to nearest */
    l_out:=l_out/1.188502227;	// = 10 ^ (1.5/20) = 1.5dB */
  end;
  Vol_Table[0]:=0;
end;

procedure AY8910_resample(num:byte);
var
  aypsg:pay8910;
  temp:int64;
begin
  aypsg:=psg[num];
  temp:=STEP*44100;
  temp:=temp*8;
  AYPSG.UpdateStep:=trunc(temp/aypsg.clock);
end;

procedure AY8910_init(clock:integer;num,amp:byte;porta_read,portb_read:read_port;porta_write,portb_write:write_port);
var
  aypsg:pay8910;
begin
  if psg[num]=nil then begin
      getmem(psg[num],sizeof(ay8910));
      fillchar(psg[num]^,sizeof(ay8910),0);
  end else ay8910_reset(num);
  aypsg:=psg[num];
  aypsg.clock:=clock;
  init_table;
  {set clock}
  AY8910_resample(num);
  aypsg.porta_read:=porta_read;
  aypsg.portb_read:=portb_read;
  aypsg.porta_write:=porta_write;
  aypsg.portb_write:=portb_write;
  AY8910_reset(num);
  aypsg.PeriodA:=aypsg.UpdateStep;
  aypsg.PeriodB:=aypsg.UpdateStep;
  aypsg.PeriodC:=aypsg.UpdateStep;
  aypsg.PeriodE:=aypsg.UpdateStep;
  aypsg.PeriodN:=aypsg.UpdateStep;
  aypsg.tsample:=init_channel;
  aypsg.amp:=amp;
end;

procedure AY8910_init_internal(clock:integer;num,amp:byte;porta_read,portb_read:read_port;porta_write,portb_write:write_port);
var
  aypsg:pay8910;
begin
  if psg[num]=nil then begin
      getmem(psg[num],sizeof(ay8910));
      fillchar(psg[num]^,sizeof(ay8910),0);
  end else ay8910_reset(num);
  aypsg:=psg[num];
  aypsg.clock:=clock;
  init_table;
  {set clock}
  AY8910_resample(num);
  aypsg.porta_read:=porta_read;
  aypsg.portb_read:=portb_read;
  aypsg.porta_write:=porta_write;
  aypsg.portb_write:=portb_write;
  AY8910_reset(num);
  aypsg.PeriodA:=aypsg.UpdateStep;
  aypsg.PeriodB:=aypsg.UpdateStep;
  aypsg.PeriodC:=aypsg.UpdateStep;
  aypsg.PeriodE:=aypsg.UpdateStep;
  aypsg.PeriodN:=aypsg.UpdateStep;
  aypsg.tsample:=$ff;
  aypsg.amp:=amp;
end;

function ay8910_update_internal(num:byte):pinteger;
var
  AY_OutNoise: integer;
  VolA,VolB,VolC: integer;
  lOut1,lOut2,lOut3: integer;
  AY_Left: integer;
  AY_NextEvent: integer;
  aypsg:pay8910;
  temp2:integer;
begin
  aypsg:=psg[num];
  if (AYPSG.Regs[AY_ENABLE] and $1)<>0 then begin
    if AYPSG.CountA <=STEP then AYPSG.CountA :=AYPSG.CountA +STEP;
    AYPSG.OutputA := 1;
  end else if (AYPSG.Regs[AY_AVOL] = 0) then begin
      if AYPSG.CountA <=STEP then AYPSG.CountA :=AYPSG.CountA +STEP;
  end;
  if (AYPSG.Regs[AY_ENABLE] and $2)<>0 then begin
      if AYPSG.CountB <=STEP then AYPSG.CountB :=AYPSG.CountB + STEP;
      AYPSG.OutputB := 1;
  end else if AYPSG.Regs[AY_BVOL] = 0 then begin
      if AYPSG.CountB <=STEP then AYPSG.CountB :=AYPSG.CountB + STEP;
  end;
  if (AYPSG.Regs[AY_ENABLE] and $4)<>0 then begin
      if AYPSG.CountC <=STEP then AYPSG.CountC :=AYPSG.CountC + STEP;
      AYPSG.OutputC := 1;
  end else if (AYPSG.Regs[AY_CVOL] = 0) then begin
      if AYPSG.CountC <=STEP then AYPSG.CountC :=AYPSG.CountC +STEP;
  end;
    if ((AYPSG.Regs[AY_ENABLE] and $38) = $38) then
      if (AYPSG.CountN <=STEP) then AYPSG.CountN:=AYPSG.CountN +STEP;
    AY_OutNoise := (AYPSG.OutputN Or AYPSG.Regs[AY_ENABLE]);
    VolA := 0; VolB := 0; VolC := 0;
    AY_Left :=STEP;
    repeat
        If (AYPSG.CountN < AY_Left) Then AY_NextEvent := AYPSG.CountN
                else AY_NextEvent := AY_Left;
        If (AY_OutNoise And $8)<>0 Then begin
            If AYPSG.OutputA<>0 Then VolA := VolA + AYPSG.CountA;
            AYPSG.CountA := AYPSG.CountA - AY_NextEvent;
            While (AYPSG.CountA <= 0) do begin
                AYPSG.CountA := AYPSG.CountA + AYPSG.PeriodA;
                If (AYPSG.CountA > 0) Then begin
                    AYPSG.OutputA := AYPSG.OutputA Xor 1;
                    If (AYPSG.OutputA<>0) Then VolA := VolA + AYPSG.PeriodA;
                    break;
                end;
                AYPSG.CountA := AYPSG.CountA + AYPSG.PeriodA;
                VolA := VolA + AYPSG.PeriodA;
            end;
            If (AYPSG.OutputA<>0) Then VolA := VolA - AYPSG.CountA;
        end Else begin
            AYPSG.CountA := AYPSG.CountA - AY_NextEvent;
            While (AYPSG.CountA <= 0) do begin
                AYPSG.CountA := AYPSG.CountA + AYPSG.PeriodA;
                If (AYPSG.CountA > 0) Then begin
                    AYPSG.OutputA := AYPSG.OutputA Xor 1;
                    break;
                end;
                AYPSG.CountA := AYPSG.CountA + AYPSG.PeriodA;
            end;
        end;
        If (AY_OutNoise And $10)<>0 Then begin
            If AYPSG.OutputB<>0 Then VolB := VolB + AYPSG.CountB;
            AYPSG.CountB := AYPSG.CountB - AY_NextEvent;
            While (AYPSG.CountB <= 0) do begin
                AYPSG.CountB := AYPSG.CountB + AYPSG.PeriodB;
                If (AYPSG.CountB > 0) Then begin
                    AYPSG.OutputB := AYPSG.OutputB Xor 1;
                    If (AYPSG.OutputB<>0) Then VolB := VolB + AYPSG.PeriodB;
                    break;
                end;
                AYPSG.CountB := AYPSG.CountB + AYPSG.PeriodB;
                VolB := VolB + AYPSG.PeriodB;
            end;
            If (AYPSG.OutputB<>0) Then VolB := VolB - AYPSG.CountB;
        end Else begin
            AYPSG.CountB := AYPSG.CountB - AY_NextEvent;
            While (AYPSG.CountB <= 0) do begin
                AYPSG.CountB := AYPSG.CountB + AYPSG.PeriodB;
                If (AYPSG.CountB > 0) Then begin
                    AYPSG.OutputB := AYPSG.OutputB Xor 1;
                    break;
                end;
                AYPSG.CountB := AYPSG.CountB + AYPSG.PeriodB;
            end;
        end;
        If (AY_OutNoise And $20)<>0 Then begin
            If (AYPSG.OutputC<>0) Then VolC := VolC + AYPSG.CountC;
            AYPSG.CountC := AYPSG.CountC - AY_NextEvent;
            While (AYPSG.CountC <= 0) do begin
                AYPSG.CountC := AYPSG.CountC + AYPSG.PeriodC;
                If (AYPSG.CountC > 0) Then begin
                    AYPSG.OutputC := AYPSG.OutputC Xor 1;
                    If (AYPSG.OutputC<>0) Then VolC := VolC + AYPSG.PeriodC;
                    break;
                end;
                AYPSG.CountC := AYPSG.CountC + AYPSG.PeriodC;
                VolC := VolC + AYPSG.PeriodC;
            end;
            If (AYPSG.OutputC<>0) Then VolC := VolC - AYPSG.CountC;
        end Else begin
            AYPSG.CountC := AYPSG.CountC - AY_NextEvent;
            While (AYPSG.CountC <= 0) do begin
                AYPSG.CountC := AYPSG.CountC + AYPSG.PeriodC;
                If (AYPSG.CountC > 0) Then begin
                    AYPSG.OutputC := AYPSG.OutputC Xor 1;
                    break;
                end;
                AYPSG.CountC := AYPSG.CountC + AYPSG.PeriodC;
            end;
        end;
        AYPSG.CountN := AYPSG.CountN - AY_NextEvent;
        If (AYPSG.CountN <= 0) Then begin
          if ((AYPSG.RNG + 1) and 2)<>0 then begin	//* (bit0^bit1)? */
					  AYPSG.OutputN:=not(AYPSG.OutputN);
					  AY_Outnoise:=(AYPSG.OutputN or AYPSG.Regs[AY_ENABLE]);
          end;
          if (AYPSG.RNG and 1)<>0 then AYPSG.RNG:=AYPSG.RNG xor $28000; //* This version is called the "Galois configuration". */
				  AYPSG.RNG:=AYPSG.RNG shr 1;
				  AYPSG.CountN:=AYPSG.CountN+AYPSG.PeriodN;
        end;
        AY_Left := AY_Left - AY_NextEvent;
    until (AY_Left <= 0);
    if (AYPSG.Holding = 0) then begin
        AYPSG.CountE :=AYPSG.CountE -STEP;
        If (AYPSG.CountE <= 0) then begin
            repeat
                AYPSG.CountEnv := AYPSG.CountEnv - 1;
                AYPSG.CountE := AYPSG.CountE + AYPSG.PeriodE;
            until (AYPSG.CountE > 0);
            if (AYPSG.CountEnv < 0) then begin
                if (AYPSG.Hold<>0) then begin
                    if (AYPSG.Alternate<>0) then AYPSG.Attack := AYPSG.Attack xor $1f;
                    AYPSG.Holding := 1;
                    AYPSG.CountEnv := 0;
                end else begin
                    If (AYPSG.Alternate<>0) and ((AYPSG.CountEnv and $20)<>0) then AYPSG.Attack := AYPSG.Attack xor $1f;
                    AYPSG.CountEnv := AYPSG.CountEnv and $1f;  //1f
                end;
            end;
            AYPSG.VolE :=trunc(Vol_Table[AYPSG.CountEnv xor AYPSG.Attack]);
            If (AYPSG.EnvelopeA <> 0) then AYPSG.VolA := AYPSG.VolE;
            If (AYPSG.EnvelopeB <> 0) then AYPSG.VolB := AYPSG.VolE;
            If (AYPSG.EnvelopeC <> 0) then AYPSG.VolC := AYPSG.VolE;
        end;
    end;
    lOut1:=trunc((VolA * AYPSG.VolA)/STEP);
    lOut2:=trunc((VolB * AYPSG.VolB)/STEP);
    lOut3:=trunc((VolC * AYPSG.VolC)/STEP);
    temp2:=trunc(((VolA * AYPSG.VolA)/STEP)+((VolB * AYPSG.VolB)/STEP)+((VolC * AYPSG.VolC)/STEP));
    if lout1>32767 then lout1:=32767
      else if lout1<-32768 then lout1:=-32768;
    if lout2>32767 then lout2:=32767
      else if lout2<-32768 then lout2:=-32768;
    if lout3>32767 then lout3:=32767
      else if lout3<-32768 then lout3:=-32768;
    if temp2>32767 then temp2:=32767
      else if temp2<-32768 then temp2:=-32768;
    salida_ay[0]:=temp2*AYPSG.amp;
    salida_ay[1]:=lout1*AYPSG.amp;
    salida_ay[2]:=lout2*AYPSG.amp;
    salida_ay[3]:=lout3*AYPSG.amp;
    ay8910_update_internal:=@salida_ay[0];
end;

procedure ay8910_update(num:byte);
begin
ay8910_update_internal(num);
tsample[psg[num].tsample,sound_status.posicion_sonido]:=salida_ay[0];
if sound_status.stereo then tsample[psg[num].tsample,sound_status.posicion_sonido+1]:=salida_ay[0];
end;


end.
