unit samples;

{$ifdef fpc}{$mode delphi}{$H+}{$endif}

interface
uses {$IFDEF WINDOWS}windows,{$ENDIF}
     dialogs,sysutils,misc_functions,sound_engine,file_engine;

const
  MAX_SAMPLES=30;
  MAX_CHANNELS=6;
type
  tipo_nombre_samples=record
      nombre:string;
      restart,loop:boolean;
  end;
  tipo_audio=record
             long:dword;
             playing:boolean;
             data:pword;
             pos:dword;
             restart,loop:boolean;
             tsample:byte;
        end;
  ptipo_audio=^tipo_audio;
  tipo_samples=record
             num_samples:byte;
             audio:array[0..MAX_SAMPLES] of ptipo_audio;
             tsample_use:array[0..MAX_CHANNELS] of boolean;
             tsample_reserved:array[0..MAX_CHANNELS] of byte;
        end;
  pnom_sample=^tipo_nombre_samples;
  ptipo_samples=^tipo_samples;
var
  data_samples:ptipo_samples;

function load_samples(nombre_zip:string;nombre_samples:pnom_sample;num_samples:byte):boolean;
procedure start_sample(num:byte);
procedure samples_update;
procedure stop_sample(num:byte);
procedure close_samples;
procedure reset_samples;
procedure stop_all_samples;

implementation
uses principal;

function cargar_wav(nsample:byte;long:integer;ptemp:pbyte):boolean;
var
  cadena:string;
  h:byte;
  ltemp,f:dword;
  data:pbyte;
  salir,fmt,datos:boolean;
  temp2,ncanales,nbits:word;
  lsamples,temp,lsamples_m:integer;
  data2:pword;
begin
data:=ptemp;
data_samples.audio[nsample].pos:=0;
data_samples.audio[nsample].playing:=false;
cargar_wav:=false;
cadena:='';
for temp:=0 to 3 do begin
  cadena:=cadena+chr(data^);
  inc(data);
end;
inc(data,4);
for temp:=0 to 3 do begin
  cadena:=cadena+chr(data^);
  inc(data);
end;
if cadena<>'RIFFWAVE' then exit;
fmt:=false;
datos:=false;
salir:=false;
while not(salir) do begin
  cadena:='';
  for temp:=0 to 3 do begin
    cadena:=cadena+chr(data^);
    inc(data);
  end;
  if cadena='fmt ' then begin
    inc(data,4);
    //Tipo de compresion
    temp2:=sacar_word(data);
    inc(data,2);
    if temp2<>1 then exit; //Solo soporto PCM!
    //Numero de canales
    ncanales:=sacar_word(data);
    if ((ncanales<>1) and (ncanales<>2)) then exit;
    inc(data,2);
    //Samples seg.
    lsamples:=sacar_word(data);
    inc(data,2);
    lsamples:=sacar_word(data)*$10000+lsamples;
    inc(data,2);
    case lsamples of
      11025:lsamples_m:=4;
      22050:lsamples_m:=2;
      44100:lsamples_m:=1;
    end;
    //Me salto 'Average bytes seg' y 'Bloq align'
    inc(data,6);
    //Bits por sample (8 o 16)
    nbits:=sacar_word(data);
    inc(data,2);
    fmt:=true;
  end;
  if cadena='data' then begin
    if not(fmt) then exit;
    //Longitud en samples
    ltemp:=sacar_word(data);
    inc(data,2);
    ltemp:=sacar_word(data)*$10000+ltemp;
    inc(data,2);
    //Y ahora resampleado a 44100 y 16bits
    if (nbits=16) then ltemp:=ltemp div 2;
    getmem(data_samples.audio[nsample].data,ltemp*lsamples_m*2);
    data_samples.audio[nsample].long:=ltemp*lsamples_m;
    data2:=data_samples.audio[nsample].data;
    for f:=0 to (ltemp-1) do begin
      if nbits=8 then begin
        temp:=data^ shl 7;
        inc(data);
      end else begin
        temp:=sacar_word(data);
        inc(data,2);
      end;
     for h:=0 to (lsamples_m-1) do begin
        data2^:=temp;
        inc(data2);
     end;
    end;
    datos:=true;
  end;
  if ((cadena='fact') or (cadena='list') or (cadena='cue') or (cadena='plst') or (cadena='labl') or (cadena='ltxt') or (cadena='smpl') or (cadena='note') or (cadena='inst')) then begin
    //Longitud
    ltemp:=sacar_word(data);
    inc(data,2);
    ltemp:=sacar_word(data)*$10000+ltemp;
    inc(data,2);
    inc(data,ltemp);
  end;
  if (fmt and datos) then begin
    salir:=true;
    cargar_wav:=true;
  end;
end;
end;

function load_samples(nombre_zip:string;nombre_samples:pnom_sample;num_samples:byte):boolean;
var
  nsamples,f:byte;
  ptemp:pbyte;
  longitud,crc:integer;
begin
load_samples:=false;
nsamples:=0;
//Inicializo los samples
getmem(data_samples,sizeof(tipo_samples));
//Inicializo un buffer
getmem(ptemp,$100000);
repeat
    if not(load_file_from_zip(Directory.Arcade_samples+nombre_zip,nombre_samples.nombre,ptemp,longitud,crc,false)) then begin
        freemem(data_samples);
        data_samples:=nil;
        freemem(ptemp);
        exit;
    end;
    //Inicializo el sample
    getmem(data_samples.audio[nsamples],sizeof(tipo_audio));
    data_samples.audio[nsamples].data:=nil;
    //extraigo la informacion
    if not(cargar_wav(nsamples,longitud,ptemp)) then begin
      MessageDlg('Error loading sample file: '+'"'+nombre_samples.nombre+'"', mtError,[mbOk], 0);
      freemem(data_samples);
      data_samples:=nil;
      freemem(ptemp);
      exit;
    end;
    data_samples.audio[nsamples].restart:=nombre_samples.restart;
    data_samples.audio[nsamples].loop:=nombre_samples.loop;
    inc(nombre_samples);
    inc(nsamples);
until nsamples=num_samples;
freemem(ptemp);
data_samples.num_samples:=num_samples;
for f:=0 to MAX_CHANNELS do begin
  data_samples.tsample_reserved[f]:=init_channel;
  data_samples.tsample_use[f]:=false;
end;
load_samples:=true;
end;

procedure reset_samples;
var
  f:byte;
begin
for f:=0 to data_samples.num_samples-1 do begin
  data_samples.audio[f].playing:=false;
  data_samples.audio[f].pos:=0;
end;
for f:=0 to MAX_CHANNELS do data_samples.tsample_use[f]:=false;
end;

function first_sample_free:byte;
var
  f:byte;
begin
  for f:=0 to MAX_CHANNELS do begin
      if not(data_samples.tsample_use[f]) then begin
        data_samples.tsample_use[f]:=true;
        first_sample_free:=data_samples.tsample_reserved[f];
        exit;
      end;
  end;
  //Si no hay libres, que coja el primero...
  first_sample_free:=data_samples.tsample_reserved[0];
end;

procedure start_sample(num:byte);
begin
//Si no esta en marcha que comience
if not(data_samples.audio[num].playing) then begin
  data_samples.audio[num].playing:=true;
  data_samples.audio[num].pos:=0;
  data_samples.audio[num].tsample:=first_sample_free;
end else begin //Si ya ha empezado, pero puede volver a comenzar lo hace
  if data_samples.audio[num].restart then data_samples.audio[num].pos:=0;
end;
end;

procedure stop_sample(num:byte);
begin
if data_samples.audio[num].playing then begin
  data_samples.audio[num].playing:=false;
  data_samples.tsample_use[data_samples.audio[num].tsample]:=false;
end;
end;

procedure stop_all_samples;
var
  f:word;
begin
for f:=0 to (data_samples.num_samples-1) do begin
  if data_samples.audio[f].playing then begin
    data_samples.audio[f].playing:=false;
    data_samples.tsample_use[data_samples.audio[f].tsample]:=false;
  end;
end;
end;

procedure samples_update;
var
  f:word;
  ptemp:pword;
begin
for f:=0 to (data_samples.num_samples-1) do begin
 if data_samples.audio[f].playing then begin
    ptemp:=data_samples.audio[f].data;
    inc(ptemp,data_samples.audio[f].pos);
    data_samples.audio[f].pos:=data_samples.audio[f].pos+1;
    tsample[data_samples.audio[f].tsample,sound_status.posicion_sonido]:=smallint(ptemp^);
    if data_samples.audio[f].pos>=data_samples.audio[f].long then begin
      if data_samples.audio[f].loop then begin
        data_samples.audio[f].pos:=0;
      end else begin
        data_samples.audio[f].playing:=false;
        data_samples.tsample_use[data_samples.audio[f].tsample]:=false;
      end;
    end;
 end;
end;
end;

procedure close_samples;
var
  f:byte;
begin
if data_samples=nil then exit;
for f:=0 to data_samples.num_samples-1 do begin
  if data_samples.audio[f]<>nil then begin
    if data_samples.audio[f].data<>nil then begin
      freemem(data_samples.audio[f].data);
      data_samples.audio[f].data:=nil;
    end;
    freemem(data_samples.audio[f]);
    data_samples.audio[f]:=nil;
  end;
end;
freemem(data_samples);
data_samples:=nil;
end;

end.
